#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 5
#define STATE_COUNT 2439
#define SYMBOL_COUNT 123
#define ALIAS_COUNT 4
#define TOKEN_COUNT 78
#define EXTERNAL_TOKEN_COUNT 11
#define MAX_ALIAS_SEQUENCE_LENGTH 8

enum {
  sym__simple_heredoc = 1,
  sym__heredoc_beginning = 2,
  sym__heredoc_middle = 3,
  sym__heredoc_end = 4,
  sym_file_descriptor = 5,
  sym__empty_value = 6,
  sym__concat = 7,
  sym_variable_name = 8,
  anon_sym_for = 9,
  anon_sym_in = 10,
  anon_sym_while = 11,
  anon_sym_do = 12,
  anon_sym_done = 13,
  anon_sym_if = 14,
  anon_sym_then = 15,
  anon_sym_fi = 16,
  anon_sym_elif = 17,
  anon_sym_else = 18,
  anon_sym_case = 19,
  anon_sym_esac = 20,
  anon_sym_PIPE = 21,
  anon_sym_RPAREN = 22,
  anon_sym_SEMI_SEMI = 23,
  anon_sym_function = 24,
  anon_sym_LPAREN = 25,
  anon_sym_LBRACE = 26,
  anon_sym_RBRACE = 27,
  anon_sym_PIPE_AMP = 28,
  anon_sym_AMP_AMP = 29,
  anon_sym_PIPE_PIPE = 30,
  anon_sym_declare = 31,
  anon_sym_typeset = 32,
  anon_sym_export = 33,
  anon_sym_readonly = 34,
  anon_sym_local = 35,
  anon_sym_EQ = 36,
  anon_sym_PLUS_EQ = 37,
  anon_sym_LBRACK = 38,
  anon_sym_RBRACK = 39,
  anon_sym_LT = 40,
  anon_sym_GT = 41,
  anon_sym_GT_GT = 42,
  anon_sym_AMP_GT = 43,
  anon_sym_AMP_GT_GT = 44,
  anon_sym_LT_AMP = 45,
  anon_sym_GT_AMP = 46,
  anon_sym_LT_LT = 47,
  anon_sym_LT_LT_DASH = 48,
  anon_sym_LT_LT_LT = 49,
  sym__special_characters = 50,
  anon_sym_DQUOTE = 51,
  sym__string_content = 52,
  sym_raw_string = 53,
  anon_sym_DOLLAR = 54,
  anon_sym_POUND = 55,
  anon_sym_DOLLAR_LBRACE = 56,
  anon_sym_COLON = 57,
  anon_sym_COLON_QMARK = 58,
  anon_sym_COLON_DASH = 59,
  anon_sym_PERCENT = 60,
  anon_sym_SLASH = 61,
  anon_sym_DASH = 62,
  anon_sym_DOLLAR_LPAREN = 63,
  anon_sym_BQUOTE = 64,
  anon_sym_LT_LPAREN = 65,
  anon_sym_GT_LPAREN = 66,
  sym_comment = 67,
  aux_sym_SLASH_BSLASHw_PLUS_SLASH = 68,
  anon_sym_STAR = 69,
  anon_sym_AT = 70,
  anon_sym_QMARK = 71,
  anon_sym_0 = 72,
  anon_sym__ = 73,
  sym_word = 74,
  anon_sym_SEMI = 75,
  anon_sym_LF = 76,
  anon_sym_AMP = 77,
  sym_program = 78,
  sym__terminated_statement = 79,
  sym_for_statement = 80,
  sym_while_statement = 81,
  sym_do_group = 82,
  sym_if_statement = 83,
  sym_elif_clause = 84,
  sym_else_clause = 85,
  sym_case_statement = 86,
  sym_case_item = 87,
  sym_last_case_item = 88,
  sym_function_definition = 89,
  sym_compound_statement = 90,
  sym_subshell = 91,
  sym_pipeline = 92,
  sym_list = 93,
  sym_command = 94,
  sym_command_name = 95,
  sym_variable_assignment = 96,
  sym_declaration_command = 97,
  sym__assignment = 98,
  sym_subscript = 99,
  sym_file_redirect = 100,
  sym_heredoc_redirect = 101,
  sym_heredoc = 102,
  sym_herestring_redirect = 103,
  sym_concatenation = 104,
  sym_string = 105,
  sym_array = 106,
  sym_simple_expansion = 107,
  sym_expansion = 108,
  sym_command_substitution = 109,
  sym_process_substitution = 110,
  aux_sym_program_repeat1 = 111,
  aux_sym_for_statement_repeat1 = 112,
  aux_sym_while_statement_repeat1 = 113,
  aux_sym_if_statement_repeat1 = 114,
  aux_sym_case_statement_repeat1 = 115,
  aux_sym_case_item_repeat1 = 116,
  aux_sym_command_repeat1 = 117,
  aux_sym_declaration_command_repeat1 = 118,
  aux_sym_heredoc_repeat1 = 119,
  aux_sym_concatenation_repeat1 = 120,
  aux_sym_string_repeat1 = 121,
  aux_sym_expansion_repeat1 = 122,
  alias_sym_case_item = 123,
  alias_sym_special_variable_name = 124,
  alias_sym_variable_name = 125,
  alias_sym_word = 126,
};

static const char *ts_symbol_names[] = {
  [sym__simple_heredoc] = "_simple_heredoc",
  [sym__heredoc_beginning] = "_heredoc_beginning",
  [sym__heredoc_middle] = "_heredoc_middle",
  [sym__heredoc_end] = "_heredoc_end",
  [sym_file_descriptor] = "file_descriptor",
  [sym__empty_value] = "_empty_value",
  [sym__concat] = "_concat",
  [sym_variable_name] = "variable_name",
  [ts_builtin_sym_end] = "END",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_do] = "do",
  [anon_sym_done] = "done",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_fi] = "fi",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_case] = "case",
  [anon_sym_esac] = "esac",
  [anon_sym_PIPE] = "|",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI_SEMI] = ";;",
  [anon_sym_function] = "function",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_PIPE_AMP] = "|&",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_declare] = "declare",
  [anon_sym_typeset] = "typeset",
  [anon_sym_export] = "export",
  [anon_sym_readonly] = "readonly",
  [anon_sym_local] = "local",
  [anon_sym_EQ] = "=",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_AMP_GT] = "&>",
  [anon_sym_AMP_GT_GT] = "&>>",
  [anon_sym_LT_AMP] = "<&",
  [anon_sym_GT_AMP] = ">&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_LT_LT_DASH] = "<<-",
  [anon_sym_LT_LT_LT] = "<<<",
  [sym__special_characters] = "_special_characters",
  [anon_sym_DQUOTE] = "\"",
  [sym__string_content] = "_string_content",
  [sym_raw_string] = "raw_string",
  [anon_sym_DOLLAR] = "$",
  [anon_sym_POUND] = "#",
  [anon_sym_DOLLAR_LBRACE] = "${",
  [anon_sym_COLON] = ":",
  [anon_sym_COLON_QMARK] = ":?",
  [anon_sym_COLON_DASH] = ":-",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH] = "/",
  [anon_sym_DASH] = "-",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_LT_LPAREN] = "<(",
  [anon_sym_GT_LPAREN] = ">(",
  [sym_comment] = "comment",
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = "/\\w+/",
  [anon_sym_STAR] = "*",
  [anon_sym_AT] = "@",
  [anon_sym_QMARK] = "?",
  [anon_sym_0] = "0",
  [anon_sym__] = "_",
  [sym_word] = "word",
  [anon_sym_SEMI] = ";",
  [anon_sym_LF] = "\n",
  [anon_sym_AMP] = "&",
  [sym_program] = "program",
  [sym__terminated_statement] = "_terminated_statement",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_do_group] = "do_group",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_case_statement] = "case_statement",
  [sym_case_item] = "case_item",
  [sym_last_case_item] = "last_case_item",
  [sym_function_definition] = "function_definition",
  [sym_compound_statement] = "compound_statement",
  [sym_subshell] = "subshell",
  [sym_pipeline] = "pipeline",
  [sym_list] = "list",
  [sym_command] = "command",
  [sym_command_name] = "command_name",
  [sym_variable_assignment] = "variable_assignment",
  [sym_declaration_command] = "declaration_command",
  [sym__assignment] = "_assignment",
  [sym_subscript] = "subscript",
  [sym_file_redirect] = "file_redirect",
  [sym_heredoc_redirect] = "heredoc_redirect",
  [sym_heredoc] = "heredoc",
  [sym_herestring_redirect] = "herestring_redirect",
  [sym_concatenation] = "concatenation",
  [sym_string] = "string",
  [sym_array] = "array",
  [sym_simple_expansion] = "simple_expansion",
  [sym_expansion] = "expansion",
  [sym_command_substitution] = "command_substitution",
  [sym_process_substitution] = "process_substitution",
  [aux_sym_program_repeat1] = "program_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_while_statement_repeat1] = "while_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_case_statement_repeat1] = "case_statement_repeat1",
  [aux_sym_case_item_repeat1] = "case_item_repeat1",
  [aux_sym_command_repeat1] = "command_repeat1",
  [aux_sym_declaration_command_repeat1] = "declaration_command_repeat1",
  [aux_sym_heredoc_repeat1] = "heredoc_repeat1",
  [aux_sym_concatenation_repeat1] = "concatenation_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [aux_sym_expansion_repeat1] = "expansion_repeat1",
  [alias_sym_case_item] = "case_item",
  [alias_sym_special_variable_name] = "special_variable_name",
  [alias_sym_variable_name] = "variable_name",
  [alias_sym_word] = "word",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__simple_heredoc] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_beginning] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_middle] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_end] = {
    .visible = false,
    .named = true,
  },
  [sym_file_descriptor] = {
    .visible = true,
    .named = true,
  },
  [sym__empty_value] = {
    .visible = false,
    .named = true,
  },
  [sym__concat] = {
    .visible = false,
    .named = true,
  },
  [sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_done] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fi] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_esac] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_function] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_declare] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_export] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_local] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [sym__special_characters] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_raw_string] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DOLLAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_0] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = false,
  },
  [sym_word] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LF] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__terminated_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_group] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_last_case_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_compound_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym_command] = {
    .visible = true,
    .named = true,
  },
  [sym_command_name] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_command] = {
    .visible = true,
    .named = true,
  },
  [sym__assignment] = {
    .visible = false,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_file_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc] = {
    .visible = true,
    .named = true,
  },
  [sym_herestring_redirect] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_expansion] = {
    .visible = true,
    .named = true,
  },
  [sym_command_substitution] = {
    .visible = true,
    .named = true,
  },
  [sym_process_substitution] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_program_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_while_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_command_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_expansion_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_case_item] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_special_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_variable_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_word] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[17][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_word,
  },
  [2] = {
    [0] = alias_sym_variable_name,
  },
  [3] = {
    [1] = alias_sym_word,
  },
  [4] = {
    [1] = alias_sym_special_variable_name,
  },
  [5] = {
    [1] = alias_sym_variable_name,
  },
  [6] = {
    [2] = alias_sym_word,
  },
  [7] = {
    [2] = alias_sym_special_variable_name,
  },
  [8] = {
    [2] = alias_sym_variable_name,
  },
  [9] = {
    [3] = alias_sym_word,
  },
  [10] = {
    [1] = alias_sym_word,
    [4] = alias_sym_case_item,
  },
  [11] = {
    [4] = alias_sym_case_item,
  },
  [12] = {
    [4] = alias_sym_word,
  },
  [13] = {
    [1] = alias_sym_word,
    [5] = alias_sym_case_item,
  },
  [14] = {
    [5] = alias_sym_case_item,
  },
  [15] = {
    [1] = alias_sym_word,
    [6] = alias_sym_case_item,
  },
  [16] = {
    [6] = alias_sym_case_item,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '/')
        ADVANCE(21);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == ':')
        ADVANCE(24);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        SKIP(43);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(0);
      if (('1' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_LF);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '(')
        ADVANCE(6);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LBRACE);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_AMP_GT);
      if (lookahead == '>')
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_AMP_GT_GT);
      END_STATE();
    case 13:
      if (lookahead == '\'')
        ADVANCE(14);
      if (lookahead != 0)
        ADVANCE(13);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(sym_raw_string);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 18:
      if (lookahead == '=')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_0);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(25);
      if (lookahead == '?')
        ADVANCE(26);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_SEMI);
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_SEMI_SEMI);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_LT_AMP);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_LT_LPAREN);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '-')
        ADVANCE(33);
      if (lookahead == '<')
        ADVANCE(34);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_LT_LT_DASH);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LT_LT_LT);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '(')
        ADVANCE(38);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_GT_AMP);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_GT_LPAREN);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 41:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym__special_characters);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '&')
        ADVANCE(48);
      if (lookahead == '|')
        ADVANCE(49);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_PIPE_AMP);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 51:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(55);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(69);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(51);
      if ((lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(52);
      END_STATE();
    case 53:
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 55:
      if (lookahead == '\n')
        SKIP(51);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 57:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'a')
        ADVANCE(59);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 's')
        ADVANCE(60);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(61);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_case);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(63);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'c')
        ADVANCE(64);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'l')
        ADVANCE(65);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'a')
        ADVANCE(66);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'r')
        ADVANCE(67);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(68);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_declare);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'x')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'p')
        ADVANCE(71);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'o')
        ADVANCE(72);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'r')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(74);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_export);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'o')
        ADVANCE(76);
      if (lookahead == 'u')
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'r')
        ADVANCE(77);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'n')
        ADVANCE(79);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'c')
        ADVANCE(80);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(81);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'i')
        ADVANCE(82);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'o')
        ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'n')
        ADVANCE(84);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_function);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'f')
        ADVANCE(86);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'o')
        ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'c')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'a')
        ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'l')
        ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_local);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(93);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'a')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'd')
        ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'o')
        ADVANCE(96);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'n')
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'l')
        ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'y')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_readonly);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'y')
        ADVANCE(101);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'p')
        ADVANCE(102);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 's')
        ADVANCE(104);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 't')
        ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_typeset);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'h')
        ADVANCE(108);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'i')
        ADVANCE(109);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'l')
        ADVANCE(110);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(111);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_while);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 112:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(115);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'd')
        ADVANCE(116);
      if (lookahead == 'e')
        ADVANCE(118);
      if (lookahead == 'f')
        ADVANCE(127);
      if (lookahead == 'i')
        ADVANCE(129);
      if (lookahead == 't')
        ADVANCE(131);
      if (lookahead == '{')
        ADVANCE(135);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(112);
      END_STATE();
    case 113:
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 115:
      if (lookahead == '\n')
        SKIP(112);
      END_STATE();
    case 116:
      if (lookahead == 'o')
        ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 118:
      if (lookahead == 'l')
        ADVANCE(119);
      if (lookahead == 's')
        ADVANCE(124);
      END_STATE();
    case 119:
      if (lookahead == 'i')
        ADVANCE(120);
      if (lookahead == 's')
        ADVANCE(122);
      END_STATE();
    case 120:
      if (lookahead == 'f')
        ADVANCE(121);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 122:
      if (lookahead == 'e')
        ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 124:
      if (lookahead == 'a')
        ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == 'c')
        ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_esac);
      END_STATE();
    case 127:
      if (lookahead == 'i')
        ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(anon_sym_fi);
      END_STATE();
    case 129:
      if (lookahead == 'n')
        ADVANCE(130);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 131:
      if (lookahead == 'h')
        ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'e')
        ADVANCE(133);
      END_STATE();
    case 133:
      if (lookahead == 'n')
        ADVANCE(134);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 136:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(137);
      if (lookahead == '|')
        ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(136);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 137:
      if (lookahead == '\n')
        SKIP(136);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 139:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(140);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(139);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 140:
      if (lookahead == '\n')
        SKIP(139);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 141:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(142);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(145);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(146);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(56);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(10);
      END_STATE();
    case 143:
      if (lookahead == '(')
        ADVANCE(31);
      END_STATE();
    case 144:
      if (lookahead == '(')
        ADVANCE(38);
      END_STATE();
    case 145:
      if (lookahead == '\n')
        SKIP(141);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHw_PLUS_SLASH);
      if (lookahead == '\\')
        ADVANCE(57);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(146);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < 'A' || lookahead > ']') &&
          (lookahead < '_' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 147:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(148);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(147);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(56);
      END_STATE();
    case 148:
      if (lookahead == '\n')
        SKIP(147);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 149:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(150);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(154);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(155);
      if (lookahead != 0)
        ADVANCE(151);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(151);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(150);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\\')
        ADVANCE(152);
      if (lookahead != 0 &&
          lookahead != '\"' &&
          lookahead != '$' &&
          lookahead != '`')
        ADVANCE(151);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(151);
      if (lookahead == '\\')
        ADVANCE(152);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(151);
      if (lookahead != 0)
        ADVANCE(151);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(151);
      if (lookahead == '\\')
        ADVANCE(153);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(150);
      if (lookahead != 0)
        ADVANCE(150);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '\n')
        ADVANCE(155);
      if (lookahead == '\\')
        ADVANCE(152);
      if (lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '`')
        ADVANCE(151);
      if (lookahead != 0)
        ADVANCE(151);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym__string_content);
      if (lookahead == '#')
        ADVANCE(150);
      if (lookahead == '\\')
        ADVANCE(154);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(155);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > '$') &&
          lookahead != '`')
        ADVANCE(151);
      END_STATE();
    case 156:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(157);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(158);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(156);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      END_STATE();
    case 158:
      if (lookahead == '\n')
        SKIP(156);
      END_STATE();
    case 159:
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(157);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(160);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(159);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 160:
      if (lookahead == '\n')
        SKIP(159);
      END_STATE();
    case 161:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(162);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(161);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(56);
      END_STATE();
    case 162:
      if (lookahead == '\n')
        SKIP(161);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 163:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(165);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(69);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(163);
      if ((lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 164:
      if (lookahead == ';')
        ADVANCE(28);
      END_STATE();
    case 165:
      if (lookahead == '\n')
        SKIP(163);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 166:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(167);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(166);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(56);
      END_STATE();
    case 167:
      if (lookahead == '\n')
        SKIP(166);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 168:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(169);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(168);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(56);
      END_STATE();
    case 169:
      if (lookahead == '\n')
        SKIP(168);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 170:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(171);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(170);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 171:
      if (lookahead == '\n')
        SKIP(170);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(173);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(172);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(56);
      END_STATE();
    case 173:
      if (lookahead == '\n')
        SKIP(172);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 174:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(176);
      if (lookahead == 'i')
        ADVANCE(129);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 176:
      if (lookahead == '\n')
        SKIP(174);
      END_STATE();
    case 177:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(142);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(146);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')'))
        ADVANCE(56);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        SKIP(177);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 179:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(180);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(179);
      if (lookahead != 0)
        ADVANCE(56);
      END_STATE();
    case 180:
      if (lookahead == '\n')
        SKIP(179);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 181:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(4);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(182);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '-')
        ADVANCE(183);
      if (lookahead == '/')
        ADVANCE(184);
      if (lookahead == ':')
        ADVANCE(185);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '=')
        ADVANCE(188);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(189);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(181);
      if (lookahead != 0 &&
          (lookahead < '\"' || lookahead > ')') &&
          (lookahead < ':' || lookahead > '>') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-')
        ADVANCE(186);
      if (lookahead == '?')
        ADVANCE(187);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_COLON_DASH);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_COLON_QMARK);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 189:
      if (lookahead == '\n')
        SKIP(181);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 190:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(157);
      if (lookahead == '*')
        ADVANCE(17);
      if (lookahead == '-')
        ADVANCE(20);
      if (lookahead == '0')
        ADVANCE(22);
      if (lookahead == '?')
        ADVANCE(40);
      if (lookahead == '@')
        ADVANCE(41);
      if (lookahead == '\\')
        SKIP(191);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(190);
      if (('1' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 191:
      if (lookahead == '\n')
        SKIP(190);
      END_STATE();
    case 192:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(193);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(146);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(192);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 194:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(196);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 195:
      if (lookahead == '&')
        ADVANCE(10);
      if (lookahead == '>')
        ADVANCE(11);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(194);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 197:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(198);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 198:
      if (lookahead == '\n')
        SKIP(197);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 199:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(200);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(199);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 200:
      if (lookahead == '\n')
        SKIP(199);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 201:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(202);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(201);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(146);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        SKIP(201);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 203:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(204);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(203);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        SKIP(203);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 205:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(29);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(206);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(205);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 206:
      if (lookahead == '\n')
        SKIP(205);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 207:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(208);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(207);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<')
        ADVANCE(56);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        SKIP(207);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 209:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(212);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(214);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      if (lookahead == '<')
        ADVANCE(32);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '&')
        ADVANCE(37);
      if (lookahead == '>')
        ADVANCE(39);
      END_STATE();
    case 214:
      if (lookahead == '\n')
        SKIP(211);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(212);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(216);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(215);
      END_STATE();
    case 216:
      if (lookahead == '\n')
        SKIP(215);
      END_STATE();
    case 217:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '\\')
        SKIP(218);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(217);
      END_STATE();
    case 218:
      if (lookahead == '\n')
        SKIP(217);
      END_STATE();
    case 219:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(220);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(221);
      if (lookahead == 'e')
        ADVANCE(69);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(219);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        SKIP(219);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(63);
      if (lookahead == 'o')
        ADVANCE(222);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'n')
        ADVANCE(223);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(224);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_done);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 225:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(226);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(227);
      if (lookahead == 'f')
        ADVANCE(233);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 226:
      if (lookahead == '\n')
        SKIP(225);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'l')
        ADVANCE(228);
      if (lookahead == 'x')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'i')
        ADVANCE(229);
      if (lookahead == 's')
        ADVANCE(231);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'f')
        ADVANCE(230);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_elif);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'e')
        ADVANCE(232);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_else);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'i')
        ADVANCE(234);
      if (lookahead == 'o')
        ADVANCE(76);
      if (lookahead == 'u')
        ADVANCE(78);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_fi);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 235:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(236);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(69);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        SKIP(235);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 237:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(238);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(237);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '&')
        ADVANCE(30);
      END_STATE();
    case 239:
      if (lookahead == '\n')
        SKIP(237);
      END_STATE();
    case 240:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(241);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(69);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        SKIP(240);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 242:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(243);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(242);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(242);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 244:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(212);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(245);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(244);
      END_STATE();
    case 245:
      if (lookahead == '\n')
        SKIP(244);
      END_STATE();
    case 246:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(212);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(247);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(246);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        SKIP(246);
      END_STATE();
    case 248:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '<')
        ADVANCE(212);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(249);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(248);
      END_STATE();
    case 249:
      if (lookahead == '\n')
        SKIP(248);
      END_STATE();
    case 250:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(251);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(250);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(anon_sym_DOLLAR);
      if (lookahead == '{')
        ADVANCE(7);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(250);
      END_STATE();
    case 253:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(254);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 254:
      if (lookahead == '\n')
        SKIP(253);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 255:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(256);
      if (lookahead == ']')
        ADVANCE(44);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(255);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        SKIP(255);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 257:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '+')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(35);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(257);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        SKIP(257);
      END_STATE();
    case 259:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(175);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(260);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(259);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        SKIP(259);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 261:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(262);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(69);
      if (lookahead == 'f')
        ADVANCE(233);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 262:
      if (lookahead == '\n')
        SKIP(261);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 263:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '<')
        ADVANCE(143);
      if (lookahead == '>')
        ADVANCE(144);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(264);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'e')
        ADVANCE(265);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(263);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 264:
      if (lookahead == '\n')
        SKIP(263);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 's')
        ADVANCE(266);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'a')
        ADVANCE(267);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          lookahead != 'a' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 'c')
        ADVANCE(268);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(anon_sym_esac);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 269:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(9);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '<')
        ADVANCE(238);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(270);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(269);
      END_STATE();
    case 270:
      if (lookahead == '\n')
        SKIP(269);
      END_STATE();
    case 271:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '\\')
        SKIP(272);
      if (lookahead == '}')
        ADVANCE(50);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(271);
      END_STATE();
    case 272:
      if (lookahead == '\n')
        SKIP(271);
      END_STATE();
    case 273:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(238);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(274);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(273);
      END_STATE();
    case 274:
      if (lookahead == '\n')
        SKIP(273);
      END_STATE();
    case 275:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == '<')
        ADVANCE(238);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(276);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(275);
      END_STATE();
    case 276:
      if (lookahead == '\n')
        SKIP(275);
      END_STATE();
    case 277:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(278);
      if (lookahead == '|')
        ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(277);
      END_STATE();
    case 278:
      if (lookahead == '\n')
        SKIP(277);
      END_STATE();
    case 279:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(142);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(280);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(279);
      END_STATE();
    case 280:
      if (lookahead == '\n')
        SKIP(279);
      END_STATE();
    case 281:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(195);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '<')
        ADVANCE(238);
      if (lookahead == '>')
        ADVANCE(213);
      if (lookahead == '\\')
        SKIP(282);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(281);
      END_STATE();
    case 282:
      if (lookahead == '\n')
        SKIP(281);
      END_STATE();
    case 283:
      if (lookahead == '\"')
        ADVANCE(3);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '$')
        ADVANCE(5);
      if (lookahead == '&')
        ADVANCE(53);
      if (lookahead == '\'')
        ADVANCE(13);
      if (lookahead == '(')
        ADVANCE(15);
      if (lookahead == ';')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(54);
      if (lookahead == '>')
        ADVANCE(36);
      if (lookahead == '[')
        ADVANCE(42);
      if (lookahead == '\\')
        ADVANCE(284);
      if (lookahead == ']')
        ADVANCE(42);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == 'c')
        ADVANCE(58);
      if (lookahead == 'd')
        ADVANCE(62);
      if (lookahead == 'e')
        ADVANCE(285);
      if (lookahead == 'f')
        ADVANCE(75);
      if (lookahead == 'i')
        ADVANCE(85);
      if (lookahead == 'l')
        ADVANCE(87);
      if (lookahead == 'r')
        ADVANCE(92);
      if (lookahead == 't')
        ADVANCE(100);
      if (lookahead == 'w')
        ADVANCE(107);
      if (lookahead == '{')
        ADVANCE(42);
      if (lookahead == '}')
        ADVANCE(42);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(283);
      if (lookahead != 0 &&
          (lookahead < '&' || lookahead > ')') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 284:
      if (lookahead == '\n')
        SKIP(283);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(56);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_word);
      if (lookahead == '\\')
        ADVANCE(57);
      if (lookahead == 's')
        ADVANCE(266);
      if (lookahead == 'x')
        ADVANCE(70);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ' &&
          (lookahead < '\"' || lookahead > '$') &&
          (lookahead < '&' || lookahead > ')') &&
          lookahead != ';' &&
          lookahead != '<' &&
          lookahead != '>' &&
          (lookahead < '[' || lookahead > ']') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(56);
      END_STATE();
    case 286:
      if (lookahead == '\n')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(142);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == ';')
        ADVANCE(27);
      if (lookahead == '\\')
        SKIP(287);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        SKIP(286);
      END_STATE();
    case 288:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == ')')
        ADVANCE(16);
      if (lookahead == '\\')
        SKIP(289);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(288);
      END_STATE();
    case 289:
      if (lookahead == '\n')
        SKIP(288);
      END_STATE();
    case 290:
      if (lookahead == '#')
        ADVANCE(52);
      if (lookahead == '&')
        ADVANCE(113);
      if (lookahead == '\\')
        SKIP(291);
      if (lookahead == '`')
        ADVANCE(46);
      if (lookahead == '|')
        ADVANCE(47);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(290);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        SKIP(290);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 51, .external_lex_state = 2},
  [2] = {.lex_state = 51},
  [3] = {.lex_state = 112},
  [4] = {.lex_state = 136},
  [5] = {.lex_state = 51, .external_lex_state = 2},
  [6] = {.lex_state = 51, .external_lex_state = 2},
  [7] = {.lex_state = 139},
  [8] = {.lex_state = 139},
  [9] = {.lex_state = 51, .external_lex_state = 2},
  [10] = {.lex_state = 141, .external_lex_state = 3},
  [11] = {.lex_state = 139},
  [12] = {.lex_state = 147, .external_lex_state = 4},
  [13] = {.lex_state = 149},
  [14] = {.lex_state = 147, .external_lex_state = 4},
  [15] = {.lex_state = 156},
  [16] = {.lex_state = 159, .external_lex_state = 5},
  [17] = {.lex_state = 51, .external_lex_state = 2},
  [18] = {.lex_state = 51, .external_lex_state = 2},
  [19] = {.lex_state = 51, .external_lex_state = 2},
  [20] = {.lex_state = 161, .external_lex_state = 4},
  [21] = {.lex_state = 51},
  [22] = {.lex_state = 163, .external_lex_state = 2},
  [23] = {.lex_state = 141, .external_lex_state = 6},
  [24] = {.lex_state = 147, .external_lex_state = 7},
  [25] = {.lex_state = 166, .external_lex_state = 8},
  [26] = {.lex_state = 112},
  [27] = {.lex_state = 139, .external_lex_state = 2},
  [28] = {.lex_state = 168, .external_lex_state = 7},
  [29] = {.lex_state = 51, .external_lex_state = 2},
  [30] = {.lex_state = 139, .external_lex_state = 2},
  [31] = {.lex_state = 139},
  [32] = {.lex_state = 170, .external_lex_state = 9},
  [33] = {.lex_state = 139},
  [34] = {.lex_state = 172, .external_lex_state = 8},
  [35] = {.lex_state = 112},
  [36] = {.lex_state = 112},
  [37] = {.lex_state = 141, .external_lex_state = 6},
  [38] = {.lex_state = 166, .external_lex_state = 8},
  [39] = {.lex_state = 112},
  [40] = {.lex_state = 174, .external_lex_state = 10},
  [41] = {.lex_state = 149},
  [42] = {.lex_state = 174, .external_lex_state = 10},
  [43] = {.lex_state = 156},
  [44] = {.lex_state = 159, .external_lex_state = 5},
  [45] = {.lex_state = 51, .external_lex_state = 2},
  [46] = {.lex_state = 51, .external_lex_state = 2},
  [47] = {.lex_state = 51, .external_lex_state = 2},
  [48] = {.lex_state = 174, .external_lex_state = 6},
  [49] = {.lex_state = 112},
  [50] = {.lex_state = 112},
  [51] = {.lex_state = 51, .external_lex_state = 2},
  [52] = {.lex_state = 139},
  [53] = {.lex_state = 177, .external_lex_state = 3},
  [54] = {.lex_state = 168, .external_lex_state = 4},
  [55] = {.lex_state = 149},
  [56] = {.lex_state = 168, .external_lex_state = 4},
  [57] = {.lex_state = 156},
  [58] = {.lex_state = 159, .external_lex_state = 5},
  [59] = {.lex_state = 51, .external_lex_state = 2},
  [60] = {.lex_state = 51, .external_lex_state = 2},
  [61] = {.lex_state = 51, .external_lex_state = 2},
  [62] = {.lex_state = 179, .external_lex_state = 4},
  [63] = {.lex_state = 177, .external_lex_state = 6},
  [64] = {.lex_state = 168, .external_lex_state = 7},
  [65] = {.lex_state = 172, .external_lex_state = 8},
  [66] = {.lex_state = 112},
  [67] = {.lex_state = 51, .external_lex_state = 2},
  [68] = {.lex_state = 139, .external_lex_state = 2},
  [69] = {.lex_state = 112},
  [70] = {.lex_state = 141, .external_lex_state = 11},
  [71] = {.lex_state = 149},
  [72] = {.lex_state = 141, .external_lex_state = 11},
  [73] = {.lex_state = 156},
  [74] = {.lex_state = 159, .external_lex_state = 5},
  [75] = {.lex_state = 51, .external_lex_state = 2},
  [76] = {.lex_state = 51, .external_lex_state = 2},
  [77] = {.lex_state = 51, .external_lex_state = 2},
  [78] = {.lex_state = 177, .external_lex_state = 3},
  [79] = {.lex_state = 177, .external_lex_state = 3},
  [80] = {.lex_state = 112},
  [81] = {.lex_state = 141, .external_lex_state = 3},
  [82] = {.lex_state = 139, .external_lex_state = 12},
  [83] = {.lex_state = 149},
  [84] = {.lex_state = 139, .external_lex_state = 12},
  [85] = {.lex_state = 156},
  [86] = {.lex_state = 159, .external_lex_state = 5},
  [87] = {.lex_state = 51, .external_lex_state = 2},
  [88] = {.lex_state = 51, .external_lex_state = 2},
  [89] = {.lex_state = 51, .external_lex_state = 2},
  [90] = {.lex_state = 139, .external_lex_state = 2},
  [91] = {.lex_state = 139},
  [92] = {.lex_state = 147, .external_lex_state = 4},
  [93] = {.lex_state = 147, .external_lex_state = 4},
  [94] = {.lex_state = 149, .external_lex_state = 13},
  [95] = {.lex_state = 156},
  [96] = {.lex_state = 159, .external_lex_state = 5},
  [97] = {.lex_state = 51, .external_lex_state = 2},
  [98] = {.lex_state = 51, .external_lex_state = 2},
  [99] = {.lex_state = 149},
  [100] = {.lex_state = 147, .external_lex_state = 4},
  [101] = {.lex_state = 147, .external_lex_state = 4},
  [102] = {.lex_state = 147, .external_lex_state = 4},
  [103] = {.lex_state = 112},
  [104] = {.lex_state = 181, .external_lex_state = 14},
  [105] = {.lex_state = 190, .external_lex_state = 5},
  [106] = {.lex_state = 181, .external_lex_state = 14},
  [107] = {.lex_state = 181, .external_lex_state = 14},
  [108] = {.lex_state = 112},
  [109] = {.lex_state = 136},
  [110] = {.lex_state = 51, .external_lex_state = 2},
  [111] = {.lex_state = 51, .external_lex_state = 2},
  [112] = {.lex_state = 139},
  [113] = {.lex_state = 139},
  [114] = {.lex_state = 51, .external_lex_state = 2},
  [115] = {.lex_state = 192, .external_lex_state = 5},
  [116] = {.lex_state = 194, .external_lex_state = 15},
  [117] = {.lex_state = 149},
  [118] = {.lex_state = 194, .external_lex_state = 15},
  [119] = {.lex_state = 156},
  [120] = {.lex_state = 159, .external_lex_state = 5},
  [121] = {.lex_state = 51, .external_lex_state = 2},
  [122] = {.lex_state = 51, .external_lex_state = 2},
  [123] = {.lex_state = 51, .external_lex_state = 2},
  [124] = {.lex_state = 197, .external_lex_state = 15},
  [125] = {.lex_state = 112},
  [126] = {.lex_state = 194, .external_lex_state = 16},
  [127] = {.lex_state = 199, .external_lex_state = 2},
  [128] = {.lex_state = 112},
  [129] = {.lex_state = 194, .external_lex_state = 16},
  [130] = {.lex_state = 139, .external_lex_state = 2},
  [131] = {.lex_state = 112},
  [132] = {.lex_state = 51, .external_lex_state = 2},
  [133] = {.lex_state = 139},
  [134] = {.lex_state = 201, .external_lex_state = 5},
  [135] = {.lex_state = 203, .external_lex_state = 15},
  [136] = {.lex_state = 149},
  [137] = {.lex_state = 203, .external_lex_state = 15},
  [138] = {.lex_state = 156},
  [139] = {.lex_state = 159, .external_lex_state = 5},
  [140] = {.lex_state = 51, .external_lex_state = 2},
  [141] = {.lex_state = 51, .external_lex_state = 2},
  [142] = {.lex_state = 51, .external_lex_state = 2},
  [143] = {.lex_state = 205, .external_lex_state = 15},
  [144] = {.lex_state = 112},
  [145] = {.lex_state = 203, .external_lex_state = 16},
  [146] = {.lex_state = 207, .external_lex_state = 2},
  [147] = {.lex_state = 112},
  [148] = {.lex_state = 139, .external_lex_state = 2},
  [149] = {.lex_state = 112},
  [150] = {.lex_state = 199, .external_lex_state = 2},
  [151] = {.lex_state = 112},
  [152] = {.lex_state = 51, .external_lex_state = 2},
  [153] = {.lex_state = 163, .external_lex_state = 2},
  [154] = {.lex_state = 51, .external_lex_state = 2},
  [155] = {.lex_state = 51},
  [156] = {.lex_state = 139},
  [157] = {.lex_state = 209, .external_lex_state = 17},
  [158] = {.lex_state = 139},
  [159] = {.lex_state = 147, .external_lex_state = 4},
  [160] = {.lex_state = 147, .external_lex_state = 4},
  [161] = {.lex_state = 211, .external_lex_state = 7},
  [162] = {.lex_state = 168, .external_lex_state = 7},
  [163] = {.lex_state = 147, .external_lex_state = 7},
  [164] = {.lex_state = 215, .external_lex_state = 7},
  [165] = {.lex_state = 51, .external_lex_state = 2},
  [166] = {.lex_state = 112},
  [167] = {.lex_state = 147, .external_lex_state = 7},
  [168] = {.lex_state = 112},
  [169] = {.lex_state = 139, .external_lex_state = 2},
  [170] = {.lex_state = 139, .external_lex_state = 12},
  [171] = {.lex_state = 139, .external_lex_state = 12},
  [172] = {.lex_state = 139, .external_lex_state = 2},
  [173] = {.lex_state = 172, .external_lex_state = 8},
  [174] = {.lex_state = 194},
  [175] = {.lex_state = 166, .external_lex_state = 18},
  [176] = {.lex_state = 149},
  [177] = {.lex_state = 166, .external_lex_state = 18},
  [178] = {.lex_state = 156},
  [179] = {.lex_state = 159, .external_lex_state = 5},
  [180] = {.lex_state = 51, .external_lex_state = 2},
  [181] = {.lex_state = 51, .external_lex_state = 2},
  [182] = {.lex_state = 51, .external_lex_state = 2},
  [183] = {.lex_state = 217, .external_lex_state = 19},
  [184] = {.lex_state = 149},
  [185] = {.lex_state = 217, .external_lex_state = 19},
  [186] = {.lex_state = 156},
  [187] = {.lex_state = 159, .external_lex_state = 5},
  [188] = {.lex_state = 51, .external_lex_state = 2},
  [189] = {.lex_state = 51, .external_lex_state = 2},
  [190] = {.lex_state = 51, .external_lex_state = 2},
  [191] = {.lex_state = 217, .external_lex_state = 19},
  [192] = {.lex_state = 139},
  [193] = {.lex_state = 219, .external_lex_state = 2},
  [194] = {.lex_state = 215, .external_lex_state = 7},
  [195] = {.lex_state = 112},
  [196] = {.lex_state = 225, .external_lex_state = 2},
  [197] = {.lex_state = 139},
  [198] = {.lex_state = 174, .external_lex_state = 6},
  [199] = {.lex_state = 112},
  [200] = {.lex_state = 174, .external_lex_state = 10},
  [201] = {.lex_state = 174, .external_lex_state = 10},
  [202] = {.lex_state = 149},
  [203] = {.lex_state = 174, .external_lex_state = 6},
  [204] = {.lex_state = 112},
  [205] = {.lex_state = 174, .external_lex_state = 10},
  [206] = {.lex_state = 174, .external_lex_state = 10},
  [207] = {.lex_state = 174, .external_lex_state = 10},
  [208] = {.lex_state = 112},
  [209] = {.lex_state = 181, .external_lex_state = 14},
  [210] = {.lex_state = 190, .external_lex_state = 5},
  [211] = {.lex_state = 181, .external_lex_state = 14},
  [212] = {.lex_state = 181, .external_lex_state = 14},
  [213] = {.lex_state = 112},
  [214] = {.lex_state = 199, .external_lex_state = 2},
  [215] = {.lex_state = 112},
  [216] = {.lex_state = 207, .external_lex_state = 2},
  [217] = {.lex_state = 112},
  [218] = {.lex_state = 199, .external_lex_state = 2},
  [219] = {.lex_state = 112},
  [220] = {.lex_state = 235, .external_lex_state = 20},
  [221] = {.lex_state = 237, .external_lex_state = 7},
  [222] = {.lex_state = 170, .external_lex_state = 9},
  [223] = {.lex_state = 112},
  [224] = {.lex_state = 112},
  [225] = {.lex_state = 112},
  [226] = {.lex_state = 177, .external_lex_state = 11},
  [227] = {.lex_state = 149},
  [228] = {.lex_state = 177, .external_lex_state = 11},
  [229] = {.lex_state = 156},
  [230] = {.lex_state = 159, .external_lex_state = 5},
  [231] = {.lex_state = 51, .external_lex_state = 2},
  [232] = {.lex_state = 51, .external_lex_state = 2},
  [233] = {.lex_state = 51, .external_lex_state = 2},
  [234] = {.lex_state = 112},
  [235] = {.lex_state = 177, .external_lex_state = 3},
  [236] = {.lex_state = 139},
  [237] = {.lex_state = 168, .external_lex_state = 4},
  [238] = {.lex_state = 168, .external_lex_state = 4},
  [239] = {.lex_state = 149},
  [240] = {.lex_state = 168, .external_lex_state = 4},
  [241] = {.lex_state = 168, .external_lex_state = 4},
  [242] = {.lex_state = 168, .external_lex_state = 4},
  [243] = {.lex_state = 112},
  [244] = {.lex_state = 181, .external_lex_state = 14},
  [245] = {.lex_state = 190, .external_lex_state = 5},
  [246] = {.lex_state = 181, .external_lex_state = 14},
  [247] = {.lex_state = 181, .external_lex_state = 14},
  [248] = {.lex_state = 112},
  [249] = {.lex_state = 199, .external_lex_state = 2},
  [250] = {.lex_state = 112},
  [251] = {.lex_state = 207, .external_lex_state = 2},
  [252] = {.lex_state = 112},
  [253] = {.lex_state = 199, .external_lex_state = 2},
  [254] = {.lex_state = 112},
  [255] = {.lex_state = 51, .external_lex_state = 2},
  [256] = {.lex_state = 177, .external_lex_state = 6},
  [257] = {.lex_state = 240, .external_lex_state = 2},
  [258] = {.lex_state = 51, .external_lex_state = 2},
  [259] = {.lex_state = 51},
  [260] = {.lex_state = 139},
  [261] = {.lex_state = 139},
  [262] = {.lex_state = 168, .external_lex_state = 4},
  [263] = {.lex_state = 168, .external_lex_state = 4},
  [264] = {.lex_state = 168, .external_lex_state = 7},
  [265] = {.lex_state = 211, .external_lex_state = 7},
  [266] = {.lex_state = 177, .external_lex_state = 6},
  [267] = {.lex_state = 172, .external_lex_state = 8},
  [268] = {.lex_state = 51, .external_lex_state = 2},
  [269] = {.lex_state = 168, .external_lex_state = 7},
  [270] = {.lex_state = 170, .external_lex_state = 9},
  [271] = {.lex_state = 177, .external_lex_state = 3},
  [272] = {.lex_state = 139},
  [273] = {.lex_state = 141, .external_lex_state = 11},
  [274] = {.lex_state = 141, .external_lex_state = 11},
  [275] = {.lex_state = 149},
  [276] = {.lex_state = 141, .external_lex_state = 11},
  [277] = {.lex_state = 141, .external_lex_state = 11},
  [278] = {.lex_state = 141, .external_lex_state = 11},
  [279] = {.lex_state = 112},
  [280] = {.lex_state = 181, .external_lex_state = 14},
  [281] = {.lex_state = 190, .external_lex_state = 5},
  [282] = {.lex_state = 181, .external_lex_state = 14},
  [283] = {.lex_state = 181, .external_lex_state = 14},
  [284] = {.lex_state = 112},
  [285] = {.lex_state = 199, .external_lex_state = 2},
  [286] = {.lex_state = 112},
  [287] = {.lex_state = 207, .external_lex_state = 2},
  [288] = {.lex_state = 112},
  [289] = {.lex_state = 199, .external_lex_state = 2},
  [290] = {.lex_state = 141, .external_lex_state = 3},
  [291] = {.lex_state = 139},
  [292] = {.lex_state = 139, .external_lex_state = 12},
  [293] = {.lex_state = 139, .external_lex_state = 12},
  [294] = {.lex_state = 149},
  [295] = {.lex_state = 139, .external_lex_state = 12},
  [296] = {.lex_state = 139, .external_lex_state = 12},
  [297] = {.lex_state = 139, .external_lex_state = 12},
  [298] = {.lex_state = 112},
  [299] = {.lex_state = 181, .external_lex_state = 14},
  [300] = {.lex_state = 190, .external_lex_state = 5},
  [301] = {.lex_state = 181, .external_lex_state = 14},
  [302] = {.lex_state = 181, .external_lex_state = 14},
  [303] = {.lex_state = 112},
  [304] = {.lex_state = 199, .external_lex_state = 2},
  [305] = {.lex_state = 112},
  [306] = {.lex_state = 207, .external_lex_state = 2},
  [307] = {.lex_state = 112},
  [308] = {.lex_state = 199, .external_lex_state = 2},
  [309] = {.lex_state = 147, .external_lex_state = 4},
  [310] = {.lex_state = 147, .external_lex_state = 4},
  [311] = {.lex_state = 149},
  [312] = {.lex_state = 149},
  [313] = {.lex_state = 149, .external_lex_state = 13},
  [314] = {.lex_state = 149, .external_lex_state = 13},
  [315] = {.lex_state = 149, .external_lex_state = 13},
  [316] = {.lex_state = 112},
  [317] = {.lex_state = 181, .external_lex_state = 14},
  [318] = {.lex_state = 190, .external_lex_state = 5},
  [319] = {.lex_state = 181, .external_lex_state = 14},
  [320] = {.lex_state = 181, .external_lex_state = 14},
  [321] = {.lex_state = 112},
  [322] = {.lex_state = 199, .external_lex_state = 2},
  [323] = {.lex_state = 112},
  [324] = {.lex_state = 207, .external_lex_state = 2},
  [325] = {.lex_state = 147, .external_lex_state = 4},
  [326] = {.lex_state = 149},
  [327] = {.lex_state = 242, .external_lex_state = 14},
  [328] = {.lex_state = 139},
  [329] = {.lex_state = 147, .external_lex_state = 4},
  [330] = {.lex_state = 181, .external_lex_state = 14},
  [331] = {.lex_state = 181, .external_lex_state = 21},
  [332] = {.lex_state = 149},
  [333] = {.lex_state = 181, .external_lex_state = 21},
  [334] = {.lex_state = 156},
  [335] = {.lex_state = 159, .external_lex_state = 5},
  [336] = {.lex_state = 51, .external_lex_state = 2},
  [337] = {.lex_state = 51, .external_lex_state = 2},
  [338] = {.lex_state = 51, .external_lex_state = 2},
  [339] = {.lex_state = 181, .external_lex_state = 14},
  [340] = {.lex_state = 112},
  [341] = {.lex_state = 181, .external_lex_state = 14},
  [342] = {.lex_state = 181, .external_lex_state = 14},
  [343] = {.lex_state = 181, .external_lex_state = 14},
  [344] = {.lex_state = 147, .external_lex_state = 4},
  [345] = {.lex_state = 181, .external_lex_state = 14},
  [346] = {.lex_state = 147, .external_lex_state = 4},
  [347] = {.lex_state = 181, .external_lex_state = 14},
  [348] = {.lex_state = 170, .external_lex_state = 9},
  [349] = {.lex_state = 199, .external_lex_state = 2},
  [350] = {.lex_state = 112},
  [351] = {.lex_state = 112},
  [352] = {.lex_state = 112},
  [353] = {.lex_state = 174, .external_lex_state = 10},
  [354] = {.lex_state = 174, .external_lex_state = 10},
  [355] = {.lex_state = 174, .external_lex_state = 6},
  [356] = {.lex_state = 112},
  [357] = {.lex_state = 177, .external_lex_state = 6},
  [358] = {.lex_state = 172, .external_lex_state = 8},
  [359] = {.lex_state = 51, .external_lex_state = 2},
  [360] = {.lex_state = 112},
  [361] = {.lex_state = 192, .external_lex_state = 22},
  [362] = {.lex_state = 149},
  [363] = {.lex_state = 192, .external_lex_state = 22},
  [364] = {.lex_state = 156},
  [365] = {.lex_state = 159, .external_lex_state = 5},
  [366] = {.lex_state = 51, .external_lex_state = 2},
  [367] = {.lex_state = 51, .external_lex_state = 2},
  [368] = {.lex_state = 51, .external_lex_state = 2},
  [369] = {.lex_state = 192, .external_lex_state = 5},
  [370] = {.lex_state = 192, .external_lex_state = 5},
  [371] = {.lex_state = 112},
  [372] = {.lex_state = 192, .external_lex_state = 5},
  [373] = {.lex_state = 139},
  [374] = {.lex_state = 194, .external_lex_state = 15},
  [375] = {.lex_state = 194, .external_lex_state = 15},
  [376] = {.lex_state = 149},
  [377] = {.lex_state = 194, .external_lex_state = 15},
  [378] = {.lex_state = 194, .external_lex_state = 15},
  [379] = {.lex_state = 194, .external_lex_state = 15},
  [380] = {.lex_state = 112},
  [381] = {.lex_state = 181, .external_lex_state = 14},
  [382] = {.lex_state = 190, .external_lex_state = 5},
  [383] = {.lex_state = 181, .external_lex_state = 14},
  [384] = {.lex_state = 181, .external_lex_state = 14},
  [385] = {.lex_state = 112},
  [386] = {.lex_state = 199, .external_lex_state = 2},
  [387] = {.lex_state = 112},
  [388] = {.lex_state = 207, .external_lex_state = 2},
  [389] = {.lex_state = 112},
  [390] = {.lex_state = 199, .external_lex_state = 2},
  [391] = {.lex_state = 112},
  [392] = {.lex_state = 51, .external_lex_state = 2},
  [393] = {.lex_state = 147, .external_lex_state = 4},
  [394] = {.lex_state = 51, .external_lex_state = 2},
  [395] = {.lex_state = 51},
  [396] = {.lex_state = 139},
  [397] = {.lex_state = 209, .external_lex_state = 17},
  [398] = {.lex_state = 139},
  [399] = {.lex_state = 194, .external_lex_state = 15},
  [400] = {.lex_state = 194, .external_lex_state = 15},
  [401] = {.lex_state = 244, .external_lex_state = 16},
  [402] = {.lex_state = 194, .external_lex_state = 16},
  [403] = {.lex_state = 194, .external_lex_state = 16},
  [404] = {.lex_state = 246, .external_lex_state = 16},
  [405] = {.lex_state = 194, .external_lex_state = 16},
  [406] = {.lex_state = 170, .external_lex_state = 9},
  [407] = {.lex_state = 112},
  [408] = {.lex_state = 112},
  [409] = {.lex_state = 112},
  [410] = {.lex_state = 201, .external_lex_state = 22},
  [411] = {.lex_state = 149},
  [412] = {.lex_state = 201, .external_lex_state = 22},
  [413] = {.lex_state = 156},
  [414] = {.lex_state = 159, .external_lex_state = 5},
  [415] = {.lex_state = 51, .external_lex_state = 2},
  [416] = {.lex_state = 51, .external_lex_state = 2},
  [417] = {.lex_state = 51, .external_lex_state = 2},
  [418] = {.lex_state = 112},
  [419] = {.lex_state = 201, .external_lex_state = 5},
  [420] = {.lex_state = 139},
  [421] = {.lex_state = 203, .external_lex_state = 15},
  [422] = {.lex_state = 203, .external_lex_state = 15},
  [423] = {.lex_state = 149},
  [424] = {.lex_state = 203, .external_lex_state = 15},
  [425] = {.lex_state = 203, .external_lex_state = 15},
  [426] = {.lex_state = 203, .external_lex_state = 15},
  [427] = {.lex_state = 112},
  [428] = {.lex_state = 181, .external_lex_state = 14},
  [429] = {.lex_state = 190, .external_lex_state = 5},
  [430] = {.lex_state = 181, .external_lex_state = 14},
  [431] = {.lex_state = 181, .external_lex_state = 14},
  [432] = {.lex_state = 112},
  [433] = {.lex_state = 199, .external_lex_state = 2},
  [434] = {.lex_state = 112},
  [435] = {.lex_state = 207, .external_lex_state = 2},
  [436] = {.lex_state = 112},
  [437] = {.lex_state = 199, .external_lex_state = 2},
  [438] = {.lex_state = 112},
  [439] = {.lex_state = 51, .external_lex_state = 2},
  [440] = {.lex_state = 51, .external_lex_state = 2},
  [441] = {.lex_state = 51},
  [442] = {.lex_state = 139},
  [443] = {.lex_state = 139},
  [444] = {.lex_state = 203, .external_lex_state = 15},
  [445] = {.lex_state = 203, .external_lex_state = 15},
  [446] = {.lex_state = 203, .external_lex_state = 16},
  [447] = {.lex_state = 248, .external_lex_state = 16},
  [448] = {.lex_state = 203, .external_lex_state = 16},
  [449] = {.lex_state = 147, .external_lex_state = 4},
  [450] = {.lex_state = 112},
  [451] = {.lex_state = 177, .external_lex_state = 6},
  [452] = {.lex_state = 172, .external_lex_state = 8},
  [453] = {.lex_state = 141, .external_lex_state = 6},
  [454] = {.lex_state = 166, .external_lex_state = 8},
  [455] = {.lex_state = 139},
  [456] = {.lex_state = 215, .external_lex_state = 4},
  [457] = {.lex_state = 149},
  [458] = {.lex_state = 215, .external_lex_state = 4},
  [459] = {.lex_state = 156},
  [460] = {.lex_state = 159, .external_lex_state = 5},
  [461] = {.lex_state = 51, .external_lex_state = 2},
  [462] = {.lex_state = 51, .external_lex_state = 2},
  [463] = {.lex_state = 51, .external_lex_state = 2},
  [464] = {.lex_state = 211, .external_lex_state = 7},
  [465] = {.lex_state = 211, .external_lex_state = 7},
  [466] = {.lex_state = 250, .external_lex_state = 23},
  [467] = {.lex_state = 211, .external_lex_state = 7},
  [468] = {.lex_state = 215, .external_lex_state = 4},
  [469] = {.lex_state = 215, .external_lex_state = 4},
  [470] = {.lex_state = 211, .external_lex_state = 7},
  [471] = {.lex_state = 147, .external_lex_state = 7},
  [472] = {.lex_state = 215, .external_lex_state = 7},
  [473] = {.lex_state = 215, .external_lex_state = 7},
  [474] = {.lex_state = 170, .external_lex_state = 9},
  [475] = {.lex_state = 147, .external_lex_state = 7},
  [476] = {.lex_state = 172, .external_lex_state = 8},
  [477] = {.lex_state = 253, .external_lex_state = 13},
  [478] = {.lex_state = 149},
  [479] = {.lex_state = 253, .external_lex_state = 13},
  [480] = {.lex_state = 156},
  [481] = {.lex_state = 159, .external_lex_state = 5},
  [482] = {.lex_state = 51, .external_lex_state = 2},
  [483] = {.lex_state = 51, .external_lex_state = 2},
  [484] = {.lex_state = 51, .external_lex_state = 2},
  [485] = {.lex_state = 194},
  [486] = {.lex_state = 194},
  [487] = {.lex_state = 139},
  [488] = {.lex_state = 166, .external_lex_state = 18},
  [489] = {.lex_state = 166, .external_lex_state = 18},
  [490] = {.lex_state = 149},
  [491] = {.lex_state = 166, .external_lex_state = 18},
  [492] = {.lex_state = 166, .external_lex_state = 18},
  [493] = {.lex_state = 166, .external_lex_state = 18},
  [494] = {.lex_state = 112},
  [495] = {.lex_state = 181, .external_lex_state = 14},
  [496] = {.lex_state = 190, .external_lex_state = 5},
  [497] = {.lex_state = 181, .external_lex_state = 14},
  [498] = {.lex_state = 181, .external_lex_state = 14},
  [499] = {.lex_state = 112},
  [500] = {.lex_state = 199, .external_lex_state = 2},
  [501] = {.lex_state = 112},
  [502] = {.lex_state = 207, .external_lex_state = 2},
  [503] = {.lex_state = 112},
  [504] = {.lex_state = 199, .external_lex_state = 2},
  [505] = {.lex_state = 255, .external_lex_state = 24},
  [506] = {.lex_state = 257, .external_lex_state = 13},
  [507] = {.lex_state = 217, .external_lex_state = 19},
  [508] = {.lex_state = 217, .external_lex_state = 19},
  [509] = {.lex_state = 149},
  [510] = {.lex_state = 255, .external_lex_state = 24},
  [511] = {.lex_state = 257, .external_lex_state = 13},
  [512] = {.lex_state = 217, .external_lex_state = 19},
  [513] = {.lex_state = 217, .external_lex_state = 19},
  [514] = {.lex_state = 217, .external_lex_state = 19},
  [515] = {.lex_state = 112},
  [516] = {.lex_state = 181, .external_lex_state = 14},
  [517] = {.lex_state = 190, .external_lex_state = 5},
  [518] = {.lex_state = 181, .external_lex_state = 14},
  [519] = {.lex_state = 181, .external_lex_state = 14},
  [520] = {.lex_state = 112},
  [521] = {.lex_state = 199, .external_lex_state = 2},
  [522] = {.lex_state = 112},
  [523] = {.lex_state = 207, .external_lex_state = 2},
  [524] = {.lex_state = 112},
  [525] = {.lex_state = 199, .external_lex_state = 2},
  [526] = {.lex_state = 112, .external_lex_state = 24},
  [527] = {.lex_state = 259, .external_lex_state = 10},
  [528] = {.lex_state = 149},
  [529] = {.lex_state = 259, .external_lex_state = 10},
  [530] = {.lex_state = 156},
  [531] = {.lex_state = 159, .external_lex_state = 5},
  [532] = {.lex_state = 51, .external_lex_state = 2},
  [533] = {.lex_state = 51, .external_lex_state = 2},
  [534] = {.lex_state = 51, .external_lex_state = 2},
  [535] = {.lex_state = 259, .external_lex_state = 6},
  [536] = {.lex_state = 259, .external_lex_state = 6},
  [537] = {.lex_state = 211, .external_lex_state = 7},
  [538] = {.lex_state = 219, .external_lex_state = 2},
  [539] = {.lex_state = 141, .external_lex_state = 6},
  [540] = {.lex_state = 166, .external_lex_state = 8},
  [541] = {.lex_state = 219, .external_lex_state = 2},
  [542] = {.lex_state = 215, .external_lex_state = 7},
  [543] = {.lex_state = 177, .external_lex_state = 6},
  [544] = {.lex_state = 51, .external_lex_state = 2},
  [545] = {.lex_state = 261, .external_lex_state = 2},
  [546] = {.lex_state = 225, .external_lex_state = 2},
  [547] = {.lex_state = 141, .external_lex_state = 6},
  [548] = {.lex_state = 112},
  [549] = {.lex_state = 112},
  [550] = {.lex_state = 166, .external_lex_state = 8},
  [551] = {.lex_state = 225, .external_lex_state = 2},
  [552] = {.lex_state = 112},
  [553] = {.lex_state = 174, .external_lex_state = 10},
  [554] = {.lex_state = 263},
  [555] = {.lex_state = 174, .external_lex_state = 6},
  [556] = {.lex_state = 174, .external_lex_state = 10},
  [557] = {.lex_state = 174, .external_lex_state = 10},
  [558] = {.lex_state = 263},
  [559] = {.lex_state = 174, .external_lex_state = 6},
  [560] = {.lex_state = 242, .external_lex_state = 14},
  [561] = {.lex_state = 174, .external_lex_state = 10},
  [562] = {.lex_state = 181, .external_lex_state = 14},
  [563] = {.lex_state = 112},
  [564] = {.lex_state = 181, .external_lex_state = 14},
  [565] = {.lex_state = 181, .external_lex_state = 14},
  [566] = {.lex_state = 181, .external_lex_state = 14},
  [567] = {.lex_state = 174, .external_lex_state = 10},
  [568] = {.lex_state = 181, .external_lex_state = 14},
  [569] = {.lex_state = 174, .external_lex_state = 10},
  [570] = {.lex_state = 181, .external_lex_state = 14},
  [571] = {.lex_state = 174, .external_lex_state = 10},
  [572] = {.lex_state = 174, .external_lex_state = 10},
  [573] = {.lex_state = 112},
  [574] = {.lex_state = 269, .external_lex_state = 7},
  [575] = {.lex_state = 235, .external_lex_state = 20},
  [576] = {.lex_state = 141, .external_lex_state = 6},
  [577] = {.lex_state = 166, .external_lex_state = 8},
  [578] = {.lex_state = 235, .external_lex_state = 20},
  [579] = {.lex_state = 51},
  [580] = {.lex_state = 139},
  [581] = {.lex_state = 177, .external_lex_state = 6},
  [582] = {.lex_state = 172, .external_lex_state = 18},
  [583] = {.lex_state = 149},
  [584] = {.lex_state = 172, .external_lex_state = 18},
  [585] = {.lex_state = 156},
  [586] = {.lex_state = 159, .external_lex_state = 5},
  [587] = {.lex_state = 51, .external_lex_state = 2},
  [588] = {.lex_state = 51, .external_lex_state = 2},
  [589] = {.lex_state = 51, .external_lex_state = 2},
  [590] = {.lex_state = 211, .external_lex_state = 7},
  [591] = {.lex_state = 112},
  [592] = {.lex_state = 269, .external_lex_state = 7},
  [593] = {.lex_state = 170, .external_lex_state = 9},
  [594] = {.lex_state = 139},
  [595] = {.lex_state = 177, .external_lex_state = 11},
  [596] = {.lex_state = 177, .external_lex_state = 11},
  [597] = {.lex_state = 149},
  [598] = {.lex_state = 177, .external_lex_state = 11},
  [599] = {.lex_state = 177, .external_lex_state = 11},
  [600] = {.lex_state = 177, .external_lex_state = 11},
  [601] = {.lex_state = 112},
  [602] = {.lex_state = 181, .external_lex_state = 14},
  [603] = {.lex_state = 190, .external_lex_state = 5},
  [604] = {.lex_state = 181, .external_lex_state = 14},
  [605] = {.lex_state = 181, .external_lex_state = 14},
  [606] = {.lex_state = 112},
  [607] = {.lex_state = 199, .external_lex_state = 2},
  [608] = {.lex_state = 112},
  [609] = {.lex_state = 207, .external_lex_state = 2},
  [610] = {.lex_state = 112},
  [611] = {.lex_state = 199, .external_lex_state = 2},
  [612] = {.lex_state = 177, .external_lex_state = 3},
  [613] = {.lex_state = 168, .external_lex_state = 4},
  [614] = {.lex_state = 168, .external_lex_state = 4},
  [615] = {.lex_state = 168, .external_lex_state = 4},
  [616] = {.lex_state = 242, .external_lex_state = 14},
  [617] = {.lex_state = 168, .external_lex_state = 4},
  [618] = {.lex_state = 181, .external_lex_state = 14},
  [619] = {.lex_state = 112},
  [620] = {.lex_state = 181, .external_lex_state = 14},
  [621] = {.lex_state = 181, .external_lex_state = 14},
  [622] = {.lex_state = 181, .external_lex_state = 14},
  [623] = {.lex_state = 168, .external_lex_state = 4},
  [624] = {.lex_state = 181, .external_lex_state = 14},
  [625] = {.lex_state = 168, .external_lex_state = 4},
  [626] = {.lex_state = 181, .external_lex_state = 14},
  [627] = {.lex_state = 168, .external_lex_state = 4},
  [628] = {.lex_state = 168, .external_lex_state = 4},
  [629] = {.lex_state = 112},
  [630] = {.lex_state = 177, .external_lex_state = 6},
  [631] = {.lex_state = 177, .external_lex_state = 6},
  [632] = {.lex_state = 172, .external_lex_state = 8},
  [633] = {.lex_state = 139},
  [634] = {.lex_state = 211, .external_lex_state = 4},
  [635] = {.lex_state = 149},
  [636] = {.lex_state = 211, .external_lex_state = 4},
  [637] = {.lex_state = 156},
  [638] = {.lex_state = 159, .external_lex_state = 5},
  [639] = {.lex_state = 51, .external_lex_state = 2},
  [640] = {.lex_state = 51, .external_lex_state = 2},
  [641] = {.lex_state = 51, .external_lex_state = 2},
  [642] = {.lex_state = 211, .external_lex_state = 4},
  [643] = {.lex_state = 211, .external_lex_state = 4},
  [644] = {.lex_state = 168, .external_lex_state = 7},
  [645] = {.lex_state = 211, .external_lex_state = 7},
  [646] = {.lex_state = 211, .external_lex_state = 7},
  [647] = {.lex_state = 240, .external_lex_state = 2},
  [648] = {.lex_state = 168, .external_lex_state = 7},
  [649] = {.lex_state = 177, .external_lex_state = 3},
  [650] = {.lex_state = 194},
  [651] = {.lex_state = 141, .external_lex_state = 11},
  [652] = {.lex_state = 141, .external_lex_state = 11},
  [653] = {.lex_state = 141, .external_lex_state = 11},
  [654] = {.lex_state = 141, .external_lex_state = 11},
  [655] = {.lex_state = 141, .external_lex_state = 11},
  [656] = {.lex_state = 242, .external_lex_state = 14},
  [657] = {.lex_state = 141, .external_lex_state = 11},
  [658] = {.lex_state = 181, .external_lex_state = 14},
  [659] = {.lex_state = 112},
  [660] = {.lex_state = 181, .external_lex_state = 14},
  [661] = {.lex_state = 181, .external_lex_state = 14},
  [662] = {.lex_state = 181, .external_lex_state = 14},
  [663] = {.lex_state = 141, .external_lex_state = 11},
  [664] = {.lex_state = 181, .external_lex_state = 14},
  [665] = {.lex_state = 141, .external_lex_state = 11},
  [666] = {.lex_state = 181, .external_lex_state = 14},
  [667] = {.lex_state = 141, .external_lex_state = 11},
  [668] = {.lex_state = 141, .external_lex_state = 11},
  [669] = {.lex_state = 139, .external_lex_state = 12},
  [670] = {.lex_state = 139, .external_lex_state = 12},
  [671] = {.lex_state = 139, .external_lex_state = 12},
  [672] = {.lex_state = 242, .external_lex_state = 14},
  [673] = {.lex_state = 139, .external_lex_state = 12},
  [674] = {.lex_state = 181, .external_lex_state = 14},
  [675] = {.lex_state = 112},
  [676] = {.lex_state = 181, .external_lex_state = 14},
  [677] = {.lex_state = 181, .external_lex_state = 14},
  [678] = {.lex_state = 181, .external_lex_state = 14},
  [679] = {.lex_state = 139, .external_lex_state = 12},
  [680] = {.lex_state = 181, .external_lex_state = 14},
  [681] = {.lex_state = 139, .external_lex_state = 12},
  [682] = {.lex_state = 181, .external_lex_state = 14},
  [683] = {.lex_state = 139, .external_lex_state = 12},
  [684] = {.lex_state = 139, .external_lex_state = 12},
  [685] = {.lex_state = 149, .external_lex_state = 13},
  [686] = {.lex_state = 149},
  [687] = {.lex_state = 242, .external_lex_state = 14},
  [688] = {.lex_state = 149, .external_lex_state = 13},
  [689] = {.lex_state = 181, .external_lex_state = 14},
  [690] = {.lex_state = 112},
  [691] = {.lex_state = 181, .external_lex_state = 14},
  [692] = {.lex_state = 181, .external_lex_state = 14},
  [693] = {.lex_state = 181, .external_lex_state = 14},
  [694] = {.lex_state = 149, .external_lex_state = 13},
  [695] = {.lex_state = 181, .external_lex_state = 14},
  [696] = {.lex_state = 149, .external_lex_state = 13},
  [697] = {.lex_state = 181, .external_lex_state = 14},
  [698] = {.lex_state = 149, .external_lex_state = 13},
  [699] = {.lex_state = 147, .external_lex_state = 4},
  [700] = {.lex_state = 271, .external_lex_state = 21},
  [701] = {.lex_state = 149},
  [702] = {.lex_state = 271, .external_lex_state = 21},
  [703] = {.lex_state = 156},
  [704] = {.lex_state = 159, .external_lex_state = 5},
  [705] = {.lex_state = 51, .external_lex_state = 2},
  [706] = {.lex_state = 51, .external_lex_state = 2},
  [707] = {.lex_state = 51, .external_lex_state = 2},
  [708] = {.lex_state = 112, .external_lex_state = 14},
  [709] = {.lex_state = 217, .external_lex_state = 19},
  [710] = {.lex_state = 217, .external_lex_state = 19},
  [711] = {.lex_state = 217, .external_lex_state = 19},
  [712] = {.lex_state = 139},
  [713] = {.lex_state = 181, .external_lex_state = 21},
  [714] = {.lex_state = 181, .external_lex_state = 21},
  [715] = {.lex_state = 149},
  [716] = {.lex_state = 181, .external_lex_state = 21},
  [717] = {.lex_state = 181, .external_lex_state = 21},
  [718] = {.lex_state = 181, .external_lex_state = 21},
  [719] = {.lex_state = 112},
  [720] = {.lex_state = 181, .external_lex_state = 14},
  [721] = {.lex_state = 190, .external_lex_state = 5},
  [722] = {.lex_state = 181, .external_lex_state = 14},
  [723] = {.lex_state = 181, .external_lex_state = 14},
  [724] = {.lex_state = 112},
  [725] = {.lex_state = 199, .external_lex_state = 2},
  [726] = {.lex_state = 112},
  [727] = {.lex_state = 207, .external_lex_state = 2},
  [728] = {.lex_state = 112},
  [729] = {.lex_state = 199, .external_lex_state = 2},
  [730] = {.lex_state = 147, .external_lex_state = 4},
  [731] = {.lex_state = 181, .external_lex_state = 14},
  [732] = {.lex_state = 242, .external_lex_state = 14},
  [733] = {.lex_state = 147, .external_lex_state = 4},
  [734] = {.lex_state = 181, .external_lex_state = 14},
  [735] = {.lex_state = 147, .external_lex_state = 4},
  [736] = {.lex_state = 181, .external_lex_state = 14},
  [737] = {.lex_state = 181, .external_lex_state = 14},
  [738] = {.lex_state = 147, .external_lex_state = 4},
  [739] = {.lex_state = 199, .external_lex_state = 2},
  [740] = {.lex_state = 194},
  [741] = {.lex_state = 199, .external_lex_state = 12},
  [742] = {.lex_state = 149},
  [743] = {.lex_state = 199, .external_lex_state = 12},
  [744] = {.lex_state = 156},
  [745] = {.lex_state = 159, .external_lex_state = 5},
  [746] = {.lex_state = 51, .external_lex_state = 2},
  [747] = {.lex_state = 51, .external_lex_state = 2},
  [748] = {.lex_state = 51, .external_lex_state = 2},
  [749] = {.lex_state = 139},
  [750] = {.lex_state = 219, .external_lex_state = 2},
  [751] = {.lex_state = 246, .external_lex_state = 16},
  [752] = {.lex_state = 225, .external_lex_state = 2},
  [753] = {.lex_state = 174, .external_lex_state = 6},
  [754] = {.lex_state = 112},
  [755] = {.lex_state = 174, .external_lex_state = 6},
  [756] = {.lex_state = 112},
  [757] = {.lex_state = 112},
  [758] = {.lex_state = 235, .external_lex_state = 20},
  [759] = {.lex_state = 273, .external_lex_state = 16},
  [760] = {.lex_state = 112},
  [761] = {.lex_state = 240, .external_lex_state = 2},
  [762] = {.lex_state = 177, .external_lex_state = 6},
  [763] = {.lex_state = 172, .external_lex_state = 8},
  [764] = {.lex_state = 170, .external_lex_state = 9},
  [765] = {.lex_state = 192, .external_lex_state = 5},
  [766] = {.lex_state = 139},
  [767] = {.lex_state = 192, .external_lex_state = 22},
  [768] = {.lex_state = 192, .external_lex_state = 22},
  [769] = {.lex_state = 149},
  [770] = {.lex_state = 192, .external_lex_state = 22},
  [771] = {.lex_state = 192, .external_lex_state = 22},
  [772] = {.lex_state = 192, .external_lex_state = 22},
  [773] = {.lex_state = 112},
  [774] = {.lex_state = 181, .external_lex_state = 14},
  [775] = {.lex_state = 190, .external_lex_state = 5},
  [776] = {.lex_state = 181, .external_lex_state = 14},
  [777] = {.lex_state = 181, .external_lex_state = 14},
  [778] = {.lex_state = 112},
  [779] = {.lex_state = 199, .external_lex_state = 2},
  [780] = {.lex_state = 112},
  [781] = {.lex_state = 207, .external_lex_state = 2},
  [782] = {.lex_state = 112},
  [783] = {.lex_state = 199, .external_lex_state = 2},
  [784] = {.lex_state = 192, .external_lex_state = 5},
  [785] = {.lex_state = 194, .external_lex_state = 15},
  [786] = {.lex_state = 194, .external_lex_state = 15},
  [787] = {.lex_state = 194, .external_lex_state = 15},
  [788] = {.lex_state = 242, .external_lex_state = 14},
  [789] = {.lex_state = 194, .external_lex_state = 15},
  [790] = {.lex_state = 181, .external_lex_state = 14},
  [791] = {.lex_state = 112},
  [792] = {.lex_state = 181, .external_lex_state = 14},
  [793] = {.lex_state = 181, .external_lex_state = 14},
  [794] = {.lex_state = 181, .external_lex_state = 14},
  [795] = {.lex_state = 194, .external_lex_state = 15},
  [796] = {.lex_state = 181, .external_lex_state = 14},
  [797] = {.lex_state = 194, .external_lex_state = 15},
  [798] = {.lex_state = 181, .external_lex_state = 14},
  [799] = {.lex_state = 194, .external_lex_state = 15},
  [800] = {.lex_state = 194, .external_lex_state = 15},
  [801] = {.lex_state = 112},
  [802] = {.lex_state = 112},
  [803] = {.lex_state = 199, .external_lex_state = 2},
  [804] = {.lex_state = 112},
  [805] = {.lex_state = 199, .external_lex_state = 2},
  [806] = {.lex_state = 139},
  [807] = {.lex_state = 246, .external_lex_state = 15},
  [808] = {.lex_state = 149},
  [809] = {.lex_state = 246, .external_lex_state = 15},
  [810] = {.lex_state = 156},
  [811] = {.lex_state = 159, .external_lex_state = 5},
  [812] = {.lex_state = 51, .external_lex_state = 2},
  [813] = {.lex_state = 51, .external_lex_state = 2},
  [814] = {.lex_state = 51, .external_lex_state = 2},
  [815] = {.lex_state = 244, .external_lex_state = 16},
  [816] = {.lex_state = 244, .external_lex_state = 16},
  [817] = {.lex_state = 250, .external_lex_state = 23},
  [818] = {.lex_state = 244, .external_lex_state = 16},
  [819] = {.lex_state = 246, .external_lex_state = 15},
  [820] = {.lex_state = 246, .external_lex_state = 15},
  [821] = {.lex_state = 244, .external_lex_state = 16},
  [822] = {.lex_state = 194, .external_lex_state = 16},
  [823] = {.lex_state = 246, .external_lex_state = 16},
  [824] = {.lex_state = 246, .external_lex_state = 16},
  [825] = {.lex_state = 194, .external_lex_state = 16},
  [826] = {.lex_state = 207, .external_lex_state = 12},
  [827] = {.lex_state = 149},
  [828] = {.lex_state = 207, .external_lex_state = 12},
  [829] = {.lex_state = 156},
  [830] = {.lex_state = 159, .external_lex_state = 5},
  [831] = {.lex_state = 51, .external_lex_state = 2},
  [832] = {.lex_state = 51, .external_lex_state = 2},
  [833] = {.lex_state = 51, .external_lex_state = 2},
  [834] = {.lex_state = 248, .external_lex_state = 16},
  [835] = {.lex_state = 112},
  [836] = {.lex_state = 275, .external_lex_state = 16},
  [837] = {.lex_state = 170, .external_lex_state = 9},
  [838] = {.lex_state = 139},
  [839] = {.lex_state = 201, .external_lex_state = 22},
  [840] = {.lex_state = 201, .external_lex_state = 22},
  [841] = {.lex_state = 149},
  [842] = {.lex_state = 201, .external_lex_state = 22},
  [843] = {.lex_state = 201, .external_lex_state = 22},
  [844] = {.lex_state = 201, .external_lex_state = 22},
  [845] = {.lex_state = 112},
  [846] = {.lex_state = 181, .external_lex_state = 14},
  [847] = {.lex_state = 190, .external_lex_state = 5},
  [848] = {.lex_state = 181, .external_lex_state = 14},
  [849] = {.lex_state = 181, .external_lex_state = 14},
  [850] = {.lex_state = 112},
  [851] = {.lex_state = 199, .external_lex_state = 2},
  [852] = {.lex_state = 112},
  [853] = {.lex_state = 207, .external_lex_state = 2},
  [854] = {.lex_state = 112},
  [855] = {.lex_state = 199, .external_lex_state = 2},
  [856] = {.lex_state = 201, .external_lex_state = 5},
  [857] = {.lex_state = 203, .external_lex_state = 15},
  [858] = {.lex_state = 203, .external_lex_state = 15},
  [859] = {.lex_state = 203, .external_lex_state = 15},
  [860] = {.lex_state = 242, .external_lex_state = 14},
  [861] = {.lex_state = 203, .external_lex_state = 15},
  [862] = {.lex_state = 181, .external_lex_state = 14},
  [863] = {.lex_state = 112},
  [864] = {.lex_state = 181, .external_lex_state = 14},
  [865] = {.lex_state = 181, .external_lex_state = 14},
  [866] = {.lex_state = 181, .external_lex_state = 14},
  [867] = {.lex_state = 203, .external_lex_state = 15},
  [868] = {.lex_state = 181, .external_lex_state = 14},
  [869] = {.lex_state = 203, .external_lex_state = 15},
  [870] = {.lex_state = 181, .external_lex_state = 14},
  [871] = {.lex_state = 203, .external_lex_state = 15},
  [872] = {.lex_state = 203, .external_lex_state = 15},
  [873] = {.lex_state = 112},
  [874] = {.lex_state = 207, .external_lex_state = 2},
  [875] = {.lex_state = 112},
  [876] = {.lex_state = 207, .external_lex_state = 2},
  [877] = {.lex_state = 139},
  [878] = {.lex_state = 248, .external_lex_state = 15},
  [879] = {.lex_state = 149},
  [880] = {.lex_state = 248, .external_lex_state = 15},
  [881] = {.lex_state = 156},
  [882] = {.lex_state = 159, .external_lex_state = 5},
  [883] = {.lex_state = 51, .external_lex_state = 2},
  [884] = {.lex_state = 51, .external_lex_state = 2},
  [885] = {.lex_state = 51, .external_lex_state = 2},
  [886] = {.lex_state = 248, .external_lex_state = 15},
  [887] = {.lex_state = 248, .external_lex_state = 15},
  [888] = {.lex_state = 203, .external_lex_state = 16},
  [889] = {.lex_state = 248, .external_lex_state = 16},
  [890] = {.lex_state = 248, .external_lex_state = 16},
  [891] = {.lex_state = 203, .external_lex_state = 16},
  [892] = {.lex_state = 237, .external_lex_state = 7},
  [893] = {.lex_state = 215, .external_lex_state = 4},
  [894] = {.lex_state = 215, .external_lex_state = 4},
  [895] = {.lex_state = 211, .external_lex_state = 7},
  [896] = {.lex_state = 139},
  [897] = {.lex_state = 215, .external_lex_state = 4},
  [898] = {.lex_state = 215, .external_lex_state = 4},
  [899] = {.lex_state = 149},
  [900] = {.lex_state = 215, .external_lex_state = 4},
  [901] = {.lex_state = 215, .external_lex_state = 4},
  [902] = {.lex_state = 215, .external_lex_state = 4},
  [903] = {.lex_state = 112},
  [904] = {.lex_state = 181, .external_lex_state = 14},
  [905] = {.lex_state = 190, .external_lex_state = 5},
  [906] = {.lex_state = 181, .external_lex_state = 14},
  [907] = {.lex_state = 181, .external_lex_state = 14},
  [908] = {.lex_state = 112},
  [909] = {.lex_state = 199, .external_lex_state = 2},
  [910] = {.lex_state = 112},
  [911] = {.lex_state = 207, .external_lex_state = 2},
  [912] = {.lex_state = 112},
  [913] = {.lex_state = 199, .external_lex_state = 2},
  [914] = {.lex_state = 250, .external_lex_state = 23},
  [915] = {.lex_state = 211, .external_lex_state = 7},
  [916] = {.lex_state = 156},
  [917] = {.lex_state = 159, .external_lex_state = 5},
  [918] = {.lex_state = 250, .external_lex_state = 23},
  [919] = {.lex_state = 139, .external_lex_state = 12},
  [920] = {.lex_state = 139, .external_lex_state = 12},
  [921] = {.lex_state = 215, .external_lex_state = 7},
  [922] = {.lex_state = 139},
  [923] = {.lex_state = 253, .external_lex_state = 13},
  [924] = {.lex_state = 253, .external_lex_state = 13},
  [925] = {.lex_state = 149},
  [926] = {.lex_state = 253, .external_lex_state = 13},
  [927] = {.lex_state = 253, .external_lex_state = 13},
  [928] = {.lex_state = 253, .external_lex_state = 13},
  [929] = {.lex_state = 112},
  [930] = {.lex_state = 181, .external_lex_state = 14},
  [931] = {.lex_state = 190, .external_lex_state = 5},
  [932] = {.lex_state = 181, .external_lex_state = 14},
  [933] = {.lex_state = 181, .external_lex_state = 14},
  [934] = {.lex_state = 112},
  [935] = {.lex_state = 199, .external_lex_state = 2},
  [936] = {.lex_state = 112},
  [937] = {.lex_state = 207, .external_lex_state = 2},
  [938] = {.lex_state = 112},
  [939] = {.lex_state = 199, .external_lex_state = 2},
  [940] = {.lex_state = 172, .external_lex_state = 8},
  [941] = {.lex_state = 194},
  [942] = {.lex_state = 166, .external_lex_state = 18},
  [943] = {.lex_state = 166, .external_lex_state = 18},
  [944] = {.lex_state = 166, .external_lex_state = 18},
  [945] = {.lex_state = 242, .external_lex_state = 14},
  [946] = {.lex_state = 166, .external_lex_state = 18},
  [947] = {.lex_state = 181, .external_lex_state = 14},
  [948] = {.lex_state = 112},
  [949] = {.lex_state = 181, .external_lex_state = 14},
  [950] = {.lex_state = 181, .external_lex_state = 14},
  [951] = {.lex_state = 181, .external_lex_state = 14},
  [952] = {.lex_state = 166, .external_lex_state = 18},
  [953] = {.lex_state = 181, .external_lex_state = 14},
  [954] = {.lex_state = 166, .external_lex_state = 18},
  [955] = {.lex_state = 181, .external_lex_state = 14},
  [956] = {.lex_state = 166, .external_lex_state = 18},
  [957] = {.lex_state = 166, .external_lex_state = 18},
  [958] = {.lex_state = 257, .external_lex_state = 13},
  [959] = {.lex_state = 217, .external_lex_state = 19},
  [960] = {.lex_state = 112},
  [961] = {.lex_state = 139},
  [962] = {.lex_state = 217, .external_lex_state = 19},
  [963] = {.lex_state = 217, .external_lex_state = 19},
  [964] = {.lex_state = 257, .external_lex_state = 13},
  [965] = {.lex_state = 112},
  [966] = {.lex_state = 242, .external_lex_state = 14},
  [967] = {.lex_state = 217, .external_lex_state = 19},
  [968] = {.lex_state = 181, .external_lex_state = 14},
  [969] = {.lex_state = 112},
  [970] = {.lex_state = 181, .external_lex_state = 14},
  [971] = {.lex_state = 181, .external_lex_state = 14},
  [972] = {.lex_state = 181, .external_lex_state = 14},
  [973] = {.lex_state = 217, .external_lex_state = 19},
  [974] = {.lex_state = 181, .external_lex_state = 14},
  [975] = {.lex_state = 217, .external_lex_state = 19},
  [976] = {.lex_state = 181, .external_lex_state = 14},
  [977] = {.lex_state = 217, .external_lex_state = 19},
  [978] = {.lex_state = 217, .external_lex_state = 19},
  [979] = {.lex_state = 139},
  [980] = {.lex_state = 259, .external_lex_state = 10},
  [981] = {.lex_state = 259, .external_lex_state = 10},
  [982] = {.lex_state = 149},
  [983] = {.lex_state = 259, .external_lex_state = 10},
  [984] = {.lex_state = 259, .external_lex_state = 10},
  [985] = {.lex_state = 259, .external_lex_state = 10},
  [986] = {.lex_state = 112},
  [987] = {.lex_state = 181, .external_lex_state = 14},
  [988] = {.lex_state = 190, .external_lex_state = 5},
  [989] = {.lex_state = 181, .external_lex_state = 14},
  [990] = {.lex_state = 181, .external_lex_state = 14},
  [991] = {.lex_state = 112},
  [992] = {.lex_state = 199, .external_lex_state = 2},
  [993] = {.lex_state = 112},
  [994] = {.lex_state = 207, .external_lex_state = 2},
  [995] = {.lex_state = 112},
  [996] = {.lex_state = 199, .external_lex_state = 2},
  [997] = {.lex_state = 112},
  [998] = {.lex_state = 259, .external_lex_state = 6},
  [999] = {.lex_state = 219, .external_lex_state = 2},
  [1000] = {.lex_state = 211, .external_lex_state = 7},
  [1001] = {.lex_state = 219, .external_lex_state = 2},
  [1002] = {.lex_state = 112},
  [1003] = {.lex_state = 261, .external_lex_state = 2},
  [1004] = {.lex_state = 141, .external_lex_state = 6},
  [1005] = {.lex_state = 166, .external_lex_state = 8},
  [1006] = {.lex_state = 261, .external_lex_state = 2},
  [1007] = {.lex_state = 225, .external_lex_state = 2},
  [1008] = {.lex_state = 177, .external_lex_state = 6},
  [1009] = {.lex_state = 112},
  [1010] = {.lex_state = 225, .external_lex_state = 2},
  [1011] = {.lex_state = 112},
  [1012] = {.lex_state = 112},
  [1013] = {.lex_state = 177, .external_lex_state = 6},
  [1014] = {.lex_state = 277, .external_lex_state = 13},
  [1015] = {.lex_state = 149},
  [1016] = {.lex_state = 277, .external_lex_state = 13},
  [1017] = {.lex_state = 156},
  [1018] = {.lex_state = 159, .external_lex_state = 5},
  [1019] = {.lex_state = 51, .external_lex_state = 2},
  [1020] = {.lex_state = 51, .external_lex_state = 2},
  [1021] = {.lex_state = 51, .external_lex_state = 2},
  [1022] = {.lex_state = 139},
  [1023] = {.lex_state = 112},
  [1024] = {.lex_state = 136},
  [1025] = {.lex_state = 139},
  [1026] = {.lex_state = 263},
  [1027] = {.lex_state = 177, .external_lex_state = 6},
  [1028] = {.lex_state = 112},
  [1029] = {.lex_state = 139},
  [1030] = {.lex_state = 263},
  [1031] = {.lex_state = 174, .external_lex_state = 10},
  [1032] = {.lex_state = 271, .external_lex_state = 21},
  [1033] = {.lex_state = 271, .external_lex_state = 21},
  [1034] = {.lex_state = 112, .external_lex_state = 14},
  [1035] = {.lex_state = 174, .external_lex_state = 10},
  [1036] = {.lex_state = 242, .external_lex_state = 14},
  [1037] = {.lex_state = 174, .external_lex_state = 10},
  [1038] = {.lex_state = 181, .external_lex_state = 14},
  [1039] = {.lex_state = 174, .external_lex_state = 10},
  [1040] = {.lex_state = 181, .external_lex_state = 14},
  [1041] = {.lex_state = 181, .external_lex_state = 14},
  [1042] = {.lex_state = 174, .external_lex_state = 10},
  [1043] = {.lex_state = 237, .external_lex_state = 7},
  [1044] = {.lex_state = 235, .external_lex_state = 20},
  [1045] = {.lex_state = 269, .external_lex_state = 7},
  [1046] = {.lex_state = 235, .external_lex_state = 20},
  [1047] = {.lex_state = 139},
  [1048] = {.lex_state = 279, .external_lex_state = 10},
  [1049] = {.lex_state = 149},
  [1050] = {.lex_state = 279, .external_lex_state = 10},
  [1051] = {.lex_state = 156},
  [1052] = {.lex_state = 159, .external_lex_state = 5},
  [1053] = {.lex_state = 51, .external_lex_state = 2},
  [1054] = {.lex_state = 51, .external_lex_state = 2},
  [1055] = {.lex_state = 51, .external_lex_state = 2},
  [1056] = {.lex_state = 177, .external_lex_state = 6},
  [1057] = {.lex_state = 139},
  [1058] = {.lex_state = 172, .external_lex_state = 18},
  [1059] = {.lex_state = 172, .external_lex_state = 18},
  [1060] = {.lex_state = 149},
  [1061] = {.lex_state = 172, .external_lex_state = 18},
  [1062] = {.lex_state = 172, .external_lex_state = 18},
  [1063] = {.lex_state = 172, .external_lex_state = 18},
  [1064] = {.lex_state = 112},
  [1065] = {.lex_state = 181, .external_lex_state = 14},
  [1066] = {.lex_state = 190, .external_lex_state = 5},
  [1067] = {.lex_state = 181, .external_lex_state = 14},
  [1068] = {.lex_state = 181, .external_lex_state = 14},
  [1069] = {.lex_state = 112},
  [1070] = {.lex_state = 199, .external_lex_state = 2},
  [1071] = {.lex_state = 112},
  [1072] = {.lex_state = 207, .external_lex_state = 2},
  [1073] = {.lex_state = 112},
  [1074] = {.lex_state = 199, .external_lex_state = 2},
  [1075] = {.lex_state = 211, .external_lex_state = 7},
  [1076] = {.lex_state = 112},
  [1077] = {.lex_state = 51},
  [1078] = {.lex_state = 139},
  [1079] = {.lex_state = 177, .external_lex_state = 11},
  [1080] = {.lex_state = 177, .external_lex_state = 11},
  [1081] = {.lex_state = 177, .external_lex_state = 11},
  [1082] = {.lex_state = 177, .external_lex_state = 11},
  [1083] = {.lex_state = 177, .external_lex_state = 11},
  [1084] = {.lex_state = 242, .external_lex_state = 14},
  [1085] = {.lex_state = 177, .external_lex_state = 11},
  [1086] = {.lex_state = 181, .external_lex_state = 14},
  [1087] = {.lex_state = 112},
  [1088] = {.lex_state = 181, .external_lex_state = 14},
  [1089] = {.lex_state = 181, .external_lex_state = 14},
  [1090] = {.lex_state = 181, .external_lex_state = 14},
  [1091] = {.lex_state = 177, .external_lex_state = 11},
  [1092] = {.lex_state = 181, .external_lex_state = 14},
  [1093] = {.lex_state = 177, .external_lex_state = 11},
  [1094] = {.lex_state = 181, .external_lex_state = 14},
  [1095] = {.lex_state = 177, .external_lex_state = 11},
  [1096] = {.lex_state = 177, .external_lex_state = 11},
  [1097] = {.lex_state = 168, .external_lex_state = 4},
  [1098] = {.lex_state = 271, .external_lex_state = 21},
  [1099] = {.lex_state = 271, .external_lex_state = 21},
  [1100] = {.lex_state = 112, .external_lex_state = 14},
  [1101] = {.lex_state = 168, .external_lex_state = 4},
  [1102] = {.lex_state = 242, .external_lex_state = 14},
  [1103] = {.lex_state = 168, .external_lex_state = 4},
  [1104] = {.lex_state = 181, .external_lex_state = 14},
  [1105] = {.lex_state = 168, .external_lex_state = 4},
  [1106] = {.lex_state = 181, .external_lex_state = 14},
  [1107] = {.lex_state = 181, .external_lex_state = 14},
  [1108] = {.lex_state = 168, .external_lex_state = 4},
  [1109] = {.lex_state = 269, .external_lex_state = 7},
  [1110] = {.lex_state = 211, .external_lex_state = 4},
  [1111] = {.lex_state = 211, .external_lex_state = 4},
  [1112] = {.lex_state = 139},
  [1113] = {.lex_state = 211, .external_lex_state = 4},
  [1114] = {.lex_state = 211, .external_lex_state = 4},
  [1115] = {.lex_state = 149},
  [1116] = {.lex_state = 211, .external_lex_state = 4},
  [1117] = {.lex_state = 211, .external_lex_state = 4},
  [1118] = {.lex_state = 211, .external_lex_state = 4},
  [1119] = {.lex_state = 112},
  [1120] = {.lex_state = 181, .external_lex_state = 14},
  [1121] = {.lex_state = 190, .external_lex_state = 5},
  [1122] = {.lex_state = 181, .external_lex_state = 14},
  [1123] = {.lex_state = 181, .external_lex_state = 14},
  [1124] = {.lex_state = 112},
  [1125] = {.lex_state = 199, .external_lex_state = 2},
  [1126] = {.lex_state = 112},
  [1127] = {.lex_state = 207, .external_lex_state = 2},
  [1128] = {.lex_state = 112},
  [1129] = {.lex_state = 199, .external_lex_state = 2},
  [1130] = {.lex_state = 177, .external_lex_state = 6},
  [1131] = {.lex_state = 211, .external_lex_state = 7},
  [1132] = {.lex_state = 177, .external_lex_state = 3},
  [1133] = {.lex_state = 194},
  [1134] = {.lex_state = 141, .external_lex_state = 11},
  [1135] = {.lex_state = 271, .external_lex_state = 21},
  [1136] = {.lex_state = 271, .external_lex_state = 21},
  [1137] = {.lex_state = 112, .external_lex_state = 14},
  [1138] = {.lex_state = 141, .external_lex_state = 11},
  [1139] = {.lex_state = 242, .external_lex_state = 14},
  [1140] = {.lex_state = 141, .external_lex_state = 11},
  [1141] = {.lex_state = 181, .external_lex_state = 14},
  [1142] = {.lex_state = 141, .external_lex_state = 11},
  [1143] = {.lex_state = 181, .external_lex_state = 14},
  [1144] = {.lex_state = 181, .external_lex_state = 14},
  [1145] = {.lex_state = 141, .external_lex_state = 11},
  [1146] = {.lex_state = 139, .external_lex_state = 12},
  [1147] = {.lex_state = 271, .external_lex_state = 21},
  [1148] = {.lex_state = 271, .external_lex_state = 21},
  [1149] = {.lex_state = 112, .external_lex_state = 14},
  [1150] = {.lex_state = 139, .external_lex_state = 12},
  [1151] = {.lex_state = 242, .external_lex_state = 14},
  [1152] = {.lex_state = 139, .external_lex_state = 12},
  [1153] = {.lex_state = 181, .external_lex_state = 14},
  [1154] = {.lex_state = 139, .external_lex_state = 12},
  [1155] = {.lex_state = 181, .external_lex_state = 14},
  [1156] = {.lex_state = 181, .external_lex_state = 14},
  [1157] = {.lex_state = 139, .external_lex_state = 12},
  [1158] = {.lex_state = 149, .external_lex_state = 13},
  [1159] = {.lex_state = 149, .external_lex_state = 13},
  [1160] = {.lex_state = 271, .external_lex_state = 21},
  [1161] = {.lex_state = 271, .external_lex_state = 21},
  [1162] = {.lex_state = 112, .external_lex_state = 14},
  [1163] = {.lex_state = 149, .external_lex_state = 13},
  [1164] = {.lex_state = 242, .external_lex_state = 14},
  [1165] = {.lex_state = 149, .external_lex_state = 13},
  [1166] = {.lex_state = 181, .external_lex_state = 14},
  [1167] = {.lex_state = 149, .external_lex_state = 13},
  [1168] = {.lex_state = 181, .external_lex_state = 14},
  [1169] = {.lex_state = 181, .external_lex_state = 14},
  [1170] = {.lex_state = 149, .external_lex_state = 13},
  [1171] = {.lex_state = 139},
  [1172] = {.lex_state = 147, .external_lex_state = 4},
  [1173] = {.lex_state = 271, .external_lex_state = 21},
  [1174] = {.lex_state = 271, .external_lex_state = 21},
  [1175] = {.lex_state = 149},
  [1176] = {.lex_state = 147, .external_lex_state = 4},
  [1177] = {.lex_state = 271, .external_lex_state = 21},
  [1178] = {.lex_state = 271, .external_lex_state = 21},
  [1179] = {.lex_state = 271, .external_lex_state = 21},
  [1180] = {.lex_state = 112},
  [1181] = {.lex_state = 181, .external_lex_state = 14},
  [1182] = {.lex_state = 190, .external_lex_state = 5},
  [1183] = {.lex_state = 181, .external_lex_state = 14},
  [1184] = {.lex_state = 181, .external_lex_state = 14},
  [1185] = {.lex_state = 112},
  [1186] = {.lex_state = 199, .external_lex_state = 2},
  [1187] = {.lex_state = 112},
  [1188] = {.lex_state = 207, .external_lex_state = 2},
  [1189] = {.lex_state = 112},
  [1190] = {.lex_state = 199, .external_lex_state = 2},
  [1191] = {.lex_state = 255, .external_lex_state = 24},
  [1192] = {.lex_state = 181, .external_lex_state = 21},
  [1193] = {.lex_state = 255, .external_lex_state = 24},
  [1194] = {.lex_state = 181, .external_lex_state = 21},
  [1195] = {.lex_state = 112, .external_lex_state = 24},
  [1196] = {.lex_state = 181, .external_lex_state = 21},
  [1197] = {.lex_state = 181, .external_lex_state = 21},
  [1198] = {.lex_state = 181, .external_lex_state = 21},
  [1199] = {.lex_state = 242, .external_lex_state = 14},
  [1200] = {.lex_state = 181, .external_lex_state = 21},
  [1201] = {.lex_state = 181, .external_lex_state = 14},
  [1202] = {.lex_state = 112},
  [1203] = {.lex_state = 181, .external_lex_state = 14},
  [1204] = {.lex_state = 181, .external_lex_state = 14},
  [1205] = {.lex_state = 181, .external_lex_state = 14},
  [1206] = {.lex_state = 181, .external_lex_state = 21},
  [1207] = {.lex_state = 181, .external_lex_state = 14},
  [1208] = {.lex_state = 181, .external_lex_state = 21},
  [1209] = {.lex_state = 181, .external_lex_state = 14},
  [1210] = {.lex_state = 181, .external_lex_state = 21},
  [1211] = {.lex_state = 181, .external_lex_state = 21},
  [1212] = {.lex_state = 271, .external_lex_state = 21},
  [1213] = {.lex_state = 271, .external_lex_state = 21},
  [1214] = {.lex_state = 112, .external_lex_state = 14},
  [1215] = {.lex_state = 147, .external_lex_state = 4},
  [1216] = {.lex_state = 147, .external_lex_state = 4},
  [1217] = {.lex_state = 199, .external_lex_state = 2},
  [1218] = {.lex_state = 194},
  [1219] = {.lex_state = 139},
  [1220] = {.lex_state = 199, .external_lex_state = 12},
  [1221] = {.lex_state = 199, .external_lex_state = 12},
  [1222] = {.lex_state = 149},
  [1223] = {.lex_state = 199, .external_lex_state = 12},
  [1224] = {.lex_state = 199, .external_lex_state = 12},
  [1225] = {.lex_state = 199, .external_lex_state = 12},
  [1226] = {.lex_state = 112},
  [1227] = {.lex_state = 181, .external_lex_state = 14},
  [1228] = {.lex_state = 190, .external_lex_state = 5},
  [1229] = {.lex_state = 181, .external_lex_state = 14},
  [1230] = {.lex_state = 181, .external_lex_state = 14},
  [1231] = {.lex_state = 112},
  [1232] = {.lex_state = 199, .external_lex_state = 2},
  [1233] = {.lex_state = 112},
  [1234] = {.lex_state = 207, .external_lex_state = 2},
  [1235] = {.lex_state = 112},
  [1236] = {.lex_state = 199, .external_lex_state = 2},
  [1237] = {.lex_state = 259, .external_lex_state = 6},
  [1238] = {.lex_state = 244, .external_lex_state = 16},
  [1239] = {.lex_state = 219, .external_lex_state = 2},
  [1240] = {.lex_state = 246, .external_lex_state = 16},
  [1241] = {.lex_state = 112},
  [1242] = {.lex_state = 112},
  [1243] = {.lex_state = 225, .external_lex_state = 2},
  [1244] = {.lex_state = 112},
  [1245] = {.lex_state = 263},
  [1246] = {.lex_state = 174, .external_lex_state = 6},
  [1247] = {.lex_state = 263},
  [1248] = {.lex_state = 174, .external_lex_state = 6},
  [1249] = {.lex_state = 112},
  [1250] = {.lex_state = 281, .external_lex_state = 16},
  [1251] = {.lex_state = 235, .external_lex_state = 20},
  [1252] = {.lex_state = 51},
  [1253] = {.lex_state = 139},
  [1254] = {.lex_state = 112},
  [1255] = {.lex_state = 112},
  [1256] = {.lex_state = 240, .external_lex_state = 2},
  [1257] = {.lex_state = 192, .external_lex_state = 5},
  [1258] = {.lex_state = 194},
  [1259] = {.lex_state = 192, .external_lex_state = 22},
  [1260] = {.lex_state = 192, .external_lex_state = 22},
  [1261] = {.lex_state = 192, .external_lex_state = 22},
  [1262] = {.lex_state = 192, .external_lex_state = 22},
  [1263] = {.lex_state = 192, .external_lex_state = 22},
  [1264] = {.lex_state = 242, .external_lex_state = 14},
  [1265] = {.lex_state = 192, .external_lex_state = 22},
  [1266] = {.lex_state = 181, .external_lex_state = 14},
  [1267] = {.lex_state = 112},
  [1268] = {.lex_state = 181, .external_lex_state = 14},
  [1269] = {.lex_state = 181, .external_lex_state = 14},
  [1270] = {.lex_state = 181, .external_lex_state = 14},
  [1271] = {.lex_state = 192, .external_lex_state = 22},
  [1272] = {.lex_state = 181, .external_lex_state = 14},
  [1273] = {.lex_state = 192, .external_lex_state = 22},
  [1274] = {.lex_state = 181, .external_lex_state = 14},
  [1275] = {.lex_state = 192, .external_lex_state = 22},
  [1276] = {.lex_state = 192, .external_lex_state = 22},
  [1277] = {.lex_state = 194, .external_lex_state = 15},
  [1278] = {.lex_state = 271, .external_lex_state = 21},
  [1279] = {.lex_state = 271, .external_lex_state = 21},
  [1280] = {.lex_state = 112, .external_lex_state = 14},
  [1281] = {.lex_state = 194, .external_lex_state = 15},
  [1282] = {.lex_state = 242, .external_lex_state = 14},
  [1283] = {.lex_state = 194, .external_lex_state = 15},
  [1284] = {.lex_state = 181, .external_lex_state = 14},
  [1285] = {.lex_state = 194, .external_lex_state = 15},
  [1286] = {.lex_state = 181, .external_lex_state = 14},
  [1287] = {.lex_state = 181, .external_lex_state = 14},
  [1288] = {.lex_state = 194, .external_lex_state = 15},
  [1289] = {.lex_state = 273, .external_lex_state = 16},
  [1290] = {.lex_state = 246, .external_lex_state = 15},
  [1291] = {.lex_state = 246, .external_lex_state = 15},
  [1292] = {.lex_state = 244, .external_lex_state = 16},
  [1293] = {.lex_state = 139},
  [1294] = {.lex_state = 246, .external_lex_state = 15},
  [1295] = {.lex_state = 246, .external_lex_state = 15},
  [1296] = {.lex_state = 149},
  [1297] = {.lex_state = 246, .external_lex_state = 15},
  [1298] = {.lex_state = 246, .external_lex_state = 15},
  [1299] = {.lex_state = 246, .external_lex_state = 15},
  [1300] = {.lex_state = 112},
  [1301] = {.lex_state = 181, .external_lex_state = 14},
  [1302] = {.lex_state = 190, .external_lex_state = 5},
  [1303] = {.lex_state = 181, .external_lex_state = 14},
  [1304] = {.lex_state = 181, .external_lex_state = 14},
  [1305] = {.lex_state = 112},
  [1306] = {.lex_state = 199, .external_lex_state = 2},
  [1307] = {.lex_state = 112},
  [1308] = {.lex_state = 207, .external_lex_state = 2},
  [1309] = {.lex_state = 112},
  [1310] = {.lex_state = 199, .external_lex_state = 2},
  [1311] = {.lex_state = 244, .external_lex_state = 16},
  [1312] = {.lex_state = 250, .external_lex_state = 23},
  [1313] = {.lex_state = 246, .external_lex_state = 16},
  [1314] = {.lex_state = 139},
  [1315] = {.lex_state = 207, .external_lex_state = 12},
  [1316] = {.lex_state = 207, .external_lex_state = 12},
  [1317] = {.lex_state = 149},
  [1318] = {.lex_state = 207, .external_lex_state = 12},
  [1319] = {.lex_state = 207, .external_lex_state = 12},
  [1320] = {.lex_state = 207, .external_lex_state = 12},
  [1321] = {.lex_state = 112},
  [1322] = {.lex_state = 181, .external_lex_state = 14},
  [1323] = {.lex_state = 190, .external_lex_state = 5},
  [1324] = {.lex_state = 181, .external_lex_state = 14},
  [1325] = {.lex_state = 181, .external_lex_state = 14},
  [1326] = {.lex_state = 112},
  [1327] = {.lex_state = 199, .external_lex_state = 2},
  [1328] = {.lex_state = 112},
  [1329] = {.lex_state = 207, .external_lex_state = 2},
  [1330] = {.lex_state = 112},
  [1331] = {.lex_state = 199, .external_lex_state = 2},
  [1332] = {.lex_state = 248, .external_lex_state = 16},
  [1333] = {.lex_state = 112},
  [1334] = {.lex_state = 51},
  [1335] = {.lex_state = 139},
  [1336] = {.lex_state = 201, .external_lex_state = 22},
  [1337] = {.lex_state = 201, .external_lex_state = 22},
  [1338] = {.lex_state = 201, .external_lex_state = 22},
  [1339] = {.lex_state = 201, .external_lex_state = 22},
  [1340] = {.lex_state = 201, .external_lex_state = 22},
  [1341] = {.lex_state = 242, .external_lex_state = 14},
  [1342] = {.lex_state = 201, .external_lex_state = 22},
  [1343] = {.lex_state = 181, .external_lex_state = 14},
  [1344] = {.lex_state = 112},
  [1345] = {.lex_state = 181, .external_lex_state = 14},
  [1346] = {.lex_state = 181, .external_lex_state = 14},
  [1347] = {.lex_state = 181, .external_lex_state = 14},
  [1348] = {.lex_state = 201, .external_lex_state = 22},
  [1349] = {.lex_state = 181, .external_lex_state = 14},
  [1350] = {.lex_state = 201, .external_lex_state = 22},
  [1351] = {.lex_state = 181, .external_lex_state = 14},
  [1352] = {.lex_state = 201, .external_lex_state = 22},
  [1353] = {.lex_state = 201, .external_lex_state = 22},
  [1354] = {.lex_state = 203, .external_lex_state = 15},
  [1355] = {.lex_state = 271, .external_lex_state = 21},
  [1356] = {.lex_state = 271, .external_lex_state = 21},
  [1357] = {.lex_state = 112, .external_lex_state = 14},
  [1358] = {.lex_state = 203, .external_lex_state = 15},
  [1359] = {.lex_state = 242, .external_lex_state = 14},
  [1360] = {.lex_state = 203, .external_lex_state = 15},
  [1361] = {.lex_state = 181, .external_lex_state = 14},
  [1362] = {.lex_state = 203, .external_lex_state = 15},
  [1363] = {.lex_state = 181, .external_lex_state = 14},
  [1364] = {.lex_state = 181, .external_lex_state = 14},
  [1365] = {.lex_state = 203, .external_lex_state = 15},
  [1366] = {.lex_state = 275, .external_lex_state = 16},
  [1367] = {.lex_state = 248, .external_lex_state = 15},
  [1368] = {.lex_state = 248, .external_lex_state = 15},
  [1369] = {.lex_state = 139},
  [1370] = {.lex_state = 248, .external_lex_state = 15},
  [1371] = {.lex_state = 248, .external_lex_state = 15},
  [1372] = {.lex_state = 149},
  [1373] = {.lex_state = 248, .external_lex_state = 15},
  [1374] = {.lex_state = 248, .external_lex_state = 15},
  [1375] = {.lex_state = 248, .external_lex_state = 15},
  [1376] = {.lex_state = 112},
  [1377] = {.lex_state = 181, .external_lex_state = 14},
  [1378] = {.lex_state = 190, .external_lex_state = 5},
  [1379] = {.lex_state = 181, .external_lex_state = 14},
  [1380] = {.lex_state = 181, .external_lex_state = 14},
  [1381] = {.lex_state = 112},
  [1382] = {.lex_state = 199, .external_lex_state = 2},
  [1383] = {.lex_state = 112},
  [1384] = {.lex_state = 207, .external_lex_state = 2},
  [1385] = {.lex_state = 112},
  [1386] = {.lex_state = 199, .external_lex_state = 2},
  [1387] = {.lex_state = 248, .external_lex_state = 16},
  [1388] = {.lex_state = 177, .external_lex_state = 6},
  [1389] = {.lex_state = 215, .external_lex_state = 4},
  [1390] = {.lex_state = 215, .external_lex_state = 4},
  [1391] = {.lex_state = 215, .external_lex_state = 4},
  [1392] = {.lex_state = 242, .external_lex_state = 14},
  [1393] = {.lex_state = 215, .external_lex_state = 4},
  [1394] = {.lex_state = 181, .external_lex_state = 14},
  [1395] = {.lex_state = 112},
  [1396] = {.lex_state = 181, .external_lex_state = 14},
  [1397] = {.lex_state = 181, .external_lex_state = 14},
  [1398] = {.lex_state = 181, .external_lex_state = 14},
  [1399] = {.lex_state = 215, .external_lex_state = 4},
  [1400] = {.lex_state = 181, .external_lex_state = 14},
  [1401] = {.lex_state = 215, .external_lex_state = 4},
  [1402] = {.lex_state = 181, .external_lex_state = 14},
  [1403] = {.lex_state = 215, .external_lex_state = 4},
  [1404] = {.lex_state = 215, .external_lex_state = 4},
  [1405] = {.lex_state = 149},
  [1406] = {.lex_state = 250, .external_lex_state = 23},
  [1407] = {.lex_state = 250, .external_lex_state = 23},
  [1408] = {.lex_state = 250, .external_lex_state = 23},
  [1409] = {.lex_state = 112},
  [1410] = {.lex_state = 181, .external_lex_state = 14},
  [1411] = {.lex_state = 190, .external_lex_state = 5},
  [1412] = {.lex_state = 181, .external_lex_state = 14},
  [1413] = {.lex_state = 181, .external_lex_state = 14},
  [1414] = {.lex_state = 211, .external_lex_state = 7},
  [1415] = {.lex_state = 250, .external_lex_state = 23},
  [1416] = {.lex_state = 253, .external_lex_state = 13},
  [1417] = {.lex_state = 253, .external_lex_state = 13},
  [1418] = {.lex_state = 253, .external_lex_state = 13},
  [1419] = {.lex_state = 242, .external_lex_state = 14},
  [1420] = {.lex_state = 253, .external_lex_state = 13},
  [1421] = {.lex_state = 181, .external_lex_state = 14},
  [1422] = {.lex_state = 112},
  [1423] = {.lex_state = 181, .external_lex_state = 14},
  [1424] = {.lex_state = 181, .external_lex_state = 14},
  [1425] = {.lex_state = 181, .external_lex_state = 14},
  [1426] = {.lex_state = 253, .external_lex_state = 13},
  [1427] = {.lex_state = 181, .external_lex_state = 14},
  [1428] = {.lex_state = 253, .external_lex_state = 13},
  [1429] = {.lex_state = 181, .external_lex_state = 14},
  [1430] = {.lex_state = 253, .external_lex_state = 13},
  [1431] = {.lex_state = 253, .external_lex_state = 13},
  [1432] = {.lex_state = 166, .external_lex_state = 18},
  [1433] = {.lex_state = 271, .external_lex_state = 21},
  [1434] = {.lex_state = 271, .external_lex_state = 21},
  [1435] = {.lex_state = 112, .external_lex_state = 14},
  [1436] = {.lex_state = 166, .external_lex_state = 18},
  [1437] = {.lex_state = 242, .external_lex_state = 14},
  [1438] = {.lex_state = 166, .external_lex_state = 18},
  [1439] = {.lex_state = 181, .external_lex_state = 14},
  [1440] = {.lex_state = 166, .external_lex_state = 18},
  [1441] = {.lex_state = 181, .external_lex_state = 14},
  [1442] = {.lex_state = 181, .external_lex_state = 14},
  [1443] = {.lex_state = 166, .external_lex_state = 18},
  [1444] = {.lex_state = 112},
  [1445] = {.lex_state = 112},
  [1446] = {.lex_state = 217, .external_lex_state = 19},
  [1447] = {.lex_state = 271, .external_lex_state = 21},
  [1448] = {.lex_state = 271, .external_lex_state = 21},
  [1449] = {.lex_state = 112, .external_lex_state = 14},
  [1450] = {.lex_state = 217, .external_lex_state = 19},
  [1451] = {.lex_state = 242, .external_lex_state = 14},
  [1452] = {.lex_state = 217, .external_lex_state = 19},
  [1453] = {.lex_state = 181, .external_lex_state = 14},
  [1454] = {.lex_state = 217, .external_lex_state = 19},
  [1455] = {.lex_state = 181, .external_lex_state = 14},
  [1456] = {.lex_state = 181, .external_lex_state = 14},
  [1457] = {.lex_state = 217, .external_lex_state = 19},
  [1458] = {.lex_state = 259, .external_lex_state = 10},
  [1459] = {.lex_state = 259, .external_lex_state = 10},
  [1460] = {.lex_state = 259, .external_lex_state = 10},
  [1461] = {.lex_state = 242, .external_lex_state = 14},
  [1462] = {.lex_state = 259, .external_lex_state = 10},
  [1463] = {.lex_state = 181, .external_lex_state = 14},
  [1464] = {.lex_state = 112},
  [1465] = {.lex_state = 181, .external_lex_state = 14},
  [1466] = {.lex_state = 181, .external_lex_state = 14},
  [1467] = {.lex_state = 181, .external_lex_state = 14},
  [1468] = {.lex_state = 259, .external_lex_state = 10},
  [1469] = {.lex_state = 181, .external_lex_state = 14},
  [1470] = {.lex_state = 259, .external_lex_state = 10},
  [1471] = {.lex_state = 181, .external_lex_state = 14},
  [1472] = {.lex_state = 259, .external_lex_state = 10},
  [1473] = {.lex_state = 259, .external_lex_state = 10},
  [1474] = {.lex_state = 219, .external_lex_state = 2},
  [1475] = {.lex_state = 177, .external_lex_state = 6},
  [1476] = {.lex_state = 225, .external_lex_state = 2},
  [1477] = {.lex_state = 261, .external_lex_state = 2},
  [1478] = {.lex_state = 261, .external_lex_state = 2},
  [1479] = {.lex_state = 177, .external_lex_state = 6},
  [1480] = {.lex_state = 112},
  [1481] = {.lex_state = 139},
  [1482] = {.lex_state = 139},
  [1483] = {.lex_state = 283, .external_lex_state = 2},
  [1484] = {.lex_state = 136},
  [1485] = {.lex_state = 277, .external_lex_state = 13},
  [1486] = {.lex_state = 277, .external_lex_state = 13},
  [1487] = {.lex_state = 149},
  [1488] = {.lex_state = 283, .external_lex_state = 2},
  [1489] = {.lex_state = 136},
  [1490] = {.lex_state = 277, .external_lex_state = 13},
  [1491] = {.lex_state = 277, .external_lex_state = 13},
  [1492] = {.lex_state = 277, .external_lex_state = 13},
  [1493] = {.lex_state = 112},
  [1494] = {.lex_state = 181, .external_lex_state = 14},
  [1495] = {.lex_state = 190, .external_lex_state = 5},
  [1496] = {.lex_state = 181, .external_lex_state = 14},
  [1497] = {.lex_state = 181, .external_lex_state = 14},
  [1498] = {.lex_state = 112},
  [1499] = {.lex_state = 199, .external_lex_state = 2},
  [1500] = {.lex_state = 112},
  [1501] = {.lex_state = 207, .external_lex_state = 2},
  [1502] = {.lex_state = 112},
  [1503] = {.lex_state = 199, .external_lex_state = 2},
  [1504] = {.lex_state = 177, .external_lex_state = 6},
  [1505] = {.lex_state = 112},
  [1506] = {.lex_state = 139},
  [1507] = {.lex_state = 177, .external_lex_state = 6},
  [1508] = {.lex_state = 139},
  [1509] = {.lex_state = 177, .external_lex_state = 6},
  [1510] = {.lex_state = 112},
  [1511] = {.lex_state = 177, .external_lex_state = 6},
  [1512] = {.lex_state = 139},
  [1513] = {.lex_state = 174, .external_lex_state = 10},
  [1514] = {.lex_state = 174, .external_lex_state = 10},
  [1515] = {.lex_state = 271, .external_lex_state = 21},
  [1516] = {.lex_state = 271, .external_lex_state = 21},
  [1517] = {.lex_state = 112, .external_lex_state = 14},
  [1518] = {.lex_state = 174, .external_lex_state = 10},
  [1519] = {.lex_state = 174, .external_lex_state = 10},
  [1520] = {.lex_state = 177, .external_lex_state = 6},
  [1521] = {.lex_state = 279, .external_lex_state = 10},
  [1522] = {.lex_state = 279, .external_lex_state = 10},
  [1523] = {.lex_state = 177, .external_lex_state = 6},
  [1524] = {.lex_state = 139},
  [1525] = {.lex_state = 279, .external_lex_state = 10},
  [1526] = {.lex_state = 279, .external_lex_state = 10},
  [1527] = {.lex_state = 149},
  [1528] = {.lex_state = 279, .external_lex_state = 10},
  [1529] = {.lex_state = 279, .external_lex_state = 10},
  [1530] = {.lex_state = 279, .external_lex_state = 10},
  [1531] = {.lex_state = 112},
  [1532] = {.lex_state = 181, .external_lex_state = 14},
  [1533] = {.lex_state = 190, .external_lex_state = 5},
  [1534] = {.lex_state = 181, .external_lex_state = 14},
  [1535] = {.lex_state = 181, .external_lex_state = 14},
  [1536] = {.lex_state = 112},
  [1537] = {.lex_state = 199, .external_lex_state = 2},
  [1538] = {.lex_state = 112},
  [1539] = {.lex_state = 207, .external_lex_state = 2},
  [1540] = {.lex_state = 112},
  [1541] = {.lex_state = 199, .external_lex_state = 2},
  [1542] = {.lex_state = 172, .external_lex_state = 18},
  [1543] = {.lex_state = 172, .external_lex_state = 18},
  [1544] = {.lex_state = 172, .external_lex_state = 18},
  [1545] = {.lex_state = 242, .external_lex_state = 14},
  [1546] = {.lex_state = 172, .external_lex_state = 18},
  [1547] = {.lex_state = 181, .external_lex_state = 14},
  [1548] = {.lex_state = 112},
  [1549] = {.lex_state = 181, .external_lex_state = 14},
  [1550] = {.lex_state = 181, .external_lex_state = 14},
  [1551] = {.lex_state = 181, .external_lex_state = 14},
  [1552] = {.lex_state = 172, .external_lex_state = 18},
  [1553] = {.lex_state = 181, .external_lex_state = 14},
  [1554] = {.lex_state = 172, .external_lex_state = 18},
  [1555] = {.lex_state = 181, .external_lex_state = 14},
  [1556] = {.lex_state = 172, .external_lex_state = 18},
  [1557] = {.lex_state = 172, .external_lex_state = 18},
  [1558] = {.lex_state = 269, .external_lex_state = 7},
  [1559] = {.lex_state = 139},
  [1560] = {.lex_state = 286, .external_lex_state = 10},
  [1561] = {.lex_state = 149},
  [1562] = {.lex_state = 286, .external_lex_state = 10},
  [1563] = {.lex_state = 156},
  [1564] = {.lex_state = 159, .external_lex_state = 5},
  [1565] = {.lex_state = 51, .external_lex_state = 2},
  [1566] = {.lex_state = 51, .external_lex_state = 2},
  [1567] = {.lex_state = 51, .external_lex_state = 2},
  [1568] = {.lex_state = 177, .external_lex_state = 11},
  [1569] = {.lex_state = 271, .external_lex_state = 21},
  [1570] = {.lex_state = 271, .external_lex_state = 21},
  [1571] = {.lex_state = 112, .external_lex_state = 14},
  [1572] = {.lex_state = 177, .external_lex_state = 11},
  [1573] = {.lex_state = 242, .external_lex_state = 14},
  [1574] = {.lex_state = 177, .external_lex_state = 11},
  [1575] = {.lex_state = 181, .external_lex_state = 14},
  [1576] = {.lex_state = 177, .external_lex_state = 11},
  [1577] = {.lex_state = 181, .external_lex_state = 14},
  [1578] = {.lex_state = 181, .external_lex_state = 14},
  [1579] = {.lex_state = 177, .external_lex_state = 11},
  [1580] = {.lex_state = 168, .external_lex_state = 4},
  [1581] = {.lex_state = 168, .external_lex_state = 4},
  [1582] = {.lex_state = 271, .external_lex_state = 21},
  [1583] = {.lex_state = 271, .external_lex_state = 21},
  [1584] = {.lex_state = 112, .external_lex_state = 14},
  [1585] = {.lex_state = 168, .external_lex_state = 4},
  [1586] = {.lex_state = 168, .external_lex_state = 4},
  [1587] = {.lex_state = 211, .external_lex_state = 4},
  [1588] = {.lex_state = 211, .external_lex_state = 4},
  [1589] = {.lex_state = 211, .external_lex_state = 4},
  [1590] = {.lex_state = 242, .external_lex_state = 14},
  [1591] = {.lex_state = 211, .external_lex_state = 4},
  [1592] = {.lex_state = 181, .external_lex_state = 14},
  [1593] = {.lex_state = 112},
  [1594] = {.lex_state = 181, .external_lex_state = 14},
  [1595] = {.lex_state = 181, .external_lex_state = 14},
  [1596] = {.lex_state = 181, .external_lex_state = 14},
  [1597] = {.lex_state = 211, .external_lex_state = 4},
  [1598] = {.lex_state = 181, .external_lex_state = 14},
  [1599] = {.lex_state = 211, .external_lex_state = 4},
  [1600] = {.lex_state = 181, .external_lex_state = 14},
  [1601] = {.lex_state = 211, .external_lex_state = 4},
  [1602] = {.lex_state = 211, .external_lex_state = 4},
  [1603] = {.lex_state = 177, .external_lex_state = 3},
  [1604] = {.lex_state = 141, .external_lex_state = 11},
  [1605] = {.lex_state = 141, .external_lex_state = 11},
  [1606] = {.lex_state = 271, .external_lex_state = 21},
  [1607] = {.lex_state = 271, .external_lex_state = 21},
  [1608] = {.lex_state = 112, .external_lex_state = 14},
  [1609] = {.lex_state = 141, .external_lex_state = 11},
  [1610] = {.lex_state = 141, .external_lex_state = 11},
  [1611] = {.lex_state = 139, .external_lex_state = 12},
  [1612] = {.lex_state = 139, .external_lex_state = 12},
  [1613] = {.lex_state = 271, .external_lex_state = 21},
  [1614] = {.lex_state = 271, .external_lex_state = 21},
  [1615] = {.lex_state = 112, .external_lex_state = 14},
  [1616] = {.lex_state = 139, .external_lex_state = 12},
  [1617] = {.lex_state = 139, .external_lex_state = 12},
  [1618] = {.lex_state = 149, .external_lex_state = 13},
  [1619] = {.lex_state = 149, .external_lex_state = 13},
  [1620] = {.lex_state = 271, .external_lex_state = 21},
  [1621] = {.lex_state = 271, .external_lex_state = 21},
  [1622] = {.lex_state = 112, .external_lex_state = 14},
  [1623] = {.lex_state = 149, .external_lex_state = 13},
  [1624] = {.lex_state = 149, .external_lex_state = 13},
  [1625] = {.lex_state = 271, .external_lex_state = 21},
  [1626] = {.lex_state = 271, .external_lex_state = 21},
  [1627] = {.lex_state = 271, .external_lex_state = 21},
  [1628] = {.lex_state = 242, .external_lex_state = 14},
  [1629] = {.lex_state = 271, .external_lex_state = 21},
  [1630] = {.lex_state = 181, .external_lex_state = 14},
  [1631] = {.lex_state = 112},
  [1632] = {.lex_state = 181, .external_lex_state = 14},
  [1633] = {.lex_state = 181, .external_lex_state = 14},
  [1634] = {.lex_state = 181, .external_lex_state = 14},
  [1635] = {.lex_state = 271, .external_lex_state = 21},
  [1636] = {.lex_state = 181, .external_lex_state = 14},
  [1637] = {.lex_state = 271, .external_lex_state = 21},
  [1638] = {.lex_state = 181, .external_lex_state = 14},
  [1639] = {.lex_state = 271, .external_lex_state = 21},
  [1640] = {.lex_state = 271, .external_lex_state = 21},
  [1641] = {.lex_state = 181, .external_lex_state = 21},
  [1642] = {.lex_state = 181, .external_lex_state = 14},
  [1643] = {.lex_state = 181, .external_lex_state = 21},
  [1644] = {.lex_state = 181, .external_lex_state = 14},
  [1645] = {.lex_state = 181, .external_lex_state = 21},
  [1646] = {.lex_state = 271, .external_lex_state = 21},
  [1647] = {.lex_state = 271, .external_lex_state = 21},
  [1648] = {.lex_state = 112, .external_lex_state = 14},
  [1649] = {.lex_state = 181, .external_lex_state = 21},
  [1650] = {.lex_state = 242, .external_lex_state = 14},
  [1651] = {.lex_state = 181, .external_lex_state = 21},
  [1652] = {.lex_state = 181, .external_lex_state = 14},
  [1653] = {.lex_state = 181, .external_lex_state = 21},
  [1654] = {.lex_state = 181, .external_lex_state = 14},
  [1655] = {.lex_state = 181, .external_lex_state = 14},
  [1656] = {.lex_state = 181, .external_lex_state = 21},
  [1657] = {.lex_state = 147, .external_lex_state = 4},
  [1658] = {.lex_state = 147, .external_lex_state = 4},
  [1659] = {.lex_state = 199, .external_lex_state = 2},
  [1660] = {.lex_state = 199, .external_lex_state = 12},
  [1661] = {.lex_state = 199, .external_lex_state = 12},
  [1662] = {.lex_state = 199, .external_lex_state = 12},
  [1663] = {.lex_state = 242, .external_lex_state = 14},
  [1664] = {.lex_state = 199, .external_lex_state = 12},
  [1665] = {.lex_state = 181, .external_lex_state = 14},
  [1666] = {.lex_state = 112},
  [1667] = {.lex_state = 181, .external_lex_state = 14},
  [1668] = {.lex_state = 181, .external_lex_state = 14},
  [1669] = {.lex_state = 181, .external_lex_state = 14},
  [1670] = {.lex_state = 199, .external_lex_state = 12},
  [1671] = {.lex_state = 181, .external_lex_state = 14},
  [1672] = {.lex_state = 199, .external_lex_state = 12},
  [1673] = {.lex_state = 181, .external_lex_state = 14},
  [1674] = {.lex_state = 199, .external_lex_state = 12},
  [1675] = {.lex_state = 199, .external_lex_state = 12},
  [1676] = {.lex_state = 112},
  [1677] = {.lex_state = 244, .external_lex_state = 16},
  [1678] = {.lex_state = 112},
  [1679] = {.lex_state = 112},
  [1680] = {.lex_state = 112},
  [1681] = {.lex_state = 112},
  [1682] = {.lex_state = 112},
  [1683] = {.lex_state = 139},
  [1684] = {.lex_state = 263},
  [1685] = {.lex_state = 112},
  [1686] = {.lex_state = 112},
  [1687] = {.lex_state = 139},
  [1688] = {.lex_state = 263},
  [1689] = {.lex_state = 273, .external_lex_state = 16},
  [1690] = {.lex_state = 281, .external_lex_state = 16},
  [1691] = {.lex_state = 139},
  [1692] = {.lex_state = 288, .external_lex_state = 13},
  [1693] = {.lex_state = 149},
  [1694] = {.lex_state = 288, .external_lex_state = 13},
  [1695] = {.lex_state = 156},
  [1696] = {.lex_state = 159, .external_lex_state = 5},
  [1697] = {.lex_state = 51, .external_lex_state = 2},
  [1698] = {.lex_state = 51, .external_lex_state = 2},
  [1699] = {.lex_state = 51, .external_lex_state = 2},
  [1700] = {.lex_state = 112},
  [1701] = {.lex_state = 112},
  [1702] = {.lex_state = 192, .external_lex_state = 5},
  [1703] = {.lex_state = 194},
  [1704] = {.lex_state = 192, .external_lex_state = 22},
  [1705] = {.lex_state = 271, .external_lex_state = 21},
  [1706] = {.lex_state = 271, .external_lex_state = 21},
  [1707] = {.lex_state = 112, .external_lex_state = 14},
  [1708] = {.lex_state = 192, .external_lex_state = 22},
  [1709] = {.lex_state = 242, .external_lex_state = 14},
  [1710] = {.lex_state = 192, .external_lex_state = 22},
  [1711] = {.lex_state = 181, .external_lex_state = 14},
  [1712] = {.lex_state = 192, .external_lex_state = 22},
  [1713] = {.lex_state = 181, .external_lex_state = 14},
  [1714] = {.lex_state = 181, .external_lex_state = 14},
  [1715] = {.lex_state = 192, .external_lex_state = 22},
  [1716] = {.lex_state = 194, .external_lex_state = 15},
  [1717] = {.lex_state = 194, .external_lex_state = 15},
  [1718] = {.lex_state = 271, .external_lex_state = 21},
  [1719] = {.lex_state = 271, .external_lex_state = 21},
  [1720] = {.lex_state = 112, .external_lex_state = 14},
  [1721] = {.lex_state = 194, .external_lex_state = 15},
  [1722] = {.lex_state = 194, .external_lex_state = 15},
  [1723] = {.lex_state = 112},
  [1724] = {.lex_state = 246, .external_lex_state = 15},
  [1725] = {.lex_state = 246, .external_lex_state = 15},
  [1726] = {.lex_state = 246, .external_lex_state = 15},
  [1727] = {.lex_state = 242, .external_lex_state = 14},
  [1728] = {.lex_state = 246, .external_lex_state = 15},
  [1729] = {.lex_state = 181, .external_lex_state = 14},
  [1730] = {.lex_state = 112},
  [1731] = {.lex_state = 181, .external_lex_state = 14},
  [1732] = {.lex_state = 181, .external_lex_state = 14},
  [1733] = {.lex_state = 181, .external_lex_state = 14},
  [1734] = {.lex_state = 246, .external_lex_state = 15},
  [1735] = {.lex_state = 181, .external_lex_state = 14},
  [1736] = {.lex_state = 246, .external_lex_state = 15},
  [1737] = {.lex_state = 181, .external_lex_state = 14},
  [1738] = {.lex_state = 246, .external_lex_state = 15},
  [1739] = {.lex_state = 246, .external_lex_state = 15},
  [1740] = {.lex_state = 244, .external_lex_state = 16},
  [1741] = {.lex_state = 207, .external_lex_state = 12},
  [1742] = {.lex_state = 207, .external_lex_state = 12},
  [1743] = {.lex_state = 207, .external_lex_state = 12},
  [1744] = {.lex_state = 242, .external_lex_state = 14},
  [1745] = {.lex_state = 207, .external_lex_state = 12},
  [1746] = {.lex_state = 181, .external_lex_state = 14},
  [1747] = {.lex_state = 112},
  [1748] = {.lex_state = 181, .external_lex_state = 14},
  [1749] = {.lex_state = 181, .external_lex_state = 14},
  [1750] = {.lex_state = 181, .external_lex_state = 14},
  [1751] = {.lex_state = 207, .external_lex_state = 12},
  [1752] = {.lex_state = 181, .external_lex_state = 14},
  [1753] = {.lex_state = 207, .external_lex_state = 12},
  [1754] = {.lex_state = 181, .external_lex_state = 14},
  [1755] = {.lex_state = 207, .external_lex_state = 12},
  [1756] = {.lex_state = 207, .external_lex_state = 12},
  [1757] = {.lex_state = 275, .external_lex_state = 16},
  [1758] = {.lex_state = 139},
  [1759] = {.lex_state = 290, .external_lex_state = 13},
  [1760] = {.lex_state = 149},
  [1761] = {.lex_state = 290, .external_lex_state = 13},
  [1762] = {.lex_state = 156},
  [1763] = {.lex_state = 159, .external_lex_state = 5},
  [1764] = {.lex_state = 51, .external_lex_state = 2},
  [1765] = {.lex_state = 51, .external_lex_state = 2},
  [1766] = {.lex_state = 51, .external_lex_state = 2},
  [1767] = {.lex_state = 201, .external_lex_state = 22},
  [1768] = {.lex_state = 271, .external_lex_state = 21},
  [1769] = {.lex_state = 271, .external_lex_state = 21},
  [1770] = {.lex_state = 112, .external_lex_state = 14},
  [1771] = {.lex_state = 201, .external_lex_state = 22},
  [1772] = {.lex_state = 242, .external_lex_state = 14},
  [1773] = {.lex_state = 201, .external_lex_state = 22},
  [1774] = {.lex_state = 181, .external_lex_state = 14},
  [1775] = {.lex_state = 201, .external_lex_state = 22},
  [1776] = {.lex_state = 181, .external_lex_state = 14},
  [1777] = {.lex_state = 181, .external_lex_state = 14},
  [1778] = {.lex_state = 201, .external_lex_state = 22},
  [1779] = {.lex_state = 203, .external_lex_state = 15},
  [1780] = {.lex_state = 203, .external_lex_state = 15},
  [1781] = {.lex_state = 271, .external_lex_state = 21},
  [1782] = {.lex_state = 271, .external_lex_state = 21},
  [1783] = {.lex_state = 112, .external_lex_state = 14},
  [1784] = {.lex_state = 203, .external_lex_state = 15},
  [1785] = {.lex_state = 203, .external_lex_state = 15},
  [1786] = {.lex_state = 248, .external_lex_state = 15},
  [1787] = {.lex_state = 248, .external_lex_state = 15},
  [1788] = {.lex_state = 248, .external_lex_state = 15},
  [1789] = {.lex_state = 242, .external_lex_state = 14},
  [1790] = {.lex_state = 248, .external_lex_state = 15},
  [1791] = {.lex_state = 181, .external_lex_state = 14},
  [1792] = {.lex_state = 112},
  [1793] = {.lex_state = 181, .external_lex_state = 14},
  [1794] = {.lex_state = 181, .external_lex_state = 14},
  [1795] = {.lex_state = 181, .external_lex_state = 14},
  [1796] = {.lex_state = 248, .external_lex_state = 15},
  [1797] = {.lex_state = 181, .external_lex_state = 14},
  [1798] = {.lex_state = 248, .external_lex_state = 15},
  [1799] = {.lex_state = 181, .external_lex_state = 14},
  [1800] = {.lex_state = 248, .external_lex_state = 15},
  [1801] = {.lex_state = 248, .external_lex_state = 15},
  [1802] = {.lex_state = 215, .external_lex_state = 4},
  [1803] = {.lex_state = 271, .external_lex_state = 21},
  [1804] = {.lex_state = 271, .external_lex_state = 21},
  [1805] = {.lex_state = 112, .external_lex_state = 14},
  [1806] = {.lex_state = 215, .external_lex_state = 4},
  [1807] = {.lex_state = 242, .external_lex_state = 14},
  [1808] = {.lex_state = 215, .external_lex_state = 4},
  [1809] = {.lex_state = 181, .external_lex_state = 14},
  [1810] = {.lex_state = 215, .external_lex_state = 4},
  [1811] = {.lex_state = 181, .external_lex_state = 14},
  [1812] = {.lex_state = 181, .external_lex_state = 14},
  [1813] = {.lex_state = 215, .external_lex_state = 4},
  [1814] = {.lex_state = 250, .external_lex_state = 23},
  [1815] = {.lex_state = 149},
  [1816] = {.lex_state = 242, .external_lex_state = 14},
  [1817] = {.lex_state = 250, .external_lex_state = 23},
  [1818] = {.lex_state = 181, .external_lex_state = 14},
  [1819] = {.lex_state = 112},
  [1820] = {.lex_state = 181, .external_lex_state = 14},
  [1821] = {.lex_state = 181, .external_lex_state = 14},
  [1822] = {.lex_state = 181, .external_lex_state = 14},
  [1823] = {.lex_state = 250, .external_lex_state = 23},
  [1824] = {.lex_state = 181, .external_lex_state = 14},
  [1825] = {.lex_state = 250, .external_lex_state = 23},
  [1826] = {.lex_state = 181, .external_lex_state = 14},
  [1827] = {.lex_state = 253, .external_lex_state = 13},
  [1828] = {.lex_state = 271, .external_lex_state = 21},
  [1829] = {.lex_state = 271, .external_lex_state = 21},
  [1830] = {.lex_state = 112, .external_lex_state = 14},
  [1831] = {.lex_state = 253, .external_lex_state = 13},
  [1832] = {.lex_state = 242, .external_lex_state = 14},
  [1833] = {.lex_state = 253, .external_lex_state = 13},
  [1834] = {.lex_state = 181, .external_lex_state = 14},
  [1835] = {.lex_state = 253, .external_lex_state = 13},
  [1836] = {.lex_state = 181, .external_lex_state = 14},
  [1837] = {.lex_state = 181, .external_lex_state = 14},
  [1838] = {.lex_state = 253, .external_lex_state = 13},
  [1839] = {.lex_state = 166, .external_lex_state = 18},
  [1840] = {.lex_state = 166, .external_lex_state = 18},
  [1841] = {.lex_state = 271, .external_lex_state = 21},
  [1842] = {.lex_state = 271, .external_lex_state = 21},
  [1843] = {.lex_state = 112, .external_lex_state = 14},
  [1844] = {.lex_state = 166, .external_lex_state = 18},
  [1845] = {.lex_state = 166, .external_lex_state = 18},
  [1846] = {.lex_state = 217, .external_lex_state = 19},
  [1847] = {.lex_state = 217, .external_lex_state = 19},
  [1848] = {.lex_state = 271, .external_lex_state = 21},
  [1849] = {.lex_state = 271, .external_lex_state = 21},
  [1850] = {.lex_state = 112, .external_lex_state = 14},
  [1851] = {.lex_state = 217, .external_lex_state = 19},
  [1852] = {.lex_state = 217, .external_lex_state = 19},
  [1853] = {.lex_state = 259, .external_lex_state = 10},
  [1854] = {.lex_state = 271, .external_lex_state = 21},
  [1855] = {.lex_state = 271, .external_lex_state = 21},
  [1856] = {.lex_state = 112, .external_lex_state = 14},
  [1857] = {.lex_state = 259, .external_lex_state = 10},
  [1858] = {.lex_state = 242, .external_lex_state = 14},
  [1859] = {.lex_state = 259, .external_lex_state = 10},
  [1860] = {.lex_state = 181, .external_lex_state = 14},
  [1861] = {.lex_state = 259, .external_lex_state = 10},
  [1862] = {.lex_state = 181, .external_lex_state = 14},
  [1863] = {.lex_state = 181, .external_lex_state = 14},
  [1864] = {.lex_state = 259, .external_lex_state = 10},
  [1865] = {.lex_state = 177, .external_lex_state = 6},
  [1866] = {.lex_state = 219, .external_lex_state = 2},
  [1867] = {.lex_state = 225, .external_lex_state = 2},
  [1868] = {.lex_state = 177, .external_lex_state = 6},
  [1869] = {.lex_state = 277, .external_lex_state = 13},
  [1870] = {.lex_state = 277, .external_lex_state = 13},
  [1871] = {.lex_state = 277, .external_lex_state = 13},
  [1872] = {.lex_state = 136},
  [1873] = {.lex_state = 263},
  [1874] = {.lex_state = 283, .external_lex_state = 2},
  [1875] = {.lex_state = 141, .external_lex_state = 6},
  [1876] = {.lex_state = 166, .external_lex_state = 8},
  [1877] = {.lex_state = 283, .external_lex_state = 2},
  [1878] = {.lex_state = 283, .external_lex_state = 2},
  [1879] = {.lex_state = 136},
  [1880] = {.lex_state = 277, .external_lex_state = 13},
  [1881] = {.lex_state = 277, .external_lex_state = 13},
  [1882] = {.lex_state = 263},
  [1883] = {.lex_state = 283, .external_lex_state = 2},
  [1884] = {.lex_state = 283, .external_lex_state = 2},
  [1885] = {.lex_state = 242, .external_lex_state = 14},
  [1886] = {.lex_state = 277, .external_lex_state = 13},
  [1887] = {.lex_state = 181, .external_lex_state = 14},
  [1888] = {.lex_state = 112},
  [1889] = {.lex_state = 181, .external_lex_state = 14},
  [1890] = {.lex_state = 181, .external_lex_state = 14},
  [1891] = {.lex_state = 181, .external_lex_state = 14},
  [1892] = {.lex_state = 277, .external_lex_state = 13},
  [1893] = {.lex_state = 181, .external_lex_state = 14},
  [1894] = {.lex_state = 277, .external_lex_state = 13},
  [1895] = {.lex_state = 181, .external_lex_state = 14},
  [1896] = {.lex_state = 277, .external_lex_state = 13},
  [1897] = {.lex_state = 277, .external_lex_state = 13},
  [1898] = {.lex_state = 177, .external_lex_state = 6},
  [1899] = {.lex_state = 277, .external_lex_state = 13},
  [1900] = {.lex_state = 277, .external_lex_state = 13},
  [1901] = {.lex_state = 136},
  [1902] = {.lex_state = 112},
  [1903] = {.lex_state = 177, .external_lex_state = 6},
  [1904] = {.lex_state = 112},
  [1905] = {.lex_state = 174, .external_lex_state = 10},
  [1906] = {.lex_state = 174, .external_lex_state = 10},
  [1907] = {.lex_state = 279, .external_lex_state = 10},
  [1908] = {.lex_state = 279, .external_lex_state = 10},
  [1909] = {.lex_state = 279, .external_lex_state = 10},
  [1910] = {.lex_state = 242, .external_lex_state = 14},
  [1911] = {.lex_state = 279, .external_lex_state = 10},
  [1912] = {.lex_state = 181, .external_lex_state = 14},
  [1913] = {.lex_state = 112},
  [1914] = {.lex_state = 181, .external_lex_state = 14},
  [1915] = {.lex_state = 181, .external_lex_state = 14},
  [1916] = {.lex_state = 181, .external_lex_state = 14},
  [1917] = {.lex_state = 279, .external_lex_state = 10},
  [1918] = {.lex_state = 181, .external_lex_state = 14},
  [1919] = {.lex_state = 279, .external_lex_state = 10},
  [1920] = {.lex_state = 181, .external_lex_state = 14},
  [1921] = {.lex_state = 279, .external_lex_state = 10},
  [1922] = {.lex_state = 279, .external_lex_state = 10},
  [1923] = {.lex_state = 172, .external_lex_state = 18},
  [1924] = {.lex_state = 271, .external_lex_state = 21},
  [1925] = {.lex_state = 271, .external_lex_state = 21},
  [1926] = {.lex_state = 112, .external_lex_state = 14},
  [1927] = {.lex_state = 172, .external_lex_state = 18},
  [1928] = {.lex_state = 242, .external_lex_state = 14},
  [1929] = {.lex_state = 172, .external_lex_state = 18},
  [1930] = {.lex_state = 181, .external_lex_state = 14},
  [1931] = {.lex_state = 172, .external_lex_state = 18},
  [1932] = {.lex_state = 181, .external_lex_state = 14},
  [1933] = {.lex_state = 181, .external_lex_state = 14},
  [1934] = {.lex_state = 172, .external_lex_state = 18},
  [1935] = {.lex_state = 286, .external_lex_state = 10},
  [1936] = {.lex_state = 286, .external_lex_state = 10},
  [1937] = {.lex_state = 139},
  [1938] = {.lex_state = 286, .external_lex_state = 10},
  [1939] = {.lex_state = 286, .external_lex_state = 10},
  [1940] = {.lex_state = 149},
  [1941] = {.lex_state = 286, .external_lex_state = 10},
  [1942] = {.lex_state = 286, .external_lex_state = 10},
  [1943] = {.lex_state = 286, .external_lex_state = 10},
  [1944] = {.lex_state = 112},
  [1945] = {.lex_state = 181, .external_lex_state = 14},
  [1946] = {.lex_state = 190, .external_lex_state = 5},
  [1947] = {.lex_state = 181, .external_lex_state = 14},
  [1948] = {.lex_state = 181, .external_lex_state = 14},
  [1949] = {.lex_state = 112},
  [1950] = {.lex_state = 199, .external_lex_state = 2},
  [1951] = {.lex_state = 112},
  [1952] = {.lex_state = 207, .external_lex_state = 2},
  [1953] = {.lex_state = 112},
  [1954] = {.lex_state = 199, .external_lex_state = 2},
  [1955] = {.lex_state = 177, .external_lex_state = 11},
  [1956] = {.lex_state = 177, .external_lex_state = 11},
  [1957] = {.lex_state = 271, .external_lex_state = 21},
  [1958] = {.lex_state = 271, .external_lex_state = 21},
  [1959] = {.lex_state = 112, .external_lex_state = 14},
  [1960] = {.lex_state = 177, .external_lex_state = 11},
  [1961] = {.lex_state = 177, .external_lex_state = 11},
  [1962] = {.lex_state = 168, .external_lex_state = 4},
  [1963] = {.lex_state = 168, .external_lex_state = 4},
  [1964] = {.lex_state = 211, .external_lex_state = 4},
  [1965] = {.lex_state = 271, .external_lex_state = 21},
  [1966] = {.lex_state = 271, .external_lex_state = 21},
  [1967] = {.lex_state = 112, .external_lex_state = 14},
  [1968] = {.lex_state = 211, .external_lex_state = 4},
  [1969] = {.lex_state = 242, .external_lex_state = 14},
  [1970] = {.lex_state = 211, .external_lex_state = 4},
  [1971] = {.lex_state = 181, .external_lex_state = 14},
  [1972] = {.lex_state = 211, .external_lex_state = 4},
  [1973] = {.lex_state = 181, .external_lex_state = 14},
  [1974] = {.lex_state = 181, .external_lex_state = 14},
  [1975] = {.lex_state = 211, .external_lex_state = 4},
  [1976] = {.lex_state = 141, .external_lex_state = 11},
  [1977] = {.lex_state = 141, .external_lex_state = 11},
  [1978] = {.lex_state = 139, .external_lex_state = 12},
  [1979] = {.lex_state = 139, .external_lex_state = 12},
  [1980] = {.lex_state = 149, .external_lex_state = 13},
  [1981] = {.lex_state = 149, .external_lex_state = 13},
  [1982] = {.lex_state = 271, .external_lex_state = 21},
  [1983] = {.lex_state = 271, .external_lex_state = 21},
  [1984] = {.lex_state = 271, .external_lex_state = 21},
  [1985] = {.lex_state = 112, .external_lex_state = 14},
  [1986] = {.lex_state = 271, .external_lex_state = 21},
  [1987] = {.lex_state = 242, .external_lex_state = 14},
  [1988] = {.lex_state = 271, .external_lex_state = 21},
  [1989] = {.lex_state = 181, .external_lex_state = 14},
  [1990] = {.lex_state = 271, .external_lex_state = 21},
  [1991] = {.lex_state = 181, .external_lex_state = 14},
  [1992] = {.lex_state = 181, .external_lex_state = 14},
  [1993] = {.lex_state = 271, .external_lex_state = 21},
  [1994] = {.lex_state = 181, .external_lex_state = 14},
  [1995] = {.lex_state = 181, .external_lex_state = 14},
  [1996] = {.lex_state = 181, .external_lex_state = 21},
  [1997] = {.lex_state = 181, .external_lex_state = 21},
  [1998] = {.lex_state = 271, .external_lex_state = 21},
  [1999] = {.lex_state = 271, .external_lex_state = 21},
  [2000] = {.lex_state = 112, .external_lex_state = 14},
  [2001] = {.lex_state = 181, .external_lex_state = 21},
  [2002] = {.lex_state = 181, .external_lex_state = 21},
  [2003] = {.lex_state = 199, .external_lex_state = 12},
  [2004] = {.lex_state = 271, .external_lex_state = 21},
  [2005] = {.lex_state = 271, .external_lex_state = 21},
  [2006] = {.lex_state = 112, .external_lex_state = 14},
  [2007] = {.lex_state = 199, .external_lex_state = 12},
  [2008] = {.lex_state = 242, .external_lex_state = 14},
  [2009] = {.lex_state = 199, .external_lex_state = 12},
  [2010] = {.lex_state = 181, .external_lex_state = 14},
  [2011] = {.lex_state = 199, .external_lex_state = 12},
  [2012] = {.lex_state = 181, .external_lex_state = 14},
  [2013] = {.lex_state = 181, .external_lex_state = 14},
  [2014] = {.lex_state = 199, .external_lex_state = 12},
  [2015] = {.lex_state = 219, .external_lex_state = 2},
  [2016] = {.lex_state = 112},
  [2017] = {.lex_state = 112},
  [2018] = {.lex_state = 112},
  [2019] = {.lex_state = 112},
  [2020] = {.lex_state = 112},
  [2021] = {.lex_state = 112},
  [2022] = {.lex_state = 139},
  [2023] = {.lex_state = 112},
  [2024] = {.lex_state = 112},
  [2025] = {.lex_state = 112},
  [2026] = {.lex_state = 139},
  [2027] = {.lex_state = 112},
  [2028] = {.lex_state = 288, .external_lex_state = 13},
  [2029] = {.lex_state = 288, .external_lex_state = 13},
  [2030] = {.lex_state = 112},
  [2031] = {.lex_state = 139},
  [2032] = {.lex_state = 288, .external_lex_state = 13},
  [2033] = {.lex_state = 288, .external_lex_state = 13},
  [2034] = {.lex_state = 149},
  [2035] = {.lex_state = 288, .external_lex_state = 13},
  [2036] = {.lex_state = 288, .external_lex_state = 13},
  [2037] = {.lex_state = 288, .external_lex_state = 13},
  [2038] = {.lex_state = 112},
  [2039] = {.lex_state = 181, .external_lex_state = 14},
  [2040] = {.lex_state = 190, .external_lex_state = 5},
  [2041] = {.lex_state = 181, .external_lex_state = 14},
  [2042] = {.lex_state = 181, .external_lex_state = 14},
  [2043] = {.lex_state = 112},
  [2044] = {.lex_state = 199, .external_lex_state = 2},
  [2045] = {.lex_state = 112},
  [2046] = {.lex_state = 207, .external_lex_state = 2},
  [2047] = {.lex_state = 112},
  [2048] = {.lex_state = 199, .external_lex_state = 2},
  [2049] = {.lex_state = 192, .external_lex_state = 5},
  [2050] = {.lex_state = 192, .external_lex_state = 22},
  [2051] = {.lex_state = 192, .external_lex_state = 22},
  [2052] = {.lex_state = 271, .external_lex_state = 21},
  [2053] = {.lex_state = 271, .external_lex_state = 21},
  [2054] = {.lex_state = 112, .external_lex_state = 14},
  [2055] = {.lex_state = 192, .external_lex_state = 22},
  [2056] = {.lex_state = 192, .external_lex_state = 22},
  [2057] = {.lex_state = 194, .external_lex_state = 15},
  [2058] = {.lex_state = 194, .external_lex_state = 15},
  [2059] = {.lex_state = 246, .external_lex_state = 15},
  [2060] = {.lex_state = 271, .external_lex_state = 21},
  [2061] = {.lex_state = 271, .external_lex_state = 21},
  [2062] = {.lex_state = 112, .external_lex_state = 14},
  [2063] = {.lex_state = 246, .external_lex_state = 15},
  [2064] = {.lex_state = 242, .external_lex_state = 14},
  [2065] = {.lex_state = 246, .external_lex_state = 15},
  [2066] = {.lex_state = 181, .external_lex_state = 14},
  [2067] = {.lex_state = 246, .external_lex_state = 15},
  [2068] = {.lex_state = 181, .external_lex_state = 14},
  [2069] = {.lex_state = 181, .external_lex_state = 14},
  [2070] = {.lex_state = 246, .external_lex_state = 15},
  [2071] = {.lex_state = 207, .external_lex_state = 12},
  [2072] = {.lex_state = 271, .external_lex_state = 21},
  [2073] = {.lex_state = 271, .external_lex_state = 21},
  [2074] = {.lex_state = 112, .external_lex_state = 14},
  [2075] = {.lex_state = 207, .external_lex_state = 12},
  [2076] = {.lex_state = 242, .external_lex_state = 14},
  [2077] = {.lex_state = 207, .external_lex_state = 12},
  [2078] = {.lex_state = 181, .external_lex_state = 14},
  [2079] = {.lex_state = 207, .external_lex_state = 12},
  [2080] = {.lex_state = 181, .external_lex_state = 14},
  [2081] = {.lex_state = 181, .external_lex_state = 14},
  [2082] = {.lex_state = 207, .external_lex_state = 12},
  [2083] = {.lex_state = 290, .external_lex_state = 13},
  [2084] = {.lex_state = 290, .external_lex_state = 13},
  [2085] = {.lex_state = 139},
  [2086] = {.lex_state = 290, .external_lex_state = 13},
  [2087] = {.lex_state = 290, .external_lex_state = 13},
  [2088] = {.lex_state = 149},
  [2089] = {.lex_state = 290, .external_lex_state = 13},
  [2090] = {.lex_state = 290, .external_lex_state = 13},
  [2091] = {.lex_state = 290, .external_lex_state = 13},
  [2092] = {.lex_state = 112},
  [2093] = {.lex_state = 181, .external_lex_state = 14},
  [2094] = {.lex_state = 190, .external_lex_state = 5},
  [2095] = {.lex_state = 181, .external_lex_state = 14},
  [2096] = {.lex_state = 181, .external_lex_state = 14},
  [2097] = {.lex_state = 112},
  [2098] = {.lex_state = 199, .external_lex_state = 2},
  [2099] = {.lex_state = 112},
  [2100] = {.lex_state = 207, .external_lex_state = 2},
  [2101] = {.lex_state = 112},
  [2102] = {.lex_state = 199, .external_lex_state = 2},
  [2103] = {.lex_state = 201, .external_lex_state = 22},
  [2104] = {.lex_state = 201, .external_lex_state = 22},
  [2105] = {.lex_state = 271, .external_lex_state = 21},
  [2106] = {.lex_state = 271, .external_lex_state = 21},
  [2107] = {.lex_state = 112, .external_lex_state = 14},
  [2108] = {.lex_state = 201, .external_lex_state = 22},
  [2109] = {.lex_state = 201, .external_lex_state = 22},
  [2110] = {.lex_state = 203, .external_lex_state = 15},
  [2111] = {.lex_state = 203, .external_lex_state = 15},
  [2112] = {.lex_state = 248, .external_lex_state = 15},
  [2113] = {.lex_state = 271, .external_lex_state = 21},
  [2114] = {.lex_state = 271, .external_lex_state = 21},
  [2115] = {.lex_state = 112, .external_lex_state = 14},
  [2116] = {.lex_state = 248, .external_lex_state = 15},
  [2117] = {.lex_state = 242, .external_lex_state = 14},
  [2118] = {.lex_state = 248, .external_lex_state = 15},
  [2119] = {.lex_state = 181, .external_lex_state = 14},
  [2120] = {.lex_state = 248, .external_lex_state = 15},
  [2121] = {.lex_state = 181, .external_lex_state = 14},
  [2122] = {.lex_state = 181, .external_lex_state = 14},
  [2123] = {.lex_state = 248, .external_lex_state = 15},
  [2124] = {.lex_state = 215, .external_lex_state = 4},
  [2125] = {.lex_state = 215, .external_lex_state = 4},
  [2126] = {.lex_state = 271, .external_lex_state = 21},
  [2127] = {.lex_state = 271, .external_lex_state = 21},
  [2128] = {.lex_state = 112, .external_lex_state = 14},
  [2129] = {.lex_state = 215, .external_lex_state = 4},
  [2130] = {.lex_state = 215, .external_lex_state = 4},
  [2131] = {.lex_state = 250, .external_lex_state = 23},
  [2132] = {.lex_state = 250, .external_lex_state = 23},
  [2133] = {.lex_state = 271, .external_lex_state = 21},
  [2134] = {.lex_state = 271, .external_lex_state = 21},
  [2135] = {.lex_state = 112, .external_lex_state = 14},
  [2136] = {.lex_state = 250, .external_lex_state = 23},
  [2137] = {.lex_state = 242, .external_lex_state = 14},
  [2138] = {.lex_state = 250, .external_lex_state = 23},
  [2139] = {.lex_state = 181, .external_lex_state = 14},
  [2140] = {.lex_state = 250, .external_lex_state = 23},
  [2141] = {.lex_state = 181, .external_lex_state = 14},
  [2142] = {.lex_state = 181, .external_lex_state = 14},
  [2143] = {.lex_state = 250, .external_lex_state = 23},
  [2144] = {.lex_state = 253, .external_lex_state = 13},
  [2145] = {.lex_state = 253, .external_lex_state = 13},
  [2146] = {.lex_state = 271, .external_lex_state = 21},
  [2147] = {.lex_state = 271, .external_lex_state = 21},
  [2148] = {.lex_state = 112, .external_lex_state = 14},
  [2149] = {.lex_state = 253, .external_lex_state = 13},
  [2150] = {.lex_state = 253, .external_lex_state = 13},
  [2151] = {.lex_state = 166, .external_lex_state = 18},
  [2152] = {.lex_state = 166, .external_lex_state = 18},
  [2153] = {.lex_state = 217, .external_lex_state = 19},
  [2154] = {.lex_state = 217, .external_lex_state = 19},
  [2155] = {.lex_state = 259, .external_lex_state = 10},
  [2156] = {.lex_state = 259, .external_lex_state = 10},
  [2157] = {.lex_state = 271, .external_lex_state = 21},
  [2158] = {.lex_state = 271, .external_lex_state = 21},
  [2159] = {.lex_state = 112, .external_lex_state = 14},
  [2160] = {.lex_state = 259, .external_lex_state = 10},
  [2161] = {.lex_state = 259, .external_lex_state = 10},
  [2162] = {.lex_state = 177, .external_lex_state = 6},
  [2163] = {.lex_state = 283, .external_lex_state = 2},
  [2164] = {.lex_state = 263},
  [2165] = {.lex_state = 283, .external_lex_state = 2},
  [2166] = {.lex_state = 283, .external_lex_state = 2},
  [2167] = {.lex_state = 263},
  [2168] = {.lex_state = 283, .external_lex_state = 2},
  [2169] = {.lex_state = 277, .external_lex_state = 13},
  [2170] = {.lex_state = 271, .external_lex_state = 21},
  [2171] = {.lex_state = 271, .external_lex_state = 21},
  [2172] = {.lex_state = 112, .external_lex_state = 14},
  [2173] = {.lex_state = 277, .external_lex_state = 13},
  [2174] = {.lex_state = 242, .external_lex_state = 14},
  [2175] = {.lex_state = 277, .external_lex_state = 13},
  [2176] = {.lex_state = 181, .external_lex_state = 14},
  [2177] = {.lex_state = 277, .external_lex_state = 13},
  [2178] = {.lex_state = 181, .external_lex_state = 14},
  [2179] = {.lex_state = 181, .external_lex_state = 14},
  [2180] = {.lex_state = 277, .external_lex_state = 13},
  [2181] = {.lex_state = 163, .external_lex_state = 2},
  [2182] = {.lex_state = 136},
  [2183] = {.lex_state = 163, .external_lex_state = 2},
  [2184] = {.lex_state = 136},
  [2185] = {.lex_state = 177, .external_lex_state = 6},
  [2186] = {.lex_state = 177, .external_lex_state = 6},
  [2187] = {.lex_state = 279, .external_lex_state = 10},
  [2188] = {.lex_state = 271, .external_lex_state = 21},
  [2189] = {.lex_state = 271, .external_lex_state = 21},
  [2190] = {.lex_state = 112, .external_lex_state = 14},
  [2191] = {.lex_state = 279, .external_lex_state = 10},
  [2192] = {.lex_state = 242, .external_lex_state = 14},
  [2193] = {.lex_state = 279, .external_lex_state = 10},
  [2194] = {.lex_state = 181, .external_lex_state = 14},
  [2195] = {.lex_state = 279, .external_lex_state = 10},
  [2196] = {.lex_state = 181, .external_lex_state = 14},
  [2197] = {.lex_state = 181, .external_lex_state = 14},
  [2198] = {.lex_state = 279, .external_lex_state = 10},
  [2199] = {.lex_state = 172, .external_lex_state = 18},
  [2200] = {.lex_state = 172, .external_lex_state = 18},
  [2201] = {.lex_state = 271, .external_lex_state = 21},
  [2202] = {.lex_state = 271, .external_lex_state = 21},
  [2203] = {.lex_state = 112, .external_lex_state = 14},
  [2204] = {.lex_state = 172, .external_lex_state = 18},
  [2205] = {.lex_state = 172, .external_lex_state = 18},
  [2206] = {.lex_state = 286, .external_lex_state = 10},
  [2207] = {.lex_state = 286, .external_lex_state = 10},
  [2208] = {.lex_state = 286, .external_lex_state = 10},
  [2209] = {.lex_state = 242, .external_lex_state = 14},
  [2210] = {.lex_state = 286, .external_lex_state = 10},
  [2211] = {.lex_state = 181, .external_lex_state = 14},
  [2212] = {.lex_state = 112},
  [2213] = {.lex_state = 181, .external_lex_state = 14},
  [2214] = {.lex_state = 181, .external_lex_state = 14},
  [2215] = {.lex_state = 181, .external_lex_state = 14},
  [2216] = {.lex_state = 286, .external_lex_state = 10},
  [2217] = {.lex_state = 181, .external_lex_state = 14},
  [2218] = {.lex_state = 286, .external_lex_state = 10},
  [2219] = {.lex_state = 181, .external_lex_state = 14},
  [2220] = {.lex_state = 286, .external_lex_state = 10},
  [2221] = {.lex_state = 286, .external_lex_state = 10},
  [2222] = {.lex_state = 177, .external_lex_state = 11},
  [2223] = {.lex_state = 177, .external_lex_state = 11},
  [2224] = {.lex_state = 211, .external_lex_state = 4},
  [2225] = {.lex_state = 211, .external_lex_state = 4},
  [2226] = {.lex_state = 271, .external_lex_state = 21},
  [2227] = {.lex_state = 271, .external_lex_state = 21},
  [2228] = {.lex_state = 112, .external_lex_state = 14},
  [2229] = {.lex_state = 211, .external_lex_state = 4},
  [2230] = {.lex_state = 211, .external_lex_state = 4},
  [2231] = {.lex_state = 271, .external_lex_state = 21},
  [2232] = {.lex_state = 271, .external_lex_state = 21},
  [2233] = {.lex_state = 271, .external_lex_state = 21},
  [2234] = {.lex_state = 271, .external_lex_state = 21},
  [2235] = {.lex_state = 112, .external_lex_state = 14},
  [2236] = {.lex_state = 271, .external_lex_state = 21},
  [2237] = {.lex_state = 271, .external_lex_state = 21},
  [2238] = {.lex_state = 181, .external_lex_state = 21},
  [2239] = {.lex_state = 181, .external_lex_state = 21},
  [2240] = {.lex_state = 199, .external_lex_state = 12},
  [2241] = {.lex_state = 199, .external_lex_state = 12},
  [2242] = {.lex_state = 271, .external_lex_state = 21},
  [2243] = {.lex_state = 271, .external_lex_state = 21},
  [2244] = {.lex_state = 112, .external_lex_state = 14},
  [2245] = {.lex_state = 199, .external_lex_state = 12},
  [2246] = {.lex_state = 199, .external_lex_state = 12},
  [2247] = {.lex_state = 112},
  [2248] = {.lex_state = 219, .external_lex_state = 2},
  [2249] = {.lex_state = 112},
  [2250] = {.lex_state = 112},
  [2251] = {.lex_state = 112},
  [2252] = {.lex_state = 112},
  [2253] = {.lex_state = 112},
  [2254] = {.lex_state = 288, .external_lex_state = 13},
  [2255] = {.lex_state = 288, .external_lex_state = 13},
  [2256] = {.lex_state = 288, .external_lex_state = 13},
  [2257] = {.lex_state = 242, .external_lex_state = 14},
  [2258] = {.lex_state = 288, .external_lex_state = 13},
  [2259] = {.lex_state = 181, .external_lex_state = 14},
  [2260] = {.lex_state = 112},
  [2261] = {.lex_state = 181, .external_lex_state = 14},
  [2262] = {.lex_state = 181, .external_lex_state = 14},
  [2263] = {.lex_state = 181, .external_lex_state = 14},
  [2264] = {.lex_state = 288, .external_lex_state = 13},
  [2265] = {.lex_state = 181, .external_lex_state = 14},
  [2266] = {.lex_state = 288, .external_lex_state = 13},
  [2267] = {.lex_state = 181, .external_lex_state = 14},
  [2268] = {.lex_state = 288, .external_lex_state = 13},
  [2269] = {.lex_state = 288, .external_lex_state = 13},
  [2270] = {.lex_state = 192, .external_lex_state = 22},
  [2271] = {.lex_state = 192, .external_lex_state = 22},
  [2272] = {.lex_state = 246, .external_lex_state = 15},
  [2273] = {.lex_state = 246, .external_lex_state = 15},
  [2274] = {.lex_state = 271, .external_lex_state = 21},
  [2275] = {.lex_state = 271, .external_lex_state = 21},
  [2276] = {.lex_state = 112, .external_lex_state = 14},
  [2277] = {.lex_state = 246, .external_lex_state = 15},
  [2278] = {.lex_state = 246, .external_lex_state = 15},
  [2279] = {.lex_state = 207, .external_lex_state = 12},
  [2280] = {.lex_state = 207, .external_lex_state = 12},
  [2281] = {.lex_state = 271, .external_lex_state = 21},
  [2282] = {.lex_state = 271, .external_lex_state = 21},
  [2283] = {.lex_state = 112, .external_lex_state = 14},
  [2284] = {.lex_state = 207, .external_lex_state = 12},
  [2285] = {.lex_state = 207, .external_lex_state = 12},
  [2286] = {.lex_state = 290, .external_lex_state = 13},
  [2287] = {.lex_state = 290, .external_lex_state = 13},
  [2288] = {.lex_state = 290, .external_lex_state = 13},
  [2289] = {.lex_state = 242, .external_lex_state = 14},
  [2290] = {.lex_state = 290, .external_lex_state = 13},
  [2291] = {.lex_state = 181, .external_lex_state = 14},
  [2292] = {.lex_state = 112},
  [2293] = {.lex_state = 181, .external_lex_state = 14},
  [2294] = {.lex_state = 181, .external_lex_state = 14},
  [2295] = {.lex_state = 181, .external_lex_state = 14},
  [2296] = {.lex_state = 290, .external_lex_state = 13},
  [2297] = {.lex_state = 181, .external_lex_state = 14},
  [2298] = {.lex_state = 290, .external_lex_state = 13},
  [2299] = {.lex_state = 181, .external_lex_state = 14},
  [2300] = {.lex_state = 290, .external_lex_state = 13},
  [2301] = {.lex_state = 290, .external_lex_state = 13},
  [2302] = {.lex_state = 201, .external_lex_state = 22},
  [2303] = {.lex_state = 201, .external_lex_state = 22},
  [2304] = {.lex_state = 248, .external_lex_state = 15},
  [2305] = {.lex_state = 248, .external_lex_state = 15},
  [2306] = {.lex_state = 271, .external_lex_state = 21},
  [2307] = {.lex_state = 271, .external_lex_state = 21},
  [2308] = {.lex_state = 112, .external_lex_state = 14},
  [2309] = {.lex_state = 248, .external_lex_state = 15},
  [2310] = {.lex_state = 248, .external_lex_state = 15},
  [2311] = {.lex_state = 215, .external_lex_state = 4},
  [2312] = {.lex_state = 215, .external_lex_state = 4},
  [2313] = {.lex_state = 250, .external_lex_state = 23},
  [2314] = {.lex_state = 250, .external_lex_state = 23},
  [2315] = {.lex_state = 271, .external_lex_state = 21},
  [2316] = {.lex_state = 271, .external_lex_state = 21},
  [2317] = {.lex_state = 112, .external_lex_state = 14},
  [2318] = {.lex_state = 250, .external_lex_state = 23},
  [2319] = {.lex_state = 250, .external_lex_state = 23},
  [2320] = {.lex_state = 253, .external_lex_state = 13},
  [2321] = {.lex_state = 253, .external_lex_state = 13},
  [2322] = {.lex_state = 259, .external_lex_state = 10},
  [2323] = {.lex_state = 259, .external_lex_state = 10},
  [2324] = {.lex_state = 263},
  [2325] = {.lex_state = 263},
  [2326] = {.lex_state = 277, .external_lex_state = 13},
  [2327] = {.lex_state = 277, .external_lex_state = 13},
  [2328] = {.lex_state = 271, .external_lex_state = 21},
  [2329] = {.lex_state = 271, .external_lex_state = 21},
  [2330] = {.lex_state = 112, .external_lex_state = 14},
  [2331] = {.lex_state = 277, .external_lex_state = 13},
  [2332] = {.lex_state = 277, .external_lex_state = 13},
  [2333] = {.lex_state = 139},
  [2334] = {.lex_state = 163, .external_lex_state = 2},
  [2335] = {.lex_state = 163, .external_lex_state = 2},
  [2336] = {.lex_state = 139},
  [2337] = {.lex_state = 163, .external_lex_state = 2},
  [2338] = {.lex_state = 163, .external_lex_state = 2},
  [2339] = {.lex_state = 279, .external_lex_state = 10},
  [2340] = {.lex_state = 279, .external_lex_state = 10},
  [2341] = {.lex_state = 271, .external_lex_state = 21},
  [2342] = {.lex_state = 271, .external_lex_state = 21},
  [2343] = {.lex_state = 112, .external_lex_state = 14},
  [2344] = {.lex_state = 279, .external_lex_state = 10},
  [2345] = {.lex_state = 279, .external_lex_state = 10},
  [2346] = {.lex_state = 172, .external_lex_state = 18},
  [2347] = {.lex_state = 172, .external_lex_state = 18},
  [2348] = {.lex_state = 286, .external_lex_state = 10},
  [2349] = {.lex_state = 271, .external_lex_state = 21},
  [2350] = {.lex_state = 271, .external_lex_state = 21},
  [2351] = {.lex_state = 112, .external_lex_state = 14},
  [2352] = {.lex_state = 286, .external_lex_state = 10},
  [2353] = {.lex_state = 242, .external_lex_state = 14},
  [2354] = {.lex_state = 286, .external_lex_state = 10},
  [2355] = {.lex_state = 181, .external_lex_state = 14},
  [2356] = {.lex_state = 286, .external_lex_state = 10},
  [2357] = {.lex_state = 181, .external_lex_state = 14},
  [2358] = {.lex_state = 181, .external_lex_state = 14},
  [2359] = {.lex_state = 286, .external_lex_state = 10},
  [2360] = {.lex_state = 211, .external_lex_state = 4},
  [2361] = {.lex_state = 211, .external_lex_state = 4},
  [2362] = {.lex_state = 271, .external_lex_state = 21},
  [2363] = {.lex_state = 271, .external_lex_state = 21},
  [2364] = {.lex_state = 199, .external_lex_state = 12},
  [2365] = {.lex_state = 199, .external_lex_state = 12},
  [2366] = {.lex_state = 112},
  [2367] = {.lex_state = 112},
  [2368] = {.lex_state = 112},
  [2369] = {.lex_state = 288, .external_lex_state = 13},
  [2370] = {.lex_state = 271, .external_lex_state = 21},
  [2371] = {.lex_state = 271, .external_lex_state = 21},
  [2372] = {.lex_state = 112, .external_lex_state = 14},
  [2373] = {.lex_state = 288, .external_lex_state = 13},
  [2374] = {.lex_state = 242, .external_lex_state = 14},
  [2375] = {.lex_state = 288, .external_lex_state = 13},
  [2376] = {.lex_state = 181, .external_lex_state = 14},
  [2377] = {.lex_state = 288, .external_lex_state = 13},
  [2378] = {.lex_state = 181, .external_lex_state = 14},
  [2379] = {.lex_state = 181, .external_lex_state = 14},
  [2380] = {.lex_state = 288, .external_lex_state = 13},
  [2381] = {.lex_state = 246, .external_lex_state = 15},
  [2382] = {.lex_state = 246, .external_lex_state = 15},
  [2383] = {.lex_state = 207, .external_lex_state = 12},
  [2384] = {.lex_state = 207, .external_lex_state = 12},
  [2385] = {.lex_state = 290, .external_lex_state = 13},
  [2386] = {.lex_state = 271, .external_lex_state = 21},
  [2387] = {.lex_state = 271, .external_lex_state = 21},
  [2388] = {.lex_state = 112, .external_lex_state = 14},
  [2389] = {.lex_state = 290, .external_lex_state = 13},
  [2390] = {.lex_state = 242, .external_lex_state = 14},
  [2391] = {.lex_state = 290, .external_lex_state = 13},
  [2392] = {.lex_state = 181, .external_lex_state = 14},
  [2393] = {.lex_state = 290, .external_lex_state = 13},
  [2394] = {.lex_state = 181, .external_lex_state = 14},
  [2395] = {.lex_state = 181, .external_lex_state = 14},
  [2396] = {.lex_state = 290, .external_lex_state = 13},
  [2397] = {.lex_state = 248, .external_lex_state = 15},
  [2398] = {.lex_state = 248, .external_lex_state = 15},
  [2399] = {.lex_state = 250, .external_lex_state = 23},
  [2400] = {.lex_state = 250, .external_lex_state = 23},
  [2401] = {.lex_state = 277, .external_lex_state = 13},
  [2402] = {.lex_state = 277, .external_lex_state = 13},
  [2403] = {.lex_state = 139},
  [2404] = {.lex_state = 163, .external_lex_state = 2},
  [2405] = {.lex_state = 163, .external_lex_state = 2},
  [2406] = {.lex_state = 139},
  [2407] = {.lex_state = 163, .external_lex_state = 2},
  [2408] = {.lex_state = 279, .external_lex_state = 10},
  [2409] = {.lex_state = 279, .external_lex_state = 10},
  [2410] = {.lex_state = 286, .external_lex_state = 10},
  [2411] = {.lex_state = 286, .external_lex_state = 10},
  [2412] = {.lex_state = 271, .external_lex_state = 21},
  [2413] = {.lex_state = 271, .external_lex_state = 21},
  [2414] = {.lex_state = 112, .external_lex_state = 14},
  [2415] = {.lex_state = 286, .external_lex_state = 10},
  [2416] = {.lex_state = 286, .external_lex_state = 10},
  [2417] = {.lex_state = 288, .external_lex_state = 13},
  [2418] = {.lex_state = 288, .external_lex_state = 13},
  [2419] = {.lex_state = 271, .external_lex_state = 21},
  [2420] = {.lex_state = 271, .external_lex_state = 21},
  [2421] = {.lex_state = 112, .external_lex_state = 14},
  [2422] = {.lex_state = 288, .external_lex_state = 13},
  [2423] = {.lex_state = 288, .external_lex_state = 13},
  [2424] = {.lex_state = 290, .external_lex_state = 13},
  [2425] = {.lex_state = 290, .external_lex_state = 13},
  [2426] = {.lex_state = 271, .external_lex_state = 21},
  [2427] = {.lex_state = 271, .external_lex_state = 21},
  [2428] = {.lex_state = 112, .external_lex_state = 14},
  [2429] = {.lex_state = 290, .external_lex_state = 13},
  [2430] = {.lex_state = 290, .external_lex_state = 13},
  [2431] = {.lex_state = 139},
  [2432] = {.lex_state = 139},
  [2433] = {.lex_state = 286, .external_lex_state = 10},
  [2434] = {.lex_state = 286, .external_lex_state = 10},
  [2435] = {.lex_state = 288, .external_lex_state = 13},
  [2436] = {.lex_state = 288, .external_lex_state = 13},
  [2437] = {.lex_state = 290, .external_lex_state = 13},
  [2438] = {.lex_state = 290, .external_lex_state = 13},
};

enum {
  ts_external_token__simple_heredoc,
  ts_external_token__heredoc_beginning,
  ts_external_token__heredoc_middle,
  ts_external_token__heredoc_end,
  ts_external_token_file_descriptor,
  ts_external_token__empty_value,
  ts_external_token__concat,
  ts_external_token_variable_name,
  ts_external_token_RBRACE,
  ts_external_token_RBRACK,
  ts_external_token_LF,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__simple_heredoc] = sym__simple_heredoc,
  [ts_external_token__heredoc_beginning] = sym__heredoc_beginning,
  [ts_external_token__heredoc_middle] = sym__heredoc_middle,
  [ts_external_token__heredoc_end] = sym__heredoc_end,
  [ts_external_token_file_descriptor] = sym_file_descriptor,
  [ts_external_token__empty_value] = sym__empty_value,
  [ts_external_token__concat] = sym__concat,
  [ts_external_token_variable_name] = sym_variable_name,
  [ts_external_token_RBRACE] = anon_sym_RBRACE,
  [ts_external_token_RBRACK] = anon_sym_RBRACK,
  [ts_external_token_LF] = anon_sym_LF,
};

static bool ts_external_scanner_states[25][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__empty_value] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
    [ts_external_token_RBRACK] = true,
    [ts_external_token_LF] = true,
  },
  [2] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
  },
  [3] = {
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [4] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [5] = {
    [ts_external_token_variable_name] = true,
  },
  [6] = {
    [ts_external_token_LF] = true,
  },
  [7] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_LF] = true,
  },
  [8] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [9] = {
    [ts_external_token__empty_value] = true,
  },
  [10] = {
    [ts_external_token__concat] = true,
    [ts_external_token_LF] = true,
  },
  [11] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [12] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [13] = {
    [ts_external_token__concat] = true,
  },
  [14] = {
    [ts_external_token_RBRACE] = true,
  },
  [15] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
  },
  [16] = {
    [ts_external_token_file_descriptor] = true,
  },
  [17] = {
    [ts_external_token__simple_heredoc] = true,
    [ts_external_token__heredoc_beginning] = true,
  },
  [18] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_LF] = true,
  },
  [19] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACK] = true,
  },
  [20] = {
    [ts_external_token_file_descriptor] = true,
    [ts_external_token_variable_name] = true,
    [ts_external_token_RBRACE] = true,
  },
  [21] = {
    [ts_external_token__concat] = true,
    [ts_external_token_RBRACE] = true,
  },
  [22] = {
    [ts_external_token__concat] = true,
    [ts_external_token_variable_name] = true,
  },
  [23] = {
    [ts_external_token__heredoc_middle] = true,
    [ts_external_token__heredoc_end] = true,
  },
  [24] = {
    [ts_external_token_RBRACK] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__simple_heredoc] = ACTIONS(1),
    [sym__heredoc_beginning] = ACTIONS(1),
    [sym__heredoc_middle] = ACTIONS(1),
    [sym__heredoc_end] = ACTIONS(1),
    [sym_file_descriptor] = ACTIONS(1),
    [sym__empty_value] = ACTIONS(1),
    [sym__concat] = ACTIONS(1),
    [sym_variable_name] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(3),
    [anon_sym_SEMI_SEMI] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_RBRACE] = ACTIONS(3),
    [anon_sym_PIPE_AMP] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(3),
    [anon_sym_RBRACK] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_AMP_GT] = ACTIONS(3),
    [anon_sym_AMP_GT_GT] = ACTIONS(3),
    [anon_sym_LT_AMP] = ACTIONS(3),
    [anon_sym_GT_AMP] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_LT_LT_DASH] = ACTIONS(3),
    [anon_sym_LT_LT_LT] = ACTIONS(3),
    [sym__special_characters] = ACTIONS(3),
    [anon_sym_DQUOTE] = ACTIONS(3),
    [sym_raw_string] = ACTIONS(3),
    [anon_sym_DOLLAR] = ACTIONS(3),
    [anon_sym_POUND] = ACTIONS(3),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_COLON_QMARK] = ACTIONS(3),
    [anon_sym_COLON_DASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3),
    [anon_sym_BQUOTE] = ACTIONS(3),
    [anon_sym_LT_LPAREN] = ACTIONS(3),
    [anon_sym_GT_LPAREN] = ACTIONS(3),
    [sym_comment] = ACTIONS(5),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(3),
    [anon_sym_QMARK] = ACTIONS(3),
    [anon_sym_0] = ACTIONS(3),
    [anon_sym__] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(3),
    [anon_sym_LF] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(21),
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(29),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [ts_builtin_sym_end] = ACTIONS(12),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2] = {
    [anon_sym_LT] = ACTIONS(52),
    [anon_sym_GT] = ACTIONS(52),
    [anon_sym_GT_GT] = ACTIONS(54),
    [anon_sym_AMP_GT] = ACTIONS(52),
    [anon_sym_AMP_GT_GT] = ACTIONS(54),
    [anon_sym_LT_AMP] = ACTIONS(54),
    [anon_sym_GT_AMP] = ACTIONS(54),
    [sym_comment] = ACTIONS(48),
  },
  [3] = {
    [sym__assignment] = STATE(34),
    [anon_sym_EQ] = ACTIONS(56),
    [anon_sym_PLUS_EQ] = ACTIONS(56),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [4] = {
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(60),
  },
  [5] = {
    [sym__terminated_statement] = STATE(36),
    [sym_for_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_subshell] = STATE(37),
    [sym_pipeline] = STATE(37),
    [sym_list] = STATE(37),
    [sym_command] = STATE(37),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(38),
    [sym_declaration_command] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [6] = {
    [sym__terminated_statement] = STATE(39),
    [sym_for_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_subshell] = STATE(37),
    [sym_pipeline] = STATE(37),
    [sym_list] = STATE(37),
    [sym_command] = STATE(37),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(38),
    [sym_declaration_command] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [7] = {
    [sym_concatenation] = STATE(48),
    [sym_string] = STATE(42),
    [sym_simple_expansion] = STATE(42),
    [sym_expansion] = STATE(42),
    [sym_command_substitution] = STATE(42),
    [sym_process_substitution] = STATE(42),
    [sym__special_characters] = ACTIONS(62),
    [anon_sym_DQUOTE] = ACTIONS(64),
    [sym_raw_string] = ACTIONS(66),
    [anon_sym_DOLLAR] = ACTIONS(68),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(70),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(72),
    [anon_sym_BQUOTE] = ACTIONS(74),
    [anon_sym_LT_LPAREN] = ACTIONS(76),
    [anon_sym_GT_LPAREN] = ACTIONS(76),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(78),
  },
  [8] = {
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(80),
  },
  [9] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(63),
    [sym_while_statement] = STATE(63),
    [sym_if_statement] = STATE(63),
    [sym_case_statement] = STATE(63),
    [sym_function_definition] = STATE(63),
    [sym_subshell] = STATE(63),
    [sym_pipeline] = STATE(63),
    [sym_list] = STATE(63),
    [sym_command] = STATE(63),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(65),
    [sym_declaration_command] = STATE(63),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_program_repeat1] = STATE(67),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(84),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(88),
    [anon_sym_typeset] = ACTIONS(88),
    [anon_sym_export] = ACTIONS(88),
    [anon_sym_readonly] = ACTIONS(88),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(90),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(94),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(106),
  },
  [10] = {
    [sym_variable_assignment] = STATE(79),
    [sym_subscript] = STATE(80),
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(72),
    [sym_simple_expansion] = STATE(72),
    [sym_expansion] = STATE(72),
    [sym_command_substitution] = STATE(72),
    [sym_process_substitution] = STATE(72),
    [aux_sym_declaration_command_repeat1] = STATE(81),
    [sym_variable_name] = ACTIONS(108),
    [anon_sym_PIPE] = ACTIONS(110),
    [anon_sym_SEMI_SEMI] = ACTIONS(110),
    [anon_sym_PIPE_AMP] = ACTIONS(110),
    [anon_sym_AMP_AMP] = ACTIONS(110),
    [anon_sym_PIPE_PIPE] = ACTIONS(110),
    [sym__special_characters] = ACTIONS(112),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [sym_raw_string] = ACTIONS(116),
    [anon_sym_DOLLAR] = ACTIONS(118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(122),
    [anon_sym_BQUOTE] = ACTIONS(124),
    [anon_sym_LT_LPAREN] = ACTIONS(126),
    [anon_sym_GT_LPAREN] = ACTIONS(126),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(130),
    [sym_word] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(110),
    [anon_sym_LF] = ACTIONS(110),
    [anon_sym_AMP] = ACTIONS(110),
  },
  [11] = {
    [sym_concatenation] = STATE(90),
    [sym_string] = STATE(84),
    [sym_simple_expansion] = STATE(84),
    [sym_expansion] = STATE(84),
    [sym_command_substitution] = STATE(84),
    [sym_process_substitution] = STATE(84),
    [sym__special_characters] = ACTIONS(132),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_raw_string] = ACTIONS(136),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(142),
    [anon_sym_BQUOTE] = ACTIONS(144),
    [anon_sym_LT_LPAREN] = ACTIONS(146),
    [anon_sym_GT_LPAREN] = ACTIONS(146),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(148),
  },
  [12] = {
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(150),
    [sym__concat] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(154),
    [anon_sym_SEMI_SEMI] = ACTIONS(154),
    [anon_sym_PIPE_AMP] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(154),
    [anon_sym_PIPE_PIPE] = ACTIONS(154),
    [anon_sym_LT] = ACTIONS(154),
    [anon_sym_GT] = ACTIONS(154),
    [anon_sym_GT_GT] = ACTIONS(154),
    [anon_sym_AMP_GT] = ACTIONS(154),
    [anon_sym_AMP_GT_GT] = ACTIONS(154),
    [anon_sym_LT_AMP] = ACTIONS(154),
    [anon_sym_GT_AMP] = ACTIONS(154),
    [anon_sym_LT_LT] = ACTIONS(154),
    [anon_sym_LT_LT_DASH] = ACTIONS(154),
    [anon_sym_LT_LT_LT] = ACTIONS(154),
    [sym__special_characters] = ACTIONS(154),
    [anon_sym_DQUOTE] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(154),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(154),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(154),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [anon_sym_LT_LPAREN] = ACTIONS(154),
    [anon_sym_GT_LPAREN] = ACTIONS(154),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(154),
    [anon_sym_SEMI] = ACTIONS(154),
    [anon_sym_LF] = ACTIONS(154),
    [anon_sym_AMP] = ACTIONS(154),
  },
  [13] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(99),
    [anon_sym_DQUOTE] = ACTIONS(156),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [14] = {
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(170),
    [anon_sym_SEMI_SEMI] = ACTIONS(170),
    [anon_sym_PIPE_AMP] = ACTIONS(170),
    [anon_sym_AMP_AMP] = ACTIONS(170),
    [anon_sym_PIPE_PIPE] = ACTIONS(170),
    [anon_sym_LT] = ACTIONS(170),
    [anon_sym_GT] = ACTIONS(170),
    [anon_sym_GT_GT] = ACTIONS(170),
    [anon_sym_AMP_GT] = ACTIONS(170),
    [anon_sym_AMP_GT_GT] = ACTIONS(170),
    [anon_sym_LT_AMP] = ACTIONS(170),
    [anon_sym_GT_AMP] = ACTIONS(170),
    [anon_sym_LT_LT] = ACTIONS(170),
    [anon_sym_LT_LT_DASH] = ACTIONS(170),
    [anon_sym_LT_LT_LT] = ACTIONS(170),
    [sym__special_characters] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(170),
    [sym_raw_string] = ACTIONS(170),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(170),
    [anon_sym_LT_LPAREN] = ACTIONS(170),
    [anon_sym_GT_LPAREN] = ACTIONS(170),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(170),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(170),
  },
  [15] = {
    [sym_string] = STATE(102),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [anon_sym_DOLLAR] = ACTIONS(172),
    [anon_sym_POUND] = ACTIONS(172),
    [anon_sym_DASH] = ACTIONS(172),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(174),
    [anon_sym_STAR] = ACTIONS(172),
    [anon_sym_AT] = ACTIONS(172),
    [anon_sym_QMARK] = ACTIONS(172),
    [anon_sym_0] = ACTIONS(176),
    [anon_sym__] = ACTIONS(176),
  },
  [16] = {
    [sym_subscript] = STATE(107),
    [sym_variable_name] = ACTIONS(178),
    [anon_sym_DOLLAR] = ACTIONS(180),
    [anon_sym_POUND] = ACTIONS(182),
    [anon_sym_DASH] = ACTIONS(180),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(184),
    [anon_sym_STAR] = ACTIONS(180),
    [anon_sym_AT] = ACTIONS(180),
    [anon_sym_QMARK] = ACTIONS(180),
    [anon_sym_0] = ACTIONS(186),
    [anon_sym__] = ACTIONS(186),
  },
  [17] = {
    [sym_for_statement] = STATE(125),
    [sym_while_statement] = STATE(125),
    [sym_if_statement] = STATE(125),
    [sym_case_statement] = STATE(125),
    [sym_function_definition] = STATE(125),
    [sym_subshell] = STATE(125),
    [sym_pipeline] = STATE(125),
    [sym_list] = STATE(125),
    [sym_command] = STATE(125),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(127),
    [sym_declaration_command] = STATE(125),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [18] = {
    [sym_for_statement] = STATE(144),
    [sym_while_statement] = STATE(144),
    [sym_if_statement] = STATE(144),
    [sym_case_statement] = STATE(144),
    [sym_function_definition] = STATE(144),
    [sym_subshell] = STATE(144),
    [sym_pipeline] = STATE(144),
    [sym_list] = STATE(144),
    [sym_command] = STATE(144),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(146),
    [sym_declaration_command] = STATE(144),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [19] = {
    [sym_for_statement] = STATE(149),
    [sym_while_statement] = STATE(149),
    [sym_if_statement] = STATE(149),
    [sym_case_statement] = STATE(149),
    [sym_function_definition] = STATE(149),
    [sym_subshell] = STATE(149),
    [sym_pipeline] = STATE(149),
    [sym_list] = STATE(149),
    [sym_command] = STATE(149),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(150),
    [sym_declaration_command] = STATE(149),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [20] = {
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(170),
    [anon_sym_SEMI_SEMI] = ACTIONS(170),
    [anon_sym_LPAREN] = ACTIONS(248),
    [anon_sym_PIPE_AMP] = ACTIONS(170),
    [anon_sym_AMP_AMP] = ACTIONS(170),
    [anon_sym_PIPE_PIPE] = ACTIONS(170),
    [anon_sym_LT] = ACTIONS(170),
    [anon_sym_GT] = ACTIONS(170),
    [anon_sym_GT_GT] = ACTIONS(170),
    [anon_sym_AMP_GT] = ACTIONS(170),
    [anon_sym_AMP_GT_GT] = ACTIONS(170),
    [anon_sym_LT_AMP] = ACTIONS(170),
    [anon_sym_GT_AMP] = ACTIONS(170),
    [anon_sym_LT_LT] = ACTIONS(170),
    [anon_sym_LT_LT_DASH] = ACTIONS(170),
    [anon_sym_LT_LT_LT] = ACTIONS(170),
    [sym__special_characters] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(170),
    [sym_raw_string] = ACTIONS(170),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(170),
    [anon_sym_LT_LPAREN] = ACTIONS(170),
    [anon_sym_GT_LPAREN] = ACTIONS(170),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(170),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(170),
  },
  [21] = {
    [ts_builtin_sym_end] = ACTIONS(250),
    [sym_comment] = ACTIONS(48),
  },
  [22] = {
    [sym_file_descriptor] = ACTIONS(252),
    [sym_variable_name] = ACTIONS(252),
    [ts_builtin_sym_end] = ACTIONS(252),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_SEMI_SEMI] = ACTIONS(252),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_declare] = ACTIONS(254),
    [anon_sym_typeset] = ACTIONS(254),
    [anon_sym_export] = ACTIONS(254),
    [anon_sym_readonly] = ACTIONS(254),
    [anon_sym_local] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [anon_sym_AMP_GT] = ACTIONS(254),
    [anon_sym_AMP_GT_GT] = ACTIONS(252),
    [anon_sym_LT_AMP] = ACTIONS(252),
    [anon_sym_GT_AMP] = ACTIONS(252),
    [sym__special_characters] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(252),
    [anon_sym_BQUOTE] = ACTIONS(252),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(256),
  },
  [23] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(260),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(260),
    [anon_sym_LF] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(260),
  },
  [24] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_command_substitution] = STATE(160),
    [sym_process_substitution] = STATE(160),
    [aux_sym_for_statement_repeat1] = STATE(163),
    [aux_sym_while_statement_repeat1] = STATE(164),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(266),
    [anon_sym_SEMI_SEMI] = ACTIONS(266),
    [anon_sym_PIPE_AMP] = ACTIONS(266),
    [anon_sym_AMP_AMP] = ACTIONS(266),
    [anon_sym_PIPE_PIPE] = ACTIONS(266),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(266),
    [anon_sym_LF] = ACTIONS(266),
    [anon_sym_AMP] = ACTIONS(266),
  },
  [25] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(260),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(260),
    [anon_sym_LF] = ACTIONS(260),
    [anon_sym_AMP] = ACTIONS(260),
  },
  [26] = {
    [sym__assignment] = STATE(34),
    [anon_sym_EQ] = ACTIONS(56),
    [anon_sym_PLUS_EQ] = ACTIONS(56),
    [sym_comment] = ACTIONS(48),
  },
  [27] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [28] = {
    [sym_file_descriptor] = ACTIONS(168),
    [anon_sym_PIPE] = ACTIONS(170),
    [anon_sym_RPAREN] = ACTIONS(170),
    [anon_sym_SEMI_SEMI] = ACTIONS(170),
    [anon_sym_PIPE_AMP] = ACTIONS(170),
    [anon_sym_AMP_AMP] = ACTIONS(170),
    [anon_sym_PIPE_PIPE] = ACTIONS(170),
    [anon_sym_LT] = ACTIONS(170),
    [anon_sym_GT] = ACTIONS(170),
    [anon_sym_GT_GT] = ACTIONS(170),
    [anon_sym_AMP_GT] = ACTIONS(170),
    [anon_sym_AMP_GT_GT] = ACTIONS(170),
    [anon_sym_LT_AMP] = ACTIONS(170),
    [anon_sym_GT_AMP] = ACTIONS(170),
    [anon_sym_LT_LT] = ACTIONS(170),
    [anon_sym_LT_LT_DASH] = ACTIONS(170),
    [anon_sym_LT_LT_LT] = ACTIONS(170),
    [sym__special_characters] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(170),
    [sym_raw_string] = ACTIONS(170),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(170),
    [anon_sym_LT_LPAREN] = ACTIONS(170),
    [anon_sym_GT_LPAREN] = ACTIONS(170),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(170),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(170),
  },
  [29] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(165),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [ts_builtin_sym_end] = ACTIONS(296),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [30] = {
    [sym_command_name] = STATE(167),
    [sym_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(168),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(169),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(300),
  },
  [31] = {
    [sym_concatenation] = STATE(172),
    [sym_string] = STATE(171),
    [sym_simple_expansion] = STATE(171),
    [sym_expansion] = STATE(171),
    [sym_command_substitution] = STATE(171),
    [sym_process_substitution] = STATE(171),
    [sym__special_characters] = ACTIONS(302),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_raw_string] = ACTIONS(304),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(142),
    [anon_sym_BQUOTE] = ACTIONS(144),
    [anon_sym_LT_LPAREN] = ACTIONS(146),
    [anon_sym_GT_LPAREN] = ACTIONS(146),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(306),
  },
  [32] = {
    [sym_concatenation] = STATE(173),
    [sym_string] = STATE(177),
    [sym_array] = STATE(173),
    [sym_simple_expansion] = STATE(177),
    [sym_expansion] = STATE(177),
    [sym_command_substitution] = STATE(177),
    [sym_process_substitution] = STATE(177),
    [sym__empty_value] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(310),
    [sym__special_characters] = ACTIONS(312),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_raw_string] = ACTIONS(316),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(320),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(324),
    [anon_sym_LT_LPAREN] = ACTIONS(326),
    [anon_sym_GT_LPAREN] = ACTIONS(326),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(328),
  },
  [33] = {
    [sym_concatenation] = STATE(191),
    [sym_string] = STATE(185),
    [sym_simple_expansion] = STATE(185),
    [sym_expansion] = STATE(185),
    [sym_command_substitution] = STATE(185),
    [sym_process_substitution] = STATE(185),
    [sym__special_characters] = ACTIONS(330),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [sym_raw_string] = ACTIONS(334),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(340),
    [anon_sym_BQUOTE] = ACTIONS(342),
    [anon_sym_LT_LPAREN] = ACTIONS(344),
    [anon_sym_GT_LPAREN] = ACTIONS(344),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(346),
  },
  [34] = {
    [sym_file_descriptor] = ACTIONS(348),
    [sym_variable_name] = ACTIONS(348),
    [anon_sym_PIPE] = ACTIONS(350),
    [anon_sym_RPAREN] = ACTIONS(350),
    [anon_sym_SEMI_SEMI] = ACTIONS(350),
    [anon_sym_PIPE_AMP] = ACTIONS(350),
    [anon_sym_AMP_AMP] = ACTIONS(350),
    [anon_sym_PIPE_PIPE] = ACTIONS(350),
    [anon_sym_LT] = ACTIONS(350),
    [anon_sym_GT] = ACTIONS(350),
    [anon_sym_GT_GT] = ACTIONS(350),
    [anon_sym_AMP_GT] = ACTIONS(350),
    [anon_sym_AMP_GT_GT] = ACTIONS(350),
    [anon_sym_LT_AMP] = ACTIONS(350),
    [anon_sym_GT_AMP] = ACTIONS(350),
    [sym__special_characters] = ACTIONS(350),
    [anon_sym_DQUOTE] = ACTIONS(350),
    [sym_raw_string] = ACTIONS(350),
    [anon_sym_DOLLAR] = ACTIONS(350),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(350),
    [anon_sym_BQUOTE] = ACTIONS(350),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(350),
    [anon_sym_SEMI] = ACTIONS(350),
    [anon_sym_LF] = ACTIONS(350),
    [anon_sym_AMP] = ACTIONS(350),
  },
  [35] = {
    [anon_sym_in] = ACTIONS(352),
    [sym_comment] = ACTIONS(48),
  },
  [36] = {
    [sym_do_group] = STATE(194),
    [anon_sym_do] = ACTIONS(354),
    [sym_comment] = ACTIONS(48),
  },
  [37] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(356),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(356),
    [anon_sym_LF] = ACTIONS(356),
    [anon_sym_AMP] = ACTIONS(356),
  },
  [38] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(356),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(356),
    [anon_sym_LF] = ACTIONS(356),
    [anon_sym_AMP] = ACTIONS(356),
  },
  [39] = {
    [anon_sym_then] = ACTIONS(358),
    [sym_comment] = ACTIONS(48),
  },
  [40] = {
    [aux_sym_concatenation_repeat1] = STATE(200),
    [sym__concat] = ACTIONS(360),
    [anon_sym_in] = ACTIONS(362),
    [anon_sym_SEMI_SEMI] = ACTIONS(364),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(364),
    [anon_sym_LF] = ACTIONS(364),
    [anon_sym_AMP] = ACTIONS(364),
  },
  [41] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(202),
    [anon_sym_DQUOTE] = ACTIONS(366),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [42] = {
    [aux_sym_concatenation_repeat1] = STATE(200),
    [sym__concat] = ACTIONS(360),
    [anon_sym_in] = ACTIONS(368),
    [anon_sym_SEMI_SEMI] = ACTIONS(370),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_LF] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(370),
  },
  [43] = {
    [sym_string] = STATE(207),
    [anon_sym_DQUOTE] = ACTIONS(64),
    [anon_sym_DOLLAR] = ACTIONS(372),
    [anon_sym_POUND] = ACTIONS(372),
    [anon_sym_DASH] = ACTIONS(372),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(374),
    [anon_sym_STAR] = ACTIONS(372),
    [anon_sym_AT] = ACTIONS(372),
    [anon_sym_QMARK] = ACTIONS(372),
    [anon_sym_0] = ACTIONS(376),
    [anon_sym__] = ACTIONS(376),
  },
  [44] = {
    [sym_subscript] = STATE(212),
    [sym_variable_name] = ACTIONS(378),
    [anon_sym_DOLLAR] = ACTIONS(380),
    [anon_sym_POUND] = ACTIONS(382),
    [anon_sym_DASH] = ACTIONS(380),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(384),
    [anon_sym_STAR] = ACTIONS(380),
    [anon_sym_AT] = ACTIONS(380),
    [anon_sym_QMARK] = ACTIONS(380),
    [anon_sym_0] = ACTIONS(386),
    [anon_sym__] = ACTIONS(386),
  },
  [45] = {
    [sym_for_statement] = STATE(213),
    [sym_while_statement] = STATE(213),
    [sym_if_statement] = STATE(213),
    [sym_case_statement] = STATE(213),
    [sym_function_definition] = STATE(213),
    [sym_subshell] = STATE(213),
    [sym_pipeline] = STATE(213),
    [sym_list] = STATE(213),
    [sym_command] = STATE(213),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(214),
    [sym_declaration_command] = STATE(213),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [46] = {
    [sym_for_statement] = STATE(215),
    [sym_while_statement] = STATE(215),
    [sym_if_statement] = STATE(215),
    [sym_case_statement] = STATE(215),
    [sym_function_definition] = STATE(215),
    [sym_subshell] = STATE(215),
    [sym_pipeline] = STATE(215),
    [sym_list] = STATE(215),
    [sym_command] = STATE(215),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(216),
    [sym_declaration_command] = STATE(215),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [47] = {
    [sym_for_statement] = STATE(217),
    [sym_while_statement] = STATE(217),
    [sym_if_statement] = STATE(217),
    [sym_case_statement] = STATE(217),
    [sym_function_definition] = STATE(217),
    [sym_subshell] = STATE(217),
    [sym_pipeline] = STATE(217),
    [sym_list] = STATE(217),
    [sym_command] = STATE(217),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(218),
    [sym_declaration_command] = STATE(217),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [48] = {
    [anon_sym_in] = ACTIONS(368),
    [anon_sym_SEMI_SEMI] = ACTIONS(370),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(370),
    [anon_sym_LF] = ACTIONS(370),
    [anon_sym_AMP] = ACTIONS(370),
  },
  [49] = {
    [sym_compound_statement] = STATE(221),
    [anon_sym_LPAREN] = ACTIONS(388),
    [anon_sym_LBRACE] = ACTIONS(390),
    [sym_comment] = ACTIONS(48),
  },
  [50] = {
    [sym__assignment] = STATE(34),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(392),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [51] = {
    [sym__terminated_statement] = STATE(223),
    [sym_for_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_subshell] = STATE(37),
    [sym_pipeline] = STATE(37),
    [sym_list] = STATE(37),
    [sym_command] = STATE(37),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(38),
    [sym_declaration_command] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [52] = {
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(394),
  },
  [53] = {
    [sym_variable_assignment] = STATE(79),
    [sym_subscript] = STATE(234),
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(228),
    [sym_simple_expansion] = STATE(228),
    [sym_expansion] = STATE(228),
    [sym_command_substitution] = STATE(228),
    [sym_process_substitution] = STATE(228),
    [aux_sym_declaration_command_repeat1] = STATE(235),
    [sym_variable_name] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(110),
    [anon_sym_RPAREN] = ACTIONS(110),
    [anon_sym_SEMI_SEMI] = ACTIONS(110),
    [anon_sym_PIPE_AMP] = ACTIONS(110),
    [anon_sym_AMP_AMP] = ACTIONS(110),
    [anon_sym_PIPE_PIPE] = ACTIONS(110),
    [sym__special_characters] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [sym_raw_string] = ACTIONS(402),
    [anon_sym_DOLLAR] = ACTIONS(404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(408),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_LT_LPAREN] = ACTIONS(412),
    [anon_sym_GT_LPAREN] = ACTIONS(412),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(130),
    [sym_word] = ACTIONS(402),
    [anon_sym_SEMI] = ACTIONS(110),
    [anon_sym_LF] = ACTIONS(110),
    [anon_sym_AMP] = ACTIONS(110),
  },
  [54] = {
    [aux_sym_concatenation_repeat1] = STATE(237),
    [sym_file_descriptor] = ACTIONS(150),
    [sym__concat] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(154),
    [anon_sym_RPAREN] = ACTIONS(154),
    [anon_sym_SEMI_SEMI] = ACTIONS(154),
    [anon_sym_PIPE_AMP] = ACTIONS(154),
    [anon_sym_AMP_AMP] = ACTIONS(154),
    [anon_sym_PIPE_PIPE] = ACTIONS(154),
    [anon_sym_LT] = ACTIONS(154),
    [anon_sym_GT] = ACTIONS(154),
    [anon_sym_GT_GT] = ACTIONS(154),
    [anon_sym_AMP_GT] = ACTIONS(154),
    [anon_sym_AMP_GT_GT] = ACTIONS(154),
    [anon_sym_LT_AMP] = ACTIONS(154),
    [anon_sym_GT_AMP] = ACTIONS(154),
    [anon_sym_LT_LT] = ACTIONS(154),
    [anon_sym_LT_LT_DASH] = ACTIONS(154),
    [anon_sym_LT_LT_LT] = ACTIONS(154),
    [sym__special_characters] = ACTIONS(154),
    [anon_sym_DQUOTE] = ACTIONS(154),
    [sym_raw_string] = ACTIONS(154),
    [anon_sym_DOLLAR] = ACTIONS(154),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(154),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(154),
    [anon_sym_BQUOTE] = ACTIONS(154),
    [anon_sym_LT_LPAREN] = ACTIONS(154),
    [anon_sym_GT_LPAREN] = ACTIONS(154),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(154),
    [anon_sym_SEMI] = ACTIONS(154),
    [anon_sym_LF] = ACTIONS(154),
    [anon_sym_AMP] = ACTIONS(154),
  },
  [55] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(239),
    [anon_sym_DQUOTE] = ACTIONS(416),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [56] = {
    [aux_sym_concatenation_repeat1] = STATE(237),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(170),
    [anon_sym_RPAREN] = ACTIONS(170),
    [anon_sym_SEMI_SEMI] = ACTIONS(170),
    [anon_sym_PIPE_AMP] = ACTIONS(170),
    [anon_sym_AMP_AMP] = ACTIONS(170),
    [anon_sym_PIPE_PIPE] = ACTIONS(170),
    [anon_sym_LT] = ACTIONS(170),
    [anon_sym_GT] = ACTIONS(170),
    [anon_sym_GT_GT] = ACTIONS(170),
    [anon_sym_AMP_GT] = ACTIONS(170),
    [anon_sym_AMP_GT_GT] = ACTIONS(170),
    [anon_sym_LT_AMP] = ACTIONS(170),
    [anon_sym_GT_AMP] = ACTIONS(170),
    [anon_sym_LT_LT] = ACTIONS(170),
    [anon_sym_LT_LT_DASH] = ACTIONS(170),
    [anon_sym_LT_LT_LT] = ACTIONS(170),
    [sym__special_characters] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(170),
    [sym_raw_string] = ACTIONS(170),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(170),
    [anon_sym_LT_LPAREN] = ACTIONS(170),
    [anon_sym_GT_LPAREN] = ACTIONS(170),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(170),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(170),
  },
  [57] = {
    [sym_string] = STATE(242),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [anon_sym_DOLLAR] = ACTIONS(418),
    [anon_sym_POUND] = ACTIONS(418),
    [anon_sym_DASH] = ACTIONS(418),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(420),
    [anon_sym_STAR] = ACTIONS(418),
    [anon_sym_AT] = ACTIONS(418),
    [anon_sym_QMARK] = ACTIONS(418),
    [anon_sym_0] = ACTIONS(422),
    [anon_sym__] = ACTIONS(422),
  },
  [58] = {
    [sym_subscript] = STATE(247),
    [sym_variable_name] = ACTIONS(424),
    [anon_sym_DOLLAR] = ACTIONS(426),
    [anon_sym_POUND] = ACTIONS(428),
    [anon_sym_DASH] = ACTIONS(426),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(430),
    [anon_sym_STAR] = ACTIONS(426),
    [anon_sym_AT] = ACTIONS(426),
    [anon_sym_QMARK] = ACTIONS(426),
    [anon_sym_0] = ACTIONS(432),
    [anon_sym__] = ACTIONS(432),
  },
  [59] = {
    [sym_for_statement] = STATE(248),
    [sym_while_statement] = STATE(248),
    [sym_if_statement] = STATE(248),
    [sym_case_statement] = STATE(248),
    [sym_function_definition] = STATE(248),
    [sym_subshell] = STATE(248),
    [sym_pipeline] = STATE(248),
    [sym_list] = STATE(248),
    [sym_command] = STATE(248),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(249),
    [sym_declaration_command] = STATE(248),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [60] = {
    [sym_for_statement] = STATE(250),
    [sym_while_statement] = STATE(250),
    [sym_if_statement] = STATE(250),
    [sym_case_statement] = STATE(250),
    [sym_function_definition] = STATE(250),
    [sym_subshell] = STATE(250),
    [sym_pipeline] = STATE(250),
    [sym_list] = STATE(250),
    [sym_command] = STATE(250),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(251),
    [sym_declaration_command] = STATE(250),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [61] = {
    [sym_for_statement] = STATE(252),
    [sym_while_statement] = STATE(252),
    [sym_if_statement] = STATE(252),
    [sym_case_statement] = STATE(252),
    [sym_function_definition] = STATE(252),
    [sym_subshell] = STATE(252),
    [sym_pipeline] = STATE(252),
    [sym_list] = STATE(252),
    [sym_command] = STATE(252),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(253),
    [sym_declaration_command] = STATE(252),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [62] = {
    [aux_sym_concatenation_repeat1] = STATE(237),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(170),
    [anon_sym_RPAREN] = ACTIONS(170),
    [anon_sym_SEMI_SEMI] = ACTIONS(170),
    [anon_sym_LPAREN] = ACTIONS(434),
    [anon_sym_PIPE_AMP] = ACTIONS(170),
    [anon_sym_AMP_AMP] = ACTIONS(170),
    [anon_sym_PIPE_PIPE] = ACTIONS(170),
    [anon_sym_LT] = ACTIONS(170),
    [anon_sym_GT] = ACTIONS(170),
    [anon_sym_GT_GT] = ACTIONS(170),
    [anon_sym_AMP_GT] = ACTIONS(170),
    [anon_sym_AMP_GT_GT] = ACTIONS(170),
    [anon_sym_LT_AMP] = ACTIONS(170),
    [anon_sym_GT_AMP] = ACTIONS(170),
    [anon_sym_LT_LT] = ACTIONS(170),
    [anon_sym_LT_LT_DASH] = ACTIONS(170),
    [anon_sym_LT_LT_LT] = ACTIONS(170),
    [sym__special_characters] = ACTIONS(170),
    [anon_sym_DQUOTE] = ACTIONS(170),
    [sym_raw_string] = ACTIONS(170),
    [anon_sym_DOLLAR] = ACTIONS(170),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(170),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(170),
    [anon_sym_BQUOTE] = ACTIONS(170),
    [anon_sym_LT_LPAREN] = ACTIONS(170),
    [anon_sym_GT_LPAREN] = ACTIONS(170),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(170),
    [anon_sym_SEMI] = ACTIONS(170),
    [anon_sym_LF] = ACTIONS(170),
    [anon_sym_AMP] = ACTIONS(170),
  },
  [63] = {
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI_SEMI] = ACTIONS(440),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(440),
    [anon_sym_LF] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
  },
  [64] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(263),
    [sym_simple_expansion] = STATE(263),
    [sym_expansion] = STATE(263),
    [sym_command_substitution] = STATE(263),
    [sym_process_substitution] = STATE(263),
    [aux_sym_for_statement_repeat1] = STATE(264),
    [aux_sym_while_statement_repeat1] = STATE(265),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(266),
    [anon_sym_RPAREN] = ACTIONS(266),
    [anon_sym_SEMI_SEMI] = ACTIONS(266),
    [anon_sym_PIPE_AMP] = ACTIONS(266),
    [anon_sym_AMP_AMP] = ACTIONS(266),
    [anon_sym_PIPE_PIPE] = ACTIONS(266),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym__special_characters] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(454),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(454),
    [anon_sym_SEMI] = ACTIONS(266),
    [anon_sym_LF] = ACTIONS(266),
    [anon_sym_AMP] = ACTIONS(266),
  },
  [65] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(438),
    [anon_sym_SEMI_SEMI] = ACTIONS(440),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(440),
    [anon_sym_LF] = ACTIONS(440),
    [anon_sym_AMP] = ACTIONS(440),
  },
  [66] = {
    [sym__assignment] = STATE(34),
    [anon_sym_EQ] = ACTIONS(392),
    [anon_sym_PLUS_EQ] = ACTIONS(392),
    [sym_comment] = ACTIONS(48),
  },
  [67] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(266),
    [sym_while_statement] = STATE(266),
    [sym_if_statement] = STATE(266),
    [sym_case_statement] = STATE(266),
    [sym_function_definition] = STATE(266),
    [sym_subshell] = STATE(266),
    [sym_pipeline] = STATE(266),
    [sym_list] = STATE(266),
    [sym_command] = STATE(266),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(267),
    [sym_declaration_command] = STATE(266),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_program_repeat1] = STATE(268),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(84),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(88),
    [anon_sym_typeset] = ACTIONS(88),
    [anon_sym_export] = ACTIONS(88),
    [anon_sym_readonly] = ACTIONS(88),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(90),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(94),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(106),
  },
  [68] = {
    [sym_command_name] = STATE(269),
    [sym_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(168),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(169),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(90),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(94),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(466),
  },
  [69] = {
    [sym__assignment] = STATE(271),
    [anon_sym_EQ] = ACTIONS(468),
    [anon_sym_PLUS_EQ] = ACTIONS(468),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [70] = {
    [aux_sym_concatenation_repeat1] = STATE(273),
    [sym__concat] = ACTIONS(470),
    [sym_variable_name] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [anon_sym_PIPE_AMP] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [sym__special_characters] = ACTIONS(474),
    [anon_sym_DQUOTE] = ACTIONS(474),
    [sym_raw_string] = ACTIONS(474),
    [anon_sym_DOLLAR] = ACTIONS(474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(474),
    [anon_sym_BQUOTE] = ACTIONS(474),
    [anon_sym_LT_LPAREN] = ACTIONS(474),
    [anon_sym_GT_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(474),
    [sym_word] = ACTIONS(474),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [71] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(275),
    [anon_sym_DQUOTE] = ACTIONS(476),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [72] = {
    [aux_sym_concatenation_repeat1] = STATE(273),
    [sym__concat] = ACTIONS(470),
    [sym_variable_name] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(480),
    [anon_sym_SEMI_SEMI] = ACTIONS(480),
    [anon_sym_PIPE_AMP] = ACTIONS(480),
    [anon_sym_AMP_AMP] = ACTIONS(480),
    [anon_sym_PIPE_PIPE] = ACTIONS(480),
    [sym__special_characters] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [sym_raw_string] = ACTIONS(480),
    [anon_sym_DOLLAR] = ACTIONS(480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(480),
    [anon_sym_BQUOTE] = ACTIONS(480),
    [anon_sym_LT_LPAREN] = ACTIONS(480),
    [anon_sym_GT_LPAREN] = ACTIONS(480),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(480),
    [sym_word] = ACTIONS(480),
    [anon_sym_SEMI] = ACTIONS(480),
    [anon_sym_LF] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(480),
  },
  [73] = {
    [sym_string] = STATE(278),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [anon_sym_DOLLAR] = ACTIONS(484),
    [anon_sym_POUND] = ACTIONS(484),
    [anon_sym_DASH] = ACTIONS(484),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(486),
    [anon_sym_STAR] = ACTIONS(484),
    [anon_sym_AT] = ACTIONS(484),
    [anon_sym_QMARK] = ACTIONS(484),
    [anon_sym_0] = ACTIONS(488),
    [anon_sym__] = ACTIONS(488),
  },
  [74] = {
    [sym_subscript] = STATE(283),
    [sym_variable_name] = ACTIONS(490),
    [anon_sym_DOLLAR] = ACTIONS(492),
    [anon_sym_POUND] = ACTIONS(494),
    [anon_sym_DASH] = ACTIONS(492),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(496),
    [anon_sym_STAR] = ACTIONS(492),
    [anon_sym_AT] = ACTIONS(492),
    [anon_sym_QMARK] = ACTIONS(492),
    [anon_sym_0] = ACTIONS(498),
    [anon_sym__] = ACTIONS(498),
  },
  [75] = {
    [sym_for_statement] = STATE(284),
    [sym_while_statement] = STATE(284),
    [sym_if_statement] = STATE(284),
    [sym_case_statement] = STATE(284),
    [sym_function_definition] = STATE(284),
    [sym_subshell] = STATE(284),
    [sym_pipeline] = STATE(284),
    [sym_list] = STATE(284),
    [sym_command] = STATE(284),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(285),
    [sym_declaration_command] = STATE(284),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [76] = {
    [sym_for_statement] = STATE(286),
    [sym_while_statement] = STATE(286),
    [sym_if_statement] = STATE(286),
    [sym_case_statement] = STATE(286),
    [sym_function_definition] = STATE(286),
    [sym_subshell] = STATE(286),
    [sym_pipeline] = STATE(286),
    [sym_list] = STATE(286),
    [sym_command] = STATE(286),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(287),
    [sym_declaration_command] = STATE(286),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [77] = {
    [sym_for_statement] = STATE(288),
    [sym_while_statement] = STATE(288),
    [sym_if_statement] = STATE(288),
    [sym_case_statement] = STATE(288),
    [sym_function_definition] = STATE(288),
    [sym_subshell] = STATE(288),
    [sym_pipeline] = STATE(288),
    [sym_list] = STATE(288),
    [sym_command] = STATE(288),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(289),
    [sym_declaration_command] = STATE(288),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [78] = {
    [sym_variable_name] = ACTIONS(500),
    [anon_sym_PIPE] = ACTIONS(502),
    [anon_sym_RPAREN] = ACTIONS(502),
    [anon_sym_SEMI_SEMI] = ACTIONS(502),
    [anon_sym_PIPE_AMP] = ACTIONS(502),
    [anon_sym_AMP_AMP] = ACTIONS(502),
    [anon_sym_PIPE_PIPE] = ACTIONS(502),
    [sym__special_characters] = ACTIONS(502),
    [anon_sym_DQUOTE] = ACTIONS(502),
    [sym_raw_string] = ACTIONS(502),
    [anon_sym_DOLLAR] = ACTIONS(502),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(502),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(502),
    [anon_sym_BQUOTE] = ACTIONS(502),
    [anon_sym_LT_LPAREN] = ACTIONS(502),
    [anon_sym_GT_LPAREN] = ACTIONS(502),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(502),
    [sym_word] = ACTIONS(502),
    [anon_sym_SEMI] = ACTIONS(502),
    [anon_sym_LF] = ACTIONS(502),
    [anon_sym_AMP] = ACTIONS(502),
  },
  [79] = {
    [sym_variable_name] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(480),
    [anon_sym_RPAREN] = ACTIONS(480),
    [anon_sym_SEMI_SEMI] = ACTIONS(480),
    [anon_sym_PIPE_AMP] = ACTIONS(480),
    [anon_sym_AMP_AMP] = ACTIONS(480),
    [anon_sym_PIPE_PIPE] = ACTIONS(480),
    [sym__special_characters] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [sym_raw_string] = ACTIONS(480),
    [anon_sym_DOLLAR] = ACTIONS(480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(480),
    [anon_sym_BQUOTE] = ACTIONS(480),
    [anon_sym_LT_LPAREN] = ACTIONS(480),
    [anon_sym_GT_LPAREN] = ACTIONS(480),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(480),
    [sym_word] = ACTIONS(480),
    [anon_sym_SEMI] = ACTIONS(480),
    [anon_sym_LF] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(480),
  },
  [80] = {
    [sym__assignment] = STATE(271),
    [anon_sym_EQ] = ACTIONS(468),
    [anon_sym_PLUS_EQ] = ACTIONS(468),
    [sym_comment] = ACTIONS(48),
  },
  [81] = {
    [sym_variable_assignment] = STATE(79),
    [sym_subscript] = STATE(80),
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(72),
    [sym_simple_expansion] = STATE(72),
    [sym_expansion] = STATE(72),
    [sym_command_substitution] = STATE(72),
    [sym_process_substitution] = STATE(72),
    [aux_sym_declaration_command_repeat1] = STATE(290),
    [sym_variable_name] = ACTIONS(108),
    [anon_sym_PIPE] = ACTIONS(504),
    [anon_sym_SEMI_SEMI] = ACTIONS(504),
    [anon_sym_PIPE_AMP] = ACTIONS(504),
    [anon_sym_AMP_AMP] = ACTIONS(504),
    [anon_sym_PIPE_PIPE] = ACTIONS(504),
    [sym__special_characters] = ACTIONS(112),
    [anon_sym_DQUOTE] = ACTIONS(114),
    [sym_raw_string] = ACTIONS(116),
    [anon_sym_DOLLAR] = ACTIONS(118),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(120),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(122),
    [anon_sym_BQUOTE] = ACTIONS(124),
    [anon_sym_LT_LPAREN] = ACTIONS(126),
    [anon_sym_GT_LPAREN] = ACTIONS(126),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(130),
    [sym_word] = ACTIONS(116),
    [anon_sym_SEMI] = ACTIONS(504),
    [anon_sym_LF] = ACTIONS(504),
    [anon_sym_AMP] = ACTIONS(504),
  },
  [82] = {
    [aux_sym_concatenation_repeat1] = STATE(292),
    [sym_file_descriptor] = ACTIONS(506),
    [sym__concat] = ACTIONS(508),
    [sym_variable_name] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_AMP_GT] = ACTIONS(510),
    [anon_sym_AMP_GT_GT] = ACTIONS(506),
    [anon_sym_LT_AMP] = ACTIONS(506),
    [anon_sym_GT_AMP] = ACTIONS(506),
    [sym__special_characters] = ACTIONS(510),
    [anon_sym_DQUOTE] = ACTIONS(506),
    [sym_raw_string] = ACTIONS(506),
    [anon_sym_DOLLAR] = ACTIONS(510),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(506),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [anon_sym_LT_LPAREN] = ACTIONS(506),
    [anon_sym_GT_LPAREN] = ACTIONS(506),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(510),
  },
  [83] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(294),
    [anon_sym_DQUOTE] = ACTIONS(512),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [84] = {
    [aux_sym_concatenation_repeat1] = STATE(292),
    [sym_file_descriptor] = ACTIONS(514),
    [sym__concat] = ACTIONS(508),
    [sym_variable_name] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(514),
    [anon_sym_AMP_GT] = ACTIONS(516),
    [anon_sym_AMP_GT_GT] = ACTIONS(514),
    [anon_sym_LT_AMP] = ACTIONS(514),
    [anon_sym_GT_AMP] = ACTIONS(514),
    [sym__special_characters] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(514),
    [sym_raw_string] = ACTIONS(514),
    [anon_sym_DOLLAR] = ACTIONS(516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(514),
    [anon_sym_BQUOTE] = ACTIONS(514),
    [anon_sym_LT_LPAREN] = ACTIONS(514),
    [anon_sym_GT_LPAREN] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(516),
  },
  [85] = {
    [sym_string] = STATE(297),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [anon_sym_DOLLAR] = ACTIONS(518),
    [anon_sym_POUND] = ACTIONS(518),
    [anon_sym_DASH] = ACTIONS(518),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(520),
    [anon_sym_STAR] = ACTIONS(518),
    [anon_sym_AT] = ACTIONS(518),
    [anon_sym_QMARK] = ACTIONS(518),
    [anon_sym_0] = ACTIONS(522),
    [anon_sym__] = ACTIONS(522),
  },
  [86] = {
    [sym_subscript] = STATE(302),
    [sym_variable_name] = ACTIONS(524),
    [anon_sym_DOLLAR] = ACTIONS(526),
    [anon_sym_POUND] = ACTIONS(528),
    [anon_sym_DASH] = ACTIONS(526),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(530),
    [anon_sym_STAR] = ACTIONS(526),
    [anon_sym_AT] = ACTIONS(526),
    [anon_sym_QMARK] = ACTIONS(526),
    [anon_sym_0] = ACTIONS(532),
    [anon_sym__] = ACTIONS(532),
  },
  [87] = {
    [sym_for_statement] = STATE(303),
    [sym_while_statement] = STATE(303),
    [sym_if_statement] = STATE(303),
    [sym_case_statement] = STATE(303),
    [sym_function_definition] = STATE(303),
    [sym_subshell] = STATE(303),
    [sym_pipeline] = STATE(303),
    [sym_list] = STATE(303),
    [sym_command] = STATE(303),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(304),
    [sym_declaration_command] = STATE(303),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [88] = {
    [sym_for_statement] = STATE(305),
    [sym_while_statement] = STATE(305),
    [sym_if_statement] = STATE(305),
    [sym_case_statement] = STATE(305),
    [sym_function_definition] = STATE(305),
    [sym_subshell] = STATE(305),
    [sym_pipeline] = STATE(305),
    [sym_list] = STATE(305),
    [sym_command] = STATE(305),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(306),
    [sym_declaration_command] = STATE(305),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [89] = {
    [sym_for_statement] = STATE(307),
    [sym_while_statement] = STATE(307),
    [sym_if_statement] = STATE(307),
    [sym_case_statement] = STATE(307),
    [sym_function_definition] = STATE(307),
    [sym_subshell] = STATE(307),
    [sym_pipeline] = STATE(307),
    [sym_list] = STATE(307),
    [sym_command] = STATE(307),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(308),
    [sym_declaration_command] = STATE(307),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [90] = {
    [sym_file_descriptor] = ACTIONS(514),
    [sym_variable_name] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(514),
    [anon_sym_AMP_GT] = ACTIONS(516),
    [anon_sym_AMP_GT_GT] = ACTIONS(514),
    [anon_sym_LT_AMP] = ACTIONS(514),
    [anon_sym_GT_AMP] = ACTIONS(514),
    [sym__special_characters] = ACTIONS(516),
    [anon_sym_DQUOTE] = ACTIONS(514),
    [sym_raw_string] = ACTIONS(514),
    [anon_sym_DOLLAR] = ACTIONS(516),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(514),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(514),
    [anon_sym_BQUOTE] = ACTIONS(514),
    [anon_sym_LT_LPAREN] = ACTIONS(514),
    [anon_sym_GT_LPAREN] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(516),
  },
  [91] = {
    [sym_string] = STATE(309),
    [sym_simple_expansion] = STATE(309),
    [sym_expansion] = STATE(309),
    [sym_command_substitution] = STATE(309),
    [sym_process_substitution] = STATE(309),
    [sym__special_characters] = ACTIONS(534),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(536),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(534),
  },
  [92] = {
    [aux_sym_concatenation_repeat1] = STATE(310),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_AMP_GT] = ACTIONS(540),
    [anon_sym_AMP_GT_GT] = ACTIONS(540),
    [anon_sym_LT_AMP] = ACTIONS(540),
    [anon_sym_GT_AMP] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_LT_LT_DASH] = ACTIONS(540),
    [anon_sym_LT_LT_LT] = ACTIONS(540),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [sym_raw_string] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(540),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(540),
    [anon_sym_GT_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [93] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [anon_sym_LT_LT_LT] = ACTIONS(544),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [94] = {
    [sym__concat] = ACTIONS(546),
    [anon_sym_DQUOTE] = ACTIONS(548),
    [sym__string_content] = ACTIONS(550),
    [anon_sym_DOLLAR] = ACTIONS(548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(548),
    [anon_sym_BQUOTE] = ACTIONS(548),
    [sym_comment] = ACTIONS(128),
  },
  [95] = {
    [sym_string] = STATE(315),
    [anon_sym_DQUOTE] = ACTIONS(552),
    [anon_sym_DOLLAR] = ACTIONS(554),
    [anon_sym_POUND] = ACTIONS(554),
    [anon_sym_DASH] = ACTIONS(554),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(556),
    [anon_sym_STAR] = ACTIONS(554),
    [anon_sym_AT] = ACTIONS(554),
    [anon_sym_QMARK] = ACTIONS(554),
    [anon_sym_0] = ACTIONS(558),
    [anon_sym__] = ACTIONS(558),
  },
  [96] = {
    [sym_subscript] = STATE(320),
    [sym_variable_name] = ACTIONS(560),
    [anon_sym_DOLLAR] = ACTIONS(562),
    [anon_sym_POUND] = ACTIONS(564),
    [anon_sym_DASH] = ACTIONS(562),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(566),
    [anon_sym_STAR] = ACTIONS(562),
    [anon_sym_AT] = ACTIONS(562),
    [anon_sym_QMARK] = ACTIONS(562),
    [anon_sym_0] = ACTIONS(568),
    [anon_sym__] = ACTIONS(568),
  },
  [97] = {
    [sym_for_statement] = STATE(321),
    [sym_while_statement] = STATE(321),
    [sym_if_statement] = STATE(321),
    [sym_case_statement] = STATE(321),
    [sym_function_definition] = STATE(321),
    [sym_subshell] = STATE(321),
    [sym_pipeline] = STATE(321),
    [sym_list] = STATE(321),
    [sym_command] = STATE(321),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(322),
    [sym_declaration_command] = STATE(321),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [98] = {
    [sym_for_statement] = STATE(323),
    [sym_while_statement] = STATE(323),
    [sym_if_statement] = STATE(323),
    [sym_case_statement] = STATE(323),
    [sym_function_definition] = STATE(323),
    [sym_subshell] = STATE(323),
    [sym_pipeline] = STATE(323),
    [sym_list] = STATE(323),
    [sym_command] = STATE(323),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(324),
    [sym_declaration_command] = STATE(323),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [99] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(570),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [100] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_LT_LT] = ACTIONS(574),
    [anon_sym_LT_LT_DASH] = ACTIONS(574),
    [anon_sym_LT_LT_LT] = ACTIONS(574),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [101] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_GT] = ACTIONS(578),
    [anon_sym_AMP_GT_GT] = ACTIONS(578),
    [anon_sym_LT_AMP] = ACTIONS(578),
    [anon_sym_GT_AMP] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_LT_LT_DASH] = ACTIONS(578),
    [anon_sym_LT_LT_LT] = ACTIONS(578),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [anon_sym_LT_LPAREN] = ACTIONS(578),
    [anon_sym_GT_LPAREN] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [102] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT_LT_DASH] = ACTIONS(582),
    [anon_sym_LT_LT_LT] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [103] = {
    [anon_sym_EQ] = ACTIONS(584),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [104] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(339),
    [anon_sym_RBRACE] = ACTIONS(588),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [105] = {
    [sym_subscript] = STATE(343),
    [sym_variable_name] = ACTIONS(612),
    [anon_sym_DOLLAR] = ACTIONS(614),
    [anon_sym_DASH] = ACTIONS(614),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(616),
    [anon_sym_STAR] = ACTIONS(614),
    [anon_sym_AT] = ACTIONS(614),
    [anon_sym_QMARK] = ACTIONS(614),
    [anon_sym_0] = ACTIONS(618),
    [anon_sym__] = ACTIONS(618),
  },
  [106] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(345),
    [anon_sym_RBRACE] = ACTIONS(620),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [107] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(347),
    [anon_sym_RBRACE] = ACTIONS(622),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [108] = {
    [sym__assignment] = STATE(349),
    [anon_sym_EQ] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(624),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [109] = {
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(626),
  },
  [110] = {
    [sym__terminated_statement] = STATE(351),
    [sym_for_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_subshell] = STATE(37),
    [sym_pipeline] = STATE(37),
    [sym_list] = STATE(37),
    [sym_command] = STATE(37),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(38),
    [sym_declaration_command] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [111] = {
    [sym__terminated_statement] = STATE(352),
    [sym_for_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_subshell] = STATE(37),
    [sym_pipeline] = STATE(37),
    [sym_list] = STATE(37),
    [sym_command] = STATE(37),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(38),
    [sym_declaration_command] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [112] = {
    [sym_concatenation] = STATE(355),
    [sym_string] = STATE(354),
    [sym_simple_expansion] = STATE(354),
    [sym_expansion] = STATE(354),
    [sym_command_substitution] = STATE(354),
    [sym_process_substitution] = STATE(354),
    [sym__special_characters] = ACTIONS(628),
    [anon_sym_DQUOTE] = ACTIONS(64),
    [sym_raw_string] = ACTIONS(630),
    [anon_sym_DOLLAR] = ACTIONS(68),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(70),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(72),
    [anon_sym_BQUOTE] = ACTIONS(74),
    [anon_sym_LT_LPAREN] = ACTIONS(76),
    [anon_sym_GT_LPAREN] = ACTIONS(76),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(632),
  },
  [113] = {
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(634),
  },
  [114] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(357),
    [sym_while_statement] = STATE(357),
    [sym_if_statement] = STATE(357),
    [sym_case_statement] = STATE(357),
    [sym_function_definition] = STATE(357),
    [sym_subshell] = STATE(357),
    [sym_pipeline] = STATE(357),
    [sym_list] = STATE(357),
    [sym_command] = STATE(357),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(358),
    [sym_declaration_command] = STATE(357),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_program_repeat1] = STATE(359),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(84),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(88),
    [anon_sym_typeset] = ACTIONS(88),
    [anon_sym_export] = ACTIONS(88),
    [anon_sym_readonly] = ACTIONS(88),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(90),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(94),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(106),
  },
  [115] = {
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(371),
    [sym_concatenation] = STATE(370),
    [sym_string] = STATE(363),
    [sym_simple_expansion] = STATE(363),
    [sym_expansion] = STATE(363),
    [sym_command_substitution] = STATE(363),
    [sym_process_substitution] = STATE(363),
    [aux_sym_declaration_command_repeat1] = STATE(372),
    [sym_variable_name] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_RPAREN] = ACTIONS(640),
    [anon_sym_PIPE_AMP] = ACTIONS(640),
    [anon_sym_AMP_AMP] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [sym__special_characters] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_LT_LPAREN] = ACTIONS(656),
    [anon_sym_GT_LPAREN] = ACTIONS(656),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(658),
    [sym_word] = ACTIONS(660),
  },
  [116] = {
    [aux_sym_concatenation_repeat1] = STATE(374),
    [sym_file_descriptor] = ACTIONS(150),
    [sym__concat] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_RPAREN] = ACTIONS(150),
    [anon_sym_PIPE_AMP] = ACTIONS(150),
    [anon_sym_AMP_AMP] = ACTIONS(150),
    [anon_sym_PIPE_PIPE] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(150),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(150),
    [anon_sym_LT_AMP] = ACTIONS(150),
    [anon_sym_GT_AMP] = ACTIONS(150),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(150),
    [anon_sym_LT_LT_LT] = ACTIONS(150),
    [sym__special_characters] = ACTIONS(664),
    [anon_sym_DQUOTE] = ACTIONS(150),
    [sym_raw_string] = ACTIONS(150),
    [anon_sym_DOLLAR] = ACTIONS(664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(150),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_LT_LPAREN] = ACTIONS(150),
    [anon_sym_GT_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(664),
  },
  [117] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(376),
    [anon_sym_DQUOTE] = ACTIONS(666),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [118] = {
    [aux_sym_concatenation_repeat1] = STATE(374),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(168),
    [anon_sym_PIPE_AMP] = ACTIONS(168),
    [anon_sym_AMP_AMP] = ACTIONS(168),
    [anon_sym_PIPE_PIPE] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(168),
    [anon_sym_AMP_GT] = ACTIONS(668),
    [anon_sym_AMP_GT_GT] = ACTIONS(168),
    [anon_sym_LT_AMP] = ACTIONS(168),
    [anon_sym_GT_AMP] = ACTIONS(168),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_LT_LT_DASH] = ACTIONS(168),
    [anon_sym_LT_LT_LT] = ACTIONS(168),
    [sym__special_characters] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_raw_string] = ACTIONS(168),
    [anon_sym_DOLLAR] = ACTIONS(668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(168),
    [anon_sym_BQUOTE] = ACTIONS(168),
    [anon_sym_LT_LPAREN] = ACTIONS(168),
    [anon_sym_GT_LPAREN] = ACTIONS(168),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(668),
  },
  [119] = {
    [sym_string] = STATE(379),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [anon_sym_DOLLAR] = ACTIONS(670),
    [anon_sym_POUND] = ACTIONS(670),
    [anon_sym_DASH] = ACTIONS(670),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(672),
    [anon_sym_STAR] = ACTIONS(670),
    [anon_sym_AT] = ACTIONS(670),
    [anon_sym_QMARK] = ACTIONS(670),
    [anon_sym_0] = ACTIONS(674),
    [anon_sym__] = ACTIONS(674),
  },
  [120] = {
    [sym_subscript] = STATE(384),
    [sym_variable_name] = ACTIONS(676),
    [anon_sym_DOLLAR] = ACTIONS(678),
    [anon_sym_POUND] = ACTIONS(680),
    [anon_sym_DASH] = ACTIONS(678),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(682),
    [anon_sym_STAR] = ACTIONS(678),
    [anon_sym_AT] = ACTIONS(678),
    [anon_sym_QMARK] = ACTIONS(678),
    [anon_sym_0] = ACTIONS(684),
    [anon_sym__] = ACTIONS(684),
  },
  [121] = {
    [sym_for_statement] = STATE(385),
    [sym_while_statement] = STATE(385),
    [sym_if_statement] = STATE(385),
    [sym_case_statement] = STATE(385),
    [sym_function_definition] = STATE(385),
    [sym_subshell] = STATE(385),
    [sym_pipeline] = STATE(385),
    [sym_list] = STATE(385),
    [sym_command] = STATE(385),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(386),
    [sym_declaration_command] = STATE(385),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [122] = {
    [sym_for_statement] = STATE(387),
    [sym_while_statement] = STATE(387),
    [sym_if_statement] = STATE(387),
    [sym_case_statement] = STATE(387),
    [sym_function_definition] = STATE(387),
    [sym_subshell] = STATE(387),
    [sym_pipeline] = STATE(387),
    [sym_list] = STATE(387),
    [sym_command] = STATE(387),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(388),
    [sym_declaration_command] = STATE(387),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [123] = {
    [sym_for_statement] = STATE(389),
    [sym_while_statement] = STATE(389),
    [sym_if_statement] = STATE(389),
    [sym_case_statement] = STATE(389),
    [sym_function_definition] = STATE(389),
    [sym_subshell] = STATE(389),
    [sym_pipeline] = STATE(389),
    [sym_list] = STATE(389),
    [sym_command] = STATE(389),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(390),
    [sym_declaration_command] = STATE(389),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [124] = {
    [aux_sym_concatenation_repeat1] = STATE(374),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(168),
    [anon_sym_LPAREN] = ACTIONS(686),
    [anon_sym_PIPE_AMP] = ACTIONS(168),
    [anon_sym_AMP_AMP] = ACTIONS(168),
    [anon_sym_PIPE_PIPE] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(168),
    [anon_sym_AMP_GT] = ACTIONS(668),
    [anon_sym_AMP_GT_GT] = ACTIONS(168),
    [anon_sym_LT_AMP] = ACTIONS(168),
    [anon_sym_GT_AMP] = ACTIONS(168),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_LT_LT_DASH] = ACTIONS(168),
    [anon_sym_LT_LT_LT] = ACTIONS(168),
    [sym__special_characters] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_raw_string] = ACTIONS(168),
    [anon_sym_DOLLAR] = ACTIONS(668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(168),
    [anon_sym_BQUOTE] = ACTIONS(168),
    [anon_sym_LT_LPAREN] = ACTIONS(168),
    [anon_sym_GT_LPAREN] = ACTIONS(168),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(668),
  },
  [125] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [126] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(403),
    [aux_sym_while_statement_repeat1] = STATE(404),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_RPAREN] = ACTIONS(700),
    [anon_sym_PIPE_AMP] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym__special_characters] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(716),
  },
  [127] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(690),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [128] = {
    [sym__assignment] = STATE(349),
    [anon_sym_EQ] = ACTIONS(624),
    [anon_sym_PLUS_EQ] = ACTIONS(624),
    [sym_comment] = ACTIONS(48),
  },
  [129] = {
    [sym_file_descriptor] = ACTIONS(168),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_RPAREN] = ACTIONS(168),
    [anon_sym_PIPE_AMP] = ACTIONS(168),
    [anon_sym_AMP_AMP] = ACTIONS(168),
    [anon_sym_PIPE_PIPE] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(168),
    [anon_sym_AMP_GT] = ACTIONS(668),
    [anon_sym_AMP_GT_GT] = ACTIONS(168),
    [anon_sym_LT_AMP] = ACTIONS(168),
    [anon_sym_GT_AMP] = ACTIONS(168),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_LT_LT_DASH] = ACTIONS(168),
    [anon_sym_LT_LT_LT] = ACTIONS(168),
    [sym__special_characters] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_raw_string] = ACTIONS(168),
    [anon_sym_DOLLAR] = ACTIONS(668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(168),
    [anon_sym_BQUOTE] = ACTIONS(168),
    [anon_sym_LT_LPAREN] = ACTIONS(168),
    [anon_sym_GT_LPAREN] = ACTIONS(168),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(668),
  },
  [130] = {
    [sym_command_name] = STATE(405),
    [sym_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(168),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(169),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(718),
  },
  [131] = {
    [sym__assignment] = STATE(349),
    [anon_sym_EQ] = ACTIONS(720),
    [anon_sym_PLUS_EQ] = ACTIONS(720),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [132] = {
    [sym__terminated_statement] = STATE(407),
    [sym_for_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_subshell] = STATE(37),
    [sym_pipeline] = STATE(37),
    [sym_list] = STATE(37),
    [sym_command] = STATE(37),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(38),
    [sym_declaration_command] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [133] = {
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(722),
  },
  [134] = {
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(418),
    [sym_concatenation] = STATE(370),
    [sym_string] = STATE(412),
    [sym_simple_expansion] = STATE(412),
    [sym_expansion] = STATE(412),
    [sym_command_substitution] = STATE(412),
    [sym_process_substitution] = STATE(412),
    [aux_sym_declaration_command_repeat1] = STATE(419),
    [sym_variable_name] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(638),
    [anon_sym_PIPE_AMP] = ACTIONS(640),
    [anon_sym_AMP_AMP] = ACTIONS(640),
    [anon_sym_PIPE_PIPE] = ACTIONS(640),
    [sym__special_characters] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(640),
    [anon_sym_LT_LPAREN] = ACTIONS(738),
    [anon_sym_GT_LPAREN] = ACTIONS(738),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(658),
    [sym_word] = ACTIONS(740),
  },
  [135] = {
    [aux_sym_concatenation_repeat1] = STATE(421),
    [sym_file_descriptor] = ACTIONS(150),
    [sym__concat] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(664),
    [anon_sym_PIPE_AMP] = ACTIONS(150),
    [anon_sym_AMP_AMP] = ACTIONS(150),
    [anon_sym_PIPE_PIPE] = ACTIONS(150),
    [anon_sym_LT] = ACTIONS(664),
    [anon_sym_GT] = ACTIONS(664),
    [anon_sym_GT_GT] = ACTIONS(150),
    [anon_sym_AMP_GT] = ACTIONS(664),
    [anon_sym_AMP_GT_GT] = ACTIONS(150),
    [anon_sym_LT_AMP] = ACTIONS(150),
    [anon_sym_GT_AMP] = ACTIONS(150),
    [anon_sym_LT_LT] = ACTIONS(664),
    [anon_sym_LT_LT_DASH] = ACTIONS(150),
    [anon_sym_LT_LT_LT] = ACTIONS(150),
    [sym__special_characters] = ACTIONS(664),
    [anon_sym_DQUOTE] = ACTIONS(150),
    [sym_raw_string] = ACTIONS(150),
    [anon_sym_DOLLAR] = ACTIONS(664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(150),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(150),
    [anon_sym_BQUOTE] = ACTIONS(150),
    [anon_sym_LT_LPAREN] = ACTIONS(150),
    [anon_sym_GT_LPAREN] = ACTIONS(150),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(664),
  },
  [136] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(423),
    [anon_sym_DQUOTE] = ACTIONS(744),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [137] = {
    [aux_sym_concatenation_repeat1] = STATE(421),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_PIPE_AMP] = ACTIONS(168),
    [anon_sym_AMP_AMP] = ACTIONS(168),
    [anon_sym_PIPE_PIPE] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(168),
    [anon_sym_AMP_GT] = ACTIONS(668),
    [anon_sym_AMP_GT_GT] = ACTIONS(168),
    [anon_sym_LT_AMP] = ACTIONS(168),
    [anon_sym_GT_AMP] = ACTIONS(168),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_LT_LT_DASH] = ACTIONS(168),
    [anon_sym_LT_LT_LT] = ACTIONS(168),
    [sym__special_characters] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_raw_string] = ACTIONS(168),
    [anon_sym_DOLLAR] = ACTIONS(668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(168),
    [anon_sym_BQUOTE] = ACTIONS(168),
    [anon_sym_LT_LPAREN] = ACTIONS(168),
    [anon_sym_GT_LPAREN] = ACTIONS(168),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(668),
  },
  [138] = {
    [sym_string] = STATE(426),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [anon_sym_DOLLAR] = ACTIONS(746),
    [anon_sym_POUND] = ACTIONS(746),
    [anon_sym_DASH] = ACTIONS(746),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(748),
    [anon_sym_STAR] = ACTIONS(746),
    [anon_sym_AT] = ACTIONS(746),
    [anon_sym_QMARK] = ACTIONS(746),
    [anon_sym_0] = ACTIONS(750),
    [anon_sym__] = ACTIONS(750),
  },
  [139] = {
    [sym_subscript] = STATE(431),
    [sym_variable_name] = ACTIONS(752),
    [anon_sym_DOLLAR] = ACTIONS(754),
    [anon_sym_POUND] = ACTIONS(756),
    [anon_sym_DASH] = ACTIONS(754),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(758),
    [anon_sym_STAR] = ACTIONS(754),
    [anon_sym_AT] = ACTIONS(754),
    [anon_sym_QMARK] = ACTIONS(754),
    [anon_sym_0] = ACTIONS(760),
    [anon_sym__] = ACTIONS(760),
  },
  [140] = {
    [sym_for_statement] = STATE(432),
    [sym_while_statement] = STATE(432),
    [sym_if_statement] = STATE(432),
    [sym_case_statement] = STATE(432),
    [sym_function_definition] = STATE(432),
    [sym_subshell] = STATE(432),
    [sym_pipeline] = STATE(432),
    [sym_list] = STATE(432),
    [sym_command] = STATE(432),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(433),
    [sym_declaration_command] = STATE(432),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [141] = {
    [sym_for_statement] = STATE(434),
    [sym_while_statement] = STATE(434),
    [sym_if_statement] = STATE(434),
    [sym_case_statement] = STATE(434),
    [sym_function_definition] = STATE(434),
    [sym_subshell] = STATE(434),
    [sym_pipeline] = STATE(434),
    [sym_list] = STATE(434),
    [sym_command] = STATE(434),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(435),
    [sym_declaration_command] = STATE(434),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [142] = {
    [sym_for_statement] = STATE(436),
    [sym_while_statement] = STATE(436),
    [sym_if_statement] = STATE(436),
    [sym_case_statement] = STATE(436),
    [sym_function_definition] = STATE(436),
    [sym_subshell] = STATE(436),
    [sym_pipeline] = STATE(436),
    [sym_list] = STATE(436),
    [sym_command] = STATE(436),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(437),
    [sym_declaration_command] = STATE(436),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [143] = {
    [aux_sym_concatenation_repeat1] = STATE(421),
    [sym_file_descriptor] = ACTIONS(168),
    [sym__concat] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(668),
    [anon_sym_LPAREN] = ACTIONS(762),
    [anon_sym_PIPE_AMP] = ACTIONS(168),
    [anon_sym_AMP_AMP] = ACTIONS(168),
    [anon_sym_PIPE_PIPE] = ACTIONS(168),
    [anon_sym_LT] = ACTIONS(668),
    [anon_sym_GT] = ACTIONS(668),
    [anon_sym_GT_GT] = ACTIONS(168),
    [anon_sym_AMP_GT] = ACTIONS(668),
    [anon_sym_AMP_GT_GT] = ACTIONS(168),
    [anon_sym_LT_AMP] = ACTIONS(168),
    [anon_sym_GT_AMP] = ACTIONS(168),
    [anon_sym_LT_LT] = ACTIONS(668),
    [anon_sym_LT_LT_DASH] = ACTIONS(168),
    [anon_sym_LT_LT_LT] = ACTIONS(168),
    [sym__special_characters] = ACTIONS(668),
    [anon_sym_DQUOTE] = ACTIONS(168),
    [sym_raw_string] = ACTIONS(168),
    [anon_sym_DOLLAR] = ACTIONS(668),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(168),
    [anon_sym_BQUOTE] = ACTIONS(168),
    [anon_sym_LT_LPAREN] = ACTIONS(168),
    [anon_sym_GT_LPAREN] = ACTIONS(168),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(668),
  },
  [144] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [sym_comment] = ACTIONS(48),
  },
  [145] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(445),
    [sym_simple_expansion] = STATE(445),
    [sym_expansion] = STATE(445),
    [sym_command_substitution] = STATE(445),
    [sym_process_substitution] = STATE(445),
    [aux_sym_for_statement_repeat1] = STATE(446),
    [aux_sym_while_statement_repeat1] = STATE(447),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(698),
    [anon_sym_PIPE_AMP] = ACTIONS(700),
    [anon_sym_AMP_AMP] = ACTIONS(700),
    [anon_sym_PIPE_PIPE] = ACTIONS(700),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [sym__special_characters] = ACTIONS(778),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(780),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(700),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(782),
  },
  [146] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(690),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [147] = {
    [sym__assignment] = STATE(349),
    [anon_sym_EQ] = ACTIONS(720),
    [anon_sym_PLUS_EQ] = ACTIONS(720),
    [sym_comment] = ACTIONS(48),
  },
  [148] = {
    [sym_command_name] = STATE(448),
    [sym_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(168),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(169),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(298),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(784),
  },
  [149] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(786),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [150] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(786),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [151] = {
    [anon_sym_RPAREN] = ACTIONS(788),
    [sym_comment] = ACTIONS(48),
  },
  [152] = {
    [sym_for_statement] = STATE(451),
    [sym_while_statement] = STATE(451),
    [sym_if_statement] = STATE(451),
    [sym_case_statement] = STATE(451),
    [sym_function_definition] = STATE(451),
    [sym_subshell] = STATE(451),
    [sym_pipeline] = STATE(451),
    [sym_list] = STATE(451),
    [sym_command] = STATE(451),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(452),
    [sym_declaration_command] = STATE(451),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [153] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [ts_builtin_sym_end] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_SEMI_SEMI] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [154] = {
    [sym_for_statement] = STATE(453),
    [sym_while_statement] = STATE(453),
    [sym_if_statement] = STATE(453),
    [sym_case_statement] = STATE(453),
    [sym_function_definition] = STATE(453),
    [sym_subshell] = STATE(453),
    [sym_pipeline] = STATE(453),
    [sym_list] = STATE(453),
    [sym_command] = STATE(453),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(454),
    [sym_declaration_command] = STATE(453),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [155] = {
    [anon_sym_LT] = ACTIONS(796),
    [anon_sym_GT] = ACTIONS(796),
    [anon_sym_GT_GT] = ACTIONS(798),
    [anon_sym_AMP_GT] = ACTIONS(796),
    [anon_sym_AMP_GT_GT] = ACTIONS(798),
    [anon_sym_LT_AMP] = ACTIONS(798),
    [anon_sym_GT_AMP] = ACTIONS(798),
    [sym_comment] = ACTIONS(48),
  },
  [156] = {
    [sym_concatenation] = STATE(464),
    [sym_string] = STATE(458),
    [sym_simple_expansion] = STATE(458),
    [sym_expansion] = STATE(458),
    [sym_command_substitution] = STATE(458),
    [sym_process_substitution] = STATE(458),
    [sym__special_characters] = ACTIONS(800),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [sym_raw_string] = ACTIONS(804),
    [anon_sym_DOLLAR] = ACTIONS(806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(810),
    [anon_sym_BQUOTE] = ACTIONS(812),
    [anon_sym_LT_LPAREN] = ACTIONS(814),
    [anon_sym_GT_LPAREN] = ACTIONS(814),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(816),
  },
  [157] = {
    [sym_heredoc] = STATE(467),
    [sym__simple_heredoc] = ACTIONS(818),
    [sym__heredoc_beginning] = ACTIONS(820),
    [sym_comment] = ACTIONS(48),
  },
  [158] = {
    [sym_concatenation] = STATE(470),
    [sym_string] = STATE(469),
    [sym_simple_expansion] = STATE(469),
    [sym_expansion] = STATE(469),
    [sym_command_substitution] = STATE(469),
    [sym_process_substitution] = STATE(469),
    [sym__special_characters] = ACTIONS(822),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [sym_raw_string] = ACTIONS(824),
    [anon_sym_DOLLAR] = ACTIONS(806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(810),
    [anon_sym_BQUOTE] = ACTIONS(812),
    [anon_sym_LT_LPAREN] = ACTIONS(814),
    [anon_sym_GT_LPAREN] = ACTIONS(814),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(826),
  },
  [159] = {
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(828),
    [sym__concat] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(830),
    [anon_sym_SEMI_SEMI] = ACTIONS(830),
    [anon_sym_PIPE_AMP] = ACTIONS(830),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_LT] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(830),
    [anon_sym_GT_GT] = ACTIONS(830),
    [anon_sym_AMP_GT] = ACTIONS(830),
    [anon_sym_AMP_GT_GT] = ACTIONS(830),
    [anon_sym_LT_AMP] = ACTIONS(830),
    [anon_sym_GT_AMP] = ACTIONS(830),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LT_LT_DASH] = ACTIONS(830),
    [anon_sym_LT_LT_LT] = ACTIONS(830),
    [sym__special_characters] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(830),
    [sym_raw_string] = ACTIONS(830),
    [anon_sym_DOLLAR] = ACTIONS(830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_LT_LPAREN] = ACTIONS(830),
    [anon_sym_GT_LPAREN] = ACTIONS(830),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_LF] = ACTIONS(830),
    [anon_sym_AMP] = ACTIONS(830),
  },
  [160] = {
    [aux_sym_concatenation_repeat1] = STATE(92),
    [sym_file_descriptor] = ACTIONS(832),
    [sym__concat] = ACTIONS(152),
    [anon_sym_PIPE] = ACTIONS(834),
    [anon_sym_SEMI_SEMI] = ACTIONS(834),
    [anon_sym_PIPE_AMP] = ACTIONS(834),
    [anon_sym_AMP_AMP] = ACTIONS(834),
    [anon_sym_PIPE_PIPE] = ACTIONS(834),
    [anon_sym_LT] = ACTIONS(834),
    [anon_sym_GT] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(834),
    [anon_sym_AMP_GT] = ACTIONS(834),
    [anon_sym_AMP_GT_GT] = ACTIONS(834),
    [anon_sym_LT_AMP] = ACTIONS(834),
    [anon_sym_GT_AMP] = ACTIONS(834),
    [anon_sym_LT_LT] = ACTIONS(834),
    [anon_sym_LT_LT_DASH] = ACTIONS(834),
    [anon_sym_LT_LT_LT] = ACTIONS(834),
    [sym__special_characters] = ACTIONS(834),
    [anon_sym_DQUOTE] = ACTIONS(834),
    [sym_raw_string] = ACTIONS(834),
    [anon_sym_DOLLAR] = ACTIONS(834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(834),
    [anon_sym_LT_LPAREN] = ACTIONS(834),
    [anon_sym_GT_LPAREN] = ACTIONS(834),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_LF] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
  },
  [161] = {
    [sym_file_descriptor] = ACTIONS(836),
    [anon_sym_PIPE] = ACTIONS(838),
    [anon_sym_RPAREN] = ACTIONS(838),
    [anon_sym_SEMI_SEMI] = ACTIONS(838),
    [anon_sym_PIPE_AMP] = ACTIONS(838),
    [anon_sym_AMP_AMP] = ACTIONS(838),
    [anon_sym_PIPE_PIPE] = ACTIONS(838),
    [anon_sym_LT] = ACTIONS(838),
    [anon_sym_GT] = ACTIONS(838),
    [anon_sym_GT_GT] = ACTIONS(838),
    [anon_sym_AMP_GT] = ACTIONS(838),
    [anon_sym_AMP_GT_GT] = ACTIONS(838),
    [anon_sym_LT_AMP] = ACTIONS(838),
    [anon_sym_GT_AMP] = ACTIONS(838),
    [anon_sym_LT_LT] = ACTIONS(838),
    [anon_sym_LT_LT_DASH] = ACTIONS(838),
    [anon_sym_LT_LT_LT] = ACTIONS(838),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(838),
    [anon_sym_LF] = ACTIONS(838),
    [anon_sym_AMP] = ACTIONS(838),
  },
  [162] = {
    [sym_file_descriptor] = ACTIONS(832),
    [anon_sym_PIPE] = ACTIONS(834),
    [anon_sym_RPAREN] = ACTIONS(834),
    [anon_sym_SEMI_SEMI] = ACTIONS(834),
    [anon_sym_PIPE_AMP] = ACTIONS(834),
    [anon_sym_AMP_AMP] = ACTIONS(834),
    [anon_sym_PIPE_PIPE] = ACTIONS(834),
    [anon_sym_LT] = ACTIONS(834),
    [anon_sym_GT] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(834),
    [anon_sym_AMP_GT] = ACTIONS(834),
    [anon_sym_AMP_GT_GT] = ACTIONS(834),
    [anon_sym_LT_AMP] = ACTIONS(834),
    [anon_sym_GT_AMP] = ACTIONS(834),
    [anon_sym_LT_LT] = ACTIONS(834),
    [anon_sym_LT_LT_DASH] = ACTIONS(834),
    [anon_sym_LT_LT_LT] = ACTIONS(834),
    [sym__special_characters] = ACTIONS(834),
    [anon_sym_DQUOTE] = ACTIONS(834),
    [sym_raw_string] = ACTIONS(834),
    [anon_sym_DOLLAR] = ACTIONS(834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(834),
    [anon_sym_LT_LPAREN] = ACTIONS(834),
    [anon_sym_GT_LPAREN] = ACTIONS(834),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_LF] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
  },
  [163] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_command_substitution] = STATE(160),
    [sym_process_substitution] = STATE(160),
    [aux_sym_for_statement_repeat1] = STATE(471),
    [aux_sym_while_statement_repeat1] = STATE(472),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [164] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(473),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [165] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(165),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [ts_builtin_sym_end] = ACTIONS(848),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [166] = {
    [sym__assignment] = STATE(349),
    [anon_sym_EQ] = ACTIONS(904),
    [anon_sym_PLUS_EQ] = ACTIONS(904),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [167] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_command_substitution] = STATE(160),
    [sym_process_substitution] = STATE(160),
    [aux_sym_for_statement_repeat1] = STATE(475),
    [aux_sym_while_statement_repeat1] = STATE(472),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [168] = {
    [sym__assignment] = STATE(349),
    [anon_sym_EQ] = ACTIONS(904),
    [anon_sym_PLUS_EQ] = ACTIONS(904),
    [sym_comment] = ACTIONS(48),
  },
  [169] = {
    [sym_variable_assignment] = STATE(27),
    [sym_subscript] = STATE(168),
    [sym_file_redirect] = STATE(27),
    [aux_sym_command_repeat1] = STATE(169),
    [sym_file_descriptor] = ACTIONS(906),
    [sym_variable_name] = ACTIONS(909),
    [anon_sym_LT] = ACTIONS(912),
    [anon_sym_GT] = ACTIONS(912),
    [anon_sym_GT_GT] = ACTIONS(915),
    [anon_sym_AMP_GT] = ACTIONS(912),
    [anon_sym_AMP_GT_GT] = ACTIONS(915),
    [anon_sym_LT_AMP] = ACTIONS(915),
    [anon_sym_GT_AMP] = ACTIONS(915),
    [sym__special_characters] = ACTIONS(918),
    [anon_sym_DQUOTE] = ACTIONS(920),
    [sym_raw_string] = ACTIONS(920),
    [anon_sym_DOLLAR] = ACTIONS(918),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(920),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(920),
    [anon_sym_BQUOTE] = ACTIONS(920),
    [anon_sym_LT_LPAREN] = ACTIONS(920),
    [anon_sym_GT_LPAREN] = ACTIONS(920),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(918),
  },
  [170] = {
    [aux_sym_concatenation_repeat1] = STATE(292),
    [sym_file_descriptor] = ACTIONS(922),
    [sym__concat] = ACTIONS(508),
    [sym_variable_name] = ACTIONS(922),
    [anon_sym_LT] = ACTIONS(924),
    [anon_sym_GT] = ACTIONS(924),
    [anon_sym_GT_GT] = ACTIONS(922),
    [anon_sym_AMP_GT] = ACTIONS(924),
    [anon_sym_AMP_GT_GT] = ACTIONS(922),
    [anon_sym_LT_AMP] = ACTIONS(922),
    [anon_sym_GT_AMP] = ACTIONS(922),
    [sym__special_characters] = ACTIONS(924),
    [anon_sym_DQUOTE] = ACTIONS(922),
    [sym_raw_string] = ACTIONS(922),
    [anon_sym_DOLLAR] = ACTIONS(924),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(922),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(922),
    [anon_sym_BQUOTE] = ACTIONS(922),
    [anon_sym_LT_LPAREN] = ACTIONS(922),
    [anon_sym_GT_LPAREN] = ACTIONS(922),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(924),
  },
  [171] = {
    [aux_sym_concatenation_repeat1] = STATE(292),
    [sym_file_descriptor] = ACTIONS(926),
    [sym__concat] = ACTIONS(508),
    [sym_variable_name] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [anon_sym_GT] = ACTIONS(928),
    [anon_sym_GT_GT] = ACTIONS(926),
    [anon_sym_AMP_GT] = ACTIONS(928),
    [anon_sym_AMP_GT_GT] = ACTIONS(926),
    [anon_sym_LT_AMP] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(926),
    [sym__special_characters] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(926),
    [sym_raw_string] = ACTIONS(926),
    [anon_sym_DOLLAR] = ACTIONS(928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(926),
    [anon_sym_LT_LPAREN] = ACTIONS(926),
    [anon_sym_GT_LPAREN] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(928),
  },
  [172] = {
    [sym_file_descriptor] = ACTIONS(926),
    [sym_variable_name] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [anon_sym_GT] = ACTIONS(928),
    [anon_sym_GT_GT] = ACTIONS(926),
    [anon_sym_AMP_GT] = ACTIONS(928),
    [anon_sym_AMP_GT_GT] = ACTIONS(926),
    [anon_sym_LT_AMP] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(926),
    [sym__special_characters] = ACTIONS(928),
    [anon_sym_DQUOTE] = ACTIONS(926),
    [sym_raw_string] = ACTIONS(926),
    [anon_sym_DOLLAR] = ACTIONS(928),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(926),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(926),
    [anon_sym_LT_LPAREN] = ACTIONS(926),
    [anon_sym_GT_LPAREN] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(928),
  },
  [173] = {
    [sym_file_descriptor] = ACTIONS(930),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(932),
    [anon_sym_RPAREN] = ACTIONS(932),
    [anon_sym_SEMI_SEMI] = ACTIONS(932),
    [anon_sym_PIPE_AMP] = ACTIONS(932),
    [anon_sym_AMP_AMP] = ACTIONS(932),
    [anon_sym_PIPE_PIPE] = ACTIONS(932),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(932),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(932),
    [anon_sym_LT_AMP] = ACTIONS(932),
    [anon_sym_GT_AMP] = ACTIONS(932),
    [sym__special_characters] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_raw_string] = ACTIONS(932),
    [anon_sym_DOLLAR] = ACTIONS(932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(932),
    [anon_sym_BQUOTE] = ACTIONS(932),
    [anon_sym_LT_LPAREN] = ACTIONS(932),
    [anon_sym_GT_LPAREN] = ACTIONS(932),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_LF] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
  },
  [174] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(486),
    [anon_sym_RPAREN] = ACTIONS(934),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [175] = {
    [aux_sym_concatenation_repeat1] = STATE(488),
    [sym_file_descriptor] = ACTIONS(954),
    [sym__concat] = ACTIONS(956),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(958),
    [anon_sym_SEMI_SEMI] = ACTIONS(958),
    [anon_sym_PIPE_AMP] = ACTIONS(958),
    [anon_sym_AMP_AMP] = ACTIONS(958),
    [anon_sym_PIPE_PIPE] = ACTIONS(958),
    [anon_sym_LT] = ACTIONS(958),
    [anon_sym_GT] = ACTIONS(958),
    [anon_sym_GT_GT] = ACTIONS(958),
    [anon_sym_AMP_GT] = ACTIONS(958),
    [anon_sym_AMP_GT_GT] = ACTIONS(958),
    [anon_sym_LT_AMP] = ACTIONS(958),
    [anon_sym_GT_AMP] = ACTIONS(958),
    [sym__special_characters] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_raw_string] = ACTIONS(958),
    [anon_sym_DOLLAR] = ACTIONS(958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(958),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [anon_sym_LT_LPAREN] = ACTIONS(958),
    [anon_sym_GT_LPAREN] = ACTIONS(958),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_LF] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
  },
  [176] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(490),
    [anon_sym_DQUOTE] = ACTIONS(960),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [177] = {
    [aux_sym_concatenation_repeat1] = STATE(488),
    [sym_file_descriptor] = ACTIONS(930),
    [sym__concat] = ACTIONS(956),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(932),
    [anon_sym_SEMI_SEMI] = ACTIONS(932),
    [anon_sym_PIPE_AMP] = ACTIONS(932),
    [anon_sym_AMP_AMP] = ACTIONS(932),
    [anon_sym_PIPE_PIPE] = ACTIONS(932),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(932),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(932),
    [anon_sym_LT_AMP] = ACTIONS(932),
    [anon_sym_GT_AMP] = ACTIONS(932),
    [sym__special_characters] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_raw_string] = ACTIONS(932),
    [anon_sym_DOLLAR] = ACTIONS(932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(932),
    [anon_sym_BQUOTE] = ACTIONS(932),
    [anon_sym_LT_LPAREN] = ACTIONS(932),
    [anon_sym_GT_LPAREN] = ACTIONS(932),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_LF] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
  },
  [178] = {
    [sym_string] = STATE(493),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [anon_sym_DOLLAR] = ACTIONS(962),
    [anon_sym_POUND] = ACTIONS(962),
    [anon_sym_DASH] = ACTIONS(962),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(964),
    [anon_sym_STAR] = ACTIONS(962),
    [anon_sym_AT] = ACTIONS(962),
    [anon_sym_QMARK] = ACTIONS(962),
    [anon_sym_0] = ACTIONS(966),
    [anon_sym__] = ACTIONS(966),
  },
  [179] = {
    [sym_subscript] = STATE(498),
    [sym_variable_name] = ACTIONS(968),
    [anon_sym_DOLLAR] = ACTIONS(970),
    [anon_sym_POUND] = ACTIONS(972),
    [anon_sym_DASH] = ACTIONS(970),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(974),
    [anon_sym_STAR] = ACTIONS(970),
    [anon_sym_AT] = ACTIONS(970),
    [anon_sym_QMARK] = ACTIONS(970),
    [anon_sym_0] = ACTIONS(976),
    [anon_sym__] = ACTIONS(976),
  },
  [180] = {
    [sym_for_statement] = STATE(499),
    [sym_while_statement] = STATE(499),
    [sym_if_statement] = STATE(499),
    [sym_case_statement] = STATE(499),
    [sym_function_definition] = STATE(499),
    [sym_subshell] = STATE(499),
    [sym_pipeline] = STATE(499),
    [sym_list] = STATE(499),
    [sym_command] = STATE(499),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(500),
    [sym_declaration_command] = STATE(499),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [181] = {
    [sym_for_statement] = STATE(501),
    [sym_while_statement] = STATE(501),
    [sym_if_statement] = STATE(501),
    [sym_case_statement] = STATE(501),
    [sym_function_definition] = STATE(501),
    [sym_subshell] = STATE(501),
    [sym_pipeline] = STATE(501),
    [sym_list] = STATE(501),
    [sym_command] = STATE(501),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(502),
    [sym_declaration_command] = STATE(501),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [182] = {
    [sym_for_statement] = STATE(503),
    [sym_while_statement] = STATE(503),
    [sym_if_statement] = STATE(503),
    [sym_case_statement] = STATE(503),
    [sym_function_definition] = STATE(503),
    [sym_subshell] = STATE(503),
    [sym_pipeline] = STATE(503),
    [sym_list] = STATE(503),
    [sym_command] = STATE(503),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(504),
    [sym_declaration_command] = STATE(503),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [183] = {
    [aux_sym_concatenation_repeat1] = STATE(507),
    [sym__concat] = ACTIONS(978),
    [anon_sym_RBRACK] = ACTIONS(980),
    [sym_comment] = ACTIONS(48),
  },
  [184] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(509),
    [anon_sym_DQUOTE] = ACTIONS(982),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [185] = {
    [aux_sym_concatenation_repeat1] = STATE(507),
    [sym__concat] = ACTIONS(984),
    [anon_sym_RBRACK] = ACTIONS(986),
    [sym_comment] = ACTIONS(48),
  },
  [186] = {
    [sym_string] = STATE(514),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [anon_sym_DOLLAR] = ACTIONS(988),
    [anon_sym_POUND] = ACTIONS(988),
    [anon_sym_DASH] = ACTIONS(988),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(990),
    [anon_sym_STAR] = ACTIONS(988),
    [anon_sym_AT] = ACTIONS(988),
    [anon_sym_QMARK] = ACTIONS(988),
    [anon_sym_0] = ACTIONS(992),
    [anon_sym__] = ACTIONS(992),
  },
  [187] = {
    [sym_subscript] = STATE(519),
    [sym_variable_name] = ACTIONS(994),
    [anon_sym_DOLLAR] = ACTIONS(996),
    [anon_sym_POUND] = ACTIONS(998),
    [anon_sym_DASH] = ACTIONS(996),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1000),
    [anon_sym_STAR] = ACTIONS(996),
    [anon_sym_AT] = ACTIONS(996),
    [anon_sym_QMARK] = ACTIONS(996),
    [anon_sym_0] = ACTIONS(1002),
    [anon_sym__] = ACTIONS(1002),
  },
  [188] = {
    [sym_for_statement] = STATE(520),
    [sym_while_statement] = STATE(520),
    [sym_if_statement] = STATE(520),
    [sym_case_statement] = STATE(520),
    [sym_function_definition] = STATE(520),
    [sym_subshell] = STATE(520),
    [sym_pipeline] = STATE(520),
    [sym_list] = STATE(520),
    [sym_command] = STATE(520),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(521),
    [sym_declaration_command] = STATE(520),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [189] = {
    [sym_for_statement] = STATE(522),
    [sym_while_statement] = STATE(522),
    [sym_if_statement] = STATE(522),
    [sym_case_statement] = STATE(522),
    [sym_function_definition] = STATE(522),
    [sym_subshell] = STATE(522),
    [sym_pipeline] = STATE(522),
    [sym_list] = STATE(522),
    [sym_command] = STATE(522),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(523),
    [sym_declaration_command] = STATE(522),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [190] = {
    [sym_for_statement] = STATE(524),
    [sym_while_statement] = STATE(524),
    [sym_if_statement] = STATE(524),
    [sym_case_statement] = STATE(524),
    [sym_function_definition] = STATE(524),
    [sym_subshell] = STATE(524),
    [sym_pipeline] = STATE(524),
    [sym_list] = STATE(524),
    [sym_command] = STATE(524),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(525),
    [sym_declaration_command] = STATE(524),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [191] = {
    [sym__concat] = ACTIONS(1004),
    [anon_sym_RBRACK] = ACTIONS(986),
    [sym_comment] = ACTIONS(48),
  },
  [192] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(529),
    [sym_simple_expansion] = STATE(529),
    [sym_expansion] = STATE(529),
    [sym_command_substitution] = STATE(529),
    [sym_process_substitution] = STATE(529),
    [aux_sym_for_statement_repeat1] = STATE(536),
    [sym__special_characters] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [sym_raw_string] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [anon_sym_LT_LPAREN] = ACTIONS(1020),
    [anon_sym_GT_LPAREN] = ACTIONS(1020),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1022),
  },
  [193] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(541),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(1024),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [194] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(542),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(1026),
    [anon_sym_SEMI_SEMI] = ACTIONS(1026),
    [anon_sym_PIPE_AMP] = ACTIONS(1026),
    [anon_sym_AMP_AMP] = ACTIONS(1026),
    [anon_sym_PIPE_PIPE] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_LF] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
  },
  [195] = {
    [anon_sym_do] = ACTIONS(790),
    [anon_sym_then] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
  },
  [196] = {
    [sym__terminated_statement] = STATE(546),
    [sym_for_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(549),
    [sym_case_statement] = STATE(547),
    [sym_function_definition] = STATE(547),
    [sym_subshell] = STATE(547),
    [sym_pipeline] = STATE(547),
    [sym_list] = STATE(547),
    [sym_command] = STATE(547),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(550),
    [sym_declaration_command] = STATE(547),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(551),
    [aux_sym_if_statement_repeat1] = STATE(552),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(1028),
    [anon_sym_elif] = ACTIONS(1030),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [197] = {
    [sym_string] = STATE(553),
    [sym_simple_expansion] = STATE(553),
    [sym_expansion] = STATE(553),
    [sym_command_substitution] = STATE(553),
    [sym_process_substitution] = STATE(553),
    [sym__special_characters] = ACTIONS(1034),
    [anon_sym_DQUOTE] = ACTIONS(64),
    [sym_raw_string] = ACTIONS(1036),
    [anon_sym_DOLLAR] = ACTIONS(68),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(70),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(72),
    [anon_sym_BQUOTE] = ACTIONS(74),
    [anon_sym_LT_LPAREN] = ACTIONS(76),
    [anon_sym_GT_LPAREN] = ACTIONS(76),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1034),
  },
  [198] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1038),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1038),
    [anon_sym_LF] = ACTIONS(1038),
    [anon_sym_AMP] = ACTIONS(1038),
  },
  [199] = {
    [anon_sym_in] = ACTIONS(1040),
    [sym_comment] = ACTIONS(48),
  },
  [200] = {
    [aux_sym_concatenation_repeat1] = STATE(556),
    [sym__concat] = ACTIONS(360),
    [anon_sym_in] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [201] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_in] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [202] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1042),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [203] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1044),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1044),
    [anon_sym_LF] = ACTIONS(1044),
    [anon_sym_AMP] = ACTIONS(1044),
  },
  [204] = {
    [anon_sym_in] = ACTIONS(1046),
    [sym_comment] = ACTIONS(48),
  },
  [205] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_in] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [206] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_in] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [207] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_in] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [208] = {
    [anon_sym_EQ] = ACTIONS(1048),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [209] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(562),
    [anon_sym_RBRACE] = ACTIONS(1050),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [210] = {
    [sym_subscript] = STATE(566),
    [sym_variable_name] = ACTIONS(1052),
    [anon_sym_DOLLAR] = ACTIONS(1054),
    [anon_sym_DASH] = ACTIONS(1054),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1056),
    [anon_sym_STAR] = ACTIONS(1054),
    [anon_sym_AT] = ACTIONS(1054),
    [anon_sym_QMARK] = ACTIONS(1054),
    [anon_sym_0] = ACTIONS(1058),
    [anon_sym__] = ACTIONS(1058),
  },
  [211] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(568),
    [anon_sym_RBRACE] = ACTIONS(1060),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [212] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(570),
    [anon_sym_RBRACE] = ACTIONS(1062),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [213] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1064),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [214] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1064),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [215] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [sym_comment] = ACTIONS(48),
  },
  [216] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1064),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [217] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [218] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1066),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [219] = {
    [anon_sym_RPAREN] = ACTIONS(1068),
    [sym_comment] = ACTIONS(48),
  },
  [220] = {
    [sym__terminated_statement] = STATE(575),
    [sym_for_statement] = STATE(576),
    [sym_while_statement] = STATE(576),
    [sym_if_statement] = STATE(576),
    [sym_case_statement] = STATE(576),
    [sym_function_definition] = STATE(576),
    [sym_subshell] = STATE(576),
    [sym_pipeline] = STATE(576),
    [sym_list] = STATE(576),
    [sym_command] = STATE(576),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(577),
    [sym_declaration_command] = STATE(576),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(578),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(1070),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [221] = {
    [sym_file_redirect] = STATE(581),
    [sym_file_descriptor] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(1076),
    [anon_sym_SEMI_SEMI] = ACTIONS(1076),
    [anon_sym_PIPE_AMP] = ACTIONS(1076),
    [anon_sym_AMP_AMP] = ACTIONS(1076),
    [anon_sym_PIPE_PIPE] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(1078),
    [anon_sym_GT] = ACTIONS(1078),
    [anon_sym_GT_GT] = ACTIONS(1078),
    [anon_sym_AMP_GT] = ACTIONS(1078),
    [anon_sym_AMP_GT_GT] = ACTIONS(1078),
    [anon_sym_LT_AMP] = ACTIONS(1078),
    [anon_sym_GT_AMP] = ACTIONS(1078),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1076),
    [anon_sym_LF] = ACTIONS(1076),
    [anon_sym_AMP] = ACTIONS(1076),
  },
  [222] = {
    [sym_concatenation] = STATE(173),
    [sym_string] = STATE(584),
    [sym_array] = STATE(173),
    [sym_simple_expansion] = STATE(584),
    [sym_expansion] = STATE(584),
    [sym_command_substitution] = STATE(584),
    [sym_process_substitution] = STATE(584),
    [sym__empty_value] = ACTIONS(308),
    [anon_sym_LPAREN] = ACTIONS(310),
    [sym__special_characters] = ACTIONS(1080),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_raw_string] = ACTIONS(1084),
    [anon_sym_DOLLAR] = ACTIONS(1086),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1088),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1090),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LT_LPAREN] = ACTIONS(1094),
    [anon_sym_GT_LPAREN] = ACTIONS(1094),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1096),
  },
  [223] = {
    [sym_do_group] = STATE(590),
    [anon_sym_do] = ACTIONS(354),
    [sym_comment] = ACTIONS(48),
  },
  [224] = {
    [sym_compound_statement] = STATE(592),
    [anon_sym_LPAREN] = ACTIONS(1098),
    [anon_sym_LBRACE] = ACTIONS(390),
    [sym_comment] = ACTIONS(48),
  },
  [225] = {
    [sym__assignment] = STATE(271),
    [anon_sym_EQ] = ACTIONS(1100),
    [anon_sym_PLUS_EQ] = ACTIONS(1100),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [226] = {
    [aux_sym_concatenation_repeat1] = STATE(595),
    [sym__concat] = ACTIONS(1102),
    [sym_variable_name] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(474),
    [anon_sym_RPAREN] = ACTIONS(474),
    [anon_sym_SEMI_SEMI] = ACTIONS(474),
    [anon_sym_PIPE_AMP] = ACTIONS(474),
    [anon_sym_AMP_AMP] = ACTIONS(474),
    [anon_sym_PIPE_PIPE] = ACTIONS(474),
    [sym__special_characters] = ACTIONS(474),
    [anon_sym_DQUOTE] = ACTIONS(474),
    [sym_raw_string] = ACTIONS(474),
    [anon_sym_DOLLAR] = ACTIONS(474),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(474),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(474),
    [anon_sym_BQUOTE] = ACTIONS(474),
    [anon_sym_LT_LPAREN] = ACTIONS(474),
    [anon_sym_GT_LPAREN] = ACTIONS(474),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(474),
    [sym_word] = ACTIONS(474),
    [anon_sym_SEMI] = ACTIONS(474),
    [anon_sym_LF] = ACTIONS(474),
    [anon_sym_AMP] = ACTIONS(474),
  },
  [227] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(597),
    [anon_sym_DQUOTE] = ACTIONS(1104),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [228] = {
    [aux_sym_concatenation_repeat1] = STATE(595),
    [sym__concat] = ACTIONS(1102),
    [sym_variable_name] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(480),
    [anon_sym_RPAREN] = ACTIONS(480),
    [anon_sym_SEMI_SEMI] = ACTIONS(480),
    [anon_sym_PIPE_AMP] = ACTIONS(480),
    [anon_sym_AMP_AMP] = ACTIONS(480),
    [anon_sym_PIPE_PIPE] = ACTIONS(480),
    [sym__special_characters] = ACTIONS(480),
    [anon_sym_DQUOTE] = ACTIONS(480),
    [sym_raw_string] = ACTIONS(480),
    [anon_sym_DOLLAR] = ACTIONS(480),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(480),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(480),
    [anon_sym_BQUOTE] = ACTIONS(480),
    [anon_sym_LT_LPAREN] = ACTIONS(480),
    [anon_sym_GT_LPAREN] = ACTIONS(480),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(480),
    [sym_word] = ACTIONS(480),
    [anon_sym_SEMI] = ACTIONS(480),
    [anon_sym_LF] = ACTIONS(480),
    [anon_sym_AMP] = ACTIONS(480),
  },
  [229] = {
    [sym_string] = STATE(600),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [anon_sym_DOLLAR] = ACTIONS(1108),
    [anon_sym_POUND] = ACTIONS(1108),
    [anon_sym_DASH] = ACTIONS(1108),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1110),
    [anon_sym_STAR] = ACTIONS(1108),
    [anon_sym_AT] = ACTIONS(1108),
    [anon_sym_QMARK] = ACTIONS(1108),
    [anon_sym_0] = ACTIONS(1112),
    [anon_sym__] = ACTIONS(1112),
  },
  [230] = {
    [sym_subscript] = STATE(605),
    [sym_variable_name] = ACTIONS(1114),
    [anon_sym_DOLLAR] = ACTIONS(1116),
    [anon_sym_POUND] = ACTIONS(1118),
    [anon_sym_DASH] = ACTIONS(1116),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1120),
    [anon_sym_STAR] = ACTIONS(1116),
    [anon_sym_AT] = ACTIONS(1116),
    [anon_sym_QMARK] = ACTIONS(1116),
    [anon_sym_0] = ACTIONS(1122),
    [anon_sym__] = ACTIONS(1122),
  },
  [231] = {
    [sym_for_statement] = STATE(606),
    [sym_while_statement] = STATE(606),
    [sym_if_statement] = STATE(606),
    [sym_case_statement] = STATE(606),
    [sym_function_definition] = STATE(606),
    [sym_subshell] = STATE(606),
    [sym_pipeline] = STATE(606),
    [sym_list] = STATE(606),
    [sym_command] = STATE(606),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(607),
    [sym_declaration_command] = STATE(606),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [232] = {
    [sym_for_statement] = STATE(608),
    [sym_while_statement] = STATE(608),
    [sym_if_statement] = STATE(608),
    [sym_case_statement] = STATE(608),
    [sym_function_definition] = STATE(608),
    [sym_subshell] = STATE(608),
    [sym_pipeline] = STATE(608),
    [sym_list] = STATE(608),
    [sym_command] = STATE(608),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(609),
    [sym_declaration_command] = STATE(608),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [233] = {
    [sym_for_statement] = STATE(610),
    [sym_while_statement] = STATE(610),
    [sym_if_statement] = STATE(610),
    [sym_case_statement] = STATE(610),
    [sym_function_definition] = STATE(610),
    [sym_subshell] = STATE(610),
    [sym_pipeline] = STATE(610),
    [sym_list] = STATE(610),
    [sym_command] = STATE(610),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(611),
    [sym_declaration_command] = STATE(610),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [234] = {
    [sym__assignment] = STATE(271),
    [anon_sym_EQ] = ACTIONS(1100),
    [anon_sym_PLUS_EQ] = ACTIONS(1100),
    [sym_comment] = ACTIONS(48),
  },
  [235] = {
    [sym_variable_assignment] = STATE(79),
    [sym_subscript] = STATE(234),
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(228),
    [sym_simple_expansion] = STATE(228),
    [sym_expansion] = STATE(228),
    [sym_command_substitution] = STATE(228),
    [sym_process_substitution] = STATE(228),
    [aux_sym_declaration_command_repeat1] = STATE(612),
    [sym_variable_name] = ACTIONS(396),
    [anon_sym_PIPE] = ACTIONS(504),
    [anon_sym_RPAREN] = ACTIONS(504),
    [anon_sym_SEMI_SEMI] = ACTIONS(504),
    [anon_sym_PIPE_AMP] = ACTIONS(504),
    [anon_sym_AMP_AMP] = ACTIONS(504),
    [anon_sym_PIPE_PIPE] = ACTIONS(504),
    [sym__special_characters] = ACTIONS(398),
    [anon_sym_DQUOTE] = ACTIONS(400),
    [sym_raw_string] = ACTIONS(402),
    [anon_sym_DOLLAR] = ACTIONS(404),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(406),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(408),
    [anon_sym_BQUOTE] = ACTIONS(410),
    [anon_sym_LT_LPAREN] = ACTIONS(412),
    [anon_sym_GT_LPAREN] = ACTIONS(412),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(130),
    [sym_word] = ACTIONS(402),
    [anon_sym_SEMI] = ACTIONS(504),
    [anon_sym_LF] = ACTIONS(504),
    [anon_sym_AMP] = ACTIONS(504),
  },
  [236] = {
    [sym_string] = STATE(613),
    [sym_simple_expansion] = STATE(613),
    [sym_expansion] = STATE(613),
    [sym_command_substitution] = STATE(613),
    [sym_process_substitution] = STATE(613),
    [sym__special_characters] = ACTIONS(1124),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(1126),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1124),
  },
  [237] = {
    [aux_sym_concatenation_repeat1] = STATE(614),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_AMP_GT] = ACTIONS(540),
    [anon_sym_AMP_GT_GT] = ACTIONS(540),
    [anon_sym_LT_AMP] = ACTIONS(540),
    [anon_sym_GT_AMP] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_LT_LT_DASH] = ACTIONS(540),
    [anon_sym_LT_LT_LT] = ACTIONS(540),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [sym_raw_string] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(540),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(540),
    [anon_sym_GT_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [238] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [anon_sym_LT_LT_LT] = ACTIONS(544),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [239] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1128),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [240] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_LT_LT] = ACTIONS(574),
    [anon_sym_LT_LT_DASH] = ACTIONS(574),
    [anon_sym_LT_LT_LT] = ACTIONS(574),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [241] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_GT] = ACTIONS(578),
    [anon_sym_AMP_GT_GT] = ACTIONS(578),
    [anon_sym_LT_AMP] = ACTIONS(578),
    [anon_sym_GT_AMP] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_LT_LT_DASH] = ACTIONS(578),
    [anon_sym_LT_LT_LT] = ACTIONS(578),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [anon_sym_LT_LPAREN] = ACTIONS(578),
    [anon_sym_GT_LPAREN] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [242] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT_LT_DASH] = ACTIONS(582),
    [anon_sym_LT_LT_LT] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [243] = {
    [anon_sym_EQ] = ACTIONS(1130),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [244] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(618),
    [anon_sym_RBRACE] = ACTIONS(1132),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [245] = {
    [sym_subscript] = STATE(622),
    [sym_variable_name] = ACTIONS(1134),
    [anon_sym_DOLLAR] = ACTIONS(1136),
    [anon_sym_DASH] = ACTIONS(1136),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1138),
    [anon_sym_STAR] = ACTIONS(1136),
    [anon_sym_AT] = ACTIONS(1136),
    [anon_sym_QMARK] = ACTIONS(1136),
    [anon_sym_0] = ACTIONS(1140),
    [anon_sym__] = ACTIONS(1140),
  },
  [246] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(624),
    [anon_sym_RBRACE] = ACTIONS(1142),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [247] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(626),
    [anon_sym_RBRACE] = ACTIONS(1144),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [248] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1146),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [249] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1146),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [250] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1146),
    [sym_comment] = ACTIONS(48),
  },
  [251] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1146),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [252] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1148),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [253] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1148),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [254] = {
    [anon_sym_RPAREN] = ACTIONS(1150),
    [sym_comment] = ACTIONS(48),
  },
  [255] = {
    [sym_for_statement] = STATE(451),
    [sym_while_statement] = STATE(451),
    [sym_if_statement] = STATE(451),
    [sym_case_statement] = STATE(451),
    [sym_function_definition] = STATE(451),
    [sym_subshell] = STATE(451),
    [sym_pipeline] = STATE(451),
    [sym_list] = STATE(451),
    [sym_command] = STATE(451),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(452),
    [sym_declaration_command] = STATE(451),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(84),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(88),
    [anon_sym_typeset] = ACTIONS(88),
    [anon_sym_export] = ACTIONS(88),
    [anon_sym_readonly] = ACTIONS(88),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(90),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(94),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(106),
  },
  [256] = {
    [anon_sym_PIPE] = ACTIONS(1152),
    [anon_sym_RPAREN] = ACTIONS(1152),
    [anon_sym_SEMI_SEMI] = ACTIONS(1152),
    [anon_sym_PIPE_AMP] = ACTIONS(1152),
    [anon_sym_AMP_AMP] = ACTIONS(1152),
    [anon_sym_PIPE_PIPE] = ACTIONS(1152),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1152),
    [anon_sym_LF] = ACTIONS(1152),
    [anon_sym_AMP] = ACTIONS(1152),
  },
  [257] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(1154),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [258] = {
    [sym_for_statement] = STATE(631),
    [sym_while_statement] = STATE(631),
    [sym_if_statement] = STATE(631),
    [sym_case_statement] = STATE(631),
    [sym_function_definition] = STATE(631),
    [sym_subshell] = STATE(631),
    [sym_pipeline] = STATE(631),
    [sym_list] = STATE(631),
    [sym_command] = STATE(631),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(632),
    [sym_declaration_command] = STATE(631),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(84),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(88),
    [anon_sym_typeset] = ACTIONS(88),
    [anon_sym_export] = ACTIONS(88),
    [anon_sym_readonly] = ACTIONS(88),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(90),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(94),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(106),
  },
  [259] = {
    [anon_sym_LT] = ACTIONS(1156),
    [anon_sym_GT] = ACTIONS(1156),
    [anon_sym_GT_GT] = ACTIONS(1158),
    [anon_sym_AMP_GT] = ACTIONS(1156),
    [anon_sym_AMP_GT_GT] = ACTIONS(1158),
    [anon_sym_LT_AMP] = ACTIONS(1158),
    [anon_sym_GT_AMP] = ACTIONS(1158),
    [sym_comment] = ACTIONS(48),
  },
  [260] = {
    [sym_concatenation] = STATE(464),
    [sym_string] = STATE(636),
    [sym_simple_expansion] = STATE(636),
    [sym_expansion] = STATE(636),
    [sym_command_substitution] = STATE(636),
    [sym_process_substitution] = STATE(636),
    [sym__special_characters] = ACTIONS(1160),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [sym_raw_string] = ACTIONS(1164),
    [anon_sym_DOLLAR] = ACTIONS(1166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1172),
    [anon_sym_LT_LPAREN] = ACTIONS(1174),
    [anon_sym_GT_LPAREN] = ACTIONS(1174),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1176),
  },
  [261] = {
    [sym_concatenation] = STATE(470),
    [sym_string] = STATE(643),
    [sym_simple_expansion] = STATE(643),
    [sym_expansion] = STATE(643),
    [sym_command_substitution] = STATE(643),
    [sym_process_substitution] = STATE(643),
    [sym__special_characters] = ACTIONS(1178),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [sym_raw_string] = ACTIONS(1180),
    [anon_sym_DOLLAR] = ACTIONS(1166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1172),
    [anon_sym_LT_LPAREN] = ACTIONS(1174),
    [anon_sym_GT_LPAREN] = ACTIONS(1174),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1182),
  },
  [262] = {
    [aux_sym_concatenation_repeat1] = STATE(237),
    [sym_file_descriptor] = ACTIONS(828),
    [sym__concat] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(830),
    [anon_sym_RPAREN] = ACTIONS(830),
    [anon_sym_SEMI_SEMI] = ACTIONS(830),
    [anon_sym_PIPE_AMP] = ACTIONS(830),
    [anon_sym_AMP_AMP] = ACTIONS(830),
    [anon_sym_PIPE_PIPE] = ACTIONS(830),
    [anon_sym_LT] = ACTIONS(830),
    [anon_sym_GT] = ACTIONS(830),
    [anon_sym_GT_GT] = ACTIONS(830),
    [anon_sym_AMP_GT] = ACTIONS(830),
    [anon_sym_AMP_GT_GT] = ACTIONS(830),
    [anon_sym_LT_AMP] = ACTIONS(830),
    [anon_sym_GT_AMP] = ACTIONS(830),
    [anon_sym_LT_LT] = ACTIONS(830),
    [anon_sym_LT_LT_DASH] = ACTIONS(830),
    [anon_sym_LT_LT_LT] = ACTIONS(830),
    [sym__special_characters] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(830),
    [sym_raw_string] = ACTIONS(830),
    [anon_sym_DOLLAR] = ACTIONS(830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_LT_LPAREN] = ACTIONS(830),
    [anon_sym_GT_LPAREN] = ACTIONS(830),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_LF] = ACTIONS(830),
    [anon_sym_AMP] = ACTIONS(830),
  },
  [263] = {
    [aux_sym_concatenation_repeat1] = STATE(237),
    [sym_file_descriptor] = ACTIONS(832),
    [sym__concat] = ACTIONS(414),
    [anon_sym_PIPE] = ACTIONS(834),
    [anon_sym_RPAREN] = ACTIONS(834),
    [anon_sym_SEMI_SEMI] = ACTIONS(834),
    [anon_sym_PIPE_AMP] = ACTIONS(834),
    [anon_sym_AMP_AMP] = ACTIONS(834),
    [anon_sym_PIPE_PIPE] = ACTIONS(834),
    [anon_sym_LT] = ACTIONS(834),
    [anon_sym_GT] = ACTIONS(834),
    [anon_sym_GT_GT] = ACTIONS(834),
    [anon_sym_AMP_GT] = ACTIONS(834),
    [anon_sym_AMP_GT_GT] = ACTIONS(834),
    [anon_sym_LT_AMP] = ACTIONS(834),
    [anon_sym_GT_AMP] = ACTIONS(834),
    [anon_sym_LT_LT] = ACTIONS(834),
    [anon_sym_LT_LT_DASH] = ACTIONS(834),
    [anon_sym_LT_LT_LT] = ACTIONS(834),
    [sym__special_characters] = ACTIONS(834),
    [anon_sym_DQUOTE] = ACTIONS(834),
    [sym_raw_string] = ACTIONS(834),
    [anon_sym_DOLLAR] = ACTIONS(834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(834),
    [anon_sym_LT_LPAREN] = ACTIONS(834),
    [anon_sym_GT_LPAREN] = ACTIONS(834),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_LF] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
  },
  [264] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(263),
    [sym_simple_expansion] = STATE(263),
    [sym_expansion] = STATE(263),
    [sym_command_substitution] = STATE(263),
    [sym_process_substitution] = STATE(263),
    [aux_sym_for_statement_repeat1] = STATE(644),
    [aux_sym_while_statement_repeat1] = STATE(645),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(840),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym__special_characters] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(454),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(454),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [265] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(646),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(840),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [266] = {
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(1184),
    [anon_sym_SEMI_SEMI] = ACTIONS(1186),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_LF] = ACTIONS(1186),
    [anon_sym_AMP] = ACTIONS(1186),
  },
  [267] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(1184),
    [anon_sym_SEMI_SEMI] = ACTIONS(1186),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(1186),
    [anon_sym_LF] = ACTIONS(1186),
    [anon_sym_AMP] = ACTIONS(1186),
  },
  [268] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(268),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [269] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(263),
    [sym_simple_expansion] = STATE(263),
    [sym_expansion] = STATE(263),
    [sym_command_substitution] = STATE(263),
    [sym_process_substitution] = STATE(263),
    [aux_sym_for_statement_repeat1] = STATE(648),
    [aux_sym_while_statement_repeat1] = STATE(645),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(840),
    [anon_sym_RPAREN] = ACTIONS(840),
    [anon_sym_SEMI_SEMI] = ACTIONS(840),
    [anon_sym_PIPE_AMP] = ACTIONS(840),
    [anon_sym_AMP_AMP] = ACTIONS(840),
    [anon_sym_PIPE_PIPE] = ACTIONS(840),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym__special_characters] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(454),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(454),
    [anon_sym_SEMI] = ACTIONS(840),
    [anon_sym_LF] = ACTIONS(840),
    [anon_sym_AMP] = ACTIONS(840),
  },
  [270] = {
    [sym_concatenation] = STATE(649),
    [sym_string] = STATE(652),
    [sym_array] = STATE(649),
    [sym_simple_expansion] = STATE(652),
    [sym_expansion] = STATE(652),
    [sym_command_substitution] = STATE(652),
    [sym_process_substitution] = STATE(652),
    [sym__empty_value] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [sym__special_characters] = ACTIONS(1192),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [sym_raw_string] = ACTIONS(1194),
    [anon_sym_DOLLAR] = ACTIONS(1196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1200),
    [anon_sym_BQUOTE] = ACTIONS(1202),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1206),
  },
  [271] = {
    [sym_variable_name] = ACTIONS(348),
    [anon_sym_PIPE] = ACTIONS(350),
    [anon_sym_RPAREN] = ACTIONS(350),
    [anon_sym_SEMI_SEMI] = ACTIONS(350),
    [anon_sym_PIPE_AMP] = ACTIONS(350),
    [anon_sym_AMP_AMP] = ACTIONS(350),
    [anon_sym_PIPE_PIPE] = ACTIONS(350),
    [sym__special_characters] = ACTIONS(350),
    [anon_sym_DQUOTE] = ACTIONS(350),
    [sym_raw_string] = ACTIONS(350),
    [anon_sym_DOLLAR] = ACTIONS(350),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(350),
    [anon_sym_BQUOTE] = ACTIONS(350),
    [anon_sym_LT_LPAREN] = ACTIONS(350),
    [anon_sym_GT_LPAREN] = ACTIONS(350),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(350),
    [sym_word] = ACTIONS(350),
    [anon_sym_SEMI] = ACTIONS(350),
    [anon_sym_LF] = ACTIONS(350),
    [anon_sym_AMP] = ACTIONS(350),
  },
  [272] = {
    [sym_string] = STATE(653),
    [sym_simple_expansion] = STATE(653),
    [sym_expansion] = STATE(653),
    [sym_command_substitution] = STATE(653),
    [sym_process_substitution] = STATE(653),
    [sym__special_characters] = ACTIONS(1208),
    [anon_sym_DQUOTE] = ACTIONS(482),
    [sym_raw_string] = ACTIONS(1210),
    [anon_sym_DOLLAR] = ACTIONS(1196),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1198),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1200),
    [anon_sym_BQUOTE] = ACTIONS(1202),
    [anon_sym_LT_LPAREN] = ACTIONS(1204),
    [anon_sym_GT_LPAREN] = ACTIONS(1204),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1208),
  },
  [273] = {
    [aux_sym_concatenation_repeat1] = STATE(654),
    [sym__concat] = ACTIONS(470),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [sym_raw_string] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(540),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(540),
    [anon_sym_GT_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(540),
    [sym_word] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [274] = {
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(544),
    [sym_word] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [275] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1212),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [276] = {
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(574),
    [sym_word] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [277] = {
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [anon_sym_LT_LPAREN] = ACTIONS(578),
    [anon_sym_GT_LPAREN] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(578),
    [sym_word] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [278] = {
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(582),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [279] = {
    [anon_sym_EQ] = ACTIONS(1214),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [280] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(658),
    [anon_sym_RBRACE] = ACTIONS(1216),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [281] = {
    [sym_subscript] = STATE(662),
    [sym_variable_name] = ACTIONS(1218),
    [anon_sym_DOLLAR] = ACTIONS(1220),
    [anon_sym_DASH] = ACTIONS(1220),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1222),
    [anon_sym_STAR] = ACTIONS(1220),
    [anon_sym_AT] = ACTIONS(1220),
    [anon_sym_QMARK] = ACTIONS(1220),
    [anon_sym_0] = ACTIONS(1224),
    [anon_sym__] = ACTIONS(1224),
  },
  [282] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(664),
    [anon_sym_RBRACE] = ACTIONS(1226),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [283] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(666),
    [anon_sym_RBRACE] = ACTIONS(1228),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [284] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1230),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [285] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1230),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [286] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [sym_comment] = ACTIONS(48),
  },
  [287] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1230),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [288] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1232),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [289] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1232),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [290] = {
    [sym_variable_assignment] = STATE(79),
    [sym_subscript] = STATE(80),
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(72),
    [sym_simple_expansion] = STATE(72),
    [sym_expansion] = STATE(72),
    [sym_command_substitution] = STATE(72),
    [sym_process_substitution] = STATE(72),
    [aux_sym_declaration_command_repeat1] = STATE(290),
    [sym_variable_name] = ACTIONS(1234),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [sym__special_characters] = ACTIONS(1239),
    [anon_sym_DQUOTE] = ACTIONS(1242),
    [sym_raw_string] = ACTIONS(1245),
    [anon_sym_DOLLAR] = ACTIONS(1248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1251),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1254),
    [anon_sym_BQUOTE] = ACTIONS(1257),
    [anon_sym_LT_LPAREN] = ACTIONS(1260),
    [anon_sym_GT_LPAREN] = ACTIONS(1260),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1263),
    [sym_word] = ACTIONS(1245),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_LF] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
  },
  [291] = {
    [sym_string] = STATE(669),
    [sym_simple_expansion] = STATE(669),
    [sym_expansion] = STATE(669),
    [sym_command_substitution] = STATE(669),
    [sym_process_substitution] = STATE(669),
    [sym__special_characters] = ACTIONS(1266),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_raw_string] = ACTIONS(1268),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(142),
    [anon_sym_BQUOTE] = ACTIONS(144),
    [anon_sym_LT_LPAREN] = ACTIONS(146),
    [anon_sym_GT_LPAREN] = ACTIONS(146),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1266),
  },
  [292] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(508),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_AMP_GT] = ACTIONS(1270),
    [anon_sym_AMP_GT_GT] = ACTIONS(538),
    [anon_sym_LT_AMP] = ACTIONS(538),
    [anon_sym_GT_AMP] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1270),
  },
  [293] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(1272),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1272),
  },
  [294] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1274),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [295] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(1276),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1276),
  },
  [296] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(1278),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1278),
  },
  [297] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1280),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1280),
  },
  [298] = {
    [anon_sym_EQ] = ACTIONS(1282),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [299] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(674),
    [anon_sym_RBRACE] = ACTIONS(1284),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [300] = {
    [sym_subscript] = STATE(678),
    [sym_variable_name] = ACTIONS(1286),
    [anon_sym_DOLLAR] = ACTIONS(1288),
    [anon_sym_DASH] = ACTIONS(1288),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1290),
    [anon_sym_STAR] = ACTIONS(1288),
    [anon_sym_AT] = ACTIONS(1288),
    [anon_sym_QMARK] = ACTIONS(1288),
    [anon_sym_0] = ACTIONS(1292),
    [anon_sym__] = ACTIONS(1292),
  },
  [301] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(680),
    [anon_sym_RBRACE] = ACTIONS(1294),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [302] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(682),
    [anon_sym_RBRACE] = ACTIONS(1296),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [303] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1298),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [304] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1298),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [305] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1298),
    [sym_comment] = ACTIONS(48),
  },
  [306] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1298),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [307] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [308] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1300),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [309] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [310] = {
    [aux_sym_concatenation_repeat1] = STATE(310),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1306),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [311] = {
    [anon_sym_DQUOTE] = ACTIONS(1309),
    [sym__string_content] = ACTIONS(1311),
    [anon_sym_DOLLAR] = ACTIONS(1309),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1309),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1309),
    [anon_sym_BQUOTE] = ACTIONS(1309),
    [sym_comment] = ACTIONS(128),
  },
  [312] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(686),
    [anon_sym_DQUOTE] = ACTIONS(1313),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [313] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym__string_content] = ACTIONS(1276),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
  },
  [314] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym__string_content] = ACTIONS(1278),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
  },
  [315] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym__string_content] = ACTIONS(1280),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
  },
  [316] = {
    [anon_sym_EQ] = ACTIONS(1315),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [317] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(689),
    [anon_sym_RBRACE] = ACTIONS(1317),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [318] = {
    [sym_subscript] = STATE(693),
    [sym_variable_name] = ACTIONS(1319),
    [anon_sym_DOLLAR] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1323),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_AT] = ACTIONS(1321),
    [anon_sym_QMARK] = ACTIONS(1321),
    [anon_sym_0] = ACTIONS(1325),
    [anon_sym__] = ACTIONS(1325),
  },
  [319] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(695),
    [anon_sym_RBRACE] = ACTIONS(1327),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [320] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(697),
    [anon_sym_RBRACE] = ACTIONS(1329),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [321] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1331),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [322] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1331),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [323] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1331),
    [sym_comment] = ACTIONS(48),
  },
  [324] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1331),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [325] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1335),
    [anon_sym_LT_LT_DASH] = ACTIONS(1335),
    [anon_sym_LT_LT_LT] = ACTIONS(1335),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_raw_string] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [326] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1309),
    [sym__string_content] = ACTIONS(1337),
    [anon_sym_DOLLAR] = ACTIONS(1340),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1343),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1346),
    [anon_sym_BQUOTE] = ACTIONS(1349),
    [sym_comment] = ACTIONS(128),
  },
  [327] = {
    [sym_concatenation] = STATE(708),
    [sym_string] = STATE(702),
    [sym_simple_expansion] = STATE(702),
    [sym_expansion] = STATE(702),
    [sym_command_substitution] = STATE(702),
    [sym_process_substitution] = STATE(702),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [sym__special_characters] = ACTIONS(1354),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(1358),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1370),
  },
  [328] = {
    [sym_concatenation] = STATE(711),
    [sym_string] = STATE(710),
    [sym_simple_expansion] = STATE(710),
    [sym_expansion] = STATE(710),
    [sym_command_substitution] = STATE(710),
    [sym_process_substitution] = STATE(710),
    [sym__special_characters] = ACTIONS(1372),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [sym_raw_string] = ACTIONS(1374),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(340),
    [anon_sym_BQUOTE] = ACTIONS(342),
    [anon_sym_LT_LPAREN] = ACTIONS(344),
    [anon_sym_GT_LPAREN] = ACTIONS(344),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1376),
  },
  [329] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [330] = {
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_EQ] = ACTIONS(1384),
    [sym__special_characters] = ACTIONS(1386),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [sym_raw_string] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [anon_sym_POUND] = ACTIONS(1382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_COLON_QMARK] = ACTIONS(1384),
    [anon_sym_COLON_DASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1382),
    [anon_sym_GT_LPAREN] = ACTIONS(1382),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1386),
  },
  [331] = {
    [aux_sym_concatenation_repeat1] = STATE(713),
    [sym__concat] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1390),
    [anon_sym_EQ] = ACTIONS(1392),
    [sym__special_characters] = ACTIONS(1394),
    [anon_sym_DQUOTE] = ACTIONS(1390),
    [sym_raw_string] = ACTIONS(1390),
    [anon_sym_DOLLAR] = ACTIONS(1392),
    [anon_sym_POUND] = ACTIONS(1390),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1390),
    [anon_sym_COLON] = ACTIONS(1392),
    [anon_sym_COLON_QMARK] = ACTIONS(1392),
    [anon_sym_COLON_DASH] = ACTIONS(1392),
    [anon_sym_PERCENT] = ACTIONS(1392),
    [anon_sym_SLASH] = ACTIONS(1392),
    [anon_sym_DASH] = ACTIONS(1392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1390),
    [anon_sym_BQUOTE] = ACTIONS(1390),
    [anon_sym_LT_LPAREN] = ACTIONS(1390),
    [anon_sym_GT_LPAREN] = ACTIONS(1390),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1394),
  },
  [332] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(715),
    [anon_sym_DQUOTE] = ACTIONS(1396),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [333] = {
    [aux_sym_concatenation_repeat1] = STATE(713),
    [sym__concat] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(1382),
    [anon_sym_EQ] = ACTIONS(1384),
    [sym__special_characters] = ACTIONS(1386),
    [anon_sym_DQUOTE] = ACTIONS(1382),
    [sym_raw_string] = ACTIONS(1382),
    [anon_sym_DOLLAR] = ACTIONS(1384),
    [anon_sym_POUND] = ACTIONS(1382),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1382),
    [anon_sym_COLON] = ACTIONS(1384),
    [anon_sym_COLON_QMARK] = ACTIONS(1384),
    [anon_sym_COLON_DASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1384),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_DASH] = ACTIONS(1384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1382),
    [anon_sym_BQUOTE] = ACTIONS(1382),
    [anon_sym_LT_LPAREN] = ACTIONS(1382),
    [anon_sym_GT_LPAREN] = ACTIONS(1382),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1386),
  },
  [334] = {
    [sym_string] = STATE(718),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [anon_sym_DOLLAR] = ACTIONS(1398),
    [anon_sym_POUND] = ACTIONS(1398),
    [anon_sym_DASH] = ACTIONS(1398),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1400),
    [anon_sym_STAR] = ACTIONS(1398),
    [anon_sym_AT] = ACTIONS(1398),
    [anon_sym_QMARK] = ACTIONS(1398),
    [anon_sym_0] = ACTIONS(1402),
    [anon_sym__] = ACTIONS(1402),
  },
  [335] = {
    [sym_subscript] = STATE(723),
    [sym_variable_name] = ACTIONS(1404),
    [anon_sym_DOLLAR] = ACTIONS(1406),
    [anon_sym_POUND] = ACTIONS(1408),
    [anon_sym_DASH] = ACTIONS(1406),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1410),
    [anon_sym_STAR] = ACTIONS(1406),
    [anon_sym_AT] = ACTIONS(1406),
    [anon_sym_QMARK] = ACTIONS(1406),
    [anon_sym_0] = ACTIONS(1412),
    [anon_sym__] = ACTIONS(1412),
  },
  [336] = {
    [sym_for_statement] = STATE(724),
    [sym_while_statement] = STATE(724),
    [sym_if_statement] = STATE(724),
    [sym_case_statement] = STATE(724),
    [sym_function_definition] = STATE(724),
    [sym_subshell] = STATE(724),
    [sym_pipeline] = STATE(724),
    [sym_list] = STATE(724),
    [sym_command] = STATE(724),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(725),
    [sym_declaration_command] = STATE(724),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [337] = {
    [sym_for_statement] = STATE(726),
    [sym_while_statement] = STATE(726),
    [sym_if_statement] = STATE(726),
    [sym_case_statement] = STATE(726),
    [sym_function_definition] = STATE(726),
    [sym_subshell] = STATE(726),
    [sym_pipeline] = STATE(726),
    [sym_list] = STATE(726),
    [sym_command] = STATE(726),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(727),
    [sym_declaration_command] = STATE(726),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [338] = {
    [sym_for_statement] = STATE(728),
    [sym_while_statement] = STATE(728),
    [sym_if_statement] = STATE(728),
    [sym_case_statement] = STATE(728),
    [sym_function_definition] = STATE(728),
    [sym_subshell] = STATE(728),
    [sym_pipeline] = STATE(728),
    [sym_list] = STATE(728),
    [sym_command] = STATE(728),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(729),
    [sym_declaration_command] = STATE(728),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [339] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(1414),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [340] = {
    [anon_sym_EQ] = ACTIONS(1416),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [341] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(734),
    [anon_sym_RBRACE] = ACTIONS(1418),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [342] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(736),
    [anon_sym_RBRACE] = ACTIONS(1420),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [343] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(737),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [344] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT_GT] = ACTIONS(1424),
    [anon_sym_LT_AMP] = ACTIONS(1424),
    [anon_sym_GT_AMP] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1424),
    [anon_sym_LT_LT_DASH] = ACTIONS(1424),
    [anon_sym_LT_LT_LT] = ACTIONS(1424),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LPAREN] = ACTIONS(1424),
    [anon_sym_GT_LPAREN] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [345] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(1426),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [346] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_AMP] = ACTIONS(1430),
    [anon_sym_GT_AMP] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1430),
    [anon_sym_LT_LT_LT] = ACTIONS(1430),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym_raw_string] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LPAREN] = ACTIONS(1430),
    [anon_sym_GT_LPAREN] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [347] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(1352),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [348] = {
    [sym_concatenation] = STATE(739),
    [sym_string] = STATE(743),
    [sym_array] = STATE(739),
    [sym_simple_expansion] = STATE(743),
    [sym_expansion] = STATE(743),
    [sym_command_substitution] = STATE(743),
    [sym_process_substitution] = STATE(743),
    [sym__empty_value] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [sym__special_characters] = ACTIONS(1436),
    [anon_sym_DQUOTE] = ACTIONS(1438),
    [sym_raw_string] = ACTIONS(1440),
    [anon_sym_DOLLAR] = ACTIONS(1442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [anon_sym_LT_LPAREN] = ACTIONS(1450),
    [anon_sym_GT_LPAREN] = ACTIONS(1450),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1452),
  },
  [349] = {
    [sym_file_descriptor] = ACTIONS(348),
    [sym_variable_name] = ACTIONS(348),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_RPAREN] = ACTIONS(348),
    [anon_sym_PIPE_AMP] = ACTIONS(348),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [anon_sym_LT] = ACTIONS(1454),
    [anon_sym_GT] = ACTIONS(1454),
    [anon_sym_GT_GT] = ACTIONS(348),
    [anon_sym_AMP_GT] = ACTIONS(1454),
    [anon_sym_AMP_GT_GT] = ACTIONS(348),
    [anon_sym_LT_AMP] = ACTIONS(348),
    [anon_sym_GT_AMP] = ACTIONS(348),
    [sym__special_characters] = ACTIONS(1454),
    [anon_sym_DQUOTE] = ACTIONS(348),
    [sym_raw_string] = ACTIONS(348),
    [anon_sym_DOLLAR] = ACTIONS(1454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(348),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(348),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(348),
    [anon_sym_GT_LPAREN] = ACTIONS(348),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1454),
  },
  [350] = {
    [anon_sym_in] = ACTIONS(1456),
    [sym_comment] = ACTIONS(48),
  },
  [351] = {
    [sym_do_group] = STATE(751),
    [anon_sym_do] = ACTIONS(1458),
    [sym_comment] = ACTIONS(48),
  },
  [352] = {
    [anon_sym_then] = ACTIONS(1460),
    [sym_comment] = ACTIONS(48),
  },
  [353] = {
    [aux_sym_concatenation_repeat1] = STATE(200),
    [sym__concat] = ACTIONS(360),
    [anon_sym_in] = ACTIONS(1462),
    [anon_sym_SEMI_SEMI] = ACTIONS(1464),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1464),
    [anon_sym_LF] = ACTIONS(1464),
    [anon_sym_AMP] = ACTIONS(1464),
  },
  [354] = {
    [aux_sym_concatenation_repeat1] = STATE(200),
    [sym__concat] = ACTIONS(360),
    [anon_sym_in] = ACTIONS(1466),
    [anon_sym_SEMI_SEMI] = ACTIONS(1468),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym_LF] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
  },
  [355] = {
    [anon_sym_in] = ACTIONS(1466),
    [anon_sym_SEMI_SEMI] = ACTIONS(1468),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1468),
    [anon_sym_LF] = ACTIONS(1468),
    [anon_sym_AMP] = ACTIONS(1468),
  },
  [356] = {
    [sym_compound_statement] = STATE(759),
    [anon_sym_LPAREN] = ACTIONS(1470),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [sym_comment] = ACTIONS(48),
  },
  [357] = {
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(1474),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
  },
  [358] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(1474),
    [anon_sym_SEMI_SEMI] = ACTIONS(1476),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(1476),
    [anon_sym_LF] = ACTIONS(1476),
    [anon_sym_AMP] = ACTIONS(1476),
  },
  [359] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(762),
    [sym_while_statement] = STATE(762),
    [sym_if_statement] = STATE(762),
    [sym_case_statement] = STATE(762),
    [sym_function_definition] = STATE(762),
    [sym_subshell] = STATE(762),
    [sym_pipeline] = STATE(762),
    [sym_list] = STATE(762),
    [sym_command] = STATE(762),
    [sym_command_name] = STATE(64),
    [sym_variable_assignment] = STATE(763),
    [sym_declaration_command] = STATE(762),
    [sym_subscript] = STATE(66),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(56),
    [sym_simple_expansion] = STATE(56),
    [sym_expansion] = STATE(56),
    [sym_command_substitution] = STATE(56),
    [sym_process_substitution] = STATE(56),
    [aux_sym_program_repeat1] = STATE(268),
    [aux_sym_command_repeat1] = STATE(68),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(82),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(84),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(86),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(88),
    [anon_sym_typeset] = ACTIONS(88),
    [anon_sym_export] = ACTIONS(88),
    [anon_sym_readonly] = ACTIONS(88),
    [anon_sym_local] = ACTIONS(88),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(90),
    [anon_sym_DQUOTE] = ACTIONS(92),
    [sym_raw_string] = ACTIONS(94),
    [anon_sym_DOLLAR] = ACTIONS(96),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(98),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(100),
    [anon_sym_BQUOTE] = ACTIONS(102),
    [anon_sym_LT_LPAREN] = ACTIONS(104),
    [anon_sym_GT_LPAREN] = ACTIONS(104),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(106),
  },
  [360] = {
    [sym__assignment] = STATE(765),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_PLUS_EQ] = ACTIONS(1478),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [361] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [sym__concat] = ACTIONS(1480),
    [sym_variable_name] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(1482),
    [anon_sym_RPAREN] = ACTIONS(472),
    [anon_sym_PIPE_AMP] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [sym__special_characters] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1482),
    [sym_word] = ACTIONS(474),
  },
  [362] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(769),
    [anon_sym_DQUOTE] = ACTIONS(1484),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [363] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [sym__concat] = ACTIONS(1480),
    [sym_variable_name] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1486),
    [anon_sym_RPAREN] = ACTIONS(478),
    [anon_sym_PIPE_AMP] = ACTIONS(478),
    [anon_sym_AMP_AMP] = ACTIONS(478),
    [anon_sym_PIPE_PIPE] = ACTIONS(478),
    [sym__special_characters] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(478),
    [sym_raw_string] = ACTIONS(478),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(478),
    [anon_sym_BQUOTE] = ACTIONS(478),
    [anon_sym_LT_LPAREN] = ACTIONS(478),
    [anon_sym_GT_LPAREN] = ACTIONS(478),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1486),
    [sym_word] = ACTIONS(480),
  },
  [364] = {
    [sym_string] = STATE(772),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [anon_sym_DOLLAR] = ACTIONS(1488),
    [anon_sym_POUND] = ACTIONS(1488),
    [anon_sym_DASH] = ACTIONS(1488),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1490),
    [anon_sym_STAR] = ACTIONS(1488),
    [anon_sym_AT] = ACTIONS(1488),
    [anon_sym_QMARK] = ACTIONS(1488),
    [anon_sym_0] = ACTIONS(1492),
    [anon_sym__] = ACTIONS(1492),
  },
  [365] = {
    [sym_subscript] = STATE(777),
    [sym_variable_name] = ACTIONS(1494),
    [anon_sym_DOLLAR] = ACTIONS(1496),
    [anon_sym_POUND] = ACTIONS(1498),
    [anon_sym_DASH] = ACTIONS(1496),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1500),
    [anon_sym_STAR] = ACTIONS(1496),
    [anon_sym_AT] = ACTIONS(1496),
    [anon_sym_QMARK] = ACTIONS(1496),
    [anon_sym_0] = ACTIONS(1502),
    [anon_sym__] = ACTIONS(1502),
  },
  [366] = {
    [sym_for_statement] = STATE(778),
    [sym_while_statement] = STATE(778),
    [sym_if_statement] = STATE(778),
    [sym_case_statement] = STATE(778),
    [sym_function_definition] = STATE(778),
    [sym_subshell] = STATE(778),
    [sym_pipeline] = STATE(778),
    [sym_list] = STATE(778),
    [sym_command] = STATE(778),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(779),
    [sym_declaration_command] = STATE(778),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [367] = {
    [sym_for_statement] = STATE(780),
    [sym_while_statement] = STATE(780),
    [sym_if_statement] = STATE(780),
    [sym_case_statement] = STATE(780),
    [sym_function_definition] = STATE(780),
    [sym_subshell] = STATE(780),
    [sym_pipeline] = STATE(780),
    [sym_list] = STATE(780),
    [sym_command] = STATE(780),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(781),
    [sym_declaration_command] = STATE(780),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [368] = {
    [sym_for_statement] = STATE(782),
    [sym_while_statement] = STATE(782),
    [sym_if_statement] = STATE(782),
    [sym_case_statement] = STATE(782),
    [sym_function_definition] = STATE(782),
    [sym_subshell] = STATE(782),
    [sym_pipeline] = STATE(782),
    [sym_list] = STATE(782),
    [sym_command] = STATE(782),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(783),
    [sym_declaration_command] = STATE(782),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [369] = {
    [sym_variable_name] = ACTIONS(500),
    [anon_sym_PIPE] = ACTIONS(1504),
    [anon_sym_RPAREN] = ACTIONS(500),
    [anon_sym_PIPE_AMP] = ACTIONS(500),
    [anon_sym_AMP_AMP] = ACTIONS(500),
    [anon_sym_PIPE_PIPE] = ACTIONS(500),
    [sym__special_characters] = ACTIONS(1504),
    [anon_sym_DQUOTE] = ACTIONS(500),
    [sym_raw_string] = ACTIONS(500),
    [anon_sym_DOLLAR] = ACTIONS(1504),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(500),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(500),
    [anon_sym_BQUOTE] = ACTIONS(500),
    [anon_sym_LT_LPAREN] = ACTIONS(500),
    [anon_sym_GT_LPAREN] = ACTIONS(500),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1504),
    [sym_word] = ACTIONS(502),
  },
  [370] = {
    [sym_variable_name] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1486),
    [anon_sym_RPAREN] = ACTIONS(478),
    [anon_sym_PIPE_AMP] = ACTIONS(478),
    [anon_sym_AMP_AMP] = ACTIONS(478),
    [anon_sym_PIPE_PIPE] = ACTIONS(478),
    [sym__special_characters] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(478),
    [sym_raw_string] = ACTIONS(478),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(478),
    [anon_sym_BQUOTE] = ACTIONS(478),
    [anon_sym_LT_LPAREN] = ACTIONS(478),
    [anon_sym_GT_LPAREN] = ACTIONS(478),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1486),
    [sym_word] = ACTIONS(480),
  },
  [371] = {
    [sym__assignment] = STATE(765),
    [anon_sym_EQ] = ACTIONS(1478),
    [anon_sym_PLUS_EQ] = ACTIONS(1478),
    [sym_comment] = ACTIONS(48),
  },
  [372] = {
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(371),
    [sym_concatenation] = STATE(370),
    [sym_string] = STATE(363),
    [sym_simple_expansion] = STATE(363),
    [sym_expansion] = STATE(363),
    [sym_command_substitution] = STATE(363),
    [sym_process_substitution] = STATE(363),
    [aux_sym_declaration_command_repeat1] = STATE(784),
    [sym_variable_name] = ACTIONS(636),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_RPAREN] = ACTIONS(1508),
    [anon_sym_PIPE_AMP] = ACTIONS(1508),
    [anon_sym_AMP_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1508),
    [sym__special_characters] = ACTIONS(642),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(646),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_LT_LPAREN] = ACTIONS(656),
    [anon_sym_GT_LPAREN] = ACTIONS(656),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(658),
    [sym_word] = ACTIONS(660),
  },
  [373] = {
    [sym_string] = STATE(785),
    [sym_simple_expansion] = STATE(785),
    [sym_expansion] = STATE(785),
    [sym_command_substitution] = STATE(785),
    [sym_process_substitution] = STATE(785),
    [sym__special_characters] = ACTIONS(1510),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(1512),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1510),
  },
  [374] = {
    [aux_sym_concatenation_repeat1] = STATE(786),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_RPAREN] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_AMP_GT] = ACTIONS(1270),
    [anon_sym_AMP_GT_GT] = ACTIONS(538),
    [anon_sym_LT_AMP] = ACTIONS(538),
    [anon_sym_GT_AMP] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_LT_LT_DASH] = ACTIONS(538),
    [anon_sym_LT_LT_LT] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1270),
  },
  [375] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(1272),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(1272),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [anon_sym_LT_LT_LT] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1272),
  },
  [376] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1514),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [377] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(1276),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_LT_LT_DASH] = ACTIONS(572),
    [anon_sym_LT_LT_LT] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1276),
  },
  [378] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(1278),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_LT_LT_DASH] = ACTIONS(576),
    [anon_sym_LT_LT_LT] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1278),
  },
  [379] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1280),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(1280),
    [anon_sym_LT_LT_DASH] = ACTIONS(580),
    [anon_sym_LT_LT_LT] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1280),
  },
  [380] = {
    [anon_sym_EQ] = ACTIONS(1516),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [381] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(790),
    [anon_sym_RBRACE] = ACTIONS(1518),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [382] = {
    [sym_subscript] = STATE(794),
    [sym_variable_name] = ACTIONS(1520),
    [anon_sym_DOLLAR] = ACTIONS(1522),
    [anon_sym_DASH] = ACTIONS(1522),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1524),
    [anon_sym_STAR] = ACTIONS(1522),
    [anon_sym_AT] = ACTIONS(1522),
    [anon_sym_QMARK] = ACTIONS(1522),
    [anon_sym_0] = ACTIONS(1526),
    [anon_sym__] = ACTIONS(1526),
  },
  [383] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(796),
    [anon_sym_RBRACE] = ACTIONS(1528),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [384] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(798),
    [anon_sym_RBRACE] = ACTIONS(1530),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [385] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [386] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1532),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [387] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [sym_comment] = ACTIONS(48),
  },
  [388] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1532),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [389] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [390] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1534),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [391] = {
    [anon_sym_RPAREN] = ACTIONS(1536),
    [sym_comment] = ACTIONS(48),
  },
  [392] = {
    [sym_for_statement] = STATE(802),
    [sym_while_statement] = STATE(802),
    [sym_if_statement] = STATE(802),
    [sym_case_statement] = STATE(802),
    [sym_function_definition] = STATE(802),
    [sym_subshell] = STATE(802),
    [sym_pipeline] = STATE(802),
    [sym_list] = STATE(802),
    [sym_command] = STATE(802),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(803),
    [sym_declaration_command] = STATE(802),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [393] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_LT_LT_DASH] = ACTIONS(1540),
    [anon_sym_LT_LT_LT] = ACTIONS(1540),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [394] = {
    [sym_for_statement] = STATE(804),
    [sym_while_statement] = STATE(804),
    [sym_if_statement] = STATE(804),
    [sym_case_statement] = STATE(804),
    [sym_function_definition] = STATE(804),
    [sym_subshell] = STATE(804),
    [sym_pipeline] = STATE(804),
    [sym_list] = STATE(804),
    [sym_command] = STATE(804),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(805),
    [sym_declaration_command] = STATE(804),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [395] = {
    [anon_sym_LT] = ACTIONS(1542),
    [anon_sym_GT] = ACTIONS(1542),
    [anon_sym_GT_GT] = ACTIONS(1544),
    [anon_sym_AMP_GT] = ACTIONS(1542),
    [anon_sym_AMP_GT_GT] = ACTIONS(1544),
    [anon_sym_LT_AMP] = ACTIONS(1544),
    [anon_sym_GT_AMP] = ACTIONS(1544),
    [sym_comment] = ACTIONS(48),
  },
  [396] = {
    [sym_concatenation] = STATE(815),
    [sym_string] = STATE(809),
    [sym_simple_expansion] = STATE(809),
    [sym_expansion] = STATE(809),
    [sym_command_substitution] = STATE(809),
    [sym_process_substitution] = STATE(809),
    [sym__special_characters] = ACTIONS(1546),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(1550),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1556),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [anon_sym_LT_LPAREN] = ACTIONS(1560),
    [anon_sym_GT_LPAREN] = ACTIONS(1560),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1562),
  },
  [397] = {
    [sym_heredoc] = STATE(818),
    [sym__simple_heredoc] = ACTIONS(1564),
    [sym__heredoc_beginning] = ACTIONS(1566),
    [sym_comment] = ACTIONS(48),
  },
  [398] = {
    [sym_concatenation] = STATE(821),
    [sym_string] = STATE(820),
    [sym_simple_expansion] = STATE(820),
    [sym_expansion] = STATE(820),
    [sym_command_substitution] = STATE(820),
    [sym_process_substitution] = STATE(820),
    [sym__special_characters] = ACTIONS(1568),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(1570),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1556),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [anon_sym_LT_LPAREN] = ACTIONS(1560),
    [anon_sym_GT_LPAREN] = ACTIONS(1560),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1572),
  },
  [399] = {
    [aux_sym_concatenation_repeat1] = STATE(374),
    [sym_file_descriptor] = ACTIONS(828),
    [sym__concat] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_RPAREN] = ACTIONS(828),
    [anon_sym_PIPE_AMP] = ACTIONS(828),
    [anon_sym_AMP_AMP] = ACTIONS(828),
    [anon_sym_PIPE_PIPE] = ACTIONS(828),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_GT_GT] = ACTIONS(828),
    [anon_sym_AMP_GT] = ACTIONS(1574),
    [anon_sym_AMP_GT_GT] = ACTIONS(828),
    [anon_sym_LT_AMP] = ACTIONS(828),
    [anon_sym_GT_AMP] = ACTIONS(828),
    [anon_sym_LT_LT] = ACTIONS(1574),
    [anon_sym_LT_LT_DASH] = ACTIONS(828),
    [anon_sym_LT_LT_LT] = ACTIONS(828),
    [sym__special_characters] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(828),
    [anon_sym_DOLLAR] = ACTIONS(1574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(828),
    [anon_sym_BQUOTE] = ACTIONS(828),
    [anon_sym_LT_LPAREN] = ACTIONS(828),
    [anon_sym_GT_LPAREN] = ACTIONS(828),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1574),
  },
  [400] = {
    [aux_sym_concatenation_repeat1] = STATE(374),
    [sym_file_descriptor] = ACTIONS(832),
    [sym__concat] = ACTIONS(662),
    [anon_sym_PIPE] = ACTIONS(1576),
    [anon_sym_RPAREN] = ACTIONS(832),
    [anon_sym_PIPE_AMP] = ACTIONS(832),
    [anon_sym_AMP_AMP] = ACTIONS(832),
    [anon_sym_PIPE_PIPE] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(1576),
    [anon_sym_GT] = ACTIONS(1576),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_AMP_GT] = ACTIONS(1576),
    [anon_sym_AMP_GT_GT] = ACTIONS(832),
    [anon_sym_LT_AMP] = ACTIONS(832),
    [anon_sym_GT_AMP] = ACTIONS(832),
    [anon_sym_LT_LT] = ACTIONS(1576),
    [anon_sym_LT_LT_DASH] = ACTIONS(832),
    [anon_sym_LT_LT_LT] = ACTIONS(832),
    [sym__special_characters] = ACTIONS(1576),
    [anon_sym_DQUOTE] = ACTIONS(832),
    [sym_raw_string] = ACTIONS(832),
    [anon_sym_DOLLAR] = ACTIONS(1576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(832),
    [anon_sym_LT_LPAREN] = ACTIONS(832),
    [anon_sym_GT_LPAREN] = ACTIONS(832),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1576),
  },
  [401] = {
    [sym_file_descriptor] = ACTIONS(836),
    [anon_sym_PIPE] = ACTIONS(1578),
    [anon_sym_RPAREN] = ACTIONS(836),
    [anon_sym_PIPE_AMP] = ACTIONS(836),
    [anon_sym_AMP_AMP] = ACTIONS(836),
    [anon_sym_PIPE_PIPE] = ACTIONS(836),
    [anon_sym_LT] = ACTIONS(1578),
    [anon_sym_GT] = ACTIONS(1578),
    [anon_sym_GT_GT] = ACTIONS(836),
    [anon_sym_AMP_GT] = ACTIONS(1578),
    [anon_sym_AMP_GT_GT] = ACTIONS(836),
    [anon_sym_LT_AMP] = ACTIONS(836),
    [anon_sym_GT_AMP] = ACTIONS(836),
    [anon_sym_LT_LT] = ACTIONS(1578),
    [anon_sym_LT_LT_DASH] = ACTIONS(836),
    [anon_sym_LT_LT_LT] = ACTIONS(836),
    [anon_sym_BQUOTE] = ACTIONS(836),
    [sym_comment] = ACTIONS(48),
  },
  [402] = {
    [sym_file_descriptor] = ACTIONS(832),
    [anon_sym_PIPE] = ACTIONS(1576),
    [anon_sym_RPAREN] = ACTIONS(832),
    [anon_sym_PIPE_AMP] = ACTIONS(832),
    [anon_sym_AMP_AMP] = ACTIONS(832),
    [anon_sym_PIPE_PIPE] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(1576),
    [anon_sym_GT] = ACTIONS(1576),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_AMP_GT] = ACTIONS(1576),
    [anon_sym_AMP_GT_GT] = ACTIONS(832),
    [anon_sym_LT_AMP] = ACTIONS(832),
    [anon_sym_GT_AMP] = ACTIONS(832),
    [anon_sym_LT_LT] = ACTIONS(1576),
    [anon_sym_LT_LT_DASH] = ACTIONS(832),
    [anon_sym_LT_LT_LT] = ACTIONS(832),
    [sym__special_characters] = ACTIONS(1576),
    [anon_sym_DQUOTE] = ACTIONS(832),
    [sym_raw_string] = ACTIONS(832),
    [anon_sym_DOLLAR] = ACTIONS(1576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(832),
    [anon_sym_LT_LPAREN] = ACTIONS(832),
    [anon_sym_GT_LPAREN] = ACTIONS(832),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1576),
  },
  [403] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(822),
    [aux_sym_while_statement_repeat1] = STATE(823),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym__special_characters] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(716),
  },
  [404] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(824),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym_comment] = ACTIONS(48),
  },
  [405] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(825),
    [aux_sym_while_statement_repeat1] = STATE(823),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_RPAREN] = ACTIONS(1582),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym__special_characters] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(716),
  },
  [406] = {
    [sym_concatenation] = STATE(739),
    [sym_string] = STATE(828),
    [sym_array] = STATE(739),
    [sym_simple_expansion] = STATE(828),
    [sym_expansion] = STATE(828),
    [sym_command_substitution] = STATE(828),
    [sym_process_substitution] = STATE(828),
    [sym__empty_value] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [sym__special_characters] = ACTIONS(1584),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [sym_raw_string] = ACTIONS(1588),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1592),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1600),
  },
  [407] = {
    [sym_do_group] = STATE(834),
    [anon_sym_do] = ACTIONS(1458),
    [sym_comment] = ACTIONS(48),
  },
  [408] = {
    [sym_compound_statement] = STATE(836),
    [anon_sym_LPAREN] = ACTIONS(1602),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [sym_comment] = ACTIONS(48),
  },
  [409] = {
    [sym__assignment] = STATE(765),
    [anon_sym_EQ] = ACTIONS(1604),
    [anon_sym_PLUS_EQ] = ACTIONS(1604),
    [anon_sym_LBRACK] = ACTIONS(58),
    [sym_comment] = ACTIONS(48),
  },
  [410] = {
    [aux_sym_concatenation_repeat1] = STATE(839),
    [sym__concat] = ACTIONS(1606),
    [sym_variable_name] = ACTIONS(472),
    [anon_sym_PIPE] = ACTIONS(1482),
    [anon_sym_PIPE_AMP] = ACTIONS(472),
    [anon_sym_AMP_AMP] = ACTIONS(472),
    [anon_sym_PIPE_PIPE] = ACTIONS(472),
    [sym__special_characters] = ACTIONS(1482),
    [anon_sym_DQUOTE] = ACTIONS(472),
    [sym_raw_string] = ACTIONS(472),
    [anon_sym_DOLLAR] = ACTIONS(1482),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(472),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(472),
    [anon_sym_BQUOTE] = ACTIONS(472),
    [anon_sym_LT_LPAREN] = ACTIONS(472),
    [anon_sym_GT_LPAREN] = ACTIONS(472),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1482),
    [sym_word] = ACTIONS(474),
  },
  [411] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(841),
    [anon_sym_DQUOTE] = ACTIONS(1608),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [412] = {
    [aux_sym_concatenation_repeat1] = STATE(839),
    [sym__concat] = ACTIONS(1606),
    [sym_variable_name] = ACTIONS(478),
    [anon_sym_PIPE] = ACTIONS(1486),
    [anon_sym_PIPE_AMP] = ACTIONS(478),
    [anon_sym_AMP_AMP] = ACTIONS(478),
    [anon_sym_PIPE_PIPE] = ACTIONS(478),
    [sym__special_characters] = ACTIONS(1486),
    [anon_sym_DQUOTE] = ACTIONS(478),
    [sym_raw_string] = ACTIONS(478),
    [anon_sym_DOLLAR] = ACTIONS(1486),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(478),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(478),
    [anon_sym_BQUOTE] = ACTIONS(478),
    [anon_sym_LT_LPAREN] = ACTIONS(478),
    [anon_sym_GT_LPAREN] = ACTIONS(478),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1486),
    [sym_word] = ACTIONS(480),
  },
  [413] = {
    [sym_string] = STATE(844),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [anon_sym_DOLLAR] = ACTIONS(1610),
    [anon_sym_POUND] = ACTIONS(1610),
    [anon_sym_DASH] = ACTIONS(1610),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1612),
    [anon_sym_STAR] = ACTIONS(1610),
    [anon_sym_AT] = ACTIONS(1610),
    [anon_sym_QMARK] = ACTIONS(1610),
    [anon_sym_0] = ACTIONS(1614),
    [anon_sym__] = ACTIONS(1614),
  },
  [414] = {
    [sym_subscript] = STATE(849),
    [sym_variable_name] = ACTIONS(1616),
    [anon_sym_DOLLAR] = ACTIONS(1618),
    [anon_sym_POUND] = ACTIONS(1620),
    [anon_sym_DASH] = ACTIONS(1618),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1622),
    [anon_sym_STAR] = ACTIONS(1618),
    [anon_sym_AT] = ACTIONS(1618),
    [anon_sym_QMARK] = ACTIONS(1618),
    [anon_sym_0] = ACTIONS(1624),
    [anon_sym__] = ACTIONS(1624),
  },
  [415] = {
    [sym_for_statement] = STATE(850),
    [sym_while_statement] = STATE(850),
    [sym_if_statement] = STATE(850),
    [sym_case_statement] = STATE(850),
    [sym_function_definition] = STATE(850),
    [sym_subshell] = STATE(850),
    [sym_pipeline] = STATE(850),
    [sym_list] = STATE(850),
    [sym_command] = STATE(850),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(851),
    [sym_declaration_command] = STATE(850),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [416] = {
    [sym_for_statement] = STATE(852),
    [sym_while_statement] = STATE(852),
    [sym_if_statement] = STATE(852),
    [sym_case_statement] = STATE(852),
    [sym_function_definition] = STATE(852),
    [sym_subshell] = STATE(852),
    [sym_pipeline] = STATE(852),
    [sym_list] = STATE(852),
    [sym_command] = STATE(852),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(853),
    [sym_declaration_command] = STATE(852),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [417] = {
    [sym_for_statement] = STATE(854),
    [sym_while_statement] = STATE(854),
    [sym_if_statement] = STATE(854),
    [sym_case_statement] = STATE(854),
    [sym_function_definition] = STATE(854),
    [sym_subshell] = STATE(854),
    [sym_pipeline] = STATE(854),
    [sym_list] = STATE(854),
    [sym_command] = STATE(854),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(855),
    [sym_declaration_command] = STATE(854),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [418] = {
    [sym__assignment] = STATE(765),
    [anon_sym_EQ] = ACTIONS(1604),
    [anon_sym_PLUS_EQ] = ACTIONS(1604),
    [sym_comment] = ACTIONS(48),
  },
  [419] = {
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(418),
    [sym_concatenation] = STATE(370),
    [sym_string] = STATE(412),
    [sym_simple_expansion] = STATE(412),
    [sym_expansion] = STATE(412),
    [sym_command_substitution] = STATE(412),
    [sym_process_substitution] = STATE(412),
    [aux_sym_declaration_command_repeat1] = STATE(856),
    [sym_variable_name] = ACTIONS(724),
    [anon_sym_PIPE] = ACTIONS(1506),
    [anon_sym_PIPE_AMP] = ACTIONS(1508),
    [anon_sym_AMP_AMP] = ACTIONS(1508),
    [anon_sym_PIPE_PIPE] = ACTIONS(1508),
    [sym__special_characters] = ACTIONS(726),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(730),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(1508),
    [anon_sym_LT_LPAREN] = ACTIONS(738),
    [anon_sym_GT_LPAREN] = ACTIONS(738),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(658),
    [sym_word] = ACTIONS(740),
  },
  [420] = {
    [sym_string] = STATE(857),
    [sym_simple_expansion] = STATE(857),
    [sym_expansion] = STATE(857),
    [sym_command_substitution] = STATE(857),
    [sym_process_substitution] = STATE(857),
    [sym__special_characters] = ACTIONS(1626),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(1628),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1626),
  },
  [421] = {
    [aux_sym_concatenation_repeat1] = STATE(858),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_AMP_GT] = ACTIONS(1270),
    [anon_sym_AMP_GT_GT] = ACTIONS(538),
    [anon_sym_LT_AMP] = ACTIONS(538),
    [anon_sym_GT_AMP] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_LT_LT_DASH] = ACTIONS(538),
    [anon_sym_LT_LT_LT] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1270),
  },
  [422] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(1272),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(1272),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [anon_sym_LT_LT_LT] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1272),
  },
  [423] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1630),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [424] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(1276),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_LT_LT_DASH] = ACTIONS(572),
    [anon_sym_LT_LT_LT] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1276),
  },
  [425] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(1278),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_LT_LT_DASH] = ACTIONS(576),
    [anon_sym_LT_LT_LT] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1278),
  },
  [426] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1280),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(1280),
    [anon_sym_LT_LT_DASH] = ACTIONS(580),
    [anon_sym_LT_LT_LT] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1280),
  },
  [427] = {
    [anon_sym_EQ] = ACTIONS(1632),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [428] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(862),
    [anon_sym_RBRACE] = ACTIONS(1634),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [429] = {
    [sym_subscript] = STATE(866),
    [sym_variable_name] = ACTIONS(1636),
    [anon_sym_DOLLAR] = ACTIONS(1638),
    [anon_sym_DASH] = ACTIONS(1638),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1640),
    [anon_sym_STAR] = ACTIONS(1638),
    [anon_sym_AT] = ACTIONS(1638),
    [anon_sym_QMARK] = ACTIONS(1638),
    [anon_sym_0] = ACTIONS(1642),
    [anon_sym__] = ACTIONS(1642),
  },
  [430] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(868),
    [anon_sym_RBRACE] = ACTIONS(1644),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [431] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(870),
    [anon_sym_RBRACE] = ACTIONS(1646),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [432] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [433] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1648),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [434] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [sym_comment] = ACTIONS(48),
  },
  [435] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1648),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [436] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [437] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1650),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [438] = {
    [anon_sym_RPAREN] = ACTIONS(1652),
    [sym_comment] = ACTIONS(48),
  },
  [439] = {
    [sym_for_statement] = STATE(802),
    [sym_while_statement] = STATE(802),
    [sym_if_statement] = STATE(802),
    [sym_case_statement] = STATE(802),
    [sym_function_definition] = STATE(802),
    [sym_subshell] = STATE(802),
    [sym_pipeline] = STATE(802),
    [sym_list] = STATE(802),
    [sym_command] = STATE(802),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(874),
    [sym_declaration_command] = STATE(802),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [440] = {
    [sym_for_statement] = STATE(875),
    [sym_while_statement] = STATE(875),
    [sym_if_statement] = STATE(875),
    [sym_case_statement] = STATE(875),
    [sym_function_definition] = STATE(875),
    [sym_subshell] = STATE(875),
    [sym_pipeline] = STATE(875),
    [sym_list] = STATE(875),
    [sym_command] = STATE(875),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(876),
    [sym_declaration_command] = STATE(875),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [441] = {
    [anon_sym_LT] = ACTIONS(1654),
    [anon_sym_GT] = ACTIONS(1654),
    [anon_sym_GT_GT] = ACTIONS(1656),
    [anon_sym_AMP_GT] = ACTIONS(1654),
    [anon_sym_AMP_GT_GT] = ACTIONS(1656),
    [anon_sym_LT_AMP] = ACTIONS(1656),
    [anon_sym_GT_AMP] = ACTIONS(1656),
    [sym_comment] = ACTIONS(48),
  },
  [442] = {
    [sym_concatenation] = STATE(815),
    [sym_string] = STATE(880),
    [sym_simple_expansion] = STATE(880),
    [sym_expansion] = STATE(880),
    [sym_command_substitution] = STATE(880),
    [sym_process_substitution] = STATE(880),
    [sym__special_characters] = ACTIONS(1658),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [sym_raw_string] = ACTIONS(1662),
    [anon_sym_DOLLAR] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1668),
    [anon_sym_BQUOTE] = ACTIONS(1670),
    [anon_sym_LT_LPAREN] = ACTIONS(1672),
    [anon_sym_GT_LPAREN] = ACTIONS(1672),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1674),
  },
  [443] = {
    [sym_concatenation] = STATE(821),
    [sym_string] = STATE(887),
    [sym_simple_expansion] = STATE(887),
    [sym_expansion] = STATE(887),
    [sym_command_substitution] = STATE(887),
    [sym_process_substitution] = STATE(887),
    [sym__special_characters] = ACTIONS(1676),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [sym_raw_string] = ACTIONS(1678),
    [anon_sym_DOLLAR] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1668),
    [anon_sym_BQUOTE] = ACTIONS(1670),
    [anon_sym_LT_LPAREN] = ACTIONS(1672),
    [anon_sym_GT_LPAREN] = ACTIONS(1672),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1680),
  },
  [444] = {
    [aux_sym_concatenation_repeat1] = STATE(421),
    [sym_file_descriptor] = ACTIONS(828),
    [sym__concat] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(1574),
    [anon_sym_PIPE_AMP] = ACTIONS(828),
    [anon_sym_AMP_AMP] = ACTIONS(828),
    [anon_sym_PIPE_PIPE] = ACTIONS(828),
    [anon_sym_LT] = ACTIONS(1574),
    [anon_sym_GT] = ACTIONS(1574),
    [anon_sym_GT_GT] = ACTIONS(828),
    [anon_sym_AMP_GT] = ACTIONS(1574),
    [anon_sym_AMP_GT_GT] = ACTIONS(828),
    [anon_sym_LT_AMP] = ACTIONS(828),
    [anon_sym_GT_AMP] = ACTIONS(828),
    [anon_sym_LT_LT] = ACTIONS(1574),
    [anon_sym_LT_LT_DASH] = ACTIONS(828),
    [anon_sym_LT_LT_LT] = ACTIONS(828),
    [sym__special_characters] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(828),
    [anon_sym_DOLLAR] = ACTIONS(1574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(828),
    [anon_sym_BQUOTE] = ACTIONS(828),
    [anon_sym_LT_LPAREN] = ACTIONS(828),
    [anon_sym_GT_LPAREN] = ACTIONS(828),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1574),
  },
  [445] = {
    [aux_sym_concatenation_repeat1] = STATE(421),
    [sym_file_descriptor] = ACTIONS(832),
    [sym__concat] = ACTIONS(742),
    [anon_sym_PIPE] = ACTIONS(1576),
    [anon_sym_PIPE_AMP] = ACTIONS(832),
    [anon_sym_AMP_AMP] = ACTIONS(832),
    [anon_sym_PIPE_PIPE] = ACTIONS(832),
    [anon_sym_LT] = ACTIONS(1576),
    [anon_sym_GT] = ACTIONS(1576),
    [anon_sym_GT_GT] = ACTIONS(832),
    [anon_sym_AMP_GT] = ACTIONS(1576),
    [anon_sym_AMP_GT_GT] = ACTIONS(832),
    [anon_sym_LT_AMP] = ACTIONS(832),
    [anon_sym_GT_AMP] = ACTIONS(832),
    [anon_sym_LT_LT] = ACTIONS(1576),
    [anon_sym_LT_LT_DASH] = ACTIONS(832),
    [anon_sym_LT_LT_LT] = ACTIONS(832),
    [sym__special_characters] = ACTIONS(1576),
    [anon_sym_DQUOTE] = ACTIONS(832),
    [sym_raw_string] = ACTIONS(832),
    [anon_sym_DOLLAR] = ACTIONS(1576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(832),
    [anon_sym_LT_LPAREN] = ACTIONS(832),
    [anon_sym_GT_LPAREN] = ACTIONS(832),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1576),
  },
  [446] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(445),
    [sym_simple_expansion] = STATE(445),
    [sym_expansion] = STATE(445),
    [sym_command_substitution] = STATE(445),
    [sym_process_substitution] = STATE(445),
    [aux_sym_for_statement_repeat1] = STATE(888),
    [aux_sym_while_statement_repeat1] = STATE(889),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [sym__special_characters] = ACTIONS(778),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(780),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(782),
  },
  [447] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(890),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [sym_comment] = ACTIONS(48),
  },
  [448] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(445),
    [sym_simple_expansion] = STATE(445),
    [sym_expansion] = STATE(445),
    [sym_command_substitution] = STATE(445),
    [sym_process_substitution] = STATE(445),
    [aux_sym_for_statement_repeat1] = STATE(891),
    [aux_sym_while_statement_repeat1] = STATE(889),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(1580),
    [anon_sym_PIPE_AMP] = ACTIONS(1582),
    [anon_sym_AMP_AMP] = ACTIONS(1582),
    [anon_sym_PIPE_PIPE] = ACTIONS(1582),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [sym__special_characters] = ACTIONS(778),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(780),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(1582),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(782),
  },
  [449] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT_GT] = ACTIONS(1684),
    [anon_sym_LT_AMP] = ACTIONS(1684),
    [anon_sym_GT_AMP] = ACTIONS(1684),
    [anon_sym_LT_LT] = ACTIONS(1684),
    [anon_sym_LT_LT_DASH] = ACTIONS(1684),
    [anon_sym_LT_LT_LT] = ACTIONS(1684),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LT_LPAREN] = ACTIONS(1684),
    [anon_sym_GT_LPAREN] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [450] = {
    [sym_compound_statement] = STATE(892),
    [anon_sym_LBRACE] = ACTIONS(390),
    [sym_comment] = ACTIONS(48),
  },
  [451] = {
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_SEMI_SEMI] = ACTIONS(1686),
    [anon_sym_PIPE_AMP] = ACTIONS(1686),
    [anon_sym_AMP_AMP] = ACTIONS(1686),
    [anon_sym_PIPE_PIPE] = ACTIONS(1686),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_LF] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
  },
  [452] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(1686),
    [anon_sym_RPAREN] = ACTIONS(1686),
    [anon_sym_SEMI_SEMI] = ACTIONS(1686),
    [anon_sym_PIPE_AMP] = ACTIONS(1686),
    [anon_sym_AMP_AMP] = ACTIONS(1686),
    [anon_sym_PIPE_PIPE] = ACTIONS(1686),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(1686),
    [anon_sym_LF] = ACTIONS(1686),
    [anon_sym_AMP] = ACTIONS(1686),
  },
  [453] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [454] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [455] = {
    [sym_concatenation] = STATE(895),
    [sym_string] = STATE(894),
    [sym_simple_expansion] = STATE(894),
    [sym_expansion] = STATE(894),
    [sym_command_substitution] = STATE(894),
    [sym_process_substitution] = STATE(894),
    [sym__special_characters] = ACTIONS(1690),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [sym_raw_string] = ACTIONS(1692),
    [anon_sym_DOLLAR] = ACTIONS(806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(810),
    [anon_sym_BQUOTE] = ACTIONS(812),
    [anon_sym_LT_LPAREN] = ACTIONS(814),
    [anon_sym_GT_LPAREN] = ACTIONS(814),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1694),
  },
  [456] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(506),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(1698),
    [anon_sym_SEMI_SEMI] = ACTIONS(1698),
    [anon_sym_PIPE_AMP] = ACTIONS(1698),
    [anon_sym_AMP_AMP] = ACTIONS(1698),
    [anon_sym_PIPE_PIPE] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1698),
    [anon_sym_GT] = ACTIONS(1698),
    [anon_sym_GT_GT] = ACTIONS(1698),
    [anon_sym_AMP_GT] = ACTIONS(1698),
    [anon_sym_AMP_GT_GT] = ACTIONS(1698),
    [anon_sym_LT_AMP] = ACTIONS(1698),
    [anon_sym_GT_AMP] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1698),
    [anon_sym_LT_LT_DASH] = ACTIONS(1698),
    [anon_sym_LT_LT_LT] = ACTIONS(1698),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_LF] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
  },
  [457] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(899),
    [anon_sym_DQUOTE] = ACTIONS(1700),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [458] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(514),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_SEMI_SEMI] = ACTIONS(1702),
    [anon_sym_PIPE_AMP] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1702),
    [anon_sym_PIPE_PIPE] = ACTIONS(1702),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_GT] = ACTIONS(1702),
    [anon_sym_GT_GT] = ACTIONS(1702),
    [anon_sym_AMP_GT] = ACTIONS(1702),
    [anon_sym_AMP_GT_GT] = ACTIONS(1702),
    [anon_sym_LT_AMP] = ACTIONS(1702),
    [anon_sym_GT_AMP] = ACTIONS(1702),
    [anon_sym_LT_LT] = ACTIONS(1702),
    [anon_sym_LT_LT_DASH] = ACTIONS(1702),
    [anon_sym_LT_LT_LT] = ACTIONS(1702),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_LF] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
  },
  [459] = {
    [sym_string] = STATE(902),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [anon_sym_DOLLAR] = ACTIONS(1704),
    [anon_sym_POUND] = ACTIONS(1704),
    [anon_sym_DASH] = ACTIONS(1704),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1706),
    [anon_sym_STAR] = ACTIONS(1704),
    [anon_sym_AT] = ACTIONS(1704),
    [anon_sym_QMARK] = ACTIONS(1704),
    [anon_sym_0] = ACTIONS(1708),
    [anon_sym__] = ACTIONS(1708),
  },
  [460] = {
    [sym_subscript] = STATE(907),
    [sym_variable_name] = ACTIONS(1710),
    [anon_sym_DOLLAR] = ACTIONS(1712),
    [anon_sym_POUND] = ACTIONS(1714),
    [anon_sym_DASH] = ACTIONS(1712),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1716),
    [anon_sym_STAR] = ACTIONS(1712),
    [anon_sym_AT] = ACTIONS(1712),
    [anon_sym_QMARK] = ACTIONS(1712),
    [anon_sym_0] = ACTIONS(1718),
    [anon_sym__] = ACTIONS(1718),
  },
  [461] = {
    [sym_for_statement] = STATE(908),
    [sym_while_statement] = STATE(908),
    [sym_if_statement] = STATE(908),
    [sym_case_statement] = STATE(908),
    [sym_function_definition] = STATE(908),
    [sym_subshell] = STATE(908),
    [sym_pipeline] = STATE(908),
    [sym_list] = STATE(908),
    [sym_command] = STATE(908),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(909),
    [sym_declaration_command] = STATE(908),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [462] = {
    [sym_for_statement] = STATE(910),
    [sym_while_statement] = STATE(910),
    [sym_if_statement] = STATE(910),
    [sym_case_statement] = STATE(910),
    [sym_function_definition] = STATE(910),
    [sym_subshell] = STATE(910),
    [sym_pipeline] = STATE(910),
    [sym_list] = STATE(910),
    [sym_command] = STATE(910),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(911),
    [sym_declaration_command] = STATE(910),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [463] = {
    [sym_for_statement] = STATE(912),
    [sym_while_statement] = STATE(912),
    [sym_if_statement] = STATE(912),
    [sym_case_statement] = STATE(912),
    [sym_function_definition] = STATE(912),
    [sym_subshell] = STATE(912),
    [sym_pipeline] = STATE(912),
    [sym_list] = STATE(912),
    [sym_command] = STATE(912),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(913),
    [sym_declaration_command] = STATE(912),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [464] = {
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_RPAREN] = ACTIONS(1702),
    [anon_sym_SEMI_SEMI] = ACTIONS(1702),
    [anon_sym_PIPE_AMP] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1702),
    [anon_sym_PIPE_PIPE] = ACTIONS(1702),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_GT] = ACTIONS(1702),
    [anon_sym_GT_GT] = ACTIONS(1702),
    [anon_sym_AMP_GT] = ACTIONS(1702),
    [anon_sym_AMP_GT_GT] = ACTIONS(1702),
    [anon_sym_LT_AMP] = ACTIONS(1702),
    [anon_sym_GT_AMP] = ACTIONS(1702),
    [anon_sym_LT_LT] = ACTIONS(1702),
    [anon_sym_LT_LT_DASH] = ACTIONS(1702),
    [anon_sym_LT_LT_LT] = ACTIONS(1702),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_LF] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
  },
  [465] = {
    [sym_file_descriptor] = ACTIONS(1720),
    [anon_sym_PIPE] = ACTIONS(1722),
    [anon_sym_RPAREN] = ACTIONS(1722),
    [anon_sym_SEMI_SEMI] = ACTIONS(1722),
    [anon_sym_PIPE_AMP] = ACTIONS(1722),
    [anon_sym_AMP_AMP] = ACTIONS(1722),
    [anon_sym_PIPE_PIPE] = ACTIONS(1722),
    [anon_sym_LT] = ACTIONS(1722),
    [anon_sym_GT] = ACTIONS(1722),
    [anon_sym_GT_GT] = ACTIONS(1722),
    [anon_sym_AMP_GT] = ACTIONS(1722),
    [anon_sym_AMP_GT_GT] = ACTIONS(1722),
    [anon_sym_LT_AMP] = ACTIONS(1722),
    [anon_sym_GT_AMP] = ACTIONS(1722),
    [anon_sym_LT_LT] = ACTIONS(1722),
    [anon_sym_LT_LT_DASH] = ACTIONS(1722),
    [anon_sym_LT_LT_LT] = ACTIONS(1722),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1722),
    [anon_sym_LF] = ACTIONS(1722),
    [anon_sym_AMP] = ACTIONS(1722),
  },
  [466] = {
    [sym_simple_expansion] = STATE(914),
    [sym_expansion] = STATE(914),
    [aux_sym_heredoc_repeat1] = STATE(918),
    [sym__heredoc_middle] = ACTIONS(1724),
    [sym__heredoc_end] = ACTIONS(1726),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1730),
    [sym_comment] = ACTIONS(48),
  },
  [467] = {
    [sym_file_descriptor] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(1734),
    [anon_sym_RPAREN] = ACTIONS(1734),
    [anon_sym_SEMI_SEMI] = ACTIONS(1734),
    [anon_sym_PIPE_AMP] = ACTIONS(1734),
    [anon_sym_AMP_AMP] = ACTIONS(1734),
    [anon_sym_PIPE_PIPE] = ACTIONS(1734),
    [anon_sym_LT] = ACTIONS(1734),
    [anon_sym_GT] = ACTIONS(1734),
    [anon_sym_GT_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT] = ACTIONS(1734),
    [anon_sym_AMP_GT_GT] = ACTIONS(1734),
    [anon_sym_LT_AMP] = ACTIONS(1734),
    [anon_sym_GT_AMP] = ACTIONS(1734),
    [anon_sym_LT_LT] = ACTIONS(1734),
    [anon_sym_LT_LT_DASH] = ACTIONS(1734),
    [anon_sym_LT_LT_LT] = ACTIONS(1734),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1734),
    [anon_sym_LF] = ACTIONS(1734),
    [anon_sym_AMP] = ACTIONS(1734),
  },
  [468] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(1736),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(1738),
    [anon_sym_SEMI_SEMI] = ACTIONS(1738),
    [anon_sym_PIPE_AMP] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1738),
    [anon_sym_GT] = ACTIONS(1738),
    [anon_sym_GT_GT] = ACTIONS(1738),
    [anon_sym_AMP_GT] = ACTIONS(1738),
    [anon_sym_AMP_GT_GT] = ACTIONS(1738),
    [anon_sym_LT_AMP] = ACTIONS(1738),
    [anon_sym_GT_AMP] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1738),
    [anon_sym_LT_LT_DASH] = ACTIONS(1738),
    [anon_sym_LT_LT_LT] = ACTIONS(1738),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_LF] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1738),
  },
  [469] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(1740),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_SEMI_SEMI] = ACTIONS(1742),
    [anon_sym_PIPE_AMP] = ACTIONS(1742),
    [anon_sym_AMP_AMP] = ACTIONS(1742),
    [anon_sym_PIPE_PIPE] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_GT] = ACTIONS(1742),
    [anon_sym_GT_GT] = ACTIONS(1742),
    [anon_sym_AMP_GT] = ACTIONS(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(1742),
    [anon_sym_LT_AMP] = ACTIONS(1742),
    [anon_sym_GT_AMP] = ACTIONS(1742),
    [anon_sym_LT_LT] = ACTIONS(1742),
    [anon_sym_LT_LT_DASH] = ACTIONS(1742),
    [anon_sym_LT_LT_LT] = ACTIONS(1742),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_LF] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
  },
  [470] = {
    [sym_file_descriptor] = ACTIONS(1740),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_RPAREN] = ACTIONS(1742),
    [anon_sym_SEMI_SEMI] = ACTIONS(1742),
    [anon_sym_PIPE_AMP] = ACTIONS(1742),
    [anon_sym_AMP_AMP] = ACTIONS(1742),
    [anon_sym_PIPE_PIPE] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_GT] = ACTIONS(1742),
    [anon_sym_GT_GT] = ACTIONS(1742),
    [anon_sym_AMP_GT] = ACTIONS(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(1742),
    [anon_sym_LT_AMP] = ACTIONS(1742),
    [anon_sym_GT_AMP] = ACTIONS(1742),
    [anon_sym_LT_LT] = ACTIONS(1742),
    [anon_sym_LT_LT_DASH] = ACTIONS(1742),
    [anon_sym_LT_LT_LT] = ACTIONS(1742),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_LF] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
  },
  [471] = {
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_command_substitution] = STATE(160),
    [sym_process_substitution] = STATE(160),
    [aux_sym_for_statement_repeat1] = STATE(471),
    [sym_file_descriptor] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1746),
    [anon_sym_LT_LT_LT] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(1748),
    [anon_sym_DQUOTE] = ACTIONS(1751),
    [sym_raw_string] = ACTIONS(1754),
    [anon_sym_DOLLAR] = ACTIONS(1757),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1760),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1763),
    [anon_sym_BQUOTE] = ACTIONS(1766),
    [anon_sym_LT_LPAREN] = ACTIONS(1769),
    [anon_sym_GT_LPAREN] = ACTIONS(1769),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1754),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1746),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [472] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(473),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_SEMI_SEMI] = ACTIONS(1772),
    [anon_sym_PIPE_AMP] = ACTIONS(1772),
    [anon_sym_AMP_AMP] = ACTIONS(1772),
    [anon_sym_PIPE_PIPE] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1772),
    [anon_sym_LF] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
  },
  [473] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(473),
    [sym_file_descriptor] = ACTIONS(1774),
    [anon_sym_PIPE] = ACTIONS(1777),
    [anon_sym_SEMI_SEMI] = ACTIONS(1777),
    [anon_sym_PIPE_AMP] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_LT] = ACTIONS(1779),
    [anon_sym_GT] = ACTIONS(1779),
    [anon_sym_GT_GT] = ACTIONS(1779),
    [anon_sym_AMP_GT] = ACTIONS(1779),
    [anon_sym_AMP_GT_GT] = ACTIONS(1779),
    [anon_sym_LT_AMP] = ACTIONS(1779),
    [anon_sym_GT_AMP] = ACTIONS(1779),
    [anon_sym_LT_LT] = ACTIONS(1782),
    [anon_sym_LT_LT_DASH] = ACTIONS(1782),
    [anon_sym_LT_LT_LT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1777),
    [anon_sym_LF] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1777),
  },
  [474] = {
    [sym_concatenation] = STATE(739),
    [sym_string] = STATE(920),
    [sym_array] = STATE(739),
    [sym_simple_expansion] = STATE(920),
    [sym_expansion] = STATE(920),
    [sym_command_substitution] = STATE(920),
    [sym_process_substitution] = STATE(920),
    [sym__empty_value] = ACTIONS(1432),
    [anon_sym_LPAREN] = ACTIONS(1434),
    [sym__special_characters] = ACTIONS(1788),
    [anon_sym_DQUOTE] = ACTIONS(134),
    [sym_raw_string] = ACTIONS(1790),
    [anon_sym_DOLLAR] = ACTIONS(138),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(140),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(142),
    [anon_sym_BQUOTE] = ACTIONS(144),
    [anon_sym_LT_LPAREN] = ACTIONS(146),
    [anon_sym_GT_LPAREN] = ACTIONS(146),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1792),
  },
  [475] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(160),
    [sym_simple_expansion] = STATE(160),
    [sym_expansion] = STATE(160),
    [sym_command_substitution] = STATE(160),
    [sym_process_substitution] = STATE(160),
    [aux_sym_for_statement_repeat1] = STATE(471),
    [aux_sym_while_statement_repeat1] = STATE(921),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_SEMI_SEMI] = ACTIONS(1772),
    [anon_sym_PIPE_AMP] = ACTIONS(1772),
    [anon_sym_AMP_AMP] = ACTIONS(1772),
    [anon_sym_PIPE_PIPE] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym__special_characters] = ACTIONS(274),
    [anon_sym_DQUOTE] = ACTIONS(276),
    [sym_raw_string] = ACTIONS(278),
    [anon_sym_DOLLAR] = ACTIONS(280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(282),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(284),
    [anon_sym_BQUOTE] = ACTIONS(286),
    [anon_sym_LT_LPAREN] = ACTIONS(288),
    [anon_sym_GT_LPAREN] = ACTIONS(288),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(278),
    [anon_sym_SEMI] = ACTIONS(1772),
    [anon_sym_LF] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
  },
  [476] = {
    [sym_file_descriptor] = ACTIONS(1794),
    [sym_variable_name] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(1796),
    [anon_sym_RPAREN] = ACTIONS(1796),
    [anon_sym_SEMI_SEMI] = ACTIONS(1796),
    [anon_sym_PIPE_AMP] = ACTIONS(1796),
    [anon_sym_AMP_AMP] = ACTIONS(1796),
    [anon_sym_PIPE_PIPE] = ACTIONS(1796),
    [anon_sym_LT] = ACTIONS(1796),
    [anon_sym_GT] = ACTIONS(1796),
    [anon_sym_GT_GT] = ACTIONS(1796),
    [anon_sym_AMP_GT] = ACTIONS(1796),
    [anon_sym_AMP_GT_GT] = ACTIONS(1796),
    [anon_sym_LT_AMP] = ACTIONS(1796),
    [anon_sym_GT_AMP] = ACTIONS(1796),
    [sym__special_characters] = ACTIONS(1796),
    [anon_sym_DQUOTE] = ACTIONS(1796),
    [sym_raw_string] = ACTIONS(1796),
    [anon_sym_DOLLAR] = ACTIONS(1796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1796),
    [anon_sym_BQUOTE] = ACTIONS(1796),
    [anon_sym_LT_LPAREN] = ACTIONS(1796),
    [anon_sym_GT_LPAREN] = ACTIONS(1796),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1796),
    [anon_sym_SEMI] = ACTIONS(1796),
    [anon_sym_LF] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1796),
  },
  [477] = {
    [aux_sym_concatenation_repeat1] = STATE(923),
    [sym__concat] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(828),
    [sym__special_characters] = ACTIONS(1574),
    [anon_sym_DQUOTE] = ACTIONS(828),
    [sym_raw_string] = ACTIONS(828),
    [anon_sym_DOLLAR] = ACTIONS(1574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(828),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(828),
    [anon_sym_BQUOTE] = ACTIONS(828),
    [anon_sym_LT_LPAREN] = ACTIONS(828),
    [anon_sym_GT_LPAREN] = ACTIONS(828),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1574),
  },
  [478] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(925),
    [anon_sym_DQUOTE] = ACTIONS(1800),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [479] = {
    [aux_sym_concatenation_repeat1] = STATE(923),
    [sym__concat] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(832),
    [sym__special_characters] = ACTIONS(1576),
    [anon_sym_DQUOTE] = ACTIONS(832),
    [sym_raw_string] = ACTIONS(832),
    [anon_sym_DOLLAR] = ACTIONS(1576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(832),
    [anon_sym_LT_LPAREN] = ACTIONS(832),
    [anon_sym_GT_LPAREN] = ACTIONS(832),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1576),
  },
  [480] = {
    [sym_string] = STATE(928),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [anon_sym_DOLLAR] = ACTIONS(1802),
    [anon_sym_POUND] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(1802),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1804),
    [anon_sym_STAR] = ACTIONS(1802),
    [anon_sym_AT] = ACTIONS(1802),
    [anon_sym_QMARK] = ACTIONS(1802),
    [anon_sym_0] = ACTIONS(1806),
    [anon_sym__] = ACTIONS(1806),
  },
  [481] = {
    [sym_subscript] = STATE(933),
    [sym_variable_name] = ACTIONS(1808),
    [anon_sym_DOLLAR] = ACTIONS(1810),
    [anon_sym_POUND] = ACTIONS(1812),
    [anon_sym_DASH] = ACTIONS(1810),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1814),
    [anon_sym_STAR] = ACTIONS(1810),
    [anon_sym_AT] = ACTIONS(1810),
    [anon_sym_QMARK] = ACTIONS(1810),
    [anon_sym_0] = ACTIONS(1816),
    [anon_sym__] = ACTIONS(1816),
  },
  [482] = {
    [sym_for_statement] = STATE(934),
    [sym_while_statement] = STATE(934),
    [sym_if_statement] = STATE(934),
    [sym_case_statement] = STATE(934),
    [sym_function_definition] = STATE(934),
    [sym_subshell] = STATE(934),
    [sym_pipeline] = STATE(934),
    [sym_list] = STATE(934),
    [sym_command] = STATE(934),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(935),
    [sym_declaration_command] = STATE(934),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [483] = {
    [sym_for_statement] = STATE(936),
    [sym_while_statement] = STATE(936),
    [sym_if_statement] = STATE(936),
    [sym_case_statement] = STATE(936),
    [sym_function_definition] = STATE(936),
    [sym_subshell] = STATE(936),
    [sym_pipeline] = STATE(936),
    [sym_list] = STATE(936),
    [sym_command] = STATE(936),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(937),
    [sym_declaration_command] = STATE(936),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [484] = {
    [sym_for_statement] = STATE(938),
    [sym_while_statement] = STATE(938),
    [sym_if_statement] = STATE(938),
    [sym_case_statement] = STATE(938),
    [sym_function_definition] = STATE(938),
    [sym_subshell] = STATE(938),
    [sym_pipeline] = STATE(938),
    [sym_list] = STATE(938),
    [sym_command] = STATE(938),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(939),
    [sym_declaration_command] = STATE(938),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [485] = {
    [anon_sym_RPAREN] = ACTIONS(832),
    [sym__special_characters] = ACTIONS(1576),
    [anon_sym_DQUOTE] = ACTIONS(832),
    [sym_raw_string] = ACTIONS(832),
    [anon_sym_DOLLAR] = ACTIONS(1576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(832),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(832),
    [anon_sym_BQUOTE] = ACTIONS(832),
    [anon_sym_LT_LPAREN] = ACTIONS(832),
    [anon_sym_GT_LPAREN] = ACTIONS(832),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1576),
  },
  [486] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(941),
    [anon_sym_RPAREN] = ACTIONS(1818),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [487] = {
    [sym_string] = STATE(942),
    [sym_simple_expansion] = STATE(942),
    [sym_expansion] = STATE(942),
    [sym_command_substitution] = STATE(942),
    [sym_process_substitution] = STATE(942),
    [sym__special_characters] = ACTIONS(1820),
    [anon_sym_DQUOTE] = ACTIONS(314),
    [sym_raw_string] = ACTIONS(1822),
    [anon_sym_DOLLAR] = ACTIONS(318),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(320),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(322),
    [anon_sym_BQUOTE] = ACTIONS(324),
    [anon_sym_LT_LPAREN] = ACTIONS(326),
    [anon_sym_GT_LPAREN] = ACTIONS(326),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1820),
  },
  [488] = {
    [aux_sym_concatenation_repeat1] = STATE(943),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(956),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_AMP_GT] = ACTIONS(540),
    [anon_sym_AMP_GT_GT] = ACTIONS(540),
    [anon_sym_LT_AMP] = ACTIONS(540),
    [anon_sym_GT_AMP] = ACTIONS(540),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [sym_raw_string] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(540),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(540),
    [anon_sym_GT_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [489] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [490] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1824),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [491] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [492] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_GT] = ACTIONS(578),
    [anon_sym_AMP_GT_GT] = ACTIONS(578),
    [anon_sym_LT_AMP] = ACTIONS(578),
    [anon_sym_GT_AMP] = ACTIONS(578),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [anon_sym_LT_LPAREN] = ACTIONS(578),
    [anon_sym_GT_LPAREN] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [493] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [494] = {
    [anon_sym_EQ] = ACTIONS(1826),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [495] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(947),
    [anon_sym_RBRACE] = ACTIONS(1828),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [496] = {
    [sym_subscript] = STATE(951),
    [sym_variable_name] = ACTIONS(1830),
    [anon_sym_DOLLAR] = ACTIONS(1832),
    [anon_sym_DASH] = ACTIONS(1832),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1834),
    [anon_sym_STAR] = ACTIONS(1832),
    [anon_sym_AT] = ACTIONS(1832),
    [anon_sym_QMARK] = ACTIONS(1832),
    [anon_sym_0] = ACTIONS(1836),
    [anon_sym__] = ACTIONS(1836),
  },
  [497] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(953),
    [anon_sym_RBRACE] = ACTIONS(1838),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [498] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(955),
    [anon_sym_RBRACE] = ACTIONS(1840),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [499] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [500] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1842),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [501] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [sym_comment] = ACTIONS(48),
  },
  [502] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1842),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [503] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1844),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [504] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1844),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [505] = {
    [sym_string] = STATE(959),
    [sym_simple_expansion] = STATE(959),
    [sym_expansion] = STATE(959),
    [sym_command_substitution] = STATE(959),
    [sym_process_substitution] = STATE(959),
    [anon_sym_RBRACK] = ACTIONS(1846),
    [sym__special_characters] = ACTIONS(1848),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(340),
    [anon_sym_BQUOTE] = ACTIONS(342),
    [anon_sym_LT_LPAREN] = ACTIONS(344),
    [anon_sym_GT_LPAREN] = ACTIONS(344),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1852),
  },
  [506] = {
    [sym__concat] = ACTIONS(1854),
    [anon_sym_EQ] = ACTIONS(1856),
    [anon_sym_PLUS_EQ] = ACTIONS(1856),
    [sym_comment] = ACTIONS(48),
  },
  [507] = {
    [aux_sym_concatenation_repeat1] = STATE(962),
    [sym__concat] = ACTIONS(1858),
    [anon_sym_RBRACK] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
  },
  [508] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_RBRACK] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [509] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(1860),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [510] = {
    [sym_string] = STATE(959),
    [sym_simple_expansion] = STATE(959),
    [sym_expansion] = STATE(959),
    [sym_command_substitution] = STATE(959),
    [sym_process_substitution] = STATE(959),
    [anon_sym_RBRACK] = ACTIONS(1862),
    [sym__special_characters] = ACTIONS(1848),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(340),
    [anon_sym_BQUOTE] = ACTIONS(342),
    [anon_sym_LT_LPAREN] = ACTIONS(344),
    [anon_sym_GT_LPAREN] = ACTIONS(344),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1852),
  },
  [511] = {
    [sym__concat] = ACTIONS(1864),
    [anon_sym_EQ] = ACTIONS(1866),
    [anon_sym_PLUS_EQ] = ACTIONS(1866),
    [sym_comment] = ACTIONS(48),
  },
  [512] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_RBRACK] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [513] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_RBRACK] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [514] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_RBRACK] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [515] = {
    [anon_sym_EQ] = ACTIONS(1868),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [516] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(968),
    [anon_sym_RBRACE] = ACTIONS(1870),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [517] = {
    [sym_subscript] = STATE(972),
    [sym_variable_name] = ACTIONS(1872),
    [anon_sym_DOLLAR] = ACTIONS(1874),
    [anon_sym_DASH] = ACTIONS(1874),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1876),
    [anon_sym_STAR] = ACTIONS(1874),
    [anon_sym_AT] = ACTIONS(1874),
    [anon_sym_QMARK] = ACTIONS(1874),
    [anon_sym_0] = ACTIONS(1878),
    [anon_sym__] = ACTIONS(1878),
  },
  [518] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(974),
    [anon_sym_RBRACE] = ACTIONS(1880),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [519] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(976),
    [anon_sym_RBRACE] = ACTIONS(1882),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [520] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [521] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1884),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [522] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [sym_comment] = ACTIONS(48),
  },
  [523] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(1884),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [524] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [525] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(1886),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [526] = {
    [anon_sym_RBRACK] = ACTIONS(1862),
    [sym_comment] = ACTIONS(48),
  },
  [527] = {
    [aux_sym_concatenation_repeat1] = STATE(980),
    [sym__concat] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(830),
    [sym__special_characters] = ACTIONS(830),
    [anon_sym_DQUOTE] = ACTIONS(830),
    [sym_raw_string] = ACTIONS(830),
    [anon_sym_DOLLAR] = ACTIONS(830),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(830),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(830),
    [anon_sym_BQUOTE] = ACTIONS(830),
    [anon_sym_LT_LPAREN] = ACTIONS(830),
    [anon_sym_GT_LPAREN] = ACTIONS(830),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(830),
    [anon_sym_SEMI] = ACTIONS(830),
    [anon_sym_LF] = ACTIONS(830),
    [anon_sym_AMP] = ACTIONS(830),
  },
  [528] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(982),
    [anon_sym_DQUOTE] = ACTIONS(1890),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [529] = {
    [aux_sym_concatenation_repeat1] = STATE(980),
    [sym__concat] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(834),
    [sym__special_characters] = ACTIONS(834),
    [anon_sym_DQUOTE] = ACTIONS(834),
    [sym_raw_string] = ACTIONS(834),
    [anon_sym_DOLLAR] = ACTIONS(834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(834),
    [anon_sym_LT_LPAREN] = ACTIONS(834),
    [anon_sym_GT_LPAREN] = ACTIONS(834),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_LF] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
  },
  [530] = {
    [sym_string] = STATE(985),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [anon_sym_DOLLAR] = ACTIONS(1892),
    [anon_sym_POUND] = ACTIONS(1892),
    [anon_sym_DASH] = ACTIONS(1892),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1894),
    [anon_sym_STAR] = ACTIONS(1892),
    [anon_sym_AT] = ACTIONS(1892),
    [anon_sym_QMARK] = ACTIONS(1892),
    [anon_sym_0] = ACTIONS(1896),
    [anon_sym__] = ACTIONS(1896),
  },
  [531] = {
    [sym_subscript] = STATE(990),
    [sym_variable_name] = ACTIONS(1898),
    [anon_sym_DOLLAR] = ACTIONS(1900),
    [anon_sym_POUND] = ACTIONS(1902),
    [anon_sym_DASH] = ACTIONS(1900),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1904),
    [anon_sym_STAR] = ACTIONS(1900),
    [anon_sym_AT] = ACTIONS(1900),
    [anon_sym_QMARK] = ACTIONS(1900),
    [anon_sym_0] = ACTIONS(1906),
    [anon_sym__] = ACTIONS(1906),
  },
  [532] = {
    [sym_for_statement] = STATE(991),
    [sym_while_statement] = STATE(991),
    [sym_if_statement] = STATE(991),
    [sym_case_statement] = STATE(991),
    [sym_function_definition] = STATE(991),
    [sym_subshell] = STATE(991),
    [sym_pipeline] = STATE(991),
    [sym_list] = STATE(991),
    [sym_command] = STATE(991),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(992),
    [sym_declaration_command] = STATE(991),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [533] = {
    [sym_for_statement] = STATE(993),
    [sym_while_statement] = STATE(993),
    [sym_if_statement] = STATE(993),
    [sym_case_statement] = STATE(993),
    [sym_function_definition] = STATE(993),
    [sym_subshell] = STATE(993),
    [sym_pipeline] = STATE(993),
    [sym_list] = STATE(993),
    [sym_command] = STATE(993),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(994),
    [sym_declaration_command] = STATE(993),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [534] = {
    [sym_for_statement] = STATE(995),
    [sym_while_statement] = STATE(995),
    [sym_if_statement] = STATE(995),
    [sym_case_statement] = STATE(995),
    [sym_function_definition] = STATE(995),
    [sym_subshell] = STATE(995),
    [sym_pipeline] = STATE(995),
    [sym_list] = STATE(995),
    [sym_command] = STATE(995),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(996),
    [sym_declaration_command] = STATE(995),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [535] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(834),
    [sym__special_characters] = ACTIONS(834),
    [anon_sym_DQUOTE] = ACTIONS(834),
    [sym_raw_string] = ACTIONS(834),
    [anon_sym_DOLLAR] = ACTIONS(834),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(834),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(834),
    [anon_sym_BQUOTE] = ACTIONS(834),
    [anon_sym_LT_LPAREN] = ACTIONS(834),
    [anon_sym_GT_LPAREN] = ACTIONS(834),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(834),
    [anon_sym_SEMI] = ACTIONS(834),
    [anon_sym_LF] = ACTIONS(834),
    [anon_sym_AMP] = ACTIONS(834),
  },
  [536] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(529),
    [sym_simple_expansion] = STATE(529),
    [sym_expansion] = STATE(529),
    [sym_command_substitution] = STATE(529),
    [sym_process_substitution] = STATE(529),
    [aux_sym_for_statement_repeat1] = STATE(998),
    [anon_sym_SEMI_SEMI] = ACTIONS(1908),
    [sym__special_characters] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(1912),
    [sym_raw_string] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1920),
    [anon_sym_BQUOTE] = ACTIONS(1922),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1914),
    [anon_sym_SEMI] = ACTIONS(1908),
    [anon_sym_LF] = ACTIONS(1908),
    [anon_sym_AMP] = ACTIONS(1908),
  },
  [537] = {
    [sym_file_descriptor] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(1928),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [anon_sym_LT] = ACTIONS(1928),
    [anon_sym_GT] = ACTIONS(1928),
    [anon_sym_GT_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT] = ACTIONS(1928),
    [anon_sym_AMP_GT_GT] = ACTIONS(1928),
    [anon_sym_LT_AMP] = ACTIONS(1928),
    [anon_sym_GT_AMP] = ACTIONS(1928),
    [anon_sym_LT_LT] = ACTIONS(1928),
    [anon_sym_LT_LT_DASH] = ACTIONS(1928),
    [anon_sym_LT_LT_LT] = ACTIONS(1928),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1928),
  },
  [538] = {
    [sym_file_descriptor] = ACTIONS(252),
    [sym_variable_name] = ACTIONS(252),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_done] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_declare] = ACTIONS(254),
    [anon_sym_typeset] = ACTIONS(254),
    [anon_sym_export] = ACTIONS(254),
    [anon_sym_readonly] = ACTIONS(254),
    [anon_sym_local] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [anon_sym_AMP_GT] = ACTIONS(254),
    [anon_sym_AMP_GT_GT] = ACTIONS(252),
    [anon_sym_LT_AMP] = ACTIONS(252),
    [anon_sym_GT_AMP] = ACTIONS(252),
    [sym__special_characters] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(252),
    [anon_sym_BQUOTE] = ACTIONS(252),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(256),
  },
  [539] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [540] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(1930),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(1930),
    [anon_sym_LF] = ACTIONS(1930),
    [anon_sym_AMP] = ACTIONS(1930),
  },
  [541] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1001),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(1932),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [542] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(473),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(1934),
    [anon_sym_SEMI_SEMI] = ACTIONS(1934),
    [anon_sym_PIPE_AMP] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_PIPE_PIPE] = ACTIONS(1934),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_LF] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1934),
  },
  [543] = {
    [anon_sym_PIPE] = ACTIONS(1936),
    [anon_sym_RPAREN] = ACTIONS(1936),
    [anon_sym_SEMI_SEMI] = ACTIONS(1936),
    [anon_sym_PIPE_AMP] = ACTIONS(1936),
    [anon_sym_AMP_AMP] = ACTIONS(1936),
    [anon_sym_PIPE_PIPE] = ACTIONS(1936),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1936),
    [anon_sym_LF] = ACTIONS(1936),
    [anon_sym_AMP] = ACTIONS(1936),
  },
  [544] = {
    [sym__terminated_statement] = STATE(1002),
    [sym_for_statement] = STATE(37),
    [sym_while_statement] = STATE(37),
    [sym_if_statement] = STATE(37),
    [sym_case_statement] = STATE(37),
    [sym_function_definition] = STATE(37),
    [sym_subshell] = STATE(37),
    [sym_pipeline] = STATE(37),
    [sym_list] = STATE(37),
    [sym_command] = STATE(37),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(38),
    [sym_declaration_command] = STATE(37),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [545] = {
    [sym__terminated_statement] = STATE(1003),
    [sym_for_statement] = STATE(1004),
    [sym_while_statement] = STATE(1004),
    [sym_if_statement] = STATE(1004),
    [sym_case_statement] = STATE(1004),
    [sym_function_definition] = STATE(1004),
    [sym_subshell] = STATE(1004),
    [sym_pipeline] = STATE(1004),
    [sym_list] = STATE(1004),
    [sym_command] = STATE(1004),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1005),
    [sym_declaration_command] = STATE(1004),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1006),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(1938),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [546] = {
    [sym_file_descriptor] = ACTIONS(252),
    [sym_variable_name] = ACTIONS(252),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_fi] = ACTIONS(254),
    [anon_sym_elif] = ACTIONS(254),
    [anon_sym_else] = ACTIONS(254),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_declare] = ACTIONS(254),
    [anon_sym_typeset] = ACTIONS(254),
    [anon_sym_export] = ACTIONS(254),
    [anon_sym_readonly] = ACTIONS(254),
    [anon_sym_local] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [anon_sym_AMP_GT] = ACTIONS(254),
    [anon_sym_AMP_GT_GT] = ACTIONS(252),
    [anon_sym_LT_AMP] = ACTIONS(252),
    [anon_sym_GT_AMP] = ACTIONS(252),
    [sym__special_characters] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(252),
    [anon_sym_BQUOTE] = ACTIONS(252),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(256),
  },
  [547] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1940),
  },
  [548] = {
    [anon_sym_fi] = ACTIONS(1942),
    [anon_sym_elif] = ACTIONS(1942),
    [anon_sym_else] = ACTIONS(1942),
    [sym_comment] = ACTIONS(48),
  },
  [549] = {
    [anon_sym_fi] = ACTIONS(1944),
    [sym_comment] = ACTIONS(48),
  },
  [550] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(1940),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(1940),
    [anon_sym_LF] = ACTIONS(1940),
    [anon_sym_AMP] = ACTIONS(1940),
  },
  [551] = {
    [sym__terminated_statement] = STATE(546),
    [sym_for_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(1009),
    [sym_case_statement] = STATE(547),
    [sym_function_definition] = STATE(547),
    [sym_subshell] = STATE(547),
    [sym_pipeline] = STATE(547),
    [sym_list] = STATE(547),
    [sym_command] = STATE(547),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(550),
    [sym_declaration_command] = STATE(547),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1010),
    [aux_sym_if_statement_repeat1] = STATE(1011),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(1946),
    [anon_sym_elif] = ACTIONS(1030),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [552] = {
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(1009),
    [aux_sym_if_statement_repeat1] = STATE(1012),
    [anon_sym_fi] = ACTIONS(1944),
    [anon_sym_elif] = ACTIONS(1948),
    [anon_sym_else] = ACTIONS(1950),
    [sym_comment] = ACTIONS(48),
  },
  [553] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [554] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1023),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1025),
    [anon_sym_esac] = ACTIONS(1952),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [555] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1972),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1972),
    [anon_sym_LF] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1972),
  },
  [556] = {
    [aux_sym_concatenation_repeat1] = STATE(556),
    [sym__concat] = ACTIONS(1974),
    [anon_sym_in] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [557] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_in] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [558] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1028),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1029),
    [anon_sym_esac] = ACTIONS(1977),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [559] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(1979),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1979),
    [anon_sym_LF] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
  },
  [560] = {
    [sym_concatenation] = STATE(1034),
    [sym_string] = STATE(1033),
    [sym_simple_expansion] = STATE(1033),
    [sym_expansion] = STATE(1033),
    [sym_command_substitution] = STATE(1033),
    [sym_process_substitution] = STATE(1033),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [sym__special_characters] = ACTIONS(1983),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(1985),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1987),
  },
  [561] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_in] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [562] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [563] = {
    [anon_sym_EQ] = ACTIONS(1991),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [564] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1038),
    [anon_sym_RBRACE] = ACTIONS(1993),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [565] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1040),
    [anon_sym_RBRACE] = ACTIONS(1995),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [566] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1041),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [567] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_in] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [568] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(1997),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [569] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_in] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [570] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [571] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_in] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [572] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_in] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [573] = {
    [sym_compound_statement] = STATE(1043),
    [anon_sym_LBRACE] = ACTIONS(390),
    [sym_comment] = ACTIONS(48),
  },
  [574] = {
    [sym_file_descriptor] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(2001),
    [anon_sym_RPAREN] = ACTIONS(2001),
    [anon_sym_SEMI_SEMI] = ACTIONS(2001),
    [anon_sym_PIPE_AMP] = ACTIONS(2001),
    [anon_sym_AMP_AMP] = ACTIONS(2001),
    [anon_sym_PIPE_PIPE] = ACTIONS(2001),
    [anon_sym_LT] = ACTIONS(2001),
    [anon_sym_GT] = ACTIONS(2001),
    [anon_sym_GT_GT] = ACTIONS(2001),
    [anon_sym_AMP_GT] = ACTIONS(2001),
    [anon_sym_AMP_GT_GT] = ACTIONS(2001),
    [anon_sym_LT_AMP] = ACTIONS(2001),
    [anon_sym_GT_AMP] = ACTIONS(2001),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2001),
    [anon_sym_LF] = ACTIONS(2001),
    [anon_sym_AMP] = ACTIONS(2001),
  },
  [575] = {
    [sym_file_descriptor] = ACTIONS(252),
    [sym_variable_name] = ACTIONS(252),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_RBRACE] = ACTIONS(252),
    [anon_sym_declare] = ACTIONS(254),
    [anon_sym_typeset] = ACTIONS(254),
    [anon_sym_export] = ACTIONS(254),
    [anon_sym_readonly] = ACTIONS(254),
    [anon_sym_local] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [anon_sym_AMP_GT] = ACTIONS(254),
    [anon_sym_AMP_GT_GT] = ACTIONS(252),
    [anon_sym_LT_AMP] = ACTIONS(252),
    [anon_sym_GT_AMP] = ACTIONS(252),
    [sym__special_characters] = ACTIONS(256),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(252),
    [anon_sym_BQUOTE] = ACTIONS(252),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(256),
  },
  [576] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(2003),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_LF] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2003),
  },
  [577] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(2003),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(2003),
    [anon_sym_LF] = ACTIONS(2003),
    [anon_sym_AMP] = ACTIONS(2003),
  },
  [578] = {
    [sym__terminated_statement] = STATE(575),
    [sym_for_statement] = STATE(576),
    [sym_while_statement] = STATE(576),
    [sym_if_statement] = STATE(576),
    [sym_case_statement] = STATE(576),
    [sym_function_definition] = STATE(576),
    [sym_subshell] = STATE(576),
    [sym_pipeline] = STATE(576),
    [sym_list] = STATE(576),
    [sym_command] = STATE(576),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(577),
    [sym_declaration_command] = STATE(576),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1046),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2005),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [579] = {
    [anon_sym_LT] = ACTIONS(2007),
    [anon_sym_GT] = ACTIONS(2007),
    [anon_sym_GT_GT] = ACTIONS(2009),
    [anon_sym_AMP_GT] = ACTIONS(2007),
    [anon_sym_AMP_GT_GT] = ACTIONS(2009),
    [anon_sym_LT_AMP] = ACTIONS(2009),
    [anon_sym_GT_AMP] = ACTIONS(2009),
    [sym_comment] = ACTIONS(48),
  },
  [580] = {
    [sym_concatenation] = STATE(1056),
    [sym_string] = STATE(1050),
    [sym_simple_expansion] = STATE(1050),
    [sym_expansion] = STATE(1050),
    [sym_command_substitution] = STATE(1050),
    [sym_process_substitution] = STATE(1050),
    [sym__special_characters] = ACTIONS(2011),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_raw_string] = ACTIONS(2015),
    [anon_sym_DOLLAR] = ACTIONS(2017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(2023),
    [anon_sym_LT_LPAREN] = ACTIONS(2025),
    [anon_sym_GT_LPAREN] = ACTIONS(2025),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2027),
  },
  [581] = {
    [anon_sym_PIPE] = ACTIONS(2029),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_SEMI_SEMI] = ACTIONS(2029),
    [anon_sym_PIPE_AMP] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_LF] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2029),
  },
  [582] = {
    [aux_sym_concatenation_repeat1] = STATE(1058),
    [sym_file_descriptor] = ACTIONS(954),
    [sym__concat] = ACTIONS(2031),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(958),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_SEMI_SEMI] = ACTIONS(958),
    [anon_sym_PIPE_AMP] = ACTIONS(958),
    [anon_sym_AMP_AMP] = ACTIONS(958),
    [anon_sym_PIPE_PIPE] = ACTIONS(958),
    [anon_sym_LT] = ACTIONS(958),
    [anon_sym_GT] = ACTIONS(958),
    [anon_sym_GT_GT] = ACTIONS(958),
    [anon_sym_AMP_GT] = ACTIONS(958),
    [anon_sym_AMP_GT_GT] = ACTIONS(958),
    [anon_sym_LT_AMP] = ACTIONS(958),
    [anon_sym_GT_AMP] = ACTIONS(958),
    [sym__special_characters] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_raw_string] = ACTIONS(958),
    [anon_sym_DOLLAR] = ACTIONS(958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(958),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [anon_sym_LT_LPAREN] = ACTIONS(958),
    [anon_sym_GT_LPAREN] = ACTIONS(958),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_LF] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
  },
  [583] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1060),
    [anon_sym_DQUOTE] = ACTIONS(2033),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [584] = {
    [aux_sym_concatenation_repeat1] = STATE(1058),
    [sym_file_descriptor] = ACTIONS(930),
    [sym__concat] = ACTIONS(2031),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(932),
    [anon_sym_RPAREN] = ACTIONS(932),
    [anon_sym_SEMI_SEMI] = ACTIONS(932),
    [anon_sym_PIPE_AMP] = ACTIONS(932),
    [anon_sym_AMP_AMP] = ACTIONS(932),
    [anon_sym_PIPE_PIPE] = ACTIONS(932),
    [anon_sym_LT] = ACTIONS(932),
    [anon_sym_GT] = ACTIONS(932),
    [anon_sym_GT_GT] = ACTIONS(932),
    [anon_sym_AMP_GT] = ACTIONS(932),
    [anon_sym_AMP_GT_GT] = ACTIONS(932),
    [anon_sym_LT_AMP] = ACTIONS(932),
    [anon_sym_GT_AMP] = ACTIONS(932),
    [sym__special_characters] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_raw_string] = ACTIONS(932),
    [anon_sym_DOLLAR] = ACTIONS(932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(932),
    [anon_sym_BQUOTE] = ACTIONS(932),
    [anon_sym_LT_LPAREN] = ACTIONS(932),
    [anon_sym_GT_LPAREN] = ACTIONS(932),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_LF] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
  },
  [585] = {
    [sym_string] = STATE(1063),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [anon_sym_DOLLAR] = ACTIONS(2035),
    [anon_sym_POUND] = ACTIONS(2035),
    [anon_sym_DASH] = ACTIONS(2035),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2037),
    [anon_sym_STAR] = ACTIONS(2035),
    [anon_sym_AT] = ACTIONS(2035),
    [anon_sym_QMARK] = ACTIONS(2035),
    [anon_sym_0] = ACTIONS(2039),
    [anon_sym__] = ACTIONS(2039),
  },
  [586] = {
    [sym_subscript] = STATE(1068),
    [sym_variable_name] = ACTIONS(2041),
    [anon_sym_DOLLAR] = ACTIONS(2043),
    [anon_sym_POUND] = ACTIONS(2045),
    [anon_sym_DASH] = ACTIONS(2043),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2047),
    [anon_sym_STAR] = ACTIONS(2043),
    [anon_sym_AT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2043),
    [anon_sym_0] = ACTIONS(2049),
    [anon_sym__] = ACTIONS(2049),
  },
  [587] = {
    [sym_for_statement] = STATE(1069),
    [sym_while_statement] = STATE(1069),
    [sym_if_statement] = STATE(1069),
    [sym_case_statement] = STATE(1069),
    [sym_function_definition] = STATE(1069),
    [sym_subshell] = STATE(1069),
    [sym_pipeline] = STATE(1069),
    [sym_list] = STATE(1069),
    [sym_command] = STATE(1069),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1070),
    [sym_declaration_command] = STATE(1069),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [588] = {
    [sym_for_statement] = STATE(1071),
    [sym_while_statement] = STATE(1071),
    [sym_if_statement] = STATE(1071),
    [sym_case_statement] = STATE(1071),
    [sym_function_definition] = STATE(1071),
    [sym_subshell] = STATE(1071),
    [sym_pipeline] = STATE(1071),
    [sym_list] = STATE(1071),
    [sym_command] = STATE(1071),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1072),
    [sym_declaration_command] = STATE(1071),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [589] = {
    [sym_for_statement] = STATE(1073),
    [sym_while_statement] = STATE(1073),
    [sym_if_statement] = STATE(1073),
    [sym_case_statement] = STATE(1073),
    [sym_function_definition] = STATE(1073),
    [sym_subshell] = STATE(1073),
    [sym_pipeline] = STATE(1073),
    [sym_list] = STATE(1073),
    [sym_command] = STATE(1073),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1074),
    [sym_declaration_command] = STATE(1073),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [590] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(1075),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1026),
    [anon_sym_RPAREN] = ACTIONS(1026),
    [anon_sym_SEMI_SEMI] = ACTIONS(1026),
    [anon_sym_PIPE_AMP] = ACTIONS(1026),
    [anon_sym_AMP_AMP] = ACTIONS(1026),
    [anon_sym_PIPE_PIPE] = ACTIONS(1026),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1026),
    [anon_sym_LF] = ACTIONS(1026),
    [anon_sym_AMP] = ACTIONS(1026),
  },
  [591] = {
    [anon_sym_RPAREN] = ACTIONS(2051),
    [sym_comment] = ACTIONS(48),
  },
  [592] = {
    [sym_file_redirect] = STATE(581),
    [sym_file_descriptor] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(1076),
    [anon_sym_RPAREN] = ACTIONS(1076),
    [anon_sym_SEMI_SEMI] = ACTIONS(1076),
    [anon_sym_PIPE_AMP] = ACTIONS(1076),
    [anon_sym_AMP_AMP] = ACTIONS(1076),
    [anon_sym_PIPE_PIPE] = ACTIONS(1076),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_AMP_GT] = ACTIONS(2055),
    [anon_sym_AMP_GT_GT] = ACTIONS(2055),
    [anon_sym_LT_AMP] = ACTIONS(2055),
    [anon_sym_GT_AMP] = ACTIONS(2055),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1076),
    [anon_sym_LF] = ACTIONS(1076),
    [anon_sym_AMP] = ACTIONS(1076),
  },
  [593] = {
    [sym_concatenation] = STATE(649),
    [sym_string] = STATE(1080),
    [sym_array] = STATE(649),
    [sym_simple_expansion] = STATE(1080),
    [sym_expansion] = STATE(1080),
    [sym_command_substitution] = STATE(1080),
    [sym_process_substitution] = STATE(1080),
    [sym__empty_value] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1190),
    [sym__special_characters] = ACTIONS(2057),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_raw_string] = ACTIONS(2059),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [anon_sym_LT_LPAREN] = ACTIONS(2069),
    [anon_sym_GT_LPAREN] = ACTIONS(2069),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2071),
  },
  [594] = {
    [sym_string] = STATE(1081),
    [sym_simple_expansion] = STATE(1081),
    [sym_expansion] = STATE(1081),
    [sym_command_substitution] = STATE(1081),
    [sym_process_substitution] = STATE(1081),
    [sym__special_characters] = ACTIONS(2073),
    [anon_sym_DQUOTE] = ACTIONS(1106),
    [sym_raw_string] = ACTIONS(2075),
    [anon_sym_DOLLAR] = ACTIONS(2061),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2063),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2065),
    [anon_sym_BQUOTE] = ACTIONS(2067),
    [anon_sym_LT_LPAREN] = ACTIONS(2069),
    [anon_sym_GT_LPAREN] = ACTIONS(2069),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2073),
  },
  [595] = {
    [aux_sym_concatenation_repeat1] = STATE(1082),
    [sym__concat] = ACTIONS(1102),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [sym_raw_string] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(540),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(540),
    [anon_sym_GT_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(540),
    [sym_word] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [596] = {
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(544),
    [sym_word] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [597] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(2077),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [598] = {
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(574),
    [sym_word] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [599] = {
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [anon_sym_LT_LPAREN] = ACTIONS(578),
    [anon_sym_GT_LPAREN] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(578),
    [sym_word] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [600] = {
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(582),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [601] = {
    [anon_sym_EQ] = ACTIONS(2079),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [602] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1086),
    [anon_sym_RBRACE] = ACTIONS(2081),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [603] = {
    [sym_subscript] = STATE(1090),
    [sym_variable_name] = ACTIONS(2083),
    [anon_sym_DOLLAR] = ACTIONS(2085),
    [anon_sym_DASH] = ACTIONS(2085),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2087),
    [anon_sym_STAR] = ACTIONS(2085),
    [anon_sym_AT] = ACTIONS(2085),
    [anon_sym_QMARK] = ACTIONS(2085),
    [anon_sym_0] = ACTIONS(2089),
    [anon_sym__] = ACTIONS(2089),
  },
  [604] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1092),
    [anon_sym_RBRACE] = ACTIONS(2091),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [605] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1094),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [606] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2095),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [607] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2095),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [608] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(2095),
    [sym_comment] = ACTIONS(48),
  },
  [609] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(2095),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [610] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2097),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [611] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2097),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [612] = {
    [sym_variable_assignment] = STATE(79),
    [sym_subscript] = STATE(234),
    [sym_concatenation] = STATE(79),
    [sym_string] = STATE(228),
    [sym_simple_expansion] = STATE(228),
    [sym_expansion] = STATE(228),
    [sym_command_substitution] = STATE(228),
    [sym_process_substitution] = STATE(228),
    [aux_sym_declaration_command_repeat1] = STATE(612),
    [sym_variable_name] = ACTIONS(2099),
    [anon_sym_PIPE] = ACTIONS(1237),
    [anon_sym_RPAREN] = ACTIONS(1237),
    [anon_sym_SEMI_SEMI] = ACTIONS(1237),
    [anon_sym_PIPE_AMP] = ACTIONS(1237),
    [anon_sym_AMP_AMP] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE] = ACTIONS(1237),
    [sym__special_characters] = ACTIONS(2102),
    [anon_sym_DQUOTE] = ACTIONS(2105),
    [sym_raw_string] = ACTIONS(2108),
    [anon_sym_DOLLAR] = ACTIONS(2111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2114),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2117),
    [anon_sym_BQUOTE] = ACTIONS(2120),
    [anon_sym_LT_LPAREN] = ACTIONS(2123),
    [anon_sym_GT_LPAREN] = ACTIONS(2123),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1263),
    [sym_word] = ACTIONS(2108),
    [anon_sym_SEMI] = ACTIONS(1237),
    [anon_sym_LF] = ACTIONS(1237),
    [anon_sym_AMP] = ACTIONS(1237),
  },
  [613] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [614] = {
    [aux_sym_concatenation_repeat1] = STATE(614),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(2126),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [615] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1335),
    [anon_sym_LT_LT_DASH] = ACTIONS(1335),
    [anon_sym_LT_LT_LT] = ACTIONS(1335),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_raw_string] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [616] = {
    [sym_concatenation] = STATE(1100),
    [sym_string] = STATE(1099),
    [sym_simple_expansion] = STATE(1099),
    [sym_expansion] = STATE(1099),
    [sym_command_substitution] = STATE(1099),
    [sym_process_substitution] = STATE(1099),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [sym__special_characters] = ACTIONS(2131),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2133),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2135),
  },
  [617] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [618] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2137),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [619] = {
    [anon_sym_EQ] = ACTIONS(2139),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [620] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1104),
    [anon_sym_RBRACE] = ACTIONS(2141),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [621] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1106),
    [anon_sym_RBRACE] = ACTIONS(2143),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [622] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1107),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [623] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT_GT] = ACTIONS(1424),
    [anon_sym_LT_AMP] = ACTIONS(1424),
    [anon_sym_GT_AMP] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1424),
    [anon_sym_LT_LT_DASH] = ACTIONS(1424),
    [anon_sym_LT_LT_LT] = ACTIONS(1424),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LPAREN] = ACTIONS(1424),
    [anon_sym_GT_LPAREN] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [624] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [625] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_AMP] = ACTIONS(1430),
    [anon_sym_GT_AMP] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1430),
    [anon_sym_LT_LT_LT] = ACTIONS(1430),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym_raw_string] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LPAREN] = ACTIONS(1430),
    [anon_sym_GT_LPAREN] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [626] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2129),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [627] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_LT_LT_DASH] = ACTIONS(1540),
    [anon_sym_LT_LT_LT] = ACTIONS(1540),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [628] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT_GT] = ACTIONS(1684),
    [anon_sym_LT_AMP] = ACTIONS(1684),
    [anon_sym_GT_AMP] = ACTIONS(1684),
    [anon_sym_LT_LT] = ACTIONS(1684),
    [anon_sym_LT_LT_DASH] = ACTIONS(1684),
    [anon_sym_LT_LT_LT] = ACTIONS(1684),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LT_LPAREN] = ACTIONS(1684),
    [anon_sym_GT_LPAREN] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [629] = {
    [sym_compound_statement] = STATE(1109),
    [anon_sym_LBRACE] = ACTIONS(390),
    [sym_comment] = ACTIONS(48),
  },
  [630] = {
    [anon_sym_PIPE] = ACTIONS(2147),
    [anon_sym_RPAREN] = ACTIONS(2147),
    [anon_sym_SEMI_SEMI] = ACTIONS(2147),
    [anon_sym_PIPE_AMP] = ACTIONS(2147),
    [anon_sym_AMP_AMP] = ACTIONS(2147),
    [anon_sym_PIPE_PIPE] = ACTIONS(2147),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_LF] = ACTIONS(2147),
    [anon_sym_AMP] = ACTIONS(2147),
  },
  [631] = {
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [632] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(1688),
    [anon_sym_SEMI_SEMI] = ACTIONS(1688),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(1688),
    [anon_sym_PIPE_PIPE] = ACTIONS(1688),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(1688),
    [anon_sym_LF] = ACTIONS(1688),
    [anon_sym_AMP] = ACTIONS(1688),
  },
  [633] = {
    [sym_concatenation] = STATE(895),
    [sym_string] = STATE(1111),
    [sym_simple_expansion] = STATE(1111),
    [sym_expansion] = STATE(1111),
    [sym_command_substitution] = STATE(1111),
    [sym_process_substitution] = STATE(1111),
    [sym__special_characters] = ACTIONS(2149),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [sym_raw_string] = ACTIONS(2151),
    [anon_sym_DOLLAR] = ACTIONS(1166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1172),
    [anon_sym_LT_LPAREN] = ACTIONS(1174),
    [anon_sym_GT_LPAREN] = ACTIONS(1174),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2153),
  },
  [634] = {
    [aux_sym_concatenation_repeat1] = STATE(1113),
    [sym_file_descriptor] = ACTIONS(506),
    [sym__concat] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(1698),
    [anon_sym_RPAREN] = ACTIONS(1698),
    [anon_sym_SEMI_SEMI] = ACTIONS(1698),
    [anon_sym_PIPE_AMP] = ACTIONS(1698),
    [anon_sym_AMP_AMP] = ACTIONS(1698),
    [anon_sym_PIPE_PIPE] = ACTIONS(1698),
    [anon_sym_LT] = ACTIONS(1698),
    [anon_sym_GT] = ACTIONS(1698),
    [anon_sym_GT_GT] = ACTIONS(1698),
    [anon_sym_AMP_GT] = ACTIONS(1698),
    [anon_sym_AMP_GT_GT] = ACTIONS(1698),
    [anon_sym_LT_AMP] = ACTIONS(1698),
    [anon_sym_GT_AMP] = ACTIONS(1698),
    [anon_sym_LT_LT] = ACTIONS(1698),
    [anon_sym_LT_LT_DASH] = ACTIONS(1698),
    [anon_sym_LT_LT_LT] = ACTIONS(1698),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_LF] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
  },
  [635] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1115),
    [anon_sym_DQUOTE] = ACTIONS(2157),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [636] = {
    [aux_sym_concatenation_repeat1] = STATE(1113),
    [sym_file_descriptor] = ACTIONS(514),
    [sym__concat] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_RPAREN] = ACTIONS(1702),
    [anon_sym_SEMI_SEMI] = ACTIONS(1702),
    [anon_sym_PIPE_AMP] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1702),
    [anon_sym_PIPE_PIPE] = ACTIONS(1702),
    [anon_sym_LT] = ACTIONS(1702),
    [anon_sym_GT] = ACTIONS(1702),
    [anon_sym_GT_GT] = ACTIONS(1702),
    [anon_sym_AMP_GT] = ACTIONS(1702),
    [anon_sym_AMP_GT_GT] = ACTIONS(1702),
    [anon_sym_LT_AMP] = ACTIONS(1702),
    [anon_sym_GT_AMP] = ACTIONS(1702),
    [anon_sym_LT_LT] = ACTIONS(1702),
    [anon_sym_LT_LT_DASH] = ACTIONS(1702),
    [anon_sym_LT_LT_LT] = ACTIONS(1702),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_LF] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
  },
  [637] = {
    [sym_string] = STATE(1118),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [anon_sym_DOLLAR] = ACTIONS(2159),
    [anon_sym_POUND] = ACTIONS(2159),
    [anon_sym_DASH] = ACTIONS(2159),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2161),
    [anon_sym_STAR] = ACTIONS(2159),
    [anon_sym_AT] = ACTIONS(2159),
    [anon_sym_QMARK] = ACTIONS(2159),
    [anon_sym_0] = ACTIONS(2163),
    [anon_sym__] = ACTIONS(2163),
  },
  [638] = {
    [sym_subscript] = STATE(1123),
    [sym_variable_name] = ACTIONS(2165),
    [anon_sym_DOLLAR] = ACTIONS(2167),
    [anon_sym_POUND] = ACTIONS(2169),
    [anon_sym_DASH] = ACTIONS(2167),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2171),
    [anon_sym_STAR] = ACTIONS(2167),
    [anon_sym_AT] = ACTIONS(2167),
    [anon_sym_QMARK] = ACTIONS(2167),
    [anon_sym_0] = ACTIONS(2173),
    [anon_sym__] = ACTIONS(2173),
  },
  [639] = {
    [sym_for_statement] = STATE(1124),
    [sym_while_statement] = STATE(1124),
    [sym_if_statement] = STATE(1124),
    [sym_case_statement] = STATE(1124),
    [sym_function_definition] = STATE(1124),
    [sym_subshell] = STATE(1124),
    [sym_pipeline] = STATE(1124),
    [sym_list] = STATE(1124),
    [sym_command] = STATE(1124),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1125),
    [sym_declaration_command] = STATE(1124),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [640] = {
    [sym_for_statement] = STATE(1126),
    [sym_while_statement] = STATE(1126),
    [sym_if_statement] = STATE(1126),
    [sym_case_statement] = STATE(1126),
    [sym_function_definition] = STATE(1126),
    [sym_subshell] = STATE(1126),
    [sym_pipeline] = STATE(1126),
    [sym_list] = STATE(1126),
    [sym_command] = STATE(1126),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1127),
    [sym_declaration_command] = STATE(1126),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [641] = {
    [sym_for_statement] = STATE(1128),
    [sym_while_statement] = STATE(1128),
    [sym_if_statement] = STATE(1128),
    [sym_case_statement] = STATE(1128),
    [sym_function_definition] = STATE(1128),
    [sym_subshell] = STATE(1128),
    [sym_pipeline] = STATE(1128),
    [sym_list] = STATE(1128),
    [sym_command] = STATE(1128),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1129),
    [sym_declaration_command] = STATE(1128),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [642] = {
    [aux_sym_concatenation_repeat1] = STATE(1113),
    [sym_file_descriptor] = ACTIONS(1736),
    [sym__concat] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(1738),
    [anon_sym_RPAREN] = ACTIONS(1738),
    [anon_sym_SEMI_SEMI] = ACTIONS(1738),
    [anon_sym_PIPE_AMP] = ACTIONS(1738),
    [anon_sym_AMP_AMP] = ACTIONS(1738),
    [anon_sym_PIPE_PIPE] = ACTIONS(1738),
    [anon_sym_LT] = ACTIONS(1738),
    [anon_sym_GT] = ACTIONS(1738),
    [anon_sym_GT_GT] = ACTIONS(1738),
    [anon_sym_AMP_GT] = ACTIONS(1738),
    [anon_sym_AMP_GT_GT] = ACTIONS(1738),
    [anon_sym_LT_AMP] = ACTIONS(1738),
    [anon_sym_GT_AMP] = ACTIONS(1738),
    [anon_sym_LT_LT] = ACTIONS(1738),
    [anon_sym_LT_LT_DASH] = ACTIONS(1738),
    [anon_sym_LT_LT_LT] = ACTIONS(1738),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1738),
    [anon_sym_LF] = ACTIONS(1738),
    [anon_sym_AMP] = ACTIONS(1738),
  },
  [643] = {
    [aux_sym_concatenation_repeat1] = STATE(1113),
    [sym_file_descriptor] = ACTIONS(1740),
    [sym__concat] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(1742),
    [anon_sym_RPAREN] = ACTIONS(1742),
    [anon_sym_SEMI_SEMI] = ACTIONS(1742),
    [anon_sym_PIPE_AMP] = ACTIONS(1742),
    [anon_sym_AMP_AMP] = ACTIONS(1742),
    [anon_sym_PIPE_PIPE] = ACTIONS(1742),
    [anon_sym_LT] = ACTIONS(1742),
    [anon_sym_GT] = ACTIONS(1742),
    [anon_sym_GT_GT] = ACTIONS(1742),
    [anon_sym_AMP_GT] = ACTIONS(1742),
    [anon_sym_AMP_GT_GT] = ACTIONS(1742),
    [anon_sym_LT_AMP] = ACTIONS(1742),
    [anon_sym_GT_AMP] = ACTIONS(1742),
    [anon_sym_LT_LT] = ACTIONS(1742),
    [anon_sym_LT_LT_DASH] = ACTIONS(1742),
    [anon_sym_LT_LT_LT] = ACTIONS(1742),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1742),
    [anon_sym_LF] = ACTIONS(1742),
    [anon_sym_AMP] = ACTIONS(1742),
  },
  [644] = {
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(263),
    [sym_simple_expansion] = STATE(263),
    [sym_expansion] = STATE(263),
    [sym_command_substitution] = STATE(263),
    [sym_process_substitution] = STATE(263),
    [aux_sym_for_statement_repeat1] = STATE(644),
    [sym_file_descriptor] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(1746),
    [anon_sym_RPAREN] = ACTIONS(1746),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [anon_sym_PIPE_AMP] = ACTIONS(1746),
    [anon_sym_AMP_AMP] = ACTIONS(1746),
    [anon_sym_PIPE_PIPE] = ACTIONS(1746),
    [anon_sym_LT] = ACTIONS(1746),
    [anon_sym_GT] = ACTIONS(1746),
    [anon_sym_GT_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT] = ACTIONS(1746),
    [anon_sym_AMP_GT_GT] = ACTIONS(1746),
    [anon_sym_LT_AMP] = ACTIONS(1746),
    [anon_sym_GT_AMP] = ACTIONS(1746),
    [anon_sym_LT_LT] = ACTIONS(1746),
    [anon_sym_LT_LT_DASH] = ACTIONS(1746),
    [anon_sym_LT_LT_LT] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(2175),
    [anon_sym_DQUOTE] = ACTIONS(2178),
    [sym_raw_string] = ACTIONS(2181),
    [anon_sym_DOLLAR] = ACTIONS(2184),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2187),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2190),
    [anon_sym_BQUOTE] = ACTIONS(2193),
    [anon_sym_LT_LPAREN] = ACTIONS(2196),
    [anon_sym_GT_LPAREN] = ACTIONS(2196),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2181),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1746),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [645] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(646),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_RPAREN] = ACTIONS(1772),
    [anon_sym_SEMI_SEMI] = ACTIONS(1772),
    [anon_sym_PIPE_AMP] = ACTIONS(1772),
    [anon_sym_AMP_AMP] = ACTIONS(1772),
    [anon_sym_PIPE_PIPE] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1772),
    [anon_sym_LF] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
  },
  [646] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(646),
    [sym_file_descriptor] = ACTIONS(2199),
    [anon_sym_PIPE] = ACTIONS(1777),
    [anon_sym_RPAREN] = ACTIONS(1777),
    [anon_sym_SEMI_SEMI] = ACTIONS(1777),
    [anon_sym_PIPE_AMP] = ACTIONS(1777),
    [anon_sym_AMP_AMP] = ACTIONS(1777),
    [anon_sym_PIPE_PIPE] = ACTIONS(1777),
    [anon_sym_LT] = ACTIONS(2202),
    [anon_sym_GT] = ACTIONS(2202),
    [anon_sym_GT_GT] = ACTIONS(2202),
    [anon_sym_AMP_GT] = ACTIONS(2202),
    [anon_sym_AMP_GT_GT] = ACTIONS(2202),
    [anon_sym_LT_AMP] = ACTIONS(2202),
    [anon_sym_GT_AMP] = ACTIONS(2202),
    [anon_sym_LT_LT] = ACTIONS(1782),
    [anon_sym_LT_LT_DASH] = ACTIONS(1782),
    [anon_sym_LT_LT_LT] = ACTIONS(2205),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1777),
    [anon_sym_LF] = ACTIONS(1777),
    [anon_sym_AMP] = ACTIONS(1777),
  },
  [647] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(2208),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [648] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [sym_concatenation] = STATE(162),
    [sym_string] = STATE(263),
    [sym_simple_expansion] = STATE(263),
    [sym_expansion] = STATE(263),
    [sym_command_substitution] = STATE(263),
    [sym_process_substitution] = STATE(263),
    [aux_sym_for_statement_repeat1] = STATE(644),
    [aux_sym_while_statement_repeat1] = STATE(1131),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1772),
    [anon_sym_RPAREN] = ACTIONS(1772),
    [anon_sym_SEMI_SEMI] = ACTIONS(1772),
    [anon_sym_PIPE_AMP] = ACTIONS(1772),
    [anon_sym_AMP_AMP] = ACTIONS(1772),
    [anon_sym_PIPE_PIPE] = ACTIONS(1772),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym__special_characters] = ACTIONS(450),
    [anon_sym_DQUOTE] = ACTIONS(452),
    [sym_raw_string] = ACTIONS(454),
    [anon_sym_DOLLAR] = ACTIONS(456),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(458),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(460),
    [anon_sym_BQUOTE] = ACTIONS(462),
    [anon_sym_LT_LPAREN] = ACTIONS(464),
    [anon_sym_GT_LPAREN] = ACTIONS(464),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(454),
    [anon_sym_SEMI] = ACTIONS(1772),
    [anon_sym_LF] = ACTIONS(1772),
    [anon_sym_AMP] = ACTIONS(1772),
  },
  [649] = {
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(932),
    [anon_sym_RPAREN] = ACTIONS(932),
    [anon_sym_SEMI_SEMI] = ACTIONS(932),
    [anon_sym_PIPE_AMP] = ACTIONS(932),
    [anon_sym_AMP_AMP] = ACTIONS(932),
    [anon_sym_PIPE_PIPE] = ACTIONS(932),
    [sym__special_characters] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_raw_string] = ACTIONS(932),
    [anon_sym_DOLLAR] = ACTIONS(932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(932),
    [anon_sym_BQUOTE] = ACTIONS(932),
    [anon_sym_LT_LPAREN] = ACTIONS(932),
    [anon_sym_GT_LPAREN] = ACTIONS(932),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(932),
    [sym_word] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_LF] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
  },
  [650] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(1133),
    [anon_sym_RPAREN] = ACTIONS(2210),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [651] = {
    [aux_sym_concatenation_repeat1] = STATE(273),
    [sym__concat] = ACTIONS(470),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(958),
    [anon_sym_SEMI_SEMI] = ACTIONS(958),
    [anon_sym_PIPE_AMP] = ACTIONS(958),
    [anon_sym_AMP_AMP] = ACTIONS(958),
    [anon_sym_PIPE_PIPE] = ACTIONS(958),
    [sym__special_characters] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_raw_string] = ACTIONS(958),
    [anon_sym_DOLLAR] = ACTIONS(958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(958),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [anon_sym_LT_LPAREN] = ACTIONS(958),
    [anon_sym_GT_LPAREN] = ACTIONS(958),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(958),
    [sym_word] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_LF] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
  },
  [652] = {
    [aux_sym_concatenation_repeat1] = STATE(273),
    [sym__concat] = ACTIONS(470),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(932),
    [anon_sym_SEMI_SEMI] = ACTIONS(932),
    [anon_sym_PIPE_AMP] = ACTIONS(932),
    [anon_sym_AMP_AMP] = ACTIONS(932),
    [anon_sym_PIPE_PIPE] = ACTIONS(932),
    [sym__special_characters] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_raw_string] = ACTIONS(932),
    [anon_sym_DOLLAR] = ACTIONS(932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(932),
    [anon_sym_BQUOTE] = ACTIONS(932),
    [anon_sym_LT_LPAREN] = ACTIONS(932),
    [anon_sym_GT_LPAREN] = ACTIONS(932),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(932),
    [sym_word] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_LF] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
  },
  [653] = {
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1304),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [654] = {
    [aux_sym_concatenation_repeat1] = STATE(654),
    [sym__concat] = ACTIONS(2212),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1304),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [655] = {
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_raw_string] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1335),
    [sym_word] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [656] = {
    [sym_concatenation] = STATE(1137),
    [sym_string] = STATE(1136),
    [sym_simple_expansion] = STATE(1136),
    [sym_expansion] = STATE(1136),
    [sym_command_substitution] = STATE(1136),
    [sym_process_substitution] = STATE(1136),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [sym__special_characters] = ACTIONS(2217),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2219),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2221),
  },
  [657] = {
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [658] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2223),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [659] = {
    [anon_sym_EQ] = ACTIONS(2225),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [660] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1141),
    [anon_sym_RBRACE] = ACTIONS(2227),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [661] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1143),
    [anon_sym_RBRACE] = ACTIONS(2229),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [662] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1144),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [663] = {
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LPAREN] = ACTIONS(1424),
    [anon_sym_GT_LPAREN] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1424),
    [sym_word] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [664] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2231),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [665] = {
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym_raw_string] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LPAREN] = ACTIONS(1430),
    [anon_sym_GT_LPAREN] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1430),
    [sym_word] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [666] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2215),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [667] = {
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1540),
    [sym_word] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [668] = {
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LT_LPAREN] = ACTIONS(1684),
    [anon_sym_GT_LPAREN] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1684),
    [sym_word] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [669] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [670] = {
    [aux_sym_concatenation_repeat1] = STATE(670),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(2235),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [671] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_AMP] = ACTIONS(1333),
    [anon_sym_GT_AMP] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2238),
  },
  [672] = {
    [sym_concatenation] = STATE(1149),
    [sym_string] = STATE(1148),
    [sym_simple_expansion] = STATE(1148),
    [sym_expansion] = STATE(1148),
    [sym_command_substitution] = STATE(1148),
    [sym_process_substitution] = STATE(1148),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [sym__special_characters] = ACTIONS(2242),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2244),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2246),
  },
  [673] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(2248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2248),
  },
  [674] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [675] = {
    [anon_sym_EQ] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [676] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1153),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [677] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1155),
    [anon_sym_RBRACE] = ACTIONS(2256),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [678] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1156),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [679] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP_GT] = ACTIONS(2258),
    [anon_sym_AMP_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_AMP] = ACTIONS(1422),
    [anon_sym_GT_AMP] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2258),
  },
  [680] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [681] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_AMP_GT] = ACTIONS(2262),
    [anon_sym_AMP_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_AMP] = ACTIONS(1428),
    [anon_sym_GT_AMP] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2262),
  },
  [682] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2240),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [683] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2264),
  },
  [684] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(2266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2266),
  },
  [685] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym__string_content] = ACTIONS(1272),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
  },
  [686] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(2268),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [687] = {
    [sym_concatenation] = STATE(1162),
    [sym_string] = STATE(1161),
    [sym_simple_expansion] = STATE(1161),
    [sym_expansion] = STATE(1161),
    [sym_command_substitution] = STATE(1161),
    [sym_process_substitution] = STATE(1161),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [sym__special_characters] = ACTIONS(2272),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2274),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2276),
  },
  [688] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym__string_content] = ACTIONS(2248),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
  },
  [689] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [690] = {
    [anon_sym_EQ] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [691] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1166),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [692] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1168),
    [anon_sym_RBRACE] = ACTIONS(2284),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [693] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1169),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [694] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym__string_content] = ACTIONS(2258),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
  },
  [695] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [696] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym__string_content] = ACTIONS(2262),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
  },
  [697] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [698] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym__string_content] = ACTIONS(2264),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
  },
  [699] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT_GT] = ACTIONS(2290),
    [anon_sym_LT_AMP] = ACTIONS(2290),
    [anon_sym_GT_AMP] = ACTIONS(2290),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_LT_LT_DASH] = ACTIONS(2290),
    [anon_sym_LT_LT_LT] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_raw_string] = ACTIONS(2290),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2290),
    [anon_sym_GT_LPAREN] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [700] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [sym_comment] = ACTIONS(48),
  },
  [701] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1175),
    [anon_sym_DQUOTE] = ACTIONS(2296),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [702] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [sym_comment] = ACTIONS(48),
  },
  [703] = {
    [sym_string] = STATE(1179),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [anon_sym_DOLLAR] = ACTIONS(2300),
    [anon_sym_POUND] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2302),
    [anon_sym_STAR] = ACTIONS(2300),
    [anon_sym_AT] = ACTIONS(2300),
    [anon_sym_QMARK] = ACTIONS(2300),
    [anon_sym_0] = ACTIONS(2304),
    [anon_sym__] = ACTIONS(2304),
  },
  [704] = {
    [sym_subscript] = STATE(1184),
    [sym_variable_name] = ACTIONS(2306),
    [anon_sym_DOLLAR] = ACTIONS(2308),
    [anon_sym_POUND] = ACTIONS(2310),
    [anon_sym_DASH] = ACTIONS(2308),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2308),
    [anon_sym_AT] = ACTIONS(2308),
    [anon_sym_QMARK] = ACTIONS(2308),
    [anon_sym_0] = ACTIONS(2314),
    [anon_sym__] = ACTIONS(2314),
  },
  [705] = {
    [sym_for_statement] = STATE(1185),
    [sym_while_statement] = STATE(1185),
    [sym_if_statement] = STATE(1185),
    [sym_case_statement] = STATE(1185),
    [sym_function_definition] = STATE(1185),
    [sym_subshell] = STATE(1185),
    [sym_pipeline] = STATE(1185),
    [sym_list] = STATE(1185),
    [sym_command] = STATE(1185),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1186),
    [sym_declaration_command] = STATE(1185),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [706] = {
    [sym_for_statement] = STATE(1187),
    [sym_while_statement] = STATE(1187),
    [sym_if_statement] = STATE(1187),
    [sym_case_statement] = STATE(1187),
    [sym_function_definition] = STATE(1187),
    [sym_subshell] = STATE(1187),
    [sym_pipeline] = STATE(1187),
    [sym_list] = STATE(1187),
    [sym_command] = STATE(1187),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1188),
    [sym_declaration_command] = STATE(1187),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [707] = {
    [sym_for_statement] = STATE(1189),
    [sym_while_statement] = STATE(1189),
    [sym_if_statement] = STATE(1189),
    [sym_case_statement] = STATE(1189),
    [sym_function_definition] = STATE(1189),
    [sym_subshell] = STATE(1189),
    [sym_pipeline] = STATE(1189),
    [sym_list] = STATE(1189),
    [sym_command] = STATE(1189),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1190),
    [sym_declaration_command] = STATE(1189),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [708] = {
    [anon_sym_RBRACE] = ACTIONS(2298),
    [sym_comment] = ACTIONS(48),
  },
  [709] = {
    [aux_sym_concatenation_repeat1] = STATE(507),
    [sym__concat] = ACTIONS(2316),
    [anon_sym_RBRACK] = ACTIONS(2318),
    [sym_comment] = ACTIONS(48),
  },
  [710] = {
    [aux_sym_concatenation_repeat1] = STATE(507),
    [sym__concat] = ACTIONS(2320),
    [anon_sym_RBRACK] = ACTIONS(2322),
    [sym_comment] = ACTIONS(48),
  },
  [711] = {
    [sym__concat] = ACTIONS(2324),
    [anon_sym_RBRACK] = ACTIONS(2322),
    [sym_comment] = ACTIONS(48),
  },
  [712] = {
    [sym_string] = STATE(1196),
    [sym_simple_expansion] = STATE(1196),
    [sym_expansion] = STATE(1196),
    [sym_command_substitution] = STATE(1196),
    [sym_process_substitution] = STATE(1196),
    [sym__special_characters] = ACTIONS(2326),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(2328),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2326),
  },
  [713] = {
    [aux_sym_concatenation_repeat1] = STATE(1197),
    [sym__concat] = ACTIONS(1388),
    [anon_sym_RBRACE] = ACTIONS(538),
    [anon_sym_EQ] = ACTIONS(1270),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_POUND] = ACTIONS(538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_COLON] = ACTIONS(1270),
    [anon_sym_COLON_QMARK] = ACTIONS(1270),
    [anon_sym_COLON_DASH] = ACTIONS(1270),
    [anon_sym_PERCENT] = ACTIONS(1270),
    [anon_sym_SLASH] = ACTIONS(1270),
    [anon_sym_DASH] = ACTIONS(1270),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(540),
  },
  [714] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [anon_sym_EQ] = ACTIONS(1272),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_POUND] = ACTIONS(542),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_COLON] = ACTIONS(1272),
    [anon_sym_COLON_QMARK] = ACTIONS(1272),
    [anon_sym_COLON_DASH] = ACTIONS(1272),
    [anon_sym_PERCENT] = ACTIONS(1272),
    [anon_sym_SLASH] = ACTIONS(1272),
    [anon_sym_DASH] = ACTIONS(1272),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(544),
  },
  [715] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(2330),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [716] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(572),
    [anon_sym_EQ] = ACTIONS(1276),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_POUND] = ACTIONS(572),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_COLON] = ACTIONS(1276),
    [anon_sym_COLON_QMARK] = ACTIONS(1276),
    [anon_sym_COLON_DASH] = ACTIONS(1276),
    [anon_sym_PERCENT] = ACTIONS(1276),
    [anon_sym_SLASH] = ACTIONS(1276),
    [anon_sym_DASH] = ACTIONS(1276),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(574),
  },
  [717] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_RBRACE] = ACTIONS(576),
    [anon_sym_EQ] = ACTIONS(1278),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_POUND] = ACTIONS(576),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_COLON] = ACTIONS(1278),
    [anon_sym_COLON_QMARK] = ACTIONS(1278),
    [anon_sym_COLON_DASH] = ACTIONS(1278),
    [anon_sym_PERCENT] = ACTIONS(1278),
    [anon_sym_SLASH] = ACTIONS(1278),
    [anon_sym_DASH] = ACTIONS(1278),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(578),
  },
  [718] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(580),
    [anon_sym_EQ] = ACTIONS(1280),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_POUND] = ACTIONS(580),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_COLON] = ACTIONS(1280),
    [anon_sym_COLON_QMARK] = ACTIONS(1280),
    [anon_sym_COLON_DASH] = ACTIONS(1280),
    [anon_sym_PERCENT] = ACTIONS(1280),
    [anon_sym_SLASH] = ACTIONS(1280),
    [anon_sym_DASH] = ACTIONS(1280),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(582),
  },
  [719] = {
    [anon_sym_EQ] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [720] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1201),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [721] = {
    [sym_subscript] = STATE(1205),
    [sym_variable_name] = ACTIONS(2336),
    [anon_sym_DOLLAR] = ACTIONS(2338),
    [anon_sym_DASH] = ACTIONS(2338),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2338),
    [anon_sym_AT] = ACTIONS(2338),
    [anon_sym_QMARK] = ACTIONS(2338),
    [anon_sym_0] = ACTIONS(2342),
    [anon_sym__] = ACTIONS(2342),
  },
  [722] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1207),
    [anon_sym_RBRACE] = ACTIONS(2344),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [723] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1209),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [724] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2348),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [725] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2348),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [726] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(2348),
    [sym_comment] = ACTIONS(48),
  },
  [727] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(2348),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [728] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [729] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2350),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [730] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2354),
    [anon_sym_GT_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT_GT] = ACTIONS(2354),
    [anon_sym_LT_AMP] = ACTIONS(2354),
    [anon_sym_GT_AMP] = ACTIONS(2354),
    [anon_sym_LT_LT] = ACTIONS(2354),
    [anon_sym_LT_LT_DASH] = ACTIONS(2354),
    [anon_sym_LT_LT_LT] = ACTIONS(2354),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_raw_string] = ACTIONS(2354),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [anon_sym_LT_LPAREN] = ACTIONS(2354),
    [anon_sym_GT_LPAREN] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [731] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2356),
    [anon_sym_EQ] = ACTIONS(2358),
    [sym__special_characters] = ACTIONS(2361),
    [anon_sym_DQUOTE] = ACTIONS(2364),
    [sym_raw_string] = ACTIONS(2367),
    [anon_sym_DOLLAR] = ACTIONS(2370),
    [anon_sym_POUND] = ACTIONS(2373),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2376),
    [anon_sym_COLON] = ACTIONS(2358),
    [anon_sym_COLON_QMARK] = ACTIONS(2358),
    [anon_sym_COLON_DASH] = ACTIONS(2358),
    [anon_sym_PERCENT] = ACTIONS(2358),
    [anon_sym_SLASH] = ACTIONS(2358),
    [anon_sym_DASH] = ACTIONS(2358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2379),
    [anon_sym_BQUOTE] = ACTIONS(2382),
    [anon_sym_LT_LPAREN] = ACTIONS(2385),
    [anon_sym_GT_LPAREN] = ACTIONS(2385),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2388),
  },
  [732] = {
    [sym_concatenation] = STATE(1214),
    [sym_string] = STATE(1213),
    [sym_simple_expansion] = STATE(1213),
    [sym_expansion] = STATE(1213),
    [sym_command_substitution] = STATE(1213),
    [sym_process_substitution] = STATE(1213),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [sym__special_characters] = ACTIONS(2391),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2393),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2395),
  },
  [733] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT_GT] = ACTIONS(2399),
    [anon_sym_LT_AMP] = ACTIONS(2399),
    [anon_sym_GT_AMP] = ACTIONS(2399),
    [anon_sym_LT_LT] = ACTIONS(2399),
    [anon_sym_LT_LT_DASH] = ACTIONS(2399),
    [anon_sym_LT_LT_LT] = ACTIONS(2399),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym_raw_string] = ACTIONS(2399),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_LT_LPAREN] = ACTIONS(2399),
    [anon_sym_GT_LPAREN] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [734] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2401),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [735] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_GT_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT_GT] = ACTIONS(2405),
    [anon_sym_LT_AMP] = ACTIONS(2405),
    [anon_sym_GT_AMP] = ACTIONS(2405),
    [anon_sym_LT_LT] = ACTIONS(2405),
    [anon_sym_LT_LT_DASH] = ACTIONS(2405),
    [anon_sym_LT_LT_LT] = ACTIONS(2405),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym_raw_string] = ACTIONS(2405),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [anon_sym_LT_LPAREN] = ACTIONS(2405),
    [anon_sym_GT_LPAREN] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [736] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2407),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [737] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [738] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_GT_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT_GT] = ACTIONS(2411),
    [anon_sym_LT_AMP] = ACTIONS(2411),
    [anon_sym_GT_AMP] = ACTIONS(2411),
    [anon_sym_LT_LT] = ACTIONS(2411),
    [anon_sym_LT_LT_DASH] = ACTIONS(2411),
    [anon_sym_LT_LT_LT] = ACTIONS(2411),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_raw_string] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2411),
    [anon_sym_GT_LPAREN] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [739] = {
    [sym_file_descriptor] = ACTIONS(930),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_RPAREN] = ACTIONS(930),
    [anon_sym_PIPE_AMP] = ACTIONS(930),
    [anon_sym_AMP_AMP] = ACTIONS(930),
    [anon_sym_PIPE_PIPE] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2413),
    [anon_sym_GT_GT] = ACTIONS(930),
    [anon_sym_AMP_GT] = ACTIONS(2413),
    [anon_sym_AMP_GT_GT] = ACTIONS(930),
    [anon_sym_LT_AMP] = ACTIONS(930),
    [anon_sym_GT_AMP] = ACTIONS(930),
    [sym__special_characters] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [sym_raw_string] = ACTIONS(930),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(930),
    [anon_sym_BQUOTE] = ACTIONS(930),
    [anon_sym_LT_LPAREN] = ACTIONS(930),
    [anon_sym_GT_LPAREN] = ACTIONS(930),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2413),
  },
  [740] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(1218),
    [anon_sym_RPAREN] = ACTIONS(2415),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [741] = {
    [aux_sym_concatenation_repeat1] = STATE(1220),
    [sym_file_descriptor] = ACTIONS(954),
    [sym__concat] = ACTIONS(2417),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_RPAREN] = ACTIONS(954),
    [anon_sym_PIPE_AMP] = ACTIONS(954),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_GT_GT] = ACTIONS(954),
    [anon_sym_AMP_GT] = ACTIONS(2419),
    [anon_sym_AMP_GT_GT] = ACTIONS(954),
    [anon_sym_LT_AMP] = ACTIONS(954),
    [anon_sym_GT_AMP] = ACTIONS(954),
    [sym__special_characters] = ACTIONS(2419),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_raw_string] = ACTIONS(954),
    [anon_sym_DOLLAR] = ACTIONS(2419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(954),
    [anon_sym_BQUOTE] = ACTIONS(954),
    [anon_sym_LT_LPAREN] = ACTIONS(954),
    [anon_sym_GT_LPAREN] = ACTIONS(954),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2419),
  },
  [742] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1222),
    [anon_sym_DQUOTE] = ACTIONS(2421),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [743] = {
    [aux_sym_concatenation_repeat1] = STATE(1220),
    [sym_file_descriptor] = ACTIONS(930),
    [sym__concat] = ACTIONS(2417),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_RPAREN] = ACTIONS(930),
    [anon_sym_PIPE_AMP] = ACTIONS(930),
    [anon_sym_AMP_AMP] = ACTIONS(930),
    [anon_sym_PIPE_PIPE] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2413),
    [anon_sym_GT_GT] = ACTIONS(930),
    [anon_sym_AMP_GT] = ACTIONS(2413),
    [anon_sym_AMP_GT_GT] = ACTIONS(930),
    [anon_sym_LT_AMP] = ACTIONS(930),
    [anon_sym_GT_AMP] = ACTIONS(930),
    [sym__special_characters] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [sym_raw_string] = ACTIONS(930),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(930),
    [anon_sym_BQUOTE] = ACTIONS(930),
    [anon_sym_LT_LPAREN] = ACTIONS(930),
    [anon_sym_GT_LPAREN] = ACTIONS(930),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2413),
  },
  [744] = {
    [sym_string] = STATE(1225),
    [anon_sym_DQUOTE] = ACTIONS(1438),
    [anon_sym_DOLLAR] = ACTIONS(2423),
    [anon_sym_POUND] = ACTIONS(2423),
    [anon_sym_DASH] = ACTIONS(2423),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2425),
    [anon_sym_STAR] = ACTIONS(2423),
    [anon_sym_AT] = ACTIONS(2423),
    [anon_sym_QMARK] = ACTIONS(2423),
    [anon_sym_0] = ACTIONS(2427),
    [anon_sym__] = ACTIONS(2427),
  },
  [745] = {
    [sym_subscript] = STATE(1230),
    [sym_variable_name] = ACTIONS(2429),
    [anon_sym_DOLLAR] = ACTIONS(2431),
    [anon_sym_POUND] = ACTIONS(2433),
    [anon_sym_DASH] = ACTIONS(2431),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2435),
    [anon_sym_STAR] = ACTIONS(2431),
    [anon_sym_AT] = ACTIONS(2431),
    [anon_sym_QMARK] = ACTIONS(2431),
    [anon_sym_0] = ACTIONS(2437),
    [anon_sym__] = ACTIONS(2437),
  },
  [746] = {
    [sym_for_statement] = STATE(1231),
    [sym_while_statement] = STATE(1231),
    [sym_if_statement] = STATE(1231),
    [sym_case_statement] = STATE(1231),
    [sym_function_definition] = STATE(1231),
    [sym_subshell] = STATE(1231),
    [sym_pipeline] = STATE(1231),
    [sym_list] = STATE(1231),
    [sym_command] = STATE(1231),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1232),
    [sym_declaration_command] = STATE(1231),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [747] = {
    [sym_for_statement] = STATE(1233),
    [sym_while_statement] = STATE(1233),
    [sym_if_statement] = STATE(1233),
    [sym_case_statement] = STATE(1233),
    [sym_function_definition] = STATE(1233),
    [sym_subshell] = STATE(1233),
    [sym_pipeline] = STATE(1233),
    [sym_list] = STATE(1233),
    [sym_command] = STATE(1233),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1234),
    [sym_declaration_command] = STATE(1233),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [748] = {
    [sym_for_statement] = STATE(1235),
    [sym_while_statement] = STATE(1235),
    [sym_if_statement] = STATE(1235),
    [sym_case_statement] = STATE(1235),
    [sym_function_definition] = STATE(1235),
    [sym_subshell] = STATE(1235),
    [sym_pipeline] = STATE(1235),
    [sym_list] = STATE(1235),
    [sym_command] = STATE(1235),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1236),
    [sym_declaration_command] = STATE(1235),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [749] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(529),
    [sym_simple_expansion] = STATE(529),
    [sym_expansion] = STATE(529),
    [sym_command_substitution] = STATE(529),
    [sym_process_substitution] = STATE(529),
    [aux_sym_for_statement_repeat1] = STATE(1237),
    [sym__special_characters] = ACTIONS(1006),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [sym_raw_string] = ACTIONS(1010),
    [anon_sym_DOLLAR] = ACTIONS(1012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [anon_sym_LT_LPAREN] = ACTIONS(1020),
    [anon_sym_GT_LPAREN] = ACTIONS(1020),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1022),
  },
  [750] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1239),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(2439),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [751] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(1240),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(2441),
    [anon_sym_RPAREN] = ACTIONS(2443),
    [anon_sym_PIPE_AMP] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_PIPE_PIPE] = ACTIONS(2443),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym_comment] = ACTIONS(48),
  },
  [752] = {
    [sym__terminated_statement] = STATE(546),
    [sym_for_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(1242),
    [sym_case_statement] = STATE(547),
    [sym_function_definition] = STATE(547),
    [sym_subshell] = STATE(547),
    [sym_pipeline] = STATE(547),
    [sym_list] = STATE(547),
    [sym_command] = STATE(547),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(550),
    [sym_declaration_command] = STATE(547),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1243),
    [aux_sym_if_statement_repeat1] = STATE(1244),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(2445),
    [anon_sym_elif] = ACTIONS(1030),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [753] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2447),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2447),
    [anon_sym_LF] = ACTIONS(2447),
    [anon_sym_AMP] = ACTIONS(2447),
  },
  [754] = {
    [anon_sym_in] = ACTIONS(2449),
    [sym_comment] = ACTIONS(48),
  },
  [755] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(2451),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2451),
    [anon_sym_LF] = ACTIONS(2451),
    [anon_sym_AMP] = ACTIONS(2451),
  },
  [756] = {
    [anon_sym_in] = ACTIONS(2453),
    [sym_comment] = ACTIONS(48),
  },
  [757] = {
    [anon_sym_RPAREN] = ACTIONS(2455),
    [sym_comment] = ACTIONS(48),
  },
  [758] = {
    [sym__terminated_statement] = STATE(575),
    [sym_for_statement] = STATE(576),
    [sym_while_statement] = STATE(576),
    [sym_if_statement] = STATE(576),
    [sym_case_statement] = STATE(576),
    [sym_function_definition] = STATE(576),
    [sym_subshell] = STATE(576),
    [sym_pipeline] = STATE(576),
    [sym_list] = STATE(576),
    [sym_command] = STATE(576),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(577),
    [sym_declaration_command] = STATE(576),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1251),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(2457),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [759] = {
    [sym_file_redirect] = STATE(1254),
    [sym_file_descriptor] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_RPAREN] = ACTIONS(2463),
    [anon_sym_PIPE_AMP] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2467),
    [anon_sym_AMP_GT] = ACTIONS(2465),
    [anon_sym_AMP_GT_GT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2467),
    [anon_sym_GT_AMP] = ACTIONS(2467),
    [sym_comment] = ACTIONS(48),
  },
  [760] = {
    [anon_sym_PIPE] = ACTIONS(2469),
    [anon_sym_RPAREN] = ACTIONS(2471),
    [anon_sym_PIPE_AMP] = ACTIONS(2471),
    [anon_sym_AMP_AMP] = ACTIONS(2471),
    [anon_sym_PIPE_PIPE] = ACTIONS(2471),
    [anon_sym_BQUOTE] = ACTIONS(2471),
    [sym_comment] = ACTIONS(48),
  },
  [761] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(2473),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [762] = {
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(2475),
    [anon_sym_SEMI_SEMI] = ACTIONS(2477),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym_LF] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2477),
  },
  [763] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(436),
    [anon_sym_RPAREN] = ACTIONS(2475),
    [anon_sym_SEMI_SEMI] = ACTIONS(2477),
    [anon_sym_PIPE_AMP] = ACTIONS(436),
    [anon_sym_AMP_AMP] = ACTIONS(442),
    [anon_sym_PIPE_PIPE] = ACTIONS(442),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(2477),
    [anon_sym_LF] = ACTIONS(2477),
    [anon_sym_AMP] = ACTIONS(2477),
  },
  [764] = {
    [sym_concatenation] = STATE(1257),
    [sym_string] = STATE(1260),
    [sym_array] = STATE(1257),
    [sym_simple_expansion] = STATE(1260),
    [sym_expansion] = STATE(1260),
    [sym_command_substitution] = STATE(1260),
    [sym_process_substitution] = STATE(1260),
    [sym__empty_value] = ACTIONS(2479),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [sym__special_characters] = ACTIONS(2483),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(2485),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_LT_LPAREN] = ACTIONS(656),
    [anon_sym_GT_LPAREN] = ACTIONS(656),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2487),
  },
  [765] = {
    [sym_variable_name] = ACTIONS(348),
    [anon_sym_PIPE] = ACTIONS(1454),
    [anon_sym_RPAREN] = ACTIONS(348),
    [anon_sym_PIPE_AMP] = ACTIONS(348),
    [anon_sym_AMP_AMP] = ACTIONS(348),
    [anon_sym_PIPE_PIPE] = ACTIONS(348),
    [sym__special_characters] = ACTIONS(1454),
    [anon_sym_DQUOTE] = ACTIONS(348),
    [sym_raw_string] = ACTIONS(348),
    [anon_sym_DOLLAR] = ACTIONS(1454),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(348),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(348),
    [anon_sym_BQUOTE] = ACTIONS(348),
    [anon_sym_LT_LPAREN] = ACTIONS(348),
    [anon_sym_GT_LPAREN] = ACTIONS(348),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1454),
    [sym_word] = ACTIONS(350),
  },
  [766] = {
    [sym_string] = STATE(1261),
    [sym_simple_expansion] = STATE(1261),
    [sym_expansion] = STATE(1261),
    [sym_command_substitution] = STATE(1261),
    [sym_process_substitution] = STATE(1261),
    [sym__special_characters] = ACTIONS(2489),
    [anon_sym_DQUOTE] = ACTIONS(644),
    [sym_raw_string] = ACTIONS(2491),
    [anon_sym_DOLLAR] = ACTIONS(648),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(650),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(652),
    [anon_sym_BQUOTE] = ACTIONS(654),
    [anon_sym_LT_LPAREN] = ACTIONS(656),
    [anon_sym_GT_LPAREN] = ACTIONS(656),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2489),
  },
  [767] = {
    [aux_sym_concatenation_repeat1] = STATE(1262),
    [sym__concat] = ACTIONS(1480),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_RPAREN] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1270),
    [sym_word] = ACTIONS(540),
  },
  [768] = {
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1272),
    [sym_word] = ACTIONS(544),
  },
  [769] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(2493),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [770] = {
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1276),
    [sym_word] = ACTIONS(574),
  },
  [771] = {
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1278),
    [sym_word] = ACTIONS(578),
  },
  [772] = {
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1280),
    [sym_word] = ACTIONS(582),
  },
  [773] = {
    [anon_sym_EQ] = ACTIONS(2495),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [774] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1266),
    [anon_sym_RBRACE] = ACTIONS(2497),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [775] = {
    [sym_subscript] = STATE(1270),
    [sym_variable_name] = ACTIONS(2499),
    [anon_sym_DOLLAR] = ACTIONS(2501),
    [anon_sym_DASH] = ACTIONS(2501),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2503),
    [anon_sym_STAR] = ACTIONS(2501),
    [anon_sym_AT] = ACTIONS(2501),
    [anon_sym_QMARK] = ACTIONS(2501),
    [anon_sym_0] = ACTIONS(2505),
    [anon_sym__] = ACTIONS(2505),
  },
  [776] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1272),
    [anon_sym_RBRACE] = ACTIONS(2507),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [777] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1274),
    [anon_sym_RBRACE] = ACTIONS(2509),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [778] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2511),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [779] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2511),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [780] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(2511),
    [sym_comment] = ACTIONS(48),
  },
  [781] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(2511),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [782] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2513),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [783] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2513),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [784] = {
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(371),
    [sym_concatenation] = STATE(370),
    [sym_string] = STATE(363),
    [sym_simple_expansion] = STATE(363),
    [sym_expansion] = STATE(363),
    [sym_command_substitution] = STATE(363),
    [sym_process_substitution] = STATE(363),
    [aux_sym_declaration_command_repeat1] = STATE(784),
    [sym_variable_name] = ACTIONS(2515),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_RPAREN] = ACTIONS(2520),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [sym__special_characters] = ACTIONS(2522),
    [anon_sym_DQUOTE] = ACTIONS(2525),
    [sym_raw_string] = ACTIONS(2528),
    [anon_sym_DOLLAR] = ACTIONS(2531),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2534),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2537),
    [anon_sym_BQUOTE] = ACTIONS(2540),
    [anon_sym_LT_LPAREN] = ACTIONS(2543),
    [anon_sym_GT_LPAREN] = ACTIONS(2543),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2546),
    [sym_word] = ACTIONS(2549),
  },
  [785] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [786] = {
    [aux_sym_concatenation_repeat1] = STATE(786),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(2552),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [787] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_AMP] = ACTIONS(1333),
    [anon_sym_GT_AMP] = ACTIONS(1333),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_LT] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2238),
  },
  [788] = {
    [sym_concatenation] = STATE(1280),
    [sym_string] = STATE(1279),
    [sym_simple_expansion] = STATE(1279),
    [sym_expansion] = STATE(1279),
    [sym_command_substitution] = STATE(1279),
    [sym_process_substitution] = STATE(1279),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [sym__special_characters] = ACTIONS(2557),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2559),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2561),
  },
  [789] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(2248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2248),
  },
  [790] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2563),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [791] = {
    [anon_sym_EQ] = ACTIONS(2565),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [792] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1284),
    [anon_sym_RBRACE] = ACTIONS(2567),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [793] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1286),
    [anon_sym_RBRACE] = ACTIONS(2569),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [794] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1287),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [795] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP_GT] = ACTIONS(2258),
    [anon_sym_AMP_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_AMP] = ACTIONS(1422),
    [anon_sym_GT_AMP] = ACTIONS(1422),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_LT_LT_DASH] = ACTIONS(1422),
    [anon_sym_LT_LT_LT] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2258),
  },
  [796] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2571),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [797] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_AMP_GT] = ACTIONS(2262),
    [anon_sym_AMP_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_AMP] = ACTIONS(1428),
    [anon_sym_GT_AMP] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_LT_LT_DASH] = ACTIONS(1428),
    [anon_sym_LT_LT_LT] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2262),
  },
  [798] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2555),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [799] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_LT_LT_LT] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2264),
  },
  [800] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(2266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_LT_LT_DASH] = ACTIONS(1682),
    [anon_sym_LT_LT_LT] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2266),
  },
  [801] = {
    [sym_compound_statement] = STATE(1289),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [sym_comment] = ACTIONS(48),
  },
  [802] = {
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(2575),
    [anon_sym_PIPE_AMP] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_BQUOTE] = ACTIONS(2575),
    [sym_comment] = ACTIONS(48),
  },
  [803] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_RPAREN] = ACTIONS(2575),
    [anon_sym_PIPE_AMP] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [804] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [sym_comment] = ACTIONS(48),
  },
  [805] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2577),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [806] = {
    [sym_concatenation] = STATE(1292),
    [sym_string] = STATE(1291),
    [sym_simple_expansion] = STATE(1291),
    [sym_expansion] = STATE(1291),
    [sym_command_substitution] = STATE(1291),
    [sym_process_substitution] = STATE(1291),
    [sym__special_characters] = ACTIONS(2579),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(2581),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1556),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [anon_sym_LT_LPAREN] = ACTIONS(1560),
    [anon_sym_GT_LPAREN] = ACTIONS(1560),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2583),
  },
  [807] = {
    [aux_sym_concatenation_repeat1] = STATE(1294),
    [sym_file_descriptor] = ACTIONS(506),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_RPAREN] = ACTIONS(506),
    [anon_sym_PIPE_AMP] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_AMP_GT] = ACTIONS(510),
    [anon_sym_AMP_GT_GT] = ACTIONS(506),
    [anon_sym_LT_AMP] = ACTIONS(506),
    [anon_sym_GT_AMP] = ACTIONS(506),
    [anon_sym_LT_LT] = ACTIONS(510),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_LT_LT_LT] = ACTIONS(506),
    [sym_comment] = ACTIONS(48),
  },
  [808] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1296),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [809] = {
    [aux_sym_concatenation_repeat1] = STATE(1294),
    [sym_file_descriptor] = ACTIONS(514),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_PIPE_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(514),
    [anon_sym_PIPE_PIPE] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(514),
    [anon_sym_AMP_GT] = ACTIONS(516),
    [anon_sym_AMP_GT_GT] = ACTIONS(514),
    [anon_sym_LT_AMP] = ACTIONS(514),
    [anon_sym_GT_AMP] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_LT_LT_DASH] = ACTIONS(514),
    [anon_sym_LT_LT_LT] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
  },
  [810] = {
    [sym_string] = STATE(1299),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [anon_sym_DOLLAR] = ACTIONS(2589),
    [anon_sym_POUND] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2589),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2591),
    [anon_sym_STAR] = ACTIONS(2589),
    [anon_sym_AT] = ACTIONS(2589),
    [anon_sym_QMARK] = ACTIONS(2589),
    [anon_sym_0] = ACTIONS(2593),
    [anon_sym__] = ACTIONS(2593),
  },
  [811] = {
    [sym_subscript] = STATE(1304),
    [sym_variable_name] = ACTIONS(2595),
    [anon_sym_DOLLAR] = ACTIONS(2597),
    [anon_sym_POUND] = ACTIONS(2599),
    [anon_sym_DASH] = ACTIONS(2597),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2601),
    [anon_sym_STAR] = ACTIONS(2597),
    [anon_sym_AT] = ACTIONS(2597),
    [anon_sym_QMARK] = ACTIONS(2597),
    [anon_sym_0] = ACTIONS(2603),
    [anon_sym__] = ACTIONS(2603),
  },
  [812] = {
    [sym_for_statement] = STATE(1305),
    [sym_while_statement] = STATE(1305),
    [sym_if_statement] = STATE(1305),
    [sym_case_statement] = STATE(1305),
    [sym_function_definition] = STATE(1305),
    [sym_subshell] = STATE(1305),
    [sym_pipeline] = STATE(1305),
    [sym_list] = STATE(1305),
    [sym_command] = STATE(1305),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1306),
    [sym_declaration_command] = STATE(1305),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [813] = {
    [sym_for_statement] = STATE(1307),
    [sym_while_statement] = STATE(1307),
    [sym_if_statement] = STATE(1307),
    [sym_case_statement] = STATE(1307),
    [sym_function_definition] = STATE(1307),
    [sym_subshell] = STATE(1307),
    [sym_pipeline] = STATE(1307),
    [sym_list] = STATE(1307),
    [sym_command] = STATE(1307),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1308),
    [sym_declaration_command] = STATE(1307),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [814] = {
    [sym_for_statement] = STATE(1309),
    [sym_while_statement] = STATE(1309),
    [sym_if_statement] = STATE(1309),
    [sym_case_statement] = STATE(1309),
    [sym_function_definition] = STATE(1309),
    [sym_subshell] = STATE(1309),
    [sym_pipeline] = STATE(1309),
    [sym_list] = STATE(1309),
    [sym_command] = STATE(1309),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1310),
    [sym_declaration_command] = STATE(1309),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [815] = {
    [sym_file_descriptor] = ACTIONS(514),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_PIPE_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(514),
    [anon_sym_PIPE_PIPE] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(514),
    [anon_sym_AMP_GT] = ACTIONS(516),
    [anon_sym_AMP_GT_GT] = ACTIONS(514),
    [anon_sym_LT_AMP] = ACTIONS(514),
    [anon_sym_GT_AMP] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_LT_LT_DASH] = ACTIONS(514),
    [anon_sym_LT_LT_LT] = ACTIONS(514),
    [anon_sym_BQUOTE] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
  },
  [816] = {
    [sym_file_descriptor] = ACTIONS(1720),
    [anon_sym_PIPE] = ACTIONS(2605),
    [anon_sym_RPAREN] = ACTIONS(1720),
    [anon_sym_PIPE_AMP] = ACTIONS(1720),
    [anon_sym_AMP_AMP] = ACTIONS(1720),
    [anon_sym_PIPE_PIPE] = ACTIONS(1720),
    [anon_sym_LT] = ACTIONS(2605),
    [anon_sym_GT] = ACTIONS(2605),
    [anon_sym_GT_GT] = ACTIONS(1720),
    [anon_sym_AMP_GT] = ACTIONS(2605),
    [anon_sym_AMP_GT_GT] = ACTIONS(1720),
    [anon_sym_LT_AMP] = ACTIONS(1720),
    [anon_sym_GT_AMP] = ACTIONS(1720),
    [anon_sym_LT_LT] = ACTIONS(2605),
    [anon_sym_LT_LT_DASH] = ACTIONS(1720),
    [anon_sym_LT_LT_LT] = ACTIONS(1720),
    [anon_sym_BQUOTE] = ACTIONS(1720),
    [sym_comment] = ACTIONS(48),
  },
  [817] = {
    [sym_simple_expansion] = STATE(914),
    [sym_expansion] = STATE(914),
    [aux_sym_heredoc_repeat1] = STATE(1312),
    [sym__heredoc_middle] = ACTIONS(1724),
    [sym__heredoc_end] = ACTIONS(2607),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1730),
    [sym_comment] = ACTIONS(48),
  },
  [818] = {
    [sym_file_descriptor] = ACTIONS(1732),
    [anon_sym_PIPE] = ACTIONS(2609),
    [anon_sym_RPAREN] = ACTIONS(1732),
    [anon_sym_PIPE_AMP] = ACTIONS(1732),
    [anon_sym_AMP_AMP] = ACTIONS(1732),
    [anon_sym_PIPE_PIPE] = ACTIONS(1732),
    [anon_sym_LT] = ACTIONS(2609),
    [anon_sym_GT] = ACTIONS(2609),
    [anon_sym_GT_GT] = ACTIONS(1732),
    [anon_sym_AMP_GT] = ACTIONS(2609),
    [anon_sym_AMP_GT_GT] = ACTIONS(1732),
    [anon_sym_LT_AMP] = ACTIONS(1732),
    [anon_sym_GT_AMP] = ACTIONS(1732),
    [anon_sym_LT_LT] = ACTIONS(2609),
    [anon_sym_LT_LT_DASH] = ACTIONS(1732),
    [anon_sym_LT_LT_LT] = ACTIONS(1732),
    [anon_sym_BQUOTE] = ACTIONS(1732),
    [sym_comment] = ACTIONS(48),
  },
  [819] = {
    [aux_sym_concatenation_repeat1] = STATE(1294),
    [sym_file_descriptor] = ACTIONS(1736),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_RPAREN] = ACTIONS(1736),
    [anon_sym_PIPE_AMP] = ACTIONS(1736),
    [anon_sym_AMP_AMP] = ACTIONS(1736),
    [anon_sym_PIPE_PIPE] = ACTIONS(1736),
    [anon_sym_LT] = ACTIONS(2611),
    [anon_sym_GT] = ACTIONS(2611),
    [anon_sym_GT_GT] = ACTIONS(1736),
    [anon_sym_AMP_GT] = ACTIONS(2611),
    [anon_sym_AMP_GT_GT] = ACTIONS(1736),
    [anon_sym_LT_AMP] = ACTIONS(1736),
    [anon_sym_GT_AMP] = ACTIONS(1736),
    [anon_sym_LT_LT] = ACTIONS(2611),
    [anon_sym_LT_LT_DASH] = ACTIONS(1736),
    [anon_sym_LT_LT_LT] = ACTIONS(1736),
    [sym_comment] = ACTIONS(48),
  },
  [820] = {
    [aux_sym_concatenation_repeat1] = STATE(1294),
    [sym_file_descriptor] = ACTIONS(1740),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(2613),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [anon_sym_PIPE_AMP] = ACTIONS(1740),
    [anon_sym_AMP_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(2613),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_AMP_GT] = ACTIONS(2613),
    [anon_sym_AMP_GT_GT] = ACTIONS(1740),
    [anon_sym_LT_AMP] = ACTIONS(1740),
    [anon_sym_GT_AMP] = ACTIONS(1740),
    [anon_sym_LT_LT] = ACTIONS(2613),
    [anon_sym_LT_LT_DASH] = ACTIONS(1740),
    [anon_sym_LT_LT_LT] = ACTIONS(1740),
    [sym_comment] = ACTIONS(48),
  },
  [821] = {
    [sym_file_descriptor] = ACTIONS(1740),
    [anon_sym_PIPE] = ACTIONS(2613),
    [anon_sym_RPAREN] = ACTIONS(1740),
    [anon_sym_PIPE_AMP] = ACTIONS(1740),
    [anon_sym_AMP_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(2613),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_AMP_GT] = ACTIONS(2613),
    [anon_sym_AMP_GT_GT] = ACTIONS(1740),
    [anon_sym_LT_AMP] = ACTIONS(1740),
    [anon_sym_GT_AMP] = ACTIONS(1740),
    [anon_sym_LT_LT] = ACTIONS(2613),
    [anon_sym_LT_LT_DASH] = ACTIONS(1740),
    [anon_sym_LT_LT_LT] = ACTIONS(1740),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_comment] = ACTIONS(48),
  },
  [822] = {
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(822),
    [sym_file_descriptor] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(1744),
    [anon_sym_AMP_GT] = ACTIONS(2615),
    [anon_sym_AMP_GT_GT] = ACTIONS(1744),
    [anon_sym_LT_AMP] = ACTIONS(1744),
    [anon_sym_GT_AMP] = ACTIONS(1744),
    [anon_sym_LT_LT] = ACTIONS(2615),
    [anon_sym_LT_LT_DASH] = ACTIONS(1744),
    [anon_sym_LT_LT_LT] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(2617),
    [anon_sym_DQUOTE] = ACTIONS(2620),
    [sym_raw_string] = ACTIONS(2623),
    [anon_sym_DOLLAR] = ACTIONS(2626),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2629),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2632),
    [anon_sym_BQUOTE] = ACTIONS(2635),
    [anon_sym_LT_LPAREN] = ACTIONS(2638),
    [anon_sym_GT_LPAREN] = ACTIONS(2638),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2641),
  },
  [823] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(824),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym_comment] = ACTIONS(48),
  },
  [824] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(824),
    [sym_file_descriptor] = ACTIONS(2648),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_RPAREN] = ACTIONS(2653),
    [anon_sym_PIPE_AMP] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_PIPE_PIPE] = ACTIONS(2653),
    [anon_sym_LT] = ACTIONS(2655),
    [anon_sym_GT] = ACTIONS(2655),
    [anon_sym_GT_GT] = ACTIONS(2658),
    [anon_sym_AMP_GT] = ACTIONS(2655),
    [anon_sym_AMP_GT_GT] = ACTIONS(2658),
    [anon_sym_LT_AMP] = ACTIONS(2658),
    [anon_sym_GT_AMP] = ACTIONS(2658),
    [anon_sym_LT_LT] = ACTIONS(2661),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2667),
    [sym_comment] = ACTIONS(48),
  },
  [825] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(400),
    [sym_simple_expansion] = STATE(400),
    [sym_expansion] = STATE(400),
    [sym_command_substitution] = STATE(400),
    [sym_process_substitution] = STATE(400),
    [aux_sym_for_statement_repeat1] = STATE(822),
    [aux_sym_while_statement_repeat1] = STATE(1313),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_RPAREN] = ACTIONS(2646),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym__special_characters] = ACTIONS(712),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(714),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(716),
  },
  [826] = {
    [aux_sym_concatenation_repeat1] = STATE(1315),
    [sym_file_descriptor] = ACTIONS(954),
    [sym__concat] = ACTIONS(2670),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE_AMP] = ACTIONS(954),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_GT_GT] = ACTIONS(954),
    [anon_sym_AMP_GT] = ACTIONS(2419),
    [anon_sym_AMP_GT_GT] = ACTIONS(954),
    [anon_sym_LT_AMP] = ACTIONS(954),
    [anon_sym_GT_AMP] = ACTIONS(954),
    [sym__special_characters] = ACTIONS(2419),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_raw_string] = ACTIONS(954),
    [anon_sym_DOLLAR] = ACTIONS(2419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(954),
    [anon_sym_BQUOTE] = ACTIONS(954),
    [anon_sym_LT_LPAREN] = ACTIONS(954),
    [anon_sym_GT_LPAREN] = ACTIONS(954),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2419),
  },
  [827] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1317),
    [anon_sym_DQUOTE] = ACTIONS(2672),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [828] = {
    [aux_sym_concatenation_repeat1] = STATE(1315),
    [sym_file_descriptor] = ACTIONS(930),
    [sym__concat] = ACTIONS(2670),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_PIPE_AMP] = ACTIONS(930),
    [anon_sym_AMP_AMP] = ACTIONS(930),
    [anon_sym_PIPE_PIPE] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2413),
    [anon_sym_GT_GT] = ACTIONS(930),
    [anon_sym_AMP_GT] = ACTIONS(2413),
    [anon_sym_AMP_GT_GT] = ACTIONS(930),
    [anon_sym_LT_AMP] = ACTIONS(930),
    [anon_sym_GT_AMP] = ACTIONS(930),
    [sym__special_characters] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [sym_raw_string] = ACTIONS(930),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(930),
    [anon_sym_BQUOTE] = ACTIONS(930),
    [anon_sym_LT_LPAREN] = ACTIONS(930),
    [anon_sym_GT_LPAREN] = ACTIONS(930),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2413),
  },
  [829] = {
    [sym_string] = STATE(1320),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [anon_sym_DOLLAR] = ACTIONS(2674),
    [anon_sym_POUND] = ACTIONS(2674),
    [anon_sym_DASH] = ACTIONS(2674),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2676),
    [anon_sym_STAR] = ACTIONS(2674),
    [anon_sym_AT] = ACTIONS(2674),
    [anon_sym_QMARK] = ACTIONS(2674),
    [anon_sym_0] = ACTIONS(2678),
    [anon_sym__] = ACTIONS(2678),
  },
  [830] = {
    [sym_subscript] = STATE(1325),
    [sym_variable_name] = ACTIONS(2680),
    [anon_sym_DOLLAR] = ACTIONS(2682),
    [anon_sym_POUND] = ACTIONS(2684),
    [anon_sym_DASH] = ACTIONS(2682),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2686),
    [anon_sym_STAR] = ACTIONS(2682),
    [anon_sym_AT] = ACTIONS(2682),
    [anon_sym_QMARK] = ACTIONS(2682),
    [anon_sym_0] = ACTIONS(2688),
    [anon_sym__] = ACTIONS(2688),
  },
  [831] = {
    [sym_for_statement] = STATE(1326),
    [sym_while_statement] = STATE(1326),
    [sym_if_statement] = STATE(1326),
    [sym_case_statement] = STATE(1326),
    [sym_function_definition] = STATE(1326),
    [sym_subshell] = STATE(1326),
    [sym_pipeline] = STATE(1326),
    [sym_list] = STATE(1326),
    [sym_command] = STATE(1326),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1327),
    [sym_declaration_command] = STATE(1326),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [832] = {
    [sym_for_statement] = STATE(1328),
    [sym_while_statement] = STATE(1328),
    [sym_if_statement] = STATE(1328),
    [sym_case_statement] = STATE(1328),
    [sym_function_definition] = STATE(1328),
    [sym_subshell] = STATE(1328),
    [sym_pipeline] = STATE(1328),
    [sym_list] = STATE(1328),
    [sym_command] = STATE(1328),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1329),
    [sym_declaration_command] = STATE(1328),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [833] = {
    [sym_for_statement] = STATE(1330),
    [sym_while_statement] = STATE(1330),
    [sym_if_statement] = STATE(1330),
    [sym_case_statement] = STATE(1330),
    [sym_function_definition] = STATE(1330),
    [sym_subshell] = STATE(1330),
    [sym_pipeline] = STATE(1330),
    [sym_list] = STATE(1330),
    [sym_command] = STATE(1330),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1331),
    [sym_declaration_command] = STATE(1330),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [834] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(1332),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(2441),
    [anon_sym_PIPE_AMP] = ACTIONS(2443),
    [anon_sym_AMP_AMP] = ACTIONS(2443),
    [anon_sym_PIPE_PIPE] = ACTIONS(2443),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(2443),
    [sym_comment] = ACTIONS(48),
  },
  [835] = {
    [anon_sym_RPAREN] = ACTIONS(2690),
    [sym_comment] = ACTIONS(48),
  },
  [836] = {
    [sym_file_redirect] = STATE(1254),
    [sym_file_descriptor] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(2461),
    [anon_sym_PIPE_AMP] = ACTIONS(2463),
    [anon_sym_AMP_AMP] = ACTIONS(2463),
    [anon_sym_PIPE_PIPE] = ACTIONS(2463),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(2463),
    [sym_comment] = ACTIONS(48),
  },
  [837] = {
    [sym_concatenation] = STATE(1257),
    [sym_string] = STATE(1337),
    [sym_array] = STATE(1257),
    [sym_simple_expansion] = STATE(1337),
    [sym_expansion] = STATE(1337),
    [sym_command_substitution] = STATE(1337),
    [sym_process_substitution] = STATE(1337),
    [sym__empty_value] = ACTIONS(2479),
    [anon_sym_LPAREN] = ACTIONS(2481),
    [sym__special_characters] = ACTIONS(2698),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(2700),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(2702),
    [anon_sym_LT_LPAREN] = ACTIONS(738),
    [anon_sym_GT_LPAREN] = ACTIONS(738),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2704),
  },
  [838] = {
    [sym_string] = STATE(1338),
    [sym_simple_expansion] = STATE(1338),
    [sym_expansion] = STATE(1338),
    [sym_command_substitution] = STATE(1338),
    [sym_process_substitution] = STATE(1338),
    [sym__special_characters] = ACTIONS(2706),
    [anon_sym_DQUOTE] = ACTIONS(728),
    [sym_raw_string] = ACTIONS(2708),
    [anon_sym_DOLLAR] = ACTIONS(732),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(734),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(736),
    [anon_sym_BQUOTE] = ACTIONS(2702),
    [anon_sym_LT_LPAREN] = ACTIONS(738),
    [anon_sym_GT_LPAREN] = ACTIONS(738),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2706),
  },
  [839] = {
    [aux_sym_concatenation_repeat1] = STATE(1339),
    [sym__concat] = ACTIONS(1606),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1270),
    [sym_word] = ACTIONS(540),
  },
  [840] = {
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1272),
    [sym_word] = ACTIONS(544),
  },
  [841] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(2710),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [842] = {
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1276),
    [sym_word] = ACTIONS(574),
  },
  [843] = {
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1278),
    [sym_word] = ACTIONS(578),
  },
  [844] = {
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1280),
    [sym_word] = ACTIONS(582),
  },
  [845] = {
    [anon_sym_EQ] = ACTIONS(2712),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [846] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1343),
    [anon_sym_RBRACE] = ACTIONS(2714),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [847] = {
    [sym_subscript] = STATE(1347),
    [sym_variable_name] = ACTIONS(2716),
    [anon_sym_DOLLAR] = ACTIONS(2718),
    [anon_sym_DASH] = ACTIONS(2718),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2720),
    [anon_sym_STAR] = ACTIONS(2718),
    [anon_sym_AT] = ACTIONS(2718),
    [anon_sym_QMARK] = ACTIONS(2718),
    [anon_sym_0] = ACTIONS(2722),
    [anon_sym__] = ACTIONS(2722),
  },
  [848] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1349),
    [anon_sym_RBRACE] = ACTIONS(2724),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [849] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1351),
    [anon_sym_RBRACE] = ACTIONS(2726),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [850] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [851] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2728),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [852] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [sym_comment] = ACTIONS(48),
  },
  [853] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(2728),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [854] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [855] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2730),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [856] = {
    [sym_variable_assignment] = STATE(370),
    [sym_subscript] = STATE(418),
    [sym_concatenation] = STATE(370),
    [sym_string] = STATE(412),
    [sym_simple_expansion] = STATE(412),
    [sym_expansion] = STATE(412),
    [sym_command_substitution] = STATE(412),
    [sym_process_substitution] = STATE(412),
    [aux_sym_declaration_command_repeat1] = STATE(856),
    [sym_variable_name] = ACTIONS(2732),
    [anon_sym_PIPE] = ACTIONS(2518),
    [anon_sym_PIPE_AMP] = ACTIONS(2520),
    [anon_sym_AMP_AMP] = ACTIONS(2520),
    [anon_sym_PIPE_PIPE] = ACTIONS(2520),
    [sym__special_characters] = ACTIONS(2735),
    [anon_sym_DQUOTE] = ACTIONS(2738),
    [sym_raw_string] = ACTIONS(2741),
    [anon_sym_DOLLAR] = ACTIONS(2744),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2747),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2750),
    [anon_sym_BQUOTE] = ACTIONS(2753),
    [anon_sym_LT_LPAREN] = ACTIONS(2756),
    [anon_sym_GT_LPAREN] = ACTIONS(2756),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2546),
    [sym_word] = ACTIONS(2759),
  },
  [857] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [858] = {
    [aux_sym_concatenation_repeat1] = STATE(858),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(2762),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [859] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_AMP] = ACTIONS(1333),
    [anon_sym_GT_AMP] = ACTIONS(1333),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_LT] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2238),
  },
  [860] = {
    [sym_concatenation] = STATE(1357),
    [sym_string] = STATE(1356),
    [sym_simple_expansion] = STATE(1356),
    [sym_expansion] = STATE(1356),
    [sym_command_substitution] = STATE(1356),
    [sym_process_substitution] = STATE(1356),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [sym__special_characters] = ACTIONS(2767),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2769),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2771),
  },
  [861] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(2248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2248),
  },
  [862] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [863] = {
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [864] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1361),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [865] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1363),
    [anon_sym_RBRACE] = ACTIONS(2779),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [866] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1364),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [867] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP_GT] = ACTIONS(2258),
    [anon_sym_AMP_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_AMP] = ACTIONS(1422),
    [anon_sym_GT_AMP] = ACTIONS(1422),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_LT_LT_DASH] = ACTIONS(1422),
    [anon_sym_LT_LT_LT] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2258),
  },
  [868] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [869] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_AMP_GT] = ACTIONS(2262),
    [anon_sym_AMP_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_AMP] = ACTIONS(1428),
    [anon_sym_GT_AMP] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_LT_LT_DASH] = ACTIONS(1428),
    [anon_sym_LT_LT_LT] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2262),
  },
  [870] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [871] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_LT_LT_LT] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2264),
  },
  [872] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(2266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_LT_LT_DASH] = ACTIONS(1682),
    [anon_sym_LT_LT_LT] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2266),
  },
  [873] = {
    [sym_compound_statement] = STATE(1366),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [sym_comment] = ACTIONS(48),
  },
  [874] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(2573),
    [anon_sym_PIPE_AMP] = ACTIONS(2575),
    [anon_sym_AMP_AMP] = ACTIONS(2575),
    [anon_sym_PIPE_PIPE] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(2575),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [875] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_BQUOTE] = ACTIONS(2577),
    [sym_comment] = ACTIONS(48),
  },
  [876] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(2577),
    [anon_sym_PIPE_PIPE] = ACTIONS(2577),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [877] = {
    [sym_concatenation] = STATE(1292),
    [sym_string] = STATE(1368),
    [sym_simple_expansion] = STATE(1368),
    [sym_expansion] = STATE(1368),
    [sym_command_substitution] = STATE(1368),
    [sym_process_substitution] = STATE(1368),
    [sym__special_characters] = ACTIONS(2783),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [sym_raw_string] = ACTIONS(2785),
    [anon_sym_DOLLAR] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1668),
    [anon_sym_BQUOTE] = ACTIONS(1670),
    [anon_sym_LT_LPAREN] = ACTIONS(1672),
    [anon_sym_GT_LPAREN] = ACTIONS(1672),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2787),
  },
  [878] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym_file_descriptor] = ACTIONS(506),
    [sym__concat] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PIPE_AMP] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_LT] = ACTIONS(510),
    [anon_sym_GT] = ACTIONS(510),
    [anon_sym_GT_GT] = ACTIONS(506),
    [anon_sym_AMP_GT] = ACTIONS(510),
    [anon_sym_AMP_GT_GT] = ACTIONS(506),
    [anon_sym_LT_AMP] = ACTIONS(506),
    [anon_sym_GT_AMP] = ACTIONS(506),
    [anon_sym_LT_LT] = ACTIONS(510),
    [anon_sym_LT_LT_DASH] = ACTIONS(506),
    [anon_sym_LT_LT_LT] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [sym_comment] = ACTIONS(48),
  },
  [879] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1372),
    [anon_sym_DQUOTE] = ACTIONS(2791),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [880] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym_file_descriptor] = ACTIONS(514),
    [sym__concat] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_PIPE_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(514),
    [anon_sym_PIPE_PIPE] = ACTIONS(514),
    [anon_sym_LT] = ACTIONS(516),
    [anon_sym_GT] = ACTIONS(516),
    [anon_sym_GT_GT] = ACTIONS(514),
    [anon_sym_AMP_GT] = ACTIONS(516),
    [anon_sym_AMP_GT_GT] = ACTIONS(514),
    [anon_sym_LT_AMP] = ACTIONS(514),
    [anon_sym_GT_AMP] = ACTIONS(514),
    [anon_sym_LT_LT] = ACTIONS(516),
    [anon_sym_LT_LT_DASH] = ACTIONS(514),
    [anon_sym_LT_LT_LT] = ACTIONS(514),
    [anon_sym_BQUOTE] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
  },
  [881] = {
    [sym_string] = STATE(1375),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [anon_sym_DOLLAR] = ACTIONS(2793),
    [anon_sym_POUND] = ACTIONS(2793),
    [anon_sym_DASH] = ACTIONS(2793),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2795),
    [anon_sym_STAR] = ACTIONS(2793),
    [anon_sym_AT] = ACTIONS(2793),
    [anon_sym_QMARK] = ACTIONS(2793),
    [anon_sym_0] = ACTIONS(2797),
    [anon_sym__] = ACTIONS(2797),
  },
  [882] = {
    [sym_subscript] = STATE(1380),
    [sym_variable_name] = ACTIONS(2799),
    [anon_sym_DOLLAR] = ACTIONS(2801),
    [anon_sym_POUND] = ACTIONS(2803),
    [anon_sym_DASH] = ACTIONS(2801),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2805),
    [anon_sym_STAR] = ACTIONS(2801),
    [anon_sym_AT] = ACTIONS(2801),
    [anon_sym_QMARK] = ACTIONS(2801),
    [anon_sym_0] = ACTIONS(2807),
    [anon_sym__] = ACTIONS(2807),
  },
  [883] = {
    [sym_for_statement] = STATE(1381),
    [sym_while_statement] = STATE(1381),
    [sym_if_statement] = STATE(1381),
    [sym_case_statement] = STATE(1381),
    [sym_function_definition] = STATE(1381),
    [sym_subshell] = STATE(1381),
    [sym_pipeline] = STATE(1381),
    [sym_list] = STATE(1381),
    [sym_command] = STATE(1381),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1382),
    [sym_declaration_command] = STATE(1381),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [884] = {
    [sym_for_statement] = STATE(1383),
    [sym_while_statement] = STATE(1383),
    [sym_if_statement] = STATE(1383),
    [sym_case_statement] = STATE(1383),
    [sym_function_definition] = STATE(1383),
    [sym_subshell] = STATE(1383),
    [sym_pipeline] = STATE(1383),
    [sym_list] = STATE(1383),
    [sym_command] = STATE(1383),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1384),
    [sym_declaration_command] = STATE(1383),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [885] = {
    [sym_for_statement] = STATE(1385),
    [sym_while_statement] = STATE(1385),
    [sym_if_statement] = STATE(1385),
    [sym_case_statement] = STATE(1385),
    [sym_function_definition] = STATE(1385),
    [sym_subshell] = STATE(1385),
    [sym_pipeline] = STATE(1385),
    [sym_list] = STATE(1385),
    [sym_command] = STATE(1385),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1386),
    [sym_declaration_command] = STATE(1385),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [886] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym_file_descriptor] = ACTIONS(1736),
    [sym__concat] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2611),
    [anon_sym_PIPE_AMP] = ACTIONS(1736),
    [anon_sym_AMP_AMP] = ACTIONS(1736),
    [anon_sym_PIPE_PIPE] = ACTIONS(1736),
    [anon_sym_LT] = ACTIONS(2611),
    [anon_sym_GT] = ACTIONS(2611),
    [anon_sym_GT_GT] = ACTIONS(1736),
    [anon_sym_AMP_GT] = ACTIONS(2611),
    [anon_sym_AMP_GT_GT] = ACTIONS(1736),
    [anon_sym_LT_AMP] = ACTIONS(1736),
    [anon_sym_GT_AMP] = ACTIONS(1736),
    [anon_sym_LT_LT] = ACTIONS(2611),
    [anon_sym_LT_LT_DASH] = ACTIONS(1736),
    [anon_sym_LT_LT_LT] = ACTIONS(1736),
    [anon_sym_BQUOTE] = ACTIONS(1736),
    [sym_comment] = ACTIONS(48),
  },
  [887] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym_file_descriptor] = ACTIONS(1740),
    [sym__concat] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(2613),
    [anon_sym_PIPE_AMP] = ACTIONS(1740),
    [anon_sym_AMP_AMP] = ACTIONS(1740),
    [anon_sym_PIPE_PIPE] = ACTIONS(1740),
    [anon_sym_LT] = ACTIONS(2613),
    [anon_sym_GT] = ACTIONS(2613),
    [anon_sym_GT_GT] = ACTIONS(1740),
    [anon_sym_AMP_GT] = ACTIONS(2613),
    [anon_sym_AMP_GT_GT] = ACTIONS(1740),
    [anon_sym_LT_AMP] = ACTIONS(1740),
    [anon_sym_GT_AMP] = ACTIONS(1740),
    [anon_sym_LT_LT] = ACTIONS(2613),
    [anon_sym_LT_LT_DASH] = ACTIONS(1740),
    [anon_sym_LT_LT_LT] = ACTIONS(1740),
    [anon_sym_BQUOTE] = ACTIONS(1740),
    [sym_comment] = ACTIONS(48),
  },
  [888] = {
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(445),
    [sym_simple_expansion] = STATE(445),
    [sym_expansion] = STATE(445),
    [sym_command_substitution] = STATE(445),
    [sym_process_substitution] = STATE(445),
    [aux_sym_for_statement_repeat1] = STATE(888),
    [sym_file_descriptor] = ACTIONS(1744),
    [anon_sym_PIPE] = ACTIONS(2615),
    [anon_sym_PIPE_AMP] = ACTIONS(1744),
    [anon_sym_AMP_AMP] = ACTIONS(1744),
    [anon_sym_PIPE_PIPE] = ACTIONS(1744),
    [anon_sym_LT] = ACTIONS(2615),
    [anon_sym_GT] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(1744),
    [anon_sym_AMP_GT] = ACTIONS(2615),
    [anon_sym_AMP_GT_GT] = ACTIONS(1744),
    [anon_sym_LT_AMP] = ACTIONS(1744),
    [anon_sym_GT_AMP] = ACTIONS(1744),
    [anon_sym_LT_LT] = ACTIONS(2615),
    [anon_sym_LT_LT_DASH] = ACTIONS(1744),
    [anon_sym_LT_LT_LT] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(2809),
    [anon_sym_DQUOTE] = ACTIONS(2812),
    [sym_raw_string] = ACTIONS(2815),
    [anon_sym_DOLLAR] = ACTIONS(2818),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2821),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2824),
    [anon_sym_BQUOTE] = ACTIONS(2827),
    [anon_sym_LT_LPAREN] = ACTIONS(2830),
    [anon_sym_GT_LPAREN] = ACTIONS(2830),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2833),
  },
  [889] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(890),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [sym_comment] = ACTIONS(48),
  },
  [890] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(890),
    [sym_file_descriptor] = ACTIONS(2836),
    [anon_sym_PIPE] = ACTIONS(2651),
    [anon_sym_PIPE_AMP] = ACTIONS(2653),
    [anon_sym_AMP_AMP] = ACTIONS(2653),
    [anon_sym_PIPE_PIPE] = ACTIONS(2653),
    [anon_sym_LT] = ACTIONS(2839),
    [anon_sym_GT] = ACTIONS(2839),
    [anon_sym_GT_GT] = ACTIONS(2842),
    [anon_sym_AMP_GT] = ACTIONS(2839),
    [anon_sym_AMP_GT_GT] = ACTIONS(2842),
    [anon_sym_LT_AMP] = ACTIONS(2842),
    [anon_sym_GT_AMP] = ACTIONS(2842),
    [anon_sym_LT_LT] = ACTIONS(2661),
    [anon_sym_LT_LT_DASH] = ACTIONS(2664),
    [anon_sym_LT_LT_LT] = ACTIONS(2845),
    [anon_sym_BQUOTE] = ACTIONS(2653),
    [sym_comment] = ACTIONS(48),
  },
  [891] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [sym_concatenation] = STATE(402),
    [sym_string] = STATE(445),
    [sym_simple_expansion] = STATE(445),
    [sym_expansion] = STATE(445),
    [sym_command_substitution] = STATE(445),
    [sym_process_substitution] = STATE(445),
    [aux_sym_for_statement_repeat1] = STATE(888),
    [aux_sym_while_statement_repeat1] = STATE(1387),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(2644),
    [anon_sym_PIPE_AMP] = ACTIONS(2646),
    [anon_sym_AMP_AMP] = ACTIONS(2646),
    [anon_sym_PIPE_PIPE] = ACTIONS(2646),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [sym__special_characters] = ACTIONS(778),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(780),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(2646),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(782),
  },
  [892] = {
    [sym_file_redirect] = STATE(1388),
    [sym_file_descriptor] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(2029),
    [anon_sym_SEMI_SEMI] = ACTIONS(2029),
    [anon_sym_PIPE_AMP] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(1078),
    [anon_sym_GT] = ACTIONS(1078),
    [anon_sym_GT_GT] = ACTIONS(1078),
    [anon_sym_AMP_GT] = ACTIONS(1078),
    [anon_sym_AMP_GT_GT] = ACTIONS(1078),
    [anon_sym_LT_AMP] = ACTIONS(1078),
    [anon_sym_GT_AMP] = ACTIONS(1078),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_LF] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2029),
  },
  [893] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(922),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(2848),
    [anon_sym_SEMI_SEMI] = ACTIONS(2848),
    [anon_sym_PIPE_AMP] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_PIPE_PIPE] = ACTIONS(2848),
    [anon_sym_LT] = ACTIONS(2848),
    [anon_sym_GT] = ACTIONS(2848),
    [anon_sym_GT_GT] = ACTIONS(2848),
    [anon_sym_AMP_GT] = ACTIONS(2848),
    [anon_sym_AMP_GT_GT] = ACTIONS(2848),
    [anon_sym_LT_AMP] = ACTIONS(2848),
    [anon_sym_GT_AMP] = ACTIONS(2848),
    [anon_sym_LT_LT] = ACTIONS(2848),
    [anon_sym_LT_LT_DASH] = ACTIONS(2848),
    [anon_sym_LT_LT_LT] = ACTIONS(2848),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_LF] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2848),
  },
  [894] = {
    [aux_sym_concatenation_repeat1] = STATE(897),
    [sym_file_descriptor] = ACTIONS(926),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_SEMI_SEMI] = ACTIONS(2850),
    [anon_sym_PIPE_AMP] = ACTIONS(2850),
    [anon_sym_AMP_AMP] = ACTIONS(2850),
    [anon_sym_PIPE_PIPE] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_GT] = ACTIONS(2850),
    [anon_sym_GT_GT] = ACTIONS(2850),
    [anon_sym_AMP_GT] = ACTIONS(2850),
    [anon_sym_AMP_GT_GT] = ACTIONS(2850),
    [anon_sym_LT_AMP] = ACTIONS(2850),
    [anon_sym_GT_AMP] = ACTIONS(2850),
    [anon_sym_LT_LT] = ACTIONS(2850),
    [anon_sym_LT_LT_DASH] = ACTIONS(2850),
    [anon_sym_LT_LT_LT] = ACTIONS(2850),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LF] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
  },
  [895] = {
    [sym_file_descriptor] = ACTIONS(926),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_RPAREN] = ACTIONS(2850),
    [anon_sym_SEMI_SEMI] = ACTIONS(2850),
    [anon_sym_PIPE_AMP] = ACTIONS(2850),
    [anon_sym_AMP_AMP] = ACTIONS(2850),
    [anon_sym_PIPE_PIPE] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_GT] = ACTIONS(2850),
    [anon_sym_GT_GT] = ACTIONS(2850),
    [anon_sym_AMP_GT] = ACTIONS(2850),
    [anon_sym_AMP_GT_GT] = ACTIONS(2850),
    [anon_sym_LT_AMP] = ACTIONS(2850),
    [anon_sym_GT_AMP] = ACTIONS(2850),
    [anon_sym_LT_LT] = ACTIONS(2850),
    [anon_sym_LT_LT_DASH] = ACTIONS(2850),
    [anon_sym_LT_LT_LT] = ACTIONS(2850),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LF] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
  },
  [896] = {
    [sym_string] = STATE(1389),
    [sym_simple_expansion] = STATE(1389),
    [sym_expansion] = STATE(1389),
    [sym_command_substitution] = STATE(1389),
    [sym_process_substitution] = STATE(1389),
    [sym__special_characters] = ACTIONS(2852),
    [anon_sym_DQUOTE] = ACTIONS(802),
    [sym_raw_string] = ACTIONS(2854),
    [anon_sym_DOLLAR] = ACTIONS(806),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(808),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(810),
    [anon_sym_BQUOTE] = ACTIONS(812),
    [anon_sym_LT_LPAREN] = ACTIONS(814),
    [anon_sym_GT_LPAREN] = ACTIONS(814),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2852),
  },
  [897] = {
    [aux_sym_concatenation_repeat1] = STATE(1390),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(1696),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_AMP_GT] = ACTIONS(540),
    [anon_sym_AMP_GT_GT] = ACTIONS(540),
    [anon_sym_LT_AMP] = ACTIONS(540),
    [anon_sym_GT_AMP] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_LT_LT_DASH] = ACTIONS(540),
    [anon_sym_LT_LT_LT] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [898] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [anon_sym_LT_LT_LT] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [899] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(2856),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [900] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_LT_LT] = ACTIONS(574),
    [anon_sym_LT_LT_DASH] = ACTIONS(574),
    [anon_sym_LT_LT_LT] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [901] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_GT] = ACTIONS(578),
    [anon_sym_AMP_GT_GT] = ACTIONS(578),
    [anon_sym_LT_AMP] = ACTIONS(578),
    [anon_sym_GT_AMP] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_LT_LT_DASH] = ACTIONS(578),
    [anon_sym_LT_LT_LT] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [902] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT_LT_DASH] = ACTIONS(582),
    [anon_sym_LT_LT_LT] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [903] = {
    [anon_sym_EQ] = ACTIONS(2858),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [904] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1394),
    [anon_sym_RBRACE] = ACTIONS(2860),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [905] = {
    [sym_subscript] = STATE(1398),
    [sym_variable_name] = ACTIONS(2862),
    [anon_sym_DOLLAR] = ACTIONS(2864),
    [anon_sym_DASH] = ACTIONS(2864),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2866),
    [anon_sym_STAR] = ACTIONS(2864),
    [anon_sym_AT] = ACTIONS(2864),
    [anon_sym_QMARK] = ACTIONS(2864),
    [anon_sym_0] = ACTIONS(2868),
    [anon_sym__] = ACTIONS(2868),
  },
  [906] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1400),
    [anon_sym_RBRACE] = ACTIONS(2870),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [907] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1402),
    [anon_sym_RBRACE] = ACTIONS(2872),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [908] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2874),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [909] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2874),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [910] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(2874),
    [sym_comment] = ACTIONS(48),
  },
  [911] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(2874),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [912] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [913] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2876),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [914] = {
    [sym__heredoc_middle] = ACTIONS(2878),
    [sym__heredoc_end] = ACTIONS(2878),
    [anon_sym_DOLLAR] = ACTIONS(2880),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2878),
    [sym_comment] = ACTIONS(48),
  },
  [915] = {
    [sym_file_descriptor] = ACTIONS(2882),
    [anon_sym_PIPE] = ACTIONS(2884),
    [anon_sym_RPAREN] = ACTIONS(2884),
    [anon_sym_SEMI_SEMI] = ACTIONS(2884),
    [anon_sym_PIPE_AMP] = ACTIONS(2884),
    [anon_sym_AMP_AMP] = ACTIONS(2884),
    [anon_sym_PIPE_PIPE] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2884),
    [anon_sym_GT] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(2884),
    [anon_sym_AMP_GT] = ACTIONS(2884),
    [anon_sym_AMP_GT_GT] = ACTIONS(2884),
    [anon_sym_LT_AMP] = ACTIONS(2884),
    [anon_sym_GT_AMP] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_LT_LT_DASH] = ACTIONS(2884),
    [anon_sym_LT_LT_LT] = ACTIONS(2884),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2884),
    [anon_sym_LF] = ACTIONS(2884),
    [anon_sym_AMP] = ACTIONS(2884),
  },
  [916] = {
    [sym_string] = STATE(1408),
    [anon_sym_DQUOTE] = ACTIONS(2886),
    [anon_sym_DOLLAR] = ACTIONS(2888),
    [anon_sym_POUND] = ACTIONS(2888),
    [anon_sym_DASH] = ACTIONS(2888),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2890),
    [anon_sym_STAR] = ACTIONS(2888),
    [anon_sym_AT] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2888),
    [anon_sym_0] = ACTIONS(2892),
    [anon_sym__] = ACTIONS(2892),
  },
  [917] = {
    [sym_subscript] = STATE(1413),
    [sym_variable_name] = ACTIONS(2894),
    [anon_sym_DOLLAR] = ACTIONS(2896),
    [anon_sym_POUND] = ACTIONS(2898),
    [anon_sym_DASH] = ACTIONS(2896),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2900),
    [anon_sym_STAR] = ACTIONS(2896),
    [anon_sym_AT] = ACTIONS(2896),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_0] = ACTIONS(2902),
    [anon_sym__] = ACTIONS(2902),
  },
  [918] = {
    [sym_simple_expansion] = STATE(914),
    [sym_expansion] = STATE(914),
    [aux_sym_heredoc_repeat1] = STATE(1415),
    [sym__heredoc_middle] = ACTIONS(1724),
    [sym__heredoc_end] = ACTIONS(2904),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1730),
    [sym_comment] = ACTIONS(48),
  },
  [919] = {
    [aux_sym_concatenation_repeat1] = STATE(292),
    [sym_file_descriptor] = ACTIONS(954),
    [sym__concat] = ACTIONS(508),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_LT] = ACTIONS(2419),
    [anon_sym_GT] = ACTIONS(2419),
    [anon_sym_GT_GT] = ACTIONS(954),
    [anon_sym_AMP_GT] = ACTIONS(2419),
    [anon_sym_AMP_GT_GT] = ACTIONS(954),
    [anon_sym_LT_AMP] = ACTIONS(954),
    [anon_sym_GT_AMP] = ACTIONS(954),
    [sym__special_characters] = ACTIONS(2419),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_raw_string] = ACTIONS(954),
    [anon_sym_DOLLAR] = ACTIONS(2419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(954),
    [anon_sym_BQUOTE] = ACTIONS(954),
    [anon_sym_LT_LPAREN] = ACTIONS(954),
    [anon_sym_GT_LPAREN] = ACTIONS(954),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2419),
  },
  [920] = {
    [aux_sym_concatenation_repeat1] = STATE(292),
    [sym_file_descriptor] = ACTIONS(930),
    [sym__concat] = ACTIONS(508),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_LT] = ACTIONS(2413),
    [anon_sym_GT] = ACTIONS(2413),
    [anon_sym_GT_GT] = ACTIONS(930),
    [anon_sym_AMP_GT] = ACTIONS(2413),
    [anon_sym_AMP_GT_GT] = ACTIONS(930),
    [anon_sym_LT_AMP] = ACTIONS(930),
    [anon_sym_GT_AMP] = ACTIONS(930),
    [sym__special_characters] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [sym_raw_string] = ACTIONS(930),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(930),
    [anon_sym_BQUOTE] = ACTIONS(930),
    [anon_sym_LT_LPAREN] = ACTIONS(930),
    [anon_sym_GT_LPAREN] = ACTIONS(930),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2413),
  },
  [921] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(473),
    [sym_file_descriptor] = ACTIONS(264),
    [anon_sym_PIPE] = ACTIONS(2906),
    [anon_sym_SEMI_SEMI] = ACTIONS(2906),
    [anon_sym_PIPE_AMP] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(268),
    [anon_sym_GT] = ACTIONS(268),
    [anon_sym_GT_GT] = ACTIONS(268),
    [anon_sym_AMP_GT] = ACTIONS(268),
    [anon_sym_AMP_GT_GT] = ACTIONS(268),
    [anon_sym_LT_AMP] = ACTIONS(268),
    [anon_sym_GT_AMP] = ACTIONS(268),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(272),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_LF] = ACTIONS(2906),
    [anon_sym_AMP] = ACTIONS(2906),
  },
  [922] = {
    [sym_string] = STATE(1416),
    [sym_simple_expansion] = STATE(1416),
    [sym_expansion] = STATE(1416),
    [sym_command_substitution] = STATE(1416),
    [sym_process_substitution] = STATE(1416),
    [sym__special_characters] = ACTIONS(2908),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(2910),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2908),
  },
  [923] = {
    [aux_sym_concatenation_repeat1] = STATE(1417),
    [sym__concat] = ACTIONS(1798),
    [anon_sym_RPAREN] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1270),
  },
  [924] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_RPAREN] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1272),
  },
  [925] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(2912),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [926] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_RPAREN] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1276),
  },
  [927] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1278),
  },
  [928] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1280),
  },
  [929] = {
    [anon_sym_EQ] = ACTIONS(2914),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [930] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1421),
    [anon_sym_RBRACE] = ACTIONS(2916),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [931] = {
    [sym_subscript] = STATE(1425),
    [sym_variable_name] = ACTIONS(2918),
    [anon_sym_DOLLAR] = ACTIONS(2920),
    [anon_sym_DASH] = ACTIONS(2920),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2920),
    [anon_sym_AT] = ACTIONS(2920),
    [anon_sym_QMARK] = ACTIONS(2920),
    [anon_sym_0] = ACTIONS(2924),
    [anon_sym__] = ACTIONS(2924),
  },
  [932] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1427),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [933] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1429),
    [anon_sym_RBRACE] = ACTIONS(2928),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [934] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [935] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2930),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [936] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [sym_comment] = ACTIONS(48),
  },
  [937] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(2930),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [938] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [939] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(2932),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [940] = {
    [sym_file_descriptor] = ACTIONS(2934),
    [sym_variable_name] = ACTIONS(2934),
    [anon_sym_PIPE] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_SEMI_SEMI] = ACTIONS(2936),
    [anon_sym_PIPE_AMP] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_GT] = ACTIONS(2936),
    [anon_sym_GT_GT] = ACTIONS(2936),
    [anon_sym_AMP_GT] = ACTIONS(2936),
    [anon_sym_AMP_GT_GT] = ACTIONS(2936),
    [anon_sym_LT_AMP] = ACTIONS(2936),
    [anon_sym_GT_AMP] = ACTIONS(2936),
    [sym__special_characters] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [sym_raw_string] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2936),
    [anon_sym_BQUOTE] = ACTIONS(2936),
    [anon_sym_LT_LPAREN] = ACTIONS(2936),
    [anon_sym_GT_LPAREN] = ACTIONS(2936),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_LF] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2936),
  },
  [941] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(941),
    [anon_sym_RPAREN] = ACTIONS(1744),
    [sym__special_characters] = ACTIONS(2938),
    [anon_sym_DQUOTE] = ACTIONS(2941),
    [sym_raw_string] = ACTIONS(2944),
    [anon_sym_DOLLAR] = ACTIONS(2947),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2950),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2953),
    [anon_sym_BQUOTE] = ACTIONS(2956),
    [anon_sym_LT_LPAREN] = ACTIONS(2959),
    [anon_sym_GT_LPAREN] = ACTIONS(2959),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2962),
  },
  [942] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [943] = {
    [aux_sym_concatenation_repeat1] = STATE(943),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(2965),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [944] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_raw_string] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [945] = {
    [sym_concatenation] = STATE(1435),
    [sym_string] = STATE(1434),
    [sym_simple_expansion] = STATE(1434),
    [sym_expansion] = STATE(1434),
    [sym_command_substitution] = STATE(1434),
    [sym_process_substitution] = STATE(1434),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [sym__special_characters] = ACTIONS(2970),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(2972),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2974),
  },
  [946] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [947] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2976),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [948] = {
    [anon_sym_EQ] = ACTIONS(2978),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [949] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1439),
    [anon_sym_RBRACE] = ACTIONS(2980),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [950] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1441),
    [anon_sym_RBRACE] = ACTIONS(2982),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [951] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1442),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [952] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT_GT] = ACTIONS(1424),
    [anon_sym_LT_AMP] = ACTIONS(1424),
    [anon_sym_GT_AMP] = ACTIONS(1424),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LPAREN] = ACTIONS(1424),
    [anon_sym_GT_LPAREN] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [953] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2984),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [954] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_AMP] = ACTIONS(1430),
    [anon_sym_GT_AMP] = ACTIONS(1430),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym_raw_string] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LPAREN] = ACTIONS(1430),
    [anon_sym_GT_LPAREN] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [955] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2968),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [956] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [957] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT_GT] = ACTIONS(1684),
    [anon_sym_LT_AMP] = ACTIONS(1684),
    [anon_sym_GT_AMP] = ACTIONS(1684),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LT_LPAREN] = ACTIONS(1684),
    [anon_sym_GT_LPAREN] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [958] = {
    [sym__concat] = ACTIONS(2986),
    [anon_sym_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [sym_comment] = ACTIONS(48),
  },
  [959] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_RBRACK] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [960] = {
    [anon_sym_EQ] = ACTIONS(2988),
    [anon_sym_PLUS_EQ] = ACTIONS(2988),
    [sym_comment] = ACTIONS(48),
  },
  [961] = {
    [sym_string] = STATE(959),
    [sym_simple_expansion] = STATE(959),
    [sym_expansion] = STATE(959),
    [sym_command_substitution] = STATE(959),
    [sym_process_substitution] = STATE(959),
    [sym__special_characters] = ACTIONS(1852),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(340),
    [anon_sym_BQUOTE] = ACTIONS(342),
    [anon_sym_LT_LPAREN] = ACTIONS(344),
    [anon_sym_GT_LPAREN] = ACTIONS(344),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1852),
  },
  [962] = {
    [aux_sym_concatenation_repeat1] = STATE(962),
    [sym__concat] = ACTIONS(2990),
    [anon_sym_RBRACK] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [963] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_RBRACK] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [964] = {
    [sym__concat] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_PLUS_EQ] = ACTIONS(2995),
    [sym_comment] = ACTIONS(48),
  },
  [965] = {
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_PLUS_EQ] = ACTIONS(2995),
    [sym_comment] = ACTIONS(48),
  },
  [966] = {
    [sym_concatenation] = STATE(1449),
    [sym_string] = STATE(1448),
    [sym_simple_expansion] = STATE(1448),
    [sym_expansion] = STATE(1448),
    [sym_command_substitution] = STATE(1448),
    [sym_process_substitution] = STATE(1448),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [sym__special_characters] = ACTIONS(2999),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3001),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3003),
  },
  [967] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_RBRACK] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [968] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [969] = {
    [anon_sym_EQ] = ACTIONS(3007),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [970] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1453),
    [anon_sym_RBRACE] = ACTIONS(3009),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [971] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1455),
    [anon_sym_RBRACE] = ACTIONS(3011),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [972] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1456),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [973] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_RBRACK] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [974] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3013),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [975] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_RBRACK] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [976] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(2997),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [977] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_RBRACK] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
  },
  [978] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_RBRACK] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
  },
  [979] = {
    [sym_string] = STATE(1458),
    [sym_simple_expansion] = STATE(1458),
    [sym_expansion] = STATE(1458),
    [sym_command_substitution] = STATE(1458),
    [sym_process_substitution] = STATE(1458),
    [sym__special_characters] = ACTIONS(3015),
    [anon_sym_DQUOTE] = ACTIONS(1008),
    [sym_raw_string] = ACTIONS(3017),
    [anon_sym_DOLLAR] = ACTIONS(1012),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1014),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1016),
    [anon_sym_BQUOTE] = ACTIONS(1018),
    [anon_sym_LT_LPAREN] = ACTIONS(1020),
    [anon_sym_GT_LPAREN] = ACTIONS(1020),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3015),
  },
  [980] = {
    [aux_sym_concatenation_repeat1] = STATE(1459),
    [sym__concat] = ACTIONS(1888),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [sym_raw_string] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(540),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(540),
    [anon_sym_GT_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [981] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [982] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3019),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [983] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [984] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [anon_sym_LT_LPAREN] = ACTIONS(578),
    [anon_sym_GT_LPAREN] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [985] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [986] = {
    [anon_sym_EQ] = ACTIONS(3021),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [987] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1463),
    [anon_sym_RBRACE] = ACTIONS(3023),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [988] = {
    [sym_subscript] = STATE(1467),
    [sym_variable_name] = ACTIONS(3025),
    [anon_sym_DOLLAR] = ACTIONS(3027),
    [anon_sym_DASH] = ACTIONS(3027),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3029),
    [anon_sym_STAR] = ACTIONS(3027),
    [anon_sym_AT] = ACTIONS(3027),
    [anon_sym_QMARK] = ACTIONS(3027),
    [anon_sym_0] = ACTIONS(3031),
    [anon_sym__] = ACTIONS(3031),
  },
  [989] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1469),
    [anon_sym_RBRACE] = ACTIONS(3033),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [990] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1471),
    [anon_sym_RBRACE] = ACTIONS(3035),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [991] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3037),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [992] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3037),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [993] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3037),
    [sym_comment] = ACTIONS(48),
  },
  [994] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3037),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [995] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [996] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3039),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [997] = {
    [sym_do_group] = STATE(1475),
    [anon_sym_do] = ACTIONS(3041),
    [sym_comment] = ACTIONS(48),
  },
  [998] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(529),
    [sym_simple_expansion] = STATE(529),
    [sym_expansion] = STATE(529),
    [sym_command_substitution] = STATE(529),
    [sym_process_substitution] = STATE(529),
    [aux_sym_for_statement_repeat1] = STATE(998),
    [anon_sym_SEMI_SEMI] = ACTIONS(1746),
    [sym__special_characters] = ACTIONS(3043),
    [anon_sym_DQUOTE] = ACTIONS(3046),
    [sym_raw_string] = ACTIONS(3049),
    [anon_sym_DOLLAR] = ACTIONS(3052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3055),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3058),
    [anon_sym_BQUOTE] = ACTIONS(3061),
    [anon_sym_LT_LPAREN] = ACTIONS(3064),
    [anon_sym_GT_LPAREN] = ACTIONS(3064),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3049),
    [anon_sym_SEMI] = ACTIONS(1746),
    [anon_sym_LF] = ACTIONS(1746),
    [anon_sym_AMP] = ACTIONS(1746),
  },
  [999] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_done] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [1000] = {
    [sym_file_descriptor] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_RPAREN] = ACTIONS(3069),
    [anon_sym_SEMI_SEMI] = ACTIONS(3069),
    [anon_sym_PIPE_AMP] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [anon_sym_LT] = ACTIONS(3069),
    [anon_sym_GT] = ACTIONS(3069),
    [anon_sym_GT_GT] = ACTIONS(3069),
    [anon_sym_AMP_GT] = ACTIONS(3069),
    [anon_sym_AMP_GT_GT] = ACTIONS(3069),
    [anon_sym_LT_AMP] = ACTIONS(3069),
    [anon_sym_GT_AMP] = ACTIONS(3069),
    [anon_sym_LT_LT] = ACTIONS(3069),
    [anon_sym_LT_LT_DASH] = ACTIONS(3069),
    [anon_sym_LT_LT_LT] = ACTIONS(3069),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_LF] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
  },
  [1001] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1001),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_done] = ACTIONS(3071),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [1002] = {
    [anon_sym_then] = ACTIONS(3073),
    [sym_comment] = ACTIONS(48),
  },
  [1003] = {
    [sym_file_descriptor] = ACTIONS(252),
    [sym_variable_name] = ACTIONS(252),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_fi] = ACTIONS(254),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_declare] = ACTIONS(254),
    [anon_sym_typeset] = ACTIONS(254),
    [anon_sym_export] = ACTIONS(254),
    [anon_sym_readonly] = ACTIONS(254),
    [anon_sym_local] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [anon_sym_AMP_GT] = ACTIONS(254),
    [anon_sym_AMP_GT_GT] = ACTIONS(252),
    [anon_sym_LT_AMP] = ACTIONS(252),
    [anon_sym_GT_AMP] = ACTIONS(252),
    [sym__special_characters] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(252),
    [anon_sym_BQUOTE] = ACTIONS(252),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(256),
  },
  [1004] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(3075),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LF] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3075),
  },
  [1005] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(3075),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_LF] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3075),
  },
  [1006] = {
    [sym__terminated_statement] = STATE(1003),
    [sym_for_statement] = STATE(1004),
    [sym_while_statement] = STATE(1004),
    [sym_if_statement] = STATE(1004),
    [sym_case_statement] = STATE(1004),
    [sym_function_definition] = STATE(1004),
    [sym_subshell] = STATE(1004),
    [sym_pipeline] = STATE(1004),
    [sym_list] = STATE(1004),
    [sym_command] = STATE(1004),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1005),
    [sym_declaration_command] = STATE(1004),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1478),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(3077),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1007] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_fi] = ACTIONS(792),
    [anon_sym_elif] = ACTIONS(792),
    [anon_sym_else] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [1008] = {
    [anon_sym_PIPE] = ACTIONS(3079),
    [anon_sym_RPAREN] = ACTIONS(3079),
    [anon_sym_SEMI_SEMI] = ACTIONS(3079),
    [anon_sym_PIPE_AMP] = ACTIONS(3079),
    [anon_sym_AMP_AMP] = ACTIONS(3079),
    [anon_sym_PIPE_PIPE] = ACTIONS(3079),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3079),
    [anon_sym_LF] = ACTIONS(3079),
    [anon_sym_AMP] = ACTIONS(3079),
  },
  [1009] = {
    [anon_sym_fi] = ACTIONS(3081),
    [sym_comment] = ACTIONS(48),
  },
  [1010] = {
    [sym__terminated_statement] = STATE(546),
    [sym_for_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_case_statement] = STATE(547),
    [sym_function_definition] = STATE(547),
    [sym_subshell] = STATE(547),
    [sym_pipeline] = STATE(547),
    [sym_list] = STATE(547),
    [sym_command] = STATE(547),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(550),
    [sym_declaration_command] = STATE(547),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1010),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_fi] = ACTIONS(3071),
    [anon_sym_elif] = ACTIONS(3071),
    [anon_sym_else] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [1011] = {
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(1480),
    [aux_sym_if_statement_repeat1] = STATE(1012),
    [anon_sym_fi] = ACTIONS(3081),
    [anon_sym_elif] = ACTIONS(1948),
    [anon_sym_else] = ACTIONS(1950),
    [sym_comment] = ACTIONS(48),
  },
  [1012] = {
    [sym_elif_clause] = STATE(548),
    [aux_sym_if_statement_repeat1] = STATE(1012),
    [anon_sym_fi] = ACTIONS(3083),
    [anon_sym_elif] = ACTIONS(3085),
    [anon_sym_else] = ACTIONS(3083),
    [sym_comment] = ACTIONS(48),
  },
  [1013] = {
    [anon_sym_PIPE] = ACTIONS(3088),
    [anon_sym_RPAREN] = ACTIONS(3088),
    [anon_sym_SEMI_SEMI] = ACTIONS(3088),
    [anon_sym_PIPE_AMP] = ACTIONS(3088),
    [anon_sym_AMP_AMP] = ACTIONS(3088),
    [anon_sym_PIPE_PIPE] = ACTIONS(3088),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3088),
    [anon_sym_LF] = ACTIONS(3088),
    [anon_sym_AMP] = ACTIONS(3088),
  },
  [1014] = {
    [aux_sym_case_item_repeat1] = STATE(1484),
    [aux_sym_concatenation_repeat1] = STATE(1485),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3094),
    [sym_comment] = ACTIONS(48),
  },
  [1015] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1487),
    [anon_sym_DQUOTE] = ACTIONS(3096),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1016] = {
    [aux_sym_case_item_repeat1] = STATE(1489),
    [aux_sym_concatenation_repeat1] = STATE(1485),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3098),
    [sym_comment] = ACTIONS(48),
  },
  [1017] = {
    [sym_string] = STATE(1492),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [anon_sym_DOLLAR] = ACTIONS(3100),
    [anon_sym_POUND] = ACTIONS(3100),
    [anon_sym_DASH] = ACTIONS(3100),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3102),
    [anon_sym_STAR] = ACTIONS(3100),
    [anon_sym_AT] = ACTIONS(3100),
    [anon_sym_QMARK] = ACTIONS(3100),
    [anon_sym_0] = ACTIONS(3104),
    [anon_sym__] = ACTIONS(3104),
  },
  [1018] = {
    [sym_subscript] = STATE(1497),
    [sym_variable_name] = ACTIONS(3106),
    [anon_sym_DOLLAR] = ACTIONS(3108),
    [anon_sym_POUND] = ACTIONS(3110),
    [anon_sym_DASH] = ACTIONS(3108),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3112),
    [anon_sym_STAR] = ACTIONS(3108),
    [anon_sym_AT] = ACTIONS(3108),
    [anon_sym_QMARK] = ACTIONS(3108),
    [anon_sym_0] = ACTIONS(3114),
    [anon_sym__] = ACTIONS(3114),
  },
  [1019] = {
    [sym_for_statement] = STATE(1498),
    [sym_while_statement] = STATE(1498),
    [sym_if_statement] = STATE(1498),
    [sym_case_statement] = STATE(1498),
    [sym_function_definition] = STATE(1498),
    [sym_subshell] = STATE(1498),
    [sym_pipeline] = STATE(1498),
    [sym_list] = STATE(1498),
    [sym_command] = STATE(1498),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1499),
    [sym_declaration_command] = STATE(1498),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1020] = {
    [sym_for_statement] = STATE(1500),
    [sym_while_statement] = STATE(1500),
    [sym_if_statement] = STATE(1500),
    [sym_case_statement] = STATE(1500),
    [sym_function_definition] = STATE(1500),
    [sym_subshell] = STATE(1500),
    [sym_pipeline] = STATE(1500),
    [sym_list] = STATE(1500),
    [sym_command] = STATE(1500),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1501),
    [sym_declaration_command] = STATE(1500),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [1021] = {
    [sym_for_statement] = STATE(1502),
    [sym_while_statement] = STATE(1502),
    [sym_if_statement] = STATE(1502),
    [sym_case_statement] = STATE(1502),
    [sym_function_definition] = STATE(1502),
    [sym_subshell] = STATE(1502),
    [sym_pipeline] = STATE(1502),
    [sym_list] = STATE(1502),
    [sym_command] = STATE(1502),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1503),
    [sym_declaration_command] = STATE(1502),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1022] = {
    [sym__special_characters] = ACTIONS(3116),
    [anon_sym_DQUOTE] = ACTIONS(3118),
    [sym_raw_string] = ACTIONS(3118),
    [anon_sym_DOLLAR] = ACTIONS(3116),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3118),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3118),
    [anon_sym_BQUOTE] = ACTIONS(3118),
    [anon_sym_LT_LPAREN] = ACTIONS(3118),
    [anon_sym_GT_LPAREN] = ACTIONS(3118),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3116),
  },
  [1023] = {
    [anon_sym_esac] = ACTIONS(3120),
    [sym_comment] = ACTIONS(48),
  },
  [1024] = {
    [aux_sym_case_item_repeat1] = STATE(1489),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3098),
    [sym_comment] = ACTIONS(48),
  },
  [1025] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1505),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [1026] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1505),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1508),
    [anon_sym_esac] = ACTIONS(3124),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [1027] = {
    [anon_sym_PIPE] = ACTIONS(3126),
    [anon_sym_RPAREN] = ACTIONS(3126),
    [anon_sym_SEMI_SEMI] = ACTIONS(3126),
    [anon_sym_PIPE_AMP] = ACTIONS(3126),
    [anon_sym_AMP_AMP] = ACTIONS(3126),
    [anon_sym_PIPE_PIPE] = ACTIONS(3126),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3126),
    [anon_sym_LF] = ACTIONS(3126),
    [anon_sym_AMP] = ACTIONS(3126),
  },
  [1028] = {
    [anon_sym_esac] = ACTIONS(3128),
    [sym_comment] = ACTIONS(48),
  },
  [1029] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1510),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [1030] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1510),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1512),
    [anon_sym_esac] = ACTIONS(3130),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [1031] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_in] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1032] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3132),
    [sym_comment] = ACTIONS(48),
  },
  [1033] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [sym_comment] = ACTIONS(48),
  },
  [1034] = {
    [anon_sym_RBRACE] = ACTIONS(3134),
    [sym_comment] = ACTIONS(48),
  },
  [1035] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_in] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1036] = {
    [sym_concatenation] = STATE(1517),
    [sym_string] = STATE(1516),
    [sym_simple_expansion] = STATE(1516),
    [sym_expansion] = STATE(1516),
    [sym_command_substitution] = STATE(1516),
    [sym_process_substitution] = STATE(1516),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [sym__special_characters] = ACTIONS(3136),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3138),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3140),
  },
  [1037] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_in] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1038] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3142),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1039] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1040] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3144),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1041] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3134),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1042] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_in] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1043] = {
    [sym_file_redirect] = STATE(1520),
    [sym_file_descriptor] = ACTIONS(1074),
    [anon_sym_PIPE] = ACTIONS(3146),
    [anon_sym_SEMI_SEMI] = ACTIONS(3146),
    [anon_sym_PIPE_AMP] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_PIPE_PIPE] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(1078),
    [anon_sym_GT] = ACTIONS(1078),
    [anon_sym_GT_GT] = ACTIONS(1078),
    [anon_sym_AMP_GT] = ACTIONS(1078),
    [anon_sym_AMP_GT_GT] = ACTIONS(1078),
    [anon_sym_LT_AMP] = ACTIONS(1078),
    [anon_sym_GT_AMP] = ACTIONS(1078),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_LF] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3146),
  },
  [1044] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_RBRACE] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(794),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [1045] = {
    [sym_file_descriptor] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(3150),
    [anon_sym_RPAREN] = ACTIONS(3150),
    [anon_sym_SEMI_SEMI] = ACTIONS(3150),
    [anon_sym_PIPE_AMP] = ACTIONS(3150),
    [anon_sym_AMP_AMP] = ACTIONS(3150),
    [anon_sym_PIPE_PIPE] = ACTIONS(3150),
    [anon_sym_LT] = ACTIONS(3150),
    [anon_sym_GT] = ACTIONS(3150),
    [anon_sym_GT_GT] = ACTIONS(3150),
    [anon_sym_AMP_GT] = ACTIONS(3150),
    [anon_sym_AMP_GT_GT] = ACTIONS(3150),
    [anon_sym_LT_AMP] = ACTIONS(3150),
    [anon_sym_GT_AMP] = ACTIONS(3150),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3150),
    [anon_sym_LF] = ACTIONS(3150),
    [anon_sym_AMP] = ACTIONS(3150),
  },
  [1046] = {
    [sym__terminated_statement] = STATE(575),
    [sym_for_statement] = STATE(576),
    [sym_while_statement] = STATE(576),
    [sym_if_statement] = STATE(576),
    [sym_case_statement] = STATE(576),
    [sym_function_definition] = STATE(576),
    [sym_subshell] = STATE(576),
    [sym_pipeline] = STATE(576),
    [sym_list] = STATE(576),
    [sym_command] = STATE(576),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(577),
    [sym_declaration_command] = STATE(576),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1046),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_RBRACE] = ACTIONS(848),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(3152),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [1047] = {
    [sym_concatenation] = STATE(1523),
    [sym_string] = STATE(1522),
    [sym_simple_expansion] = STATE(1522),
    [sym_expansion] = STATE(1522),
    [sym_command_substitution] = STATE(1522),
    [sym_process_substitution] = STATE(1522),
    [sym__special_characters] = ACTIONS(3155),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_raw_string] = ACTIONS(3157),
    [anon_sym_DOLLAR] = ACTIONS(2017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(2023),
    [anon_sym_LT_LPAREN] = ACTIONS(2025),
    [anon_sym_GT_LPAREN] = ACTIONS(2025),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3159),
  },
  [1048] = {
    [aux_sym_concatenation_repeat1] = STATE(1525),
    [sym__concat] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(1698),
    [anon_sym_SEMI_SEMI] = ACTIONS(1698),
    [anon_sym_PIPE_AMP] = ACTIONS(1698),
    [anon_sym_AMP_AMP] = ACTIONS(1698),
    [anon_sym_PIPE_PIPE] = ACTIONS(1698),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_LF] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
  },
  [1049] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1527),
    [anon_sym_DQUOTE] = ACTIONS(3163),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1050] = {
    [aux_sym_concatenation_repeat1] = STATE(1525),
    [sym__concat] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_SEMI_SEMI] = ACTIONS(1702),
    [anon_sym_PIPE_AMP] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1702),
    [anon_sym_PIPE_PIPE] = ACTIONS(1702),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_LF] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
  },
  [1051] = {
    [sym_string] = STATE(1530),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [anon_sym_DOLLAR] = ACTIONS(3165),
    [anon_sym_POUND] = ACTIONS(3165),
    [anon_sym_DASH] = ACTIONS(3165),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3167),
    [anon_sym_STAR] = ACTIONS(3165),
    [anon_sym_AT] = ACTIONS(3165),
    [anon_sym_QMARK] = ACTIONS(3165),
    [anon_sym_0] = ACTIONS(3169),
    [anon_sym__] = ACTIONS(3169),
  },
  [1052] = {
    [sym_subscript] = STATE(1535),
    [sym_variable_name] = ACTIONS(3171),
    [anon_sym_DOLLAR] = ACTIONS(3173),
    [anon_sym_POUND] = ACTIONS(3175),
    [anon_sym_DASH] = ACTIONS(3173),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3177),
    [anon_sym_STAR] = ACTIONS(3173),
    [anon_sym_AT] = ACTIONS(3173),
    [anon_sym_QMARK] = ACTIONS(3173),
    [anon_sym_0] = ACTIONS(3179),
    [anon_sym__] = ACTIONS(3179),
  },
  [1053] = {
    [sym_for_statement] = STATE(1536),
    [sym_while_statement] = STATE(1536),
    [sym_if_statement] = STATE(1536),
    [sym_case_statement] = STATE(1536),
    [sym_function_definition] = STATE(1536),
    [sym_subshell] = STATE(1536),
    [sym_pipeline] = STATE(1536),
    [sym_list] = STATE(1536),
    [sym_command] = STATE(1536),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1537),
    [sym_declaration_command] = STATE(1536),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1054] = {
    [sym_for_statement] = STATE(1538),
    [sym_while_statement] = STATE(1538),
    [sym_if_statement] = STATE(1538),
    [sym_case_statement] = STATE(1538),
    [sym_function_definition] = STATE(1538),
    [sym_subshell] = STATE(1538),
    [sym_pipeline] = STATE(1538),
    [sym_list] = STATE(1538),
    [sym_command] = STATE(1538),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1539),
    [sym_declaration_command] = STATE(1538),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [1055] = {
    [sym_for_statement] = STATE(1540),
    [sym_while_statement] = STATE(1540),
    [sym_if_statement] = STATE(1540),
    [sym_case_statement] = STATE(1540),
    [sym_function_definition] = STATE(1540),
    [sym_subshell] = STATE(1540),
    [sym_pipeline] = STATE(1540),
    [sym_list] = STATE(1540),
    [sym_command] = STATE(1540),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1541),
    [sym_declaration_command] = STATE(1540),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1056] = {
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_RPAREN] = ACTIONS(1702),
    [anon_sym_SEMI_SEMI] = ACTIONS(1702),
    [anon_sym_PIPE_AMP] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1702),
    [anon_sym_PIPE_PIPE] = ACTIONS(1702),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_LF] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
  },
  [1057] = {
    [sym_string] = STATE(1542),
    [sym_simple_expansion] = STATE(1542),
    [sym_expansion] = STATE(1542),
    [sym_command_substitution] = STATE(1542),
    [sym_process_substitution] = STATE(1542),
    [sym__special_characters] = ACTIONS(3181),
    [anon_sym_DQUOTE] = ACTIONS(1082),
    [sym_raw_string] = ACTIONS(3183),
    [anon_sym_DOLLAR] = ACTIONS(1086),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1088),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1090),
    [anon_sym_BQUOTE] = ACTIONS(1092),
    [anon_sym_LT_LPAREN] = ACTIONS(1094),
    [anon_sym_GT_LPAREN] = ACTIONS(1094),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3181),
  },
  [1058] = {
    [aux_sym_concatenation_repeat1] = STATE(1543),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(2031),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_AMP_GT] = ACTIONS(540),
    [anon_sym_AMP_GT_GT] = ACTIONS(540),
    [anon_sym_LT_AMP] = ACTIONS(540),
    [anon_sym_GT_AMP] = ACTIONS(540),
    [sym__special_characters] = ACTIONS(540),
    [anon_sym_DQUOTE] = ACTIONS(540),
    [sym_raw_string] = ACTIONS(540),
    [anon_sym_DOLLAR] = ACTIONS(540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(540),
    [anon_sym_BQUOTE] = ACTIONS(540),
    [anon_sym_LT_LPAREN] = ACTIONS(540),
    [anon_sym_GT_LPAREN] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(540),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [1059] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [sym__special_characters] = ACTIONS(544),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [sym_raw_string] = ACTIONS(544),
    [anon_sym_DOLLAR] = ACTIONS(544),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(544),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(544),
    [anon_sym_BQUOTE] = ACTIONS(544),
    [anon_sym_LT_LPAREN] = ACTIONS(544),
    [anon_sym_GT_LPAREN] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(544),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [1060] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3185),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1061] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [sym__special_characters] = ACTIONS(574),
    [anon_sym_DQUOTE] = ACTIONS(574),
    [sym_raw_string] = ACTIONS(574),
    [anon_sym_DOLLAR] = ACTIONS(574),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(574),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(574),
    [anon_sym_BQUOTE] = ACTIONS(574),
    [anon_sym_LT_LPAREN] = ACTIONS(574),
    [anon_sym_GT_LPAREN] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(574),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [1062] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_GT] = ACTIONS(578),
    [anon_sym_AMP_GT_GT] = ACTIONS(578),
    [anon_sym_LT_AMP] = ACTIONS(578),
    [anon_sym_GT_AMP] = ACTIONS(578),
    [sym__special_characters] = ACTIONS(578),
    [anon_sym_DQUOTE] = ACTIONS(578),
    [sym_raw_string] = ACTIONS(578),
    [anon_sym_DOLLAR] = ACTIONS(578),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(578),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(578),
    [anon_sym_BQUOTE] = ACTIONS(578),
    [anon_sym_LT_LPAREN] = ACTIONS(578),
    [anon_sym_GT_LPAREN] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(578),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [1063] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [sym__special_characters] = ACTIONS(582),
    [anon_sym_DQUOTE] = ACTIONS(582),
    [sym_raw_string] = ACTIONS(582),
    [anon_sym_DOLLAR] = ACTIONS(582),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(582),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(582),
    [anon_sym_BQUOTE] = ACTIONS(582),
    [anon_sym_LT_LPAREN] = ACTIONS(582),
    [anon_sym_GT_LPAREN] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(582),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [1064] = {
    [anon_sym_EQ] = ACTIONS(3187),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1065] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1547),
    [anon_sym_RBRACE] = ACTIONS(3189),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1066] = {
    [sym_subscript] = STATE(1551),
    [sym_variable_name] = ACTIONS(3191),
    [anon_sym_DOLLAR] = ACTIONS(3193),
    [anon_sym_DASH] = ACTIONS(3193),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3195),
    [anon_sym_STAR] = ACTIONS(3193),
    [anon_sym_AT] = ACTIONS(3193),
    [anon_sym_QMARK] = ACTIONS(3193),
    [anon_sym_0] = ACTIONS(3197),
    [anon_sym__] = ACTIONS(3197),
  },
  [1067] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1553),
    [anon_sym_RBRACE] = ACTIONS(3199),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1068] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1555),
    [anon_sym_RBRACE] = ACTIONS(3201),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1069] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3203),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1070] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3203),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1071] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3203),
    [sym_comment] = ACTIONS(48),
  },
  [1072] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3203),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1073] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3205),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1074] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3205),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1075] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(646),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(1934),
    [anon_sym_RPAREN] = ACTIONS(1934),
    [anon_sym_SEMI_SEMI] = ACTIONS(1934),
    [anon_sym_PIPE_AMP] = ACTIONS(1934),
    [anon_sym_AMP_AMP] = ACTIONS(1934),
    [anon_sym_PIPE_PIPE] = ACTIONS(1934),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1934),
    [anon_sym_LF] = ACTIONS(1934),
    [anon_sym_AMP] = ACTIONS(1934),
  },
  [1076] = {
    [sym_compound_statement] = STATE(1558),
    [anon_sym_LBRACE] = ACTIONS(390),
    [sym_comment] = ACTIONS(48),
  },
  [1077] = {
    [anon_sym_LT] = ACTIONS(3207),
    [anon_sym_GT] = ACTIONS(3207),
    [anon_sym_GT_GT] = ACTIONS(3209),
    [anon_sym_AMP_GT] = ACTIONS(3207),
    [anon_sym_AMP_GT_GT] = ACTIONS(3209),
    [anon_sym_LT_AMP] = ACTIONS(3209),
    [anon_sym_GT_AMP] = ACTIONS(3209),
    [sym_comment] = ACTIONS(48),
  },
  [1078] = {
    [sym_concatenation] = STATE(1056),
    [sym_string] = STATE(1562),
    [sym_simple_expansion] = STATE(1562),
    [sym_expansion] = STATE(1562),
    [sym_command_substitution] = STATE(1562),
    [sym_process_substitution] = STATE(1562),
    [sym__special_characters] = ACTIONS(3211),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [sym_raw_string] = ACTIONS(3215),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3221),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [anon_sym_LT_LPAREN] = ACTIONS(3225),
    [anon_sym_GT_LPAREN] = ACTIONS(3225),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3227),
  },
  [1079] = {
    [aux_sym_concatenation_repeat1] = STATE(595),
    [sym__concat] = ACTIONS(1102),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(958),
    [anon_sym_RPAREN] = ACTIONS(958),
    [anon_sym_SEMI_SEMI] = ACTIONS(958),
    [anon_sym_PIPE_AMP] = ACTIONS(958),
    [anon_sym_AMP_AMP] = ACTIONS(958),
    [anon_sym_PIPE_PIPE] = ACTIONS(958),
    [sym__special_characters] = ACTIONS(958),
    [anon_sym_DQUOTE] = ACTIONS(958),
    [sym_raw_string] = ACTIONS(958),
    [anon_sym_DOLLAR] = ACTIONS(958),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(958),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(958),
    [anon_sym_BQUOTE] = ACTIONS(958),
    [anon_sym_LT_LPAREN] = ACTIONS(958),
    [anon_sym_GT_LPAREN] = ACTIONS(958),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(958),
    [sym_word] = ACTIONS(958),
    [anon_sym_SEMI] = ACTIONS(958),
    [anon_sym_LF] = ACTIONS(958),
    [anon_sym_AMP] = ACTIONS(958),
  },
  [1080] = {
    [aux_sym_concatenation_repeat1] = STATE(595),
    [sym__concat] = ACTIONS(1102),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(932),
    [anon_sym_RPAREN] = ACTIONS(932),
    [anon_sym_SEMI_SEMI] = ACTIONS(932),
    [anon_sym_PIPE_AMP] = ACTIONS(932),
    [anon_sym_AMP_AMP] = ACTIONS(932),
    [anon_sym_PIPE_PIPE] = ACTIONS(932),
    [sym__special_characters] = ACTIONS(932),
    [anon_sym_DQUOTE] = ACTIONS(932),
    [sym_raw_string] = ACTIONS(932),
    [anon_sym_DOLLAR] = ACTIONS(932),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(932),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(932),
    [anon_sym_BQUOTE] = ACTIONS(932),
    [anon_sym_LT_LPAREN] = ACTIONS(932),
    [anon_sym_GT_LPAREN] = ACTIONS(932),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(932),
    [sym_word] = ACTIONS(932),
    [anon_sym_SEMI] = ACTIONS(932),
    [anon_sym_LF] = ACTIONS(932),
    [anon_sym_AMP] = ACTIONS(932),
  },
  [1081] = {
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1304),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1082] = {
    [aux_sym_concatenation_repeat1] = STATE(1082),
    [sym__concat] = ACTIONS(3229),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1304),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1083] = {
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_raw_string] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1335),
    [sym_word] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [1084] = {
    [sym_concatenation] = STATE(1571),
    [sym_string] = STATE(1570),
    [sym_simple_expansion] = STATE(1570),
    [sym_expansion] = STATE(1570),
    [sym_command_substitution] = STATE(1570),
    [sym_process_substitution] = STATE(1570),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [sym__special_characters] = ACTIONS(3234),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3236),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3238),
  },
  [1085] = {
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1380),
    [sym_word] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1086] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3240),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1087] = {
    [anon_sym_EQ] = ACTIONS(3242),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1088] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1575),
    [anon_sym_RBRACE] = ACTIONS(3244),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1089] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1577),
    [anon_sym_RBRACE] = ACTIONS(3246),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1090] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1578),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1091] = {
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LPAREN] = ACTIONS(1424),
    [anon_sym_GT_LPAREN] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1424),
    [sym_word] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [1092] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3248),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1093] = {
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym_raw_string] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LPAREN] = ACTIONS(1430),
    [anon_sym_GT_LPAREN] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1430),
    [sym_word] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [1094] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3232),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1095] = {
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1540),
    [sym_word] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1096] = {
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LT_LPAREN] = ACTIONS(1684),
    [anon_sym_GT_LPAREN] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1684),
    [sym_word] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [1097] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT_GT] = ACTIONS(2290),
    [anon_sym_LT_AMP] = ACTIONS(2290),
    [anon_sym_GT_AMP] = ACTIONS(2290),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_LT_LT_DASH] = ACTIONS(2290),
    [anon_sym_LT_LT_LT] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_raw_string] = ACTIONS(2290),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2290),
    [anon_sym_GT_LPAREN] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1098] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3250),
    [sym_comment] = ACTIONS(48),
  },
  [1099] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [sym_comment] = ACTIONS(48),
  },
  [1100] = {
    [anon_sym_RBRACE] = ACTIONS(3252),
    [sym_comment] = ACTIONS(48),
  },
  [1101] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2354),
    [anon_sym_GT_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT_GT] = ACTIONS(2354),
    [anon_sym_LT_AMP] = ACTIONS(2354),
    [anon_sym_GT_AMP] = ACTIONS(2354),
    [anon_sym_LT_LT] = ACTIONS(2354),
    [anon_sym_LT_LT_DASH] = ACTIONS(2354),
    [anon_sym_LT_LT_LT] = ACTIONS(2354),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_raw_string] = ACTIONS(2354),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [anon_sym_LT_LPAREN] = ACTIONS(2354),
    [anon_sym_GT_LPAREN] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1102] = {
    [sym_concatenation] = STATE(1584),
    [sym_string] = STATE(1583),
    [sym_simple_expansion] = STATE(1583),
    [sym_expansion] = STATE(1583),
    [sym_command_substitution] = STATE(1583),
    [sym_process_substitution] = STATE(1583),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [sym__special_characters] = ACTIONS(3254),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3256),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3258),
  },
  [1103] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_RPAREN] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT_GT] = ACTIONS(2399),
    [anon_sym_LT_AMP] = ACTIONS(2399),
    [anon_sym_GT_AMP] = ACTIONS(2399),
    [anon_sym_LT_LT] = ACTIONS(2399),
    [anon_sym_LT_LT_DASH] = ACTIONS(2399),
    [anon_sym_LT_LT_LT] = ACTIONS(2399),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym_raw_string] = ACTIONS(2399),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_LT_LPAREN] = ACTIONS(2399),
    [anon_sym_GT_LPAREN] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1104] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3260),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1105] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_GT_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT_GT] = ACTIONS(2405),
    [anon_sym_LT_AMP] = ACTIONS(2405),
    [anon_sym_GT_AMP] = ACTIONS(2405),
    [anon_sym_LT_LT] = ACTIONS(2405),
    [anon_sym_LT_LT_DASH] = ACTIONS(2405),
    [anon_sym_LT_LT_LT] = ACTIONS(2405),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym_raw_string] = ACTIONS(2405),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [anon_sym_LT_LPAREN] = ACTIONS(2405),
    [anon_sym_GT_LPAREN] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1106] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1107] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3252),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1108] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_GT_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT_GT] = ACTIONS(2411),
    [anon_sym_LT_AMP] = ACTIONS(2411),
    [anon_sym_GT_AMP] = ACTIONS(2411),
    [anon_sym_LT_LT] = ACTIONS(2411),
    [anon_sym_LT_LT_DASH] = ACTIONS(2411),
    [anon_sym_LT_LT_LT] = ACTIONS(2411),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_raw_string] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2411),
    [anon_sym_GT_LPAREN] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1109] = {
    [sym_file_redirect] = STATE(1388),
    [sym_file_descriptor] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(2029),
    [anon_sym_RPAREN] = ACTIONS(2029),
    [anon_sym_SEMI_SEMI] = ACTIONS(2029),
    [anon_sym_PIPE_AMP] = ACTIONS(2029),
    [anon_sym_AMP_AMP] = ACTIONS(2029),
    [anon_sym_PIPE_PIPE] = ACTIONS(2029),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_AMP_GT] = ACTIONS(2055),
    [anon_sym_AMP_GT_GT] = ACTIONS(2055),
    [anon_sym_LT_AMP] = ACTIONS(2055),
    [anon_sym_GT_AMP] = ACTIONS(2055),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2029),
    [anon_sym_LF] = ACTIONS(2029),
    [anon_sym_AMP] = ACTIONS(2029),
  },
  [1110] = {
    [aux_sym_concatenation_repeat1] = STATE(1113),
    [sym_file_descriptor] = ACTIONS(922),
    [sym__concat] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(2848),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_SEMI_SEMI] = ACTIONS(2848),
    [anon_sym_PIPE_AMP] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_PIPE_PIPE] = ACTIONS(2848),
    [anon_sym_LT] = ACTIONS(2848),
    [anon_sym_GT] = ACTIONS(2848),
    [anon_sym_GT_GT] = ACTIONS(2848),
    [anon_sym_AMP_GT] = ACTIONS(2848),
    [anon_sym_AMP_GT_GT] = ACTIONS(2848),
    [anon_sym_LT_AMP] = ACTIONS(2848),
    [anon_sym_GT_AMP] = ACTIONS(2848),
    [anon_sym_LT_LT] = ACTIONS(2848),
    [anon_sym_LT_LT_DASH] = ACTIONS(2848),
    [anon_sym_LT_LT_LT] = ACTIONS(2848),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_LF] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2848),
  },
  [1111] = {
    [aux_sym_concatenation_repeat1] = STATE(1113),
    [sym_file_descriptor] = ACTIONS(926),
    [sym__concat] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_RPAREN] = ACTIONS(2850),
    [anon_sym_SEMI_SEMI] = ACTIONS(2850),
    [anon_sym_PIPE_AMP] = ACTIONS(2850),
    [anon_sym_AMP_AMP] = ACTIONS(2850),
    [anon_sym_PIPE_PIPE] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_GT] = ACTIONS(2850),
    [anon_sym_GT_GT] = ACTIONS(2850),
    [anon_sym_AMP_GT] = ACTIONS(2850),
    [anon_sym_AMP_GT_GT] = ACTIONS(2850),
    [anon_sym_LT_AMP] = ACTIONS(2850),
    [anon_sym_GT_AMP] = ACTIONS(2850),
    [anon_sym_LT_LT] = ACTIONS(2850),
    [anon_sym_LT_LT_DASH] = ACTIONS(2850),
    [anon_sym_LT_LT_LT] = ACTIONS(2850),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LF] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
  },
  [1112] = {
    [sym_string] = STATE(1587),
    [sym_simple_expansion] = STATE(1587),
    [sym_expansion] = STATE(1587),
    [sym_command_substitution] = STATE(1587),
    [sym_process_substitution] = STATE(1587),
    [sym__special_characters] = ACTIONS(3264),
    [anon_sym_DQUOTE] = ACTIONS(1162),
    [sym_raw_string] = ACTIONS(3266),
    [anon_sym_DOLLAR] = ACTIONS(1166),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1168),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1170),
    [anon_sym_BQUOTE] = ACTIONS(1172),
    [anon_sym_LT_LPAREN] = ACTIONS(1174),
    [anon_sym_GT_LPAREN] = ACTIONS(1174),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3264),
  },
  [1113] = {
    [aux_sym_concatenation_repeat1] = STATE(1588),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(2155),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [anon_sym_LT] = ACTIONS(540),
    [anon_sym_GT] = ACTIONS(540),
    [anon_sym_GT_GT] = ACTIONS(540),
    [anon_sym_AMP_GT] = ACTIONS(540),
    [anon_sym_AMP_GT_GT] = ACTIONS(540),
    [anon_sym_LT_AMP] = ACTIONS(540),
    [anon_sym_GT_AMP] = ACTIONS(540),
    [anon_sym_LT_LT] = ACTIONS(540),
    [anon_sym_LT_LT_DASH] = ACTIONS(540),
    [anon_sym_LT_LT_LT] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [1114] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [anon_sym_LT] = ACTIONS(544),
    [anon_sym_GT] = ACTIONS(544),
    [anon_sym_GT_GT] = ACTIONS(544),
    [anon_sym_AMP_GT] = ACTIONS(544),
    [anon_sym_AMP_GT_GT] = ACTIONS(544),
    [anon_sym_LT_AMP] = ACTIONS(544),
    [anon_sym_GT_AMP] = ACTIONS(544),
    [anon_sym_LT_LT] = ACTIONS(544),
    [anon_sym_LT_LT_DASH] = ACTIONS(544),
    [anon_sym_LT_LT_LT] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [1115] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3268),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1116] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [anon_sym_LT] = ACTIONS(574),
    [anon_sym_GT] = ACTIONS(574),
    [anon_sym_GT_GT] = ACTIONS(574),
    [anon_sym_AMP_GT] = ACTIONS(574),
    [anon_sym_AMP_GT_GT] = ACTIONS(574),
    [anon_sym_LT_AMP] = ACTIONS(574),
    [anon_sym_GT_AMP] = ACTIONS(574),
    [anon_sym_LT_LT] = ACTIONS(574),
    [anon_sym_LT_LT_DASH] = ACTIONS(574),
    [anon_sym_LT_LT_LT] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [1117] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [anon_sym_LT] = ACTIONS(578),
    [anon_sym_GT] = ACTIONS(578),
    [anon_sym_GT_GT] = ACTIONS(578),
    [anon_sym_AMP_GT] = ACTIONS(578),
    [anon_sym_AMP_GT_GT] = ACTIONS(578),
    [anon_sym_LT_AMP] = ACTIONS(578),
    [anon_sym_GT_AMP] = ACTIONS(578),
    [anon_sym_LT_LT] = ACTIONS(578),
    [anon_sym_LT_LT_DASH] = ACTIONS(578),
    [anon_sym_LT_LT_LT] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [1118] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [anon_sym_LT] = ACTIONS(582),
    [anon_sym_GT] = ACTIONS(582),
    [anon_sym_GT_GT] = ACTIONS(582),
    [anon_sym_AMP_GT] = ACTIONS(582),
    [anon_sym_AMP_GT_GT] = ACTIONS(582),
    [anon_sym_LT_AMP] = ACTIONS(582),
    [anon_sym_GT_AMP] = ACTIONS(582),
    [anon_sym_LT_LT] = ACTIONS(582),
    [anon_sym_LT_LT_DASH] = ACTIONS(582),
    [anon_sym_LT_LT_LT] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [1119] = {
    [anon_sym_EQ] = ACTIONS(3270),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1120] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1592),
    [anon_sym_RBRACE] = ACTIONS(3272),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1121] = {
    [sym_subscript] = STATE(1596),
    [sym_variable_name] = ACTIONS(3274),
    [anon_sym_DOLLAR] = ACTIONS(3276),
    [anon_sym_DASH] = ACTIONS(3276),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3278),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_AT] = ACTIONS(3276),
    [anon_sym_QMARK] = ACTIONS(3276),
    [anon_sym_0] = ACTIONS(3280),
    [anon_sym__] = ACTIONS(3280),
  },
  [1122] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1598),
    [anon_sym_RBRACE] = ACTIONS(3282),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1123] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1600),
    [anon_sym_RBRACE] = ACTIONS(3284),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1124] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3286),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1125] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3286),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1126] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3286),
    [sym_comment] = ACTIONS(48),
  },
  [1127] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3286),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1128] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3288),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1129] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3288),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1130] = {
    [anon_sym_PIPE] = ACTIONS(3290),
    [anon_sym_RPAREN] = ACTIONS(3290),
    [anon_sym_SEMI_SEMI] = ACTIONS(3290),
    [anon_sym_PIPE_AMP] = ACTIONS(3290),
    [anon_sym_AMP_AMP] = ACTIONS(3290),
    [anon_sym_PIPE_PIPE] = ACTIONS(3290),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3290),
    [anon_sym_LF] = ACTIONS(3290),
    [anon_sym_AMP] = ACTIONS(3290),
  },
  [1131] = {
    [sym_file_redirect] = STATE(161),
    [sym_heredoc_redirect] = STATE(161),
    [sym_herestring_redirect] = STATE(161),
    [aux_sym_while_statement_repeat1] = STATE(646),
    [sym_file_descriptor] = ACTIONS(444),
    [anon_sym_PIPE] = ACTIONS(2906),
    [anon_sym_RPAREN] = ACTIONS(2906),
    [anon_sym_SEMI_SEMI] = ACTIONS(2906),
    [anon_sym_PIPE_AMP] = ACTIONS(2906),
    [anon_sym_AMP_AMP] = ACTIONS(2906),
    [anon_sym_PIPE_PIPE] = ACTIONS(2906),
    [anon_sym_LT] = ACTIONS(446),
    [anon_sym_GT] = ACTIONS(446),
    [anon_sym_GT_GT] = ACTIONS(446),
    [anon_sym_AMP_GT] = ACTIONS(446),
    [anon_sym_AMP_GT_GT] = ACTIONS(446),
    [anon_sym_LT_AMP] = ACTIONS(446),
    [anon_sym_GT_AMP] = ACTIONS(446),
    [anon_sym_LT_LT] = ACTIONS(270),
    [anon_sym_LT_LT_DASH] = ACTIONS(270),
    [anon_sym_LT_LT_LT] = ACTIONS(448),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2906),
    [anon_sym_LF] = ACTIONS(2906),
    [anon_sym_AMP] = ACTIONS(2906),
  },
  [1132] = {
    [sym_variable_name] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(1796),
    [anon_sym_RPAREN] = ACTIONS(1796),
    [anon_sym_SEMI_SEMI] = ACTIONS(1796),
    [anon_sym_PIPE_AMP] = ACTIONS(1796),
    [anon_sym_AMP_AMP] = ACTIONS(1796),
    [anon_sym_PIPE_PIPE] = ACTIONS(1796),
    [sym__special_characters] = ACTIONS(1796),
    [anon_sym_DQUOTE] = ACTIONS(1796),
    [sym_raw_string] = ACTIONS(1796),
    [anon_sym_DOLLAR] = ACTIONS(1796),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1796),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1796),
    [anon_sym_BQUOTE] = ACTIONS(1796),
    [anon_sym_LT_LPAREN] = ACTIONS(1796),
    [anon_sym_GT_LPAREN] = ACTIONS(1796),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(1796),
    [sym_word] = ACTIONS(1796),
    [anon_sym_SEMI] = ACTIONS(1796),
    [anon_sym_LF] = ACTIONS(1796),
    [anon_sym_AMP] = ACTIONS(1796),
  },
  [1133] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(941),
    [anon_sym_RPAREN] = ACTIONS(3292),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [1134] = {
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_raw_string] = ACTIONS(2290),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2290),
    [anon_sym_GT_LPAREN] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2290),
    [sym_word] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1135] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3294),
    [sym_comment] = ACTIONS(48),
  },
  [1136] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [sym_comment] = ACTIONS(48),
  },
  [1137] = {
    [anon_sym_RBRACE] = ACTIONS(3296),
    [sym_comment] = ACTIONS(48),
  },
  [1138] = {
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_raw_string] = ACTIONS(2354),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [anon_sym_LT_LPAREN] = ACTIONS(2354),
    [anon_sym_GT_LPAREN] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2354),
    [sym_word] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1139] = {
    [sym_concatenation] = STATE(1608),
    [sym_string] = STATE(1607),
    [sym_simple_expansion] = STATE(1607),
    [sym_expansion] = STATE(1607),
    [sym_command_substitution] = STATE(1607),
    [sym_process_substitution] = STATE(1607),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [sym__special_characters] = ACTIONS(3298),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3300),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3302),
  },
  [1140] = {
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym_raw_string] = ACTIONS(2399),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_LT_LPAREN] = ACTIONS(2399),
    [anon_sym_GT_LPAREN] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2399),
    [sym_word] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1141] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3304),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1142] = {
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym_raw_string] = ACTIONS(2405),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [anon_sym_LT_LPAREN] = ACTIONS(2405),
    [anon_sym_GT_LPAREN] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2405),
    [sym_word] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1143] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1144] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1145] = {
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_raw_string] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2411),
    [anon_sym_GT_LPAREN] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2411),
    [sym_word] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1146] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(3308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3308),
  },
  [1147] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [sym_comment] = ACTIONS(48),
  },
  [1148] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [sym_comment] = ACTIONS(48),
  },
  [1149] = {
    [anon_sym_RBRACE] = ACTIONS(3312),
    [sym_comment] = ACTIONS(48),
  },
  [1150] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_GT_GT] = ACTIONS(2352),
    [anon_sym_AMP_GT] = ACTIONS(3314),
    [anon_sym_AMP_GT_GT] = ACTIONS(2352),
    [anon_sym_LT_AMP] = ACTIONS(2352),
    [anon_sym_GT_AMP] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3314),
  },
  [1151] = {
    [sym_concatenation] = STATE(1615),
    [sym_string] = STATE(1614),
    [sym_simple_expansion] = STATE(1614),
    [sym_expansion] = STATE(1614),
    [sym_command_substitution] = STATE(1614),
    [sym_process_substitution] = STATE(1614),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [sym__special_characters] = ACTIONS(3316),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3318),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3320),
  },
  [1152] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT] = ACTIONS(3322),
    [anon_sym_AMP_GT_GT] = ACTIONS(2397),
    [anon_sym_LT_AMP] = ACTIONS(2397),
    [anon_sym_GT_AMP] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3322),
  },
  [1153] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1154] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(2403),
    [anon_sym_AMP_GT] = ACTIONS(3326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_AMP] = ACTIONS(2403),
    [anon_sym_GT_AMP] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3326),
  },
  [1155] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1156] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3312),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1157] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(2409),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(2409),
    [anon_sym_LT_AMP] = ACTIONS(2409),
    [anon_sym_GT_AMP] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3330),
  },
  [1158] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym__string_content] = ACTIONS(2238),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
  },
  [1159] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym__string_content] = ACTIONS(3308),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
  },
  [1160] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [sym_comment] = ACTIONS(48),
  },
  [1161] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [sym_comment] = ACTIONS(48),
  },
  [1162] = {
    [anon_sym_RBRACE] = ACTIONS(3334),
    [sym_comment] = ACTIONS(48),
  },
  [1163] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym__string_content] = ACTIONS(3314),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
  },
  [1164] = {
    [sym_concatenation] = STATE(1622),
    [sym_string] = STATE(1621),
    [sym_simple_expansion] = STATE(1621),
    [sym_expansion] = STATE(1621),
    [sym_command_substitution] = STATE(1621),
    [sym_process_substitution] = STATE(1621),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [sym__special_characters] = ACTIONS(3336),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3338),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3340),
  },
  [1165] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym__string_content] = ACTIONS(3322),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
  },
  [1166] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3342),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1167] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym__string_content] = ACTIONS(3326),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
  },
  [1168] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3344),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1169] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3334),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1170] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym__string_content] = ACTIONS(3330),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
  },
  [1171] = {
    [sym_string] = STATE(1625),
    [sym_simple_expansion] = STATE(1625),
    [sym_expansion] = STATE(1625),
    [sym_command_substitution] = STATE(1625),
    [sym_process_substitution] = STATE(1625),
    [sym__special_characters] = ACTIONS(3346),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3348),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3346),
  },
  [1172] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT_GT] = ACTIONS(3352),
    [anon_sym_LT_AMP] = ACTIONS(3352),
    [anon_sym_GT_AMP] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_LT_LT_DASH] = ACTIONS(3352),
    [anon_sym_LT_LT_LT] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [anon_sym_LT_LPAREN] = ACTIONS(3352),
    [anon_sym_GT_LPAREN] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [1173] = {
    [aux_sym_concatenation_repeat1] = STATE(1626),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
  },
  [1174] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_RBRACE] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [1175] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3354),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1176] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT_GT] = ACTIONS(3358),
    [anon_sym_LT_AMP] = ACTIONS(3358),
    [anon_sym_GT_AMP] = ACTIONS(3358),
    [anon_sym_LT_LT] = ACTIONS(3358),
    [anon_sym_LT_LT_DASH] = ACTIONS(3358),
    [anon_sym_LT_LT_LT] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym_raw_string] = ACTIONS(3358),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [anon_sym_LT_LPAREN] = ACTIONS(3358),
    [anon_sym_GT_LPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [1177] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_RBRACE] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [1178] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_RBRACE] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [1179] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_RBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [1180] = {
    [anon_sym_EQ] = ACTIONS(3360),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1181] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1630),
    [anon_sym_RBRACE] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1182] = {
    [sym_subscript] = STATE(1634),
    [sym_variable_name] = ACTIONS(3364),
    [anon_sym_DOLLAR] = ACTIONS(3366),
    [anon_sym_DASH] = ACTIONS(3366),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3366),
    [anon_sym_AT] = ACTIONS(3366),
    [anon_sym_QMARK] = ACTIONS(3366),
    [anon_sym_0] = ACTIONS(3370),
    [anon_sym__] = ACTIONS(3370),
  },
  [1183] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1636),
    [anon_sym_RBRACE] = ACTIONS(3372),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1184] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1638),
    [anon_sym_RBRACE] = ACTIONS(3374),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1185] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3376),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1186] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3376),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1187] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3376),
    [sym_comment] = ACTIONS(48),
  },
  [1188] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3376),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1189] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3378),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1190] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3378),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1191] = {
    [sym_string] = STATE(959),
    [sym_simple_expansion] = STATE(959),
    [sym_expansion] = STATE(959),
    [sym_command_substitution] = STATE(959),
    [sym_process_substitution] = STATE(959),
    [anon_sym_RBRACK] = ACTIONS(3380),
    [sym__special_characters] = ACTIONS(1848),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(340),
    [anon_sym_BQUOTE] = ACTIONS(342),
    [anon_sym_LT_LPAREN] = ACTIONS(344),
    [anon_sym_GT_LPAREN] = ACTIONS(344),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1852),
  },
  [1192] = {
    [sym__concat] = ACTIONS(3382),
    [anon_sym_RBRACE] = ACTIONS(1856),
    [anon_sym_EQ] = ACTIONS(3384),
    [sym__special_characters] = ACTIONS(3386),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [sym_raw_string] = ACTIONS(1856),
    [anon_sym_DOLLAR] = ACTIONS(3384),
    [anon_sym_POUND] = ACTIONS(1856),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1856),
    [anon_sym_COLON] = ACTIONS(3384),
    [anon_sym_COLON_QMARK] = ACTIONS(3384),
    [anon_sym_COLON_DASH] = ACTIONS(3384),
    [anon_sym_PERCENT] = ACTIONS(3384),
    [anon_sym_SLASH] = ACTIONS(3384),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1856),
    [anon_sym_BQUOTE] = ACTIONS(1856),
    [anon_sym_LT_LPAREN] = ACTIONS(1856),
    [anon_sym_GT_LPAREN] = ACTIONS(1856),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3386),
  },
  [1193] = {
    [sym_string] = STATE(959),
    [sym_simple_expansion] = STATE(959),
    [sym_expansion] = STATE(959),
    [sym_command_substitution] = STATE(959),
    [sym_process_substitution] = STATE(959),
    [anon_sym_RBRACK] = ACTIONS(3388),
    [sym__special_characters] = ACTIONS(1848),
    [anon_sym_DQUOTE] = ACTIONS(332),
    [sym_raw_string] = ACTIONS(1850),
    [anon_sym_DOLLAR] = ACTIONS(336),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(338),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(340),
    [anon_sym_BQUOTE] = ACTIONS(342),
    [anon_sym_LT_LPAREN] = ACTIONS(344),
    [anon_sym_GT_LPAREN] = ACTIONS(344),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1852),
  },
  [1194] = {
    [sym__concat] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(1866),
    [anon_sym_EQ] = ACTIONS(3392),
    [sym__special_characters] = ACTIONS(3394),
    [anon_sym_DQUOTE] = ACTIONS(1866),
    [sym_raw_string] = ACTIONS(1866),
    [anon_sym_DOLLAR] = ACTIONS(3392),
    [anon_sym_POUND] = ACTIONS(1866),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1866),
    [anon_sym_COLON] = ACTIONS(3392),
    [anon_sym_COLON_QMARK] = ACTIONS(3392),
    [anon_sym_COLON_DASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1866),
    [anon_sym_BQUOTE] = ACTIONS(1866),
    [anon_sym_LT_LPAREN] = ACTIONS(1866),
    [anon_sym_GT_LPAREN] = ACTIONS(1866),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3394),
  },
  [1195] = {
    [anon_sym_RBRACK] = ACTIONS(3388),
    [sym_comment] = ACTIONS(48),
  },
  [1196] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [anon_sym_EQ] = ACTIONS(2233),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_POUND] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_COLON] = ACTIONS(2233),
    [anon_sym_COLON_QMARK] = ACTIONS(2233),
    [anon_sym_COLON_DASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
  },
  [1197] = {
    [aux_sym_concatenation_repeat1] = STATE(1197),
    [sym__concat] = ACTIONS(3396),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [anon_sym_EQ] = ACTIONS(2233),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_POUND] = ACTIONS(1302),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_COLON] = ACTIONS(2233),
    [anon_sym_COLON_QMARK] = ACTIONS(2233),
    [anon_sym_COLON_DASH] = ACTIONS(2233),
    [anon_sym_PERCENT] = ACTIONS(2233),
    [anon_sym_SLASH] = ACTIONS(2233),
    [anon_sym_DASH] = ACTIONS(2233),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
  },
  [1198] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1333),
    [anon_sym_EQ] = ACTIONS(2238),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_POUND] = ACTIONS(1333),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_COLON] = ACTIONS(2238),
    [anon_sym_COLON_QMARK] = ACTIONS(2238),
    [anon_sym_COLON_DASH] = ACTIONS(2238),
    [anon_sym_PERCENT] = ACTIONS(2238),
    [anon_sym_SLASH] = ACTIONS(2238),
    [anon_sym_DASH] = ACTIONS(2238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1335),
  },
  [1199] = {
    [sym_concatenation] = STATE(1648),
    [sym_string] = STATE(1647),
    [sym_simple_expansion] = STATE(1647),
    [sym_expansion] = STATE(1647),
    [sym_command_substitution] = STATE(1647),
    [sym_process_substitution] = STATE(1647),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [sym__special_characters] = ACTIONS(3401),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3403),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3405),
  },
  [1200] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [anon_sym_EQ] = ACTIONS(2248),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_POUND] = ACTIONS(1378),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_COLON] = ACTIONS(2248),
    [anon_sym_COLON_QMARK] = ACTIONS(2248),
    [anon_sym_COLON_DASH] = ACTIONS(2248),
    [anon_sym_PERCENT] = ACTIONS(2248),
    [anon_sym_SLASH] = ACTIONS(2248),
    [anon_sym_DASH] = ACTIONS(2248),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1380),
  },
  [1201] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3407),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1202] = {
    [anon_sym_EQ] = ACTIONS(3409),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1203] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1652),
    [anon_sym_RBRACE] = ACTIONS(3411),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1204] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1654),
    [anon_sym_RBRACE] = ACTIONS(3413),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1205] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1655),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1206] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [anon_sym_EQ] = ACTIONS(2258),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_POUND] = ACTIONS(1422),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_COLON] = ACTIONS(2258),
    [anon_sym_COLON_QMARK] = ACTIONS(2258),
    [anon_sym_COLON_DASH] = ACTIONS(2258),
    [anon_sym_PERCENT] = ACTIONS(2258),
    [anon_sym_SLASH] = ACTIONS(2258),
    [anon_sym_DASH] = ACTIONS(2258),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1424),
  },
  [1207] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3415),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1208] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [anon_sym_EQ] = ACTIONS(2262),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_POUND] = ACTIONS(1428),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_COLON] = ACTIONS(2262),
    [anon_sym_COLON_QMARK] = ACTIONS(2262),
    [anon_sym_COLON_DASH] = ACTIONS(2262),
    [anon_sym_PERCENT] = ACTIONS(2262),
    [anon_sym_SLASH] = ACTIONS(2262),
    [anon_sym_DASH] = ACTIONS(2262),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1430),
  },
  [1209] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3399),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1210] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [anon_sym_EQ] = ACTIONS(2264),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_POUND] = ACTIONS(1538),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_COLON] = ACTIONS(2264),
    [anon_sym_COLON_QMARK] = ACTIONS(2264),
    [anon_sym_COLON_DASH] = ACTIONS(2264),
    [anon_sym_PERCENT] = ACTIONS(2264),
    [anon_sym_SLASH] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1540),
  },
  [1211] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [anon_sym_EQ] = ACTIONS(2266),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_POUND] = ACTIONS(1682),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_COLON] = ACTIONS(2266),
    [anon_sym_COLON_QMARK] = ACTIONS(2266),
    [anon_sym_COLON_DASH] = ACTIONS(2266),
    [anon_sym_PERCENT] = ACTIONS(2266),
    [anon_sym_SLASH] = ACTIONS(2266),
    [anon_sym_DASH] = ACTIONS(2266),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1684),
  },
  [1212] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3417),
    [sym_comment] = ACTIONS(48),
  },
  [1213] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3419),
    [sym_comment] = ACTIONS(48),
  },
  [1214] = {
    [anon_sym_RBRACE] = ACTIONS(3419),
    [sym_comment] = ACTIONS(48),
  },
  [1215] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_AMP] = ACTIONS(3423),
    [anon_sym_GT_AMP] = ACTIONS(3423),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_LT_LT_DASH] = ACTIONS(3423),
    [anon_sym_LT_LT_LT] = ACTIONS(3423),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [1216] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_GT_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_AMP] = ACTIONS(3427),
    [anon_sym_GT_AMP] = ACTIONS(3427),
    [anon_sym_LT_LT] = ACTIONS(3427),
    [anon_sym_LT_LT_DASH] = ACTIONS(3427),
    [anon_sym_LT_LT_LT] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_raw_string] = ACTIONS(3427),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [anon_sym_LT_LPAREN] = ACTIONS(3427),
    [anon_sym_GT_LPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [1217] = {
    [sym_file_descriptor] = ACTIONS(1794),
    [sym_variable_name] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(3429),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_PIPE_AMP] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [anon_sym_LT] = ACTIONS(3429),
    [anon_sym_GT] = ACTIONS(3429),
    [anon_sym_GT_GT] = ACTIONS(1794),
    [anon_sym_AMP_GT] = ACTIONS(3429),
    [anon_sym_AMP_GT_GT] = ACTIONS(1794),
    [anon_sym_LT_AMP] = ACTIONS(1794),
    [anon_sym_GT_AMP] = ACTIONS(1794),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(1794),
    [sym_raw_string] = ACTIONS(1794),
    [anon_sym_DOLLAR] = ACTIONS(3429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1794),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1794),
    [anon_sym_BQUOTE] = ACTIONS(1794),
    [anon_sym_LT_LPAREN] = ACTIONS(1794),
    [anon_sym_GT_LPAREN] = ACTIONS(1794),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3429),
  },
  [1218] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(941),
    [anon_sym_RPAREN] = ACTIONS(3431),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [1219] = {
    [sym_string] = STATE(1660),
    [sym_simple_expansion] = STATE(1660),
    [sym_expansion] = STATE(1660),
    [sym_command_substitution] = STATE(1660),
    [sym_process_substitution] = STATE(1660),
    [sym__special_characters] = ACTIONS(3433),
    [anon_sym_DQUOTE] = ACTIONS(1438),
    [sym_raw_string] = ACTIONS(3435),
    [anon_sym_DOLLAR] = ACTIONS(1442),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1444),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1446),
    [anon_sym_BQUOTE] = ACTIONS(1448),
    [anon_sym_LT_LPAREN] = ACTIONS(1450),
    [anon_sym_GT_LPAREN] = ACTIONS(1450),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3433),
  },
  [1220] = {
    [aux_sym_concatenation_repeat1] = STATE(1661),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(2417),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_RPAREN] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_AMP_GT] = ACTIONS(1270),
    [anon_sym_AMP_GT_GT] = ACTIONS(538),
    [anon_sym_LT_AMP] = ACTIONS(538),
    [anon_sym_GT_AMP] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1270),
  },
  [1221] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(1272),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1272),
  },
  [1222] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3437),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1223] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(1276),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1276),
  },
  [1224] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(1278),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1278),
  },
  [1225] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1280),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1280),
  },
  [1226] = {
    [anon_sym_EQ] = ACTIONS(3439),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1227] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1665),
    [anon_sym_RBRACE] = ACTIONS(3441),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1228] = {
    [sym_subscript] = STATE(1669),
    [sym_variable_name] = ACTIONS(3443),
    [anon_sym_DOLLAR] = ACTIONS(3445),
    [anon_sym_DASH] = ACTIONS(3445),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3447),
    [anon_sym_STAR] = ACTIONS(3445),
    [anon_sym_AT] = ACTIONS(3445),
    [anon_sym_QMARK] = ACTIONS(3445),
    [anon_sym_0] = ACTIONS(3449),
    [anon_sym__] = ACTIONS(3449),
  },
  [1229] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1671),
    [anon_sym_RBRACE] = ACTIONS(3451),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1230] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1673),
    [anon_sym_RBRACE] = ACTIONS(3453),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1231] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3455),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1232] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3455),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1233] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3455),
    [sym_comment] = ACTIONS(48),
  },
  [1234] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3455),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1235] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3457),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1236] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3457),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1237] = {
    [sym_concatenation] = STATE(535),
    [sym_string] = STATE(529),
    [sym_simple_expansion] = STATE(529),
    [sym_expansion] = STATE(529),
    [sym_command_substitution] = STATE(529),
    [sym_process_substitution] = STATE(529),
    [aux_sym_for_statement_repeat1] = STATE(998),
    [anon_sym_SEMI_SEMI] = ACTIONS(3459),
    [sym__special_characters] = ACTIONS(1910),
    [anon_sym_DQUOTE] = ACTIONS(1912),
    [sym_raw_string] = ACTIONS(1914),
    [anon_sym_DOLLAR] = ACTIONS(1916),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1918),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1920),
    [anon_sym_BQUOTE] = ACTIONS(1922),
    [anon_sym_LT_LPAREN] = ACTIONS(1924),
    [anon_sym_GT_LPAREN] = ACTIONS(1924),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1914),
    [anon_sym_SEMI] = ACTIONS(3459),
    [anon_sym_LF] = ACTIONS(3459),
    [anon_sym_AMP] = ACTIONS(3459),
  },
  [1238] = {
    [sym_file_descriptor] = ACTIONS(1926),
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_RPAREN] = ACTIONS(1926),
    [anon_sym_PIPE_AMP] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_PIPE_PIPE] = ACTIONS(1926),
    [anon_sym_LT] = ACTIONS(3461),
    [anon_sym_GT] = ACTIONS(3461),
    [anon_sym_GT_GT] = ACTIONS(1926),
    [anon_sym_AMP_GT] = ACTIONS(3461),
    [anon_sym_AMP_GT_GT] = ACTIONS(1926),
    [anon_sym_LT_AMP] = ACTIONS(1926),
    [anon_sym_GT_AMP] = ACTIONS(1926),
    [anon_sym_LT_LT] = ACTIONS(3461),
    [anon_sym_LT_LT_DASH] = ACTIONS(1926),
    [anon_sym_LT_LT_LT] = ACTIONS(1926),
    [anon_sym_BQUOTE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(48),
  },
  [1239] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1001),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(3463),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1240] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(824),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(3465),
    [anon_sym_RPAREN] = ACTIONS(3467),
    [anon_sym_PIPE_AMP] = ACTIONS(3467),
    [anon_sym_AMP_AMP] = ACTIONS(3467),
    [anon_sym_PIPE_PIPE] = ACTIONS(3467),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym_comment] = ACTIONS(48),
  },
  [1241] = {
    [anon_sym_PIPE] = ACTIONS(3469),
    [anon_sym_RPAREN] = ACTIONS(3471),
    [anon_sym_PIPE_AMP] = ACTIONS(3471),
    [anon_sym_AMP_AMP] = ACTIONS(3471),
    [anon_sym_PIPE_PIPE] = ACTIONS(3471),
    [anon_sym_BQUOTE] = ACTIONS(3471),
    [sym_comment] = ACTIONS(48),
  },
  [1242] = {
    [anon_sym_fi] = ACTIONS(3473),
    [sym_comment] = ACTIONS(48),
  },
  [1243] = {
    [sym__terminated_statement] = STATE(546),
    [sym_for_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(1679),
    [sym_case_statement] = STATE(547),
    [sym_function_definition] = STATE(547),
    [sym_subshell] = STATE(547),
    [sym_pipeline] = STATE(547),
    [sym_list] = STATE(547),
    [sym_command] = STATE(547),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(550),
    [sym_declaration_command] = STATE(547),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1010),
    [aux_sym_if_statement_repeat1] = STATE(1680),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(3475),
    [anon_sym_elif] = ACTIONS(1030),
    [anon_sym_else] = ACTIONS(1032),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1244] = {
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(1679),
    [aux_sym_if_statement_repeat1] = STATE(1012),
    [anon_sym_fi] = ACTIONS(3473),
    [anon_sym_elif] = ACTIONS(1948),
    [anon_sym_else] = ACTIONS(1950),
    [sym_comment] = ACTIONS(48),
  },
  [1245] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1682),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1683),
    [anon_sym_esac] = ACTIONS(3477),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [1246] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3479),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3479),
    [anon_sym_LF] = ACTIONS(3479),
    [anon_sym_AMP] = ACTIONS(3479),
  },
  [1247] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1686),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1687),
    [anon_sym_esac] = ACTIONS(3481),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [1248] = {
    [anon_sym_SEMI_SEMI] = ACTIONS(3483),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3483),
    [anon_sym_LF] = ACTIONS(3483),
    [anon_sym_AMP] = ACTIONS(3483),
  },
  [1249] = {
    [sym_compound_statement] = STATE(1689),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [sym_comment] = ACTIONS(48),
  },
  [1250] = {
    [sym_file_descriptor] = ACTIONS(1999),
    [anon_sym_PIPE] = ACTIONS(3485),
    [anon_sym_RPAREN] = ACTIONS(1999),
    [anon_sym_PIPE_AMP] = ACTIONS(1999),
    [anon_sym_AMP_AMP] = ACTIONS(1999),
    [anon_sym_PIPE_PIPE] = ACTIONS(1999),
    [anon_sym_LT] = ACTIONS(3485),
    [anon_sym_GT] = ACTIONS(3485),
    [anon_sym_GT_GT] = ACTIONS(1999),
    [anon_sym_AMP_GT] = ACTIONS(3485),
    [anon_sym_AMP_GT_GT] = ACTIONS(1999),
    [anon_sym_LT_AMP] = ACTIONS(1999),
    [anon_sym_GT_AMP] = ACTIONS(1999),
    [anon_sym_BQUOTE] = ACTIONS(1999),
    [sym_comment] = ACTIONS(48),
  },
  [1251] = {
    [sym__terminated_statement] = STATE(575),
    [sym_for_statement] = STATE(576),
    [sym_while_statement] = STATE(576),
    [sym_if_statement] = STATE(576),
    [sym_case_statement] = STATE(576),
    [sym_function_definition] = STATE(576),
    [sym_subshell] = STATE(576),
    [sym_pipeline] = STATE(576),
    [sym_list] = STATE(576),
    [sym_command] = STATE(576),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(577),
    [sym_declaration_command] = STATE(576),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1046),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_RBRACE] = ACTIONS(3487),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(1072),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1252] = {
    [anon_sym_LT] = ACTIONS(3489),
    [anon_sym_GT] = ACTIONS(3489),
    [anon_sym_GT_GT] = ACTIONS(3491),
    [anon_sym_AMP_GT] = ACTIONS(3489),
    [anon_sym_AMP_GT_GT] = ACTIONS(3491),
    [anon_sym_LT_AMP] = ACTIONS(3491),
    [anon_sym_GT_AMP] = ACTIONS(3491),
    [sym_comment] = ACTIONS(48),
  },
  [1253] = {
    [sym_concatenation] = STATE(1700),
    [sym_string] = STATE(1694),
    [sym_simple_expansion] = STATE(1694),
    [sym_expansion] = STATE(1694),
    [sym_command_substitution] = STATE(1694),
    [sym_process_substitution] = STATE(1694),
    [sym__special_characters] = ACTIONS(3493),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [sym_raw_string] = ACTIONS(3497),
    [anon_sym_DOLLAR] = ACTIONS(3499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3503),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [anon_sym_LT_LPAREN] = ACTIONS(3507),
    [anon_sym_GT_LPAREN] = ACTIONS(3507),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3509),
  },
  [1254] = {
    [anon_sym_PIPE] = ACTIONS(3511),
    [anon_sym_RPAREN] = ACTIONS(3513),
    [anon_sym_PIPE_AMP] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE_PIPE] = ACTIONS(3513),
    [anon_sym_BQUOTE] = ACTIONS(3513),
    [sym_comment] = ACTIONS(48),
  },
  [1255] = {
    [anon_sym_PIPE] = ACTIONS(3515),
    [anon_sym_RPAREN] = ACTIONS(3517),
    [anon_sym_PIPE_AMP] = ACTIONS(3517),
    [anon_sym_AMP_AMP] = ACTIONS(3517),
    [anon_sym_PIPE_PIPE] = ACTIONS(3517),
    [anon_sym_BQUOTE] = ACTIONS(3517),
    [sym_comment] = ACTIONS(48),
  },
  [1256] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_RPAREN] = ACTIONS(3519),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [1257] = {
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_RPAREN] = ACTIONS(930),
    [anon_sym_PIPE_AMP] = ACTIONS(930),
    [anon_sym_AMP_AMP] = ACTIONS(930),
    [anon_sym_PIPE_PIPE] = ACTIONS(930),
    [sym__special_characters] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [sym_raw_string] = ACTIONS(930),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(930),
    [anon_sym_BQUOTE] = ACTIONS(930),
    [anon_sym_LT_LPAREN] = ACTIONS(930),
    [anon_sym_GT_LPAREN] = ACTIONS(930),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2413),
    [sym_word] = ACTIONS(932),
  },
  [1258] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(1703),
    [anon_sym_RPAREN] = ACTIONS(3521),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [1259] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [sym__concat] = ACTIONS(1480),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_RPAREN] = ACTIONS(954),
    [anon_sym_PIPE_AMP] = ACTIONS(954),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [sym__special_characters] = ACTIONS(2419),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_raw_string] = ACTIONS(954),
    [anon_sym_DOLLAR] = ACTIONS(2419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(954),
    [anon_sym_BQUOTE] = ACTIONS(954),
    [anon_sym_LT_LPAREN] = ACTIONS(954),
    [anon_sym_GT_LPAREN] = ACTIONS(954),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2419),
    [sym_word] = ACTIONS(958),
  },
  [1260] = {
    [aux_sym_concatenation_repeat1] = STATE(767),
    [sym__concat] = ACTIONS(1480),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_RPAREN] = ACTIONS(930),
    [anon_sym_PIPE_AMP] = ACTIONS(930),
    [anon_sym_AMP_AMP] = ACTIONS(930),
    [anon_sym_PIPE_PIPE] = ACTIONS(930),
    [sym__special_characters] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [sym_raw_string] = ACTIONS(930),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(930),
    [anon_sym_BQUOTE] = ACTIONS(930),
    [anon_sym_LT_LPAREN] = ACTIONS(930),
    [anon_sym_GT_LPAREN] = ACTIONS(930),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2413),
    [sym_word] = ACTIONS(932),
  },
  [1261] = {
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2233),
    [sym_word] = ACTIONS(1304),
  },
  [1262] = {
    [aux_sym_concatenation_repeat1] = STATE(1262),
    [sym__concat] = ACTIONS(3523),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2233),
    [sym_word] = ACTIONS(1304),
  },
  [1263] = {
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2238),
    [sym_word] = ACTIONS(1335),
  },
  [1264] = {
    [sym_concatenation] = STATE(1707),
    [sym_string] = STATE(1706),
    [sym_simple_expansion] = STATE(1706),
    [sym_expansion] = STATE(1706),
    [sym_command_substitution] = STATE(1706),
    [sym_process_substitution] = STATE(1706),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [sym__special_characters] = ACTIONS(3528),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3530),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3532),
  },
  [1265] = {
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2248),
    [sym_word] = ACTIONS(1380),
  },
  [1266] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3534),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1267] = {
    [anon_sym_EQ] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1268] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1711),
    [anon_sym_RBRACE] = ACTIONS(3538),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1269] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1713),
    [anon_sym_RBRACE] = ACTIONS(3540),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1270] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1714),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1271] = {
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2258),
    [sym_word] = ACTIONS(1424),
  },
  [1272] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1273] = {
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2262),
    [sym_word] = ACTIONS(1430),
  },
  [1274] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1275] = {
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2264),
    [sym_word] = ACTIONS(1540),
  },
  [1276] = {
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2266),
    [sym_word] = ACTIONS(1684),
  },
  [1277] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_RPAREN] = ACTIONS(2288),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(3308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2288),
    [anon_sym_LT_LT_LT] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3308),
  },
  [1278] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3544),
    [sym_comment] = ACTIONS(48),
  },
  [1279] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3546),
    [sym_comment] = ACTIONS(48),
  },
  [1280] = {
    [anon_sym_RBRACE] = ACTIONS(3546),
    [sym_comment] = ACTIONS(48),
  },
  [1281] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_GT_GT] = ACTIONS(2352),
    [anon_sym_AMP_GT] = ACTIONS(3314),
    [anon_sym_AMP_GT_GT] = ACTIONS(2352),
    [anon_sym_LT_AMP] = ACTIONS(2352),
    [anon_sym_GT_AMP] = ACTIONS(2352),
    [anon_sym_LT_LT] = ACTIONS(3314),
    [anon_sym_LT_LT_DASH] = ACTIONS(2352),
    [anon_sym_LT_LT_LT] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3314),
  },
  [1282] = {
    [sym_concatenation] = STATE(1720),
    [sym_string] = STATE(1719),
    [sym_simple_expansion] = STATE(1719),
    [sym_expansion] = STATE(1719),
    [sym_command_substitution] = STATE(1719),
    [sym_process_substitution] = STATE(1719),
    [anon_sym_RBRACE] = ACTIONS(3546),
    [sym__special_characters] = ACTIONS(3548),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3550),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3552),
  },
  [1283] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT] = ACTIONS(3322),
    [anon_sym_AMP_GT_GT] = ACTIONS(2397),
    [anon_sym_LT_AMP] = ACTIONS(2397),
    [anon_sym_GT_AMP] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(3322),
    [anon_sym_LT_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT_LT] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3322),
  },
  [1284] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3554),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1285] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(2403),
    [anon_sym_AMP_GT] = ACTIONS(3326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_AMP] = ACTIONS(2403),
    [anon_sym_GT_AMP] = ACTIONS(2403),
    [anon_sym_LT_LT] = ACTIONS(3326),
    [anon_sym_LT_LT_DASH] = ACTIONS(2403),
    [anon_sym_LT_LT_LT] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3326),
  },
  [1286] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3556),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1287] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3546),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1288] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(2409),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(2409),
    [anon_sym_LT_AMP] = ACTIONS(2409),
    [anon_sym_GT_AMP] = ACTIONS(2409),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_LT_LT_DASH] = ACTIONS(2409),
    [anon_sym_LT_LT_LT] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3330),
  },
  [1289] = {
    [sym_file_redirect] = STATE(1723),
    [sym_file_descriptor] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(3511),
    [anon_sym_RPAREN] = ACTIONS(3513),
    [anon_sym_PIPE_AMP] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE_PIPE] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2467),
    [anon_sym_AMP_GT] = ACTIONS(2465),
    [anon_sym_AMP_GT_GT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2467),
    [anon_sym_GT_AMP] = ACTIONS(2467),
    [sym_comment] = ACTIONS(48),
  },
  [1290] = {
    [aux_sym_concatenation_repeat1] = STATE(1294),
    [sym_file_descriptor] = ACTIONS(922),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(924),
    [anon_sym_RPAREN] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(922),
    [anon_sym_AMP_AMP] = ACTIONS(922),
    [anon_sym_PIPE_PIPE] = ACTIONS(922),
    [anon_sym_LT] = ACTIONS(924),
    [anon_sym_GT] = ACTIONS(924),
    [anon_sym_GT_GT] = ACTIONS(922),
    [anon_sym_AMP_GT] = ACTIONS(924),
    [anon_sym_AMP_GT_GT] = ACTIONS(922),
    [anon_sym_LT_AMP] = ACTIONS(922),
    [anon_sym_GT_AMP] = ACTIONS(922),
    [anon_sym_LT_LT] = ACTIONS(924),
    [anon_sym_LT_LT_DASH] = ACTIONS(922),
    [anon_sym_LT_LT_LT] = ACTIONS(922),
    [sym_comment] = ACTIONS(48),
  },
  [1291] = {
    [aux_sym_concatenation_repeat1] = STATE(1294),
    [sym_file_descriptor] = ACTIONS(926),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [anon_sym_GT] = ACTIONS(928),
    [anon_sym_GT_GT] = ACTIONS(926),
    [anon_sym_AMP_GT] = ACTIONS(928),
    [anon_sym_AMP_GT_GT] = ACTIONS(926),
    [anon_sym_LT_AMP] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(928),
    [anon_sym_LT_LT_DASH] = ACTIONS(926),
    [anon_sym_LT_LT_LT] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
  },
  [1292] = {
    [sym_file_descriptor] = ACTIONS(926),
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [anon_sym_GT] = ACTIONS(928),
    [anon_sym_GT_GT] = ACTIONS(926),
    [anon_sym_AMP_GT] = ACTIONS(928),
    [anon_sym_AMP_GT_GT] = ACTIONS(926),
    [anon_sym_LT_AMP] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(928),
    [anon_sym_LT_LT_DASH] = ACTIONS(926),
    [anon_sym_LT_LT_LT] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
  },
  [1293] = {
    [sym_string] = STATE(1724),
    [sym_simple_expansion] = STATE(1724),
    [sym_expansion] = STATE(1724),
    [sym_command_substitution] = STATE(1724),
    [sym_process_substitution] = STATE(1724),
    [sym__special_characters] = ACTIONS(3558),
    [anon_sym_DQUOTE] = ACTIONS(1548),
    [sym_raw_string] = ACTIONS(3560),
    [anon_sym_DOLLAR] = ACTIONS(1552),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1554),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1556),
    [anon_sym_BQUOTE] = ACTIONS(1558),
    [anon_sym_LT_LPAREN] = ACTIONS(1560),
    [anon_sym_GT_LPAREN] = ACTIONS(1560),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3558),
  },
  [1294] = {
    [aux_sym_concatenation_repeat1] = STATE(1725),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(2585),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_RPAREN] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_AMP_GT] = ACTIONS(1270),
    [anon_sym_AMP_GT_GT] = ACTIONS(538),
    [anon_sym_LT_AMP] = ACTIONS(538),
    [anon_sym_GT_AMP] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_LT_LT_DASH] = ACTIONS(538),
    [anon_sym_LT_LT_LT] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
  },
  [1295] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(1272),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(1272),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [anon_sym_LT_LT_LT] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [1296] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3562),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1297] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(1276),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_LT_LT_DASH] = ACTIONS(572),
    [anon_sym_LT_LT_LT] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [1298] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(1278),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_LT_LT_DASH] = ACTIONS(576),
    [anon_sym_LT_LT_LT] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [1299] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1280),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(1280),
    [anon_sym_LT_LT_DASH] = ACTIONS(580),
    [anon_sym_LT_LT_LT] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [1300] = {
    [anon_sym_EQ] = ACTIONS(3564),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1301] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1729),
    [anon_sym_RBRACE] = ACTIONS(3566),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1302] = {
    [sym_subscript] = STATE(1733),
    [sym_variable_name] = ACTIONS(3568),
    [anon_sym_DOLLAR] = ACTIONS(3570),
    [anon_sym_DASH] = ACTIONS(3570),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3572),
    [anon_sym_STAR] = ACTIONS(3570),
    [anon_sym_AT] = ACTIONS(3570),
    [anon_sym_QMARK] = ACTIONS(3570),
    [anon_sym_0] = ACTIONS(3574),
    [anon_sym__] = ACTIONS(3574),
  },
  [1303] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1735),
    [anon_sym_RBRACE] = ACTIONS(3576),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1304] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1737),
    [anon_sym_RBRACE] = ACTIONS(3578),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1305] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3580),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1306] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3580),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1307] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3580),
    [sym_comment] = ACTIONS(48),
  },
  [1308] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3580),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1309] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3582),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1310] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3582),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1311] = {
    [sym_file_descriptor] = ACTIONS(2882),
    [anon_sym_PIPE] = ACTIONS(3584),
    [anon_sym_RPAREN] = ACTIONS(2882),
    [anon_sym_PIPE_AMP] = ACTIONS(2882),
    [anon_sym_AMP_AMP] = ACTIONS(2882),
    [anon_sym_PIPE_PIPE] = ACTIONS(2882),
    [anon_sym_LT] = ACTIONS(3584),
    [anon_sym_GT] = ACTIONS(3584),
    [anon_sym_GT_GT] = ACTIONS(2882),
    [anon_sym_AMP_GT] = ACTIONS(3584),
    [anon_sym_AMP_GT_GT] = ACTIONS(2882),
    [anon_sym_LT_AMP] = ACTIONS(2882),
    [anon_sym_GT_AMP] = ACTIONS(2882),
    [anon_sym_LT_LT] = ACTIONS(3584),
    [anon_sym_LT_LT_DASH] = ACTIONS(2882),
    [anon_sym_LT_LT_LT] = ACTIONS(2882),
    [anon_sym_BQUOTE] = ACTIONS(2882),
    [sym_comment] = ACTIONS(48),
  },
  [1312] = {
    [sym_simple_expansion] = STATE(914),
    [sym_expansion] = STATE(914),
    [aux_sym_heredoc_repeat1] = STATE(1415),
    [sym__heredoc_middle] = ACTIONS(1724),
    [sym__heredoc_end] = ACTIONS(3586),
    [anon_sym_DOLLAR] = ACTIONS(1728),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1730),
    [sym_comment] = ACTIONS(48),
  },
  [1313] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(824),
    [sym_file_descriptor] = ACTIONS(696),
    [anon_sym_PIPE] = ACTIONS(3588),
    [anon_sym_RPAREN] = ACTIONS(3590),
    [anon_sym_PIPE_AMP] = ACTIONS(3590),
    [anon_sym_AMP_AMP] = ACTIONS(3590),
    [anon_sym_PIPE_PIPE] = ACTIONS(3590),
    [anon_sym_LT] = ACTIONS(702),
    [anon_sym_GT] = ACTIONS(702),
    [anon_sym_GT_GT] = ACTIONS(704),
    [anon_sym_AMP_GT] = ACTIONS(702),
    [anon_sym_AMP_GT_GT] = ACTIONS(704),
    [anon_sym_LT_AMP] = ACTIONS(704),
    [anon_sym_GT_AMP] = ACTIONS(704),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(710),
    [sym_comment] = ACTIONS(48),
  },
  [1314] = {
    [sym_string] = STATE(1741),
    [sym_simple_expansion] = STATE(1741),
    [sym_expansion] = STATE(1741),
    [sym_command_substitution] = STATE(1741),
    [sym_process_substitution] = STATE(1741),
    [sym__special_characters] = ACTIONS(3592),
    [anon_sym_DQUOTE] = ACTIONS(1586),
    [sym_raw_string] = ACTIONS(3594),
    [anon_sym_DOLLAR] = ACTIONS(1590),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1592),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1594),
    [anon_sym_BQUOTE] = ACTIONS(1596),
    [anon_sym_LT_LPAREN] = ACTIONS(1598),
    [anon_sym_GT_LPAREN] = ACTIONS(1598),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3592),
  },
  [1315] = {
    [aux_sym_concatenation_repeat1] = STATE(1742),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(2670),
    [sym_variable_name] = ACTIONS(538),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_AMP_GT] = ACTIONS(1270),
    [anon_sym_AMP_GT_GT] = ACTIONS(538),
    [anon_sym_LT_AMP] = ACTIONS(538),
    [anon_sym_GT_AMP] = ACTIONS(538),
    [sym__special_characters] = ACTIONS(1270),
    [anon_sym_DQUOTE] = ACTIONS(538),
    [sym_raw_string] = ACTIONS(538),
    [anon_sym_DOLLAR] = ACTIONS(1270),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [anon_sym_LT_LPAREN] = ACTIONS(538),
    [anon_sym_GT_LPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1270),
  },
  [1316] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [sym_variable_name] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(1272),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [sym__special_characters] = ACTIONS(1272),
    [anon_sym_DQUOTE] = ACTIONS(542),
    [sym_raw_string] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [anon_sym_LT_LPAREN] = ACTIONS(542),
    [anon_sym_GT_LPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1272),
  },
  [1317] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3596),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1318] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [sym_variable_name] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(1276),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [sym__special_characters] = ACTIONS(1276),
    [anon_sym_DQUOTE] = ACTIONS(572),
    [sym_raw_string] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [anon_sym_LT_LPAREN] = ACTIONS(572),
    [anon_sym_GT_LPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1276),
  },
  [1319] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [sym_variable_name] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(1278),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [sym__special_characters] = ACTIONS(1278),
    [anon_sym_DQUOTE] = ACTIONS(576),
    [sym_raw_string] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [anon_sym_LT_LPAREN] = ACTIONS(576),
    [anon_sym_GT_LPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1278),
  },
  [1320] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [sym_variable_name] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1280),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [sym__special_characters] = ACTIONS(1280),
    [anon_sym_DQUOTE] = ACTIONS(580),
    [sym_raw_string] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [anon_sym_LT_LPAREN] = ACTIONS(580),
    [anon_sym_GT_LPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1280),
  },
  [1321] = {
    [anon_sym_EQ] = ACTIONS(3598),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1322] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1746),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1323] = {
    [sym_subscript] = STATE(1750),
    [sym_variable_name] = ACTIONS(3602),
    [anon_sym_DOLLAR] = ACTIONS(3604),
    [anon_sym_DASH] = ACTIONS(3604),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3606),
    [anon_sym_STAR] = ACTIONS(3604),
    [anon_sym_AT] = ACTIONS(3604),
    [anon_sym_QMARK] = ACTIONS(3604),
    [anon_sym_0] = ACTIONS(3608),
    [anon_sym__] = ACTIONS(3608),
  },
  [1324] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1752),
    [anon_sym_RBRACE] = ACTIONS(3610),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1325] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1754),
    [anon_sym_RBRACE] = ACTIONS(3612),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1326] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1327] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1328] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3614),
    [sym_comment] = ACTIONS(48),
  },
  [1329] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3614),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1330] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3616),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1331] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3616),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1332] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(890),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(3465),
    [anon_sym_PIPE_AMP] = ACTIONS(3467),
    [anon_sym_AMP_AMP] = ACTIONS(3467),
    [anon_sym_PIPE_PIPE] = ACTIONS(3467),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(3467),
    [sym_comment] = ACTIONS(48),
  },
  [1333] = {
    [sym_compound_statement] = STATE(1757),
    [anon_sym_LBRACE] = ACTIONS(1472),
    [sym_comment] = ACTIONS(48),
  },
  [1334] = {
    [anon_sym_LT] = ACTIONS(3618),
    [anon_sym_GT] = ACTIONS(3618),
    [anon_sym_GT_GT] = ACTIONS(3620),
    [anon_sym_AMP_GT] = ACTIONS(3618),
    [anon_sym_AMP_GT_GT] = ACTIONS(3620),
    [anon_sym_LT_AMP] = ACTIONS(3620),
    [anon_sym_GT_AMP] = ACTIONS(3620),
    [sym_comment] = ACTIONS(48),
  },
  [1335] = {
    [sym_concatenation] = STATE(1700),
    [sym_string] = STATE(1761),
    [sym_simple_expansion] = STATE(1761),
    [sym_expansion] = STATE(1761),
    [sym_command_substitution] = STATE(1761),
    [sym_process_substitution] = STATE(1761),
    [sym__special_characters] = ACTIONS(3622),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [sym_raw_string] = ACTIONS(3626),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3630),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3632),
    [anon_sym_BQUOTE] = ACTIONS(3634),
    [anon_sym_LT_LPAREN] = ACTIONS(3636),
    [anon_sym_GT_LPAREN] = ACTIONS(3636),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3638),
  },
  [1336] = {
    [aux_sym_concatenation_repeat1] = STATE(839),
    [sym__concat] = ACTIONS(1606),
    [sym_variable_name] = ACTIONS(954),
    [anon_sym_PIPE] = ACTIONS(2419),
    [anon_sym_PIPE_AMP] = ACTIONS(954),
    [anon_sym_AMP_AMP] = ACTIONS(954),
    [anon_sym_PIPE_PIPE] = ACTIONS(954),
    [sym__special_characters] = ACTIONS(2419),
    [anon_sym_DQUOTE] = ACTIONS(954),
    [sym_raw_string] = ACTIONS(954),
    [anon_sym_DOLLAR] = ACTIONS(2419),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(954),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(954),
    [anon_sym_BQUOTE] = ACTIONS(954),
    [anon_sym_LT_LPAREN] = ACTIONS(954),
    [anon_sym_GT_LPAREN] = ACTIONS(954),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2419),
    [sym_word] = ACTIONS(958),
  },
  [1337] = {
    [aux_sym_concatenation_repeat1] = STATE(839),
    [sym__concat] = ACTIONS(1606),
    [sym_variable_name] = ACTIONS(930),
    [anon_sym_PIPE] = ACTIONS(2413),
    [anon_sym_PIPE_AMP] = ACTIONS(930),
    [anon_sym_AMP_AMP] = ACTIONS(930),
    [anon_sym_PIPE_PIPE] = ACTIONS(930),
    [sym__special_characters] = ACTIONS(2413),
    [anon_sym_DQUOTE] = ACTIONS(930),
    [sym_raw_string] = ACTIONS(930),
    [anon_sym_DOLLAR] = ACTIONS(2413),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(930),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(930),
    [anon_sym_BQUOTE] = ACTIONS(930),
    [anon_sym_LT_LPAREN] = ACTIONS(930),
    [anon_sym_GT_LPAREN] = ACTIONS(930),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2413),
    [sym_word] = ACTIONS(932),
  },
  [1338] = {
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2233),
    [sym_word] = ACTIONS(1304),
  },
  [1339] = {
    [aux_sym_concatenation_repeat1] = STATE(1339),
    [sym__concat] = ACTIONS(3640),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2233),
    [sym_word] = ACTIONS(1304),
  },
  [1340] = {
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2238),
    [sym_word] = ACTIONS(1335),
  },
  [1341] = {
    [sym_concatenation] = STATE(1770),
    [sym_string] = STATE(1769),
    [sym_simple_expansion] = STATE(1769),
    [sym_expansion] = STATE(1769),
    [sym_command_substitution] = STATE(1769),
    [sym_process_substitution] = STATE(1769),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [sym__special_characters] = ACTIONS(3645),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3647),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3649),
  },
  [1342] = {
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2248),
    [sym_word] = ACTIONS(1380),
  },
  [1343] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3651),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1344] = {
    [anon_sym_EQ] = ACTIONS(3653),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1345] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1774),
    [anon_sym_RBRACE] = ACTIONS(3655),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1346] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1776),
    [anon_sym_RBRACE] = ACTIONS(3657),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1347] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1777),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1348] = {
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2258),
    [sym_word] = ACTIONS(1424),
  },
  [1349] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3659),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1350] = {
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2262),
    [sym_word] = ACTIONS(1430),
  },
  [1351] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1352] = {
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2264),
    [sym_word] = ACTIONS(1540),
  },
  [1353] = {
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2266),
    [sym_word] = ACTIONS(1684),
  },
  [1354] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(3308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2288),
    [anon_sym_LT_LT_LT] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3308),
  },
  [1355] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3661),
    [sym_comment] = ACTIONS(48),
  },
  [1356] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(48),
  },
  [1357] = {
    [anon_sym_RBRACE] = ACTIONS(3663),
    [sym_comment] = ACTIONS(48),
  },
  [1358] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_GT_GT] = ACTIONS(2352),
    [anon_sym_AMP_GT] = ACTIONS(3314),
    [anon_sym_AMP_GT_GT] = ACTIONS(2352),
    [anon_sym_LT_AMP] = ACTIONS(2352),
    [anon_sym_GT_AMP] = ACTIONS(2352),
    [anon_sym_LT_LT] = ACTIONS(3314),
    [anon_sym_LT_LT_DASH] = ACTIONS(2352),
    [anon_sym_LT_LT_LT] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3314),
  },
  [1359] = {
    [sym_concatenation] = STATE(1783),
    [sym_string] = STATE(1782),
    [sym_simple_expansion] = STATE(1782),
    [sym_expansion] = STATE(1782),
    [sym_command_substitution] = STATE(1782),
    [sym_process_substitution] = STATE(1782),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [sym__special_characters] = ACTIONS(3665),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3667),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3669),
  },
  [1360] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT] = ACTIONS(3322),
    [anon_sym_AMP_GT_GT] = ACTIONS(2397),
    [anon_sym_LT_AMP] = ACTIONS(2397),
    [anon_sym_GT_AMP] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(3322),
    [anon_sym_LT_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT_LT] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3322),
  },
  [1361] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3671),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1362] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(2403),
    [anon_sym_AMP_GT] = ACTIONS(3326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_AMP] = ACTIONS(2403),
    [anon_sym_GT_AMP] = ACTIONS(2403),
    [anon_sym_LT_LT] = ACTIONS(3326),
    [anon_sym_LT_LT_DASH] = ACTIONS(2403),
    [anon_sym_LT_LT_LT] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3326),
  },
  [1363] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3673),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1364] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3663),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1365] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(2409),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(2409),
    [anon_sym_LT_AMP] = ACTIONS(2409),
    [anon_sym_GT_AMP] = ACTIONS(2409),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_LT_LT_DASH] = ACTIONS(2409),
    [anon_sym_LT_LT_LT] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3330),
  },
  [1366] = {
    [sym_file_redirect] = STATE(1723),
    [sym_file_descriptor] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(3511),
    [anon_sym_PIPE_AMP] = ACTIONS(3513),
    [anon_sym_AMP_AMP] = ACTIONS(3513),
    [anon_sym_PIPE_PIPE] = ACTIONS(3513),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(3513),
    [sym_comment] = ACTIONS(48),
  },
  [1367] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym_file_descriptor] = ACTIONS(922),
    [sym__concat] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(924),
    [anon_sym_PIPE_AMP] = ACTIONS(922),
    [anon_sym_AMP_AMP] = ACTIONS(922),
    [anon_sym_PIPE_PIPE] = ACTIONS(922),
    [anon_sym_LT] = ACTIONS(924),
    [anon_sym_GT] = ACTIONS(924),
    [anon_sym_GT_GT] = ACTIONS(922),
    [anon_sym_AMP_GT] = ACTIONS(924),
    [anon_sym_AMP_GT_GT] = ACTIONS(922),
    [anon_sym_LT_AMP] = ACTIONS(922),
    [anon_sym_GT_AMP] = ACTIONS(922),
    [anon_sym_LT_LT] = ACTIONS(924),
    [anon_sym_LT_LT_DASH] = ACTIONS(922),
    [anon_sym_LT_LT_LT] = ACTIONS(922),
    [anon_sym_BQUOTE] = ACTIONS(922),
    [sym_comment] = ACTIONS(48),
  },
  [1368] = {
    [aux_sym_concatenation_repeat1] = STATE(1370),
    [sym_file_descriptor] = ACTIONS(926),
    [sym__concat] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_LT] = ACTIONS(928),
    [anon_sym_GT] = ACTIONS(928),
    [anon_sym_GT_GT] = ACTIONS(926),
    [anon_sym_AMP_GT] = ACTIONS(928),
    [anon_sym_AMP_GT_GT] = ACTIONS(926),
    [anon_sym_LT_AMP] = ACTIONS(926),
    [anon_sym_GT_AMP] = ACTIONS(926),
    [anon_sym_LT_LT] = ACTIONS(928),
    [anon_sym_LT_LT_DASH] = ACTIONS(926),
    [anon_sym_LT_LT_LT] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
  },
  [1369] = {
    [sym_string] = STATE(1786),
    [sym_simple_expansion] = STATE(1786),
    [sym_expansion] = STATE(1786),
    [sym_command_substitution] = STATE(1786),
    [sym_process_substitution] = STATE(1786),
    [sym__special_characters] = ACTIONS(3675),
    [anon_sym_DQUOTE] = ACTIONS(1660),
    [sym_raw_string] = ACTIONS(3677),
    [anon_sym_DOLLAR] = ACTIONS(1664),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1666),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1668),
    [anon_sym_BQUOTE] = ACTIONS(1670),
    [anon_sym_LT_LPAREN] = ACTIONS(1672),
    [anon_sym_GT_LPAREN] = ACTIONS(1672),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3675),
  },
  [1370] = {
    [aux_sym_concatenation_repeat1] = STATE(1787),
    [sym_file_descriptor] = ACTIONS(538),
    [sym__concat] = ACTIONS(2789),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_LT] = ACTIONS(1270),
    [anon_sym_GT] = ACTIONS(1270),
    [anon_sym_GT_GT] = ACTIONS(538),
    [anon_sym_AMP_GT] = ACTIONS(1270),
    [anon_sym_AMP_GT_GT] = ACTIONS(538),
    [anon_sym_LT_AMP] = ACTIONS(538),
    [anon_sym_GT_AMP] = ACTIONS(538),
    [anon_sym_LT_LT] = ACTIONS(1270),
    [anon_sym_LT_LT_DASH] = ACTIONS(538),
    [anon_sym_LT_LT_LT] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
  },
  [1371] = {
    [sym_file_descriptor] = ACTIONS(542),
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_LT] = ACTIONS(1272),
    [anon_sym_GT] = ACTIONS(1272),
    [anon_sym_GT_GT] = ACTIONS(542),
    [anon_sym_AMP_GT] = ACTIONS(1272),
    [anon_sym_AMP_GT_GT] = ACTIONS(542),
    [anon_sym_LT_AMP] = ACTIONS(542),
    [anon_sym_GT_AMP] = ACTIONS(542),
    [anon_sym_LT_LT] = ACTIONS(1272),
    [anon_sym_LT_LT_DASH] = ACTIONS(542),
    [anon_sym_LT_LT_LT] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [1372] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3679),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1373] = {
    [sym_file_descriptor] = ACTIONS(572),
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_LT] = ACTIONS(1276),
    [anon_sym_GT] = ACTIONS(1276),
    [anon_sym_GT_GT] = ACTIONS(572),
    [anon_sym_AMP_GT] = ACTIONS(1276),
    [anon_sym_AMP_GT_GT] = ACTIONS(572),
    [anon_sym_LT_AMP] = ACTIONS(572),
    [anon_sym_GT_AMP] = ACTIONS(572),
    [anon_sym_LT_LT] = ACTIONS(1276),
    [anon_sym_LT_LT_DASH] = ACTIONS(572),
    [anon_sym_LT_LT_LT] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [1374] = {
    [sym_file_descriptor] = ACTIONS(576),
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_LT] = ACTIONS(1278),
    [anon_sym_GT] = ACTIONS(1278),
    [anon_sym_GT_GT] = ACTIONS(576),
    [anon_sym_AMP_GT] = ACTIONS(1278),
    [anon_sym_AMP_GT_GT] = ACTIONS(576),
    [anon_sym_LT_AMP] = ACTIONS(576),
    [anon_sym_GT_AMP] = ACTIONS(576),
    [anon_sym_LT_LT] = ACTIONS(1278),
    [anon_sym_LT_LT_DASH] = ACTIONS(576),
    [anon_sym_LT_LT_LT] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [1375] = {
    [sym_file_descriptor] = ACTIONS(580),
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_LT] = ACTIONS(1280),
    [anon_sym_GT] = ACTIONS(1280),
    [anon_sym_GT_GT] = ACTIONS(580),
    [anon_sym_AMP_GT] = ACTIONS(1280),
    [anon_sym_AMP_GT_GT] = ACTIONS(580),
    [anon_sym_LT_AMP] = ACTIONS(580),
    [anon_sym_GT_AMP] = ACTIONS(580),
    [anon_sym_LT_LT] = ACTIONS(1280),
    [anon_sym_LT_LT_DASH] = ACTIONS(580),
    [anon_sym_LT_LT_LT] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [1376] = {
    [anon_sym_EQ] = ACTIONS(3681),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1377] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1791),
    [anon_sym_RBRACE] = ACTIONS(3683),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1378] = {
    [sym_subscript] = STATE(1795),
    [sym_variable_name] = ACTIONS(3685),
    [anon_sym_DOLLAR] = ACTIONS(3687),
    [anon_sym_DASH] = ACTIONS(3687),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3689),
    [anon_sym_STAR] = ACTIONS(3687),
    [anon_sym_AT] = ACTIONS(3687),
    [anon_sym_QMARK] = ACTIONS(3687),
    [anon_sym_0] = ACTIONS(3691),
    [anon_sym__] = ACTIONS(3691),
  },
  [1379] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1797),
    [anon_sym_RBRACE] = ACTIONS(3693),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1380] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1799),
    [anon_sym_RBRACE] = ACTIONS(3695),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1381] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3697),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1382] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3697),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1383] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3697),
    [sym_comment] = ACTIONS(48),
  },
  [1384] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3697),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1385] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1386] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3699),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1387] = {
    [sym_file_redirect] = STATE(401),
    [sym_heredoc_redirect] = STATE(401),
    [sym_herestring_redirect] = STATE(401),
    [aux_sym_while_statement_repeat1] = STATE(890),
    [sym_file_descriptor] = ACTIONS(770),
    [anon_sym_PIPE] = ACTIONS(3588),
    [anon_sym_PIPE_AMP] = ACTIONS(3590),
    [anon_sym_AMP_AMP] = ACTIONS(3590),
    [anon_sym_PIPE_PIPE] = ACTIONS(3590),
    [anon_sym_LT] = ACTIONS(772),
    [anon_sym_GT] = ACTIONS(772),
    [anon_sym_GT_GT] = ACTIONS(774),
    [anon_sym_AMP_GT] = ACTIONS(772),
    [anon_sym_AMP_GT_GT] = ACTIONS(774),
    [anon_sym_LT_AMP] = ACTIONS(774),
    [anon_sym_GT_AMP] = ACTIONS(774),
    [anon_sym_LT_LT] = ACTIONS(706),
    [anon_sym_LT_LT_DASH] = ACTIONS(708),
    [anon_sym_LT_LT_LT] = ACTIONS(776),
    [anon_sym_BQUOTE] = ACTIONS(3590),
    [sym_comment] = ACTIONS(48),
  },
  [1388] = {
    [anon_sym_PIPE] = ACTIONS(3146),
    [anon_sym_RPAREN] = ACTIONS(3146),
    [anon_sym_SEMI_SEMI] = ACTIONS(3146),
    [anon_sym_PIPE_AMP] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_PIPE_PIPE] = ACTIONS(3146),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_LF] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3146),
  },
  [1389] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1390] = {
    [aux_sym_concatenation_repeat1] = STATE(1390),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(3701),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1391] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1335),
    [anon_sym_LT_LT_DASH] = ACTIONS(1335),
    [anon_sym_LT_LT_LT] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [1392] = {
    [sym_concatenation] = STATE(1805),
    [sym_string] = STATE(1804),
    [sym_simple_expansion] = STATE(1804),
    [sym_expansion] = STATE(1804),
    [sym_command_substitution] = STATE(1804),
    [sym_process_substitution] = STATE(1804),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [sym__special_characters] = ACTIONS(3706),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3708),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3710),
  },
  [1393] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1394] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3712),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1395] = {
    [anon_sym_EQ] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1396] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1809),
    [anon_sym_RBRACE] = ACTIONS(3716),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1397] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1811),
    [anon_sym_RBRACE] = ACTIONS(3718),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1398] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1812),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1399] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT_GT] = ACTIONS(1424),
    [anon_sym_LT_AMP] = ACTIONS(1424),
    [anon_sym_GT_AMP] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1424),
    [anon_sym_LT_LT_DASH] = ACTIONS(1424),
    [anon_sym_LT_LT_LT] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [1400] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1401] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_AMP] = ACTIONS(1430),
    [anon_sym_GT_AMP] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1430),
    [anon_sym_LT_LT_LT] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [1402] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1403] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_LT_LT_DASH] = ACTIONS(1540),
    [anon_sym_LT_LT_LT] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1404] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT_GT] = ACTIONS(1684),
    [anon_sym_LT_AMP] = ACTIONS(1684),
    [anon_sym_GT_AMP] = ACTIONS(1684),
    [anon_sym_LT_LT] = ACTIONS(1684),
    [anon_sym_LT_LT_DASH] = ACTIONS(1684),
    [anon_sym_LT_LT_LT] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [1405] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1815),
    [anon_sym_DQUOTE] = ACTIONS(3722),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1406] = {
    [sym__heredoc_middle] = ACTIONS(572),
    [sym__heredoc_end] = ACTIONS(572),
    [anon_sym_DOLLAR] = ACTIONS(1276),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [1407] = {
    [sym__heredoc_middle] = ACTIONS(576),
    [sym__heredoc_end] = ACTIONS(576),
    [anon_sym_DOLLAR] = ACTIONS(1278),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [1408] = {
    [sym__heredoc_middle] = ACTIONS(580),
    [sym__heredoc_end] = ACTIONS(580),
    [anon_sym_DOLLAR] = ACTIONS(1280),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [1409] = {
    [anon_sym_EQ] = ACTIONS(3724),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1410] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1818),
    [anon_sym_RBRACE] = ACTIONS(3726),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1411] = {
    [sym_subscript] = STATE(1822),
    [sym_variable_name] = ACTIONS(3728),
    [anon_sym_DOLLAR] = ACTIONS(3730),
    [anon_sym_DASH] = ACTIONS(3730),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3732),
    [anon_sym_STAR] = ACTIONS(3730),
    [anon_sym_AT] = ACTIONS(3730),
    [anon_sym_QMARK] = ACTIONS(3730),
    [anon_sym_0] = ACTIONS(3734),
    [anon_sym__] = ACTIONS(3734),
  },
  [1412] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1824),
    [anon_sym_RBRACE] = ACTIONS(3736),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1413] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1826),
    [anon_sym_RBRACE] = ACTIONS(3738),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1414] = {
    [sym_file_descriptor] = ACTIONS(3740),
    [anon_sym_PIPE] = ACTIONS(3742),
    [anon_sym_RPAREN] = ACTIONS(3742),
    [anon_sym_SEMI_SEMI] = ACTIONS(3742),
    [anon_sym_PIPE_AMP] = ACTIONS(3742),
    [anon_sym_AMP_AMP] = ACTIONS(3742),
    [anon_sym_PIPE_PIPE] = ACTIONS(3742),
    [anon_sym_LT] = ACTIONS(3742),
    [anon_sym_GT] = ACTIONS(3742),
    [anon_sym_GT_GT] = ACTIONS(3742),
    [anon_sym_AMP_GT] = ACTIONS(3742),
    [anon_sym_AMP_GT_GT] = ACTIONS(3742),
    [anon_sym_LT_AMP] = ACTIONS(3742),
    [anon_sym_GT_AMP] = ACTIONS(3742),
    [anon_sym_LT_LT] = ACTIONS(3742),
    [anon_sym_LT_LT_DASH] = ACTIONS(3742),
    [anon_sym_LT_LT_LT] = ACTIONS(3742),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3742),
    [anon_sym_LF] = ACTIONS(3742),
    [anon_sym_AMP] = ACTIONS(3742),
  },
  [1415] = {
    [sym_simple_expansion] = STATE(914),
    [sym_expansion] = STATE(914),
    [aux_sym_heredoc_repeat1] = STATE(1415),
    [sym__heredoc_middle] = ACTIONS(3744),
    [sym__heredoc_end] = ACTIONS(3747),
    [anon_sym_DOLLAR] = ACTIONS(3749),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3752),
    [sym_comment] = ACTIONS(48),
  },
  [1416] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [1417] = {
    [aux_sym_concatenation_repeat1] = STATE(1417),
    [sym__concat] = ACTIONS(3755),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [1418] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2238),
  },
  [1419] = {
    [sym_concatenation] = STATE(1830),
    [sym_string] = STATE(1829),
    [sym_simple_expansion] = STATE(1829),
    [sym_expansion] = STATE(1829),
    [sym_command_substitution] = STATE(1829),
    [sym_process_substitution] = STATE(1829),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [sym__special_characters] = ACTIONS(3760),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3762),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3764),
  },
  [1420] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2248),
  },
  [1421] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3766),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1422] = {
    [anon_sym_EQ] = ACTIONS(3768),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1423] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1834),
    [anon_sym_RBRACE] = ACTIONS(3770),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1424] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1836),
    [anon_sym_RBRACE] = ACTIONS(3772),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1425] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1837),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1426] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2258),
  },
  [1427] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1428] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2262),
  },
  [1429] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3758),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1430] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2264),
  },
  [1431] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2266),
  },
  [1432] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT_GT] = ACTIONS(2290),
    [anon_sym_LT_AMP] = ACTIONS(2290),
    [anon_sym_GT_AMP] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_raw_string] = ACTIONS(2290),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2290),
    [anon_sym_GT_LPAREN] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1433] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3776),
    [sym_comment] = ACTIONS(48),
  },
  [1434] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [sym_comment] = ACTIONS(48),
  },
  [1435] = {
    [anon_sym_RBRACE] = ACTIONS(3778),
    [sym_comment] = ACTIONS(48),
  },
  [1436] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2354),
    [anon_sym_GT_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT_GT] = ACTIONS(2354),
    [anon_sym_LT_AMP] = ACTIONS(2354),
    [anon_sym_GT_AMP] = ACTIONS(2354),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_raw_string] = ACTIONS(2354),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [anon_sym_LT_LPAREN] = ACTIONS(2354),
    [anon_sym_GT_LPAREN] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1437] = {
    [sym_concatenation] = STATE(1843),
    [sym_string] = STATE(1842),
    [sym_simple_expansion] = STATE(1842),
    [sym_expansion] = STATE(1842),
    [sym_command_substitution] = STATE(1842),
    [sym_process_substitution] = STATE(1842),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [sym__special_characters] = ACTIONS(3780),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3782),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3784),
  },
  [1438] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT_GT] = ACTIONS(2399),
    [anon_sym_LT_AMP] = ACTIONS(2399),
    [anon_sym_GT_AMP] = ACTIONS(2399),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym_raw_string] = ACTIONS(2399),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_LT_LPAREN] = ACTIONS(2399),
    [anon_sym_GT_LPAREN] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1439] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1440] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_GT_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT_GT] = ACTIONS(2405),
    [anon_sym_LT_AMP] = ACTIONS(2405),
    [anon_sym_GT_AMP] = ACTIONS(2405),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym_raw_string] = ACTIONS(2405),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [anon_sym_LT_LPAREN] = ACTIONS(2405),
    [anon_sym_GT_LPAREN] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1441] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3788),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1442] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3778),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1443] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_GT_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT_GT] = ACTIONS(2411),
    [anon_sym_LT_AMP] = ACTIONS(2411),
    [anon_sym_GT_AMP] = ACTIONS(2411),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_raw_string] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2411),
    [anon_sym_GT_LPAREN] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1444] = {
    [anon_sym_EQ] = ACTIONS(3790),
    [anon_sym_PLUS_EQ] = ACTIONS(3790),
    [sym_comment] = ACTIONS(48),
  },
  [1445] = {
    [anon_sym_EQ] = ACTIONS(3792),
    [anon_sym_PLUS_EQ] = ACTIONS(3792),
    [sym_comment] = ACTIONS(48),
  },
  [1446] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_RBRACK] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [1447] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3794),
    [sym_comment] = ACTIONS(48),
  },
  [1448] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [sym_comment] = ACTIONS(48),
  },
  [1449] = {
    [anon_sym_RBRACE] = ACTIONS(3796),
    [sym_comment] = ACTIONS(48),
  },
  [1450] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_RBRACK] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [1451] = {
    [sym_concatenation] = STATE(1850),
    [sym_string] = STATE(1849),
    [sym_simple_expansion] = STATE(1849),
    [sym_expansion] = STATE(1849),
    [sym_command_substitution] = STATE(1849),
    [sym_process_substitution] = STATE(1849),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [sym__special_characters] = ACTIONS(3798),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3800),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3802),
  },
  [1452] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_RBRACK] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [1453] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3804),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1454] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_RBRACK] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [1455] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3806),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1456] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3796),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1457] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_RBRACK] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [1458] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1459] = {
    [aux_sym_concatenation_repeat1] = STATE(1459),
    [sym__concat] = ACTIONS(3808),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1460] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_raw_string] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [1461] = {
    [sym_concatenation] = STATE(1856),
    [sym_string] = STATE(1855),
    [sym_simple_expansion] = STATE(1855),
    [sym_expansion] = STATE(1855),
    [sym_command_substitution] = STATE(1855),
    [sym_process_substitution] = STATE(1855),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [sym__special_characters] = ACTIONS(3813),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3815),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3817),
  },
  [1462] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1463] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3819),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1464] = {
    [anon_sym_EQ] = ACTIONS(3821),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1465] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1860),
    [anon_sym_RBRACE] = ACTIONS(3823),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1466] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1862),
    [anon_sym_RBRACE] = ACTIONS(3825),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1467] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1863),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1468] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LPAREN] = ACTIONS(1424),
    [anon_sym_GT_LPAREN] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [1469] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3827),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1470] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym_raw_string] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LPAREN] = ACTIONS(1430),
    [anon_sym_GT_LPAREN] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [1471] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3811),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1472] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1473] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LT_LPAREN] = ACTIONS(1684),
    [anon_sym_GT_LPAREN] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [1474] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1866),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(3829),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1475] = {
    [anon_sym_PIPE] = ACTIONS(3831),
    [anon_sym_RPAREN] = ACTIONS(3831),
    [anon_sym_SEMI_SEMI] = ACTIONS(3831),
    [anon_sym_PIPE_AMP] = ACTIONS(3831),
    [anon_sym_AMP_AMP] = ACTIONS(3831),
    [anon_sym_PIPE_PIPE] = ACTIONS(3831),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3831),
    [anon_sym_LF] = ACTIONS(3831),
    [anon_sym_AMP] = ACTIONS(3831),
  },
  [1476] = {
    [sym__terminated_statement] = STATE(546),
    [sym_for_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_case_statement] = STATE(547),
    [sym_function_definition] = STATE(547),
    [sym_subshell] = STATE(547),
    [sym_pipeline] = STATE(547),
    [sym_list] = STATE(547),
    [sym_command] = STATE(547),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(550),
    [sym_declaration_command] = STATE(547),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1867),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(3833),
    [anon_sym_elif] = ACTIONS(3833),
    [anon_sym_else] = ACTIONS(3833),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1477] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_fi] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [1478] = {
    [sym__terminated_statement] = STATE(1003),
    [sym_for_statement] = STATE(1004),
    [sym_while_statement] = STATE(1004),
    [sym_if_statement] = STATE(1004),
    [sym_case_statement] = STATE(1004),
    [sym_function_definition] = STATE(1004),
    [sym_subshell] = STATE(1004),
    [sym_pipeline] = STATE(1004),
    [sym_list] = STATE(1004),
    [sym_command] = STATE(1004),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1005),
    [sym_declaration_command] = STATE(1004),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1478),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_fi] = ACTIONS(3071),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [1479] = {
    [anon_sym_PIPE] = ACTIONS(3835),
    [anon_sym_RPAREN] = ACTIONS(3835),
    [anon_sym_SEMI_SEMI] = ACTIONS(3835),
    [anon_sym_PIPE_AMP] = ACTIONS(3835),
    [anon_sym_AMP_AMP] = ACTIONS(3835),
    [anon_sym_PIPE_PIPE] = ACTIONS(3835),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3835),
    [anon_sym_LF] = ACTIONS(3835),
    [anon_sym_AMP] = ACTIONS(3835),
  },
  [1480] = {
    [anon_sym_fi] = ACTIONS(3837),
    [sym_comment] = ACTIONS(48),
  },
  [1481] = {
    [sym_string] = STATE(1869),
    [sym_simple_expansion] = STATE(1869),
    [sym_expansion] = STATE(1869),
    [sym_command_substitution] = STATE(1869),
    [sym_process_substitution] = STATE(1869),
    [sym__special_characters] = ACTIONS(3839),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(3841),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3839),
  },
  [1482] = {
    [sym_concatenation] = STATE(1872),
    [sym_string] = STATE(1871),
    [sym_simple_expansion] = STATE(1871),
    [sym_expansion] = STATE(1871),
    [sym_command_substitution] = STATE(1871),
    [sym_process_substitution] = STATE(1871),
    [sym__special_characters] = ACTIONS(3843),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(3845),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3847),
  },
  [1483] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1877),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(3849),
    [anon_sym_SEMI_SEMI] = ACTIONS(3851),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1484] = {
    [aux_sym_case_item_repeat1] = STATE(1879),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3853),
    [sym_comment] = ACTIONS(48),
  },
  [1485] = {
    [aux_sym_concatenation_repeat1] = STATE(1880),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(538),
    [anon_sym_RPAREN] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
  },
  [1486] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(542),
    [anon_sym_RPAREN] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [1487] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3855),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1488] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1883),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(3857),
    [anon_sym_SEMI_SEMI] = ACTIONS(3859),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1489] = {
    [aux_sym_case_item_repeat1] = STATE(1879),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(3861),
    [sym_comment] = ACTIONS(48),
  },
  [1490] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(572),
    [anon_sym_RPAREN] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [1491] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(576),
    [anon_sym_RPAREN] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [1492] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(580),
    [anon_sym_RPAREN] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [1493] = {
    [anon_sym_EQ] = ACTIONS(3863),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1494] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1887),
    [anon_sym_RBRACE] = ACTIONS(3865),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1495] = {
    [sym_subscript] = STATE(1891),
    [sym_variable_name] = ACTIONS(3867),
    [anon_sym_DOLLAR] = ACTIONS(3869),
    [anon_sym_DASH] = ACTIONS(3869),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3871),
    [anon_sym_STAR] = ACTIONS(3869),
    [anon_sym_AT] = ACTIONS(3869),
    [anon_sym_QMARK] = ACTIONS(3869),
    [anon_sym_0] = ACTIONS(3873),
    [anon_sym__] = ACTIONS(3873),
  },
  [1496] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1893),
    [anon_sym_RBRACE] = ACTIONS(3875),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1497] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1895),
    [anon_sym_RBRACE] = ACTIONS(3877),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1498] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1499] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3879),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1500] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [sym_comment] = ACTIONS(48),
  },
  [1501] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3879),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1502] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1503] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3881),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1504] = {
    [anon_sym_PIPE] = ACTIONS(3883),
    [anon_sym_RPAREN] = ACTIONS(3883),
    [anon_sym_SEMI_SEMI] = ACTIONS(3883),
    [anon_sym_PIPE_AMP] = ACTIONS(3883),
    [anon_sym_AMP_AMP] = ACTIONS(3883),
    [anon_sym_PIPE_PIPE] = ACTIONS(3883),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3883),
    [anon_sym_LF] = ACTIONS(3883),
    [anon_sym_AMP] = ACTIONS(3883),
  },
  [1505] = {
    [anon_sym_esac] = ACTIONS(3885),
    [sym_comment] = ACTIONS(48),
  },
  [1506] = {
    [sym_case_item] = STATE(1022),
    [sym_concatenation] = STATE(1901),
    [sym_string] = STATE(1900),
    [sym_simple_expansion] = STATE(1900),
    [sym_expansion] = STATE(1900),
    [sym_command_substitution] = STATE(1900),
    [sym_process_substitution] = STATE(1900),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(3887),
    [anon_sym_DQUOTE] = ACTIONS(3890),
    [sym_raw_string] = ACTIONS(3893),
    [anon_sym_DOLLAR] = ACTIONS(3896),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3899),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3902),
    [anon_sym_BQUOTE] = ACTIONS(3905),
    [anon_sym_LT_LPAREN] = ACTIONS(3908),
    [anon_sym_GT_LPAREN] = ACTIONS(3908),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3911),
  },
  [1507] = {
    [anon_sym_PIPE] = ACTIONS(3914),
    [anon_sym_RPAREN] = ACTIONS(3914),
    [anon_sym_SEMI_SEMI] = ACTIONS(3914),
    [anon_sym_PIPE_AMP] = ACTIONS(3914),
    [anon_sym_AMP_AMP] = ACTIONS(3914),
    [anon_sym_PIPE_PIPE] = ACTIONS(3914),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3914),
    [anon_sym_LF] = ACTIONS(3914),
    [anon_sym_AMP] = ACTIONS(3914),
  },
  [1508] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1902),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [1509] = {
    [anon_sym_PIPE] = ACTIONS(3916),
    [anon_sym_RPAREN] = ACTIONS(3916),
    [anon_sym_SEMI_SEMI] = ACTIONS(3916),
    [anon_sym_PIPE_AMP] = ACTIONS(3916),
    [anon_sym_AMP_AMP] = ACTIONS(3916),
    [anon_sym_PIPE_PIPE] = ACTIONS(3916),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3916),
    [anon_sym_LF] = ACTIONS(3916),
    [anon_sym_AMP] = ACTIONS(3916),
  },
  [1510] = {
    [anon_sym_esac] = ACTIONS(3918),
    [sym_comment] = ACTIONS(48),
  },
  [1511] = {
    [anon_sym_PIPE] = ACTIONS(3920),
    [anon_sym_RPAREN] = ACTIONS(3920),
    [anon_sym_SEMI_SEMI] = ACTIONS(3920),
    [anon_sym_PIPE_AMP] = ACTIONS(3920),
    [anon_sym_AMP_AMP] = ACTIONS(3920),
    [anon_sym_PIPE_PIPE] = ACTIONS(3920),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3920),
    [anon_sym_LF] = ACTIONS(3920),
    [anon_sym_AMP] = ACTIONS(3920),
  },
  [1512] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(1904),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [1513] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [1514] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_in] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [1515] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3922),
    [sym_comment] = ACTIONS(48),
  },
  [1516] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(3924),
    [sym_comment] = ACTIONS(48),
  },
  [1517] = {
    [anon_sym_RBRACE] = ACTIONS(3924),
    [sym_comment] = ACTIONS(48),
  },
  [1518] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_in] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [1519] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_in] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [1520] = {
    [anon_sym_PIPE] = ACTIONS(3926),
    [anon_sym_RPAREN] = ACTIONS(3926),
    [anon_sym_SEMI_SEMI] = ACTIONS(3926),
    [anon_sym_PIPE_AMP] = ACTIONS(3926),
    [anon_sym_AMP_AMP] = ACTIONS(3926),
    [anon_sym_PIPE_PIPE] = ACTIONS(3926),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3926),
    [anon_sym_LF] = ACTIONS(3926),
    [anon_sym_AMP] = ACTIONS(3926),
  },
  [1521] = {
    [aux_sym_concatenation_repeat1] = STATE(1525),
    [sym__concat] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(2848),
    [anon_sym_SEMI_SEMI] = ACTIONS(2848),
    [anon_sym_PIPE_AMP] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_PIPE_PIPE] = ACTIONS(2848),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_LF] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2848),
  },
  [1522] = {
    [aux_sym_concatenation_repeat1] = STATE(1525),
    [sym__concat] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_SEMI_SEMI] = ACTIONS(2850),
    [anon_sym_PIPE_AMP] = ACTIONS(2850),
    [anon_sym_AMP_AMP] = ACTIONS(2850),
    [anon_sym_PIPE_PIPE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LF] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
  },
  [1523] = {
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_RPAREN] = ACTIONS(2850),
    [anon_sym_SEMI_SEMI] = ACTIONS(2850),
    [anon_sym_PIPE_AMP] = ACTIONS(2850),
    [anon_sym_AMP_AMP] = ACTIONS(2850),
    [anon_sym_PIPE_PIPE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LF] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
  },
  [1524] = {
    [sym_string] = STATE(1907),
    [sym_simple_expansion] = STATE(1907),
    [sym_expansion] = STATE(1907),
    [sym_command_substitution] = STATE(1907),
    [sym_process_substitution] = STATE(1907),
    [sym__special_characters] = ACTIONS(3928),
    [anon_sym_DQUOTE] = ACTIONS(2013),
    [sym_raw_string] = ACTIONS(3930),
    [anon_sym_DOLLAR] = ACTIONS(2017),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2019),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2021),
    [anon_sym_BQUOTE] = ACTIONS(2023),
    [anon_sym_LT_LPAREN] = ACTIONS(2025),
    [anon_sym_GT_LPAREN] = ACTIONS(2025),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3928),
  },
  [1525] = {
    [aux_sym_concatenation_repeat1] = STATE(1908),
    [sym__concat] = ACTIONS(3161),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [1526] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [1527] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(3932),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1528] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [1529] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [1530] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [1531] = {
    [anon_sym_EQ] = ACTIONS(3934),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1532] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1912),
    [anon_sym_RBRACE] = ACTIONS(3936),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1533] = {
    [sym_subscript] = STATE(1916),
    [sym_variable_name] = ACTIONS(3938),
    [anon_sym_DOLLAR] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3940),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3942),
    [anon_sym_STAR] = ACTIONS(3940),
    [anon_sym_AT] = ACTIONS(3940),
    [anon_sym_QMARK] = ACTIONS(3940),
    [anon_sym_0] = ACTIONS(3944),
    [anon_sym__] = ACTIONS(3944),
  },
  [1534] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1918),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1535] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1920),
    [anon_sym_RBRACE] = ACTIONS(3948),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1536] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3950),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1537] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3950),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1538] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(3950),
    [sym_comment] = ACTIONS(48),
  },
  [1539] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(3950),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1540] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3952),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1541] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(3952),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1542] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1543] = {
    [aux_sym_concatenation_repeat1] = STATE(1543),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(3954),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [sym__special_characters] = ACTIONS(1304),
    [anon_sym_DQUOTE] = ACTIONS(1304),
    [sym_raw_string] = ACTIONS(1304),
    [anon_sym_DOLLAR] = ACTIONS(1304),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1304),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1304),
    [anon_sym_BQUOTE] = ACTIONS(1304),
    [anon_sym_LT_LPAREN] = ACTIONS(1304),
    [anon_sym_GT_LPAREN] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1304),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1544] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [sym__special_characters] = ACTIONS(1335),
    [anon_sym_DQUOTE] = ACTIONS(1335),
    [sym_raw_string] = ACTIONS(1335),
    [anon_sym_DOLLAR] = ACTIONS(1335),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1335),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1335),
    [anon_sym_BQUOTE] = ACTIONS(1335),
    [anon_sym_LT_LPAREN] = ACTIONS(1335),
    [anon_sym_GT_LPAREN] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1335),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [1545] = {
    [sym_concatenation] = STATE(1926),
    [sym_string] = STATE(1925),
    [sym_simple_expansion] = STATE(1925),
    [sym_expansion] = STATE(1925),
    [sym_command_substitution] = STATE(1925),
    [sym_process_substitution] = STATE(1925),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [sym__special_characters] = ACTIONS(3959),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(3961),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3963),
  },
  [1546] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [sym__special_characters] = ACTIONS(1380),
    [anon_sym_DQUOTE] = ACTIONS(1380),
    [sym_raw_string] = ACTIONS(1380),
    [anon_sym_DOLLAR] = ACTIONS(1380),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1380),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1380),
    [anon_sym_BQUOTE] = ACTIONS(1380),
    [anon_sym_LT_LPAREN] = ACTIONS(1380),
    [anon_sym_GT_LPAREN] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1380),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1547] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3965),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1548] = {
    [anon_sym_EQ] = ACTIONS(3967),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1549] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1930),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1550] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1932),
    [anon_sym_RBRACE] = ACTIONS(3971),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1551] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1933),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1552] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT_GT] = ACTIONS(1424),
    [anon_sym_LT_AMP] = ACTIONS(1424),
    [anon_sym_GT_AMP] = ACTIONS(1424),
    [sym__special_characters] = ACTIONS(1424),
    [anon_sym_DQUOTE] = ACTIONS(1424),
    [sym_raw_string] = ACTIONS(1424),
    [anon_sym_DOLLAR] = ACTIONS(1424),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1424),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1424),
    [anon_sym_BQUOTE] = ACTIONS(1424),
    [anon_sym_LT_LPAREN] = ACTIONS(1424),
    [anon_sym_GT_LPAREN] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1424),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [1553] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3973),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1554] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_AMP] = ACTIONS(1430),
    [anon_sym_GT_AMP] = ACTIONS(1430),
    [sym__special_characters] = ACTIONS(1430),
    [anon_sym_DQUOTE] = ACTIONS(1430),
    [sym_raw_string] = ACTIONS(1430),
    [anon_sym_DOLLAR] = ACTIONS(1430),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1430),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1430),
    [anon_sym_BQUOTE] = ACTIONS(1430),
    [anon_sym_LT_LPAREN] = ACTIONS(1430),
    [anon_sym_GT_LPAREN] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1430),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [1555] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(3957),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1556] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [sym__special_characters] = ACTIONS(1540),
    [anon_sym_DQUOTE] = ACTIONS(1540),
    [sym_raw_string] = ACTIONS(1540),
    [anon_sym_DOLLAR] = ACTIONS(1540),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1540),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1540),
    [anon_sym_BQUOTE] = ACTIONS(1540),
    [anon_sym_LT_LPAREN] = ACTIONS(1540),
    [anon_sym_GT_LPAREN] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1540),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1557] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT_GT] = ACTIONS(1684),
    [anon_sym_LT_AMP] = ACTIONS(1684),
    [anon_sym_GT_AMP] = ACTIONS(1684),
    [sym__special_characters] = ACTIONS(1684),
    [anon_sym_DQUOTE] = ACTIONS(1684),
    [sym_raw_string] = ACTIONS(1684),
    [anon_sym_DOLLAR] = ACTIONS(1684),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1684),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1684),
    [anon_sym_BQUOTE] = ACTIONS(1684),
    [anon_sym_LT_LPAREN] = ACTIONS(1684),
    [anon_sym_GT_LPAREN] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(1684),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [1558] = {
    [sym_file_redirect] = STATE(1520),
    [sym_file_descriptor] = ACTIONS(2053),
    [anon_sym_PIPE] = ACTIONS(3146),
    [anon_sym_RPAREN] = ACTIONS(3146),
    [anon_sym_SEMI_SEMI] = ACTIONS(3146),
    [anon_sym_PIPE_AMP] = ACTIONS(3146),
    [anon_sym_AMP_AMP] = ACTIONS(3146),
    [anon_sym_PIPE_PIPE] = ACTIONS(3146),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_AMP_GT] = ACTIONS(2055),
    [anon_sym_AMP_GT_GT] = ACTIONS(2055),
    [anon_sym_LT_AMP] = ACTIONS(2055),
    [anon_sym_GT_AMP] = ACTIONS(2055),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3146),
    [anon_sym_LF] = ACTIONS(3146),
    [anon_sym_AMP] = ACTIONS(3146),
  },
  [1559] = {
    [sym_concatenation] = STATE(1523),
    [sym_string] = STATE(1936),
    [sym_simple_expansion] = STATE(1936),
    [sym_expansion] = STATE(1936),
    [sym_command_substitution] = STATE(1936),
    [sym_process_substitution] = STATE(1936),
    [sym__special_characters] = ACTIONS(3975),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [sym_raw_string] = ACTIONS(3977),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3221),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [anon_sym_LT_LPAREN] = ACTIONS(3225),
    [anon_sym_GT_LPAREN] = ACTIONS(3225),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3979),
  },
  [1560] = {
    [aux_sym_concatenation_repeat1] = STATE(1938),
    [sym__concat] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(1698),
    [anon_sym_RPAREN] = ACTIONS(1698),
    [anon_sym_SEMI_SEMI] = ACTIONS(1698),
    [anon_sym_PIPE_AMP] = ACTIONS(1698),
    [anon_sym_AMP_AMP] = ACTIONS(1698),
    [anon_sym_PIPE_PIPE] = ACTIONS(1698),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1698),
    [anon_sym_LF] = ACTIONS(1698),
    [anon_sym_AMP] = ACTIONS(1698),
  },
  [1561] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(1940),
    [anon_sym_DQUOTE] = ACTIONS(3983),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1562] = {
    [aux_sym_concatenation_repeat1] = STATE(1938),
    [sym__concat] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(1702),
    [anon_sym_RPAREN] = ACTIONS(1702),
    [anon_sym_SEMI_SEMI] = ACTIONS(1702),
    [anon_sym_PIPE_AMP] = ACTIONS(1702),
    [anon_sym_AMP_AMP] = ACTIONS(1702),
    [anon_sym_PIPE_PIPE] = ACTIONS(1702),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1702),
    [anon_sym_LF] = ACTIONS(1702),
    [anon_sym_AMP] = ACTIONS(1702),
  },
  [1563] = {
    [sym_string] = STATE(1943),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [anon_sym_DOLLAR] = ACTIONS(3985),
    [anon_sym_POUND] = ACTIONS(3985),
    [anon_sym_DASH] = ACTIONS(3985),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3987),
    [anon_sym_STAR] = ACTIONS(3985),
    [anon_sym_AT] = ACTIONS(3985),
    [anon_sym_QMARK] = ACTIONS(3985),
    [anon_sym_0] = ACTIONS(3989),
    [anon_sym__] = ACTIONS(3989),
  },
  [1564] = {
    [sym_subscript] = STATE(1948),
    [sym_variable_name] = ACTIONS(3991),
    [anon_sym_DOLLAR] = ACTIONS(3993),
    [anon_sym_POUND] = ACTIONS(3995),
    [anon_sym_DASH] = ACTIONS(3993),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3997),
    [anon_sym_STAR] = ACTIONS(3993),
    [anon_sym_AT] = ACTIONS(3993),
    [anon_sym_QMARK] = ACTIONS(3993),
    [anon_sym_0] = ACTIONS(3999),
    [anon_sym__] = ACTIONS(3999),
  },
  [1565] = {
    [sym_for_statement] = STATE(1949),
    [sym_while_statement] = STATE(1949),
    [sym_if_statement] = STATE(1949),
    [sym_case_statement] = STATE(1949),
    [sym_function_definition] = STATE(1949),
    [sym_subshell] = STATE(1949),
    [sym_pipeline] = STATE(1949),
    [sym_list] = STATE(1949),
    [sym_command] = STATE(1949),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1950),
    [sym_declaration_command] = STATE(1949),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1566] = {
    [sym_for_statement] = STATE(1951),
    [sym_while_statement] = STATE(1951),
    [sym_if_statement] = STATE(1951),
    [sym_case_statement] = STATE(1951),
    [sym_function_definition] = STATE(1951),
    [sym_subshell] = STATE(1951),
    [sym_pipeline] = STATE(1951),
    [sym_list] = STATE(1951),
    [sym_command] = STATE(1951),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(1952),
    [sym_declaration_command] = STATE(1951),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [1567] = {
    [sym_for_statement] = STATE(1953),
    [sym_while_statement] = STATE(1953),
    [sym_if_statement] = STATE(1953),
    [sym_case_statement] = STATE(1953),
    [sym_function_definition] = STATE(1953),
    [sym_subshell] = STATE(1953),
    [sym_pipeline] = STATE(1953),
    [sym_list] = STATE(1953),
    [sym_command] = STATE(1953),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(1954),
    [sym_declaration_command] = STATE(1953),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1568] = {
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_raw_string] = ACTIONS(2290),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2290),
    [anon_sym_GT_LPAREN] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2290),
    [sym_word] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1569] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4001),
    [sym_comment] = ACTIONS(48),
  },
  [1570] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [sym_comment] = ACTIONS(48),
  },
  [1571] = {
    [anon_sym_RBRACE] = ACTIONS(4003),
    [sym_comment] = ACTIONS(48),
  },
  [1572] = {
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_raw_string] = ACTIONS(2354),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [anon_sym_LT_LPAREN] = ACTIONS(2354),
    [anon_sym_GT_LPAREN] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2354),
    [sym_word] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1573] = {
    [sym_concatenation] = STATE(1959),
    [sym_string] = STATE(1958),
    [sym_simple_expansion] = STATE(1958),
    [sym_expansion] = STATE(1958),
    [sym_command_substitution] = STATE(1958),
    [sym_process_substitution] = STATE(1958),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [sym__special_characters] = ACTIONS(4005),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4007),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4009),
  },
  [1574] = {
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_RPAREN] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym_raw_string] = ACTIONS(2399),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_LT_LPAREN] = ACTIONS(2399),
    [anon_sym_GT_LPAREN] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2399),
    [sym_word] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1575] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4011),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1576] = {
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym_raw_string] = ACTIONS(2405),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [anon_sym_LT_LPAREN] = ACTIONS(2405),
    [anon_sym_GT_LPAREN] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2405),
    [sym_word] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1577] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4013),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1578] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4003),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1579] = {
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_raw_string] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2411),
    [anon_sym_GT_LPAREN] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2411),
    [sym_word] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1580] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT_GT] = ACTIONS(3352),
    [anon_sym_LT_AMP] = ACTIONS(3352),
    [anon_sym_GT_AMP] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_LT_LT_DASH] = ACTIONS(3352),
    [anon_sym_LT_LT_LT] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [anon_sym_LT_LPAREN] = ACTIONS(3352),
    [anon_sym_GT_LPAREN] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [1581] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT_GT] = ACTIONS(3358),
    [anon_sym_LT_AMP] = ACTIONS(3358),
    [anon_sym_GT_AMP] = ACTIONS(3358),
    [anon_sym_LT_LT] = ACTIONS(3358),
    [anon_sym_LT_LT_DASH] = ACTIONS(3358),
    [anon_sym_LT_LT_LT] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym_raw_string] = ACTIONS(3358),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [anon_sym_LT_LPAREN] = ACTIONS(3358),
    [anon_sym_GT_LPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [1582] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4015),
    [sym_comment] = ACTIONS(48),
  },
  [1583] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4017),
    [sym_comment] = ACTIONS(48),
  },
  [1584] = {
    [anon_sym_RBRACE] = ACTIONS(4017),
    [sym_comment] = ACTIONS(48),
  },
  [1585] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_AMP] = ACTIONS(3423),
    [anon_sym_GT_AMP] = ACTIONS(3423),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_LT_LT_DASH] = ACTIONS(3423),
    [anon_sym_LT_LT_LT] = ACTIONS(3423),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [1586] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_RPAREN] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_GT_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_AMP] = ACTIONS(3427),
    [anon_sym_GT_AMP] = ACTIONS(3427),
    [anon_sym_LT_LT] = ACTIONS(3427),
    [anon_sym_LT_LT_DASH] = ACTIONS(3427),
    [anon_sym_LT_LT_LT] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_raw_string] = ACTIONS(3427),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [anon_sym_LT_LPAREN] = ACTIONS(3427),
    [anon_sym_GT_LPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [1587] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1588] = {
    [aux_sym_concatenation_repeat1] = STATE(1588),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(4019),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [anon_sym_LT] = ACTIONS(1304),
    [anon_sym_GT] = ACTIONS(1304),
    [anon_sym_GT_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT] = ACTIONS(1304),
    [anon_sym_AMP_GT_GT] = ACTIONS(1304),
    [anon_sym_LT_AMP] = ACTIONS(1304),
    [anon_sym_GT_AMP] = ACTIONS(1304),
    [anon_sym_LT_LT] = ACTIONS(1304),
    [anon_sym_LT_LT_DASH] = ACTIONS(1304),
    [anon_sym_LT_LT_LT] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1589] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [anon_sym_LT] = ACTIONS(1335),
    [anon_sym_GT] = ACTIONS(1335),
    [anon_sym_GT_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT] = ACTIONS(1335),
    [anon_sym_AMP_GT_GT] = ACTIONS(1335),
    [anon_sym_LT_AMP] = ACTIONS(1335),
    [anon_sym_GT_AMP] = ACTIONS(1335),
    [anon_sym_LT_LT] = ACTIONS(1335),
    [anon_sym_LT_LT_DASH] = ACTIONS(1335),
    [anon_sym_LT_LT_LT] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [1590] = {
    [sym_concatenation] = STATE(1967),
    [sym_string] = STATE(1966),
    [sym_simple_expansion] = STATE(1966),
    [sym_expansion] = STATE(1966),
    [sym_command_substitution] = STATE(1966),
    [sym_process_substitution] = STATE(1966),
    [anon_sym_RBRACE] = ACTIONS(4022),
    [sym__special_characters] = ACTIONS(4024),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4026),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4028),
  },
  [1591] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [anon_sym_LT] = ACTIONS(1380),
    [anon_sym_GT] = ACTIONS(1380),
    [anon_sym_GT_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT] = ACTIONS(1380),
    [anon_sym_AMP_GT_GT] = ACTIONS(1380),
    [anon_sym_LT_AMP] = ACTIONS(1380),
    [anon_sym_GT_AMP] = ACTIONS(1380),
    [anon_sym_LT_LT] = ACTIONS(1380),
    [anon_sym_LT_LT_DASH] = ACTIONS(1380),
    [anon_sym_LT_LT_LT] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1592] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1593] = {
    [anon_sym_EQ] = ACTIONS(4032),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1594] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1971),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1595] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1973),
    [anon_sym_RBRACE] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1596] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1974),
    [anon_sym_RBRACE] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1597] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [anon_sym_LT] = ACTIONS(1424),
    [anon_sym_GT] = ACTIONS(1424),
    [anon_sym_GT_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT] = ACTIONS(1424),
    [anon_sym_AMP_GT_GT] = ACTIONS(1424),
    [anon_sym_LT_AMP] = ACTIONS(1424),
    [anon_sym_GT_AMP] = ACTIONS(1424),
    [anon_sym_LT_LT] = ACTIONS(1424),
    [anon_sym_LT_LT_DASH] = ACTIONS(1424),
    [anon_sym_LT_LT_LT] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [1598] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1599] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [anon_sym_LT] = ACTIONS(1430),
    [anon_sym_GT] = ACTIONS(1430),
    [anon_sym_GT_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT] = ACTIONS(1430),
    [anon_sym_AMP_GT_GT] = ACTIONS(1430),
    [anon_sym_LT_AMP] = ACTIONS(1430),
    [anon_sym_GT_AMP] = ACTIONS(1430),
    [anon_sym_LT_LT] = ACTIONS(1430),
    [anon_sym_LT_LT_DASH] = ACTIONS(1430),
    [anon_sym_LT_LT_LT] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [1600] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4022),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1601] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [anon_sym_LT] = ACTIONS(1540),
    [anon_sym_GT] = ACTIONS(1540),
    [anon_sym_GT_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT] = ACTIONS(1540),
    [anon_sym_AMP_GT_GT] = ACTIONS(1540),
    [anon_sym_LT_AMP] = ACTIONS(1540),
    [anon_sym_GT_AMP] = ACTIONS(1540),
    [anon_sym_LT_LT] = ACTIONS(1540),
    [anon_sym_LT_LT_DASH] = ACTIONS(1540),
    [anon_sym_LT_LT_LT] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1602] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [anon_sym_LT] = ACTIONS(1684),
    [anon_sym_GT] = ACTIONS(1684),
    [anon_sym_GT_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT] = ACTIONS(1684),
    [anon_sym_AMP_GT_GT] = ACTIONS(1684),
    [anon_sym_LT_AMP] = ACTIONS(1684),
    [anon_sym_GT_AMP] = ACTIONS(1684),
    [anon_sym_LT_LT] = ACTIONS(1684),
    [anon_sym_LT_LT_DASH] = ACTIONS(1684),
    [anon_sym_LT_LT_LT] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [1603] = {
    [sym_variable_name] = ACTIONS(2934),
    [anon_sym_PIPE] = ACTIONS(2936),
    [anon_sym_RPAREN] = ACTIONS(2936),
    [anon_sym_SEMI_SEMI] = ACTIONS(2936),
    [anon_sym_PIPE_AMP] = ACTIONS(2936),
    [anon_sym_AMP_AMP] = ACTIONS(2936),
    [anon_sym_PIPE_PIPE] = ACTIONS(2936),
    [sym__special_characters] = ACTIONS(2936),
    [anon_sym_DQUOTE] = ACTIONS(2936),
    [sym_raw_string] = ACTIONS(2936),
    [anon_sym_DOLLAR] = ACTIONS(2936),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2936),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2936),
    [anon_sym_BQUOTE] = ACTIONS(2936),
    [anon_sym_LT_LPAREN] = ACTIONS(2936),
    [anon_sym_GT_LPAREN] = ACTIONS(2936),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(2936),
    [sym_word] = ACTIONS(2936),
    [anon_sym_SEMI] = ACTIONS(2936),
    [anon_sym_LF] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2936),
  },
  [1604] = {
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [anon_sym_LT_LPAREN] = ACTIONS(3352),
    [anon_sym_GT_LPAREN] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3352),
    [sym_word] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [1605] = {
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym_raw_string] = ACTIONS(3358),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [anon_sym_LT_LPAREN] = ACTIONS(3358),
    [anon_sym_GT_LPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3358),
    [sym_word] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [1606] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4040),
    [sym_comment] = ACTIONS(48),
  },
  [1607] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [sym_comment] = ACTIONS(48),
  },
  [1608] = {
    [anon_sym_RBRACE] = ACTIONS(4042),
    [sym_comment] = ACTIONS(48),
  },
  [1609] = {
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3423),
    [sym_word] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [1610] = {
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_raw_string] = ACTIONS(3427),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [anon_sym_LT_LPAREN] = ACTIONS(3427),
    [anon_sym_GT_LPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3427),
    [sym_word] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [1611] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(3350),
    [anon_sym_LT_AMP] = ACTIONS(3350),
    [anon_sym_GT_AMP] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4044),
  },
  [1612] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(3356),
    [anon_sym_LT_AMP] = ACTIONS(3356),
    [anon_sym_GT_AMP] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4046),
  },
  [1613] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4048),
    [sym_comment] = ACTIONS(48),
  },
  [1614] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4050),
    [sym_comment] = ACTIONS(48),
  },
  [1615] = {
    [anon_sym_RBRACE] = ACTIONS(4050),
    [sym_comment] = ACTIONS(48),
  },
  [1616] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4052),
  },
  [1617] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT] = ACTIONS(4054),
    [anon_sym_AMP_GT_GT] = ACTIONS(3425),
    [anon_sym_LT_AMP] = ACTIONS(3425),
    [anon_sym_GT_AMP] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4054),
  },
  [1618] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym__string_content] = ACTIONS(4044),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
  },
  [1619] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym__string_content] = ACTIONS(4046),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
  },
  [1620] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4056),
    [sym_comment] = ACTIONS(48),
  },
  [1621] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4058),
    [sym_comment] = ACTIONS(48),
  },
  [1622] = {
    [anon_sym_RBRACE] = ACTIONS(4058),
    [sym_comment] = ACTIONS(48),
  },
  [1623] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym__string_content] = ACTIONS(4052),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
  },
  [1624] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym__string_content] = ACTIONS(4054),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
  },
  [1625] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1626] = {
    [aux_sym_concatenation_repeat1] = STATE(1626),
    [sym__concat] = ACTIONS(4060),
    [anon_sym_RBRACE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1627] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_RBRACE] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [1628] = {
    [sym_concatenation] = STATE(1985),
    [sym_string] = STATE(1984),
    [sym_simple_expansion] = STATE(1984),
    [sym_expansion] = STATE(1984),
    [sym_command_substitution] = STATE(1984),
    [sym_process_substitution] = STATE(1984),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [sym__special_characters] = ACTIONS(4065),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4067),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4069),
  },
  [1629] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_RBRACE] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [1630] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4071),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1631] = {
    [anon_sym_EQ] = ACTIONS(4073),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1632] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1989),
    [anon_sym_RBRACE] = ACTIONS(4075),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1633] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1991),
    [anon_sym_RBRACE] = ACTIONS(4077),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1634] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(1992),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1635] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_RBRACE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [1636] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4079),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1637] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_RBRACE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [1638] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4063),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1639] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_RBRACE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
  },
  [1640] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_RBRACE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
  },
  [1641] = {
    [sym__concat] = ACTIONS(4081),
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(4083),
    [sym__special_characters] = ACTIONS(4085),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [sym_raw_string] = ACTIONS(2988),
    [anon_sym_DOLLAR] = ACTIONS(4083),
    [anon_sym_POUND] = ACTIONS(2988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2988),
    [anon_sym_COLON] = ACTIONS(4083),
    [anon_sym_COLON_QMARK] = ACTIONS(4083),
    [anon_sym_COLON_DASH] = ACTIONS(4083),
    [anon_sym_PERCENT] = ACTIONS(4083),
    [anon_sym_SLASH] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2988),
    [anon_sym_BQUOTE] = ACTIONS(2988),
    [anon_sym_LT_LPAREN] = ACTIONS(2988),
    [anon_sym_GT_LPAREN] = ACTIONS(2988),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4085),
  },
  [1642] = {
    [anon_sym_RBRACE] = ACTIONS(2988),
    [anon_sym_EQ] = ACTIONS(4083),
    [sym__special_characters] = ACTIONS(4085),
    [anon_sym_DQUOTE] = ACTIONS(2988),
    [sym_raw_string] = ACTIONS(2988),
    [anon_sym_DOLLAR] = ACTIONS(4083),
    [anon_sym_POUND] = ACTIONS(2988),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2988),
    [anon_sym_COLON] = ACTIONS(4083),
    [anon_sym_COLON_QMARK] = ACTIONS(4083),
    [anon_sym_COLON_DASH] = ACTIONS(4083),
    [anon_sym_PERCENT] = ACTIONS(4083),
    [anon_sym_SLASH] = ACTIONS(4083),
    [anon_sym_DASH] = ACTIONS(4083),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2988),
    [anon_sym_BQUOTE] = ACTIONS(2988),
    [anon_sym_LT_LPAREN] = ACTIONS(2988),
    [anon_sym_GT_LPAREN] = ACTIONS(2988),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4085),
  },
  [1643] = {
    [sym__concat] = ACTIONS(4087),
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_EQ] = ACTIONS(4089),
    [sym__special_characters] = ACTIONS(4091),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_raw_string] = ACTIONS(2995),
    [anon_sym_DOLLAR] = ACTIONS(4089),
    [anon_sym_POUND] = ACTIONS(2995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2995),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COLON_QMARK] = ACTIONS(4089),
    [anon_sym_COLON_DASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2995),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2995),
    [anon_sym_GT_LPAREN] = ACTIONS(2995),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4091),
  },
  [1644] = {
    [anon_sym_RBRACE] = ACTIONS(2995),
    [anon_sym_EQ] = ACTIONS(4089),
    [sym__special_characters] = ACTIONS(4091),
    [anon_sym_DQUOTE] = ACTIONS(2995),
    [sym_raw_string] = ACTIONS(2995),
    [anon_sym_DOLLAR] = ACTIONS(4089),
    [anon_sym_POUND] = ACTIONS(2995),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2995),
    [anon_sym_COLON] = ACTIONS(4089),
    [anon_sym_COLON_QMARK] = ACTIONS(4089),
    [anon_sym_COLON_DASH] = ACTIONS(4089),
    [anon_sym_PERCENT] = ACTIONS(4089),
    [anon_sym_SLASH] = ACTIONS(4089),
    [anon_sym_DASH] = ACTIONS(4089),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2995),
    [anon_sym_BQUOTE] = ACTIONS(2995),
    [anon_sym_LT_LPAREN] = ACTIONS(2995),
    [anon_sym_GT_LPAREN] = ACTIONS(2995),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4091),
  },
  [1645] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [anon_sym_EQ] = ACTIONS(3308),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_POUND] = ACTIONS(2288),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_COLON] = ACTIONS(3308),
    [anon_sym_COLON_QMARK] = ACTIONS(3308),
    [anon_sym_COLON_DASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2290),
  },
  [1646] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4093),
    [sym_comment] = ACTIONS(48),
  },
  [1647] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [sym_comment] = ACTIONS(48),
  },
  [1648] = {
    [anon_sym_RBRACE] = ACTIONS(4095),
    [sym_comment] = ACTIONS(48),
  },
  [1649] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_RBRACE] = ACTIONS(2352),
    [anon_sym_EQ] = ACTIONS(3314),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_POUND] = ACTIONS(2352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_COLON] = ACTIONS(3314),
    [anon_sym_COLON_QMARK] = ACTIONS(3314),
    [anon_sym_COLON_DASH] = ACTIONS(3314),
    [anon_sym_PERCENT] = ACTIONS(3314),
    [anon_sym_SLASH] = ACTIONS(3314),
    [anon_sym_DASH] = ACTIONS(3314),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2354),
  },
  [1650] = {
    [sym_concatenation] = STATE(2000),
    [sym_string] = STATE(1999),
    [sym_simple_expansion] = STATE(1999),
    [sym_expansion] = STATE(1999),
    [sym_command_substitution] = STATE(1999),
    [sym_process_substitution] = STATE(1999),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [sym__special_characters] = ACTIONS(4097),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4099),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4101),
  },
  [1651] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [anon_sym_EQ] = ACTIONS(3322),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_POUND] = ACTIONS(2397),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_COLON] = ACTIONS(3322),
    [anon_sym_COLON_QMARK] = ACTIONS(3322),
    [anon_sym_COLON_DASH] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2399),
  },
  [1652] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4103),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1653] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [anon_sym_EQ] = ACTIONS(3326),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_POUND] = ACTIONS(2403),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_COLON] = ACTIONS(3326),
    [anon_sym_COLON_QMARK] = ACTIONS(3326),
    [anon_sym_COLON_DASH] = ACTIONS(3326),
    [anon_sym_PERCENT] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3326),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2405),
  },
  [1654] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4105),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1655] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4095),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1656] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_RBRACE] = ACTIONS(2409),
    [anon_sym_EQ] = ACTIONS(3330),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_POUND] = ACTIONS(2409),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_COLON] = ACTIONS(3330),
    [anon_sym_COLON_QMARK] = ACTIONS(3330),
    [anon_sym_COLON_DASH] = ACTIONS(3330),
    [anon_sym_PERCENT] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2411),
  },
  [1657] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_AMP] = ACTIONS(4109),
    [anon_sym_GT_AMP] = ACTIONS(4109),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_LT_LT_DASH] = ACTIONS(4109),
    [anon_sym_LT_LT_LT] = ACTIONS(4109),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_raw_string] = ACTIONS(4109),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LT_LPAREN] = ACTIONS(4109),
    [anon_sym_GT_LPAREN] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [1658] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4113),
    [anon_sym_LT_AMP] = ACTIONS(4113),
    [anon_sym_GT_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4113),
    [anon_sym_LT_LT_LT] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_raw_string] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [anon_sym_LT_LPAREN] = ACTIONS(4113),
    [anon_sym_GT_LPAREN] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1659] = {
    [sym_file_descriptor] = ACTIONS(2934),
    [sym_variable_name] = ACTIONS(2934),
    [anon_sym_PIPE] = ACTIONS(4115),
    [anon_sym_RPAREN] = ACTIONS(2934),
    [anon_sym_PIPE_AMP] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(4115),
    [anon_sym_GT] = ACTIONS(4115),
    [anon_sym_GT_GT] = ACTIONS(2934),
    [anon_sym_AMP_GT] = ACTIONS(4115),
    [anon_sym_AMP_GT_GT] = ACTIONS(2934),
    [anon_sym_LT_AMP] = ACTIONS(2934),
    [anon_sym_GT_AMP] = ACTIONS(2934),
    [sym__special_characters] = ACTIONS(4115),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [sym_raw_string] = ACTIONS(2934),
    [anon_sym_DOLLAR] = ACTIONS(4115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2934),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2934),
    [anon_sym_BQUOTE] = ACTIONS(2934),
    [anon_sym_LT_LPAREN] = ACTIONS(2934),
    [anon_sym_GT_LPAREN] = ACTIONS(2934),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4115),
  },
  [1660] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [1661] = {
    [aux_sym_concatenation_repeat1] = STATE(1661),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(4117),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [1662] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_AMP] = ACTIONS(1333),
    [anon_sym_GT_AMP] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2238),
  },
  [1663] = {
    [sym_concatenation] = STATE(2006),
    [sym_string] = STATE(2005),
    [sym_simple_expansion] = STATE(2005),
    [sym_expansion] = STATE(2005),
    [sym_command_substitution] = STATE(2005),
    [sym_process_substitution] = STATE(2005),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [sym__special_characters] = ACTIONS(4122),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4124),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4126),
  },
  [1664] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(2248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2248),
  },
  [1665] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4128),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1666] = {
    [anon_sym_EQ] = ACTIONS(4130),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1667] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2010),
    [anon_sym_RBRACE] = ACTIONS(4132),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1668] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2012),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1669] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2013),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1670] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP_GT] = ACTIONS(2258),
    [anon_sym_AMP_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_AMP] = ACTIONS(1422),
    [anon_sym_GT_AMP] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2258),
  },
  [1671] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4136),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1672] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_AMP_GT] = ACTIONS(2262),
    [anon_sym_AMP_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_AMP] = ACTIONS(1428),
    [anon_sym_GT_AMP] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2262),
  },
  [1673] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4120),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1674] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2264),
  },
  [1675] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(2266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2266),
  },
  [1676] = {
    [sym_do_group] = STATE(2016),
    [anon_sym_do] = ACTIONS(4138),
    [sym_comment] = ACTIONS(48),
  },
  [1677] = {
    [sym_file_descriptor] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_PIPE_AMP] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(4140),
    [anon_sym_GT] = ACTIONS(4140),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_AMP_GT] = ACTIONS(4140),
    [anon_sym_AMP_GT_GT] = ACTIONS(3067),
    [anon_sym_LT_AMP] = ACTIONS(3067),
    [anon_sym_GT_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(4140),
    [anon_sym_LT_LT_DASH] = ACTIONS(3067),
    [anon_sym_LT_LT_LT] = ACTIONS(3067),
    [anon_sym_BQUOTE] = ACTIONS(3067),
    [sym_comment] = ACTIONS(48),
  },
  [1678] = {
    [anon_sym_PIPE] = ACTIONS(4142),
    [anon_sym_RPAREN] = ACTIONS(4144),
    [anon_sym_PIPE_AMP] = ACTIONS(4144),
    [anon_sym_AMP_AMP] = ACTIONS(4144),
    [anon_sym_PIPE_PIPE] = ACTIONS(4144),
    [anon_sym_BQUOTE] = ACTIONS(4144),
    [sym_comment] = ACTIONS(48),
  },
  [1679] = {
    [anon_sym_fi] = ACTIONS(4146),
    [sym_comment] = ACTIONS(48),
  },
  [1680] = {
    [sym_elif_clause] = STATE(548),
    [sym_else_clause] = STATE(2018),
    [aux_sym_if_statement_repeat1] = STATE(1012),
    [anon_sym_fi] = ACTIONS(4146),
    [anon_sym_elif] = ACTIONS(1948),
    [anon_sym_else] = ACTIONS(1950),
    [sym_comment] = ACTIONS(48),
  },
  [1681] = {
    [anon_sym_PIPE] = ACTIONS(4148),
    [anon_sym_RPAREN] = ACTIONS(4150),
    [anon_sym_PIPE_AMP] = ACTIONS(4150),
    [anon_sym_AMP_AMP] = ACTIONS(4150),
    [anon_sym_PIPE_PIPE] = ACTIONS(4150),
    [anon_sym_BQUOTE] = ACTIONS(4150),
    [sym_comment] = ACTIONS(48),
  },
  [1682] = {
    [anon_sym_esac] = ACTIONS(4152),
    [sym_comment] = ACTIONS(48),
  },
  [1683] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(2020),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [1684] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(2020),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(2022),
    [anon_sym_esac] = ACTIONS(4154),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [1685] = {
    [anon_sym_PIPE] = ACTIONS(4156),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_PIPE_AMP] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_BQUOTE] = ACTIONS(4158),
    [sym_comment] = ACTIONS(48),
  },
  [1686] = {
    [anon_sym_esac] = ACTIONS(4160),
    [sym_comment] = ACTIONS(48),
  },
  [1687] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(2024),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [1688] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(2024),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(2026),
    [anon_sym_esac] = ACTIONS(4162),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(1970),
  },
  [1689] = {
    [sym_file_redirect] = STATE(2027),
    [sym_file_descriptor] = ACTIONS(2459),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_PIPE_AMP] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4166),
    [anon_sym_LT] = ACTIONS(2465),
    [anon_sym_GT] = ACTIONS(2465),
    [anon_sym_GT_GT] = ACTIONS(2467),
    [anon_sym_AMP_GT] = ACTIONS(2465),
    [anon_sym_AMP_GT_GT] = ACTIONS(2467),
    [anon_sym_LT_AMP] = ACTIONS(2467),
    [anon_sym_GT_AMP] = ACTIONS(2467),
    [sym_comment] = ACTIONS(48),
  },
  [1690] = {
    [sym_file_descriptor] = ACTIONS(3148),
    [anon_sym_PIPE] = ACTIONS(4168),
    [anon_sym_RPAREN] = ACTIONS(3148),
    [anon_sym_PIPE_AMP] = ACTIONS(3148),
    [anon_sym_AMP_AMP] = ACTIONS(3148),
    [anon_sym_PIPE_PIPE] = ACTIONS(3148),
    [anon_sym_LT] = ACTIONS(4168),
    [anon_sym_GT] = ACTIONS(4168),
    [anon_sym_GT_GT] = ACTIONS(3148),
    [anon_sym_AMP_GT] = ACTIONS(4168),
    [anon_sym_AMP_GT_GT] = ACTIONS(3148),
    [anon_sym_LT_AMP] = ACTIONS(3148),
    [anon_sym_GT_AMP] = ACTIONS(3148),
    [anon_sym_BQUOTE] = ACTIONS(3148),
    [sym_comment] = ACTIONS(48),
  },
  [1691] = {
    [sym_concatenation] = STATE(2030),
    [sym_string] = STATE(2029),
    [sym_simple_expansion] = STATE(2029),
    [sym_expansion] = STATE(2029),
    [sym_command_substitution] = STATE(2029),
    [sym_process_substitution] = STATE(2029),
    [sym__special_characters] = ACTIONS(4170),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [sym_raw_string] = ACTIONS(4172),
    [anon_sym_DOLLAR] = ACTIONS(3499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3503),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [anon_sym_LT_LPAREN] = ACTIONS(3507),
    [anon_sym_GT_LPAREN] = ACTIONS(3507),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4174),
  },
  [1692] = {
    [aux_sym_concatenation_repeat1] = STATE(2032),
    [sym__concat] = ACTIONS(4176),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_RPAREN] = ACTIONS(506),
    [anon_sym_PIPE_AMP] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [sym_comment] = ACTIONS(48),
  },
  [1693] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(2034),
    [anon_sym_DQUOTE] = ACTIONS(4178),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1694] = {
    [aux_sym_concatenation_repeat1] = STATE(2032),
    [sym__concat] = ACTIONS(4176),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_PIPE_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(514),
    [anon_sym_PIPE_PIPE] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
  },
  [1695] = {
    [sym_string] = STATE(2037),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [anon_sym_DOLLAR] = ACTIONS(4180),
    [anon_sym_POUND] = ACTIONS(4180),
    [anon_sym_DASH] = ACTIONS(4180),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4182),
    [anon_sym_STAR] = ACTIONS(4180),
    [anon_sym_AT] = ACTIONS(4180),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_0] = ACTIONS(4184),
    [anon_sym__] = ACTIONS(4184),
  },
  [1696] = {
    [sym_subscript] = STATE(2042),
    [sym_variable_name] = ACTIONS(4186),
    [anon_sym_DOLLAR] = ACTIONS(4188),
    [anon_sym_POUND] = ACTIONS(4190),
    [anon_sym_DASH] = ACTIONS(4188),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4192),
    [anon_sym_STAR] = ACTIONS(4188),
    [anon_sym_AT] = ACTIONS(4188),
    [anon_sym_QMARK] = ACTIONS(4188),
    [anon_sym_0] = ACTIONS(4194),
    [anon_sym__] = ACTIONS(4194),
  },
  [1697] = {
    [sym_for_statement] = STATE(2043),
    [sym_while_statement] = STATE(2043),
    [sym_if_statement] = STATE(2043),
    [sym_case_statement] = STATE(2043),
    [sym_function_definition] = STATE(2043),
    [sym_subshell] = STATE(2043),
    [sym_pipeline] = STATE(2043),
    [sym_list] = STATE(2043),
    [sym_command] = STATE(2043),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(2044),
    [sym_declaration_command] = STATE(2043),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1698] = {
    [sym_for_statement] = STATE(2045),
    [sym_while_statement] = STATE(2045),
    [sym_if_statement] = STATE(2045),
    [sym_case_statement] = STATE(2045),
    [sym_function_definition] = STATE(2045),
    [sym_subshell] = STATE(2045),
    [sym_pipeline] = STATE(2045),
    [sym_list] = STATE(2045),
    [sym_command] = STATE(2045),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(2046),
    [sym_declaration_command] = STATE(2045),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [1699] = {
    [sym_for_statement] = STATE(2047),
    [sym_while_statement] = STATE(2047),
    [sym_if_statement] = STATE(2047),
    [sym_case_statement] = STATE(2047),
    [sym_function_definition] = STATE(2047),
    [sym_subshell] = STATE(2047),
    [sym_pipeline] = STATE(2047),
    [sym_list] = STATE(2047),
    [sym_command] = STATE(2047),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(2048),
    [sym_declaration_command] = STATE(2047),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1700] = {
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_RPAREN] = ACTIONS(514),
    [anon_sym_PIPE_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(514),
    [anon_sym_PIPE_PIPE] = ACTIONS(514),
    [anon_sym_BQUOTE] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
  },
  [1701] = {
    [anon_sym_PIPE] = ACTIONS(4196),
    [anon_sym_RPAREN] = ACTIONS(4198),
    [anon_sym_PIPE_AMP] = ACTIONS(4198),
    [anon_sym_AMP_AMP] = ACTIONS(4198),
    [anon_sym_PIPE_PIPE] = ACTIONS(4198),
    [anon_sym_BQUOTE] = ACTIONS(4198),
    [sym_comment] = ACTIONS(48),
  },
  [1702] = {
    [sym_variable_name] = ACTIONS(1794),
    [anon_sym_PIPE] = ACTIONS(3429),
    [anon_sym_RPAREN] = ACTIONS(1794),
    [anon_sym_PIPE_AMP] = ACTIONS(1794),
    [anon_sym_AMP_AMP] = ACTIONS(1794),
    [anon_sym_PIPE_PIPE] = ACTIONS(1794),
    [sym__special_characters] = ACTIONS(3429),
    [anon_sym_DQUOTE] = ACTIONS(1794),
    [sym_raw_string] = ACTIONS(1794),
    [anon_sym_DOLLAR] = ACTIONS(3429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1794),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1794),
    [anon_sym_BQUOTE] = ACTIONS(1794),
    [anon_sym_LT_LPAREN] = ACTIONS(1794),
    [anon_sym_GT_LPAREN] = ACTIONS(1794),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3429),
    [sym_word] = ACTIONS(1796),
  },
  [1703] = {
    [sym_concatenation] = STATE(485),
    [sym_string] = STATE(479),
    [sym_simple_expansion] = STATE(479),
    [sym_expansion] = STATE(479),
    [sym_command_substitution] = STATE(479),
    [sym_process_substitution] = STATE(479),
    [aux_sym_for_statement_repeat1] = STATE(941),
    [anon_sym_RPAREN] = ACTIONS(4200),
    [sym__special_characters] = ACTIONS(936),
    [anon_sym_DQUOTE] = ACTIONS(938),
    [sym_raw_string] = ACTIONS(940),
    [anon_sym_DOLLAR] = ACTIONS(942),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(944),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(946),
    [anon_sym_BQUOTE] = ACTIONS(948),
    [anon_sym_LT_LPAREN] = ACTIONS(950),
    [anon_sym_GT_LPAREN] = ACTIONS(950),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(952),
  },
  [1704] = {
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_RPAREN] = ACTIONS(2288),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3308),
    [sym_word] = ACTIONS(2290),
  },
  [1705] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [sym_comment] = ACTIONS(48),
  },
  [1706] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [sym_comment] = ACTIONS(48),
  },
  [1707] = {
    [anon_sym_RBRACE] = ACTIONS(4204),
    [sym_comment] = ACTIONS(48),
  },
  [1708] = {
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3314),
    [sym_word] = ACTIONS(2354),
  },
  [1709] = {
    [sym_concatenation] = STATE(2054),
    [sym_string] = STATE(2053),
    [sym_simple_expansion] = STATE(2053),
    [sym_expansion] = STATE(2053),
    [sym_command_substitution] = STATE(2053),
    [sym_process_substitution] = STATE(2053),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [sym__special_characters] = ACTIONS(4206),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4208),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4210),
  },
  [1710] = {
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3322),
    [sym_word] = ACTIONS(2399),
  },
  [1711] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1712] = {
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3326),
    [sym_word] = ACTIONS(2405),
  },
  [1713] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1714] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1715] = {
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3330),
    [sym_word] = ACTIONS(2411),
  },
  [1716] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(3350),
    [anon_sym_LT_AMP] = ACTIONS(3350),
    [anon_sym_GT_AMP] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT_LT] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4044),
  },
  [1717] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(3356),
    [anon_sym_LT_AMP] = ACTIONS(3356),
    [anon_sym_GT_AMP] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT_LT] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4046),
  },
  [1718] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4216),
    [sym_comment] = ACTIONS(48),
  },
  [1719] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [sym_comment] = ACTIONS(48),
  },
  [1720] = {
    [anon_sym_RBRACE] = ACTIONS(4218),
    [sym_comment] = ACTIONS(48),
  },
  [1721] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4052),
  },
  [1722] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT] = ACTIONS(4054),
    [anon_sym_AMP_GT_GT] = ACTIONS(3425),
    [anon_sym_LT_AMP] = ACTIONS(3425),
    [anon_sym_GT_AMP] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_LT_LT_DASH] = ACTIONS(3425),
    [anon_sym_LT_LT_LT] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4054),
  },
  [1723] = {
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4166),
    [anon_sym_PIPE_AMP] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4166),
    [anon_sym_BQUOTE] = ACTIONS(4166),
    [sym_comment] = ACTIONS(48),
  },
  [1724] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1725] = {
    [aux_sym_concatenation_repeat1] = STATE(1725),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(4220),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1726] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_AMP] = ACTIONS(1333),
    [anon_sym_GT_AMP] = ACTIONS(1333),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_LT] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [1727] = {
    [sym_concatenation] = STATE(2062),
    [sym_string] = STATE(2061),
    [sym_simple_expansion] = STATE(2061),
    [sym_expansion] = STATE(2061),
    [sym_command_substitution] = STATE(2061),
    [sym_process_substitution] = STATE(2061),
    [anon_sym_RBRACE] = ACTIONS(4223),
    [sym__special_characters] = ACTIONS(4225),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4227),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4229),
  },
  [1728] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(2248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [1729] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4231),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1730] = {
    [anon_sym_EQ] = ACTIONS(4233),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1731] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2066),
    [anon_sym_RBRACE] = ACTIONS(4235),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1732] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2068),
    [anon_sym_RBRACE] = ACTIONS(4237),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1733] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2069),
    [anon_sym_RBRACE] = ACTIONS(4223),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1734] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP_GT] = ACTIONS(2258),
    [anon_sym_AMP_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_AMP] = ACTIONS(1422),
    [anon_sym_GT_AMP] = ACTIONS(1422),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_LT_LT_DASH] = ACTIONS(1422),
    [anon_sym_LT_LT_LT] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [1735] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4239),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1736] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_AMP_GT] = ACTIONS(2262),
    [anon_sym_AMP_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_AMP] = ACTIONS(1428),
    [anon_sym_GT_AMP] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_LT_LT_DASH] = ACTIONS(1428),
    [anon_sym_LT_LT_LT] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [1737] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4223),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1738] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_LT_LT_LT] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
  },
  [1739] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(2266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_LT_LT_DASH] = ACTIONS(1682),
    [anon_sym_LT_LT_LT] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
  },
  [1740] = {
    [sym_file_descriptor] = ACTIONS(3740),
    [anon_sym_PIPE] = ACTIONS(4241),
    [anon_sym_RPAREN] = ACTIONS(3740),
    [anon_sym_PIPE_AMP] = ACTIONS(3740),
    [anon_sym_AMP_AMP] = ACTIONS(3740),
    [anon_sym_PIPE_PIPE] = ACTIONS(3740),
    [anon_sym_LT] = ACTIONS(4241),
    [anon_sym_GT] = ACTIONS(4241),
    [anon_sym_GT_GT] = ACTIONS(3740),
    [anon_sym_AMP_GT] = ACTIONS(4241),
    [anon_sym_AMP_GT_GT] = ACTIONS(3740),
    [anon_sym_LT_AMP] = ACTIONS(3740),
    [anon_sym_GT_AMP] = ACTIONS(3740),
    [anon_sym_LT_LT] = ACTIONS(4241),
    [anon_sym_LT_LT_DASH] = ACTIONS(3740),
    [anon_sym_LT_LT_LT] = ACTIONS(3740),
    [anon_sym_BQUOTE] = ACTIONS(3740),
    [sym_comment] = ACTIONS(48),
  },
  [1741] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [1742] = {
    [aux_sym_concatenation_repeat1] = STATE(1742),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(4243),
    [sym_variable_name] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [sym__special_characters] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(1302),
    [sym_raw_string] = ACTIONS(1302),
    [anon_sym_DOLLAR] = ACTIONS(2233),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1302),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [anon_sym_LT_LPAREN] = ACTIONS(1302),
    [anon_sym_GT_LPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2233),
  },
  [1743] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [sym_variable_name] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_AMP] = ACTIONS(1333),
    [anon_sym_GT_AMP] = ACTIONS(1333),
    [sym__special_characters] = ACTIONS(2238),
    [anon_sym_DQUOTE] = ACTIONS(1333),
    [sym_raw_string] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [anon_sym_LT_LPAREN] = ACTIONS(1333),
    [anon_sym_GT_LPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2238),
  },
  [1744] = {
    [sym_concatenation] = STATE(2074),
    [sym_string] = STATE(2073),
    [sym_simple_expansion] = STATE(2073),
    [sym_expansion] = STATE(2073),
    [sym_command_substitution] = STATE(2073),
    [sym_process_substitution] = STATE(2073),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [sym__special_characters] = ACTIONS(4248),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4250),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4252),
  },
  [1745] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [sym_variable_name] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(2248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [sym__special_characters] = ACTIONS(2248),
    [anon_sym_DQUOTE] = ACTIONS(1378),
    [sym_raw_string] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [anon_sym_LT_LPAREN] = ACTIONS(1378),
    [anon_sym_GT_LPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2248),
  },
  [1746] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4254),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1747] = {
    [anon_sym_EQ] = ACTIONS(4256),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1748] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2078),
    [anon_sym_RBRACE] = ACTIONS(4258),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1749] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2080),
    [anon_sym_RBRACE] = ACTIONS(4260),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1750] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2081),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1751] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [sym_variable_name] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP_GT] = ACTIONS(2258),
    [anon_sym_AMP_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_AMP] = ACTIONS(1422),
    [anon_sym_GT_AMP] = ACTIONS(1422),
    [sym__special_characters] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(1422),
    [sym_raw_string] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [anon_sym_LT_LPAREN] = ACTIONS(1422),
    [anon_sym_GT_LPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2258),
  },
  [1752] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1753] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [sym_variable_name] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_AMP_GT] = ACTIONS(2262),
    [anon_sym_AMP_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_AMP] = ACTIONS(1428),
    [anon_sym_GT_AMP] = ACTIONS(1428),
    [sym__special_characters] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(1428),
    [sym_raw_string] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [anon_sym_LT_LPAREN] = ACTIONS(1428),
    [anon_sym_GT_LPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2262),
  },
  [1754] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1755] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [sym_variable_name] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [sym__special_characters] = ACTIONS(2264),
    [anon_sym_DQUOTE] = ACTIONS(1538),
    [sym_raw_string] = ACTIONS(1538),
    [anon_sym_DOLLAR] = ACTIONS(2264),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1538),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [anon_sym_LT_LPAREN] = ACTIONS(1538),
    [anon_sym_GT_LPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2264),
  },
  [1756] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [sym_variable_name] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(2266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [sym__special_characters] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(1682),
    [sym_raw_string] = ACTIONS(1682),
    [anon_sym_DOLLAR] = ACTIONS(2266),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1682),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [anon_sym_LT_LPAREN] = ACTIONS(1682),
    [anon_sym_GT_LPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(2266),
  },
  [1757] = {
    [sym_file_redirect] = STATE(2027),
    [sym_file_descriptor] = ACTIONS(2692),
    [anon_sym_PIPE] = ACTIONS(4164),
    [anon_sym_PIPE_AMP] = ACTIONS(4166),
    [anon_sym_AMP_AMP] = ACTIONS(4166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4166),
    [anon_sym_LT] = ACTIONS(2694),
    [anon_sym_GT] = ACTIONS(2694),
    [anon_sym_GT_GT] = ACTIONS(2696),
    [anon_sym_AMP_GT] = ACTIONS(2694),
    [anon_sym_AMP_GT_GT] = ACTIONS(2696),
    [anon_sym_LT_AMP] = ACTIONS(2696),
    [anon_sym_GT_AMP] = ACTIONS(2696),
    [anon_sym_BQUOTE] = ACTIONS(4166),
    [sym_comment] = ACTIONS(48),
  },
  [1758] = {
    [sym_concatenation] = STATE(2030),
    [sym_string] = STATE(2084),
    [sym_simple_expansion] = STATE(2084),
    [sym_expansion] = STATE(2084),
    [sym_command_substitution] = STATE(2084),
    [sym_process_substitution] = STATE(2084),
    [sym__special_characters] = ACTIONS(4264),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [sym_raw_string] = ACTIONS(4266),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3630),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3632),
    [anon_sym_BQUOTE] = ACTIONS(3634),
    [anon_sym_LT_LPAREN] = ACTIONS(3636),
    [anon_sym_GT_LPAREN] = ACTIONS(3636),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4268),
  },
  [1759] = {
    [aux_sym_concatenation_repeat1] = STATE(2086),
    [sym__concat] = ACTIONS(4270),
    [anon_sym_PIPE] = ACTIONS(510),
    [anon_sym_PIPE_AMP] = ACTIONS(506),
    [anon_sym_AMP_AMP] = ACTIONS(506),
    [anon_sym_PIPE_PIPE] = ACTIONS(506),
    [anon_sym_BQUOTE] = ACTIONS(506),
    [sym_comment] = ACTIONS(48),
  },
  [1760] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(2088),
    [anon_sym_DQUOTE] = ACTIONS(4272),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1761] = {
    [aux_sym_concatenation_repeat1] = STATE(2086),
    [sym__concat] = ACTIONS(4270),
    [anon_sym_PIPE] = ACTIONS(516),
    [anon_sym_PIPE_AMP] = ACTIONS(514),
    [anon_sym_AMP_AMP] = ACTIONS(514),
    [anon_sym_PIPE_PIPE] = ACTIONS(514),
    [anon_sym_BQUOTE] = ACTIONS(514),
    [sym_comment] = ACTIONS(48),
  },
  [1762] = {
    [sym_string] = STATE(2091),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [anon_sym_DOLLAR] = ACTIONS(4274),
    [anon_sym_POUND] = ACTIONS(4274),
    [anon_sym_DASH] = ACTIONS(4274),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4276),
    [anon_sym_STAR] = ACTIONS(4274),
    [anon_sym_AT] = ACTIONS(4274),
    [anon_sym_QMARK] = ACTIONS(4274),
    [anon_sym_0] = ACTIONS(4278),
    [anon_sym__] = ACTIONS(4278),
  },
  [1763] = {
    [sym_subscript] = STATE(2096),
    [sym_variable_name] = ACTIONS(4280),
    [anon_sym_DOLLAR] = ACTIONS(4282),
    [anon_sym_POUND] = ACTIONS(4284),
    [anon_sym_DASH] = ACTIONS(4282),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4286),
    [anon_sym_STAR] = ACTIONS(4282),
    [anon_sym_AT] = ACTIONS(4282),
    [anon_sym_QMARK] = ACTIONS(4282),
    [anon_sym_0] = ACTIONS(4288),
    [anon_sym__] = ACTIONS(4288),
  },
  [1764] = {
    [sym_for_statement] = STATE(2097),
    [sym_while_statement] = STATE(2097),
    [sym_if_statement] = STATE(2097),
    [sym_case_statement] = STATE(2097),
    [sym_function_definition] = STATE(2097),
    [sym_subshell] = STATE(2097),
    [sym_pipeline] = STATE(2097),
    [sym_list] = STATE(2097),
    [sym_command] = STATE(2097),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(2098),
    [sym_declaration_command] = STATE(2097),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1765] = {
    [sym_for_statement] = STATE(2099),
    [sym_while_statement] = STATE(2099),
    [sym_if_statement] = STATE(2099),
    [sym_case_statement] = STATE(2099),
    [sym_function_definition] = STATE(2099),
    [sym_subshell] = STATE(2099),
    [sym_pipeline] = STATE(2099),
    [sym_list] = STATE(2099),
    [sym_command] = STATE(2099),
    [sym_command_name] = STATE(145),
    [sym_variable_assignment] = STATE(2100),
    [sym_declaration_command] = STATE(2099),
    [sym_subscript] = STATE(147),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(137),
    [sym_simple_expansion] = STATE(137),
    [sym_expansion] = STATE(137),
    [sym_command_substitution] = STATE(137),
    [sym_process_substitution] = STATE(137),
    [aux_sym_command_repeat1] = STATE(148),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(222),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(224),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(226),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(228),
    [anon_sym_typeset] = ACTIONS(228),
    [anon_sym_export] = ACTIONS(228),
    [anon_sym_readonly] = ACTIONS(228),
    [anon_sym_local] = ACTIONS(228),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(230),
    [anon_sym_DQUOTE] = ACTIONS(232),
    [sym_raw_string] = ACTIONS(234),
    [anon_sym_DOLLAR] = ACTIONS(236),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(238),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(240),
    [anon_sym_BQUOTE] = ACTIONS(242),
    [anon_sym_LT_LPAREN] = ACTIONS(244),
    [anon_sym_GT_LPAREN] = ACTIONS(244),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(246),
  },
  [1766] = {
    [sym_for_statement] = STATE(2101),
    [sym_while_statement] = STATE(2101),
    [sym_if_statement] = STATE(2101),
    [sym_case_statement] = STATE(2101),
    [sym_function_definition] = STATE(2101),
    [sym_subshell] = STATE(2101),
    [sym_pipeline] = STATE(2101),
    [sym_list] = STATE(2101),
    [sym_command] = STATE(2101),
    [sym_command_name] = STATE(126),
    [sym_variable_assignment] = STATE(2102),
    [sym_declaration_command] = STATE(2101),
    [sym_subscript] = STATE(128),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(129),
    [sym_string] = STATE(118),
    [sym_simple_expansion] = STATE(118),
    [sym_expansion] = STATE(118),
    [sym_command_substitution] = STATE(118),
    [sym_process_substitution] = STATE(118),
    [aux_sym_command_repeat1] = STATE(130),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(188),
    [anon_sym_for] = ACTIONS(190),
    [anon_sym_while] = ACTIONS(192),
    [anon_sym_if] = ACTIONS(194),
    [anon_sym_case] = ACTIONS(196),
    [anon_sym_function] = ACTIONS(198),
    [anon_sym_LPAREN] = ACTIONS(200),
    [anon_sym_declare] = ACTIONS(202),
    [anon_sym_typeset] = ACTIONS(202),
    [anon_sym_export] = ACTIONS(202),
    [anon_sym_readonly] = ACTIONS(202),
    [anon_sym_local] = ACTIONS(202),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(204),
    [anon_sym_DQUOTE] = ACTIONS(206),
    [sym_raw_string] = ACTIONS(208),
    [anon_sym_DOLLAR] = ACTIONS(210),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(212),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(214),
    [anon_sym_BQUOTE] = ACTIONS(216),
    [anon_sym_LT_LPAREN] = ACTIONS(218),
    [anon_sym_GT_LPAREN] = ACTIONS(218),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(220),
  },
  [1767] = {
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3308),
    [sym_word] = ACTIONS(2290),
  },
  [1768] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4290),
    [sym_comment] = ACTIONS(48),
  },
  [1769] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [sym_comment] = ACTIONS(48),
  },
  [1770] = {
    [anon_sym_RBRACE] = ACTIONS(4292),
    [sym_comment] = ACTIONS(48),
  },
  [1771] = {
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3314),
    [sym_word] = ACTIONS(2354),
  },
  [1772] = {
    [sym_concatenation] = STATE(2107),
    [sym_string] = STATE(2106),
    [sym_simple_expansion] = STATE(2106),
    [sym_expansion] = STATE(2106),
    [sym_command_substitution] = STATE(2106),
    [sym_process_substitution] = STATE(2106),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [sym__special_characters] = ACTIONS(4294),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4296),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4298),
  },
  [1773] = {
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3322),
    [sym_word] = ACTIONS(2399),
  },
  [1774] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4300),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1775] = {
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3326),
    [sym_word] = ACTIONS(2405),
  },
  [1776] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4302),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1777] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4292),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1778] = {
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3330),
    [sym_word] = ACTIONS(2411),
  },
  [1779] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(3350),
    [anon_sym_LT_AMP] = ACTIONS(3350),
    [anon_sym_GT_AMP] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT_LT] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4044),
  },
  [1780] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(3356),
    [anon_sym_LT_AMP] = ACTIONS(3356),
    [anon_sym_GT_AMP] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT_LT] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4046),
  },
  [1781] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4304),
    [sym_comment] = ACTIONS(48),
  },
  [1782] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4306),
    [sym_comment] = ACTIONS(48),
  },
  [1783] = {
    [anon_sym_RBRACE] = ACTIONS(4306),
    [sym_comment] = ACTIONS(48),
  },
  [1784] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4052),
  },
  [1785] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT] = ACTIONS(4054),
    [anon_sym_AMP_GT_GT] = ACTIONS(3425),
    [anon_sym_LT_AMP] = ACTIONS(3425),
    [anon_sym_GT_AMP] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_LT_LT_DASH] = ACTIONS(3425),
    [anon_sym_LT_LT_LT] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4054),
  },
  [1786] = {
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1787] = {
    [aux_sym_concatenation_repeat1] = STATE(1787),
    [sym_file_descriptor] = ACTIONS(1302),
    [sym__concat] = ACTIONS(4308),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_GT] = ACTIONS(1302),
    [anon_sym_AMP_GT] = ACTIONS(2233),
    [anon_sym_AMP_GT_GT] = ACTIONS(1302),
    [anon_sym_LT_AMP] = ACTIONS(1302),
    [anon_sym_GT_AMP] = ACTIONS(1302),
    [anon_sym_LT_LT] = ACTIONS(2233),
    [anon_sym_LT_LT_DASH] = ACTIONS(1302),
    [anon_sym_LT_LT_LT] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1788] = {
    [sym_file_descriptor] = ACTIONS(1333),
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_LT] = ACTIONS(2238),
    [anon_sym_GT] = ACTIONS(2238),
    [anon_sym_GT_GT] = ACTIONS(1333),
    [anon_sym_AMP_GT] = ACTIONS(2238),
    [anon_sym_AMP_GT_GT] = ACTIONS(1333),
    [anon_sym_LT_AMP] = ACTIONS(1333),
    [anon_sym_GT_AMP] = ACTIONS(1333),
    [anon_sym_LT_LT] = ACTIONS(2238),
    [anon_sym_LT_LT_DASH] = ACTIONS(1333),
    [anon_sym_LT_LT_LT] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [1789] = {
    [sym_concatenation] = STATE(2115),
    [sym_string] = STATE(2114),
    [sym_simple_expansion] = STATE(2114),
    [sym_expansion] = STATE(2114),
    [sym_command_substitution] = STATE(2114),
    [sym_process_substitution] = STATE(2114),
    [anon_sym_RBRACE] = ACTIONS(4311),
    [sym__special_characters] = ACTIONS(4313),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4315),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4317),
  },
  [1790] = {
    [sym_file_descriptor] = ACTIONS(1378),
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_LT] = ACTIONS(2248),
    [anon_sym_GT] = ACTIONS(2248),
    [anon_sym_GT_GT] = ACTIONS(1378),
    [anon_sym_AMP_GT] = ACTIONS(2248),
    [anon_sym_AMP_GT_GT] = ACTIONS(1378),
    [anon_sym_LT_AMP] = ACTIONS(1378),
    [anon_sym_GT_AMP] = ACTIONS(1378),
    [anon_sym_LT_LT] = ACTIONS(2248),
    [anon_sym_LT_LT_DASH] = ACTIONS(1378),
    [anon_sym_LT_LT_LT] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [1791] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4319),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1792] = {
    [anon_sym_EQ] = ACTIONS(4321),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1793] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2119),
    [anon_sym_RBRACE] = ACTIONS(4323),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1794] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2121),
    [anon_sym_RBRACE] = ACTIONS(4325),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1795] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2122),
    [anon_sym_RBRACE] = ACTIONS(4311),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1796] = {
    [sym_file_descriptor] = ACTIONS(1422),
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_LT] = ACTIONS(2258),
    [anon_sym_GT] = ACTIONS(2258),
    [anon_sym_GT_GT] = ACTIONS(1422),
    [anon_sym_AMP_GT] = ACTIONS(2258),
    [anon_sym_AMP_GT_GT] = ACTIONS(1422),
    [anon_sym_LT_AMP] = ACTIONS(1422),
    [anon_sym_GT_AMP] = ACTIONS(1422),
    [anon_sym_LT_LT] = ACTIONS(2258),
    [anon_sym_LT_LT_DASH] = ACTIONS(1422),
    [anon_sym_LT_LT_LT] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [1797] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4327),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1798] = {
    [sym_file_descriptor] = ACTIONS(1428),
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_LT] = ACTIONS(2262),
    [anon_sym_GT] = ACTIONS(2262),
    [anon_sym_GT_GT] = ACTIONS(1428),
    [anon_sym_AMP_GT] = ACTIONS(2262),
    [anon_sym_AMP_GT_GT] = ACTIONS(1428),
    [anon_sym_LT_AMP] = ACTIONS(1428),
    [anon_sym_GT_AMP] = ACTIONS(1428),
    [anon_sym_LT_LT] = ACTIONS(2262),
    [anon_sym_LT_LT_DASH] = ACTIONS(1428),
    [anon_sym_LT_LT_LT] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [1799] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4311),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1800] = {
    [sym_file_descriptor] = ACTIONS(1538),
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_LT] = ACTIONS(2264),
    [anon_sym_GT] = ACTIONS(2264),
    [anon_sym_GT_GT] = ACTIONS(1538),
    [anon_sym_AMP_GT] = ACTIONS(2264),
    [anon_sym_AMP_GT_GT] = ACTIONS(1538),
    [anon_sym_LT_AMP] = ACTIONS(1538),
    [anon_sym_GT_AMP] = ACTIONS(1538),
    [anon_sym_LT_LT] = ACTIONS(2264),
    [anon_sym_LT_LT_DASH] = ACTIONS(1538),
    [anon_sym_LT_LT_LT] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
  },
  [1801] = {
    [sym_file_descriptor] = ACTIONS(1682),
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(2266),
    [anon_sym_GT] = ACTIONS(2266),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_AMP_GT] = ACTIONS(2266),
    [anon_sym_AMP_GT_GT] = ACTIONS(1682),
    [anon_sym_LT_AMP] = ACTIONS(1682),
    [anon_sym_GT_AMP] = ACTIONS(1682),
    [anon_sym_LT_LT] = ACTIONS(2266),
    [anon_sym_LT_LT_DASH] = ACTIONS(1682),
    [anon_sym_LT_LT_LT] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
  },
  [1802] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT_GT] = ACTIONS(2290),
    [anon_sym_LT_AMP] = ACTIONS(2290),
    [anon_sym_GT_AMP] = ACTIONS(2290),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_LT_LT_DASH] = ACTIONS(2290),
    [anon_sym_LT_LT_LT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1803] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4329),
    [sym_comment] = ACTIONS(48),
  },
  [1804] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [sym_comment] = ACTIONS(48),
  },
  [1805] = {
    [anon_sym_RBRACE] = ACTIONS(4331),
    [sym_comment] = ACTIONS(48),
  },
  [1806] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2354),
    [anon_sym_GT_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT_GT] = ACTIONS(2354),
    [anon_sym_LT_AMP] = ACTIONS(2354),
    [anon_sym_GT_AMP] = ACTIONS(2354),
    [anon_sym_LT_LT] = ACTIONS(2354),
    [anon_sym_LT_LT_DASH] = ACTIONS(2354),
    [anon_sym_LT_LT_LT] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1807] = {
    [sym_concatenation] = STATE(2128),
    [sym_string] = STATE(2127),
    [sym_simple_expansion] = STATE(2127),
    [sym_expansion] = STATE(2127),
    [sym_command_substitution] = STATE(2127),
    [sym_process_substitution] = STATE(2127),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [sym__special_characters] = ACTIONS(4333),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4335),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4337),
  },
  [1808] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT_GT] = ACTIONS(2399),
    [anon_sym_LT_AMP] = ACTIONS(2399),
    [anon_sym_GT_AMP] = ACTIONS(2399),
    [anon_sym_LT_LT] = ACTIONS(2399),
    [anon_sym_LT_LT_DASH] = ACTIONS(2399),
    [anon_sym_LT_LT_LT] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1809] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4339),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1810] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_GT_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT_GT] = ACTIONS(2405),
    [anon_sym_LT_AMP] = ACTIONS(2405),
    [anon_sym_GT_AMP] = ACTIONS(2405),
    [anon_sym_LT_LT] = ACTIONS(2405),
    [anon_sym_LT_LT_DASH] = ACTIONS(2405),
    [anon_sym_LT_LT_LT] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1811] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4341),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1812] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4331),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1813] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_GT_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT_GT] = ACTIONS(2411),
    [anon_sym_LT_AMP] = ACTIONS(2411),
    [anon_sym_GT_AMP] = ACTIONS(2411),
    [anon_sym_LT_LT] = ACTIONS(2411),
    [anon_sym_LT_LT_DASH] = ACTIONS(2411),
    [anon_sym_LT_LT_LT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1814] = {
    [sym__heredoc_middle] = ACTIONS(542),
    [sym__heredoc_end] = ACTIONS(542),
    [anon_sym_DOLLAR] = ACTIONS(1272),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [1815] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(4343),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1816] = {
    [sym_concatenation] = STATE(2135),
    [sym_string] = STATE(2134),
    [sym_simple_expansion] = STATE(2134),
    [sym_expansion] = STATE(2134),
    [sym_command_substitution] = STATE(2134),
    [sym_process_substitution] = STATE(2134),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [sym__special_characters] = ACTIONS(4347),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4349),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4351),
  },
  [1817] = {
    [sym__heredoc_middle] = ACTIONS(1378),
    [sym__heredoc_end] = ACTIONS(1378),
    [anon_sym_DOLLAR] = ACTIONS(2248),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [1818] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4353),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1819] = {
    [anon_sym_EQ] = ACTIONS(4355),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1820] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2139),
    [anon_sym_RBRACE] = ACTIONS(4357),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1821] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2141),
    [anon_sym_RBRACE] = ACTIONS(4359),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1822] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2142),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1823] = {
    [sym__heredoc_middle] = ACTIONS(1422),
    [sym__heredoc_end] = ACTIONS(1422),
    [anon_sym_DOLLAR] = ACTIONS(2258),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [1824] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4361),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1825] = {
    [sym__heredoc_middle] = ACTIONS(1428),
    [sym__heredoc_end] = ACTIONS(1428),
    [anon_sym_DOLLAR] = ACTIONS(2262),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [1826] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4345),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1827] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_RPAREN] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3308),
  },
  [1828] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4363),
    [sym_comment] = ACTIONS(48),
  },
  [1829] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4365),
    [sym_comment] = ACTIONS(48),
  },
  [1830] = {
    [anon_sym_RBRACE] = ACTIONS(4365),
    [sym_comment] = ACTIONS(48),
  },
  [1831] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3314),
  },
  [1832] = {
    [sym_concatenation] = STATE(2148),
    [sym_string] = STATE(2147),
    [sym_simple_expansion] = STATE(2147),
    [sym_expansion] = STATE(2147),
    [sym_command_substitution] = STATE(2147),
    [sym_process_substitution] = STATE(2147),
    [anon_sym_RBRACE] = ACTIONS(4365),
    [sym__special_characters] = ACTIONS(4367),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4369),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4371),
  },
  [1833] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3322),
  },
  [1834] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4373),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1835] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3326),
  },
  [1836] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4375),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1837] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4365),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1838] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3330),
  },
  [1839] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT_GT] = ACTIONS(3352),
    [anon_sym_LT_AMP] = ACTIONS(3352),
    [anon_sym_GT_AMP] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [anon_sym_LT_LPAREN] = ACTIONS(3352),
    [anon_sym_GT_LPAREN] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [1840] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT_GT] = ACTIONS(3358),
    [anon_sym_LT_AMP] = ACTIONS(3358),
    [anon_sym_GT_AMP] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym_raw_string] = ACTIONS(3358),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [anon_sym_LT_LPAREN] = ACTIONS(3358),
    [anon_sym_GT_LPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [1841] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4377),
    [sym_comment] = ACTIONS(48),
  },
  [1842] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4379),
    [sym_comment] = ACTIONS(48),
  },
  [1843] = {
    [anon_sym_RBRACE] = ACTIONS(4379),
    [sym_comment] = ACTIONS(48),
  },
  [1844] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_AMP] = ACTIONS(3423),
    [anon_sym_GT_AMP] = ACTIONS(3423),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [1845] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_GT_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_AMP] = ACTIONS(3427),
    [anon_sym_GT_AMP] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_raw_string] = ACTIONS(3427),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [anon_sym_LT_LPAREN] = ACTIONS(3427),
    [anon_sym_GT_LPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [1846] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_RBRACK] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [1847] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_RBRACK] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [1848] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4381),
    [sym_comment] = ACTIONS(48),
  },
  [1849] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4383),
    [sym_comment] = ACTIONS(48),
  },
  [1850] = {
    [anon_sym_RBRACE] = ACTIONS(4383),
    [sym_comment] = ACTIONS(48),
  },
  [1851] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_RBRACK] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [1852] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_RBRACK] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [1853] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_raw_string] = ACTIONS(2290),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2290),
    [anon_sym_GT_LPAREN] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1854] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4385),
    [sym_comment] = ACTIONS(48),
  },
  [1855] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [sym_comment] = ACTIONS(48),
  },
  [1856] = {
    [anon_sym_RBRACE] = ACTIONS(4387),
    [sym_comment] = ACTIONS(48),
  },
  [1857] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_raw_string] = ACTIONS(2354),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [anon_sym_LT_LPAREN] = ACTIONS(2354),
    [anon_sym_GT_LPAREN] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1858] = {
    [sym_concatenation] = STATE(2159),
    [sym_string] = STATE(2158),
    [sym_simple_expansion] = STATE(2158),
    [sym_expansion] = STATE(2158),
    [sym_command_substitution] = STATE(2158),
    [sym_process_substitution] = STATE(2158),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [sym__special_characters] = ACTIONS(4389),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4391),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4393),
  },
  [1859] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym_raw_string] = ACTIONS(2399),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_LT_LPAREN] = ACTIONS(2399),
    [anon_sym_GT_LPAREN] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1860] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4395),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1861] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym_raw_string] = ACTIONS(2405),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [anon_sym_LT_LPAREN] = ACTIONS(2405),
    [anon_sym_GT_LPAREN] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1862] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4397),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1863] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4387),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1864] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_raw_string] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2411),
    [anon_sym_GT_LPAREN] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1865] = {
    [anon_sym_PIPE] = ACTIONS(1928),
    [anon_sym_RPAREN] = ACTIONS(1928),
    [anon_sym_SEMI_SEMI] = ACTIONS(1928),
    [anon_sym_PIPE_AMP] = ACTIONS(1928),
    [anon_sym_AMP_AMP] = ACTIONS(1928),
    [anon_sym_PIPE_PIPE] = ACTIONS(1928),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1928),
    [anon_sym_LF] = ACTIONS(1928),
    [anon_sym_AMP] = ACTIONS(1928),
  },
  [1866] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1001),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4399),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1867] = {
    [sym__terminated_statement] = STATE(546),
    [sym_for_statement] = STATE(547),
    [sym_while_statement] = STATE(547),
    [sym_if_statement] = STATE(547),
    [sym_case_statement] = STATE(547),
    [sym_function_definition] = STATE(547),
    [sym_subshell] = STATE(547),
    [sym_pipeline] = STATE(547),
    [sym_list] = STATE(547),
    [sym_command] = STATE(547),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(550),
    [sym_declaration_command] = STATE(547),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1010),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_fi] = ACTIONS(4401),
    [anon_sym_elif] = ACTIONS(4401),
    [anon_sym_else] = ACTIONS(4401),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1868] = {
    [anon_sym_PIPE] = ACTIONS(4403),
    [anon_sym_RPAREN] = ACTIONS(4403),
    [anon_sym_SEMI_SEMI] = ACTIONS(4403),
    [anon_sym_PIPE_AMP] = ACTIONS(4403),
    [anon_sym_AMP_AMP] = ACTIONS(4403),
    [anon_sym_PIPE_PIPE] = ACTIONS(4403),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4403),
    [anon_sym_LF] = ACTIONS(4403),
    [anon_sym_AMP] = ACTIONS(4403),
  },
  [1869] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1870] = {
    [aux_sym_concatenation_repeat1] = STATE(1485),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(4405),
    [anon_sym_RPAREN] = ACTIONS(4405),
    [sym_comment] = ACTIONS(48),
  },
  [1871] = {
    [aux_sym_concatenation_repeat1] = STATE(1485),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(4407),
    [anon_sym_RPAREN] = ACTIONS(4407),
    [sym_comment] = ACTIONS(48),
  },
  [1872] = {
    [anon_sym_PIPE] = ACTIONS(4407),
    [anon_sym_RPAREN] = ACTIONS(4407),
    [sym_comment] = ACTIONS(48),
  },
  [1873] = {
    [anon_sym_esac] = ACTIONS(4409),
    [sym__special_characters] = ACTIONS(4411),
    [anon_sym_DQUOTE] = ACTIONS(4413),
    [sym_raw_string] = ACTIONS(4413),
    [anon_sym_DOLLAR] = ACTIONS(4411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4413),
    [anon_sym_BQUOTE] = ACTIONS(4413),
    [anon_sym_LT_LPAREN] = ACTIONS(4413),
    [anon_sym_GT_LPAREN] = ACTIONS(4413),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4415),
  },
  [1874] = {
    [sym_file_descriptor] = ACTIONS(252),
    [sym_variable_name] = ACTIONS(252),
    [anon_sym_for] = ACTIONS(254),
    [anon_sym_while] = ACTIONS(254),
    [anon_sym_if] = ACTIONS(254),
    [anon_sym_case] = ACTIONS(254),
    [anon_sym_esac] = ACTIONS(254),
    [anon_sym_SEMI_SEMI] = ACTIONS(252),
    [anon_sym_function] = ACTIONS(254),
    [anon_sym_LPAREN] = ACTIONS(252),
    [anon_sym_declare] = ACTIONS(254),
    [anon_sym_typeset] = ACTIONS(254),
    [anon_sym_export] = ACTIONS(254),
    [anon_sym_readonly] = ACTIONS(254),
    [anon_sym_local] = ACTIONS(254),
    [anon_sym_LT] = ACTIONS(254),
    [anon_sym_GT] = ACTIONS(254),
    [anon_sym_GT_GT] = ACTIONS(252),
    [anon_sym_AMP_GT] = ACTIONS(254),
    [anon_sym_AMP_GT_GT] = ACTIONS(252),
    [anon_sym_LT_AMP] = ACTIONS(252),
    [anon_sym_GT_AMP] = ACTIONS(252),
    [sym__special_characters] = ACTIONS(254),
    [anon_sym_DQUOTE] = ACTIONS(252),
    [sym_raw_string] = ACTIONS(252),
    [anon_sym_DOLLAR] = ACTIONS(254),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(252),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(252),
    [anon_sym_BQUOTE] = ACTIONS(252),
    [anon_sym_LT_LPAREN] = ACTIONS(252),
    [anon_sym_GT_LPAREN] = ACTIONS(252),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(256),
  },
  [1875] = {
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(4417),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4417),
    [anon_sym_LF] = ACTIONS(4417),
    [anon_sym_AMP] = ACTIONS(4417),
  },
  [1876] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(258),
    [anon_sym_SEMI_SEMI] = ACTIONS(4417),
    [anon_sym_PIPE_AMP] = ACTIONS(258),
    [anon_sym_AMP_AMP] = ACTIONS(262),
    [anon_sym_PIPE_PIPE] = ACTIONS(262),
    [anon_sym_LT] = ACTIONS(292),
    [anon_sym_GT] = ACTIONS(292),
    [anon_sym_GT_GT] = ACTIONS(292),
    [anon_sym_AMP_GT] = ACTIONS(292),
    [anon_sym_AMP_GT_GT] = ACTIONS(292),
    [anon_sym_LT_AMP] = ACTIONS(292),
    [anon_sym_GT_AMP] = ACTIONS(292),
    [sym__special_characters] = ACTIONS(292),
    [anon_sym_DQUOTE] = ACTIONS(292),
    [sym_raw_string] = ACTIONS(292),
    [anon_sym_DOLLAR] = ACTIONS(292),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(292),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(292),
    [anon_sym_BQUOTE] = ACTIONS(292),
    [anon_sym_LT_LPAREN] = ACTIONS(292),
    [anon_sym_GT_LPAREN] = ACTIONS(292),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(292),
    [anon_sym_SEMI] = ACTIONS(4417),
    [anon_sym_LF] = ACTIONS(4417),
    [anon_sym_AMP] = ACTIONS(4417),
  },
  [1877] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2165),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4409),
    [anon_sym_SEMI_SEMI] = ACTIONS(4419),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1878] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2166),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4409),
    [anon_sym_SEMI_SEMI] = ACTIONS(4419),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1879] = {
    [aux_sym_case_item_repeat1] = STATE(1879),
    [anon_sym_PIPE] = ACTIONS(4421),
    [anon_sym_RPAREN] = ACTIONS(4407),
    [sym_comment] = ACTIONS(48),
  },
  [1880] = {
    [aux_sym_concatenation_repeat1] = STATE(1880),
    [sym__concat] = ACTIONS(4424),
    [anon_sym_PIPE] = ACTIONS(1302),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [1881] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1333),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [1882] = {
    [anon_sym_esac] = ACTIONS(4427),
    [sym__special_characters] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(4431),
    [sym_raw_string] = ACTIONS(4431),
    [anon_sym_DOLLAR] = ACTIONS(4429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4431),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4431),
    [anon_sym_BQUOTE] = ACTIONS(4431),
    [anon_sym_LT_LPAREN] = ACTIONS(4431),
    [anon_sym_GT_LPAREN] = ACTIONS(4431),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4433),
  },
  [1883] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2165),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4427),
    [anon_sym_SEMI_SEMI] = ACTIONS(4435),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1884] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2168),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4427),
    [anon_sym_SEMI_SEMI] = ACTIONS(4435),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [1885] = {
    [sym_concatenation] = STATE(2172),
    [sym_string] = STATE(2171),
    [sym_simple_expansion] = STATE(2171),
    [sym_expansion] = STATE(2171),
    [sym_command_substitution] = STATE(2171),
    [sym_process_substitution] = STATE(2171),
    [anon_sym_RBRACE] = ACTIONS(4437),
    [sym__special_characters] = ACTIONS(4439),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4441),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4443),
  },
  [1886] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1378),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [1887] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4445),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1888] = {
    [anon_sym_EQ] = ACTIONS(4447),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1889] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2176),
    [anon_sym_RBRACE] = ACTIONS(4449),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1890] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2178),
    [anon_sym_RBRACE] = ACTIONS(4451),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1891] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2179),
    [anon_sym_RBRACE] = ACTIONS(4437),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1892] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1422),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [1893] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4453),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1894] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1428),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [1895] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4437),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1896] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1538),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
  },
  [1897] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
  },
  [1898] = {
    [anon_sym_PIPE] = ACTIONS(4455),
    [anon_sym_RPAREN] = ACTIONS(4455),
    [anon_sym_SEMI_SEMI] = ACTIONS(4455),
    [anon_sym_PIPE_AMP] = ACTIONS(4455),
    [anon_sym_AMP_AMP] = ACTIONS(4455),
    [anon_sym_PIPE_PIPE] = ACTIONS(4455),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4455),
    [anon_sym_LF] = ACTIONS(4455),
    [anon_sym_AMP] = ACTIONS(4455),
  },
  [1899] = {
    [aux_sym_case_item_repeat1] = STATE(2182),
    [aux_sym_concatenation_repeat1] = STATE(1485),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(4457),
    [sym_comment] = ACTIONS(48),
  },
  [1900] = {
    [aux_sym_case_item_repeat1] = STATE(2184),
    [aux_sym_concatenation_repeat1] = STATE(1485),
    [sym__concat] = ACTIONS(3090),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(4459),
    [sym_comment] = ACTIONS(48),
  },
  [1901] = {
    [aux_sym_case_item_repeat1] = STATE(2184),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(4459),
    [sym_comment] = ACTIONS(48),
  },
  [1902] = {
    [anon_sym_esac] = ACTIONS(4461),
    [sym_comment] = ACTIONS(48),
  },
  [1903] = {
    [anon_sym_PIPE] = ACTIONS(4463),
    [anon_sym_RPAREN] = ACTIONS(4463),
    [anon_sym_SEMI_SEMI] = ACTIONS(4463),
    [anon_sym_PIPE_AMP] = ACTIONS(4463),
    [anon_sym_AMP_AMP] = ACTIONS(4463),
    [anon_sym_PIPE_PIPE] = ACTIONS(4463),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4463),
    [anon_sym_LF] = ACTIONS(4463),
    [anon_sym_AMP] = ACTIONS(4463),
  },
  [1904] = {
    [anon_sym_esac] = ACTIONS(4465),
    [sym_comment] = ACTIONS(48),
  },
  [1905] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_in] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [1906] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_in] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1907] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1908] = {
    [aux_sym_concatenation_repeat1] = STATE(1908),
    [sym__concat] = ACTIONS(4467),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [1909] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [1910] = {
    [sym_concatenation] = STATE(2190),
    [sym_string] = STATE(2189),
    [sym_simple_expansion] = STATE(2189),
    [sym_expansion] = STATE(2189),
    [sym_command_substitution] = STATE(2189),
    [sym_process_substitution] = STATE(2189),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [sym__special_characters] = ACTIONS(4472),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4474),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4476),
  },
  [1911] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [1912] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4478),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1913] = {
    [anon_sym_EQ] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1914] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2194),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1915] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2196),
    [anon_sym_RBRACE] = ACTIONS(4484),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1916] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2197),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1917] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [1918] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1919] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [1920] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1921] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [1922] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [1923] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT_GT] = ACTIONS(2290),
    [anon_sym_LT_AMP] = ACTIONS(2290),
    [anon_sym_GT_AMP] = ACTIONS(2290),
    [sym__special_characters] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [sym_raw_string] = ACTIONS(2290),
    [anon_sym_DOLLAR] = ACTIONS(2290),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2290),
    [anon_sym_BQUOTE] = ACTIONS(2290),
    [anon_sym_LT_LPAREN] = ACTIONS(2290),
    [anon_sym_GT_LPAREN] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2290),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1924] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4488),
    [sym_comment] = ACTIONS(48),
  },
  [1925] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [sym_comment] = ACTIONS(48),
  },
  [1926] = {
    [anon_sym_RBRACE] = ACTIONS(4490),
    [sym_comment] = ACTIONS(48),
  },
  [1927] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2354),
    [anon_sym_GT_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT_GT] = ACTIONS(2354),
    [anon_sym_LT_AMP] = ACTIONS(2354),
    [anon_sym_GT_AMP] = ACTIONS(2354),
    [sym__special_characters] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [sym_raw_string] = ACTIONS(2354),
    [anon_sym_DOLLAR] = ACTIONS(2354),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2354),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2354),
    [anon_sym_BQUOTE] = ACTIONS(2354),
    [anon_sym_LT_LPAREN] = ACTIONS(2354),
    [anon_sym_GT_LPAREN] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2354),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1928] = {
    [sym_concatenation] = STATE(2203),
    [sym_string] = STATE(2202),
    [sym_simple_expansion] = STATE(2202),
    [sym_expansion] = STATE(2202),
    [sym_command_substitution] = STATE(2202),
    [sym_process_substitution] = STATE(2202),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [sym__special_characters] = ACTIONS(4492),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4494),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4496),
  },
  [1929] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_RPAREN] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT_GT] = ACTIONS(2399),
    [anon_sym_LT_AMP] = ACTIONS(2399),
    [anon_sym_GT_AMP] = ACTIONS(2399),
    [sym__special_characters] = ACTIONS(2399),
    [anon_sym_DQUOTE] = ACTIONS(2399),
    [sym_raw_string] = ACTIONS(2399),
    [anon_sym_DOLLAR] = ACTIONS(2399),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2399),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2399),
    [anon_sym_BQUOTE] = ACTIONS(2399),
    [anon_sym_LT_LPAREN] = ACTIONS(2399),
    [anon_sym_GT_LPAREN] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2399),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1930] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4498),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1931] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_GT_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT_GT] = ACTIONS(2405),
    [anon_sym_LT_AMP] = ACTIONS(2405),
    [anon_sym_GT_AMP] = ACTIONS(2405),
    [sym__special_characters] = ACTIONS(2405),
    [anon_sym_DQUOTE] = ACTIONS(2405),
    [sym_raw_string] = ACTIONS(2405),
    [anon_sym_DOLLAR] = ACTIONS(2405),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2405),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2405),
    [anon_sym_BQUOTE] = ACTIONS(2405),
    [anon_sym_LT_LPAREN] = ACTIONS(2405),
    [anon_sym_GT_LPAREN] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2405),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1932] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4500),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1933] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1934] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_GT_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT_GT] = ACTIONS(2411),
    [anon_sym_LT_AMP] = ACTIONS(2411),
    [anon_sym_GT_AMP] = ACTIONS(2411),
    [sym__special_characters] = ACTIONS(2411),
    [anon_sym_DQUOTE] = ACTIONS(2411),
    [sym_raw_string] = ACTIONS(2411),
    [anon_sym_DOLLAR] = ACTIONS(2411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2411),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2411),
    [anon_sym_BQUOTE] = ACTIONS(2411),
    [anon_sym_LT_LPAREN] = ACTIONS(2411),
    [anon_sym_GT_LPAREN] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(2411),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1935] = {
    [aux_sym_concatenation_repeat1] = STATE(1938),
    [sym__concat] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(2848),
    [anon_sym_RPAREN] = ACTIONS(2848),
    [anon_sym_SEMI_SEMI] = ACTIONS(2848),
    [anon_sym_PIPE_AMP] = ACTIONS(2848),
    [anon_sym_AMP_AMP] = ACTIONS(2848),
    [anon_sym_PIPE_PIPE] = ACTIONS(2848),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2848),
    [anon_sym_LF] = ACTIONS(2848),
    [anon_sym_AMP] = ACTIONS(2848),
  },
  [1936] = {
    [aux_sym_concatenation_repeat1] = STATE(1938),
    [sym__concat] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_RPAREN] = ACTIONS(2850),
    [anon_sym_SEMI_SEMI] = ACTIONS(2850),
    [anon_sym_PIPE_AMP] = ACTIONS(2850),
    [anon_sym_AMP_AMP] = ACTIONS(2850),
    [anon_sym_PIPE_PIPE] = ACTIONS(2850),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2850),
    [anon_sym_LF] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
  },
  [1937] = {
    [sym_string] = STATE(2206),
    [sym_simple_expansion] = STATE(2206),
    [sym_expansion] = STATE(2206),
    [sym_command_substitution] = STATE(2206),
    [sym_process_substitution] = STATE(2206),
    [sym__special_characters] = ACTIONS(4502),
    [anon_sym_DQUOTE] = ACTIONS(3213),
    [sym_raw_string] = ACTIONS(4504),
    [anon_sym_DOLLAR] = ACTIONS(3217),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3219),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3221),
    [anon_sym_BQUOTE] = ACTIONS(3223),
    [anon_sym_LT_LPAREN] = ACTIONS(3225),
    [anon_sym_GT_LPAREN] = ACTIONS(3225),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4502),
  },
  [1938] = {
    [aux_sym_concatenation_repeat1] = STATE(2207),
    [sym__concat] = ACTIONS(3981),
    [anon_sym_PIPE] = ACTIONS(540),
    [anon_sym_RPAREN] = ACTIONS(540),
    [anon_sym_SEMI_SEMI] = ACTIONS(540),
    [anon_sym_PIPE_AMP] = ACTIONS(540),
    [anon_sym_AMP_AMP] = ACTIONS(540),
    [anon_sym_PIPE_PIPE] = ACTIONS(540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(540),
    [anon_sym_LF] = ACTIONS(540),
    [anon_sym_AMP] = ACTIONS(540),
  },
  [1939] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(544),
    [anon_sym_RPAREN] = ACTIONS(544),
    [anon_sym_SEMI_SEMI] = ACTIONS(544),
    [anon_sym_PIPE_AMP] = ACTIONS(544),
    [anon_sym_AMP_AMP] = ACTIONS(544),
    [anon_sym_PIPE_PIPE] = ACTIONS(544),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(544),
    [anon_sym_LF] = ACTIONS(544),
    [anon_sym_AMP] = ACTIONS(544),
  },
  [1940] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(4506),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [1941] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(574),
    [anon_sym_RPAREN] = ACTIONS(574),
    [anon_sym_SEMI_SEMI] = ACTIONS(574),
    [anon_sym_PIPE_AMP] = ACTIONS(574),
    [anon_sym_AMP_AMP] = ACTIONS(574),
    [anon_sym_PIPE_PIPE] = ACTIONS(574),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(574),
    [anon_sym_LF] = ACTIONS(574),
    [anon_sym_AMP] = ACTIONS(574),
  },
  [1942] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(578),
    [anon_sym_RPAREN] = ACTIONS(578),
    [anon_sym_SEMI_SEMI] = ACTIONS(578),
    [anon_sym_PIPE_AMP] = ACTIONS(578),
    [anon_sym_AMP_AMP] = ACTIONS(578),
    [anon_sym_PIPE_PIPE] = ACTIONS(578),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(578),
    [anon_sym_LF] = ACTIONS(578),
    [anon_sym_AMP] = ACTIONS(578),
  },
  [1943] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(582),
    [anon_sym_RPAREN] = ACTIONS(582),
    [anon_sym_SEMI_SEMI] = ACTIONS(582),
    [anon_sym_PIPE_AMP] = ACTIONS(582),
    [anon_sym_AMP_AMP] = ACTIONS(582),
    [anon_sym_PIPE_PIPE] = ACTIONS(582),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(582),
    [anon_sym_LF] = ACTIONS(582),
    [anon_sym_AMP] = ACTIONS(582),
  },
  [1944] = {
    [anon_sym_EQ] = ACTIONS(4508),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [1945] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2211),
    [anon_sym_RBRACE] = ACTIONS(4510),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1946] = {
    [sym_subscript] = STATE(2215),
    [sym_variable_name] = ACTIONS(4512),
    [anon_sym_DOLLAR] = ACTIONS(4514),
    [anon_sym_DASH] = ACTIONS(4514),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4516),
    [anon_sym_STAR] = ACTIONS(4514),
    [anon_sym_AT] = ACTIONS(4514),
    [anon_sym_QMARK] = ACTIONS(4514),
    [anon_sym_0] = ACTIONS(4518),
    [anon_sym__] = ACTIONS(4518),
  },
  [1947] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2217),
    [anon_sym_RBRACE] = ACTIONS(4520),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1948] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2219),
    [anon_sym_RBRACE] = ACTIONS(4522),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1949] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4524),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1950] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4524),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1951] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(4524),
    [sym_comment] = ACTIONS(48),
  },
  [1952] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(4524),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1953] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4526),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [1954] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4526),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [1955] = {
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [anon_sym_LT_LPAREN] = ACTIONS(3352),
    [anon_sym_GT_LPAREN] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3352),
    [sym_word] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [1956] = {
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym_raw_string] = ACTIONS(3358),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [anon_sym_LT_LPAREN] = ACTIONS(3358),
    [anon_sym_GT_LPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3358),
    [sym_word] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [1957] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4528),
    [sym_comment] = ACTIONS(48),
  },
  [1958] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4530),
    [sym_comment] = ACTIONS(48),
  },
  [1959] = {
    [anon_sym_RBRACE] = ACTIONS(4530),
    [sym_comment] = ACTIONS(48),
  },
  [1960] = {
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3423),
    [sym_word] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [1961] = {
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_RPAREN] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_raw_string] = ACTIONS(3427),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [anon_sym_LT_LPAREN] = ACTIONS(3427),
    [anon_sym_GT_LPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(3427),
    [sym_word] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [1962] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_AMP] = ACTIONS(4109),
    [anon_sym_GT_AMP] = ACTIONS(4109),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_LT_LT_DASH] = ACTIONS(4109),
    [anon_sym_LT_LT_LT] = ACTIONS(4109),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_raw_string] = ACTIONS(4109),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LT_LPAREN] = ACTIONS(4109),
    [anon_sym_GT_LPAREN] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [1963] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4113),
    [anon_sym_LT_AMP] = ACTIONS(4113),
    [anon_sym_GT_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4113),
    [anon_sym_LT_LT_LT] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_raw_string] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [anon_sym_LT_LPAREN] = ACTIONS(4113),
    [anon_sym_GT_LPAREN] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1964] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [anon_sym_LT] = ACTIONS(2290),
    [anon_sym_GT] = ACTIONS(2290),
    [anon_sym_GT_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT] = ACTIONS(2290),
    [anon_sym_AMP_GT_GT] = ACTIONS(2290),
    [anon_sym_LT_AMP] = ACTIONS(2290),
    [anon_sym_GT_AMP] = ACTIONS(2290),
    [anon_sym_LT_LT] = ACTIONS(2290),
    [anon_sym_LT_LT_DASH] = ACTIONS(2290),
    [anon_sym_LT_LT_LT] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [1965] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [sym_comment] = ACTIONS(48),
  },
  [1966] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [sym_comment] = ACTIONS(48),
  },
  [1967] = {
    [anon_sym_RBRACE] = ACTIONS(4534),
    [sym_comment] = ACTIONS(48),
  },
  [1968] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [anon_sym_LT] = ACTIONS(2354),
    [anon_sym_GT] = ACTIONS(2354),
    [anon_sym_GT_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT] = ACTIONS(2354),
    [anon_sym_AMP_GT_GT] = ACTIONS(2354),
    [anon_sym_LT_AMP] = ACTIONS(2354),
    [anon_sym_GT_AMP] = ACTIONS(2354),
    [anon_sym_LT_LT] = ACTIONS(2354),
    [anon_sym_LT_LT_DASH] = ACTIONS(2354),
    [anon_sym_LT_LT_LT] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [1969] = {
    [sym_concatenation] = STATE(2228),
    [sym_string] = STATE(2227),
    [sym_simple_expansion] = STATE(2227),
    [sym_expansion] = STATE(2227),
    [sym_command_substitution] = STATE(2227),
    [sym_process_substitution] = STATE(2227),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [sym__special_characters] = ACTIONS(4536),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4538),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4540),
  },
  [1970] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_RPAREN] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [anon_sym_LT] = ACTIONS(2399),
    [anon_sym_GT] = ACTIONS(2399),
    [anon_sym_GT_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT] = ACTIONS(2399),
    [anon_sym_AMP_GT_GT] = ACTIONS(2399),
    [anon_sym_LT_AMP] = ACTIONS(2399),
    [anon_sym_GT_AMP] = ACTIONS(2399),
    [anon_sym_LT_LT] = ACTIONS(2399),
    [anon_sym_LT_LT_DASH] = ACTIONS(2399),
    [anon_sym_LT_LT_LT] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [1971] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4542),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1972] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [anon_sym_LT] = ACTIONS(2405),
    [anon_sym_GT] = ACTIONS(2405),
    [anon_sym_GT_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT] = ACTIONS(2405),
    [anon_sym_AMP_GT_GT] = ACTIONS(2405),
    [anon_sym_LT_AMP] = ACTIONS(2405),
    [anon_sym_GT_AMP] = ACTIONS(2405),
    [anon_sym_LT_LT] = ACTIONS(2405),
    [anon_sym_LT_LT_DASH] = ACTIONS(2405),
    [anon_sym_LT_LT_LT] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [1973] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1974] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4534),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1975] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [anon_sym_LT] = ACTIONS(2411),
    [anon_sym_GT] = ACTIONS(2411),
    [anon_sym_GT_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT] = ACTIONS(2411),
    [anon_sym_AMP_GT_GT] = ACTIONS(2411),
    [anon_sym_LT_AMP] = ACTIONS(2411),
    [anon_sym_GT_AMP] = ACTIONS(2411),
    [anon_sym_LT_LT] = ACTIONS(2411),
    [anon_sym_LT_LT_DASH] = ACTIONS(2411),
    [anon_sym_LT_LT_LT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [1976] = {
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_raw_string] = ACTIONS(4109),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LT_LPAREN] = ACTIONS(4109),
    [anon_sym_GT_LPAREN] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4109),
    [sym_word] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [1977] = {
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_raw_string] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [anon_sym_LT_LPAREN] = ACTIONS(4113),
    [anon_sym_GT_LPAREN] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [1978] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(4546),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_AMP_GT] = ACTIONS(4546),
    [anon_sym_AMP_GT_GT] = ACTIONS(4107),
    [anon_sym_LT_AMP] = ACTIONS(4107),
    [anon_sym_GT_AMP] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4546),
  },
  [1979] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4548),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4548),
  },
  [1980] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym__string_content] = ACTIONS(4546),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
  },
  [1981] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym__string_content] = ACTIONS(4548),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
  },
  [1982] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_RBRACE] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [1983] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4550),
    [sym_comment] = ACTIONS(48),
  },
  [1984] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [sym_comment] = ACTIONS(48),
  },
  [1985] = {
    [anon_sym_RBRACE] = ACTIONS(4552),
    [sym_comment] = ACTIONS(48),
  },
  [1986] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_RBRACE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [1987] = {
    [sym_concatenation] = STATE(2235),
    [sym_string] = STATE(2234),
    [sym_simple_expansion] = STATE(2234),
    [sym_expansion] = STATE(2234),
    [sym_command_substitution] = STATE(2234),
    [sym_process_substitution] = STATE(2234),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [sym__special_characters] = ACTIONS(4554),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4556),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4558),
  },
  [1988] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_RBRACE] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [1989] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1990] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_RBRACE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [1991] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4562),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1992] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [1993] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_RBRACE] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [1994] = {
    [anon_sym_RBRACE] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(4564),
    [sym__special_characters] = ACTIONS(4566),
    [anon_sym_DQUOTE] = ACTIONS(3790),
    [sym_raw_string] = ACTIONS(3790),
    [anon_sym_DOLLAR] = ACTIONS(4564),
    [anon_sym_POUND] = ACTIONS(3790),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3790),
    [anon_sym_COLON] = ACTIONS(4564),
    [anon_sym_COLON_QMARK] = ACTIONS(4564),
    [anon_sym_COLON_DASH] = ACTIONS(4564),
    [anon_sym_PERCENT] = ACTIONS(4564),
    [anon_sym_SLASH] = ACTIONS(4564),
    [anon_sym_DASH] = ACTIONS(4564),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3790),
    [anon_sym_BQUOTE] = ACTIONS(3790),
    [anon_sym_LT_LPAREN] = ACTIONS(3790),
    [anon_sym_GT_LPAREN] = ACTIONS(3790),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4566),
  },
  [1995] = {
    [anon_sym_RBRACE] = ACTIONS(3792),
    [anon_sym_EQ] = ACTIONS(4568),
    [sym__special_characters] = ACTIONS(4570),
    [anon_sym_DQUOTE] = ACTIONS(3792),
    [sym_raw_string] = ACTIONS(3792),
    [anon_sym_DOLLAR] = ACTIONS(4568),
    [anon_sym_POUND] = ACTIONS(3792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3792),
    [anon_sym_COLON] = ACTIONS(4568),
    [anon_sym_COLON_QMARK] = ACTIONS(4568),
    [anon_sym_COLON_DASH] = ACTIONS(4568),
    [anon_sym_PERCENT] = ACTIONS(4568),
    [anon_sym_SLASH] = ACTIONS(4568),
    [anon_sym_DASH] = ACTIONS(4568),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3792),
    [anon_sym_BQUOTE] = ACTIONS(3792),
    [anon_sym_LT_LPAREN] = ACTIONS(3792),
    [anon_sym_GT_LPAREN] = ACTIONS(3792),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4570),
  },
  [1996] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(4044),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_POUND] = ACTIONS(3350),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_COLON] = ACTIONS(4044),
    [anon_sym_COLON_QMARK] = ACTIONS(4044),
    [anon_sym_COLON_DASH] = ACTIONS(4044),
    [anon_sym_PERCENT] = ACTIONS(4044),
    [anon_sym_SLASH] = ACTIONS(4044),
    [anon_sym_DASH] = ACTIONS(4044),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3352),
  },
  [1997] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [anon_sym_EQ] = ACTIONS(4046),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_POUND] = ACTIONS(3356),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_COLON] = ACTIONS(4046),
    [anon_sym_COLON_QMARK] = ACTIONS(4046),
    [anon_sym_COLON_DASH] = ACTIONS(4046),
    [anon_sym_PERCENT] = ACTIONS(4046),
    [anon_sym_SLASH] = ACTIONS(4046),
    [anon_sym_DASH] = ACTIONS(4046),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3358),
  },
  [1998] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [sym_comment] = ACTIONS(48),
  },
  [1999] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4574),
    [sym_comment] = ACTIONS(48),
  },
  [2000] = {
    [anon_sym_RBRACE] = ACTIONS(4574),
    [sym_comment] = ACTIONS(48),
  },
  [2001] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [anon_sym_EQ] = ACTIONS(4052),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_POUND] = ACTIONS(3421),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_COLON] = ACTIONS(4052),
    [anon_sym_COLON_QMARK] = ACTIONS(4052),
    [anon_sym_COLON_DASH] = ACTIONS(4052),
    [anon_sym_PERCENT] = ACTIONS(4052),
    [anon_sym_SLASH] = ACTIONS(4052),
    [anon_sym_DASH] = ACTIONS(4052),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3423),
  },
  [2002] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [anon_sym_EQ] = ACTIONS(4054),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_POUND] = ACTIONS(3425),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_COLON] = ACTIONS(4054),
    [anon_sym_COLON_QMARK] = ACTIONS(4054),
    [anon_sym_COLON_DASH] = ACTIONS(4054),
    [anon_sym_PERCENT] = ACTIONS(4054),
    [anon_sym_SLASH] = ACTIONS(4054),
    [anon_sym_DASH] = ACTIONS(4054),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3427),
  },
  [2003] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_RPAREN] = ACTIONS(2288),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(3308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3308),
  },
  [2004] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [sym_comment] = ACTIONS(48),
  },
  [2005] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [sym_comment] = ACTIONS(48),
  },
  [2006] = {
    [anon_sym_RBRACE] = ACTIONS(4578),
    [sym_comment] = ACTIONS(48),
  },
  [2007] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_GT_GT] = ACTIONS(2352),
    [anon_sym_AMP_GT] = ACTIONS(3314),
    [anon_sym_AMP_GT_GT] = ACTIONS(2352),
    [anon_sym_LT_AMP] = ACTIONS(2352),
    [anon_sym_GT_AMP] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3314),
  },
  [2008] = {
    [sym_concatenation] = STATE(2244),
    [sym_string] = STATE(2243),
    [sym_simple_expansion] = STATE(2243),
    [sym_expansion] = STATE(2243),
    [sym_command_substitution] = STATE(2243),
    [sym_process_substitution] = STATE(2243),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [sym__special_characters] = ACTIONS(4580),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4582),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4584),
  },
  [2009] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT] = ACTIONS(3322),
    [anon_sym_AMP_GT_GT] = ACTIONS(2397),
    [anon_sym_LT_AMP] = ACTIONS(2397),
    [anon_sym_GT_AMP] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3322),
  },
  [2010] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4586),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2011] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(2403),
    [anon_sym_AMP_GT] = ACTIONS(3326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_AMP] = ACTIONS(2403),
    [anon_sym_GT_AMP] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3326),
  },
  [2012] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2013] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4578),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2014] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(2409),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(2409),
    [anon_sym_LT_AMP] = ACTIONS(2409),
    [anon_sym_GT_AMP] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3330),
  },
  [2015] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2248),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4590),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2016] = {
    [anon_sym_PIPE] = ACTIONS(4592),
    [anon_sym_RPAREN] = ACTIONS(4594),
    [anon_sym_PIPE_AMP] = ACTIONS(4594),
    [anon_sym_AMP_AMP] = ACTIONS(4594),
    [anon_sym_PIPE_PIPE] = ACTIONS(4594),
    [anon_sym_BQUOTE] = ACTIONS(4594),
    [sym_comment] = ACTIONS(48),
  },
  [2017] = {
    [anon_sym_PIPE] = ACTIONS(4596),
    [anon_sym_RPAREN] = ACTIONS(4598),
    [anon_sym_PIPE_AMP] = ACTIONS(4598),
    [anon_sym_AMP_AMP] = ACTIONS(4598),
    [anon_sym_PIPE_PIPE] = ACTIONS(4598),
    [anon_sym_BQUOTE] = ACTIONS(4598),
    [sym_comment] = ACTIONS(48),
  },
  [2018] = {
    [anon_sym_fi] = ACTIONS(4600),
    [sym_comment] = ACTIONS(48),
  },
  [2019] = {
    [anon_sym_PIPE] = ACTIONS(4602),
    [anon_sym_RPAREN] = ACTIONS(4604),
    [anon_sym_PIPE_AMP] = ACTIONS(4604),
    [anon_sym_AMP_AMP] = ACTIONS(4604),
    [anon_sym_PIPE_PIPE] = ACTIONS(4604),
    [anon_sym_BQUOTE] = ACTIONS(4604),
    [sym_comment] = ACTIONS(48),
  },
  [2020] = {
    [anon_sym_esac] = ACTIONS(4606),
    [sym_comment] = ACTIONS(48),
  },
  [2021] = {
    [anon_sym_PIPE] = ACTIONS(4608),
    [anon_sym_RPAREN] = ACTIONS(4610),
    [anon_sym_PIPE_AMP] = ACTIONS(4610),
    [anon_sym_AMP_AMP] = ACTIONS(4610),
    [anon_sym_PIPE_PIPE] = ACTIONS(4610),
    [anon_sym_BQUOTE] = ACTIONS(4610),
    [sym_comment] = ACTIONS(48),
  },
  [2022] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(2251),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [2023] = {
    [anon_sym_PIPE] = ACTIONS(4612),
    [anon_sym_RPAREN] = ACTIONS(4614),
    [anon_sym_PIPE_AMP] = ACTIONS(4614),
    [anon_sym_AMP_AMP] = ACTIONS(4614),
    [anon_sym_PIPE_PIPE] = ACTIONS(4614),
    [anon_sym_BQUOTE] = ACTIONS(4614),
    [sym_comment] = ACTIONS(48),
  },
  [2024] = {
    [anon_sym_esac] = ACTIONS(4616),
    [sym_comment] = ACTIONS(48),
  },
  [2025] = {
    [anon_sym_PIPE] = ACTIONS(4618),
    [anon_sym_RPAREN] = ACTIONS(4620),
    [anon_sym_PIPE_AMP] = ACTIONS(4620),
    [anon_sym_AMP_AMP] = ACTIONS(4620),
    [anon_sym_PIPE_PIPE] = ACTIONS(4620),
    [anon_sym_BQUOTE] = ACTIONS(4620),
    [sym_comment] = ACTIONS(48),
  },
  [2026] = {
    [sym_case_item] = STATE(1022),
    [sym_last_case_item] = STATE(2253),
    [sym_concatenation] = STATE(1024),
    [sym_string] = STATE(1016),
    [sym_simple_expansion] = STATE(1016),
    [sym_expansion] = STATE(1016),
    [sym_command_substitution] = STATE(1016),
    [sym_process_substitution] = STATE(1016),
    [aux_sym_case_statement_repeat1] = STATE(1506),
    [sym__special_characters] = ACTIONS(1954),
    [anon_sym_DQUOTE] = ACTIONS(1956),
    [sym_raw_string] = ACTIONS(1958),
    [anon_sym_DOLLAR] = ACTIONS(1960),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1962),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1964),
    [anon_sym_BQUOTE] = ACTIONS(1966),
    [anon_sym_LT_LPAREN] = ACTIONS(1968),
    [anon_sym_GT_LPAREN] = ACTIONS(1968),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3122),
  },
  [2027] = {
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_RPAREN] = ACTIONS(4624),
    [anon_sym_PIPE_AMP] = ACTIONS(4624),
    [anon_sym_AMP_AMP] = ACTIONS(4624),
    [anon_sym_PIPE_PIPE] = ACTIONS(4624),
    [anon_sym_BQUOTE] = ACTIONS(4624),
    [sym_comment] = ACTIONS(48),
  },
  [2028] = {
    [aux_sym_concatenation_repeat1] = STATE(2032),
    [sym__concat] = ACTIONS(4176),
    [anon_sym_PIPE] = ACTIONS(924),
    [anon_sym_RPAREN] = ACTIONS(922),
    [anon_sym_PIPE_AMP] = ACTIONS(922),
    [anon_sym_AMP_AMP] = ACTIONS(922),
    [anon_sym_PIPE_PIPE] = ACTIONS(922),
    [sym_comment] = ACTIONS(48),
  },
  [2029] = {
    [aux_sym_concatenation_repeat1] = STATE(2032),
    [sym__concat] = ACTIONS(4176),
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
  },
  [2030] = {
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_RPAREN] = ACTIONS(926),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
  },
  [2031] = {
    [sym_string] = STATE(2254),
    [sym_simple_expansion] = STATE(2254),
    [sym_expansion] = STATE(2254),
    [sym_command_substitution] = STATE(2254),
    [sym_process_substitution] = STATE(2254),
    [sym__special_characters] = ACTIONS(4626),
    [anon_sym_DQUOTE] = ACTIONS(3495),
    [sym_raw_string] = ACTIONS(4628),
    [anon_sym_DOLLAR] = ACTIONS(3499),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3501),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3503),
    [anon_sym_BQUOTE] = ACTIONS(3505),
    [anon_sym_LT_LPAREN] = ACTIONS(3507),
    [anon_sym_GT_LPAREN] = ACTIONS(3507),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4626),
  },
  [2032] = {
    [aux_sym_concatenation_repeat1] = STATE(2255),
    [sym__concat] = ACTIONS(4176),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_RPAREN] = ACTIONS(538),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
  },
  [2033] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_RPAREN] = ACTIONS(542),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [2034] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(4630),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [2035] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_RPAREN] = ACTIONS(572),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [2036] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_RPAREN] = ACTIONS(576),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [2037] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_RPAREN] = ACTIONS(580),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [2038] = {
    [anon_sym_EQ] = ACTIONS(4632),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [2039] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2259),
    [anon_sym_RBRACE] = ACTIONS(4634),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2040] = {
    [sym_subscript] = STATE(2263),
    [sym_variable_name] = ACTIONS(4636),
    [anon_sym_DOLLAR] = ACTIONS(4638),
    [anon_sym_DASH] = ACTIONS(4638),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4640),
    [anon_sym_STAR] = ACTIONS(4638),
    [anon_sym_AT] = ACTIONS(4638),
    [anon_sym_QMARK] = ACTIONS(4638),
    [anon_sym_0] = ACTIONS(4642),
    [anon_sym__] = ACTIONS(4642),
  },
  [2041] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2265),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2042] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2267),
    [anon_sym_RBRACE] = ACTIONS(4646),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2043] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4648),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [2044] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4648),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [2045] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(4648),
    [sym_comment] = ACTIONS(48),
  },
  [2046] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(4648),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [2047] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4650),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [2048] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4650),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [2049] = {
    [sym_variable_name] = ACTIONS(2934),
    [anon_sym_PIPE] = ACTIONS(4115),
    [anon_sym_RPAREN] = ACTIONS(2934),
    [anon_sym_PIPE_AMP] = ACTIONS(2934),
    [anon_sym_AMP_AMP] = ACTIONS(2934),
    [anon_sym_PIPE_PIPE] = ACTIONS(2934),
    [sym__special_characters] = ACTIONS(4115),
    [anon_sym_DQUOTE] = ACTIONS(2934),
    [sym_raw_string] = ACTIONS(2934),
    [anon_sym_DOLLAR] = ACTIONS(4115),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2934),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2934),
    [anon_sym_BQUOTE] = ACTIONS(2934),
    [anon_sym_LT_LPAREN] = ACTIONS(2934),
    [anon_sym_GT_LPAREN] = ACTIONS(2934),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4115),
    [sym_word] = ACTIONS(2936),
  },
  [2050] = {
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(3352),
  },
  [2051] = {
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(3358),
  },
  [2052] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4652),
    [sym_comment] = ACTIONS(48),
  },
  [2053] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4654),
    [sym_comment] = ACTIONS(48),
  },
  [2054] = {
    [anon_sym_RBRACE] = ACTIONS(4654),
    [sym_comment] = ACTIONS(48),
  },
  [2055] = {
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(3423),
  },
  [2056] = {
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4054),
    [sym_word] = ACTIONS(3427),
  },
  [2057] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_RPAREN] = ACTIONS(4107),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(4546),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_AMP_GT] = ACTIONS(4546),
    [anon_sym_AMP_GT_GT] = ACTIONS(4107),
    [anon_sym_LT_AMP] = ACTIONS(4107),
    [anon_sym_GT_AMP] = ACTIONS(4107),
    [anon_sym_LT_LT] = ACTIONS(4546),
    [anon_sym_LT_LT_DASH] = ACTIONS(4107),
    [anon_sym_LT_LT_LT] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4546),
  },
  [2058] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4548),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4548),
  },
  [2059] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_RPAREN] = ACTIONS(2288),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(3308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2288),
    [anon_sym_LT_LT_LT] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [2060] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4656),
    [sym_comment] = ACTIONS(48),
  },
  [2061] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [sym_comment] = ACTIONS(48),
  },
  [2062] = {
    [anon_sym_RBRACE] = ACTIONS(4658),
    [sym_comment] = ACTIONS(48),
  },
  [2063] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_GT_GT] = ACTIONS(2352),
    [anon_sym_AMP_GT] = ACTIONS(3314),
    [anon_sym_AMP_GT_GT] = ACTIONS(2352),
    [anon_sym_LT_AMP] = ACTIONS(2352),
    [anon_sym_GT_AMP] = ACTIONS(2352),
    [anon_sym_LT_LT] = ACTIONS(3314),
    [anon_sym_LT_LT_DASH] = ACTIONS(2352),
    [anon_sym_LT_LT_LT] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [2064] = {
    [sym_concatenation] = STATE(2276),
    [sym_string] = STATE(2275),
    [sym_simple_expansion] = STATE(2275),
    [sym_expansion] = STATE(2275),
    [sym_command_substitution] = STATE(2275),
    [sym_process_substitution] = STATE(2275),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [sym__special_characters] = ACTIONS(4660),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4662),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4664),
  },
  [2065] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT] = ACTIONS(3322),
    [anon_sym_AMP_GT_GT] = ACTIONS(2397),
    [anon_sym_LT_AMP] = ACTIONS(2397),
    [anon_sym_GT_AMP] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(3322),
    [anon_sym_LT_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT_LT] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [2066] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4666),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2067] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(2403),
    [anon_sym_AMP_GT] = ACTIONS(3326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_AMP] = ACTIONS(2403),
    [anon_sym_GT_AMP] = ACTIONS(2403),
    [anon_sym_LT_LT] = ACTIONS(3326),
    [anon_sym_LT_LT_DASH] = ACTIONS(2403),
    [anon_sym_LT_LT_LT] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [2068] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4668),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2069] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4658),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2070] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(2409),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(2409),
    [anon_sym_LT_AMP] = ACTIONS(2409),
    [anon_sym_GT_AMP] = ACTIONS(2409),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_LT_LT_DASH] = ACTIONS(2409),
    [anon_sym_LT_LT_LT] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [2071] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [sym_variable_name] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(3308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [sym__special_characters] = ACTIONS(3308),
    [anon_sym_DQUOTE] = ACTIONS(2288),
    [sym_raw_string] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [anon_sym_LT_LPAREN] = ACTIONS(2288),
    [anon_sym_GT_LPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3308),
  },
  [2072] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4670),
    [sym_comment] = ACTIONS(48),
  },
  [2073] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4672),
    [sym_comment] = ACTIONS(48),
  },
  [2074] = {
    [anon_sym_RBRACE] = ACTIONS(4672),
    [sym_comment] = ACTIONS(48),
  },
  [2075] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [sym_variable_name] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_GT_GT] = ACTIONS(2352),
    [anon_sym_AMP_GT] = ACTIONS(3314),
    [anon_sym_AMP_GT_GT] = ACTIONS(2352),
    [anon_sym_LT_AMP] = ACTIONS(2352),
    [anon_sym_GT_AMP] = ACTIONS(2352),
    [sym__special_characters] = ACTIONS(3314),
    [anon_sym_DQUOTE] = ACTIONS(2352),
    [sym_raw_string] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [anon_sym_LT_LPAREN] = ACTIONS(2352),
    [anon_sym_GT_LPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3314),
  },
  [2076] = {
    [sym_concatenation] = STATE(2283),
    [sym_string] = STATE(2282),
    [sym_simple_expansion] = STATE(2282),
    [sym_expansion] = STATE(2282),
    [sym_command_substitution] = STATE(2282),
    [sym_process_substitution] = STATE(2282),
    [anon_sym_RBRACE] = ACTIONS(4672),
    [sym__special_characters] = ACTIONS(4674),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4676),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4678),
  },
  [2077] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [sym_variable_name] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT] = ACTIONS(3322),
    [anon_sym_AMP_GT_GT] = ACTIONS(2397),
    [anon_sym_LT_AMP] = ACTIONS(2397),
    [anon_sym_GT_AMP] = ACTIONS(2397),
    [sym__special_characters] = ACTIONS(3322),
    [anon_sym_DQUOTE] = ACTIONS(2397),
    [sym_raw_string] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [anon_sym_LT_LPAREN] = ACTIONS(2397),
    [anon_sym_GT_LPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3322),
  },
  [2078] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4680),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2079] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [sym_variable_name] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(2403),
    [anon_sym_AMP_GT] = ACTIONS(3326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_AMP] = ACTIONS(2403),
    [anon_sym_GT_AMP] = ACTIONS(2403),
    [sym__special_characters] = ACTIONS(3326),
    [anon_sym_DQUOTE] = ACTIONS(2403),
    [sym_raw_string] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [anon_sym_LT_LPAREN] = ACTIONS(2403),
    [anon_sym_GT_LPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3326),
  },
  [2080] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4682),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2081] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4672),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2082] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [sym_variable_name] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(2409),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(2409),
    [anon_sym_LT_AMP] = ACTIONS(2409),
    [anon_sym_GT_AMP] = ACTIONS(2409),
    [sym__special_characters] = ACTIONS(3330),
    [anon_sym_DQUOTE] = ACTIONS(2409),
    [sym_raw_string] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [anon_sym_LT_LPAREN] = ACTIONS(2409),
    [anon_sym_GT_LPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(3330),
  },
  [2083] = {
    [aux_sym_concatenation_repeat1] = STATE(2086),
    [sym__concat] = ACTIONS(4270),
    [anon_sym_PIPE] = ACTIONS(924),
    [anon_sym_PIPE_AMP] = ACTIONS(922),
    [anon_sym_AMP_AMP] = ACTIONS(922),
    [anon_sym_PIPE_PIPE] = ACTIONS(922),
    [anon_sym_BQUOTE] = ACTIONS(922),
    [sym_comment] = ACTIONS(48),
  },
  [2084] = {
    [aux_sym_concatenation_repeat1] = STATE(2086),
    [sym__concat] = ACTIONS(4270),
    [anon_sym_PIPE] = ACTIONS(928),
    [anon_sym_PIPE_AMP] = ACTIONS(926),
    [anon_sym_AMP_AMP] = ACTIONS(926),
    [anon_sym_PIPE_PIPE] = ACTIONS(926),
    [anon_sym_BQUOTE] = ACTIONS(926),
    [sym_comment] = ACTIONS(48),
  },
  [2085] = {
    [sym_string] = STATE(2286),
    [sym_simple_expansion] = STATE(2286),
    [sym_expansion] = STATE(2286),
    [sym_command_substitution] = STATE(2286),
    [sym_process_substitution] = STATE(2286),
    [sym__special_characters] = ACTIONS(4684),
    [anon_sym_DQUOTE] = ACTIONS(3624),
    [sym_raw_string] = ACTIONS(4686),
    [anon_sym_DOLLAR] = ACTIONS(3628),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3630),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3632),
    [anon_sym_BQUOTE] = ACTIONS(3634),
    [anon_sym_LT_LPAREN] = ACTIONS(3636),
    [anon_sym_GT_LPAREN] = ACTIONS(3636),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4684),
  },
  [2086] = {
    [aux_sym_concatenation_repeat1] = STATE(2287),
    [sym__concat] = ACTIONS(4270),
    [anon_sym_PIPE] = ACTIONS(1270),
    [anon_sym_PIPE_AMP] = ACTIONS(538),
    [anon_sym_AMP_AMP] = ACTIONS(538),
    [anon_sym_PIPE_PIPE] = ACTIONS(538),
    [anon_sym_BQUOTE] = ACTIONS(538),
    [sym_comment] = ACTIONS(48),
  },
  [2087] = {
    [sym__concat] = ACTIONS(542),
    [anon_sym_PIPE] = ACTIONS(1272),
    [anon_sym_PIPE_AMP] = ACTIONS(542),
    [anon_sym_AMP_AMP] = ACTIONS(542),
    [anon_sym_PIPE_PIPE] = ACTIONS(542),
    [anon_sym_BQUOTE] = ACTIONS(542),
    [sym_comment] = ACTIONS(48),
  },
  [2088] = {
    [sym_simple_expansion] = STATE(94),
    [sym_expansion] = STATE(94),
    [sym_command_substitution] = STATE(94),
    [aux_sym_string_repeat1] = STATE(326),
    [anon_sym_DQUOTE] = ACTIONS(4688),
    [sym__string_content] = ACTIONS(158),
    [anon_sym_DOLLAR] = ACTIONS(160),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(162),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(164),
    [anon_sym_BQUOTE] = ACTIONS(166),
    [sym_comment] = ACTIONS(128),
  },
  [2089] = {
    [sym__concat] = ACTIONS(572),
    [anon_sym_PIPE] = ACTIONS(1276),
    [anon_sym_PIPE_AMP] = ACTIONS(572),
    [anon_sym_AMP_AMP] = ACTIONS(572),
    [anon_sym_PIPE_PIPE] = ACTIONS(572),
    [anon_sym_BQUOTE] = ACTIONS(572),
    [sym_comment] = ACTIONS(48),
  },
  [2090] = {
    [sym__concat] = ACTIONS(576),
    [anon_sym_PIPE] = ACTIONS(1278),
    [anon_sym_PIPE_AMP] = ACTIONS(576),
    [anon_sym_AMP_AMP] = ACTIONS(576),
    [anon_sym_PIPE_PIPE] = ACTIONS(576),
    [anon_sym_BQUOTE] = ACTIONS(576),
    [sym_comment] = ACTIONS(48),
  },
  [2091] = {
    [sym__concat] = ACTIONS(580),
    [anon_sym_PIPE] = ACTIONS(1280),
    [anon_sym_PIPE_AMP] = ACTIONS(580),
    [anon_sym_AMP_AMP] = ACTIONS(580),
    [anon_sym_PIPE_PIPE] = ACTIONS(580),
    [anon_sym_BQUOTE] = ACTIONS(580),
    [sym_comment] = ACTIONS(48),
  },
  [2092] = {
    [anon_sym_EQ] = ACTIONS(4690),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [2093] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2291),
    [anon_sym_RBRACE] = ACTIONS(4692),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2094] = {
    [sym_subscript] = STATE(2295),
    [sym_variable_name] = ACTIONS(4694),
    [anon_sym_DOLLAR] = ACTIONS(4696),
    [anon_sym_DASH] = ACTIONS(4696),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4698),
    [anon_sym_STAR] = ACTIONS(4696),
    [anon_sym_AT] = ACTIONS(4696),
    [anon_sym_QMARK] = ACTIONS(4696),
    [anon_sym_0] = ACTIONS(4700),
    [anon_sym__] = ACTIONS(4700),
  },
  [2095] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2297),
    [anon_sym_RBRACE] = ACTIONS(4702),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2096] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2299),
    [anon_sym_RBRACE] = ACTIONS(4704),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2097] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4706),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [2098] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4706),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [2099] = {
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_BQUOTE] = ACTIONS(4706),
    [sym_comment] = ACTIONS(48),
  },
  [2100] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(764),
    [anon_sym_PIPE_AMP] = ACTIONS(766),
    [anon_sym_AMP_AMP] = ACTIONS(768),
    [anon_sym_PIPE_PIPE] = ACTIONS(768),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(4706),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [2101] = {
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4708),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [sym_comment] = ACTIONS(48),
  },
  [2102] = {
    [sym_file_descriptor] = ACTIONS(290),
    [sym_variable_name] = ACTIONS(290),
    [anon_sym_PIPE] = ACTIONS(688),
    [anon_sym_RPAREN] = ACTIONS(4708),
    [anon_sym_PIPE_AMP] = ACTIONS(692),
    [anon_sym_AMP_AMP] = ACTIONS(694),
    [anon_sym_PIPE_PIPE] = ACTIONS(694),
    [anon_sym_LT] = ACTIONS(294),
    [anon_sym_GT] = ACTIONS(294),
    [anon_sym_GT_GT] = ACTIONS(290),
    [anon_sym_AMP_GT] = ACTIONS(294),
    [anon_sym_AMP_GT_GT] = ACTIONS(290),
    [anon_sym_LT_AMP] = ACTIONS(290),
    [anon_sym_GT_AMP] = ACTIONS(290),
    [sym__special_characters] = ACTIONS(294),
    [anon_sym_DQUOTE] = ACTIONS(290),
    [sym_raw_string] = ACTIONS(290),
    [anon_sym_DOLLAR] = ACTIONS(294),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(290),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(290),
    [anon_sym_BQUOTE] = ACTIONS(290),
    [anon_sym_LT_LPAREN] = ACTIONS(290),
    [anon_sym_GT_LPAREN] = ACTIONS(290),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(294),
  },
  [2103] = {
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4044),
    [sym_word] = ACTIONS(3352),
  },
  [2104] = {
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4046),
    [sym_word] = ACTIONS(3358),
  },
  [2105] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4710),
    [sym_comment] = ACTIONS(48),
  },
  [2106] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4712),
    [sym_comment] = ACTIONS(48),
  },
  [2107] = {
    [anon_sym_RBRACE] = ACTIONS(4712),
    [sym_comment] = ACTIONS(48),
  },
  [2108] = {
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4052),
    [sym_word] = ACTIONS(3423),
  },
  [2109] = {
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4054),
    [sym_word] = ACTIONS(3427),
  },
  [2110] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(4546),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_AMP_GT] = ACTIONS(4546),
    [anon_sym_AMP_GT_GT] = ACTIONS(4107),
    [anon_sym_LT_AMP] = ACTIONS(4107),
    [anon_sym_GT_AMP] = ACTIONS(4107),
    [anon_sym_LT_LT] = ACTIONS(4546),
    [anon_sym_LT_LT_DASH] = ACTIONS(4107),
    [anon_sym_LT_LT_LT] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4546),
  },
  [2111] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4548),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4548),
  },
  [2112] = {
    [sym_file_descriptor] = ACTIONS(2288),
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(2288),
    [anon_sym_AMP_GT] = ACTIONS(3308),
    [anon_sym_AMP_GT_GT] = ACTIONS(2288),
    [anon_sym_LT_AMP] = ACTIONS(2288),
    [anon_sym_GT_AMP] = ACTIONS(2288),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_LT_LT_DASH] = ACTIONS(2288),
    [anon_sym_LT_LT_LT] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [2113] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4714),
    [sym_comment] = ACTIONS(48),
  },
  [2114] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4716),
    [sym_comment] = ACTIONS(48),
  },
  [2115] = {
    [anon_sym_RBRACE] = ACTIONS(4716),
    [sym_comment] = ACTIONS(48),
  },
  [2116] = {
    [sym_file_descriptor] = ACTIONS(2352),
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [anon_sym_LT] = ACTIONS(3314),
    [anon_sym_GT] = ACTIONS(3314),
    [anon_sym_GT_GT] = ACTIONS(2352),
    [anon_sym_AMP_GT] = ACTIONS(3314),
    [anon_sym_AMP_GT_GT] = ACTIONS(2352),
    [anon_sym_LT_AMP] = ACTIONS(2352),
    [anon_sym_GT_AMP] = ACTIONS(2352),
    [anon_sym_LT_LT] = ACTIONS(3314),
    [anon_sym_LT_LT_DASH] = ACTIONS(2352),
    [anon_sym_LT_LT_LT] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [2117] = {
    [sym_concatenation] = STATE(2308),
    [sym_string] = STATE(2307),
    [sym_simple_expansion] = STATE(2307),
    [sym_expansion] = STATE(2307),
    [sym_command_substitution] = STATE(2307),
    [sym_process_substitution] = STATE(2307),
    [anon_sym_RBRACE] = ACTIONS(4716),
    [sym__special_characters] = ACTIONS(4718),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4720),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4722),
  },
  [2118] = {
    [sym_file_descriptor] = ACTIONS(2397),
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(2397),
    [anon_sym_AMP_GT] = ACTIONS(3322),
    [anon_sym_AMP_GT_GT] = ACTIONS(2397),
    [anon_sym_LT_AMP] = ACTIONS(2397),
    [anon_sym_GT_AMP] = ACTIONS(2397),
    [anon_sym_LT_LT] = ACTIONS(3322),
    [anon_sym_LT_LT_DASH] = ACTIONS(2397),
    [anon_sym_LT_LT_LT] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [2119] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4724),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2120] = {
    [sym_file_descriptor] = ACTIONS(2403),
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(2403),
    [anon_sym_AMP_GT] = ACTIONS(3326),
    [anon_sym_AMP_GT_GT] = ACTIONS(2403),
    [anon_sym_LT_AMP] = ACTIONS(2403),
    [anon_sym_GT_AMP] = ACTIONS(2403),
    [anon_sym_LT_LT] = ACTIONS(3326),
    [anon_sym_LT_LT_DASH] = ACTIONS(2403),
    [anon_sym_LT_LT_LT] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [2121] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4726),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2122] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4716),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2123] = {
    [sym_file_descriptor] = ACTIONS(2409),
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(2409),
    [anon_sym_AMP_GT] = ACTIONS(3330),
    [anon_sym_AMP_GT_GT] = ACTIONS(2409),
    [anon_sym_LT_AMP] = ACTIONS(2409),
    [anon_sym_GT_AMP] = ACTIONS(2409),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_LT_LT_DASH] = ACTIONS(2409),
    [anon_sym_LT_LT_LT] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [2124] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT_GT] = ACTIONS(3352),
    [anon_sym_LT_AMP] = ACTIONS(3352),
    [anon_sym_GT_AMP] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_LT_LT_DASH] = ACTIONS(3352),
    [anon_sym_LT_LT_LT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [2125] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT_GT] = ACTIONS(3358),
    [anon_sym_LT_AMP] = ACTIONS(3358),
    [anon_sym_GT_AMP] = ACTIONS(3358),
    [anon_sym_LT_LT] = ACTIONS(3358),
    [anon_sym_LT_LT_DASH] = ACTIONS(3358),
    [anon_sym_LT_LT_LT] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [2126] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4728),
    [sym_comment] = ACTIONS(48),
  },
  [2127] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4730),
    [sym_comment] = ACTIONS(48),
  },
  [2128] = {
    [anon_sym_RBRACE] = ACTIONS(4730),
    [sym_comment] = ACTIONS(48),
  },
  [2129] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_AMP] = ACTIONS(3423),
    [anon_sym_GT_AMP] = ACTIONS(3423),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_LT_LT_DASH] = ACTIONS(3423),
    [anon_sym_LT_LT_LT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [2130] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_GT_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_AMP] = ACTIONS(3427),
    [anon_sym_GT_AMP] = ACTIONS(3427),
    [anon_sym_LT_LT] = ACTIONS(3427),
    [anon_sym_LT_LT_DASH] = ACTIONS(3427),
    [anon_sym_LT_LT_LT] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [2131] = {
    [sym__heredoc_middle] = ACTIONS(1333),
    [sym__heredoc_end] = ACTIONS(1333),
    [anon_sym_DOLLAR] = ACTIONS(2238),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [2132] = {
    [sym__heredoc_middle] = ACTIONS(2288),
    [sym__heredoc_end] = ACTIONS(2288),
    [anon_sym_DOLLAR] = ACTIONS(3308),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [2133] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [sym_comment] = ACTIONS(48),
  },
  [2134] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [sym_comment] = ACTIONS(48),
  },
  [2135] = {
    [anon_sym_RBRACE] = ACTIONS(4734),
    [sym_comment] = ACTIONS(48),
  },
  [2136] = {
    [sym__heredoc_middle] = ACTIONS(2352),
    [sym__heredoc_end] = ACTIONS(2352),
    [anon_sym_DOLLAR] = ACTIONS(3314),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [2137] = {
    [sym_concatenation] = STATE(2317),
    [sym_string] = STATE(2316),
    [sym_simple_expansion] = STATE(2316),
    [sym_expansion] = STATE(2316),
    [sym_command_substitution] = STATE(2316),
    [sym_process_substitution] = STATE(2316),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [sym__special_characters] = ACTIONS(4736),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4738),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4740),
  },
  [2138] = {
    [sym__heredoc_middle] = ACTIONS(2397),
    [sym__heredoc_end] = ACTIONS(2397),
    [anon_sym_DOLLAR] = ACTIONS(3322),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [2139] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4742),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2140] = {
    [sym__heredoc_middle] = ACTIONS(2403),
    [sym__heredoc_end] = ACTIONS(2403),
    [anon_sym_DOLLAR] = ACTIONS(3326),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [2141] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4744),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2142] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4734),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2143] = {
    [sym__heredoc_middle] = ACTIONS(2409),
    [sym__heredoc_end] = ACTIONS(2409),
    [anon_sym_DOLLAR] = ACTIONS(3330),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [2144] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4044),
  },
  [2145] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4046),
  },
  [2146] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4746),
    [sym_comment] = ACTIONS(48),
  },
  [2147] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4748),
    [sym_comment] = ACTIONS(48),
  },
  [2148] = {
    [anon_sym_RBRACE] = ACTIONS(4748),
    [sym_comment] = ACTIONS(48),
  },
  [2149] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4052),
  },
  [2150] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4054),
  },
  [2151] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_AMP] = ACTIONS(4109),
    [anon_sym_GT_AMP] = ACTIONS(4109),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_raw_string] = ACTIONS(4109),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LT_LPAREN] = ACTIONS(4109),
    [anon_sym_GT_LPAREN] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2152] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4113),
    [anon_sym_LT_AMP] = ACTIONS(4113),
    [anon_sym_GT_AMP] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_raw_string] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [anon_sym_LT_LPAREN] = ACTIONS(4113),
    [anon_sym_GT_LPAREN] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2153] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_RBRACK] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2154] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RBRACK] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
  [2155] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [anon_sym_LT_LPAREN] = ACTIONS(3352),
    [anon_sym_GT_LPAREN] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [2156] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym_raw_string] = ACTIONS(3358),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [anon_sym_LT_LPAREN] = ACTIONS(3358),
    [anon_sym_GT_LPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [2157] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4750),
    [sym_comment] = ACTIONS(48),
  },
  [2158] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4752),
    [sym_comment] = ACTIONS(48),
  },
  [2159] = {
    [anon_sym_RBRACE] = ACTIONS(4752),
    [sym_comment] = ACTIONS(48),
  },
  [2160] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [2161] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_raw_string] = ACTIONS(3427),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [anon_sym_LT_LPAREN] = ACTIONS(3427),
    [anon_sym_GT_LPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [2162] = {
    [anon_sym_PIPE] = ACTIONS(3069),
    [anon_sym_RPAREN] = ACTIONS(3069),
    [anon_sym_SEMI_SEMI] = ACTIONS(3069),
    [anon_sym_PIPE_AMP] = ACTIONS(3069),
    [anon_sym_AMP_AMP] = ACTIONS(3069),
    [anon_sym_PIPE_PIPE] = ACTIONS(3069),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3069),
    [anon_sym_LF] = ACTIONS(3069),
    [anon_sym_AMP] = ACTIONS(3069),
  },
  [2163] = {
    [sym_file_descriptor] = ACTIONS(790),
    [sym_variable_name] = ACTIONS(790),
    [anon_sym_for] = ACTIONS(792),
    [anon_sym_while] = ACTIONS(792),
    [anon_sym_if] = ACTIONS(792),
    [anon_sym_case] = ACTIONS(792),
    [anon_sym_esac] = ACTIONS(792),
    [anon_sym_SEMI_SEMI] = ACTIONS(790),
    [anon_sym_function] = ACTIONS(792),
    [anon_sym_LPAREN] = ACTIONS(790),
    [anon_sym_declare] = ACTIONS(792),
    [anon_sym_typeset] = ACTIONS(792),
    [anon_sym_export] = ACTIONS(792),
    [anon_sym_readonly] = ACTIONS(792),
    [anon_sym_local] = ACTIONS(792),
    [anon_sym_LT] = ACTIONS(792),
    [anon_sym_GT] = ACTIONS(792),
    [anon_sym_GT_GT] = ACTIONS(790),
    [anon_sym_AMP_GT] = ACTIONS(792),
    [anon_sym_AMP_GT_GT] = ACTIONS(790),
    [anon_sym_LT_AMP] = ACTIONS(790),
    [anon_sym_GT_AMP] = ACTIONS(790),
    [sym__special_characters] = ACTIONS(792),
    [anon_sym_DQUOTE] = ACTIONS(790),
    [sym_raw_string] = ACTIONS(790),
    [anon_sym_DOLLAR] = ACTIONS(792),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(790),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(790),
    [anon_sym_BQUOTE] = ACTIONS(790),
    [anon_sym_LT_LPAREN] = ACTIONS(790),
    [anon_sym_GT_LPAREN] = ACTIONS(790),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(794),
  },
  [2164] = {
    [anon_sym_esac] = ACTIONS(4754),
    [sym__special_characters] = ACTIONS(4756),
    [anon_sym_DQUOTE] = ACTIONS(4758),
    [sym_raw_string] = ACTIONS(4758),
    [anon_sym_DOLLAR] = ACTIONS(4756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4758),
    [anon_sym_BQUOTE] = ACTIONS(4758),
    [anon_sym_LT_LPAREN] = ACTIONS(4758),
    [anon_sym_GT_LPAREN] = ACTIONS(4758),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4760),
  },
  [2165] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2165),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_esac] = ACTIONS(3071),
    [anon_sym_SEMI_SEMI] = ACTIONS(848),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [2166] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2165),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4754),
    [anon_sym_SEMI_SEMI] = ACTIONS(4762),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2167] = {
    [anon_sym_esac] = ACTIONS(4764),
    [sym__special_characters] = ACTIONS(4766),
    [anon_sym_DQUOTE] = ACTIONS(4768),
    [sym_raw_string] = ACTIONS(4768),
    [anon_sym_DOLLAR] = ACTIONS(4766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4768),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4768),
    [anon_sym_BQUOTE] = ACTIONS(4768),
    [anon_sym_LT_LPAREN] = ACTIONS(4768),
    [anon_sym_GT_LPAREN] = ACTIONS(4768),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4770),
  },
  [2168] = {
    [sym__terminated_statement] = STATE(1874),
    [sym_for_statement] = STATE(1875),
    [sym_while_statement] = STATE(1875),
    [sym_if_statement] = STATE(1875),
    [sym_case_statement] = STATE(1875),
    [sym_function_definition] = STATE(1875),
    [sym_subshell] = STATE(1875),
    [sym_pipeline] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_command] = STATE(1875),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(1876),
    [sym_declaration_command] = STATE(1875),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2165),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_esac] = ACTIONS(4764),
    [anon_sym_SEMI_SEMI] = ACTIONS(4772),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2169] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2288),
    [anon_sym_RPAREN] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [2170] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4774),
    [sym_comment] = ACTIONS(48),
  },
  [2171] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4776),
    [sym_comment] = ACTIONS(48),
  },
  [2172] = {
    [anon_sym_RBRACE] = ACTIONS(4776),
    [sym_comment] = ACTIONS(48),
  },
  [2173] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2352),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [2174] = {
    [sym_concatenation] = STATE(2330),
    [sym_string] = STATE(2329),
    [sym_simple_expansion] = STATE(2329),
    [sym_expansion] = STATE(2329),
    [sym_command_substitution] = STATE(2329),
    [sym_process_substitution] = STATE(2329),
    [anon_sym_RBRACE] = ACTIONS(4776),
    [sym__special_characters] = ACTIONS(4778),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4780),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4782),
  },
  [2175] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2397),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [2176] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4784),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2177] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2403),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [2178] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4786),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2179] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4776),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2180] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [2181] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2334),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(4788),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2182] = {
    [aux_sym_case_item_repeat1] = STATE(1879),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(4790),
    [sym_comment] = ACTIONS(48),
  },
  [2183] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2337),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(4792),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2184] = {
    [aux_sym_case_item_repeat1] = STATE(1879),
    [anon_sym_PIPE] = ACTIONS(3092),
    [anon_sym_RPAREN] = ACTIONS(4794),
    [sym_comment] = ACTIONS(48),
  },
  [2185] = {
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_RPAREN] = ACTIONS(4796),
    [anon_sym_SEMI_SEMI] = ACTIONS(4796),
    [anon_sym_PIPE_AMP] = ACTIONS(4796),
    [anon_sym_AMP_AMP] = ACTIONS(4796),
    [anon_sym_PIPE_PIPE] = ACTIONS(4796),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4796),
    [anon_sym_LF] = ACTIONS(4796),
    [anon_sym_AMP] = ACTIONS(4796),
  },
  [2186] = {
    [anon_sym_PIPE] = ACTIONS(4798),
    [anon_sym_RPAREN] = ACTIONS(4798),
    [anon_sym_SEMI_SEMI] = ACTIONS(4798),
    [anon_sym_PIPE_AMP] = ACTIONS(4798),
    [anon_sym_AMP_AMP] = ACTIONS(4798),
    [anon_sym_PIPE_PIPE] = ACTIONS(4798),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4798),
    [anon_sym_LF] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4798),
  },
  [2187] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [2188] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [sym_comment] = ACTIONS(48),
  },
  [2189] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4802),
    [sym_comment] = ACTIONS(48),
  },
  [2190] = {
    [anon_sym_RBRACE] = ACTIONS(4802),
    [sym_comment] = ACTIONS(48),
  },
  [2191] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [2192] = {
    [sym_concatenation] = STATE(2343),
    [sym_string] = STATE(2342),
    [sym_simple_expansion] = STATE(2342),
    [sym_expansion] = STATE(2342),
    [sym_command_substitution] = STATE(2342),
    [sym_process_substitution] = STATE(2342),
    [anon_sym_RBRACE] = ACTIONS(4802),
    [sym__special_characters] = ACTIONS(4804),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4806),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4808),
  },
  [2193] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [2194] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4810),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2195] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [2196] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2197] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4802),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2198] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [2199] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT_GT] = ACTIONS(3352),
    [anon_sym_LT_AMP] = ACTIONS(3352),
    [anon_sym_GT_AMP] = ACTIONS(3352),
    [sym__special_characters] = ACTIONS(3352),
    [anon_sym_DQUOTE] = ACTIONS(3352),
    [sym_raw_string] = ACTIONS(3352),
    [anon_sym_DOLLAR] = ACTIONS(3352),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3352),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3352),
    [anon_sym_BQUOTE] = ACTIONS(3352),
    [anon_sym_LT_LPAREN] = ACTIONS(3352),
    [anon_sym_GT_LPAREN] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3352),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [2200] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT_GT] = ACTIONS(3358),
    [anon_sym_LT_AMP] = ACTIONS(3358),
    [anon_sym_GT_AMP] = ACTIONS(3358),
    [sym__special_characters] = ACTIONS(3358),
    [anon_sym_DQUOTE] = ACTIONS(3358),
    [sym_raw_string] = ACTIONS(3358),
    [anon_sym_DOLLAR] = ACTIONS(3358),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3358),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3358),
    [anon_sym_BQUOTE] = ACTIONS(3358),
    [anon_sym_LT_LPAREN] = ACTIONS(3358),
    [anon_sym_GT_LPAREN] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3358),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [2201] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4814),
    [sym_comment] = ACTIONS(48),
  },
  [2202] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [sym_comment] = ACTIONS(48),
  },
  [2203] = {
    [anon_sym_RBRACE] = ACTIONS(4816),
    [sym_comment] = ACTIONS(48),
  },
  [2204] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_AMP] = ACTIONS(3423),
    [anon_sym_GT_AMP] = ACTIONS(3423),
    [sym__special_characters] = ACTIONS(3423),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [sym_raw_string] = ACTIONS(3423),
    [anon_sym_DOLLAR] = ACTIONS(3423),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3423),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3423),
    [anon_sym_BQUOTE] = ACTIONS(3423),
    [anon_sym_LT_LPAREN] = ACTIONS(3423),
    [anon_sym_GT_LPAREN] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3423),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [2205] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_RPAREN] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_GT_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_AMP] = ACTIONS(3427),
    [anon_sym_GT_AMP] = ACTIONS(3427),
    [sym__special_characters] = ACTIONS(3427),
    [anon_sym_DQUOTE] = ACTIONS(3427),
    [sym_raw_string] = ACTIONS(3427),
    [anon_sym_DOLLAR] = ACTIONS(3427),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3427),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3427),
    [anon_sym_BQUOTE] = ACTIONS(3427),
    [anon_sym_LT_LPAREN] = ACTIONS(3427),
    [anon_sym_GT_LPAREN] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(3427),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [2206] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [2207] = {
    [aux_sym_concatenation_repeat1] = STATE(2207),
    [sym__concat] = ACTIONS(4818),
    [anon_sym_PIPE] = ACTIONS(1304),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_SEMI_SEMI] = ACTIONS(1304),
    [anon_sym_PIPE_AMP] = ACTIONS(1304),
    [anon_sym_AMP_AMP] = ACTIONS(1304),
    [anon_sym_PIPE_PIPE] = ACTIONS(1304),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1304),
    [anon_sym_LF] = ACTIONS(1304),
    [anon_sym_AMP] = ACTIONS(1304),
  },
  [2208] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(1335),
    [anon_sym_RPAREN] = ACTIONS(1335),
    [anon_sym_SEMI_SEMI] = ACTIONS(1335),
    [anon_sym_PIPE_AMP] = ACTIONS(1335),
    [anon_sym_AMP_AMP] = ACTIONS(1335),
    [anon_sym_PIPE_PIPE] = ACTIONS(1335),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1335),
    [anon_sym_LF] = ACTIONS(1335),
    [anon_sym_AMP] = ACTIONS(1335),
  },
  [2209] = {
    [sym_concatenation] = STATE(2351),
    [sym_string] = STATE(2350),
    [sym_simple_expansion] = STATE(2350),
    [sym_expansion] = STATE(2350),
    [sym_command_substitution] = STATE(2350),
    [sym_process_substitution] = STATE(2350),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [sym__special_characters] = ACTIONS(4823),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4825),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4827),
  },
  [2210] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(1380),
    [anon_sym_RPAREN] = ACTIONS(1380),
    [anon_sym_SEMI_SEMI] = ACTIONS(1380),
    [anon_sym_PIPE_AMP] = ACTIONS(1380),
    [anon_sym_AMP_AMP] = ACTIONS(1380),
    [anon_sym_PIPE_PIPE] = ACTIONS(1380),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1380),
    [anon_sym_LF] = ACTIONS(1380),
    [anon_sym_AMP] = ACTIONS(1380),
  },
  [2211] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4829),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2212] = {
    [anon_sym_EQ] = ACTIONS(4831),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [2213] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2355),
    [anon_sym_RBRACE] = ACTIONS(4833),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2214] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2357),
    [anon_sym_RBRACE] = ACTIONS(4835),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2215] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2358),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2216] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(1424),
    [anon_sym_RPAREN] = ACTIONS(1424),
    [anon_sym_SEMI_SEMI] = ACTIONS(1424),
    [anon_sym_PIPE_AMP] = ACTIONS(1424),
    [anon_sym_AMP_AMP] = ACTIONS(1424),
    [anon_sym_PIPE_PIPE] = ACTIONS(1424),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1424),
    [anon_sym_LF] = ACTIONS(1424),
    [anon_sym_AMP] = ACTIONS(1424),
  },
  [2217] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4837),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2218] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(1430),
    [anon_sym_RPAREN] = ACTIONS(1430),
    [anon_sym_SEMI_SEMI] = ACTIONS(1430),
    [anon_sym_PIPE_AMP] = ACTIONS(1430),
    [anon_sym_AMP_AMP] = ACTIONS(1430),
    [anon_sym_PIPE_PIPE] = ACTIONS(1430),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1430),
    [anon_sym_LF] = ACTIONS(1430),
    [anon_sym_AMP] = ACTIONS(1430),
  },
  [2219] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4821),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2220] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(1540),
    [anon_sym_RPAREN] = ACTIONS(1540),
    [anon_sym_SEMI_SEMI] = ACTIONS(1540),
    [anon_sym_PIPE_AMP] = ACTIONS(1540),
    [anon_sym_AMP_AMP] = ACTIONS(1540),
    [anon_sym_PIPE_PIPE] = ACTIONS(1540),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1540),
    [anon_sym_LF] = ACTIONS(1540),
    [anon_sym_AMP] = ACTIONS(1540),
  },
  [2221] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1684),
    [anon_sym_RPAREN] = ACTIONS(1684),
    [anon_sym_SEMI_SEMI] = ACTIONS(1684),
    [anon_sym_PIPE_AMP] = ACTIONS(1684),
    [anon_sym_AMP_AMP] = ACTIONS(1684),
    [anon_sym_PIPE_PIPE] = ACTIONS(1684),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(1684),
    [anon_sym_LF] = ACTIONS(1684),
    [anon_sym_AMP] = ACTIONS(1684),
  },
  [2222] = {
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_raw_string] = ACTIONS(4109),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LT_LPAREN] = ACTIONS(4109),
    [anon_sym_GT_LPAREN] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4109),
    [sym_word] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2223] = {
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_raw_string] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [anon_sym_LT_LPAREN] = ACTIONS(4113),
    [anon_sym_GT_LPAREN] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4113),
    [sym_word] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2224] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT] = ACTIONS(3352),
    [anon_sym_AMP_GT_GT] = ACTIONS(3352),
    [anon_sym_LT_AMP] = ACTIONS(3352),
    [anon_sym_GT_AMP] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_LT_LT_DASH] = ACTIONS(3352),
    [anon_sym_LT_LT_LT] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [2225] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_LT] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3358),
    [anon_sym_GT_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT] = ACTIONS(3358),
    [anon_sym_AMP_GT_GT] = ACTIONS(3358),
    [anon_sym_LT_AMP] = ACTIONS(3358),
    [anon_sym_GT_AMP] = ACTIONS(3358),
    [anon_sym_LT_LT] = ACTIONS(3358),
    [anon_sym_LT_LT_DASH] = ACTIONS(3358),
    [anon_sym_LT_LT_LT] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [2226] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4839),
    [sym_comment] = ACTIONS(48),
  },
  [2227] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4841),
    [sym_comment] = ACTIONS(48),
  },
  [2228] = {
    [anon_sym_RBRACE] = ACTIONS(4841),
    [sym_comment] = ACTIONS(48),
  },
  [2229] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [anon_sym_LT] = ACTIONS(3423),
    [anon_sym_GT] = ACTIONS(3423),
    [anon_sym_GT_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT] = ACTIONS(3423),
    [anon_sym_AMP_GT_GT] = ACTIONS(3423),
    [anon_sym_LT_AMP] = ACTIONS(3423),
    [anon_sym_GT_AMP] = ACTIONS(3423),
    [anon_sym_LT_LT] = ACTIONS(3423),
    [anon_sym_LT_LT_DASH] = ACTIONS(3423),
    [anon_sym_LT_LT_LT] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [2230] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_RPAREN] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_GT_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT] = ACTIONS(3427),
    [anon_sym_AMP_GT_GT] = ACTIONS(3427),
    [anon_sym_LT_AMP] = ACTIONS(3427),
    [anon_sym_GT_AMP] = ACTIONS(3427),
    [anon_sym_LT_LT] = ACTIONS(3427),
    [anon_sym_LT_LT_DASH] = ACTIONS(3427),
    [anon_sym_LT_LT_LT] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [2231] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [2232] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [2233] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4843),
    [sym_comment] = ACTIONS(48),
  },
  [2234] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4845),
    [sym_comment] = ACTIONS(48),
  },
  [2235] = {
    [anon_sym_RBRACE] = ACTIONS(4845),
    [sym_comment] = ACTIONS(48),
  },
  [2236] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_RBRACE] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [2237] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_RBRACE] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [2238] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_RBRACE] = ACTIONS(4107),
    [anon_sym_EQ] = ACTIONS(4546),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_POUND] = ACTIONS(4107),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_COLON] = ACTIONS(4546),
    [anon_sym_COLON_QMARK] = ACTIONS(4546),
    [anon_sym_COLON_DASH] = ACTIONS(4546),
    [anon_sym_PERCENT] = ACTIONS(4546),
    [anon_sym_SLASH] = ACTIONS(4546),
    [anon_sym_DASH] = ACTIONS(4546),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4109),
  },
  [2239] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [anon_sym_EQ] = ACTIONS(4548),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_POUND] = ACTIONS(4111),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_COLON] = ACTIONS(4548),
    [anon_sym_COLON_QMARK] = ACTIONS(4548),
    [anon_sym_COLON_DASH] = ACTIONS(4548),
    [anon_sym_PERCENT] = ACTIONS(4548),
    [anon_sym_SLASH] = ACTIONS(4548),
    [anon_sym_DASH] = ACTIONS(4548),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4113),
  },
  [2240] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(3350),
    [anon_sym_LT_AMP] = ACTIONS(3350),
    [anon_sym_GT_AMP] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4044),
  },
  [2241] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(3356),
    [anon_sym_LT_AMP] = ACTIONS(3356),
    [anon_sym_GT_AMP] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4046),
  },
  [2242] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4847),
    [sym_comment] = ACTIONS(48),
  },
  [2243] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4849),
    [sym_comment] = ACTIONS(48),
  },
  [2244] = {
    [anon_sym_RBRACE] = ACTIONS(4849),
    [sym_comment] = ACTIONS(48),
  },
  [2245] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4052),
  },
  [2246] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT] = ACTIONS(4054),
    [anon_sym_AMP_GT_GT] = ACTIONS(3425),
    [anon_sym_LT_AMP] = ACTIONS(3425),
    [anon_sym_GT_AMP] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4054),
  },
  [2247] = {
    [anon_sym_PIPE] = ACTIONS(3461),
    [anon_sym_RPAREN] = ACTIONS(1926),
    [anon_sym_PIPE_AMP] = ACTIONS(1926),
    [anon_sym_AMP_AMP] = ACTIONS(1926),
    [anon_sym_PIPE_PIPE] = ACTIONS(1926),
    [anon_sym_BQUOTE] = ACTIONS(1926),
    [sym_comment] = ACTIONS(48),
  },
  [2248] = {
    [sym__terminated_statement] = STATE(538),
    [sym_for_statement] = STATE(539),
    [sym_while_statement] = STATE(539),
    [sym_if_statement] = STATE(539),
    [sym_case_statement] = STATE(539),
    [sym_function_definition] = STATE(539),
    [sym_subshell] = STATE(539),
    [sym_pipeline] = STATE(539),
    [sym_list] = STATE(539),
    [sym_command] = STATE(539),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(540),
    [sym_declaration_command] = STATE(539),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(1001),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_done] = ACTIONS(4851),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2249] = {
    [anon_sym_PIPE] = ACTIONS(4853),
    [anon_sym_RPAREN] = ACTIONS(4855),
    [anon_sym_PIPE_AMP] = ACTIONS(4855),
    [anon_sym_AMP_AMP] = ACTIONS(4855),
    [anon_sym_PIPE_PIPE] = ACTIONS(4855),
    [anon_sym_BQUOTE] = ACTIONS(4855),
    [sym_comment] = ACTIONS(48),
  },
  [2250] = {
    [anon_sym_PIPE] = ACTIONS(4857),
    [anon_sym_RPAREN] = ACTIONS(4859),
    [anon_sym_PIPE_AMP] = ACTIONS(4859),
    [anon_sym_AMP_AMP] = ACTIONS(4859),
    [anon_sym_PIPE_PIPE] = ACTIONS(4859),
    [anon_sym_BQUOTE] = ACTIONS(4859),
    [sym_comment] = ACTIONS(48),
  },
  [2251] = {
    [anon_sym_esac] = ACTIONS(4861),
    [sym_comment] = ACTIONS(48),
  },
  [2252] = {
    [anon_sym_PIPE] = ACTIONS(4863),
    [anon_sym_RPAREN] = ACTIONS(4865),
    [anon_sym_PIPE_AMP] = ACTIONS(4865),
    [anon_sym_AMP_AMP] = ACTIONS(4865),
    [anon_sym_PIPE_PIPE] = ACTIONS(4865),
    [anon_sym_BQUOTE] = ACTIONS(4865),
    [sym_comment] = ACTIONS(48),
  },
  [2253] = {
    [anon_sym_esac] = ACTIONS(4867),
    [sym_comment] = ACTIONS(48),
  },
  [2254] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [2255] = {
    [aux_sym_concatenation_repeat1] = STATE(2255),
    [sym__concat] = ACTIONS(4869),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_RPAREN] = ACTIONS(1302),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [2256] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_RPAREN] = ACTIONS(1333),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [2257] = {
    [sym_concatenation] = STATE(2372),
    [sym_string] = STATE(2371),
    [sym_simple_expansion] = STATE(2371),
    [sym_expansion] = STATE(2371),
    [sym_command_substitution] = STATE(2371),
    [sym_process_substitution] = STATE(2371),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [sym__special_characters] = ACTIONS(4874),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4876),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4878),
  },
  [2258] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_RPAREN] = ACTIONS(1378),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [2259] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4880),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2260] = {
    [anon_sym_EQ] = ACTIONS(4882),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [2261] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2376),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2262] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2378),
    [anon_sym_RBRACE] = ACTIONS(4886),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2263] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2379),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2264] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_RPAREN] = ACTIONS(1422),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [2265] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2266] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_RPAREN] = ACTIONS(1428),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [2267] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2268] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_RPAREN] = ACTIONS(1538),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
  },
  [2269] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_RPAREN] = ACTIONS(1682),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
  },
  [2270] = {
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_RPAREN] = ACTIONS(4107),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4546),
    [sym_word] = ACTIONS(4109),
  },
  [2271] = {
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4548),
    [sym_word] = ACTIONS(4113),
  },
  [2272] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(3350),
    [anon_sym_LT_AMP] = ACTIONS(3350),
    [anon_sym_GT_AMP] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT_LT] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [2273] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(3356),
    [anon_sym_LT_AMP] = ACTIONS(3356),
    [anon_sym_GT_AMP] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT_LT] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [2274] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4890),
    [sym_comment] = ACTIONS(48),
  },
  [2275] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [sym_comment] = ACTIONS(48),
  },
  [2276] = {
    [anon_sym_RBRACE] = ACTIONS(4892),
    [sym_comment] = ACTIONS(48),
  },
  [2277] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [2278] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT] = ACTIONS(4054),
    [anon_sym_AMP_GT_GT] = ACTIONS(3425),
    [anon_sym_LT_AMP] = ACTIONS(3425),
    [anon_sym_GT_AMP] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_LT_LT_DASH] = ACTIONS(3425),
    [anon_sym_LT_LT_LT] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [2279] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [sym_variable_name] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(3350),
    [anon_sym_LT_AMP] = ACTIONS(3350),
    [anon_sym_GT_AMP] = ACTIONS(3350),
    [sym__special_characters] = ACTIONS(4044),
    [anon_sym_DQUOTE] = ACTIONS(3350),
    [sym_raw_string] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [anon_sym_LT_LPAREN] = ACTIONS(3350),
    [anon_sym_GT_LPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4044),
  },
  [2280] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [sym_variable_name] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(3356),
    [anon_sym_LT_AMP] = ACTIONS(3356),
    [anon_sym_GT_AMP] = ACTIONS(3356),
    [sym__special_characters] = ACTIONS(4046),
    [anon_sym_DQUOTE] = ACTIONS(3356),
    [sym_raw_string] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [anon_sym_LT_LPAREN] = ACTIONS(3356),
    [anon_sym_GT_LPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4046),
  },
  [2281] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4894),
    [sym_comment] = ACTIONS(48),
  },
  [2282] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4896),
    [sym_comment] = ACTIONS(48),
  },
  [2283] = {
    [anon_sym_RBRACE] = ACTIONS(4896),
    [sym_comment] = ACTIONS(48),
  },
  [2284] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [sym_variable_name] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [sym__special_characters] = ACTIONS(4052),
    [anon_sym_DQUOTE] = ACTIONS(3421),
    [sym_raw_string] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [anon_sym_LT_LPAREN] = ACTIONS(3421),
    [anon_sym_GT_LPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4052),
  },
  [2285] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [sym_variable_name] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT] = ACTIONS(4054),
    [anon_sym_AMP_GT_GT] = ACTIONS(3425),
    [anon_sym_LT_AMP] = ACTIONS(3425),
    [anon_sym_GT_AMP] = ACTIONS(3425),
    [sym__special_characters] = ACTIONS(4054),
    [anon_sym_DQUOTE] = ACTIONS(3425),
    [sym_raw_string] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [anon_sym_LT_LPAREN] = ACTIONS(3425),
    [anon_sym_GT_LPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4054),
  },
  [2286] = {
    [sym__concat] = ACTIONS(1302),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [2287] = {
    [aux_sym_concatenation_repeat1] = STATE(2287),
    [sym__concat] = ACTIONS(4898),
    [anon_sym_PIPE] = ACTIONS(2233),
    [anon_sym_PIPE_AMP] = ACTIONS(1302),
    [anon_sym_AMP_AMP] = ACTIONS(1302),
    [anon_sym_PIPE_PIPE] = ACTIONS(1302),
    [anon_sym_BQUOTE] = ACTIONS(1302),
    [sym_comment] = ACTIONS(48),
  },
  [2288] = {
    [sym__concat] = ACTIONS(1333),
    [anon_sym_PIPE] = ACTIONS(2238),
    [anon_sym_PIPE_AMP] = ACTIONS(1333),
    [anon_sym_AMP_AMP] = ACTIONS(1333),
    [anon_sym_PIPE_PIPE] = ACTIONS(1333),
    [anon_sym_BQUOTE] = ACTIONS(1333),
    [sym_comment] = ACTIONS(48),
  },
  [2289] = {
    [sym_concatenation] = STATE(2388),
    [sym_string] = STATE(2387),
    [sym_simple_expansion] = STATE(2387),
    [sym_expansion] = STATE(2387),
    [sym_command_substitution] = STATE(2387),
    [sym_process_substitution] = STATE(2387),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [sym__special_characters] = ACTIONS(4903),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4905),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4907),
  },
  [2290] = {
    [sym__concat] = ACTIONS(1378),
    [anon_sym_PIPE] = ACTIONS(2248),
    [anon_sym_PIPE_AMP] = ACTIONS(1378),
    [anon_sym_AMP_AMP] = ACTIONS(1378),
    [anon_sym_PIPE_PIPE] = ACTIONS(1378),
    [anon_sym_BQUOTE] = ACTIONS(1378),
    [sym_comment] = ACTIONS(48),
  },
  [2291] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4909),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2292] = {
    [anon_sym_EQ] = ACTIONS(4911),
    [anon_sym_LBRACK] = ACTIONS(586),
    [sym_comment] = ACTIONS(48),
  },
  [2293] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2392),
    [anon_sym_RBRACE] = ACTIONS(4913),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2294] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2394),
    [anon_sym_RBRACE] = ACTIONS(4915),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2295] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(2395),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2296] = {
    [sym__concat] = ACTIONS(1422),
    [anon_sym_PIPE] = ACTIONS(2258),
    [anon_sym_PIPE_AMP] = ACTIONS(1422),
    [anon_sym_AMP_AMP] = ACTIONS(1422),
    [anon_sym_PIPE_PIPE] = ACTIONS(1422),
    [anon_sym_BQUOTE] = ACTIONS(1422),
    [sym_comment] = ACTIONS(48),
  },
  [2297] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4917),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2298] = {
    [sym__concat] = ACTIONS(1428),
    [anon_sym_PIPE] = ACTIONS(2262),
    [anon_sym_PIPE_AMP] = ACTIONS(1428),
    [anon_sym_AMP_AMP] = ACTIONS(1428),
    [anon_sym_PIPE_PIPE] = ACTIONS(1428),
    [anon_sym_BQUOTE] = ACTIONS(1428),
    [sym_comment] = ACTIONS(48),
  },
  [2299] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4901),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2300] = {
    [sym__concat] = ACTIONS(1538),
    [anon_sym_PIPE] = ACTIONS(2264),
    [anon_sym_PIPE_AMP] = ACTIONS(1538),
    [anon_sym_AMP_AMP] = ACTIONS(1538),
    [anon_sym_PIPE_PIPE] = ACTIONS(1538),
    [anon_sym_BQUOTE] = ACTIONS(1538),
    [sym_comment] = ACTIONS(48),
  },
  [2301] = {
    [sym__concat] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(2266),
    [anon_sym_PIPE_AMP] = ACTIONS(1682),
    [anon_sym_AMP_AMP] = ACTIONS(1682),
    [anon_sym_PIPE_PIPE] = ACTIONS(1682),
    [anon_sym_BQUOTE] = ACTIONS(1682),
    [sym_comment] = ACTIONS(48),
  },
  [2302] = {
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4546),
    [sym_word] = ACTIONS(4109),
  },
  [2303] = {
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [aux_sym_SLASH_BSLASHw_PLUS_SLASH] = ACTIONS(4548),
    [sym_word] = ACTIONS(4113),
  },
  [2304] = {
    [sym_file_descriptor] = ACTIONS(3350),
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_LT] = ACTIONS(4044),
    [anon_sym_GT] = ACTIONS(4044),
    [anon_sym_GT_GT] = ACTIONS(3350),
    [anon_sym_AMP_GT] = ACTIONS(4044),
    [anon_sym_AMP_GT_GT] = ACTIONS(3350),
    [anon_sym_LT_AMP] = ACTIONS(3350),
    [anon_sym_GT_AMP] = ACTIONS(3350),
    [anon_sym_LT_LT] = ACTIONS(4044),
    [anon_sym_LT_LT_DASH] = ACTIONS(3350),
    [anon_sym_LT_LT_LT] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [2305] = {
    [sym_file_descriptor] = ACTIONS(3356),
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(4046),
    [anon_sym_GT] = ACTIONS(4046),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_AMP_GT] = ACTIONS(4046),
    [anon_sym_AMP_GT_GT] = ACTIONS(3356),
    [anon_sym_LT_AMP] = ACTIONS(3356),
    [anon_sym_GT_AMP] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(4046),
    [anon_sym_LT_LT_DASH] = ACTIONS(3356),
    [anon_sym_LT_LT_LT] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [2306] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4919),
    [sym_comment] = ACTIONS(48),
  },
  [2307] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4921),
    [sym_comment] = ACTIONS(48),
  },
  [2308] = {
    [anon_sym_RBRACE] = ACTIONS(4921),
    [sym_comment] = ACTIONS(48),
  },
  [2309] = {
    [sym_file_descriptor] = ACTIONS(3421),
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_LT] = ACTIONS(4052),
    [anon_sym_GT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(3421),
    [anon_sym_AMP_GT] = ACTIONS(4052),
    [anon_sym_AMP_GT_GT] = ACTIONS(3421),
    [anon_sym_LT_AMP] = ACTIONS(3421),
    [anon_sym_GT_AMP] = ACTIONS(3421),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_LT_LT_DASH] = ACTIONS(3421),
    [anon_sym_LT_LT_LT] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [2310] = {
    [sym_file_descriptor] = ACTIONS(3425),
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [anon_sym_LT] = ACTIONS(4054),
    [anon_sym_GT] = ACTIONS(4054),
    [anon_sym_GT_GT] = ACTIONS(3425),
    [anon_sym_AMP_GT] = ACTIONS(4054),
    [anon_sym_AMP_GT_GT] = ACTIONS(3425),
    [anon_sym_LT_AMP] = ACTIONS(3425),
    [anon_sym_GT_AMP] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(4054),
    [anon_sym_LT_LT_DASH] = ACTIONS(3425),
    [anon_sym_LT_LT_LT] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [2311] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_AMP] = ACTIONS(4109),
    [anon_sym_GT_AMP] = ACTIONS(4109),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_LT_LT_DASH] = ACTIONS(4109),
    [anon_sym_LT_LT_LT] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2312] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4113),
    [anon_sym_LT_AMP] = ACTIONS(4113),
    [anon_sym_GT_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4113),
    [anon_sym_LT_LT_LT] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2313] = {
    [sym__heredoc_middle] = ACTIONS(3350),
    [sym__heredoc_end] = ACTIONS(3350),
    [anon_sym_DOLLAR] = ACTIONS(4044),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [2314] = {
    [sym__heredoc_middle] = ACTIONS(3356),
    [sym__heredoc_end] = ACTIONS(3356),
    [anon_sym_DOLLAR] = ACTIONS(4046),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [2315] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4923),
    [sym_comment] = ACTIONS(48),
  },
  [2316] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4925),
    [sym_comment] = ACTIONS(48),
  },
  [2317] = {
    [anon_sym_RBRACE] = ACTIONS(4925),
    [sym_comment] = ACTIONS(48),
  },
  [2318] = {
    [sym__heredoc_middle] = ACTIONS(3421),
    [sym__heredoc_end] = ACTIONS(3421),
    [anon_sym_DOLLAR] = ACTIONS(4052),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [2319] = {
    [sym__heredoc_middle] = ACTIONS(3425),
    [sym__heredoc_end] = ACTIONS(3425),
    [anon_sym_DOLLAR] = ACTIONS(4054),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [2320] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_RPAREN] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4546),
  },
  [2321] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4548),
  },
  [2322] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_raw_string] = ACTIONS(4109),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LT_LPAREN] = ACTIONS(4109),
    [anon_sym_GT_LPAREN] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2323] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_raw_string] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [anon_sym_LT_LPAREN] = ACTIONS(4113),
    [anon_sym_GT_LPAREN] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2324] = {
    [anon_sym_esac] = ACTIONS(4927),
    [sym__special_characters] = ACTIONS(4929),
    [anon_sym_DQUOTE] = ACTIONS(4931),
    [sym_raw_string] = ACTIONS(4931),
    [anon_sym_DOLLAR] = ACTIONS(4929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4931),
    [anon_sym_BQUOTE] = ACTIONS(4931),
    [anon_sym_LT_LPAREN] = ACTIONS(4931),
    [anon_sym_GT_LPAREN] = ACTIONS(4931),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4933),
  },
  [2325] = {
    [anon_sym_esac] = ACTIONS(4935),
    [sym__special_characters] = ACTIONS(4937),
    [anon_sym_DQUOTE] = ACTIONS(4939),
    [sym_raw_string] = ACTIONS(4939),
    [anon_sym_DOLLAR] = ACTIONS(4937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4939),
    [anon_sym_BQUOTE] = ACTIONS(4939),
    [anon_sym_LT_LPAREN] = ACTIONS(4939),
    [anon_sym_GT_LPAREN] = ACTIONS(4939),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4941),
  },
  [2326] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3350),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [2327] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [2328] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4943),
    [sym_comment] = ACTIONS(48),
  },
  [2329] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4945),
    [sym_comment] = ACTIONS(48),
  },
  [2330] = {
    [anon_sym_RBRACE] = ACTIONS(4945),
    [sym_comment] = ACTIONS(48),
  },
  [2331] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [2332] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3425),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [2333] = {
    [sym__special_characters] = ACTIONS(4411),
    [anon_sym_DQUOTE] = ACTIONS(4413),
    [sym_raw_string] = ACTIONS(4413),
    [anon_sym_DOLLAR] = ACTIONS(4411),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4413),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4413),
    [anon_sym_BQUOTE] = ACTIONS(4413),
    [anon_sym_LT_LPAREN] = ACTIONS(4413),
    [anon_sym_GT_LPAREN] = ACTIONS(4413),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4411),
  },
  [2334] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2404),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2335] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2405),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(4947),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2336] = {
    [sym__special_characters] = ACTIONS(4429),
    [anon_sym_DQUOTE] = ACTIONS(4431),
    [sym_raw_string] = ACTIONS(4431),
    [anon_sym_DOLLAR] = ACTIONS(4429),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4431),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4431),
    [anon_sym_BQUOTE] = ACTIONS(4431),
    [anon_sym_LT_LPAREN] = ACTIONS(4431),
    [anon_sym_GT_LPAREN] = ACTIONS(4431),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4429),
  },
  [2337] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2404),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(4949),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2338] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2407),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(4949),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2339] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [2340] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [2341] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4951),
    [sym_comment] = ACTIONS(48),
  },
  [2342] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(48),
  },
  [2343] = {
    [anon_sym_RBRACE] = ACTIONS(4953),
    [sym_comment] = ACTIONS(48),
  },
  [2344] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [2345] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [2346] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_AMP] = ACTIONS(4109),
    [anon_sym_GT_AMP] = ACTIONS(4109),
    [sym__special_characters] = ACTIONS(4109),
    [anon_sym_DQUOTE] = ACTIONS(4109),
    [sym_raw_string] = ACTIONS(4109),
    [anon_sym_DOLLAR] = ACTIONS(4109),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4109),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4109),
    [anon_sym_BQUOTE] = ACTIONS(4109),
    [anon_sym_LT_LPAREN] = ACTIONS(4109),
    [anon_sym_GT_LPAREN] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4109),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2347] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4113),
    [anon_sym_LT_AMP] = ACTIONS(4113),
    [anon_sym_GT_AMP] = ACTIONS(4113),
    [sym__special_characters] = ACTIONS(4113),
    [anon_sym_DQUOTE] = ACTIONS(4113),
    [sym_raw_string] = ACTIONS(4113),
    [anon_sym_DOLLAR] = ACTIONS(4113),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4113),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4113),
    [anon_sym_BQUOTE] = ACTIONS(4113),
    [anon_sym_LT_LPAREN] = ACTIONS(4113),
    [anon_sym_GT_LPAREN] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(4113),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2348] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(2290),
    [anon_sym_RPAREN] = ACTIONS(2290),
    [anon_sym_SEMI_SEMI] = ACTIONS(2290),
    [anon_sym_PIPE_AMP] = ACTIONS(2290),
    [anon_sym_AMP_AMP] = ACTIONS(2290),
    [anon_sym_PIPE_PIPE] = ACTIONS(2290),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_LF] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
  },
  [2349] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4955),
    [sym_comment] = ACTIONS(48),
  },
  [2350] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [sym_comment] = ACTIONS(48),
  },
  [2351] = {
    [anon_sym_RBRACE] = ACTIONS(4957),
    [sym_comment] = ACTIONS(48),
  },
  [2352] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(2354),
    [anon_sym_RPAREN] = ACTIONS(2354),
    [anon_sym_SEMI_SEMI] = ACTIONS(2354),
    [anon_sym_PIPE_AMP] = ACTIONS(2354),
    [anon_sym_AMP_AMP] = ACTIONS(2354),
    [anon_sym_PIPE_PIPE] = ACTIONS(2354),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_LF] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
  },
  [2353] = {
    [sym_concatenation] = STATE(2414),
    [sym_string] = STATE(2413),
    [sym_simple_expansion] = STATE(2413),
    [sym_expansion] = STATE(2413),
    [sym_command_substitution] = STATE(2413),
    [sym_process_substitution] = STATE(2413),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [sym__special_characters] = ACTIONS(4959),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4961),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4963),
  },
  [2354] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(2399),
    [anon_sym_RPAREN] = ACTIONS(2399),
    [anon_sym_SEMI_SEMI] = ACTIONS(2399),
    [anon_sym_PIPE_AMP] = ACTIONS(2399),
    [anon_sym_AMP_AMP] = ACTIONS(2399),
    [anon_sym_PIPE_PIPE] = ACTIONS(2399),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2399),
    [anon_sym_LF] = ACTIONS(2399),
    [anon_sym_AMP] = ACTIONS(2399),
  },
  [2355] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4965),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2356] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(2405),
    [anon_sym_RPAREN] = ACTIONS(2405),
    [anon_sym_SEMI_SEMI] = ACTIONS(2405),
    [anon_sym_PIPE_AMP] = ACTIONS(2405),
    [anon_sym_AMP_AMP] = ACTIONS(2405),
    [anon_sym_PIPE_PIPE] = ACTIONS(2405),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2405),
    [anon_sym_LF] = ACTIONS(2405),
    [anon_sym_AMP] = ACTIONS(2405),
  },
  [2357] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4967),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2358] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4957),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2359] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(2411),
    [anon_sym_RPAREN] = ACTIONS(2411),
    [anon_sym_SEMI_SEMI] = ACTIONS(2411),
    [anon_sym_PIPE_AMP] = ACTIONS(2411),
    [anon_sym_AMP_AMP] = ACTIONS(2411),
    [anon_sym_PIPE_PIPE] = ACTIONS(2411),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(2411),
    [anon_sym_LF] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2411),
  },
  [2360] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [anon_sym_LT] = ACTIONS(4109),
    [anon_sym_GT] = ACTIONS(4109),
    [anon_sym_GT_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT] = ACTIONS(4109),
    [anon_sym_AMP_GT_GT] = ACTIONS(4109),
    [anon_sym_LT_AMP] = ACTIONS(4109),
    [anon_sym_GT_AMP] = ACTIONS(4109),
    [anon_sym_LT_LT] = ACTIONS(4109),
    [anon_sym_LT_LT_DASH] = ACTIONS(4109),
    [anon_sym_LT_LT_LT] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2361] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [anon_sym_LT] = ACTIONS(4113),
    [anon_sym_GT] = ACTIONS(4113),
    [anon_sym_GT_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT] = ACTIONS(4113),
    [anon_sym_AMP_GT_GT] = ACTIONS(4113),
    [anon_sym_LT_AMP] = ACTIONS(4113),
    [anon_sym_GT_AMP] = ACTIONS(4113),
    [anon_sym_LT_LT] = ACTIONS(4113),
    [anon_sym_LT_LT_DASH] = ACTIONS(4113),
    [anon_sym_LT_LT_LT] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2362] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_RBRACE] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2363] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_RBRACE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
  [2364] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_RPAREN] = ACTIONS(4107),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(4546),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_AMP_GT] = ACTIONS(4546),
    [anon_sym_AMP_GT_GT] = ACTIONS(4107),
    [anon_sym_LT_AMP] = ACTIONS(4107),
    [anon_sym_GT_AMP] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4546),
  },
  [2365] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4548),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4548),
  },
  [2366] = {
    [anon_sym_PIPE] = ACTIONS(4140),
    [anon_sym_RPAREN] = ACTIONS(3067),
    [anon_sym_PIPE_AMP] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3067),
    [anon_sym_PIPE_PIPE] = ACTIONS(3067),
    [anon_sym_BQUOTE] = ACTIONS(3067),
    [sym_comment] = ACTIONS(48),
  },
  [2367] = {
    [anon_sym_PIPE] = ACTIONS(4969),
    [anon_sym_RPAREN] = ACTIONS(4971),
    [anon_sym_PIPE_AMP] = ACTIONS(4971),
    [anon_sym_AMP_AMP] = ACTIONS(4971),
    [anon_sym_PIPE_PIPE] = ACTIONS(4971),
    [anon_sym_BQUOTE] = ACTIONS(4971),
    [sym_comment] = ACTIONS(48),
  },
  [2368] = {
    [anon_sym_PIPE] = ACTIONS(4973),
    [anon_sym_RPAREN] = ACTIONS(4975),
    [anon_sym_PIPE_AMP] = ACTIONS(4975),
    [anon_sym_AMP_AMP] = ACTIONS(4975),
    [anon_sym_PIPE_PIPE] = ACTIONS(4975),
    [anon_sym_BQUOTE] = ACTIONS(4975),
    [sym_comment] = ACTIONS(48),
  },
  [2369] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_RPAREN] = ACTIONS(2288),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [2370] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4977),
    [sym_comment] = ACTIONS(48),
  },
  [2371] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [sym_comment] = ACTIONS(48),
  },
  [2372] = {
    [anon_sym_RBRACE] = ACTIONS(4979),
    [sym_comment] = ACTIONS(48),
  },
  [2373] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_RPAREN] = ACTIONS(2352),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [2374] = {
    [sym_concatenation] = STATE(2421),
    [sym_string] = STATE(2420),
    [sym_simple_expansion] = STATE(2420),
    [sym_expansion] = STATE(2420),
    [sym_command_substitution] = STATE(2420),
    [sym_process_substitution] = STATE(2420),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [sym__special_characters] = ACTIONS(4981),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4983),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4985),
  },
  [2375] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_RPAREN] = ACTIONS(2397),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [2376] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4987),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2377] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_RPAREN] = ACTIONS(2403),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [2378] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4989),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2379] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4979),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2380] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_RPAREN] = ACTIONS(2409),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [2381] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_RPAREN] = ACTIONS(4107),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(4546),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_AMP_GT] = ACTIONS(4546),
    [anon_sym_AMP_GT_GT] = ACTIONS(4107),
    [anon_sym_LT_AMP] = ACTIONS(4107),
    [anon_sym_GT_AMP] = ACTIONS(4107),
    [anon_sym_LT_LT] = ACTIONS(4546),
    [anon_sym_LT_LT_DASH] = ACTIONS(4107),
    [anon_sym_LT_LT_LT] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2382] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4548),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
  [2383] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [sym_variable_name] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(4546),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_AMP_GT] = ACTIONS(4546),
    [anon_sym_AMP_GT_GT] = ACTIONS(4107),
    [anon_sym_LT_AMP] = ACTIONS(4107),
    [anon_sym_GT_AMP] = ACTIONS(4107),
    [sym__special_characters] = ACTIONS(4546),
    [anon_sym_DQUOTE] = ACTIONS(4107),
    [sym_raw_string] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [anon_sym_LT_LPAREN] = ACTIONS(4107),
    [anon_sym_GT_LPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4546),
  },
  [2384] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [sym_variable_name] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4548),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [sym__special_characters] = ACTIONS(4548),
    [anon_sym_DQUOTE] = ACTIONS(4111),
    [sym_raw_string] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [anon_sym_LT_LPAREN] = ACTIONS(4111),
    [anon_sym_GT_LPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4548),
  },
  [2385] = {
    [sym__concat] = ACTIONS(2288),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_PIPE_AMP] = ACTIONS(2288),
    [anon_sym_AMP_AMP] = ACTIONS(2288),
    [anon_sym_PIPE_PIPE] = ACTIONS(2288),
    [anon_sym_BQUOTE] = ACTIONS(2288),
    [sym_comment] = ACTIONS(48),
  },
  [2386] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4991),
    [sym_comment] = ACTIONS(48),
  },
  [2387] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [sym_comment] = ACTIONS(48),
  },
  [2388] = {
    [anon_sym_RBRACE] = ACTIONS(4993),
    [sym_comment] = ACTIONS(48),
  },
  [2389] = {
    [sym__concat] = ACTIONS(2352),
    [anon_sym_PIPE] = ACTIONS(3314),
    [anon_sym_PIPE_AMP] = ACTIONS(2352),
    [anon_sym_AMP_AMP] = ACTIONS(2352),
    [anon_sym_PIPE_PIPE] = ACTIONS(2352),
    [anon_sym_BQUOTE] = ACTIONS(2352),
    [sym_comment] = ACTIONS(48),
  },
  [2390] = {
    [sym_concatenation] = STATE(2428),
    [sym_string] = STATE(2427),
    [sym_simple_expansion] = STATE(2427),
    [sym_expansion] = STATE(2427),
    [sym_command_substitution] = STATE(2427),
    [sym_process_substitution] = STATE(2427),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [sym__special_characters] = ACTIONS(4995),
    [anon_sym_DQUOTE] = ACTIONS(1356),
    [sym_raw_string] = ACTIONS(4997),
    [anon_sym_DOLLAR] = ACTIONS(1360),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(1362),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1364),
    [anon_sym_BQUOTE] = ACTIONS(1366),
    [anon_sym_LT_LPAREN] = ACTIONS(1368),
    [anon_sym_GT_LPAREN] = ACTIONS(1368),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4999),
  },
  [2391] = {
    [sym__concat] = ACTIONS(2397),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_PIPE_AMP] = ACTIONS(2397),
    [anon_sym_AMP_AMP] = ACTIONS(2397),
    [anon_sym_PIPE_PIPE] = ACTIONS(2397),
    [anon_sym_BQUOTE] = ACTIONS(2397),
    [sym_comment] = ACTIONS(48),
  },
  [2392] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(5001),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2393] = {
    [sym__concat] = ACTIONS(2403),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_PIPE_AMP] = ACTIONS(2403),
    [anon_sym_AMP_AMP] = ACTIONS(2403),
    [anon_sym_PIPE_PIPE] = ACTIONS(2403),
    [anon_sym_BQUOTE] = ACTIONS(2403),
    [sym_comment] = ACTIONS(48),
  },
  [2394] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(5003),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2395] = {
    [sym_concatenation] = STATE(330),
    [sym_string] = STATE(333),
    [sym_simple_expansion] = STATE(333),
    [sym_expansion] = STATE(333),
    [sym_command_substitution] = STATE(333),
    [sym_process_substitution] = STATE(333),
    [aux_sym_expansion_repeat1] = STATE(731),
    [anon_sym_RBRACE] = ACTIONS(4993),
    [anon_sym_EQ] = ACTIONS(590),
    [sym__special_characters] = ACTIONS(592),
    [anon_sym_DQUOTE] = ACTIONS(594),
    [sym_raw_string] = ACTIONS(596),
    [anon_sym_DOLLAR] = ACTIONS(598),
    [anon_sym_POUND] = ACTIONS(600),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(602),
    [anon_sym_COLON] = ACTIONS(590),
    [anon_sym_COLON_QMARK] = ACTIONS(590),
    [anon_sym_COLON_DASH] = ACTIONS(590),
    [anon_sym_PERCENT] = ACTIONS(590),
    [anon_sym_SLASH] = ACTIONS(590),
    [anon_sym_DASH] = ACTIONS(590),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(604),
    [anon_sym_BQUOTE] = ACTIONS(606),
    [anon_sym_LT_LPAREN] = ACTIONS(608),
    [anon_sym_GT_LPAREN] = ACTIONS(608),
    [sym_comment] = ACTIONS(128),
    [sym_word] = ACTIONS(610),
  },
  [2396] = {
    [sym__concat] = ACTIONS(2409),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_PIPE_AMP] = ACTIONS(2409),
    [anon_sym_AMP_AMP] = ACTIONS(2409),
    [anon_sym_PIPE_PIPE] = ACTIONS(2409),
    [anon_sym_BQUOTE] = ACTIONS(2409),
    [sym_comment] = ACTIONS(48),
  },
  [2397] = {
    [sym_file_descriptor] = ACTIONS(4107),
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [anon_sym_LT] = ACTIONS(4546),
    [anon_sym_GT] = ACTIONS(4546),
    [anon_sym_GT_GT] = ACTIONS(4107),
    [anon_sym_AMP_GT] = ACTIONS(4546),
    [anon_sym_AMP_GT_GT] = ACTIONS(4107),
    [anon_sym_LT_AMP] = ACTIONS(4107),
    [anon_sym_GT_AMP] = ACTIONS(4107),
    [anon_sym_LT_LT] = ACTIONS(4546),
    [anon_sym_LT_LT_DASH] = ACTIONS(4107),
    [anon_sym_LT_LT_LT] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2398] = {
    [sym_file_descriptor] = ACTIONS(4111),
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_LT] = ACTIONS(4548),
    [anon_sym_GT] = ACTIONS(4548),
    [anon_sym_GT_GT] = ACTIONS(4111),
    [anon_sym_AMP_GT] = ACTIONS(4548),
    [anon_sym_AMP_GT_GT] = ACTIONS(4111),
    [anon_sym_LT_AMP] = ACTIONS(4111),
    [anon_sym_GT_AMP] = ACTIONS(4111),
    [anon_sym_LT_LT] = ACTIONS(4548),
    [anon_sym_LT_LT_DASH] = ACTIONS(4111),
    [anon_sym_LT_LT_LT] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
  [2399] = {
    [sym__heredoc_middle] = ACTIONS(4107),
    [sym__heredoc_end] = ACTIONS(4107),
    [anon_sym_DOLLAR] = ACTIONS(4546),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2400] = {
    [sym__heredoc_middle] = ACTIONS(4111),
    [sym__heredoc_end] = ACTIONS(4111),
    [anon_sym_DOLLAR] = ACTIONS(4548),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
  [2401] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4107),
    [anon_sym_RPAREN] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2402] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4111),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
  [2403] = {
    [sym__special_characters] = ACTIONS(4756),
    [anon_sym_DQUOTE] = ACTIONS(4758),
    [sym_raw_string] = ACTIONS(4758),
    [anon_sym_DOLLAR] = ACTIONS(4756),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4758),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4758),
    [anon_sym_BQUOTE] = ACTIONS(4758),
    [anon_sym_LT_LPAREN] = ACTIONS(4758),
    [anon_sym_GT_LPAREN] = ACTIONS(4758),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4756),
  },
  [2404] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2404),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(842),
    [sym_variable_name] = ACTIONS(845),
    [anon_sym_for] = ACTIONS(850),
    [anon_sym_while] = ACTIONS(853),
    [anon_sym_if] = ACTIONS(856),
    [anon_sym_case] = ACTIONS(859),
    [anon_sym_SEMI_SEMI] = ACTIONS(848),
    [anon_sym_function] = ACTIONS(862),
    [anon_sym_LPAREN] = ACTIONS(865),
    [anon_sym_declare] = ACTIONS(868),
    [anon_sym_typeset] = ACTIONS(868),
    [anon_sym_export] = ACTIONS(868),
    [anon_sym_readonly] = ACTIONS(868),
    [anon_sym_local] = ACTIONS(868),
    [anon_sym_LT] = ACTIONS(871),
    [anon_sym_GT] = ACTIONS(871),
    [anon_sym_GT_GT] = ACTIONS(874),
    [anon_sym_AMP_GT] = ACTIONS(871),
    [anon_sym_AMP_GT_GT] = ACTIONS(874),
    [anon_sym_LT_AMP] = ACTIONS(874),
    [anon_sym_GT_AMP] = ACTIONS(874),
    [sym__special_characters] = ACTIONS(877),
    [anon_sym_DQUOTE] = ACTIONS(880),
    [sym_raw_string] = ACTIONS(883),
    [anon_sym_DOLLAR] = ACTIONS(886),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(889),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(892),
    [anon_sym_BQUOTE] = ACTIONS(895),
    [anon_sym_LT_LPAREN] = ACTIONS(898),
    [anon_sym_GT_LPAREN] = ACTIONS(898),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(901),
  },
  [2405] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2404),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5005),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2406] = {
    [sym__special_characters] = ACTIONS(4766),
    [anon_sym_DQUOTE] = ACTIONS(4768),
    [sym_raw_string] = ACTIONS(4768),
    [anon_sym_DOLLAR] = ACTIONS(4766),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4768),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4768),
    [anon_sym_BQUOTE] = ACTIONS(4768),
    [anon_sym_LT_LPAREN] = ACTIONS(4768),
    [anon_sym_GT_LPAREN] = ACTIONS(4768),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4766),
  },
  [2407] = {
    [sym__terminated_statement] = STATE(22),
    [sym_for_statement] = STATE(23),
    [sym_while_statement] = STATE(23),
    [sym_if_statement] = STATE(23),
    [sym_case_statement] = STATE(23),
    [sym_function_definition] = STATE(23),
    [sym_subshell] = STATE(23),
    [sym_pipeline] = STATE(23),
    [sym_list] = STATE(23),
    [sym_command] = STATE(23),
    [sym_command_name] = STATE(24),
    [sym_variable_assignment] = STATE(25),
    [sym_declaration_command] = STATE(23),
    [sym_subscript] = STATE(26),
    [sym_file_redirect] = STATE(27),
    [sym_concatenation] = STATE(28),
    [sym_string] = STATE(14),
    [sym_simple_expansion] = STATE(14),
    [sym_expansion] = STATE(14),
    [sym_command_substitution] = STATE(14),
    [sym_process_substitution] = STATE(14),
    [aux_sym_program_repeat1] = STATE(2404),
    [aux_sym_command_repeat1] = STATE(30),
    [sym_file_descriptor] = ACTIONS(8),
    [sym_variable_name] = ACTIONS(10),
    [anon_sym_for] = ACTIONS(14),
    [anon_sym_while] = ACTIONS(16),
    [anon_sym_if] = ACTIONS(18),
    [anon_sym_case] = ACTIONS(20),
    [anon_sym_SEMI_SEMI] = ACTIONS(5007),
    [anon_sym_function] = ACTIONS(22),
    [anon_sym_LPAREN] = ACTIONS(24),
    [anon_sym_declare] = ACTIONS(26),
    [anon_sym_typeset] = ACTIONS(26),
    [anon_sym_export] = ACTIONS(26),
    [anon_sym_readonly] = ACTIONS(26),
    [anon_sym_local] = ACTIONS(26),
    [anon_sym_LT] = ACTIONS(28),
    [anon_sym_GT] = ACTIONS(28),
    [anon_sym_GT_GT] = ACTIONS(30),
    [anon_sym_AMP_GT] = ACTIONS(28),
    [anon_sym_AMP_GT_GT] = ACTIONS(30),
    [anon_sym_LT_AMP] = ACTIONS(30),
    [anon_sym_GT_AMP] = ACTIONS(30),
    [sym__special_characters] = ACTIONS(32),
    [anon_sym_DQUOTE] = ACTIONS(34),
    [sym_raw_string] = ACTIONS(36),
    [anon_sym_DOLLAR] = ACTIONS(38),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(40),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(42),
    [anon_sym_BQUOTE] = ACTIONS(44),
    [anon_sym_LT_LPAREN] = ACTIONS(46),
    [anon_sym_GT_LPAREN] = ACTIONS(46),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(50),
  },
  [2408] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2409] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2410] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_RPAREN] = ACTIONS(3352),
    [anon_sym_SEMI_SEMI] = ACTIONS(3352),
    [anon_sym_PIPE_AMP] = ACTIONS(3352),
    [anon_sym_AMP_AMP] = ACTIONS(3352),
    [anon_sym_PIPE_PIPE] = ACTIONS(3352),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3352),
    [anon_sym_LF] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
  },
  [2411] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3358),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_SEMI_SEMI] = ACTIONS(3358),
    [anon_sym_PIPE_AMP] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_LF] = ACTIONS(3358),
    [anon_sym_AMP] = ACTIONS(3358),
  },
  [2412] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(5009),
    [sym_comment] = ACTIONS(48),
  },
  [2413] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(5011),
    [sym_comment] = ACTIONS(48),
  },
  [2414] = {
    [anon_sym_RBRACE] = ACTIONS(5011),
    [sym_comment] = ACTIONS(48),
  },
  [2415] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(3423),
    [anon_sym_RPAREN] = ACTIONS(3423),
    [anon_sym_SEMI_SEMI] = ACTIONS(3423),
    [anon_sym_PIPE_AMP] = ACTIONS(3423),
    [anon_sym_AMP_AMP] = ACTIONS(3423),
    [anon_sym_PIPE_PIPE] = ACTIONS(3423),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3423),
    [anon_sym_LF] = ACTIONS(3423),
    [anon_sym_AMP] = ACTIONS(3423),
  },
  [2416] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(3427),
    [anon_sym_RPAREN] = ACTIONS(3427),
    [anon_sym_SEMI_SEMI] = ACTIONS(3427),
    [anon_sym_PIPE_AMP] = ACTIONS(3427),
    [anon_sym_AMP_AMP] = ACTIONS(3427),
    [anon_sym_PIPE_PIPE] = ACTIONS(3427),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(3427),
    [anon_sym_LF] = ACTIONS(3427),
    [anon_sym_AMP] = ACTIONS(3427),
  },
  [2417] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [2418] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_RPAREN] = ACTIONS(3356),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [2419] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(5013),
    [sym_comment] = ACTIONS(48),
  },
  [2420] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(5015),
    [sym_comment] = ACTIONS(48),
  },
  [2421] = {
    [anon_sym_RBRACE] = ACTIONS(5015),
    [sym_comment] = ACTIONS(48),
  },
  [2422] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_RPAREN] = ACTIONS(3421),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [2423] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_RPAREN] = ACTIONS(3425),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [2424] = {
    [sym__concat] = ACTIONS(3350),
    [anon_sym_PIPE] = ACTIONS(4044),
    [anon_sym_PIPE_AMP] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_BQUOTE] = ACTIONS(3350),
    [sym_comment] = ACTIONS(48),
  },
  [2425] = {
    [sym__concat] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(4046),
    [anon_sym_PIPE_AMP] = ACTIONS(3356),
    [anon_sym_AMP_AMP] = ACTIONS(3356),
    [anon_sym_PIPE_PIPE] = ACTIONS(3356),
    [anon_sym_BQUOTE] = ACTIONS(3356),
    [sym_comment] = ACTIONS(48),
  },
  [2426] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(5017),
    [sym_comment] = ACTIONS(48),
  },
  [2427] = {
    [aux_sym_concatenation_repeat1] = STATE(1173),
    [sym__concat] = ACTIONS(2292),
    [anon_sym_RBRACE] = ACTIONS(5019),
    [sym_comment] = ACTIONS(48),
  },
  [2428] = {
    [anon_sym_RBRACE] = ACTIONS(5019),
    [sym_comment] = ACTIONS(48),
  },
  [2429] = {
    [sym__concat] = ACTIONS(3421),
    [anon_sym_PIPE] = ACTIONS(4052),
    [anon_sym_PIPE_AMP] = ACTIONS(3421),
    [anon_sym_AMP_AMP] = ACTIONS(3421),
    [anon_sym_PIPE_PIPE] = ACTIONS(3421),
    [anon_sym_BQUOTE] = ACTIONS(3421),
    [sym_comment] = ACTIONS(48),
  },
  [2430] = {
    [sym__concat] = ACTIONS(3425),
    [anon_sym_PIPE] = ACTIONS(4054),
    [anon_sym_PIPE_AMP] = ACTIONS(3425),
    [anon_sym_AMP_AMP] = ACTIONS(3425),
    [anon_sym_PIPE_PIPE] = ACTIONS(3425),
    [anon_sym_BQUOTE] = ACTIONS(3425),
    [sym_comment] = ACTIONS(48),
  },
  [2431] = {
    [sym__special_characters] = ACTIONS(4929),
    [anon_sym_DQUOTE] = ACTIONS(4931),
    [sym_raw_string] = ACTIONS(4931),
    [anon_sym_DOLLAR] = ACTIONS(4929),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4931),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4931),
    [anon_sym_BQUOTE] = ACTIONS(4931),
    [anon_sym_LT_LPAREN] = ACTIONS(4931),
    [anon_sym_GT_LPAREN] = ACTIONS(4931),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4929),
  },
  [2432] = {
    [sym__special_characters] = ACTIONS(4937),
    [anon_sym_DQUOTE] = ACTIONS(4939),
    [sym_raw_string] = ACTIONS(4939),
    [anon_sym_DOLLAR] = ACTIONS(4937),
    [anon_sym_DOLLAR_LBRACE] = ACTIONS(4939),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(4939),
    [anon_sym_BQUOTE] = ACTIONS(4939),
    [anon_sym_LT_LPAREN] = ACTIONS(4939),
    [anon_sym_GT_LPAREN] = ACTIONS(4939),
    [sym_comment] = ACTIONS(48),
    [sym_word] = ACTIONS(4937),
  },
  [2433] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4109),
    [anon_sym_RPAREN] = ACTIONS(4109),
    [anon_sym_SEMI_SEMI] = ACTIONS(4109),
    [anon_sym_PIPE_AMP] = ACTIONS(4109),
    [anon_sym_AMP_AMP] = ACTIONS(4109),
    [anon_sym_PIPE_PIPE] = ACTIONS(4109),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4109),
    [anon_sym_LF] = ACTIONS(4109),
    [anon_sym_AMP] = ACTIONS(4109),
  },
  [2434] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4113),
    [anon_sym_RPAREN] = ACTIONS(4113),
    [anon_sym_SEMI_SEMI] = ACTIONS(4113),
    [anon_sym_PIPE_AMP] = ACTIONS(4113),
    [anon_sym_AMP_AMP] = ACTIONS(4113),
    [anon_sym_PIPE_PIPE] = ACTIONS(4113),
    [sym_comment] = ACTIONS(128),
    [anon_sym_SEMI] = ACTIONS(4113),
    [anon_sym_LF] = ACTIONS(4113),
    [anon_sym_AMP] = ACTIONS(4113),
  },
  [2435] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_RPAREN] = ACTIONS(4107),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2436] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_RPAREN] = ACTIONS(4111),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
  [2437] = {
    [sym__concat] = ACTIONS(4107),
    [anon_sym_PIPE] = ACTIONS(4546),
    [anon_sym_PIPE_AMP] = ACTIONS(4107),
    [anon_sym_AMP_AMP] = ACTIONS(4107),
    [anon_sym_PIPE_PIPE] = ACTIONS(4107),
    [anon_sym_BQUOTE] = ACTIONS(4107),
    [sym_comment] = ACTIONS(48),
  },
  [2438] = {
    [sym__concat] = ACTIONS(4111),
    [anon_sym_PIPE] = ACTIONS(4548),
    [anon_sym_PIPE_AMP] = ACTIONS(4111),
    [anon_sym_AMP_AMP] = ACTIONS(4111),
    [anon_sym_PIPE_PIPE] = ACTIONS(4111),
    [anon_sym_BQUOTE] = ACTIONS(4111),
    [sym_comment] = ACTIONS(48),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false, .depends_on_lookahead = false},
  [1] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, RECOVER(),
  [3] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, RECOVER(),
  [5] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(), RECOVER(),
  [8] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2),
  [10] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(3),
  [12] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 0),
  [14] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(4),
  [16] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(5),
  [18] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(6),
  [20] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(7),
  [22] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(8),
  [24] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(9),
  [26] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(10),
  [28] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(11),
  [30] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(11),
  [32] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(12),
  [34] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(13),
  [36] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(14),
  [38] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(15),
  [40] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(16),
  [42] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(17),
  [44] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(18),
  [46] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(19),
  [48] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT_EXTRA(),
  [50] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(20),
  [52] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(31),
  [54] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(31),
  [56] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(32),
  [58] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(33),
  [60] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(35),
  [62] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(40),
  [64] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(41),
  [66] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(42),
  [68] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(43),
  [70] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(44),
  [72] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(45),
  [74] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(46),
  [76] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(47),
  [78] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(42),
  [80] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(49),
  [82] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(50),
  [84] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(51),
  [86] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(52),
  [88] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(53),
  [90] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(54),
  [92] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(55),
  [94] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(56),
  [96] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(57),
  [98] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(58),
  [100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(59),
  [102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(60),
  [104] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(61),
  [106] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(62),
  [108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(69),
  [110] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 1),
  [112] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(70),
  [114] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(71),
  [116] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(72),
  [118] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(73),
  [120] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(74),
  [122] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(75),
  [124] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(76),
  [126] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(77),
  [128] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT_EXTRA(),
  [130] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(78),
  [132] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(82),
  [134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(83),
  [136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(84),
  [138] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(85),
  [140] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(86),
  [142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(87),
  [144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(88),
  [146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(89),
  [148] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(84),
  [150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(91),
  [154] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [156] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(93),
  [158] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(94),
  [160] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(95),
  [162] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(96),
  [164] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(97),
  [166] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(98),
  [168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [170] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_name, 1),
  [172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(100),
  [174] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(101),
  [176] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(100),
  [178] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(103),
  [180] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(104),
  [182] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(105),
  [184] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(106),
  [186] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(104),
  [188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(108),
  [190] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(109),
  [192] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(110),
  [194] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(111),
  [196] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(112),
  [198] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(113),
  [200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(114),
  [202] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(115),
  [204] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(116),
  [206] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(117),
  [208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(118),
  [210] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(119),
  [212] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(120),
  [214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(121),
  [216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(122),
  [218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(123),
  [220] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(124),
  [222] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(131),
  [224] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(132),
  [226] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(133),
  [228] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(134),
  [230] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(135),
  [232] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(136),
  [234] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(137),
  [236] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(138),
  [238] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(139),
  [240] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(140),
  [242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(141),
  [244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(142),
  [246] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(143),
  [248] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(151),
  [250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, ACCEPT_INPUT(),
  [252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [254] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 1),
  [256] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 1),
  [258] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(152),
  [260] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(153),
  [262] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(154),
  [264] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(155),
  [266] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [268] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(156),
  [270] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(157),
  [272] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(158),
  [274] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(159),
  [276] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(13),
  [278] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(160),
  [280] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(15),
  [282] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(16),
  [284] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(17),
  [286] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(18),
  [288] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(19),
  [290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [292] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [294] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 1, .fragile = true),
  [296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_program, 1),
  [298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(166),
  [300] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(14),
  [302] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(170),
  [304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(171),
  [306] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(171),
  [308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(173),
  [310] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(174),
  [312] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(175),
  [314] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(176),
  [316] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(177),
  [318] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(178),
  [320] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(179),
  [322] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(180),
  [324] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(181),
  [326] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(182),
  [328] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(177),
  [330] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(183),
  [332] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(184),
  [334] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(185),
  [336] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(186),
  [338] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(187),
  [340] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(188),
  [342] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(189),
  [344] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(190),
  [346] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(185),
  [348] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_variable_assignment, 2),
  [350] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_variable_assignment, 2),
  [352] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(192),
  [354] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(193),
  [356] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(195),
  [358] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(196),
  [360] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(197),
  [362] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(198),
  [364] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(199),
  [366] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(201),
  [368] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(203),
  [370] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(204),
  [372] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(205),
  [374] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(206),
  [376] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(205),
  [378] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(208),
  [380] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(209),
  [382] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(210),
  [384] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(211),
  [386] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(209),
  [388] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(219),
  [390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(220),
  [392] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(222),
  [394] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(224),
  [396] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(225),
  [398] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(226),
  [400] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(227),
  [402] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(228),
  [404] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(229),
  [406] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(230),
  [408] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(231),
  [410] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(232),
  [412] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(233),
  [414] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(236),
  [416] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(238),
  [418] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(240),
  [420] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(241),
  [422] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(240),
  [424] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(243),
  [426] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(244),
  [428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(245),
  [430] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(246),
  [432] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(244),
  [434] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(254),
  [436] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(255),
  [438] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(256),
  [440] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(257),
  [442] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(258),
  [444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(259),
  [446] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(260),
  [448] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(261),
  [450] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(262),
  [452] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(55),
  [454] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(263),
  [456] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(57),
  [458] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(58),
  [460] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(59),
  [462] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(60),
  [464] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(61),
  [466] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(56),
  [468] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(270),
  [470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(272),
  [472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [474] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [476] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(274),
  [478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [480] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(71),
  [484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(276),
  [486] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(277),
  [488] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(276),
  [490] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(279),
  [492] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(280),
  [494] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(281),
  [496] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(282),
  [498] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(280),
  [500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [502] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [504] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 2),
  [506] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(291),
  [510] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [512] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(293),
  [514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [516] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 2),
  [518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(295),
  [520] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(296),
  [522] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(295),
  [524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(298),
  [526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(299),
  [528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(300),
  [530] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(301),
  [532] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(299),
  [534] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(309),
  [536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(309),
  [538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [540] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_concatenation, 2),
  [542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [544] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 2),
  [546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(311),
  [548] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 1),
  [550] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 1),
  [552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(312),
  [554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(313),
  [556] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(314),
  [558] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(313),
  [560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(316),
  [562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(317),
  [564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(318),
  [566] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(319),
  [568] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(317),
  [570] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(325),
  [572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [574] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [578] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [580] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [582] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_simple_expansion, 2),
  [584] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(327),
  [586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(328),
  [588] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(329),
  [590] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(330),
  [592] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(331),
  [594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(332),
  [596] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(333),
  [598] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(334),
  [600] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(330),
  [602] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(335),
  [604] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(336),
  [606] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(337),
  [608] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(338),
  [610] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(333),
  [612] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(340),
  [614] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(341),
  [616] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(342),
  [618] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(341),
  [620] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(344),
  [622] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(346),
  [624] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(348),
  [626] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(350),
  [628] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(353),
  [630] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(354),
  [632] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(354),
  [634] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(356),
  [636] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(360),
  [638] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_declaration_command, 1),
  [640] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 1),
  [642] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(361),
  [644] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(362),
  [646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(363),
  [648] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(364),
  [650] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(365),
  [652] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(366),
  [654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(367),
  [656] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(368),
  [658] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(369),
  [660] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(363),
  [662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(373),
  [664] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1, .alias_sequence_id = 1),
  [666] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(375),
  [668] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_name, 1),
  [670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(377),
  [672] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(378),
  [674] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(377),
  [676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(380),
  [678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(381),
  [680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(382),
  [682] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(383),
  [684] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(381),
  [686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(391),
  [688] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(392),
  [690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(393),
  [692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(392),
  [694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(394),
  [696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(395),
  [698] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 1),
  [700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 1),
  [702] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(396),
  [704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(396),
  [706] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(397),
  [708] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(397),
  [710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(398),
  [712] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(399),
  [714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(400),
  [716] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(400),
  [718] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(118),
  [720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(406),
  [722] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(408),
  [724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(409),
  [726] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(410),
  [728] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(411),
  [730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(412),
  [732] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(413),
  [734] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(414),
  [736] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(415),
  [738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(417),
  [740] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(412),
  [742] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(420),
  [744] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(422),
  [746] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(424),
  [748] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(425),
  [750] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(424),
  [752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(427),
  [754] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(428),
  [756] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(429),
  [758] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(430),
  [760] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(428),
  [762] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(438),
  [764] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(439),
  [766] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(439),
  [768] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(440),
  [770] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(441),
  [772] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(442),
  [774] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(442),
  [776] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(443),
  [778] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(444),
  [780] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(445),
  [782] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(445),
  [784] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(137),
  [786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(449),
  [788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(450),
  [790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [792] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__terminated_statement, 2),
  [794] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__terminated_statement, 2),
  [796] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(455),
  [798] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(455),
  [800] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(456),
  [802] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(457),
  [804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(458),
  [806] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(459),
  [808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(460),
  [810] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(461),
  [812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(462),
  [814] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(463),
  [816] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(458),
  [818] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(465),
  [820] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(466),
  [822] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(468),
  [824] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(469),
  [826] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(469),
  [828] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [830] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [832] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [834] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [836] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 1),
  [838] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 1),
  [840] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [842] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(2),
  [845] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(3),
  [848] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2),
  [850] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(4),
  [853] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(5),
  [856] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(6),
  [859] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(7),
  [862] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(8),
  [865] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(9),
  [868] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(10),
  [871] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [874] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(11),
  [877] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [880] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(13),
  [883] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(14),
  [886] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(15),
  [889] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(16),
  [892] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(17),
  [895] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(18),
  [898] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(19),
  [901] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(20),
  [904] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(474),
  [906] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(2),
  [909] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(166),
  [912] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(11),
  [915] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2), SHIFT_REPEAT(11),
  [918] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_command_repeat1, 2),
  [920] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_command_repeat1, 2),
  [922] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [924] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [926] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [928] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_file_redirect, 3),
  [930] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [932] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2),
  [934] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(476),
  [936] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(477),
  [938] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(478),
  [940] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(479),
  [942] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(480),
  [944] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(481),
  [946] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(482),
  [948] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(483),
  [950] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(484),
  [952] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(479),
  [954] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [956] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(487),
  [958] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [960] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(489),
  [962] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(491),
  [964] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(492),
  [966] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(491),
  [968] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(494),
  [970] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(495),
  [972] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(496),
  [974] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(497),
  [976] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(495),
  [978] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(505),
  [980] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(506),
  [982] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(508),
  [984] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(510),
  [986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(511),
  [988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(512),
  [990] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(513),
  [992] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(512),
  [994] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(515),
  [996] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(516),
  [998] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(517),
  [1000] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(518),
  [1002] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(516),
  [1004] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(526),
  [1006] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(527),
  [1008] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(528),
  [1010] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(529),
  [1012] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(530),
  [1014] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(531),
  [1016] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(532),
  [1018] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(533),
  [1020] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(534),
  [1022] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(529),
  [1024] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(537),
  [1026] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [1028] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(543),
  [1030] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(544),
  [1032] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(545),
  [1034] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(553),
  [1036] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(553),
  [1038] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(554),
  [1040] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(555),
  [1042] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(557),
  [1044] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(558),
  [1046] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(559),
  [1048] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(560),
  [1050] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(561),
  [1052] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(563),
  [1054] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(564),
  [1056] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(565),
  [1058] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(564),
  [1060] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(567),
  [1062] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(569),
  [1064] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(571),
  [1066] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(572),
  [1068] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(573),
  [1070] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(574),
  [1072] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(12),
  [1074] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(579),
  [1076] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [1078] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(580),
  [1080] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(582),
  [1082] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(583),
  [1084] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(584),
  [1086] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(585),
  [1088] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(586),
  [1090] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(587),
  [1092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(588),
  [1094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(589),
  [1096] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(584),
  [1098] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(591),
  [1100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(593),
  [1102] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(594),
  [1104] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(596),
  [1106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(227),
  [1108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(598),
  [1110] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(599),
  [1112] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(598),
  [1114] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(601),
  [1116] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(602),
  [1118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(603),
  [1120] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(604),
  [1122] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(602),
  [1124] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(613),
  [1126] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(613),
  [1128] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(615),
  [1130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(616),
  [1132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(617),
  [1134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(619),
  [1136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(620),
  [1138] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(621),
  [1140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(620),
  [1142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(623),
  [1144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(625),
  [1146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(627),
  [1148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(628),
  [1150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(629),
  [1152] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [1154] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(630),
  [1156] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(633),
  [1158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(633),
  [1160] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(634),
  [1162] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(635),
  [1164] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(636),
  [1166] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(637),
  [1168] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(638),
  [1170] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(639),
  [1172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(640),
  [1174] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(641),
  [1176] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(636),
  [1178] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(642),
  [1180] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(643),
  [1182] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(643),
  [1184] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(630),
  [1186] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(647),
  [1188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(649),
  [1190] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(650),
  [1192] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(651),
  [1194] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(652),
  [1196] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(73),
  [1198] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(74),
  [1200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(75),
  [1202] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(76),
  [1204] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(77),
  [1206] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(652),
  [1208] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(653),
  [1210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(653),
  [1212] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(655),
  [1214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(656),
  [1216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(657),
  [1218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(659),
  [1220] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(660),
  [1222] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(661),
  [1224] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(660),
  [1226] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(663),
  [1228] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(665),
  [1230] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(667),
  [1232] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(668),
  [1234] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(69),
  [1237] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [1239] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(70),
  [1242] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(71),
  [1245] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(72),
  [1248] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(73),
  [1251] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(74),
  [1254] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(75),
  [1257] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(76),
  [1260] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(77),
  [1263] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(78),
  [1266] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(669),
  [1268] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(669),
  [1270] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_concatenation, 2),
  [1272] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 2),
  [1274] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(671),
  [1276] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 4),
  [1278] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2, .alias_sequence_id = 5),
  [1280] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_simple_expansion, 2),
  [1282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(672),
  [1284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(673),
  [1286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(675),
  [1288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(676),
  [1290] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(677),
  [1292] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(676),
  [1294] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(679),
  [1296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(681),
  [1298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(683),
  [1300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(684),
  [1302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1304] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [1306] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(91),
  [1309] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2),
  [1311] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1313] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(685),
  [1315] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(687),
  [1317] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(688),
  [1319] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(690),
  [1321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(691),
  [1323] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(692),
  [1325] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(691),
  [1327] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(694),
  [1329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(696),
  [1331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(698),
  [1333] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1335] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_string, 3),
  [1337] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(94),
  [1340] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(95),
  [1343] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(96),
  [1346] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(97),
  [1349] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(98),
  [1352] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(699),
  [1354] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(700),
  [1356] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(701),
  [1358] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(702),
  [1360] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(703),
  [1362] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(704),
  [1364] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(705),
  [1366] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(706),
  [1368] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(707),
  [1370] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(702),
  [1372] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(709),
  [1374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(710),
  [1376] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(710),
  [1378] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1380] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [1382] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1384] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1386] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1),
  [1388] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(712),
  [1390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1392] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1394] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 1, .alias_sequence_id = 1),
  [1396] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(714),
  [1398] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(716),
  [1400] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(717),
  [1402] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(716),
  [1404] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(719),
  [1406] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(720),
  [1408] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(721),
  [1410] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(722),
  [1412] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(720),
  [1414] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(730),
  [1416] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(732),
  [1418] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(733),
  [1420] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(735),
  [1422] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1424] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [1426] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(738),
  [1428] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1430] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 3),
  [1432] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(739),
  [1434] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(740),
  [1436] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(741),
  [1438] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(742),
  [1440] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(743),
  [1442] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(744),
  [1444] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(745),
  [1446] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(746),
  [1448] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(747),
  [1450] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(748),
  [1452] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(743),
  [1454] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_variable_assignment, 2),
  [1456] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(749),
  [1458] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(750),
  [1460] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(752),
  [1462] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(753),
  [1464] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(754),
  [1466] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(755),
  [1468] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(756),
  [1470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(757),
  [1472] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(758),
  [1474] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(760),
  [1476] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(761),
  [1478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(764),
  [1480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(766),
  [1482] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 1),
  [1484] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(768),
  [1486] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1),
  [1488] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(770),
  [1490] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(771),
  [1492] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(770),
  [1494] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(773),
  [1496] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(774),
  [1498] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(775),
  [1500] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(776),
  [1502] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(774),
  [1504] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 1, .alias_sequence_id = 2),
  [1506] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_declaration_command, 2),
  [1508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_declaration_command, 2),
  [1510] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(785),
  [1512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(785),
  [1514] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(787),
  [1516] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(788),
  [1518] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(789),
  [1520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(791),
  [1522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(792),
  [1524] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(793),
  [1526] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(792),
  [1528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(795),
  [1530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(797),
  [1532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(799),
  [1534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(800),
  [1536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(801),
  [1538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1540] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command_substitution, 3),
  [1542] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(806),
  [1544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(806),
  [1546] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(807),
  [1548] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(808),
  [1550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(809),
  [1552] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(810),
  [1554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(811),
  [1556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(812),
  [1558] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(813),
  [1560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(814),
  [1562] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(809),
  [1564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(816),
  [1566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(817),
  [1568] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(819),
  [1570] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(820),
  [1572] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(820),
  [1574] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1, .alias_sequence_id = 1),
  [1576] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 1),
  [1578] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 1),
  [1580] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 2),
  [1582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 2),
  [1584] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(826),
  [1586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(827),
  [1588] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(828),
  [1590] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(829),
  [1592] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(830),
  [1594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(831),
  [1596] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(832),
  [1598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(833),
  [1600] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(828),
  [1602] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(835),
  [1604] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(837),
  [1606] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(838),
  [1608] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(840),
  [1610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(842),
  [1612] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(843),
  [1614] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(842),
  [1616] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(845),
  [1618] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(846),
  [1620] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(847),
  [1622] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(848),
  [1624] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(846),
  [1626] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(857),
  [1628] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(857),
  [1630] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(859),
  [1632] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(860),
  [1634] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(861),
  [1636] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(863),
  [1638] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(864),
  [1640] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(865),
  [1642] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(864),
  [1644] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(867),
  [1646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(869),
  [1648] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(871),
  [1650] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(872),
  [1652] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(873),
  [1654] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(877),
  [1656] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(877),
  [1658] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(878),
  [1660] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(879),
  [1662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(880),
  [1664] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(881),
  [1666] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(882),
  [1668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(883),
  [1670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(884),
  [1672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(885),
  [1674] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(880),
  [1676] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(886),
  [1678] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(887),
  [1680] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(887),
  [1682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1684] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_process_substitution, 3),
  [1686] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [1688] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [1690] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(893),
  [1692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(894),
  [1694] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(894),
  [1696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(896),
  [1698] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2, .alias_sequence_id = 3),
  [1700] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(898),
  [1702] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 2),
  [1704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(900),
  [1706] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(901),
  [1708] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(900),
  [1710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(903),
  [1712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(904),
  [1714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(905),
  [1716] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(906),
  [1718] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(904),
  [1720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1722] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 1),
  [1724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(914),
  [1726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(915),
  [1728] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(916),
  [1730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(917),
  [1732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1734] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc_redirect, 2),
  [1736] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [1738] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [1740] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2),
  [1742] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_herestring_redirect, 2),
  [1744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1746] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [1748] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(159),
  [1751] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(13),
  [1754] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(160),
  [1757] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(15),
  [1760] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(16),
  [1763] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(17),
  [1766] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(18),
  [1769] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(19),
  [1772] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [1774] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(155),
  [1777] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [1779] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(156),
  [1782] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(157),
  [1785] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(158),
  [1788] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(919),
  [1790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(920),
  [1792] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(920),
  [1794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1796] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 2),
  [1798] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(922),
  [1800] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(924),
  [1802] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(926),
  [1804] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(927),
  [1806] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(926),
  [1808] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(929),
  [1810] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(930),
  [1812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(931),
  [1814] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(932),
  [1816] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(930),
  [1818] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(940),
  [1820] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(942),
  [1822] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(942),
  [1824] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(944),
  [1826] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(945),
  [1828] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(946),
  [1830] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(948),
  [1832] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(949),
  [1834] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(950),
  [1836] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(949),
  [1838] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(952),
  [1840] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(954),
  [1842] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(956),
  [1844] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(957),
  [1846] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(958),
  [1848] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(959),
  [1850] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(959),
  [1852] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(959),
  [1854] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(960),
  [1856] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [1858] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(961),
  [1860] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(963),
  [1862] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(964),
  [1864] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(965),
  [1866] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [1868] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(966),
  [1870] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(967),
  [1872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(969),
  [1874] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(970),
  [1876] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(971),
  [1878] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(970),
  [1880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(973),
  [1882] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(975),
  [1884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(977),
  [1886] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(978),
  [1888] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(979),
  [1890] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(981),
  [1892] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(983),
  [1894] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(984),
  [1896] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(983),
  [1898] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(986),
  [1900] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(987),
  [1902] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(988),
  [1904] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(989),
  [1906] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(987),
  [1908] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(997),
  [1910] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(527),
  [1912] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(528),
  [1914] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(529),
  [1916] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(530),
  [1918] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(531),
  [1920] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(532),
  [1922] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(533),
  [1924] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(534),
  [1926] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1928] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 2),
  [1930] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(999),
  [1932] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1000),
  [1934] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 4),
  [1936] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [1938] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 1),
  [1940] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1007),
  [1942] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 1),
  [1944] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1008),
  [1946] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1008),
  [1948] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(544),
  [1950] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(545),
  [1952] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1013),
  [1954] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1014),
  [1956] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1015),
  [1958] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1016),
  [1960] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1017),
  [1962] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1018),
  [1964] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1019),
  [1966] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1020),
  [1968] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1021),
  [1970] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1016),
  [1972] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1026),
  [1974] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(197),
  [1977] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1027),
  [1979] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1030),
  [1981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1031),
  [1983] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1032),
  [1985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1033),
  [1987] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1033),
  [1989] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1035),
  [1991] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1036),
  [1993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1037),
  [1995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1039),
  [1997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1042),
  [1999] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [2001] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 2),
  [2003] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1044),
  [2005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1045),
  [2007] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1047),
  [2009] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1047),
  [2011] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1048),
  [2013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1049),
  [2015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1050),
  [2017] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1051),
  [2019] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1052),
  [2021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1053),
  [2023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1054),
  [2025] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1055),
  [2027] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1050),
  [2029] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [2031] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1057),
  [2033] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1059),
  [2035] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1061),
  [2037] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1062),
  [2039] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1061),
  [2041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1064),
  [2043] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1065),
  [2045] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1066),
  [2047] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1067),
  [2049] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1065),
  [2051] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1076),
  [2053] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1077),
  [2055] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1078),
  [2057] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1079),
  [2059] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1080),
  [2061] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(229),
  [2063] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(230),
  [2065] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(231),
  [2067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(232),
  [2069] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(233),
  [2071] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1080),
  [2073] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1081),
  [2075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1081),
  [2077] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1083),
  [2079] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1084),
  [2081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1085),
  [2083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1087),
  [2085] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1088),
  [2087] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1089),
  [2089] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1088),
  [2091] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1091),
  [2093] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1093),
  [2095] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1095),
  [2097] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1096),
  [2099] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(225),
  [2102] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(226),
  [2105] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(227),
  [2108] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(228),
  [2111] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(229),
  [2114] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(230),
  [2117] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(231),
  [2120] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(232),
  [2123] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(233),
  [2126] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(236),
  [2129] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1097),
  [2131] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1098),
  [2133] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1099),
  [2135] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1099),
  [2137] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1101),
  [2139] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1102),
  [2141] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1103),
  [2143] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1105),
  [2145] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1108),
  [2147] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [2149] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1110),
  [2151] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1111),
  [2153] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1111),
  [2155] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1112),
  [2157] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1114),
  [2159] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1116),
  [2161] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1117),
  [2163] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1116),
  [2165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1119),
  [2167] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1120),
  [2169] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1121),
  [2171] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1122),
  [2173] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1120),
  [2175] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(262),
  [2178] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(55),
  [2181] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(263),
  [2184] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(57),
  [2187] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(58),
  [2190] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(59),
  [2193] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(60),
  [2196] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(61),
  [2199] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(259),
  [2202] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(260),
  [2205] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(261),
  [2208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1130),
  [2210] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1132),
  [2212] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(272),
  [2215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1134),
  [2217] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1135),
  [2219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1136),
  [2221] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1136),
  [2223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1138),
  [2225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1139),
  [2227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1140),
  [2229] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1142),
  [2231] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1145),
  [2233] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_concatenation_repeat1, 2),
  [2235] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(291),
  [2238] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_string, 3),
  [2240] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1146),
  [2242] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1147),
  [2244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1148),
  [2246] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1148),
  [2248] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 4),
  [2250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1150),
  [2252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1151),
  [2254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1152),
  [2256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1154),
  [2258] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3, .alias_sequence_id = 5),
  [2260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1157),
  [2262] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 3),
  [2264] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command_substitution, 3),
  [2266] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_process_substitution, 3),
  [2268] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1158),
  [2270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1159),
  [2272] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1160),
  [2274] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1161),
  [2276] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1161),
  [2278] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1163),
  [2280] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1164),
  [2282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1165),
  [2284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1167),
  [2286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1170),
  [2288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [2290] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4),
  [2292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1171),
  [2294] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1172),
  [2296] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1174),
  [2298] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1176),
  [2300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1177),
  [2302] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1178),
  [2304] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1177),
  [2306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1180),
  [2308] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1181),
  [2310] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1182),
  [2312] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1183),
  [2314] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1181),
  [2316] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1191),
  [2318] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1192),
  [2320] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1193),
  [2322] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1194),
  [2324] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1195),
  [2326] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1196),
  [2328] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1196),
  [2330] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1198),
  [2332] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1199),
  [2334] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1200),
  [2336] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1202),
  [2338] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1203),
  [2340] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1204),
  [2342] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1203),
  [2344] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1206),
  [2346] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1208),
  [2348] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1210),
  [2350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1211),
  [2352] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2354] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [2356] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2),
  [2358] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(330),
  [2361] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(331),
  [2364] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(332),
  [2367] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(333),
  [2370] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(334),
  [2373] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(330),
  [2376] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(335),
  [2379] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(336),
  [2382] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(337),
  [2385] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(338),
  [2388] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_expansion_repeat1, 2), SHIFT_REPEAT(333),
  [2391] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1212),
  [2393] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1213),
  [2395] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1213),
  [2397] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2399] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [2401] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1215),
  [2403] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2405] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [2407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1216),
  [2409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2411] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [2413] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__assignment, 2),
  [2415] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1217),
  [2417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1219),
  [2419] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym__assignment, 2, .alias_sequence_id = 3),
  [2421] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1221),
  [2423] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1223),
  [2425] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1224),
  [2427] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1223),
  [2429] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1226),
  [2431] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1227),
  [2433] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1228),
  [2435] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1229),
  [2437] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1227),
  [2439] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1238),
  [2441] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 3),
  [2443] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 3),
  [2445] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1241),
  [2447] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1245),
  [2449] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1246),
  [2451] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1247),
  [2453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1248),
  [2455] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1249),
  [2457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1250),
  [2459] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1252),
  [2461] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 3),
  [2463] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 3),
  [2465] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1253),
  [2467] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1253),
  [2469] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 3),
  [2471] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 3),
  [2473] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1255),
  [2475] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1255),
  [2477] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1256),
  [2479] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1257),
  [2481] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1258),
  [2483] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1259),
  [2485] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1260),
  [2487] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1260),
  [2489] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1261),
  [2491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1261),
  [2493] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1263),
  [2495] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1264),
  [2497] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1265),
  [2499] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1267),
  [2501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1268),
  [2503] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1269),
  [2505] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1268),
  [2507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1271),
  [2509] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1273),
  [2511] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1275),
  [2513] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1276),
  [2515] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(360),
  [2518] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2),
  [2522] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(361),
  [2525] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(362),
  [2528] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(363),
  [2531] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(364),
  [2534] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(365),
  [2537] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(366),
  [2540] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(367),
  [2543] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(368),
  [2546] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(369),
  [2549] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(363),
  [2552] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(373),
  [2555] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1277),
  [2557] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1278),
  [2559] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1279),
  [2561] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1279),
  [2563] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1281),
  [2565] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1282),
  [2567] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1283),
  [2569] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1285),
  [2571] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1288),
  [2573] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_pipeline, 3),
  [2575] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_pipeline, 3),
  [2577] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_list, 3, .fragile = true),
  [2579] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1290),
  [2581] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1291),
  [2583] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1291),
  [2585] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1293),
  [2587] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1295),
  [2589] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1297),
  [2591] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1298),
  [2593] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1297),
  [2595] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1300),
  [2597] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1301),
  [2599] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1302),
  [2601] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1303),
  [2603] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1301),
  [2605] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 1),
  [2607] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1311),
  [2609] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc_redirect, 2),
  [2611] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_herestring_redirect, 2, .alias_sequence_id = 3),
  [2613] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_herestring_redirect, 2),
  [2615] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [2617] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(399),
  [2620] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(117),
  [2623] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(400),
  [2626] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(119),
  [2629] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(120),
  [2632] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(121),
  [2635] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(122),
  [2638] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(123),
  [2641] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(400),
  [2644] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 3),
  [2646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 3),
  [2648] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(395),
  [2651] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2),
  [2655] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(396),
  [2658] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(396),
  [2661] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(397),
  [2664] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(397),
  [2667] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(398),
  [2670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1314),
  [2672] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1316),
  [2674] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1318),
  [2676] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1319),
  [2678] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1318),
  [2680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1321),
  [2682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1322),
  [2684] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1323),
  [2686] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1324),
  [2688] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1322),
  [2690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1333),
  [2692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1334),
  [2694] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1335),
  [2696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1335),
  [2698] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1336),
  [2700] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1337),
  [2702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(416),
  [2704] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1337),
  [2706] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1338),
  [2708] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1338),
  [2710] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1340),
  [2712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1341),
  [2714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1342),
  [2716] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1344),
  [2718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1345),
  [2720] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1346),
  [2722] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1345),
  [2724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1348),
  [2726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1350),
  [2728] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1352),
  [2730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1353),
  [2732] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(409),
  [2735] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(410),
  [2738] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(411),
  [2741] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(412),
  [2744] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(413),
  [2747] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(414),
  [2750] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(415),
  [2753] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(416),
  [2756] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(417),
  [2759] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_declaration_command_repeat1, 2), SHIFT_REPEAT(412),
  [2762] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(420),
  [2765] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1354),
  [2767] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1355),
  [2769] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1356),
  [2771] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1356),
  [2773] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1358),
  [2775] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1359),
  [2777] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1360),
  [2779] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1362),
  [2781] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1365),
  [2783] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1367),
  [2785] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1368),
  [2787] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1368),
  [2789] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1369),
  [2791] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1371),
  [2793] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1373),
  [2795] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1374),
  [2797] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1373),
  [2799] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1376),
  [2801] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1377),
  [2803] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1378),
  [2805] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1379),
  [2807] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1377),
  [2809] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(444),
  [2812] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(136),
  [2815] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(445),
  [2818] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(138),
  [2821] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(139),
  [2824] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(140),
  [2827] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(141),
  [2830] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(142),
  [2833] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(445),
  [2836] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(441),
  [2839] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(442),
  [2842] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(442),
  [2845] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_while_statement_repeat1, 2), SHIFT_REPEAT(443),
  [2848] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3, .alias_sequence_id = 6),
  [2850] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_file_redirect, 3),
  [2852] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1389),
  [2854] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1389),
  [2856] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1391),
  [2858] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1392),
  [2860] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1393),
  [2862] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1395),
  [2864] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1396),
  [2866] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1397),
  [2868] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1396),
  [2870] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1399),
  [2872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1401),
  [2874] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1403),
  [2876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1404),
  [2878] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [2880] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 1),
  [2882] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [2884] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 2),
  [2886] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1405),
  [2888] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1406),
  [2890] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1407),
  [2892] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1406),
  [2894] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1409),
  [2896] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1410),
  [2898] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1411),
  [2900] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1412),
  [2902] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1410),
  [2904] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1414),
  [2906] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [2908] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1416),
  [2910] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1416),
  [2912] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1418),
  [2914] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1419),
  [2916] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1420),
  [2918] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1422),
  [2920] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1423),
  [2922] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1424),
  [2924] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1423),
  [2926] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1426),
  [2928] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1428),
  [2930] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1430),
  [2932] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1431),
  [2934] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [2936] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_array, 3),
  [2938] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(477),
  [2941] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(478),
  [2944] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(479),
  [2947] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(480),
  [2950] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(481),
  [2953] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(482),
  [2956] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(483),
  [2959] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(484),
  [2962] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(479),
  [2965] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(487),
  [2968] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1432),
  [2970] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1433),
  [2972] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1434),
  [2974] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1434),
  [2976] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1436),
  [2978] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1437),
  [2980] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1438),
  [2982] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1440),
  [2984] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1443),
  [2986] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1444),
  [2988] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [2990] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(961),
  [2993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1445),
  [2995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5),
  [2997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1446),
  [2999] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1447),
  [3001] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1448),
  [3003] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1448),
  [3005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1450),
  [3007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1451),
  [3009] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1452),
  [3011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1454),
  [3013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1457),
  [3015] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1458),
  [3017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1458),
  [3019] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1460),
  [3021] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1461),
  [3023] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1462),
  [3025] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1464),
  [3027] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1465),
  [3029] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1466),
  [3031] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1465),
  [3033] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1468),
  [3035] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1470),
  [3037] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1472),
  [3039] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1473),
  [3041] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1474),
  [3043] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(527),
  [3046] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(528),
  [3049] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(529),
  [3052] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(530),
  [3055] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(531),
  [3058] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(532),
  [3061] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(533),
  [3064] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(534),
  [3067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [3069] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_do_group, 3),
  [3071] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_program_repeat1, 2),
  [3073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1476),
  [3075] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1477),
  [3077] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_else_clause, 2),
  [3079] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [3081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1479),
  [3083] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3085] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(544),
  [3088] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [3090] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1481),
  [3092] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1482),
  [3094] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1483),
  [3096] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1486),
  [3098] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1488),
  [3100] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1490),
  [3102] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1491),
  [3104] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1490),
  [3106] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1493),
  [3108] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1494),
  [3110] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1495),
  [3112] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1496),
  [3114] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1494),
  [3116] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [3118] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 1),
  [3120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1504),
  [3122] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1016),
  [3124] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1507),
  [3126] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [3128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1509),
  [3130] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1511),
  [3132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1513),
  [3134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1514),
  [3136] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1515),
  [3138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1516),
  [3140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1516),
  [3142] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1518),
  [3144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1519),
  [3146] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [3148] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [3150] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_compound_statement, 3),
  [3152] = {.count = 2, .reusable = false, .depends_on_lookahead = false}, REDUCE(aux_sym_program_repeat1, 2), SHIFT_REPEAT(12),
  [3155] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1521),
  [3157] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1522),
  [3159] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1522),
  [3161] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1524),
  [3163] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1526),
  [3165] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1528),
  [3167] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1529),
  [3169] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1528),
  [3171] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1531),
  [3173] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1532),
  [3175] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1533),
  [3177] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1534),
  [3179] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1532),
  [3181] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1542),
  [3183] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1542),
  [3185] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1544),
  [3187] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1545),
  [3189] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1546),
  [3191] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1548),
  [3193] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1549),
  [3195] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1550),
  [3197] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1549),
  [3199] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1552),
  [3201] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1554),
  [3203] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1556),
  [3205] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1557),
  [3207] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1559),
  [3209] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1559),
  [3211] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1560),
  [3213] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1561),
  [3215] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1562),
  [3217] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1563),
  [3219] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1564),
  [3221] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1565),
  [3223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1566),
  [3225] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1567),
  [3227] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1562),
  [3229] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(594),
  [3232] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1568),
  [3234] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1569),
  [3236] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1570),
  [3238] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1570),
  [3240] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1572),
  [3242] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1573),
  [3244] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1574),
  [3246] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1576),
  [3248] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1579),
  [3250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1580),
  [3252] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1581),
  [3254] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1582),
  [3256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1583),
  [3258] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1583),
  [3260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1585),
  [3262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1586),
  [3264] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1587),
  [3266] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1587),
  [3268] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1589),
  [3270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1590),
  [3272] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1591),
  [3274] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1593),
  [3276] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1594),
  [3278] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1595),
  [3280] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1594),
  [3282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1597),
  [3284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1599),
  [3286] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1601),
  [3288] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1602),
  [3290] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [3292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1603),
  [3294] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1604),
  [3296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1605),
  [3298] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1606),
  [3300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1607),
  [3302] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1607),
  [3304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1609),
  [3306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1610),
  [3308] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4),
  [3310] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1611),
  [3312] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1612),
  [3314] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 4),
  [3316] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1613),
  [3318] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1614),
  [3320] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1614),
  [3322] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 7),
  [3324] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1616),
  [3326] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 8),
  [3328] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1617),
  [3330] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 4, .alias_sequence_id = 5),
  [3332] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1618),
  [3334] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1619),
  [3336] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1620),
  [3338] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1621),
  [3340] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1621),
  [3342] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1623),
  [3344] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1624),
  [3346] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1625),
  [3348] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1625),
  [3350] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3352] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [3354] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1627),
  [3356] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [3358] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5),
  [3360] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1628),
  [3362] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1629),
  [3364] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1631),
  [3366] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1632),
  [3368] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1633),
  [3370] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1632),
  [3372] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1635),
  [3374] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1637),
  [3376] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1639),
  [3378] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1640),
  [3380] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1641),
  [3382] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1642),
  [3384] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3386] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4, .alias_sequence_id = 6),
  [3388] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1643),
  [3390] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1644),
  [3392] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 4),
  [3394] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 4),
  [3396] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(712),
  [3399] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1645),
  [3401] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1646),
  [3403] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1647),
  [3405] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1647),
  [3407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1649),
  [3409] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1650),
  [3411] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1651),
  [3413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1653),
  [3415] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1656),
  [3417] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1657),
  [3419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1658),
  [3421] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3423] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [3425] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3427] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [3429] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 2),
  [3431] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1659),
  [3433] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1660),
  [3435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1660),
  [3437] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1662),
  [3439] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1663),
  [3441] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1664),
  [3443] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1666),
  [3445] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1667),
  [3447] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1668),
  [3449] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1667),
  [3451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1670),
  [3453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1672),
  [3455] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1674),
  [3457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1675),
  [3459] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1676),
  [3461] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 2),
  [3463] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1677),
  [3465] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_while_statement, 4),
  [3467] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_while_statement, 4),
  [3469] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 4),
  [3471] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 4),
  [3473] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1678),
  [3475] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1678),
  [3477] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1681),
  [3479] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1684),
  [3481] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1685),
  [3483] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1688),
  [3485] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 2),
  [3487] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1690),
  [3489] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1691),
  [3491] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1691),
  [3493] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1692),
  [3495] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1693),
  [3497] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1694),
  [3499] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1695),
  [3501] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1696),
  [3503] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1697),
  [3505] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1698),
  [3507] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1699),
  [3509] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1694),
  [3511] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 4),
  [3513] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 4),
  [3515] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 4),
  [3517] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 4),
  [3519] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1701),
  [3521] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1702),
  [3523] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(766),
  [3526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1704),
  [3528] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1705),
  [3530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1706),
  [3532] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1706),
  [3534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1708),
  [3536] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1709),
  [3538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1710),
  [3540] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1712),
  [3542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1715),
  [3544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1716),
  [3546] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1717),
  [3548] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1718),
  [3550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1719),
  [3552] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1719),
  [3554] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1721),
  [3556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1722),
  [3558] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1724),
  [3560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1724),
  [3562] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1726),
  [3564] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1727),
  [3566] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1728),
  [3568] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1730),
  [3570] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1731),
  [3572] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1732),
  [3574] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1731),
  [3576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1734),
  [3578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1736),
  [3580] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1738),
  [3582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1739),
  [3584] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 2),
  [3586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1740),
  [3588] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_command, 4),
  [3590] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_command, 4),
  [3592] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1741),
  [3594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1741),
  [3596] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1743),
  [3598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1744),
  [3600] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1745),
  [3602] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1747),
  [3604] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1748),
  [3606] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1749),
  [3608] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1748),
  [3610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1751),
  [3612] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1753),
  [3614] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1755),
  [3616] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1756),
  [3618] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1758),
  [3620] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1758),
  [3622] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1759),
  [3624] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1760),
  [3626] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1761),
  [3628] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1762),
  [3630] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1763),
  [3632] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1764),
  [3634] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1765),
  [3636] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1766),
  [3638] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1761),
  [3640] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(838),
  [3643] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1767),
  [3645] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1768),
  [3647] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1769),
  [3649] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1769),
  [3651] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1771),
  [3653] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1772),
  [3655] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1773),
  [3657] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1775),
  [3659] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1778),
  [3661] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1779),
  [3663] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1780),
  [3665] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1781),
  [3667] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1782),
  [3669] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1782),
  [3671] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1784),
  [3673] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1785),
  [3675] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1786),
  [3677] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1786),
  [3679] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1788),
  [3681] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1789),
  [3683] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1790),
  [3685] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1792),
  [3687] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1793),
  [3689] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1794),
  [3691] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1793),
  [3693] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1796),
  [3695] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1798),
  [3697] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1800),
  [3699] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1801),
  [3701] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(896),
  [3704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1802),
  [3706] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1803),
  [3708] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1804),
  [3710] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1804),
  [3712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1806),
  [3714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1807),
  [3716] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1808),
  [3718] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1810),
  [3720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1813),
  [3722] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1814),
  [3724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1816),
  [3726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1817),
  [3728] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1819),
  [3730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1820),
  [3732] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1821),
  [3734] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1820),
  [3736] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1823),
  [3738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1825),
  [3740] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [3742] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_heredoc, 3),
  [3744] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(914),
  [3747] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2),
  [3749] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(916),
  [3752] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_heredoc_repeat1, 2), SHIFT_REPEAT(917),
  [3755] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(922),
  [3758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1827),
  [3760] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1828),
  [3762] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1829),
  [3764] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1829),
  [3766] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1831),
  [3768] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1832),
  [3770] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1833),
  [3772] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1835),
  [3774] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1838),
  [3776] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1839),
  [3778] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1840),
  [3780] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1841),
  [3782] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1842),
  [3784] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1842),
  [3786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1844),
  [3788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1845),
  [3790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [3792] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6),
  [3794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1846),
  [3796] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1847),
  [3798] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1848),
  [3800] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1849),
  [3802] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1849),
  [3804] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1851),
  [3806] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1852),
  [3808] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(979),
  [3811] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1853),
  [3813] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1854),
  [3815] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1855),
  [3817] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1855),
  [3819] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1857),
  [3821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1858),
  [3823] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1859),
  [3825] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1861),
  [3827] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1864),
  [3829] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1865),
  [3831] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [3833] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 3),
  [3835] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [3837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1868),
  [3839] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1869),
  [3841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1869),
  [3843] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1870),
  [3845] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1871),
  [3847] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1871),
  [3849] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 2, .alias_sequence_id = 1),
  [3851] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1873),
  [3853] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1878),
  [3855] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1881),
  [3857] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 2),
  [3859] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1882),
  [3861] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1884),
  [3863] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1885),
  [3865] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1886),
  [3867] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1888),
  [3869] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1889),
  [3871] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1890),
  [3873] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1889),
  [3875] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1892),
  [3877] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1894),
  [3879] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1896),
  [3881] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1897),
  [3883] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 10),
  [3885] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1898),
  [3887] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1899),
  [3890] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1015),
  [3893] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1900),
  [3896] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1017),
  [3899] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1018),
  [3902] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1019),
  [3905] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1020),
  [3908] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1021),
  [3911] = {.count = 2, .reusable = true, .depends_on_lookahead = true}, REDUCE(aux_sym_case_statement_repeat1, 2), SHIFT_REPEAT(1900),
  [3914] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [3916] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 11),
  [3918] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1903),
  [3920] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [3922] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1905),
  [3924] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1906),
  [3926] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [3928] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1907),
  [3930] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1907),
  [3932] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1909),
  [3934] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1910),
  [3936] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1911),
  [3938] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1913),
  [3940] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1914),
  [3942] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1915),
  [3944] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1914),
  [3946] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1917),
  [3948] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1919),
  [3950] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1921),
  [3952] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1922),
  [3954] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1057),
  [3957] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1923),
  [3959] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1924),
  [3961] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1925),
  [3963] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1925),
  [3965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1927),
  [3967] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1928),
  [3969] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1929),
  [3971] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1931),
  [3973] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1934),
  [3975] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1935),
  [3977] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1936),
  [3979] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1936),
  [3981] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1937),
  [3983] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1939),
  [3985] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1941),
  [3987] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1942),
  [3989] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1941),
  [3991] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1944),
  [3993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1945),
  [3995] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1946),
  [3997] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1947),
  [3999] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1945),
  [4001] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1955),
  [4003] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1956),
  [4005] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1957),
  [4007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1958),
  [4009] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1958),
  [4011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1960),
  [4013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1961),
  [4015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1962),
  [4017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1963),
  [4019] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1112),
  [4022] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1964),
  [4024] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1965),
  [4026] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1966),
  [4028] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1966),
  [4030] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1968),
  [4032] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1969),
  [4034] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1970),
  [4036] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1972),
  [4038] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1975),
  [4040] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1976),
  [4042] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1977),
  [4044] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 9),
  [4046] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5),
  [4048] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1978),
  [4050] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1979),
  [4052] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 7),
  [4054] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 5, .alias_sequence_id = 8),
  [4056] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1980),
  [4058] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1981),
  [4060] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1171),
  [4063] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1982),
  [4065] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1983),
  [4067] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1984),
  [4069] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1984),
  [4071] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1986),
  [4073] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1987),
  [4075] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1988),
  [4077] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1990),
  [4079] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1993),
  [4081] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1994),
  [4083] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4085] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5, .alias_sequence_id = 6),
  [4087] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1995),
  [4089] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 5),
  [4091] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 5),
  [4093] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1996),
  [4095] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1997),
  [4097] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(1998),
  [4099] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(1999),
  [4101] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(1999),
  [4103] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2001),
  [4105] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2002),
  [4107] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4109] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4111] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [4113] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_expansion, 6),
  [4115] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_array, 3),
  [4117] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1219),
  [4120] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2003),
  [4122] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2004),
  [4124] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2005),
  [4126] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2005),
  [4128] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2007),
  [4130] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2008),
  [4132] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2009),
  [4134] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2011),
  [4136] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2014),
  [4138] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2015),
  [4140] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_do_group, 3),
  [4142] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 5),
  [4144] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 5),
  [4146] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2017),
  [4148] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [4150] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5, .alias_sequence_id = 3),
  [4152] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2019),
  [4154] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2021),
  [4156] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 5),
  [4158] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 5),
  [4160] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2023),
  [4162] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2025),
  [4164] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 5),
  [4166] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 5),
  [4168] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_compound_statement, 3),
  [4170] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2028),
  [4172] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2029),
  [4174] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2029),
  [4176] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2031),
  [4178] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2033),
  [4180] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2035),
  [4182] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2036),
  [4184] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2035),
  [4186] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2038),
  [4188] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2039),
  [4190] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2040),
  [4192] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2041),
  [4194] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2039),
  [4196] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subshell, 5),
  [4198] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_subshell, 5),
  [4200] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2049),
  [4202] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2050),
  [4204] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2051),
  [4206] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2052),
  [4208] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2053),
  [4210] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2053),
  [4212] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2055),
  [4214] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2056),
  [4216] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2057),
  [4218] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2058),
  [4220] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1293),
  [4223] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2059),
  [4225] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2060),
  [4227] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2061),
  [4229] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2061),
  [4231] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2063),
  [4233] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2064),
  [4235] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2065),
  [4237] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2067),
  [4239] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2070),
  [4241] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_heredoc, 3),
  [4243] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1314),
  [4246] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2071),
  [4248] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2072),
  [4250] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2073),
  [4252] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2073),
  [4254] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2075),
  [4256] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2076),
  [4258] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2077),
  [4260] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2079),
  [4262] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2082),
  [4264] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2083),
  [4266] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2084),
  [4268] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2084),
  [4270] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2085),
  [4272] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2087),
  [4274] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2089),
  [4276] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2090),
  [4278] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2089),
  [4280] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2092),
  [4282] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2093),
  [4284] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2094),
  [4286] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2095),
  [4288] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2093),
  [4290] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2103),
  [4292] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2104),
  [4294] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2105),
  [4296] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2106),
  [4298] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2106),
  [4300] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2108),
  [4302] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2109),
  [4304] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2110),
  [4306] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2111),
  [4308] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1369),
  [4311] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2112),
  [4313] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2113),
  [4315] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2114),
  [4317] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2114),
  [4319] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2116),
  [4321] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2117),
  [4323] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2118),
  [4325] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2120),
  [4327] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2123),
  [4329] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2124),
  [4331] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2125),
  [4333] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2126),
  [4335] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2127),
  [4337] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2127),
  [4339] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2129),
  [4341] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2130),
  [4343] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2131),
  [4345] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2132),
  [4347] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2133),
  [4349] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2134),
  [4351] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2134),
  [4353] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2136),
  [4355] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2137),
  [4357] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2138),
  [4359] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2140),
  [4361] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2143),
  [4363] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2144),
  [4365] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2145),
  [4367] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2146),
  [4369] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2147),
  [4371] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2147),
  [4373] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2149),
  [4375] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2150),
  [4377] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2151),
  [4379] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2152),
  [4381] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2153),
  [4383] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2154),
  [4385] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2155),
  [4387] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2156),
  [4389] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2157),
  [4391] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2158),
  [4393] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2158),
  [4395] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2160),
  [4397] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2161),
  [4399] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2162),
  [4401] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_elif_clause, 4),
  [4403] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [4405] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2, .alias_sequence_id = 3),
  [4407] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2),
  [4409] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 3, .alias_sequence_id = 1),
  [4411] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4413] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4415] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3, .alias_sequence_id = 1),
  [4417] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2163),
  [4419] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2164),
  [4421] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_case_item_repeat1, 2), SHIFT_REPEAT(1482),
  [4424] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1481),
  [4427] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 3),
  [4429] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 3),
  [4431] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [4433] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 3),
  [4435] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2167),
  [4437] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2169),
  [4439] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2170),
  [4441] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2171),
  [4443] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2171),
  [4445] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2173),
  [4447] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2174),
  [4449] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2175),
  [4451] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2177),
  [4453] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2180),
  [4455] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 13),
  [4457] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2181),
  [4459] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2183),
  [4461] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2185),
  [4463] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 14),
  [4465] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2186),
  [4467] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1524),
  [4470] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2187),
  [4472] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2188),
  [4474] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2189),
  [4476] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2189),
  [4478] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2191),
  [4480] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2192),
  [4482] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2193),
  [4484] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2195),
  [4486] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2198),
  [4488] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2199),
  [4490] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2200),
  [4492] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2201),
  [4494] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2202),
  [4496] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2202),
  [4498] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2204),
  [4500] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2205),
  [4502] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2206),
  [4504] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2206),
  [4506] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2208),
  [4508] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2209),
  [4510] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2210),
  [4512] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2212),
  [4514] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2213),
  [4516] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2214),
  [4518] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2213),
  [4520] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2216),
  [4522] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2218),
  [4524] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2220),
  [4526] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2221),
  [4528] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2222),
  [4530] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2223),
  [4532] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2224),
  [4534] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2225),
  [4536] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2226),
  [4538] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2227),
  [4540] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2227),
  [4542] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2229),
  [4544] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2230),
  [4546] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6, .alias_sequence_id = 12),
  [4548] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_expansion, 6),
  [4550] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2231),
  [4552] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2232),
  [4554] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2233),
  [4556] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2234),
  [4558] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2234),
  [4560] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2236),
  [4562] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2237),
  [4564] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4566] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6, .alias_sequence_id = 6),
  [4568] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_subscript, 6),
  [4570] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_subscript, 6),
  [4572] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2238),
  [4574] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2239),
  [4576] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2240),
  [4578] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2241),
  [4580] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2242),
  [4582] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2243),
  [4584] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2243),
  [4586] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2245),
  [4588] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2246),
  [4590] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2247),
  [4592] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4594] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_for_statement, 6, .alias_sequence_id = 5),
  [4596] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 6),
  [4598] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 6),
  [4600] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2249),
  [4602] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 10),
  [4604] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 10),
  [4606] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2250),
  [4608] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4610] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 3),
  [4612] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 11),
  [4614] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6, .alias_sequence_id = 11),
  [4616] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2252),
  [4618] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 6),
  [4620] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 6),
  [4622] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_function_definition, 6),
  [4624] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_function_definition, 6),
  [4626] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2254),
  [4628] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2254),
  [4630] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2256),
  [4632] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2257),
  [4634] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2258),
  [4636] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2260),
  [4638] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2261),
  [4640] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2262),
  [4642] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2261),
  [4644] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2264),
  [4646] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2266),
  [4648] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2268),
  [4650] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2269),
  [4652] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2270),
  [4654] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2271),
  [4656] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2272),
  [4658] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2273),
  [4660] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2274),
  [4662] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2275),
  [4664] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2275),
  [4666] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2277),
  [4668] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2278),
  [4670] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2279),
  [4672] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2280),
  [4674] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2281),
  [4676] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2282),
  [4678] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2282),
  [4680] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2284),
  [4682] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2285),
  [4684] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2286),
  [4686] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2286),
  [4688] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2288),
  [4690] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2289),
  [4692] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2290),
  [4694] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2292),
  [4696] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2293),
  [4698] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2294),
  [4700] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2293),
  [4702] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2296),
  [4704] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2298),
  [4706] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2300),
  [4708] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2301),
  [4710] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2302),
  [4712] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2303),
  [4714] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2304),
  [4716] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2305),
  [4718] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2306),
  [4720] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2307),
  [4722] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2307),
  [4724] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2309),
  [4726] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2310),
  [4728] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2311),
  [4730] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2312),
  [4732] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2313),
  [4734] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2314),
  [4736] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2315),
  [4738] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2316),
  [4740] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2316),
  [4742] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2318),
  [4744] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2319),
  [4746] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2320),
  [4748] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2321),
  [4750] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2322),
  [4752] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2323),
  [4754] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 4, .alias_sequence_id = 1),
  [4756] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [4758] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [4760] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4, .alias_sequence_id = 1),
  [4762] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2324),
  [4764] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 4),
  [4766] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 4),
  [4768] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [4770] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 4),
  [4772] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2325),
  [4774] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2326),
  [4776] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2327),
  [4778] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2328),
  [4780] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2329),
  [4782] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2329),
  [4784] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2331),
  [4786] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2332),
  [4788] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2333),
  [4790] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2335),
  [4792] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2336),
  [4794] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2338),
  [4796] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 15),
  [4798] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 16),
  [4800] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2339),
  [4802] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2340),
  [4804] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2341),
  [4806] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2342),
  [4808] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2342),
  [4810] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2344),
  [4812] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2345),
  [4814] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2346),
  [4816] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2347),
  [4818] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(1937),
  [4821] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2348),
  [4823] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2349),
  [4825] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2350),
  [4827] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2350),
  [4829] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2352),
  [4831] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2353),
  [4833] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2354),
  [4835] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2356),
  [4837] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2359),
  [4839] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2360),
  [4841] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2361),
  [4843] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2362),
  [4845] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2363),
  [4847] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2364),
  [4849] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2365),
  [4851] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2366),
  [4853] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_if_statement, 7),
  [4855] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_if_statement, 7),
  [4857] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 13),
  [4859] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 13),
  [4861] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2367),
  [4863] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 14),
  [4865] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 7, .alias_sequence_id = 14),
  [4867] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2368),
  [4869] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2031),
  [4872] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2369),
  [4874] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2370),
  [4876] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2371),
  [4878] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2371),
  [4880] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2373),
  [4882] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2374),
  [4884] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2375),
  [4886] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2377),
  [4888] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2380),
  [4890] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2381),
  [4892] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2382),
  [4894] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2383),
  [4896] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2384),
  [4898] = {.count = 2, .reusable = true, .depends_on_lookahead = false}, REDUCE(aux_sym_concatenation_repeat1, 2), SHIFT_REPEAT(2085),
  [4901] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2385),
  [4903] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2386),
  [4905] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2387),
  [4907] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2387),
  [4909] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2389),
  [4911] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2390),
  [4913] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2391),
  [4915] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2393),
  [4917] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2396),
  [4919] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2397),
  [4921] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2398),
  [4923] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2399),
  [4925] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2400),
  [4927] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 5, .alias_sequence_id = 1),
  [4929] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [4931] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [4933] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5, .alias_sequence_id = 1),
  [4935] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_last_case_item, 5),
  [4937] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_item, 5),
  [4939] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [4941] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, REDUCE(sym_case_item, 5),
  [4943] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2401),
  [4945] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2402),
  [4947] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2403),
  [4949] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2406),
  [4951] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2408),
  [4953] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2409),
  [4955] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2410),
  [4957] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2411),
  [4959] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2412),
  [4961] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2413),
  [4963] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2413),
  [4965] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2415),
  [4967] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2416),
  [4969] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 15),
  [4971] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 15),
  [4973] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 16),
  [4975] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, REDUCE(sym_case_statement, 8, .alias_sequence_id = 16),
  [4977] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2417),
  [4979] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2418),
  [4981] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2419),
  [4983] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2420),
  [4985] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2420),
  [4987] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2422),
  [4989] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2423),
  [4991] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2424),
  [4993] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2425),
  [4995] = {.count = 1, .reusable = false, .depends_on_lookahead = false}, SHIFT(2426),
  [4997] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2427),
  [4999] = {.count = 1, .reusable = true, .depends_on_lookahead = true}, SHIFT(2427),
  [5001] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2429),
  [5003] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2430),
  [5005] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2431),
  [5007] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2432),
  [5009] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2433),
  [5011] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2434),
  [5013] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2435),
  [5015] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2436),
  [5017] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2437),
  [5019] = {.count = 1, .reusable = true, .depends_on_lookahead = false}, SHIFT(2438),
};

void *tree_sitter_bash_external_scanner_create();
void tree_sitter_bash_external_scanner_destroy(void *);
bool tree_sitter_bash_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_bash_external_scanner_serialize(void *, char *);
void tree_sitter_bash_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_bash() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_bash_external_scanner_create,
      tree_sitter_bash_external_scanner_destroy,
      tree_sitter_bash_external_scanner_scan,
      tree_sitter_bash_external_scanner_serialize,
      tree_sitter_bash_external_scanner_deserialize,
    },
  };
  return &language;
}
